#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#  Read all students in eval and evalmst. Find any orphans, both by
#  student id and by subnum (catnum) links.

my %lex = ('No Records Found' => 'No Records Found',
	   'Evaluation Record Checking' => 'Evaluation Record Checking',
	   'Admin' => 'Admin',
	   'Eval Master' => 'Eval Master',
	   
	   );

use DBI;
use CGI;

my $q = CGI->new;
print $q->header; 
my %arr = $q->Vars;

# Read config variables
require "ppp.conf" || die "Cannot read admin.conf!";
require "$globdir/global.conf" || die "Cannot read the global.conf file!";

my $dsn = "DBI:mysql:$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Evaluation Record Checking'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"/ppp.css\" type=\"text/css\">\n";
print "</head><body><a name=\"top\"></a>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ]\n";
print "<center><h1>". $lex{'Evaluation Record Checking'}. "</h1></center>\n";


# Now find the students in each of the two tables: eval and evalmst
$sth = $dbh->prepare("select distinct studnum from evalmst");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while ( my $studnum = $sth->fetchrow ) { 
    $studary{$studnum} = 1;
}

# Do same for eval table.
$sth = $dbh->prepare("select distinct studnum from eval");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while ( my $studnum = $sth->fetchrow ) { 
    $studary{$studnum} = 1;
}

# Now stuff into array and sort
foreach my $snum (keys %studary){ 
     push @temp, $snum; 
}
@studary = sort @temp;

# @studary now contains all studnums in sorted order from both tables.
#  Now do main loop.

if (not @studary ) {
    print "<h2>". $lex{'No Records Found'}. "</h2>\n";
}

foreach my $studnum ( @studary ) {
    $sth = $dbh->prepare("select * from special where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }  
    my @student = $sth->fetchrow;

    print "<h2>$student[2] $student[1] - $studnum ($student[10])</h2>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><td valign=\"top\"><b>". $lex{'Eval Master'}. "</b><br>\n";

    $sth = $dbh->prepare("select * from evalmst where studnum = ? order by subnum");
    $sth->execute( $studnum );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }  

    while (my @evalmst = $sth->fetchrow ){
	$sth1 = $dbh->prepare("select category from subject where catnum = ?");
	$sth1->execute( $evalmst[2] );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $category = $sth1->fetchrow;
	print "$category ($evalmst[2])<br>\n";
    }
    
    print "</td><td valign=\"top\">"; # Now do the evals for this
    
    $sth = $dbh->prepare("select * from eval where studnum = ? order by subnum, term");
    $sth->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }  
    $currsub = -1;
    while (@evalmst = $sth->fetchrow){
	$prevsub = $currsub;
	$currsub = $evalmst[2];
	if ($currsub != $prevsub){ print "<br>\n";}
	$sth1 = $dbh->prepare("select category from subject 
         where catnum = '$evalmst[2]'");
	$sth1->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $category = $sth1->fetchrow;
	print "$category ($evalmst[2]) Term: $evalmst[35]\n";
    } 
    print "</td></tr></table>\n";
}

print "</body></html>\n";
