#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Add Educator' => 'Add Educator',
	   'Admin' => 'Admin',
	   'School' => 'School',
	   'Save Educator Record' => 'Save Educator Record',
	   'Personnel' => 'Personnel',
	   'Userid' => 'Userid',
	   'Name' => 'Name',
	   'Userid already exists for' => 'Userid already exists for',
	   'Skipping' => 'Skipping',
	   'Educators Added' => 'Educators Added',
	   'Add More Educators' => 'Add More Educators',
	   'Error' => 'Error',
	   'Not Logged In' => 'Not Logged In',
	   'View Educators' => 'View Educators',

	   );


my $self = 'eduadd.pl';

use DBI;
use CGI;
use Data::Password qw(:all);  # for password checking...
use Crypt::GeneratePassword qw(word);


eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my $cookieuser = $q->cookie($divcookie);

print $q->header; 
my %arr = $q->Vars;

my $select;
if ($cookieuser){
    $select = " where school like '%($cookieuser%' ";
    $cookieuser = $dbase{$cookieuser};
} else {
    $cookieuser = $lex{'Not Logged In'};
}

# Open Database
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Add Educator'};
print "</title>\n<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$adminpage\">". $lex{Admin};

print "</a> ]\n<center><h1>". $lex{'Add Educator'}. "</h1>\n";

if ( not $arr{page} ) {
    showStartPage();
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    writeRecords();
}



#---------------
sub writeRecords {
#---------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    #die;

    foreach my $key ( sort keys %arr ) {

	# split key apart to get text and studnum;
	my ( $database,$userid, $id ) = split /:/, $key;

	# Check for existing userid in educator.
	my $sth = $dbh->prepare("select count(*) from educator where userid = ?");
	$sth->execute( $userid );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }    
	my $count = $sth->fetchrow;
	if ( $count > 0 ) {
	    print $lex{'Userid already exists for'}. " $userid. ". $lex{Skipping}. "<br>\n";
	    next;
	}


	# Load existing staff values to insert.
	my ($lastname, $firstname, $password);
	if ( $database eq 'per' ) { # personnel table without a password...
	    my $sth1 = $dbh->prepare("select lastname, firstname 
             from personnel where id = ?");
	    $sth1->execute( $id );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }    
	    ( $lastname, $firstname ) = $sth1->fetchrow;

	    # Add a password here. - settings now in ppp.conf
	     #$password_minlen = 6;
	     #$password_maxlen = 9; 
	     #$password_lang = 'en';
	     #$password_signs = 1;
	     #$password_caps = 2;
	     #$password_minfreq = .001;
	     #$password_avgfreq = .001;
    
	    $password = word( $password_minlen, $password_maxlen, $password_lang, 
	      $password_signs, $password_caps, $password_minfreq, $password_avgfreq );


	} else { # load values from school database

	    my $dsn1 = "DBI:$dbtype:dbname=$database";
	    my $dbh1 = DBI->connect($dsn1,$guser,$gpassword);

	    my $sth1 = $dbh1->prepare("select lastname, firstname, passwd 
          from staff where id = ?");
	    $sth1->execute( $id );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }    
	    ( $lastname, $firstname, $password ) = $sth1->fetchrow;
	}

	my %rec;
	
	# Check for password quality using Data::Password module.
	$MINLEN = 6;
	$MAXLEN = 9;
	$DICTIONARY = 1;
	if ( IsBadPassword( $password ) ) {
	    print "<h1 style=\"color:red;\">". $lex{'Password Error'}. "<br>\n";
	    print IsBadPassword( $password );
	    $arr{password} = undef;
	} else {
	    $rec{password} = $password;
	}

	$rec{lastname} = $lastname;
	$rec{firstname} = $firstname;
	$rec{userid} = $userid;
	$rec{schooldbase} = $database;

	my @keys = keys %rec;
	my $keys = join(',', @keys);
	
	foreach my $k ( keys %rec ) {
	    $rec{$k} = $dbh->quote( $rec{$k} );
	}
	my $values = join(',', ( values %rec ));

	$sth = $dbh->prepare("insert into educator ( $keys ) values ( $values )");
	$sth->execute;


    }


    print '<p><b>'. $lex{'Educators Added'}. "</b></p>\n";
    print "<p>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> |\n";
    print "<a href=\"$self\">". $lex{'Add More Educators'}. "</a> |\n";
    print "<a href=\"eduview.pl\">". $lex{'View Educators'}. "</a> ]</p>\n";
    print "</body></html>\n";

    exit;

}


#----------------
sub showStartPage {
#----------------

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<div style=\"padding:0.3em;\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Save Educator Record'}. "\"></div>\n";

    # Pull in the personnel table, first
    my $sth = $dbh->prepare("select id, userid, lastname, firstname, jobtitle from personnel
      order by lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }    

    # Now print Personnel
    print "<h2>". $lex{Personnel}. "</h2>\n";
    print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Name}. "</th><th>". $lex{Position}. "</th><th>". $lex{Userid};
    print "</th><th>". $lex{Select}. "</th></tr>\n";

    while ( my ($id, $userid, $lastname, $firstname, $jobtitle) = $sth->fetchrow ) {
	print "<tr><td><b>$lastname</b>, $firstname</td><td>$jobtitle</td>\n";
	print "<td>$userid</td><td align=\"center\">\n";
	print "<input type=\"checkbox\" name=\"per:$userid:$id\" value=\"1\"></td></tr>\n";
    }
    print "</table>\n";


    foreach my $database ( sort keys %dbase) { # defined in global config file.

	my $dsn = "DBI:$dbtype:$database";
	my $dbh = DBI->connect($dsn,$guser,$gpassword);

	my $sth = $dbh->prepare("select id, lastname, firstname, userid, 
           position from staff order by lastname, firstname");
	$sth->execute;
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	print "<h2>$dbase{$database}</h2>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print "<tr><th>". $lex{Name}. "</th><th>". $lex{Position}. "</th><th>". $lex{Userid};
	print "</th><th>". $lex{Select}. "</th></tr>\n";

	while ( my ( $id, $lastname, $firstname, $userid,$position) = $sth->fetchrow ) {
	    print "<tr><td><b>$lastname</b>, $firstname</td><td>$position</td>";
	    print "<td>$userid</td><td align=\"center\"> ";
	    print "<input type=\"checkbox\" name=\"$database:$userid:$id\" value=\"1\">";
	    print "</td></tr>\n";
	}
	print "</table>\n";
    }

    print "<div style=\"padding:0.3em;\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Save Educator Record'}. "\"></div>\n";
    print "</form></body></html>\n";

    exit;

} # end of showStartPage
