#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Edit Educators' => 'Edit Educators',
	   'Admin' => 'Admin',
	   'Save Educator Record' => 'Save Educator Record',
	   'Lastname' => 'Lastname',
	   'Firstname' => 'Firstname',
	   'Userid' => 'Userid',
	   'Password' => 'Password',
	   'School Dbase' => 'School Dbase',
	   'Your update is now stored' => 'Your update is now stored',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Edit Another Educator' => 'Edit Another Educator',
	   'Error' => 'Error',
	   'Poor Password' => 'Poor Password',
	   'Please try again' => 'Please try again',

	 );


use DBI;
use CGI;
use Data::Password qw(:all);  # for password checking...

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $q = new CGI;
print $q->header;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Edit Educators'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
</head><body><a name=\"top\"></a>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ]\n";
print "<center><h1>". $lex{'Edit Educators'}. "</h1>\n";

if ( $arr{flag} ) {
    delete $arr{flag};
    updateRecord();
}


my @schools = sort keys %dbase; # from global config file.

# Select educator
$sth = $dbh->prepare("select * from educator where id = ?"); 
$sth->execute( $arr{id} );
my $ed = $sth->fetchrow_hashref;


# Now print the form.
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$arr{id}\">\n";
print "<input type=\"hidden\" name=\"flag\" value=\"1\">\n";

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
print "<tr><td></td><td>\n";
print "<input type=\"submit\" value=\"". $lex{'Save Educator Record'}. "\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Lastname}. "</td><td>";
print "<input type=\"text\" name=\"lastname\" size=\"30\" maxlength=\"60\" 
 value=\"$ed->{lastname}\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Firstname}. "</td><td>";
print "<input type=\"text\" name=\"firstname\" size=\"30\" maxlength=\"60\" 
 value=\"$ed->{firstname}\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Userid}. "</td><td>";
print "<input type=\"text\" name=\"userid\" size=\"30\" maxlength=\"60\" 
 value=\"$ed->{userid}\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Password}. "</td><td>";
print "<input type=\"text\" name=\"password\" size=\"30\" maxlength=\"60\" 
 value=\"$ed->{password}\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'School Dbase'}. "</td>
<td><select name=\"schooldbase\"><option>$ed->{schooldbase}</option>\n";
foreach my $school ( @schools ) {
    print "<option>$school</option>\n";
}
print "</select></td></tr>\n";


print "<tr><td></td><td><input type=\"submit\" value=\"". $lex{'Save Educator Record'};
print "\"></td></tr>\n</table></center></form></center></body></html>\n";


#--------------
sub updateRecord {
#--------------

    #foreach my $key (sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $id = $arr{id}; # remove the record id from values to be updated.
    delete $arr{id}; 

    # Check for password quality using Data::Password module.
    $MINLEN = 6;
    $MAXLEN = 9;
    $DICTIONARY = 1;
    if ( IsBadPassword( $arr{password} ) ) {
	print "<h2 style=\"color:red;\">". $lex{'Poor Password'}. ". ". $lex{'Please try again'}. ".</h2>\n";
	print "<div><b>". $lex{Error}. "</b> ". IsBadPassword( $arr{password} );
	print "</div></body></html>\n";
	die;
    }

    foreach my $key ( keys %arr ) {
	my $sth = $dbh->prepare("update educator set $key = ? where id = $id");
	if ( not $arr{$key} ) { $arr{$key} = undef; }
	$sth->execute( $arr{$key} );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    }

    if ( not $DBI::errstr ) { 
	print "<h3>". $lex{'Your update is now stored'}. ".</h3>\n"; 
    } else { 
	print "<h3>". $lex{'There was an error storing your data'}. ". \n";
	print $lex{Contact}. " $adminname  <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{Error}. " :$DBI::errstr \n";
    }
    print "<p>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> |\n";
    print "<a href=\"eduview.pl\">". $lex{'Edit Another Educator'}. "</a> ]\n";
    print "</body></html>\n";

    exit;

}
