#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Power Delete evaluation and/or Evaluation Master Records.

my %lex = ('Power Delete Evaluation Records' => 'Power Delete Evaluation Records',
	   'Admin' => 'Admin',
	   'Delete Student Evaluation Records' => 'Delete Student Evaluation Records',
	   'Student' => 'Student',
	   'Both' => 'Both',
	   'Eval<br>Only' => 'Eval<br>Only',
	   'Error' => 'Error',
	   'School' => 'School',
	   'Select' => 'Select',
	   'Yes, select these schools' => 'Yes, select these schools',
	   'Check' => 'Check',
	   'Both = Evaluation Masters (Objectives) and Evaluations of Objectives' =>
	     'Both = Evaluation Masters (Objectives) and Evaluations of Objectives',
	   'Eval Only = Delete only Evaluations, Leave Evaluation Masters for next year' =>
	     'Eval Only = Delete only Evaluations, Leave Evaluation Masters for next year',
	   'Record Deletion Failed' => 'Record Deletion Failed',
	   'Contact' => 'Contact',
	   'Selected Records Deleted' => 'Selected Records Deleted',
	   
	   );

my $self = 'evalpwrdel_iep.pl';

use DBI;
use CGI;

my $q = CGI->new;
print $q->header; 
my %arr = $q->Vars;
my $checked = $arr{checked};

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Power Delete Evaluation Records'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"/ppp.css\" type=\"text/css\">\n";
print "</head><body><a name=\"top\"></a>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ]\n";
print "<center><h1>". $lex{'Power Delete Evaluation Records'}. "</h1>\n";


if ( not $arr{page} ) {
    showStartPage();
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectStudents();
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    deleteEval();
}


#-----------------
sub selectStudents {
#-----------------

    # Form Start
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
    print "<div style=\"padding:0.5em;\"><input type=\"submit\" value=\"";
    print $lex{'Delete Student Evaluation Records'}. "\"></div>\n";

    print "<div style=\"padding:0.2em;font-weight:bold;\">";
    print $lex{'Both = Evaluation Masters (Objectives) and Evaluations of Objectives'}. "<br>\n";
    print $lex{'Eval Only = Delete only Evaluations, Leave Evaluation Masters for next year'};
    print "</div>\n";


    foreach my $key ( keys %arr){ # Loop through each database.
	if ( $key eq 'checked'){ next; } # skip checked key

	# Setup Table for this School.
	print "<h2>$dbase{$key}</h2>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">";
	print "<tr><th>". $lex{Student}. "</th><th>". $lex{'Eval<br>Only'};
	print "</th><th>". $lex{'Both'}. "</th></tr>\n";

	my $sth = $dbh->prepare("select lastname,firstname,studnum from special
          where school = ? order by lastname, firstname");
	$sth->execute( $key );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	while ( my ( $lastname,$firstname,$studnum ) = $sth->fetchrow ) {
	    print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td>\n";
	    print "<td><input type=\"checkbox\" name=\"E:$studnum\" value=\"1\" $checked>\n";
	    print "<td><input type=\"checkbox\" name=\"B:$studnum\" value=\"1\">\n";
	    print "</td></tr>\n";
	}
	
	print "</table>\n";

    }

    print "<input type=\"submit\" value=\"". $lex{'Delete Student Evaluation Records'}. "\">\n";
    print "</form></center></body></html>\n";

} # end of selectStudents



#----------------
sub showStartPage {
#----------------

    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";
    print "<tr><th>". $lex{School}. "</th><th>". $lex{Select}. "</th></tr>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    foreach my $key ( sort keys %dbase ) {
	print "<tr><td>$dbase{$key} ($key)</td>\n";
	print "<td><input type=\"checkbox\" name=\"$key\" value=\"1\" $checked>\n";
	print "</td></tr>\n";
    }

    print"<tr><td colspan=\"2\" align=\"center\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Yes, select these schools'}. "\">\n";
    print $lex{Check}. " <input type=\"checkbox\" value=\"checked\" name=\"checked\">";
    print "</td></tr>\n</form></table></body></html>\n";

    exit;

} # end of showStartPage



#-------------
sub deleteEval {
#-------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # separate them into 2 groups - evalonly and both (eval,evalmst to delete)
    my (%both, %evalonly); # hashes to hold the studnums to erase.
    foreach my $key ( sort keys %arr ) {
	my ($type, $studnum ) = split /:/, $key;
	if ( $type eq 'B' ) {
	    $both{$studnum} = 1;
	} else { # eval only
	    if ( not $both{$studnum} ) { # if not already in both, then eval only.
		$evalonly{$studnum} = 1;
	    }
	}
    }

    # Testing...
    #print "Both<br>\n";
    #foreach my $key ( sort keys %both ) { print "K:$key V:$both{$key}<br>\n"; }
    #print "Eval Only<br>\n";
    #foreach my $key ( sort keys %evalonly ) { print "K:$key V:$evalonly{$key}<br>\n"; }

    $sth = $dbh->prepare("delete from eval where studnum = ?");
    $sth1 = $dbh->prepare("delete from evalmst where studnum = ?");

    # Delete Both Records
    foreach my $studnum ( sort keys %both ) { 
	#print "K:$studnum V:$both{$studnum}<br>\n";
	$sth->execute( $studnum ); # evals
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	$sth1->execute( $studnum ); # evalmst
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    }

    foreach my $studnum ( sort keys %evalonly ) { 
	#print "K:$studnum V:$evalonly{$studnum}<br>\n"; 
	$sth->execute( $studnum ); # evals only delete;
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    }


    if ( $DBI::errstr ) {
	print  $lex{'Record Deletion Failed'}. ". ". $lex{Contact}. " $adminname<br>\n";
	print $lex{Error}. ": $DBI::errstr \n";
	print "</center></body></html>\n";
	die;
    } 

    # Check for empty eval table... not sure why...
    #my $emptyflag = 1; # assume it's empty.
    #$sth = $dbh->prepare("select distinct e.studnum, s.lastname, s.firstname 
    #from eval as e, special as s 
    #where e.studnum = s.studnum 
    #order by s.lastname, s.firstname"); # any left?
    #$sth->execute;
    #while ( my ( $studnum,$lastname,$firstname ) = $sth->fetchrow ) {
    # $emptyflag = 0;
    # print "$firstname $lastname ($studnum) still has evalution records.<br>\n";
    #}
    #if ( $emptyflag ){ # no records left.
    # print"<h2>All evaluation records have been erased. The table is empty.</h2>\n";
    #}

    print "<h3>". $lex{'Selected Records Deleted'}. "</h3>\n";
    print "<p>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ]</p>\n";
    print "</center></body></html>\n";

    exit;

}


