#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Admin' => 'Admin',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Please record the following error' => 'Please record the following error',
	   'Please contact' => 'Please contact',
	   'The personnel record is now stored' => 'The personnel record is now stored',
	   'Missing User Id or Name' => 'Missing User Id or Name',
	   'Userid already exists' => 'Userid already exists',
	   'Please try again' => 'Please try again',

	   );

use DBI;
use CGI;

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

require "ppp.conf" or die "Cannot open ppp.conf!";
require "$globdir/global.conf" || die "Cannot read the global.conf file!";

print "$doctype\n<html><head>
<link rel=\"stylesheet\" href=\"/ppp.css\" type=\"text/css\">
</head><body>\n";
print "<p>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ] \n";
print "<center>\n";


my $dsn = "DBI:mysql:$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Check for missing values
if (not $arr{userid} or 
    not $arr{lastname} or 
    not $arr{firstname} ) {

    print "<h1>". $lex{'Missing User Id or Name'}. "</h1>\n";
    die;
}

# Check for existing user ids.
my $sth = $dbh->prepare("select count(userid) from personnel where userid = ?");
$sth->execute( $arr{userid} );
if ($DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my $count = $sth->fetchrow;
if ( $count > 0 ) {
    print "<h1>". $lex{'Userid already exists'}. ". \n";
    print $lex{'Please try again'}. ".</h1>\n";
    die;
}


foreach my $key (keys %arr) { 
    if ( $arr{$key} ) {
	$arr{$key} = $dbh->quote( $arr{$key} );
    } else {
	$arr{$key} = $sql{default};
    }
}

$sth = $dbh->prepare("insert into personnel values (
 $sql{default}, $arr{userid}, $arr{lastname}, $arr{firstname},
 $arr{jobtitle}, $arr{agency}, $arr{phone}, $arr{email})");
$sth->execute;



if (not $DBI::errstr ) {
    print "<h3>". $lex{'The personnel record is now stored'}. ".</h3></p>";
} else {
    print "<h3>". $lex{'There was an error storing your data'}. ". ";
    print $lex{'Please contact'}. " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
    print $lex{'Please record the following error'}. " $DBI::errstr</h3></p>\n";
}

print "<p>[ <a href=\"$adminpage\">". $lex{Admin}. "</a> ] \n";
print "</p></center></body></html>\n";


