#!/usr/bin/perl
#  Copyright 2001-2004 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Write the new subject record with a new objective (and perhaps a new
#  category and category number).
#  Expected: subject (which need splitting) , newcategory, newcatnumber, 
#   grade, objective. (multi line)

use DBI;
use CGI;

$q = new CGI;

# Http Header to return
print $q->header; 

require "ppp.conf" or die "Cannot open ppp.conf!";

print "$doctype\n<html><head><title>Objectives Addition</title>
<link rel=\"stylesheet\" href=\"/ppp.css\" type=\"text/css\">
</head><body>[ <a href=\"$adminpage\">Admin</a> ]<center>\n";

%arr = $q->Vars;

foreach $key (keys(%arr)) { 
  $arr{$key} =~ s/'/''/g;
  $arr{$key} =~ s/\\/\\\\/g;
}

$dsn = "DBI:mysql:$dbase";
$dbh = DBI->connect($dsn,$user,$password);

# split the subject apart.
($category, $catnum) = split /\(/, $arr{subject};
chop $catnum;  # remove trailing )

# Error Checking
if ($arr{newcategory} and $category){ # Both Entered.
    print "<h1>Only 1 Category can be entered. Either an existing one ";
    print " selected or a new one entered.</h1>\n";
    die;
}

if ($arr{newcategory} and not $arr{newcatnumber} or
    $arr{newcatnumber} and not $arr{newcategory}){
    print "<h1>Problem with missing value for new category.</h1>";
    die;
}

# Set New values.
if ($arr{newcategory}){
    $category = $arr{newcategory};
    $catnum = $arr{newcatnumber};
}

# Check for existing subject records with this category/catnum
$sth = $dbh->prepare("select * from subject where catnum = '$catnum'");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die;}
my $rows = $sth->rows;
my $maxid;
if ($rows > 0){ # We have existing records for this subject; check for recs.
    $sth = $dbh->prepare("select max(idnum) from subject
      where catnum = '$catnum'");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die;}
    $maxid = $sth->fetchrow;
}
$startid = $maxid + 1;

for (1..10) {
    $objname = "obj".$_;
    if ($arr{$objname}){
	$sth = $dbh->prepare("insert into subject values (NULL,
         '$catnum', '$category', '$startid',
         '$arr{grade}', '$arr{$objname}', '$arr{commentcodes}')");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die;}
	$startid++;
    } # end of if objective exists.
}

if (not $DBI::errstr ) {
   print "<h3>The subject records are now stored in the database.</h3></p>";
} else {
    print "<h3> I'm sorry. There was an error storing your data. Please
contact $adminname at <a href=\"mailto:$adminemail\">$adminemail</a> 
Please record the following error string: $DBI::errstr; \n";
}

print "<p>[ <a href=\"$adminpage\">Admin Page</a> |
<a href=\"/cgi-bin/admin/subadd0.pl\">Add More Objectives</a> ] \n";
print "</p></center></body></html>";
