#!/usr/bin/perl
#  Copyright 2001-2004 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# subrecat.pl - Recategorize Objectives within different categories.

$newcat = 3; # Number of new categories to show for entry.


use DBI;
use CGI;

$q = new CGI;

# Http Header to return
print $q->header; 

%arr = $q->Vars;
my $catnum = $arr{cat};
my $update = $arr{update};

require "ppp.conf" or die "Cannot open ppp.conf!";

$dsn = "DBI:mysql:$dbase";
$dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print <<"HEAD";
$doctype\n<html><head><title>Recategorize Objectives</title>
<link rel="stylesheet" href="/ppp.css" type="text/css">
</head><body>
[ <a href="$adminpage">Admin</a> |
<a href="/cgi-bin/admin/submuldeled.pl">Change Other Categories</a> |
<a href="/cgi-bin/admin/submuled.pl?cat=$catnum">Edit/Delete these 
Objectives</a> ]
<center><h1>Recategorize Objectives</h1>
HEAD

if ($update){ # update passed records.
    &update;
}

$sth = $dbh->prepare("select * from subject where catnum = '$catnum'
  order by idnum");
$sth->execute;
if ($DBI::errstr) { print "$DBI::errstr"; die;}


print <<"EOF";
<form action="/cgi-bin/admin/subrecat.pl" method="post">
<input type="hidden" name="update" value="1">
<input type="hidden" name="cat" value="$catnum">

<h2 style="font-size: 120%;">Add New Categories</h2>
<table cellpadding="3" cellspacing="0" border="1">
<tr><th>Cat Num</th><th>Category</th></tr>
EOF

# Print Input for New Category numbers and text.
for(1..$newcat){ # CN - Category Number CT-Category Text
    print "<tr><td><input type=\"text\" name=\"CN-$_\" size=\"8\"></td>";
    print "<td><input type=\"text\" name=\"CT-$_\" size=\"50\"></td></tr>\n";
}

print <<"EOF1";
</table><p style="font-size:120%;">These new categories may be used 
in the objectives below.</p>
<h2 style="font-size: 120%;">Existing Objectives/Category</h2>
<table cellpadding="3" cellspacing="0" border="1">
<tr><th>Cat<br>Num</th><th>Category</th><th>ID<br>Num</th>
 <th>Objective</th></tr>
EOF1
print "<tr><td colspan=\"4\" align=\"center\"><input type=\"submit\" ";
print "value=\"Update these objectives and categories\"></td></tr>";

while (@arr = $sth->fetchrow){
    print "<tr><td><input type=\"text\" name=\"CAT-$arr[1]-$arr[0]\" ";
    print "value=\"$arr[1]\" size=\"6\"></td>\n";
    print "<td>$arr[2]</td><td>$arr[3]</td>";
    print "<td>$arr[5]</td></tr>\n";
}

print "<tr><td colspan=\"4\" align=\"center\"><input type=\"submit\" ";
print "value=\"Update these objectives and categories\"></form></td>";
print "</tr></table></center>\n";
print "[ <a href=\"$adminpage\">Admin</a> |
<a href=\"/cgi-bin/admin/submuldeled.pl\">Change Other Categories</a> |
<a href=\"/cgi-bin/admin/submuled.pl?cat=$catnum\">Edit/Delete these 
Objectives</a> ]\n";
print "</body></html>\n";

#================== Functions

#----------
sub update { # update subject records (ie. objectives)
#----------
    
    # First Loop - Loop and Add new Categories to %Cathash.
    foreach my $key (keys %arr) { 
	my ($cn , $num) = split /-/,$key;
	if ($cn eq 'CN' and $arr{$key}){ 
	    # Test for Category text and add to hash.
	    #print "CN: $cn Num: $num CT: $arr{CT.\"-\".$num} <br>\n";
	    my $cttext = "CT-".$num;
	    if ($arr{$cttext}){ # we have matching text...
		$cathash{$arr{$key}} = $arr{$cttext};
	    } else { # mistake: forgot to add text for this category.
		print "<h2>Missing Text for Category: $arr{$key}</h2>\n";
		print "</body></html>\n";
		die;
	    }
	}
    }

    # Check that categories do not already exist.
    $sth = $dbh->prepare("select category from subject where catnum = ?");
    foreach my $key (keys %cathash){ 
	# check for pre-existing numbers, and fail
	$sth->execute($key);
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my $cat = $sth->fetchrow;
	if ($cat){ # mistake again. Already Exists.
	    print "<p>Category: <b>$cat</b> with number: <b>$key</b> ";
	    print "already exists.</p></body></html>\n";
	    die;
	}
    }


    # Start Table for updates
    print "<h2 style=\"font-size: 120%;\">Updated Categories</h2>";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">";
    print "<tr><th>Cat Num</th><th>Category</th><th>IdNum</th>";
    print "<th>Description</th></tr>\n";

    # Now loop through new category numbers.
    foreach my $key (keys %arr) { 
	my ($cat,$oldcat, $idrec) = split /-/,$key;
	if ($cat eq "CAT" and $oldcat ne $arr{$key}){ 
	    # we have a category change 
	    # $cat holds 'CAT', $oldcat holds old category number,
	    # $idrec is the record id that we are changing.
	    # $arr{$key} holds the new category number.
	    
	    # check for category text
	    if ($cathash{$arr{$key}}){
		$cattext = $cathash{$arr{$key}};
	    } else { # get it out of subject table.
		$sth = $dbh->prepare("select category from subject
	         where catnum = '$arr{$key}'");
		$sth->execute;
		if ($DBI::errstr){ print $DBI::errstr; die;}
		$cattext = $sth->fetchrow;
	    }
	    if (not $cattext){ # no category text found!
		print "</table>";
		print "<h2>No category text found for category number:\n";
		print "<b>$arr{$key}</b>. Please try again.</h2></body></html>\n";
		die;
	    }

	    $cattext =~ s/'/"/g;
	    $cattext =~ s/\\/\\\\/g;

	    # Get Objective to display change.
	    $sth = $dbh->prepare("select description,idnum from subject
	      where id = '$idrec'");
	    $sth->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die;}
	    my ($objective,$idnum) = $sth->fetchrow;
	    

	    #print "Catnum: $arr{$key} CatText: $cattext IDRec: $idrec\n";
	    $sth = $dbh->prepare("update subject set
	     category='$cattext',  catnum = '$arr{$key}' 
	     where id = '$idrec'");
	    $sth->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die;}

	    print "<tr><td>";
	    print "<a href=\"/cgi-bin/admin/subrecat.pl?cat=$arr{$key}\">";
	    print "$arr{$key}</a></td>\n<td>";
	    print "<a href=\"/cgi-bin/admin/subrecat.pl?cat=$arr{$key}\">";
	    print "$cattext</a></td><td>";
	    print "<a href=\"/cgi-bin/admin/submuled.pl?cat=$arr{$key}\">";
	    print "$idnum</a></td><td>";
	    print "<a href=\"/cgi-bin/admin/submuled.pl?cat=$arr{$key}\">";
	    print "$objective</a></td></tr>\n";

	}
    } # keys loop
    print "</table>\n";
}
