#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Main' => 'Main',
	   'Add Assessments' => 'Add Assessments',
	   'Error' => 'Error',
	   'Save Assessment' => 'Save Assessment',
	   'Student' => 'Student',
	   'Category' => 'Category',
	   'Request Date' => 'Request Date',
	   'Completion Date' => 'Completion Date',
	   'Comment' => 'Comment',
	   'yyyy-mm-dd' => 'yyyy-mm-dd',
	   'Category Or Student not entered! Try Again!' => 
	     'Category or Student not entered! Try Again!',
	   'There was an error storing your data' => 
	     'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Your data is now stored' => 'Your data is now stored',
	   'Add Another Record' => 'Add Another Record',
	   'Please Log In' => 'Please Log In',
	   'Continue to Add Impacts' => 'Continue to Add Impacts',

	   );

my $self = 'asadd.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;

# load configuration files
eval require "ppp.conf";
if ( $@ ) {
    print $q->header; 
    print $lex{Error}. " asadd.pl:$@<br>\n";
    die $lex{Error}. " asadd.pl:$@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $q->header; 
    print $lex{Error}. " global.conf: $@<br>\n";
    die $lex{Error}. " global.conf: $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Add Assessments'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ] $firstname $lastname\n";
print "<center><h1>". $lex{'Add Assessments'}. "</h1>\n";


if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    addRecord();
}

# Read in all special students and put in array
$sth = $dbh->prepare("select lastname, firstname, studnum from special $select 
  order by lastname, firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr;}

while ( my ( $lastname, $firstname, $studnum ) = $sth->fetchrow ) {
    my $studrec = "$lastname, $firstname ($studnum)";
    push @studarray, $studrec;
}
# Done pushing in students.


my $sth = $dbh->prepare("select * from catassess order by category");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr;}
while (my @cat = $sth->fetchrow ) {
    push @catarray, $cat[1];
}
# Done pushing in categories.

# Get value for any passed student via $arr{studnum}
my $passedstudent;
if ( $arr{studnum} ) {
    my $sth = $dbh->prepare("select lastname, firstname from special
      where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;
    $passedstudent = "$lastname, $firstname ($arr{studnum})";
}


print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";
print "<p><input type=\"submit\" value=\"". $lex{'Save Assessment'}. "\"></p>\n";

print "<table cellpadding=\"6\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><td align=\"right\"><b>". $lex{Student}. "</b></td>\n";
print "<td><select name=\"student\"><option>$passedstudent</option>\n";

foreach my $student ( @studarray ) {
    print "<option>$student</option>\n";
}
print "</select></td></tr>\n";

# Now do the Categories
print "<tr><td align=\"right\"><b>". $lex{Category};
print "</b></td><td><select name=\"category\"><option></option>\n";
foreach my $category ( @catarray ) {
    print "<option>$category</option>\n";
}
print "</select></td></tr>\n";


print "<tr><td align=\"right\">". $lex{'Request Date'};
print "</td><td><input type=\"text\" name=\"reqdate\" size=\"12\"> (\n"; 
print $lex{'yyyy-mm-dd'}. ")</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Completion Date'}. "</td>\n";
print "<td><input type=\"text\" name=\"resdate\" size=\"12\"> (\n";
print $lex{'yyyy-mm-dd'}. ")</td></tr>\n";

print "<tr><td colspan=\"2\">". $lex{Comment}. "<br>\n";
print "<textarea name=\"comment\" cols=\"60\" rows=\"6\"></textarea></td></tr>\n";
print "</table>\n";

print "<p></p><input type=\"submit\" value=\"". $lex{'Save Assessment'}. "\">\n";
print "</form></body></html>\n";


#------------
sub addRecord {
#------------

    #foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    if ( not $arr{student} or not $arr{category} ){ # fail
	print "<h1>". $lex{'Category Or Student not entered! Try Again!'}. "</h1>\n";
	print "</body></html>\n";
	die;
    }

    my ( $dud, $studnum ) = split /\(/, $arr{student};
    chop $studnum; # remove trailing parenthesis.

    foreach my $key ( keys %arr ) {
	if ( $arr{$key} ) {
	    $arr{$key} = $dbh->quote( $arr{$key} );
	} else {
	    $arr{$key} = $sql{default};
	}
    }

    my $sth = $dbh->prepare("insert into assess values (
     $sql{default}, ?, $arr{category}, $arr{reqdate},
     $arr{resdate}, $arr{comment} )");

    $sth->execute( $studnum );

    if ( not $DBI::errstr ) { 
	print "<h3>". $lex{'Your data is now stored'}. ".</h3>\n"; 
    } else { 
	print "<h3>". $lex{'There was an error storing your data'}. ". \n";
	print $lex{Contact}. " $adminname  <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{Error}. " :$DBI::errstr \n";
    }

    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self\">". $lex{'Add Another Record'}. "</a> |\n";

    print "<form action=\"impactadd.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Continue to Add Impacts'}. "\">\n";
    print "</form>\n";

    print "</body></html>\n";

    exit;

};
