#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('View Assessments' => 'View Assessments',
	   'Main' => 'Main',
	   'School' => 'School',
	   'Category / Dates' => 'Category / Dates',
	   'Error' => 'Error',
	   'Comment' => 'Comment',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Req' => 'Req',
	   'Act' => 'Act',
	   'Please Log In' => 'Please Log In',
	   );

my $self = 'asdeled.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " ppp.conf:$@<br>\n";
    die $lex{Error}. " ppp.conf:$@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " global.conf: $@<br>\n";
    die $lex{Error}. " global.conf: $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "and school = $sdb ";


my $sth = $dbh->prepare("select * from assess, special 
  where assess.studnum = special.studnum $select
  order by special.lastname, special.firstname, assess.category");

$sth->execute;
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr;}
my $rows = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'View Assessments'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ] $firstname $lastname\n";
print "<center><h1>". $lex{'View Assessments'}. "</h1>\n";

my $currstud = -1;
my $oldstud;

for ( my $i=1; $i <= $rows; ++$i) {
    my @arr = $sth->fetchrow;
   
    $oldstud = $currstud;
    $currstud = $arr[1];     

    if ( $oldstud ne $currstud ) {  # We have a new student
	my $student = "$arr[8] $arr[7]";
	if ($i != 1) {  # close previous list
	    print "</table>";
	}

	print "<h3>$student</h3><table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print "<tr><th>". $lex{'Category / Dates'}. "</th>\n";
	print "<th>". $lex{Comment}. "</th><th></th></tr>\n";      
    }

    # clear blank dates from fields 3 and 4 (requested and actual dates).
    for my $i (3..4) { if ( $arr[$i] eq '0000-00-00' ) { $arr[$i] = ''; } }

    print "<tr><td><b>$arr[2]</b><br>". $lex{Req}. ":$arr[3]<br>". $lex{Act}. ":$arr[4]</td>\n";
    print "<td>$arr[5]</td>\n";
    print "<td><form action=\"ased.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"id\" value=\"$arr[0]\">\n";
    print "<input type=\"submit\" value=\"". $lex{Edit}. "\"></form><br>\n";
    print "<form action=\"asdel.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"id\" value=\"$arr[0]\">\n";
    print "<input type=\"submit\" value=\"". $lex{Delete}. "\"></form></td></tr>\n";

} # End of loop counter

print "</ul></body></html>\n";
