#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson
#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Category not entered! Try Again!' => 'Category not entered! Try Again!',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Your update is now stored' => 'Your update is now stored',
	   'Edit Another Record' => 'Edit Another Record',
	   'Assessment Edit' => 'Assessment Edit',
	   'Update Assessment Record' => 'Update Assessment Record',
	   'Requested Date' => 'Requested Date',
	   'yyyy-mm-dd' => 'yyyy-mm-dd',
	   'Completion Date' => 'Completion Date',
	   'Comment' => 'Comment',
	   'Student' => 'Student',
	   'Please Log In' => 'Please Log In',
	   'Category' => 'Category',

	   );


my $self = 'ased.pl';

use DBI;
use CGI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

print "$doctype\n<html><head>\n";
print "<title>". $lex{'Assessment Edit'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body>\n";
print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
print "<center><h1>". $lex{'Assessment Edit'}. "</h1>\n";

if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    updateRecord();
}

# Load categories into array
$sth = $dbh->prepare("select category from catassess order by category");
$sth->execute;
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }
while ( my $cat = $sth->fetchrow ) {
  push @catarray, $cat;
}
# Done pushing in categories.


$sth = $dbh->prepare("select * from assess, special 
  where assess.id = ? and 
  assess.studnum = special.studnum"); 
$sth->execute( $arr{id} );
if ( $DBI::errstr ) { print "$DBI::errstr"; die $DBI::errstr; }
my @arr = $sth->fetchrow;


print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$arr[0]\">\n";
print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\" style=\"margin:1em;\">\n";
print "<tr><th align=\"right\">". $lex{Student}. "</th>\n";
print "<td>$arr[8] $arr[7] ($arr[1])</td></tr>\n";


# Now do the Categories
print "<tr><th align=\"right\">". $lex{Category}. "</th>\n";
print "<td><select name=\"category\"><option>$arr[2]</option>\n";
foreach my $category ( @catarray ) {
    print "<option>$category</option>\n";
}
print "</select></td></tr>\n";


print "<tr><th align=\"right\">". $lex{'Requested Date'}. "</th>\n<td>";
print "<input type=\"text\" Name=\"reqdate\" size=\"12\" value=\"$arr[3]\">(";
print $lex{'yyyy-mm-dd'}. ")</td></tr>\n";

print "<tr><th align=\"right\">". $lex{'Completion Date'}. "</th>\n<td>";
print "<input type=\"text\" Name=\"resdate\" size=\"12\" value=\"$arr[4]\">(";
print $lex{'yyyy-mm-dd'}. ")</td></tr>\n";

print "<tr><th align=\"right\">". $lex{Comment}. "</th>\n<td>";
print "<textarea name=\"comment\" cols=\"70\" rows=\"8\">$arr[5]</textarea></td></tr>\n";
print "</table>\n";

print "<p><input type=\"submit\" value=\"". $lex{'Update Assessment Record'}. "\">\n";
print "</form></center></body></html>\n";



#---------------
sub updateRecord {
#---------------

    my $id = $dbh->quote( $arr{id} );
    delete $arr{id};

    if ( $arr{resdate} eq '0000-00-00' ) { $arr{resdate} = undef; }

    if ( not $arr{category} ){ # fail
	print "<center><h1>". $lex{'Category not entered! Try Again!'}. "</h1>\n";
	print "</body></html>\n";
	die;
    }


    foreach my $key ( keys %arr ) {
	my $sth = $dbh->prepare("update assess set $key  = ? where id = $id ");
	$sth->execute( $arr{$key} );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    }

    if ( not $DBI::errstr ) { 
	print "<h3>". $lex{'Your update is now stored'}. ".</h3>\n"; 
    } else { 
	print "<h3>". $lex{'There was an error storing your data'}. ". \n";
	print $lex{Contact}. " $adminname  <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{Error}. " :$DBI::errstr \n";
    }

    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"asdeled.pl\">". $lex{'Edit Another Record'}. "</a> ]</p>\n";
    print "</body></html>\n";

    exit;

}
