#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'Student Evaluation' => 'Student Evaluation',
	   'Main' => 'Main',
	   'School' => 'School',
	   'Term' => 'Term',
	   'Student Evaluation Entry' => 'Student Evaluation Entry',
	   'Grade' => 'Grade',
	   'Add/Edit' => 'Add/Edit',
	   'No Records Found' => 'No Records Found',
	   'Term to Add/Edit' => 'Term to Add/Edit',
	   'Other Student Evaluations' => 'Other Student Evaluations',
	   'Edit More' => 'Edit More',
	   'Please record the following error' => 'Please record the following error',
	   'Contact' => 'Contact',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'The evaluation record is now stored/updated' => 
	     'The evaluation record is now stored/updated',
	   'Subject not found!' => 'Subject not found!',
	   'Objectives' => 'Objectives',
	   'Eval' => 'Eval',
	   'Comment' => 'Comment',
	   'Continue' => 'Continue',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'evaladd.pl';

use DBI;
use CGI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
my %arr = $q->Vars;

# Read in the term
my $term = $lex{Error};
open( TERM, "term") || die "Can't find the term number!";
$term = <TERM>;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


print "$doctype\n<html><head><title>". $lex{'Student Evaluation'};
print "</title><link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
</head><body>\n";
print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ] $firstname $lastname\n";

if ($term == 0) {
    print "<br>System Disabled. Please contact the secretary.</body></html>";
    die;
}

# Decide on what function to call.
if ( not $arr{page} ) {
    showStartPage( $select );
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectSubject( $arr{studnum} );
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    addEditRecord();
} elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    writeRecord();
}



#----------------
sub showStartPage {
#----------------

    my $select = shift;

    my $sth = $dbh->prepare("select lastname, firstname, studnum, grade, school 
      from special $select order by lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    print "<center><h1>". $lex{'Student Evaluation'}. "</h1>";
    print "<div style=\"padding:0.5em;\">". $lex{Term}. ": $term</div>\n";

    print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
    print "<tr><th colspan=\"3\">". $lex{'Student Evaluation Entry'}. "</th></tr>\n";

    while ( my ( $lastname, $firstname, $studnum, $grade, $school ) = $sth->fetchrow ) {
	$school =~ s/\(.*\)//; # strip out anything in parentheses.
	print "<tr><td><b>$lastname</b>, $firstname</td><td>$school - ". $lex{Grade};
	print ": $grade</td>\n<td>";
	print "<form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
	print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
	print "<input type=\"submit\"  value=\"".  $lex{'Add/Edit'}. "\"></form></td></tr>\n";
    }

    print "</table></center></body></html>\n";

    exit;

} # end of showStartPage



#----------------
sub selectSubject {
#----------------

    my $studnum = shift;
    my $sth = $dbh->prepare("select lastname, firstname, grade 
      from special where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname, $grade ) = $sth->fetchrow;

    # Print Form Start
    print "<center><h1>". $lex{'Student Evaluation Entry'}. "</h1>\n";
    print "<h2>$firstname $lastname</h2>\n";
    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";


    # Print the Term Selection
    print "<tr><td><b>". $lex{'Term to Add/Edit'}. "</b>\n";
    print "$lex{Term} <select name=\"term\"><option>$term</option>\n";
    for my $trm ( 1..$g_maxterm{ $grade } ) {
	print "<option>$trm</option>";
    }
    print "</select></td></tr>\n";

    my $firstflag = 1;

    # Get Subject Info for this student
    my $sth1 = $dbh->prepare("select distinct category, catnum 
      from subject, evalmst where evalmst.studnum = ? and
      evalmst.subnum = subject.catnum
      order by subject.category");
    $sth1->execute( $studnum );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

    # Now loop through his/her subjects; pick one to edit
    while ( my ( $category, $catnum ) = $sth1->fetchrow ) {
	print "<tr><td><input type=\"submit\" name=\"$catnum\" ";
	print "value=\"$category ($catnum)\"></td></tr>\n";
	$firstflag = 0;
    }

    print "</table></form>\n";

    if ( $firstflag ) {
	print "<p><b>". $lex{'No Records Found'}. "</b></p>\n";
    }
    print "</center></body></html>\n";

    # Choice variable passes catnum of category. 
    # 'studnum' passed is studnum for student in "special" table.

    exit;

} # end of selectSubject



#----------------
sub addEditRecord {
#----------------

    # Get studnum, term, and subject
    my $studnum = $arr{studnum};
    delete $arr{studnum};
    my $term = $arr{term};
    delete $arr{term};

    my ( $catnum, $dud ) = each %arr; # since only one left in %arr hash.

    # get student name
    my $sth = $dbh->prepare("select lastname, firstname, grade 
      from special where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname, $grade ) = $sth->fetchrow;
    

    # Print Heading for Doc (with name)
    print "<center><h1>". $lex{'Student Evaluation Entry'}. "</h1>\n";
    print "<h2>$firstname $lastname - ". $lex{Term}. " $term</h2>\n";

    # Get Subject Name
    $sth = $dbh->prepare("select category from subject where catnum = ?");
    $sth->execute( $catnum );
    if ( $DBI::errstr){print $DBI::errstr; die $DBI::errstr; }
    my $category = $sth->fetchrow;


    # Get Subject Info from evalmst for this student
    my $sth1 = $dbh->prepare("select * from evalmst where studnum = ? and subnum = ?");
    $sth1->execute( $studnum, $catnum );
    if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr; }

    # Test Code. Should never run.
    my $rows = $sth1->rows;
    if ($rows < 1){
	print "</table></form><h1>". $lex{'Subject not found!'}. "</h1></body></html>\n";
	die $lex{'Subject not found!'}. "\n";
    }

    my @evalmst = $sth1->fetchrow;

    # Read in evaluation record (if it exists) from eval.
    my $sth3 = $dbh->prepare("select * from eval where studnum = ? and 
     subnum = ? and term = ?");
    $sth3->execute( $studnum, $catnum, $term );

    my $testrows = $sth3->rows;
    if ($testrows > 1){ # We have an error!
	print "<h1>Error! More than 1 evaluation record for $studentname";
	print "for $category for term $term. Please contact Les Richardson.";
	die "Multiple Evaluation Records!\n";
    }

    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my @eval = $sth3->fetchrow;
    my $evalid;
    if ( $testrows == 1 ) { $evalid = $eval[0];} # pass whether add or edit mode.

    # Print Form section
    print"<h2>$category ($catnum)</h2>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name = \"page\" value = \"3\">\n";
    print "<input type=\"hidden\" name = \"studnum\" value = \"$studnum\">\n";
    print "<input type=\"hidden\" name = \"term\" value = \"$term\">\n";
    print "<input type=\"hidden\" name = \"subnum\" value = \"$catnum\">\n";
    print "<input type=\"hidden\" name=\"id\" value=\"$evalid\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Objectives}. "</th><th>". $lex{Eval}. "</th></tr>\n";

    for ( my $j=3; $j<=34; $j++ ) {
	if ( $evalmst[$j] ) {
	    my $i = $j - 2;
	    print "<tr><td>$evalmst[$j]</td>\n";
	    print "<td><input type=\"text\" name=\"obj$i\" size=\"6\" value=\"$eval[$j]\">";
	    print "</td></tr>\n";
	}
    } # End For loop

    print "<tr><td colspan=\"2\" align=\"center\"><b>". $lex{Comment}. "</b><br>\n";
    print "<textarea name=\"comment\" cols=\"60\" rows=\"6\">$eval[36]</textarea>\n";
    print "<p></p></td></tr>\n";

    print "</table><input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
    print "</form></center></body></html>\n";

    exit;

}


#----------------
sub writeRecord {
#----------------


    # Get Student Name
    $sth = $dbh->prepare("select lastname,firstname from special where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr; }
    my ($lastname,$firstname) = $sth->fetchrow;
    my $studentname = "$firstname $lastname";  
    my $studnum = $arr{studnum}; # non quoted version needed for link below.

    # ADD Mode
    if ( not $arr{id} ){ 

        delete $arr{id}; # delete hash key if no value found.

	my @keys = keys %arr;
	my $keys = join(',', @keys);
	
	foreach my $k ( keys %arr ) {
	    $arr{$k} = $dbh->quote( $arr{$k} );
	}
	my $values = join(',', ( values %arr ));

	$sth = $dbh->prepare("insert into eval ( $keys ) values ( $values )");
	$sth->execute;

    }  else {  # UPDATE Mode

	my $id = $arr{id}; # remove the record id from values to be updated.
	delete $arr{id}; 

	foreach my $key ( keys %arr ) {
	    my $sth = $dbh->prepare("update eval set $key = ? where id = $id ");
	    $sth->execute( $arr{$key} );
	}

    } # End of Update Mode.

    if ( not $DBI::errstr ) {
	print "<h3>". $lex{'The evaluation record is now stored/updated'}. ".</h3></p>";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. ". \n";
	print $lex{'Contact'}. " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
        print $lex{'Please record the following error'}. ": $DBI::errstr </h3>\n";
    }

    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self\">". $lex{'Other Student Evaluations'}. "</a> |\n";
    print "<a href=\"$self?page=1&studnum=$studnum\">";
    print $lex{'Edit More'}. q{ }. $studentname. "</a> ]\n";

    # Method for going one page deeper, but no term select... remove
    # Get Subject Info for this student
    #$sth = $dbh->prepare("select distinct subject.category, subject.catnum 
    # from subject,evalmst where evalmst.studnum = ? and 
    # evalmst.subnum = subject.catnum order by subject.category");
    #$sth->execute( $studnum );
    #if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

    #while ( my ($category,$catnum) = $sth->fetchrow ) {
    #print "<tr><td><a href=\"$self?choice=$catnum&studnum=$arr{studnum}\">";
    #print "$category ($catnum)</a></td></tr>\n";
    # }
    #print "</table>";

    print "</center></body></html>\n";

    exit;

} # end of writeRecord
