#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'Evaluation Master Entry' => 'Evaluation Master Entry',
	   'Category' => 'Category',
	   'School' => 'School',	   
	   'Main' => 'Main',
	   'Objective' => 'Objective',
	   'Objectives' => 'Objectives',
	   'Add' => 'Add',
	   'Please select the student and objectives' => 
	     'Please select the student and objectives',
	   'Select Student' => 'Select Student',
	   'Save Objectives' => 'Save Objectives',
	   'Strategies, Resources and Activities' => 'Strategies, Resources and Activities',
	   'Responsible Person(s)' => 'Responsible Person(s)',
	   'Long Term Objective' => 'Long Term Objective',
	   'Note' => 'Note',
	   'You are limited to 32 objectives per &quot;subject&quot;' =>
	     'You are limited to 32 objectives per &quot;subject&quot;',
	   'Mastery' => 'Mastery',
	   'Term' => 'Term',	   
	   'Select' => 'Select',
	   'Save Objectives' => 'Save Objectives',
	   'Entry Error: No student selected or &gt; 32 objectives selected.' =>
	     'Entry Error: No student selected or &gt; 32 objectives selected.',
	   'Add More Eval Master Objectives' => 'Add More Eval Master Objectives',
	   'Your subject master is now stored' => 'Your subject master is now stored',
	   'There was an error storing your data' => 'There was an error storing your data',	   
	   'Contact' => 'Contact',
	   'Please record the following error' => 'Please record the following error',
	   'You already have an evaluation master for this subject' =>
	     'You already have an evaluation master for this subject',
	   'Mastery' => 'Mastery',
	   'Impact Area' => 'Impact Area',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'evalmstadd.pl';

use DBI;
use CGI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


# Print Page Heading
print "$doctype\n<html><head><title>". $lex{'Evaluation Master Entry'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head>\n";
print "<body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ] $firstname $lastname\n";
print "<center><h1>". $lex{'Evaluation Master Entry'}. "</h1>\n";

if ( not $arr{page} ) {
    showStartPage();
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectObjectives();
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    writeRecord();
}



#----------------
sub showStartPage {
#----------------

    my $sth = $dbh->prepare("select distinct catnum, category, count(idnum) 
     from subject group by category order by category");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Category}. "</th><th></th></tr>\n";

    while ( my ($catnum,$category, $count) = $sth->fetchrow ) {
	print "<tr><td align=\"right\"><form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
	print "<input type=\"hidden\" name=\"catnum\" value=\"$catnum\">\n";
	print "<input type=\"hidden\" name=\"studnum\" value=\"$arr{studnum}\">\n";
	print "<input type=\"submit\" value=\"$category ($catnum)\"></form>\n";
	print "<td>$count ". $lex{Objectives}. "</td></tr>\n";
    }

    print "</table></center></body></html>\n";

    exit;

} # End of showStartPage


#-------------------
sub selectObjectives {
#-------------------

    my $catnum = $arr{catnum};
    my $currentstudnum = $arr{studnum};

    # Read in all special students from this school and put in array
    my $sth = $dbh->prepare("select lastname, firstname, studnum from special 
     $select order by lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    my ( $currentstud, @students );
    while ( my ( $lastname, $firstname, $studnum ) = $sth->fetchrow ) {
	if ( $studnum == $currentstudnum ) { 
	    $currentstud = "$lastname, $firstname ($studnum)";
	}
	my $studrec = "$lastname, $firstname ($studnum)";
	push @students, $studrec;
    }
    # Done loading students.

    # Now find subject name for entered value
    $sth = $dbh->prepare("select category from subject where catnum = ?");
    $sth->execute( $catnum );
    if ($DBI::errstr) { print $DBI::errstr; die;}    
    my $category = $sth->fetchrow;

    # Form Start
    print "<p>". $lex{'Please select the student and objectives'}. "</p>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"catnum\" value=\"$catnum\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";

    # Student Select
    print "<table cellpadding=\"10\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><td align=\"center\">\n";
    print "<b>". $lex{'Select Student'}. ":</b> ";
    print "<select name=\"student\"><option>$currentstud</option>\n";
    foreach my $student ( @students ){
	print "<option>$student</option>\n";
    }
    print "</select></td></tr>\n</table>\n";


    # Section subject specific stuff.
    # Now print objectives
    print "<h2>$category ". $lex{Objectives}. "</h2>\n";
    print "<div><b>". $lex{Note}. ":</b> \n";
    print $lex{'You are limited to 32 objectives per &quot;subject&quot;'}. "<br>\n";
    print "<input type=\"submit\" value=\"". $lex{'Save Objectives'}. "\"></div>\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><td colspan=\"4\"><b>". $lex{'Strategies, Resources and Activities'}. "</b>\n";
    print "<textarea name=\"method\" rows=\"2\" cols=\"100\"></textarea></td></tr>\n";

    print "<tr><td colspan=\"4\"><b>". $lex{'Responsible Person(s)'}. "</b>\n";
    print "<input name=\"responsible\" size=\"80\"></td></tr>\n";

    print "<tr><td colspan=\"4\"><b>". $lex{'Long Term Objective'}. "</b>\n";
    print "<input type=\"text\" name=\"longtermobjective\" size=\"80\" ";
    print "maxlength=\"255\"></td></tr>\n";

    # Impact Areas
    print "<tr><td colspan=\"4\"><b>". $lex{'Impact Area'}. "</b>\n";
    print "<select name=\"impactarea\"><option></option>\n";
    foreach my $impact ( @impacts ){ # from config file
	print "<option>$impact</option>\n";
    }
    print "</select></td></tr>\n";


    $sth = $dbh->prepare("select idnum, description from subject 
      where catnum = ? order by idnum");
    $sth->execute( $catnum );
    if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }    


    print "<tr><th>". $lex{Objective}. "</th><th>". $lex{Mastery}. "</th><th>";
    print $lex{Term}. "</th><th>". $lex{Select}. "</th></tr>\n";

    while ( my ( $idnum, $description ) = $sth->fetchrow ) {

	print "<tr><td><i>$idnum</i>. $description</td>\n";

	# Mastery Level
	print "<td><select name=\"M-$idnum\"><option></option>\n";
	foreach my $mst ( @g_mastery ) {
	    print "<option>$mst</option>";
	}
	print "</select></td>\n";

	# Starting Term for implementation
	print "<td><select name=\"T-$idnum\"><option></option>\n";
	foreach my $trm ( @g_termst ) {
	    print "<option>$trm</option>";
	}
	print "</select></td>\n";


	print "<td align=\"center\">";
	print "<input type=\"checkbox\" name=\"$idnum\" value=\"1\"></td></tr>\n";

    }

    print "</table><input type=\"submit\" value=\"". $lex{'Save Objectives'}. "\">\n";
    print "</form></body></html>\n";

    exit;

} # End of addObjectives



#---------------
sub writeRecord {
#---------------

    # get student name/studnum
    my ($studname, $studnum) = split /\(/, $arr{student};
    chop $studnum; # delete trailing parenthesis.
    delete $arr{student};

    # subject number.
    my $catnum = $arr{catnum};
    delete $arr{catnum};

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    #die;

    foreach my $key ( keys %arr ) {
	if ( $arr{$key} == 1 ) { # We have a selection for subject master
	    push @objarray, $key; 
	}
    }
    @objarray = sort { $a <=> $b} @objarray; # sort numerically.


    if ( $#objarray > 31 or not $studnum ) { # We have entry errors
	print "<h3>";
	print $lex{'Entry Error: No student selected or &gt; 32 objectives selected.'};
	print "</h3>\n";
	die;
    }

    my $sth = $dbh->prepare("select count(*) from evalmst where subnum = ? and studnum = ?");
    $sth->execute( $catnum, $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $mstcount = $sth->fetchrow;

    if ( $mstcount > 0 ){ # We have existing records...
	print "<h1>". $lex{'You already have an evaluation master for this subject'}. "</h1>\n";
	die;
    }

    # pull in objective description from the database.
    my $tmpcat = $dbh->quote( $catnum );
    my %rec; # hash to hold values to insert into evalmst table.
    $sth = $dbh->prepare("select description from subject where catnum = $tmpcat and idnum = ?");
    my $objcount = 1; # used to create 'obj1', 'obj2' keys
    foreach my $objective ( @objarray ) {  # $objective is an id number in subject.
	$sth->execute( $objective );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my $desc = $sth->fetchrow;

	my $mastery = $arr{'M-'.$objective};
	if ( $mastery ){ $mastery = $lex{Mastery}. q{:}. $mastery; }
	my $term = $arr{'T-'.$objective};

	my $value = $dbh->quote("($catnum-$objective) $desc $mastery $term");
	my $key = 'obj'. $objcount;
	$rec{$key} = $value;

	$objcount++;

    }

    # put in rest of record values
    $rec{method} = $dbh->quote( $arr{method} );
    $rec{responsible} = $dbh->quote( $arr{responsible} );
    $rec{longtermobjective} = $dbh->quote( $arr{longtermobjective} );
    $rec{impactarea} = $dbh->quote( $arr{impactarea} );
    $rec{studnum} = $dbh->quote( $studnum );
    $rec{subnum} = $dbh->quote( $catnum );

    my @keys = keys %rec;
    my $keys = join(',', @keys);
    my $values = join(',', ( values %rec ));

    $sth = $dbh->prepare("insert into evalmst ( $keys ) values ( $values )");
    $sth->execute;

    if (not $DBI::errstr ) {
	print "<h3>". $lex{'Your subject master is now stored'}. ".</h3>\n";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. "\n";
	print $lex{Contact}. " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Please record the following error'}. " $DBI::errstr</h3>\n";
    }

    print " <p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self\">". $lex{'Add More Eval Master Objectives'}. "</a> ]</p>\n";
    print "</center></body></html>\n";

    exit;


} # end of writeRecords
