#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'Edit/Delete Eval Masters' => 'Edit/Delete Eval Masters',
	   'Main' => 'Main',
	   'Click on <i>name</i> to view Student Objectives' =>
	     'Click on <i>name</i> to view Student Objectives',
	   'Student' => 'Student',
	   'Category' => 'Category',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Name' => 'Name',
	   'Category' => 'Category',
	   'Method' => 'Method',
	   'Responsible' => 'Responsible',
	   'Objective' => 'Objective',
	   'Number of dependent Evaluation Records' => 'Number of dependent Evaluation Records',
	   'These records will be deleted also' => 'These records will be deleted also',
	   'Are you sure you want to delete these records?' => 
	     'Are you sure you want to delete these records?',
	   'Yes, delete the records!' => 'Yes, delete the records!',
	   'Record Deletion Failed' => 'Record Deletion Failed',
	   'Contact' => 'Contact',
	   'Record deleted' => 'Record deleted',
	   'View/Edit/Delete' => 'View/Edit/Delete',
	   'Evaluation Master Records' => 'Evaluation Master Records',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'evalmstdeled.pl';

use DBI;
use CGI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "and school = $sdb ";


print "$doctype\n<html><head><title>". $lex{'Edit/Delete Eval Masters'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head>\n";
print "<body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ]  <b>School:</b> $cookieuser\n";
print "<center><h1>". $lex{'Edit/Delete Eval Masters'}. "</h1>\n";

if ( not $arr{mode} ) {
    showStartPage();
} elsif ( $arr{mode} eq 'askdel' ) {
    delete $arr{mode};
    confirmDelete( $arr{id} );
} elsif ( $arr{mode} eq 'delete' ) {
    delete $arr{mode};
    deleteRecord( $arr{id} );
}


#----------------
sub showStartPage {
#----------------

    print "<div style=\"padding:0.5em;\">";
    print $lex{'Click on <i>name</i> to view Student Objectives'}. "</div>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">";
    print "<tr><th>". $lex{Student}. "</th><th>". $lex{Category}. "</th><th></th><th></th></tr>\n";

    my $sth = $dbh->prepare("select e.id, e.studnum, e.subnum from evalmst as e, special as s 
     where e.studnum = s.studnum $select
     order by s.lastname, s.firstname , e.subnum");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;

    my $sth1 = $dbh->prepare("select lastname, firstname from special where studnum = ?");
    my $sth2 = $dbh->prepare("select category from subject where catnum = ?");

    while ( my ( $id, $studnum, $subnum ) = $sth->fetchrow ) {

	# Get Student Name
	$sth1->execute( $studnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth1->fetchrow;
  
	# Get Subject Desc
	$sth2->execute( $subnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $category = $sth2->fetchrow;

	my $name = "$firstname $lastname ($studnum)";
	print "<tr><td align=\"right\"><form action=\"evalmstview.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
	print "<input type=\"submit\" value=\"$name\"></form></td>\n";

	print "<td>$category ($subnum)</td>";

	print "<td><form action=\"evalmsted.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
	print "<input type=\"submit\" value=\"". $lex{Edit}. "\"></form></td>\n";

	print "<td><form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
	print "<input type=\"hidden\" name=\"mode\" value=\"askdel\">\n";
	print "<input type=\"submit\" value=\"". $lex{Delete}. "\"></form></td></tr>\n";

    }

    print "</table></center></body></html>\n";

    exit;

} # end of showStartPage



#----------------
sub confirmDelete {
#----------------

    # passed id of record to delete.
    my $id = shift;

    my $sth = $dbh->prepare("select studnum, subnum, obj1, obj2, obj3, 
     method, responsible from evalmst where id = ?"); 
    $sth->execute( $id );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my ($studnum, $subnum, $obj1, $obj2, $obj3, $method, $responsible ) = $sth->fetchrow;

    # Now Find out how many records depend on this...
    $sth = $dbh->prepare("select count(subnum) from eval where studnum = ? and subnum = ?"); 
    $sth->execute( $studnum, $subnum );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $evalcount = $sth->fetchrow;

    # Get Student Name
    $sth = $dbh->prepare("select lastname,firstname from special where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;
  
    # Get Subject Name
    $sth = $dbh->prepare("select category from subject where catnum = ?");
    $sth->execute( $subnum );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $category = $sth->fetchrow;

    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";

    print "<tr><td align=\"right\">". $lex{Name}. "</td><td>$firstname $lastname</td></tr>\n";
    print "<tr><td align=\"right\">". $lex{Category}. "</td><td>$category</td></tr>\n";
    print "<tr><td align=\"right\">". $lex{Method}. "</td><td>$method</td></tr>\n";
    print "<tr><td align=\"right\">". $lex{Responsible}. "</td><td>$responsible</td></tr>\n";
    print "<tr><td align=\"right\">". $lex{Objective}. " 1</td><td>$obj1</td></tr>\n";
    print "<tr><td align=\"right\">". $lex{Objective}. " 2</td><td>$obj2</td></tr>\n";
    print "<tr><td align=\"right\">". $lex{Objective}. " 3</td><td>$obj3</td></tr>\n";
    print "</table>\n";

    print "<p><b>". $lex{'Number of dependent Evaluation Records'}. ": $evalcount</b><br>\n";
    print $lex{'These records will be deleted also'}. "</p>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"mode\" value=\"delete\">\n";
    print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";

    print "<p><em>". $lex{'Are you sure you want to delete these records?'}. "</em></p>\n";
    print "<input type=\"submit\" value=\"". $lex{'Yes, delete the records!'}. "\">\n";
    print "</form></body></html>\n";

    exit;

}


#---------------
sub deleteRecord {
#---------------

    my $id = shift; # passed id of record in evalmst to delete.

    # Get the student number and subject number (catnum)
    my $sth = $dbh->prepare("select studnum, subnum from evalmst where id = ?");
    $sth->execute( $id );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr;}
    my ( $studnum, $subnum ) = $sth->fetchrow;

    # Now delete the record.
    $sth = $dbh->prepare("delete from evalmst where id = ?");
    $sth->execute( $id );

    # We'll also delete the dependent records, too.
    $sth = $dbh->prepare("delete from eval where studnum = ? and subnum = ?");
    $sth->execute( $studnum, $subnum );


    if ($DBI::errstr) {
	print $lex{'Record Deletion Failed'}. ". ". $lex{Contact}. " $adminname.<br>\n";
	print $lex{Error}. " $DBI::errstr<br>\n";
    } else {
	print "<h2>". $lex{'Record deleted'}. ".</h2>\n";
    }

    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self\">". $lex{'View/Edit/Delete'}. q{ };
    print $lex{'Evaluation Master Records'}. "</a> ]\n"; 

    print "</center></body></html>\n";

    exit;

}
