#!/usr/bin/perl

#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'No student found' => 'No student found',
	   'Missing master evaluation record id' => 'Missing master evaluation record id',
	   'or' => 'or',
	   'Missing student number' => 'Missing student number',
	   'Missing category number' => 'Missing category number',
	   'Edit Master Evaluation' => 'Edit Master Evaluation',
	   'Edit/Delete Other Evaluation Masters' => 'Edit/Delete Other Evaluation Masters',
	   'Dependent evaluation records exist' => 'Dependent evaluation records exist',
	   'If you change or delete objectives for this subject/category' =>
	     'If you change or delete objectives for this subject/category',
	   'please update any dependent records' => 'please update any dependent records',
	   'Update Record' => 'Update Record',
	   'Student' => 'Student',
	   'Method' => 'Method',
	   'Responsible' => 'Responsible',
	   'Long Term Objective' => 'Long Term Objective',
	   'Objective' => 'Objective',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Your update is now stored' => 'Your update is now stored',
	   'Impact Area' => 'Impact Area',
	   'Objective Category' => 'Objective Category',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'evalmsted.pl'; # drop zero later.

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;



# passed record to edit (recnum) or studnum and catnum
if ( $arr{id} ){ 
    $sth = $dbh->prepare("select * from evalmst where id = ?"); 
    $sth->execute( $arr{id} );
} elsif ( $arr{studnum} and $arr{catnum} ) { 
    $sth = $dbh->prepare("select * from evalmst 
      where studnum = ? and subnum = ?"); 
    $sth->execute( $arr{studnum}, $arr{catnum} );
} else { # We have an error!
    print "<h1>". $lex{'Missing master evaluation record id'}. q{ };
    print $lex{'or'}. q{ };
    print $lex{'Missing student number'}. q{ }. $lex{or}. q{ };
    print $lex{'Missing category number'}. "</h1>\n";
    die;
}

if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
my @arr = $sth->fetchrow;


# Get Student Name
my $sth1 = $dbh->prepare("select lastname,firstname from special where studnum = ?");
$sth1->execute( $arr[1] );
if ($DBI::errstr) { print $DBI::errstr;die $DBI::errstr; }
my ($lastname,$firstname) = $sth1->fetchrow;
if ( not $lastname ){ $lastname = $lex{'No student found'};}

  
# Get Category Description (ie. category)
$sth1 = $dbh->prepare("select category from subject where catnum = ?");
$sth1->execute( $arr[2] );
if ($DBI::errstr) { print $DBI::errstr;die $DBI::errstr; }
my $category = $sth1->fetchrow;


# Get Dependent Record(s) count (in eval table)
$sth1 = $dbh->prepare("select count(*) from eval where studnum = ? and subnum = ?");
$sth1->execute( $arr[1], $arr[2] );
if ($DBI::errstr) {print $DBI::errstr;die;}
my $evalcount = $sth1->fetchrow;

# Print Top of Page
print "$doctype\n<html><head><title>". $lex{'Edit Master Evaluation'}. "</title>\n";

print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body>[ <a href=\"$iephome\">". $lex{Main}. "</a> | \n";
print "<a href=\"evalmstdeled.pl\">". $lex{'Edit/Delete Other Evaluation Masters'}. "</a> ]\n";
print "$firstname $lastname \n";
print "<center><h1>". $lex{'Edit Master Evaluation'}. "</h1>\n";


if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    writeRecord();
}


print "<div style=\"width:70%;padding:0.6em;\"><b>$evalcount ";
print $lex{'Dependent evaluation records exist'};
print ".</b>\n".  $lex{'If you change or delete objectives for this subject/category'}. q{, };
print $lex{'please update any dependent records'}. ".</div><p></p>\n";

print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"id\" value=\"$arr[0]\">
<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";

print "<table><tr><td colspan=\"2\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{'Update Record'}. "\"></b></td></tr>\n";

print "<tr><td colspan=\"2\" align=\"center\" ";
print "style=\"weight:bold;font-size:130%;padding:0.5em;\">$firstname $lastname</td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Objective Category'}. "</b></td>\n";
print "<td>$arr[2] - $category</td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Method}. "</b></td>\n";
print "<td><textarea rows=\"6\" cols=\"60\" name=\"method\">$arr[35]</textarea></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Responsible}. "</b></td>\n";
print "<td><textarea rows=\"3\" cols=\"60\" name=\"responsible\">$arr[36]</textarea></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Long Term Objective'}. "</b></td>\n";
print "<td><textarea rows=\"2\" cols=\"60\" name=\"longtermobjective\">$arr[37]";
print "</textarea></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Impact Area'}. "</b></td>\n";
print "<td><select name=\"impactarea\"><option>$arr[38]</option>\n";
foreach my $impact ( @impacts ) { print "<option>$impact</option>\n"; }
print "</select></td></tr>\n";


for ( my $i=1; $i<=32; $i++ ) {
    my $index = $i + 2;
    my $name = "obj$i";
    print "<tr><td align=\"right\"><b>". $lex{Objective}. " $i</b></td>\n";
    print "<td><textarea name=\"$name\" cols=\"60\" rows=\"2\">$arr[$index]</textarea>\n";
    print "</td></tr>\n";
}

print "<tr><td></td><td><input type=\"submit\" value=\"". $lex{'Update Record'};
print "\"></td></tr></table></form></center></body></html>\n";


#--------------
sub writeRecord {
#--------------

    #foreach my $key (sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    #die;

    my $id = $arr{id}; # remove the record id from values to be updated.
    delete $arr{id}; 

    foreach my $key ( keys %arr ) {
	my $sth = $dbh->prepare("update evalmst set $key = ? where id = $id");
	if ( not $arr{$key} ) { $arr{$key} = undef; }
	$sth->execute( $arr{$key} );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    }

    if ( not $DBI::errstr ) { 
	print "<h3>". $lex{'Your update is now stored'}. ".</h3>\n"; 
    } else { 
	print "<h3>". $lex{'There was an error storing your data'}. ". \n";
	print $lex{Contact}. " $adminname  <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{Error}. " :$DBI::errstr \n";
    }
    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"evalmstdeled.pl\">". $lex{'Edit/Delete Other Evaluation Masters'}. "</a> ]\n";
    print "</body></html>\n";

    exit;

}
