#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.
#  Outline: View Evaluation Outline for Current School


my %lex = ('Error' => 'Error',
	   'View Evaluation Masters' => 'View Evaluation Masters',
	   'Main' => 'Main',
	   'Edit/Delete Eval Masters' => 'Edit/Delete Eval Masters',
	   'View All Eval Masters' => 'View All Eval Masters',
	   'Click on <i>Subject</i> to edit Objectives Text' => 
	     'Click on <i>Subject</i> to edit Objectives Text',
	   'Subject' => 'Subject',
	   'Objectives' => 'Objectives',
	   'Strategies' => 'Strategies',
	   'Responsible' => 'Responsible',
	   'Long Term Objective' => 'Long Term Objective',
	   'Impact Area' => 'Impact Area',
	   'Please Log In' => 'Please Log In',
	   
	   );

my $self = 'evalmstview.pl';

use DBI;
use CGI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "and school = $sdb ";


# Print Page Head
print "$doctype\n<html><head><title>". $lex{'View Evaluation Masters'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body><a name=\"top\"></a>[ <a href=\"$iephome\">". $lex{Main}. "</a> | \n";
print "<a href=\"evalmstdeled.pl\">". $lex{'Edit/Delete Eval Masters'}. "</a> | \n";
print "<a href=\"evalmstview.pl\">". $lex{'View All Eval Masters'}. "</a> ] ";
print "$firstname $lastname\n";
print "<center><h1>". $lex{'View Evaluation Masters'}. "</h1>\n";


# Find the Eval Masters and the Students for this school
$sth = $dbh->prepare("select s.studnum, e.subnum from evalmst as e, special as s
  where e.studnum = s.studnum $select 
  order by s.lastname, s.firstname, e.subnum");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
$rows = $sth->rows;

my $currstud = '-1'; # unlikely value
my $oldstud;

for (my $i=1; $i <= $rows; ++$i) {# loop through students/subjects

   my ($studnum, $catnum) = $sth->fetchrow;
   #print "SN: $studnum CN: $catnum<br>\n";

   # lookup subject name (category);
   $sth1 = $dbh->prepare("select category from subject where catnum = ?");
   $sth1->execute( $catnum );
   if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }
   my $category = $sth1->fetchrow; 

   # pull in evaluation master file.
   $sth1 = $dbh->prepare("select * from evalmst where subnum = ? and studnum = ?");
   $sth1->execute( $catnum, $studnum );
   if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
   my @evalmst = $sth1->fetchrow; 

   $oldstud = $currstud;
   $currstud = $studnum;     

   if ( $oldstud ne $currstud ) {  
       # new student: pull in name, finish old table, print new name.
       # Lookup Student Name
       $sth1 = $dbh->prepare("select lastname, firstname from special where studnum = ?");
       $sth1->execute( $currstud );
       if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
       my ($lastname, $firstname) = $sth1->fetchrow;
   
       if ($i != 1) { print "</table>[ <a href=\"#top\">Top</a> ]\n\n"; }

       print "<h3>$firstname $lastname ($currstud)</h3>\n";
       print "<p>". $lex{'Click on <i>Subject</i> to edit Objectives Text'}. "</p>\n";
       print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
       print "<tr><th>". $lex{Subject}. "</th><th>". $lex{Objectives}. "</th></tr>\n";      
   
   }
   
   print "<tr><td><a href=\"evalmsted.pl?studnum=$studnum&catnum=$catnum\">$category</a>";
   print "</td><td><ul>\n";
   for ( my $j=3; $j<35; $j++ ) {
       if ( $evalmst[$j] ){ print "<li>$evalmst[$j]</li> ";}
   }
   print "</ul><p><b>". $lex{Strategies}. ":</b> $evalmst[35]<br>\n";
   print "<b>". $lex{Responsible}. ":</b> $evalmst[36]<br>\n";
   print "<b>". $lex{'Long Term Objective'}. ":</b> $evalmst[37]<br>\n";
   print "<b>". $lex{'Impact Area'}. ":</b> $evalmst[38]</p></td></tr>\n";


} # End of loop counter

print "</table>[ <a href=\"#top\">Top</a> ]</center></body></html>\n";
