#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'View Evaluations' => 'View Evaluations',
	   'School' => 'School',
	   'Objectives' => 'Objectives',
	   'Term' => 'Term',
	   'Comments' => 'Comments',
	   'Please Log In' => 'Please Log In',

	   );

use DBI;
use CGI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "and school = $sdb ";


# Find students in evalmst; push into array.
$sth = $dbh->prepare("select distinct evalmst.studnum 
  from evalmst, special 
  where special.studnum = evalmst.studnum $select
  order by special.lastname, special.firstname");
$sth->execute;
if ( $DBI::errstr ) {print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;
for ( 1..$rows ) {
    my $sn = $sth->fetchrow;
    push @studarray, $sn;
} 
# Student numbers now in @studarray sorted by name


# Print Heading.
print "$doctype\n<html><head><title>". $lex{'View Evaluations'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
print "<center><h1>". $lex{'View Evaluations'}. "</h1>\n";


foreach my $studnum ( @studarray ) { # Once for each student.

    # Find the student name
    $sth = $dbh->prepare("select lastname, firstname from special where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow; 
    my $studname = "$firstname $lastname ($studnum)";

    # Find their subjects.
    $sth = $dbh->prepare("select * from evalmst where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;

    # Now table for this student
    print "<h2>$studname</h2>\n";
    print "<table>\n";


    # Loop; once for each subject.
    for ( my $i=1; $i <= $rows; ++$i ) {

	my @evalmst = $sth->fetchrow;
	my $subnum = $evalmst[2];

	#lookup subject name
	my $sth1 = $dbh->prepare("select category from subject where catnum = ?");
	$sth1->execute( $subnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $category = $sth1->fetchrow; 
	my $subname = "$category ($subnum)";

	   
	# Now find all term records for this subject for this student.
	my $sth2 = $dbh->prepare("select * from eval 
         where studnum = ? and subnum = ? order by term");
	$sth2->execute( $studnum, $subnum);
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $termrows = $sth2->rows;

	# Loop through all terms, pushing evaluations into array.   
	for ( my $j=1; $j<=$termrows; $j++ ) {
	    @termeval = $sth2->fetchrow;
	    $master[ $j ] = [ @termeval ];
	}

	print "<p><b>$subname</b></p>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print "<tr><th>". $lex{Objectives}. "</th>\n";

	for (1..$termrows){
	    print "<th>Term $_</th>";
	}
	print "</tr>\n"; # End of Table Header

	# Now print the table
	for ( my $j=3; $j<=34;$j++ ){
	    if ( $evalmst[ $j ] ) {
		print "<tr><td>$evalmst[$j]</td>";
		for ( my $k=1;$k<=$termrows;$k++ ) {
		    print "<td>$master[$k]->[$j]</td>";
		}
		print "</tr>\n";
	    }
	}

	# print comments at end of table.
	my $colspan = $termrows + 1;
	print "<tr><td colspan=\"$colspan\">\n";
	for ( my $k=1;$k<=$termrows; $k++ ) {
	    print "<b>". $lex{Term}. " $k ". $lex{Comments}. ":</b> $master[$k]->[36]<br>\n";
	    #print"T:1 $master[1][36]<br>T:2 $master[2][36]<br>";
	}
	print "</td></tr></table>\n";

    } # End of Subject "For" Loop
    
} # End of Student Loop

print "</body></html>\n";
