#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Add Impact Areas' => 'Add Impact Areas',
	   'Main' => 'Main',
	   'School' => 'School',
	   'Save Student Impacts' => 'Save Student Impacts',
	   'Student' => 'Student',
	   'Area of Impact' => 'Area of Impact',
	   'Missing Student!' => 'Missing Student!',
	   'Add More Student Impacts' => 'Add More Student Impacts',
	   'Impacts Added' => 'Impacts Added',
	   'No'  => 'No',
	   'Please Log In' => 'Please Log In',
	   'Continue to Add Rubrics' => 'Continue to Add Rubrics',

	   );


my $self = 'impactadd.pl';
my $maxImpacts = 6;  # Number of entry forms for impacts for this student...

use DBI;
use CGI;
use CGI::Session;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

# Open Database
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Add Impact Areas'};
print "</title>\n<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$iephome\">". $lex{Main};
print "</a> ] $firstname $lastname\n";
print '<center><h1>'. $lex{'Add Impact Areas'}. "</h1>\n";


if ( $arr{flag}) {
    delete $arr{flag};
    writeRecord();
} 

print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n";


# Start the form.
print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"flag\" value=\"1\">\n";
print "<div style=\"padding:0.3em;\"><input type=\"submit\" value=\"";
print $lex{'Save Student Impacts'}. "\"></div>\n";

my $passedstudent;
if ( $arr{studnum} ) {
    my $sth = $dbh->prepare("select lastname, firstname from special
      where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;
    $passedstudent = "$lastname, $firstname ($arr{studnum})";
}


# Get all/selected students
my $sth = $dbh->prepare("select lastname, firstname, studnum from special
  $select order by lastname, firstname");
$sth->execute;


print "<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\">\n";

# Show Student Choices...
print "<tr style=\"background-color:#DDD; text-align:center;\">";
print "<td><b>". $lex{'Student'};
print "</b> <select name=\"student\"><option>$passedstudent</option>\n";
while ( my ($lastname, $firstname, $studnum) = $sth->fetchrow){
    print "<option>$firstname $lastname ($studnum)</option>";
}
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
print "</select></td></tr>\n";


# Loop
foreach my $count ( 1..$maxImpacts ) {
    print "<tr><th>". $lex{'Area of Impact'}. "</th></tr>\n";
    print "<td align=\"center\"><select name=\"$count-impact\"><option></option>\n";
    foreach my $impact ( @impacts ) { # found in ppp.conf 
	print "<option>$impact</option>\n";
    }
    print "</select></td></tr>\n";

    print "<tr><td style=\"background-color:#DDD;\">";
    print "<textarea name=\"$count-desc\" cols=\"65\" rows=\"3\"></textarea></td></tr>\n";

} # End of student loop.


print "</table>\n";

print "<p><input type=\"submit\" value=\"". $lex{'Save Student Impacts'};
print "\"></p></form></body></html>\n";



#--------------
sub writeRecord {
#--------------

    # Exit if missing userid or date fields.
    if ( not $arr{student} ) {
	print '<h1>'. $lex{'Missing Student!'}. "</h1>\n";
	exit;
    }

    my ($name, $studnum) = split /\(/, $arr{student};
    chop $studnum;
    #print "S:$name  N:$studnum<br>\n";
    delete $arr{student};
    my $noflag = 1;

    foreach my $key ( keys %arr) {
	#print "K: $key V: $arr{$key}<br>\n";
	my ($num, $type) = split /-/, $key;
	my $desckey = $num . '-desc';
	if ( $type ne 'impact' or not $arr{$key} or not $arr{$desckey} ) { next; }

	my $impact = $dbh->quote( $arr{$key} );
	my $desc = $dbh->quote( $arr{$desckey} );
	#print "$num : $desc : $impact<br>\n";

	my $sth = $dbh->prepare("insert into impact values (
          $sql{default}, $studnum, $impact, $desc)");
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$noflag = 0;

    }

    if ( $noflag ) {
	print "<p><b>". $lex{No}. "</b> ";
    } else {
	print "<p><b>$name</b> ";
    }

    print $lex{'Impacts Added'}. "</p>\n";
    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self\">". $lex{'Add More Student Impacts'}. "</a> |\n";

    print "<form action=\"rubadd.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Continue to Add Rubrics'}. "\">\n";
    print "</form>\n";

    print "</body></html>\n";

    exit;

} # End of writeRecord()
