#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Script to show rubrics to allow editing or deleting.

my %lex = ('View/Edit Impacts' => 'View/Edit Impacts',
	   'Main' => 'Main',
	   'School' => 'School',
	   'Impact' => 'Impact',
	   'Description' => 'Description',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Area' => 'Area',
	   'No Records Found' => 'No Records Found',
	   'Student Impact Deleted' => 'Student Impact Deleted',
	   'View/Edit/Delete Impacts' => 'View/Edit/Delete Impacts',
	   'Update Student Impact' => 'Update Student Impact',
	   'Student Impact Updated' => 'Student Impact Updated',
	   'Missing Field!' => 'Missing Field!',
	   'Error' => 'Error',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'impactdeled.pl';

use DBI;
use CGI;
use CGI::Session;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
my $fieldlist = "i.id, i.studnum, i.area, i.description, s.lastname, s.firstname";


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "and school = $sdb ";


my $sth = $dbh->prepare("select $fieldlist from impact as i , special as s 
  where i.studnum = s.studnum $select  order by s.lastname, s.firstname, i.area");
$sth->execute;
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }


# Show Page Header.
print "$doctype\n<html><head><title>". $lex{'View/Edit Impacts'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ] $firstname $lastname\n";
print "<center><h1>". $lex{'View/Edit Impacts'}. "</h1>\n";

# Delete or Edit a Record (if passed a del or ed value).
if ( $arr{del} ) {
    deleteRecord( $arr{del} );
} elsif ( $arr{ed} ) {
    showRecord( $arr{ed} );
} elsif ( $arr{upd} ) {
    updateRecord( $arr{upd} );
}


my $currstud = -1;
my $oldstud;
my $first = 1;

while (my ($id, $studnum, $area, $description, $lastname, $firstname) = $sth->fetchrow ) {
   
    $oldstud = $currstud;
    $currstud = $studnum;

    if ($oldstud ne $currstud ) {  # We have a new student
	if (not $first) {  print "</table>"; } else { $first = 0; }

	print "<h3>$firstname $lastname</h3>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print '<tr><th>'. $lex{'Impact'}. '</th><th>'. $lex{'Description'};
	print '</th><th>'. $lex{Edit}. '</th><th>'. $lex{Delete}. "</th></tr>\n";      
    }

    print "<tr><td><b>$area</b></td><td>$description</td>\n";
    print "<td><a href=\"$self?ed=$id\">". $lex{Edit}. "</a></td>\n";
    print "<td><a href=\"$self?del=$id\">". $lex{Delete}. "</a></td></tr>\n";

} # End of loop counter

if ( $first ) {
    print "<h2>". $lex{'No Records Found'}. "</h2>\n";
}

print "</body></html>\n";



#---------------
sub deleteRecord {
#---------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    my $id = shift;
    my $sth = $dbh->prepare("delete from impact where id = ?"); 
    $sth->execute( $id );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

    print '<p><b>'. $lex{'Student Impact Deleted'}. "</b></p>\n";
    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self\">". $lex{'View/Edit/Delete Impacts'}. "</a> ]</p>\n";
    print "</body></html>\n";

    exit;

}

#-------------
sub showRecord {
#-------------

    my $id = shift;

    # Get record and then student name
    my $sth = $dbh->prepare("select * from impact where id = ?");
    $sth->execute( $id );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ($id1, $studnum, $area, $description) = $sth->fetchrow;

    $sth = $dbh->prepare("select lastname, firstname from special where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow;


    # Start the form.
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"upd\" value=\"$id\">\n";
    print "<p><input type=\"submit\" value=\"". $lex{'Update Student Impact'}. "\"></p>\n";

    print "<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th align=\"center\"><b>$firstname $lastname</b></th></tr>\n";

    # Now do the Impact Areas
    print "<tr><td align=\"center\"><b>". $lex{Impact}. q{ }. $lex{Area};
    print "</b><br><select name=\"area\">\n<option>$area</option>\n";
    foreach my $impact ( @impacts ){
	print "<option>$impact</option>\n";
    }
    print "</select></td></tr>\n";

    # Now the Description Area
    print "<tr><td>\n<textarea name=\"description\" cols=\"70\" rows=\"4\">";
    print "$description</textarea></td></tr></table>\n";

    # Final Submit and then close form.
    print "<p><input type=\"submit\" value=\"". $lex{'Update Student Impact'}. "\"></p>\n";
    print "</form></body></html>\n";

    exit;

}



#--------------
sub updateRecord {
#--------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }
    
    # exit if missing area or description
    if ( not $arr{area} or not $arr{description} ) {
	print '<h2>'. $lex{'Missing Field!'}. "</h2>\n";
	exit;
    }

    # quote fields
    my $area  = $dbh->quote( $arr{area} );
    my $description  = $dbh->quote( $arr{description} );

    # update the record
    my $sth = $dbh->prepare("update impact set
      area = $area,
      description = $description
    where id = ?");
    
    $sth->execute( $arr{upd} );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }    

    print '<p><b>'. $lex{'Student Impact Updated'}. "</b></p>\n";
    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self\">". $lex{'View/Edit/Delete Impacts'}. "</a> ]</p>\n";

    print "</body></html>\n";

    exit;

}
