#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my $self = 'login.pl';
my $defaultDuration = 20; # minutes 
my $minimumtime = 3; # minutes
my $maximumtime = 60; # minutes


my %lex = ('User Id' => 'User Id',
	   'Password' => 'Password',
	   'Duration' => 'Duration',
	   'Login' => 'Login',
	   'Staff Login' => 'Staff Login',
	   'min' => 'min',
	   'No Userid Found' => 'No Userid Found',
	   'Incorrect Password' => 'Incorrect Password',
	   'Logged In' => 'Logged In',
	   'User' => 'User',
	   'Logout Complete!' => 'Logout Complete!',
	   'Error' => 'Error',
	   'Continue' => 'Continue',

	   );


use DBI;
use CGI;
use CGI::Session;

my $q = CGI->new;
my %arr = $q->Vars;

eval require "ppp.conf";
if ( $@ ) {
    print $q->header;
    print $lex{Error}. " global.conf: $@<br>\n";
    die $lex{Error}. " global.conf: $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $q->header; 
    print $lex{Error}. " global.conf: $@<br>\n";
    die $lex{Error}. " global.conf: $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $login_result;
if ( $arr{userid} and $arr{password} ) {
    $login_result = doLogin();
} elsif ( $arr{quit} ) {
    doLogout(); 
} else {
    print $q->header;
    printHTMLHeader();
    showStartPage();
}



#----------------
sub showStartPage {
#----------------

    print "<center><h3>". $lex{'Staff Login'}. "</h3>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$arr{script}\">\n";

    print "<table cellpadding=\"6\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th align=\"right\">". $lex{'User Id'}. "</th>\n<th>";
    print "<input type=\"text\" name=\"userid\" size=\"10\" value=\"$arr{user}\"></th></tr>\n";

    print "<tr><th align=\"right\">". $lex{Password}. "</th>\n<th>";
    print "<input type=\"password\" name=\"password\" size=\"10\"></th></tr>\n";

    print "<tr><th align=\"right\">". $lex{Duration}. "</th><th>";
    print "<input type=\"text\" name=\"duration\" size=\"3\" value=\"$defaultDuration\"> ";
    print $lex{min}. "</th></tr>\n";

    print "<tr><th align=\"center\" colspan=\"2\">";
    print "<input type=\"submit\" value=\"". $lex{Login}. "\"></th></tr>\n";

    print "</table></form></center></body></html>\n";

    exit;

} # end of showStartPage;



#-----------
sub doLogout {
#-----------

    # $dbtype set in admin.conf / ppp.conf
    my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
				   undef,{Handle => $dbh}) or die CGI::Session->errstr;
    $session->delete;
    $session->flush;
    print $q->header;
    printHTMLHeader();

    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<center><h1>". $lex{'Logout Complete!'}. "</h1>\n";
    print "</center></body></html>\n";

    exit;

} # end of doLogout



#----------
sub doLogin {
#----------

    #print $q->header;
    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
				undef,{Handle => $dbh}) or die CGI::Session->errstr;

    # Check password/userid against database (-1 no user, -2 wrong password;
    my $error = checkPassword( $arr{userid}, $arr{password} );

    if ($error == -1){
	print $q->header; 
	printHTMLHeader();
	print "<center><h2>". $lex{'No Userid Found'}. "</h2>\n";
	showStartPage();
    }
    if ($error == -2){ 
	print $q->header;
	printHTMLHeader();
	print "<center><h2>". $lex{'Incorrect Password'}. "</h2>\n";
	showStartPage();
	
    }

    $cookietime = checkCookieTime( $arr{duration} );

    # Get School database 
    my $sth = $dbh->prepare("select schooldbase from educator
     where userid = ?");
    $sth->execute( $arr{userid} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $schooldbase = $sth->fetchrow;
    

    # Set values for userid, logged_in and duration in session
    $session->param('logged_in','1');
    $session->expire('logged_in',$cookietime);
    $session->param('userid',$arr{userid});
    $session->param('duration', $cookietime );
    # The duration value in the session has cookie markup: +20m format.

    $session->param('schooldbase', $schooldbase );

    # Now print page header...
    print $session->header;
    
    printHTMLHeader();
    print "<center><h3>". $lex{'Staff Login'}. "</h3>\n";

    my $sth = $dbh->prepare("select firstname, lastname from educator 
     where userid = ?");
    $sth->execute( $arr{userid} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ($firstname, $lastname) = $sth->fetchrow;
    
    print "$firstname $lastname<br>". $lex{'Logged In'}. "<br>\n";

    if ( $arr{script} ) {
	print "<form action=\"$arr{script}\" method=\"post\">\n";
	print "<input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
	print "</form>";
    }
    print "</body></html>\n";

    exit; 

}

#----------------
sub checkPassword {
#----------------
    my ($userid, $password) = @_;
    
    if (not $userid){ return -1;}
    if (not $password){ return -2;}

    # Sanitize 
    unless ( $password =~ m#^([\w\d.-@_+]+)$# ) {
      return -2;
    }
    $password = $1;

    #check for presence of userid
    my $sth = $dbh->prepare("select count(userid) from educator
     where userid = ?");
    $sth->execute( $userid );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ($count < 1){ return -1;} # no userid

    #check for presence of correct password and userid
    my $sth = $dbh->prepare("select count( userid ) from educator
     where userid = ? and password = ?");
    $sth->execute( $userid, $password );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ( $count < 1 ) { return -2; } # not correct password

    return 0; # if all ok...

}


#------------------
sub checkCookieTime {
#------------------

    # defaults set at top of script
    #$defaultDuration 
    #$minimumtime 
    #$maximumtime 

    my $cookietime;
    my $duration = shift;
    if ( $duration ) { 
	$cookietime = $duration;
    } else { 
	$cookietime = $defaultDuration;
    }

    $cookietime = $minimumtime if $cookietime < $minimumtime; 
    $cookietime = $maximumtime if $cookietime > $maximumtime; 
    $cookietime = "+".$cookietime."m"; # set format
    
    return $cookietime;

}


#------------------
sub printHTMLHeader {
#------------------

    # Print Page Heading
    print "$doctype\n<html><head><title>". $lex{'OA Staff Login'}. "</title>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";

    if ( $arr{userid} ) { # if user, jump to the password field.
	print "</head><body onload=\"document.forms[0].elements[2].focus()\">\n";
    } else {
	print "</head><body onload=\"document.forms[0].elements[1].focus()\">\n";
    }

}
