#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Subject Report' => 'Subject Report',
	   'Note' => 'Note',
	   'View Log File' => 'View Log File',
	   'Main' => 'Main',
	   'Error' => 'Error',
	   'Gr' => 'Gr',
	   'Print/View Subject Report' => 'Print/View Subject Report',
	   'Please Log In' => 'Please Log In',

	   );

$self = 'rptsubject.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "liblatex.pl";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
 $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


my $sth = $dbh->prepare("select * from subject 
 order by category, catnum, idnum");
$sth->execute;
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr ; }


print "$doctype\n<html><head><title>". $lex{'Subject Report'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
</head><body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
print "<center><h1>". $lex{'Subject Report'}. "</h1><h4>$currdate</h4>\n";


prPDFhead();
my $count = 0;
while ( my @arr = $sth->fetchrow ){
    $count++;
    @arr = latex_filter( @arr );
    
    $oldsub = $cursub;
    $cursub = $arr[1];
  
    if ( $cursub ne $oldsub ) {
	if ( $notfirst ){ 
	    print TEX "\\end{tabular}\\bigskip\n\n"; 
	} else { 
	    $notfirst = 1;
	}
	print TEX "\\hfil \\section{\\large\\sf $arr[2] ($arr[1])}\\hfil\n\n";
	print TEX "\\begin{tabular}{p{1in}p{5.4in}p{1in}}\\hline\n";
    }

    print TEX " $arr[1] - $arr[3] & $arr[5] & ";
    if ( $arr[4] ){ print TEX $lex{Gr}. ": $arr[4]"; }
    print TEX "\\\\\n";

    if ( not ($count % 2) ) { # put in space for line splits
	print TEX "\\end{tabular}\n\n";
	print TEX "\\begin{tabular}{p{1in}p{5.4in}p{1in}}\\hline\n";
    }

} # End of While loop
print TEX "\\end{tabular}"; # complete table.

prPDFfoot(); # print rest of PDF web page.

print "</center></body></html>\n";



#------------
sub prPDFhead {
#------------
    $shortname = "subjrep$$";
    $fileName = "$shortname.tex";

    open(TEX,">$fileName") || die "Can't open tex file";

    print TEX "\\documentclass[12pt,letterpaper,oneside]{article}
\\usepackage{graphicx,array,newcent,colortbl,inputenc}
\\usepackage[pdftex,bookmarks,bookmarksopen,pdfstartview=FitH]{hyperref}
\\inputencoding{latin1}
\\setlength{\\textwidth}{7.50in}
\\setlength{\\textheight}{10in}
\\setlength{\\hoffset}{0in}
\\setlength{\\voffset}{-1in}
\\setlength{\\topmargin}{0.2in}
\\addtolength{\\evensidemargin}{-1in}
\\addtolength{\\oddsidemargin}{-1in}
\\setlength{\\extrarowheight}{2pt}
\\setlength{\\parindent}{0in}
\\pagestyle{myheadings}
\\markright{$divisionname \\hfill ". $lex{'Subject Report'}. " \\hfill $currdate -- Pg }
\\begin{document}\n";

}


#------------
sub prPDFfoot {
#------------

    print TEX "\\end{document}";
    close TEX;
    system("$pdflatex $fileName > pdflog$$.txt");
    system("$pdflatex $fileName > /dev/null");
    #system("$pdflatex $fileName > /dev/null");
    # Compile 3 times to make sure all links built right.
    system("mv $shortname.pdf $downloaddir");
    system("mv pdflog$$.txt $downloaddir");
    system("rm -f $shortname.*");

    print "<h2><a href=\"$webdownloaddir/$shortname.pdf\">";
    print $lex{'Print/View Subject Report'}. "</a></h2>\n";
    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> | \n";
    print "<a href=\"$webdownloaddir/pdflog$$.txt\">";
    print $lex{'View Log File'}. "</a> ] </p>\n";

} # end of pfPDFfoot
