#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Add Student Outcome Rubric' => 'Add Student Outcome Rubric',
	   'Main' => 'Main',
	   'School' => 'School',
	   'Save Student Rubric' => 'Save Student Rubric',
	   'Student' => 'Student',
	   'Development Area' => 'Development Area',
	   'Target Skill' => 'Target Skill',
	   'Performance Level' => 'Performance Level',
	   'Responsible' => 'Responsible',
	   'Expectation' => 'Expectation',
	   'or' => 'or',
	   'Other' => 'Other',
	   'Add Another Rubric' => 'Add Another Rubric',
	   'Student Rubric Added' => 'Student Rubric Added',
	   'Missing Student or Development!' => 
	     'Missing Student or Development!',
	   'Current Date' => 'Current Date',

	   'Much Less than Expected' => 'Much Less than Expected',
	   'Current Level of Performance' => 'Current Level of Performance',
	   'Much Less than Expected' => 'Much Less than Expected',
	   'Somewhat Less than Expected' => 'Somewhat Less than Expected',
	   'Expected' => 'Expected',
	   'Somewhat More than Expected' => 'Somewhat More than Expected',
	   'Much More than Expected' => 'Much More than Expected',

	   'Objective/Curriculum Comparison' => 'Objective/Curriculum Comparison',

	   'Significant Variation in Objectives (>50%)' => 
	     'Significant Variation in Objectives (>50%)',
	   'Moderate Variation in Objectives (<50%)' => 'Moderate Variation in Objectives (<50%)',
	   'Minor Variation in Objectives (<25%)' => 'Minor Variation in Objectives (<25%)',
	   'Regular Curriculum' => 'Regular Curriculum',

	   'Evaluator' => 'Evaluator',
	   'Attainment Level Achieved' => 'Attainment Level Achieved',
	   'Year End Date' => 'Year End Date',
	   'Error' => 'Error',
	   'Please Log In' => 'Please Log In',
	   'Continue to Add Eval Masters' => 'Continue to Add Eval Masters',

	   );


my $self = 'rubadd.pl';

use DBI;
use CGI;
use CGI::Session;

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";

my $q = new CGI;
my %arr = $q->Vars;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


# Open Database
my $dsn = "DBI:$dbtype:$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Add Student Outcome Rubric'};
print "</title>\n<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$iephome\">". $lex{Main};
print "</a> ] $firstname $lastname\n";
print '<center><h1>'. $lex{'Add Student Outcome Rubric'}. "</h1>\n";

if ($arr{flag}) {
    delete $arr{flag};
    writeRecord();
    die;
}

# Get all/selected students and put into @students
my @students;
my $sth = $dbh->prepare("select lastname, firstname, studnum from special
  $select order by lastname, firstname");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}    
while (my ($lastname, $firstname, $studnum) = $sth->fetchrow){
    push @students, "$lastname, $firstname ($studnum)";
}


# Start the form.
print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"flag\" value=\"1\">
<p><input type=\"submit\" value=\"". $lex{'Save Student Rubric'}. "\"></p>\n";

my $passedstudent;
if ( $arr{studnum} ) {
    my $sth = $dbh->prepare("select lastname, firstname from special
      where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;
    $passedstudent = "$lastname, $firstname ($arr{studnum})";
}

print "<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th align=\"right\"><b>". $lex{Student}. "</b></th>
<th><select name=\"student\"><option>$passedstudent</option>\n";
foreach my $stud (@students) {
    print "<option>$stud</option>\n";
}
print "</select></th></tr>\n";


# Now do the Development Areas
print "<tr><td align=\"right\"><b>".
$lex{'Development Area'}. "</b></td><td><select name=\"dev_area\">
<option></option>\n";

foreach my $dev (@development){
    print "<option>$dev</option>\n";
}

print "</select><br>". $lex{or}. ' <b>'. $lex{Other};
print "</b> <input type=\"text\" name=\"other\" size=\"24\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Target Skill'};
print "</b></td>\n<td><input type=\"text\" name=\"target_skill\" size=\"32\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Current Date'};
print "</b></td>\n<td><input type=\"text\" name=\"currdate\" size=\"12\" value=\"$currdate\"></td></tr>\n";


# Now various performance levels.
print "<tr style=\"background-color:#DDD;\"><td align=\"right\"><b>". $lex{'Current Level of Performance'};
print "</b></td>\n<td>";
print "<textarea name=\"perf_lvl_current\" rows=\"2\" cols=\"40\"></textarea>\n";
print "</td></tr>\n";

print "<tr style=\"background-color:#DDD;\"><td align=\"right\"><b>". $lex{'Much Less than Expected'};
print "</b></td>\n<td><textarea name=\"perf_lvl_mless\" rows=\"2\" cols=\"40\"></textarea></td></tr>\n";

print "<tr style=\"background-color:#DDD;\"><td align=\"right\"><b>". $lex{'Somewhat Less than Expected'};
print "</b></td>\n<td><textarea name=\"perf_lvl_swless\" rows=\"2\" cols=\"40\"></textarea></td></tr>\n";

print "<tr style=\"background-color:#DDD;\"><td align=\"right\"><b>". $lex{'Expected'};
print "</b></td>\n<td><textarea name=\"perf_lvl_expect\" rows=\"2\" cols=\"40\"></textarea></td></tr>\n";

print "<tr style=\"background-color:#DDD;\"><td align=\"right\"><b>". $lex{'Somewhat More than Expected'};
print "</b></td>\n<td><textarea name=\"perf_lvl_swmore\" rows=\"2\" cols=\"40\"></textarea></td></tr>\n";

print "<tr style=\"background-color:#DDD;\"><td align=\"right\"><b>". $lex{'Much More than Expected'};
print "</b></td>\n<td><textarea name=\"perf_lvl_mmore\" rows=\"2\" cols=\"40\"></textarea></td></tr>\n";


# Objective Adaptation
print "<tr><td align=\"right\"><b>". $lex{'Objective/Curriculum Comparison'};
print "</b></td>\n<td><select name=\"objective_var\"><option></option>\n";
print "<option>". $lex{'Significant Variation in Objectives (>50%)'}. "</option>\n";
print "<option>". $lex{'Moderate Variation in Objectives (<50%)'}. "</option>\n";
print "<option>". $lex{'Minor Variation in Objectives (<25%)'}. "</option>\n";
print "<option>". $lex{'Regular Curriculum'}. "</option>\n";
print "</select></td></tr>\n";

# Evaluator
print "<tr  style=\"background-color:#CCC;\"><td align=\"right\"><b>". $lex{'Evaluator'};
print "</b></td>\n<td><input type=\"text\" name=\"evaluator\" size=\"20\"></td></tr>\n";

print "<tr  style=\"background-color:#CCC;\"><td align=\"right\"><b>". $lex{'Year End Date'};
print "</b> (yyyy-mm-dd)</td>\n<td><input type=\"text\" name=\"ye_date\" size=\"14\"></td></tr>\n";

print "<tr  style=\"background-color:#CCC;\"><td align=\"right\"><b>". $lex{'Attainment Level Achieved'};
print "</b></td>\n<td><input type=\"text\" name=\"attain_level\" size=\"36\"></td></tr>\n";

print "</table>\n";


print "<p><input type=\"submit\" value=\"". $lex{'Save Student Rubric'}. "\"></p>
</form></body></html>\n";



#--------------
sub writeRecord {
#--------------

    # foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    # Die if missing student or dev fields.
    if (not $arr{student} or 
	(not $arr{dev_area} and not $arr{other})) {
	print '<h1>'. $lex{'Missing Student or Development!'}. "</h1>\n";
	die;
    }


    # extract student number
    my ($name, $studnum) = split /\(/, $arr{student};
    $studnum =~ s/\)//;

    # Get development area
    my $dev_area;
    if ($arr{other}) {
	$dev_area = $dbh->quote($arr{other});
    } else {
	$dev_area = $dbh->quote($arr{dev_area});
    }

    # Filter other values...
    my $currdate = $dbh->quote($arr{currdate});
    my $perf_lvl_current = $dbh->quote($arr{perf_lvl_current});
    my $perf_lvl_mless = $dbh->quote($arr{perf_lvl_mless});
    my $perf_lvl_swless = $dbh->quote($arr{perf_lvl_swless});
    my $perf_lvl_expect = $dbh->quote($arr{perf_lvl_expect});
    my $perf_lvl_swmore = $dbh->quote($arr{perf_lvl_swmore});
    my $perf_lvl_mmore = $dbh->quote($arr{perf_lvl_mmore});

    my $objective_var = $dbh->quote($arr{objective_var});
    my $evaluator = $dbh->quote($arr{evaluator});
    my $ye_date;
    if ($arr{ye_date}) {
	$ye_date = $dbh->quote($arr{ye_date});
    } else {
	$ye_date = $sql{default};
    }
    my $attain_level = $dbh->quote($arr{attain_level});

    #my $ = $dbh->quote($arr{});

    my $sth = $dbh->prepare("insert into eval_rubric values (
     $sql{default}, '$studnum', $dev_area, '$arr{target_skill}', $perf_lvl_current, $currdate,

     $perf_lvl_mless, $perf_lvl_swless, $perf_lvl_expect, $perf_lvl_swmore, $perf_lvl_mmore,
     $objective_var, $evaluator, $ye_date, $attain_level )");

    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    print '<p><b>'. $lex{'Student Rubric Added'}. "</b></p>\n";
    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self\">". $lex{'Add Another Rubric'}. "</a> |\n";

    print "<form action=\"evalmstadd.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Continue to Add Eval Masters'}. "\">\n";
    print "</form>\n";


    print "</body></html>\n";

}
