#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

my $self = 'rubdel.pl';

my %lex = ('Delete Rubric' => 'Delete Rubric',
	   'Main' => 'Main',
	   'Name' => 'Name',
	   'Are you sure you want to delete this record?' => 
	     'Are you sure you want to delete this record?',
	   'Yes, delete the record!' => 'Yes, delete the record!',
	   'Description' => 'Description',
	   'Student Rubric Deleted' => 'Student Rubric Deleted',
	   'View/Edit/Delete Rubrics' => 'View/Edit/Delete Rubrics',
	   'Please Log In' => 'Please Log In',

	   );

use CGI;
use DBI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;
my $id = $arr{id};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

# Get Rubric Info
my $sth = $dbh->prepare("select studnum, dev_area, target_skill
 from eval_rubric where id = ?"); 
$sth->execute( $id );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
my ($studnum, $dev_area, $target_skill) = $sth->fetchrow;

# Get Student Name
my $sth = $dbh->prepare("select lastname, firstname from special where studnum = ?");
$sth->execute( $studnum );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr;}
my ($lastname, $firstname) = $sth->fetchrow;


# Page Header.
print "$doctype\n<html><head><title>". $lex{'Delete Rubric'}. "</title>
<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
</head><body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ]
<center><h1>". $lex{'Delete Rubric'}. "</h1>\n";

if ($arr{flag}) {
    delete $arr{flag};
    deleteRecord();
}


print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"4\">\n";
print "<tr><th align=\"right\"><b>". $lex{Name}. "</b></td>
  <td>$firstname $lastname ($studnum)</td></tr>
<tr><th align=\"right\"><b>". $lex{Description}. "</b></td>
<td>$dev_area<br>$target_skill</td></tr>  
</table>\n";


print "<p><em>". $lex{'Are you sure you want to delete this record?'}. "</em></p>
<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"id\" value=\"$id\">
<input type=\"hidden\" name=\"flag\" value=\"1\">
<input type=\"submit\" value=\"". $lex{'Yes, delete the record!'}. "\"></center>
</form></body></html>\n";


#---------------
sub deleteRecord {
#---------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    my $sth = $dbh->prepare("delete from eval_rubric where id = ?"); 
    $sth->execute($id);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

    print '<p><b>'. $lex{'Student Rubric Deleted'}. "</b></p>\n";
    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"rubdeled.pl\">". $lex{'View/Edit/Delete Rubrics'}. "</a> ]</p>\n";

    print "</body></html>\n";

    exit;

}
