#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Add Student Outcome Rubric' => 'Add Student Outcome Rubric',
	   'Main' => 'Main',
	   'School' => 'School',
	   'Update Student Rubric' => 'Update Student Rubric',
	   'Student' => 'Student',
	   'Development Area' => 'Development Area',
	   'Target Skill' => 'Target Skill',
	   'Performance Level' => 'Performance Level',
	   'Responsible' => 'Responsible',
	   'Expectation' => 'Expectation',
	   'or' => 'or',
	   'Other' => 'Other',
	   'View/Edit Another Rubric' => 'View/Edit Another Rubric',
	   'Student Rubric Updated' => 'Student Rubric Updated',
	   'Missing Development!' => 'Missing Development!',
	   'Performance Level' => 'Performance Level',
	   'Responsible' => 'Responsible',
	   'Expectation' => 'Expectation',
	   'or' => 'or',
	   'Other' => 'Other',
	   'Add Another Rubric' => 'Add Another Rubric',
	   'Student Rubric Added' => 'Student Rubric Added',
	   'Missing Student or Development!' => 
	     'Missing Student or Development!',
	   'Current Date' => 'Current Date',

	   'Current Level of Performance' => 'Current Level of Performance',
	   'Much Less than Expected' => 'Much Less than Expected',
	   'Somewhat Less than Expected' => 'Somewhat Less than Expected',
	   'Expected' => 'Expected',
	   'Somewhat More than Expected' => 'Somewhat More than Expected',
	   'Much More than Expected' => 'Much More than Expected',

	   'Objective Comparison' => 'Objective Comparison',

	   'Significant Variation in Objectives (>50%)' => 
	     'Significant Variation in Objectives (>50%)',
	   'Moderate Variation in Objectives (<50%)' => 'Moderate Variation in Objectives (<50%)',
	   'Minor Variation in Objectives (<25%)' => 'Minor Variation in Objectives (<25%)',
	   'Regular Curriculum' => 'Regular Curriculum',

	   'Evaluator' => 'Evaluator',
	   'Attainment Level Achieved' => 'Attainment Level Achieved',
	   'Year End Date' => 'Year End Date',
	   'Please Log In' => 'Please Log In',
	   );


my $self = 'rubed.pl';

use DBI;
use CGI;
use CGI::Session;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;
my $id = $arr{id};
delete $arr{id};

# Open Database
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Edit Student Outcome Rubric'};
print "</title>\n<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$iephome\">". $lex{Main};
print "</a> ] $firstname $lastname\n";
print '<center><h1>'. $lex{'Edit Student Outcome Rubric'}. "</h1>\n";

if ($arr{flag}) {
    delete $arr{flag};
    updateRecord();
}


# Get record and then student name
my $sth = $dbh->prepare("select * from eval_rubric where id = ?");
$sth->execute($id);
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
my ($id1, $studnum, $dev_area, $target_skill, $perf_lvl_current,$currdate,
 $perf_lvl_mless, $perf_lvl_swless, $perf_lvl_expect, $perf_lvl_swmore, $perf_lvl_mmore,
 $objective_var, $evaluator, $ye_date, $attain_level) = $sth->fetchrow;

$sth = $dbh->prepare("select lastname, firstname from special where studnum = ?");
$sth->execute($studnum);
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
my ($lastname, $firstname) = $sth->fetchrow;


# Start the form.
print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"flag\" value=\"1\">
<input type=\"hidden\" name=\"id\" value=\"$id\">
<p><input type=\"submit\" value=\"". $lex{'Update Student Rubric'}. "\"></p>\n";


print "<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th align=\"center\" colspan=\"2\"><b>$firstname $lastname</b></th></tr>\n";

# Current Date
print "<tr><td align=\"right\"><b>". $lex{'Current Date'}. "</b></td>\n<td>";
print "<input type=\"text\" name=\"currdate\" size=\"12\" value=\"$currdate\"></td></tr>\n";


# Now do the Development Areas
print "<tr><td align=\"right\"><b>". $lex{'Development Area'}. 
"</b></td><td><select name=\"dev_area\"><option>$dev_area</option>\n";

foreach my $dev (@development){
    print "<option>$dev</option>\n";
}

print "</select><br>". $lex{or}. ' <b>'. $lex{Other};
print "</b> <input type=\"text\" name=\"other\" size=\"24\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Target Skill'}. "</b></td>\n<td>";
print "<input type=\"text\" name=\"target_skill\" size=\"32\" value=\"$target_skill\">\n";
print "</td></tr>\n";

print "<tr><td colspan=\"2\"><b>". $lex{'Current Level of Performance'};
print "</b><br><textarea name=\"perf_lvl_current\" cols=\"70\" rows=\"4\">";
print "$perf_lvl_current</textarea></td></tr>\n";

print "<tr><td colspan=\"2\"><b>". $lex{'Much Less than Expected'};
print "</b><br><textarea name=\"perf_lvl_mless\" cols=\"70\" rows=\"4\">";
print "$perf_lvl_mless</textarea></td></tr>\n";

print "<tr><td colspan=\"2\"><b>". $lex{'Somewhat Less than Expected'};
print "</b><br><textarea name=\"perf_lvl_swless\" cols=\"70\" rows=\"4\">";
print "$perf_lvl_swless</textarea></td></tr>\n";

print "<tr><td colspan=\"2\"><b>". $lex{'Expected'};
print "</b><br><textarea name=\"perf_lvl_expect\" cols=\"70\" rows=\"4\">";
print "$perf_lvl_expect</textarea></td></tr>\n";

print "<tr><td colspan=\"2\"><b>". $lex{'Somewhat More than Expected'};
print "</b><br><textarea name=\"perf_lvl_swmore\" cols=\"70\" rows=\"4\">";
print "$perf_lvl_swmore</textarea></td></tr>\n";

print "<tr><td colspan=\"2\"><b>". $lex{'Much More than Expected'};
print "</b><br><textarea name=\"perf_lvl_mmore\" cols=\"70\" rows=\"4\">";
print "$perf_lvl_mmore</textarea></td></tr>\n";


# Objective Variation
print "<tr><td align=\"right\"><b>". $lex{'Objective Comparison'};
print "</b></td>\n<td><select name=\"objective_var\"><option>$objective_var</option>\n";
print "<option>". $lex{'Significant Variation in Objectives (>50%)'}. "</option>\n";
print "<option>". $lex{'Moderate Variation in Objectives (<50%)'}. "</option>\n";
print "<option>". $lex{'Minor Variation in Objectives (<25%)'}. "</option>\n";
print "<option>". $lex{'Regular Curriculum'}. "</option>\n";
print "</select></td></tr>\n";


print "<tr><td align=\"right\"><b>". $lex{'Evaluator'}. "</b></td>\n<td>";
print "<input type=\"text\" name=\"evaluator\" size=\"20\" value=\"$evaluator\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Year End Date'}. "</b> (yyyy-mm-dd)</td>\n<td>";
print "<input type=\"text\" name=\"ye_date\" size=\"12\" value=\"$ye_date\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Attainment Level Achieved'}. "</b></td>\n<td>";
print "<input type=\"text\" name=\"attain_level\" size=\"32\" value=\"$attain_level\">";
print "</td></tr></table>\n";

print "<p><input type=\"submit\" value=\"". $lex{'Update Student Rubric'}. "\"></p>
</form></body></html>\n";


#--------------
sub updateRecord {
#--------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    # Die if missing student or dev fields.
    if ( not $arr{dev_area} and not $arr{other} ) {
	print '<h1>'. $lex{'Missing Development!'}. "</h1>\n";
	die;
    }

    # Set development area
    my $dev_area;
    if ($arr{other}) {
	$dev_area = $dbh->quote($arr{other});
    } else {
	$dev_area = $dbh->quote($arr{dev_area});
    }

    # Filter expectation
    my $dev_area  = $dbh->quote($arr{dev_area});
    my $target_skill  = $dbh->quote($arr{target_skill});
    my $currdate  = $dbh->quote($arr{currdate});
    my $objective_var  = $dbh->quote($arr{objective_var});

    my $perf_lvl_current = $dbh->quote($arr{perf_lvl_current});
    my $perf_lvl_mless = $dbh->quote($arr{perf_lvl_mless});
    my $perf_lvl_swless = $dbh->quote($arr{perf_lvl_swless});
    my $perf_lvl_expect = $dbh->quote($arr{perf_lvl_expect});
    my $perf_lvl_swmore = $dbh->quote($arr{perf_lvl_swmore});
    my $perf_lvl_mmore = $dbh->quote($arr{perf_lvl_mmore});

    my $evaluator = $dbh->quote($arr{evaluator});
    my $ye_date = $dbh->quote($arr{ye_date});
    my $attain_level = $dbh->quote($arr{attain_level});


    # update the record
    my $sth = $dbh->prepare("update eval_rubric set
      dev_area = $dev_area,
      target_skill = $target_skill, 
      currdate = $currdate,
      perf_lvl_current = $perf_lvl_current,
      perf_lvl_mless = $perf_lvl_mless,
      perf_lvl_swless = $perf_lvl_swless,
      perf_lvl_expect = $perf_lvl_expect,
      perf_lvl_swmore = $perf_lvl_swmore,
      perf_lvl_mmore = $perf_lvl_mmore,
      objective_var = $objective_var,
      evaluator = $evaluator,
      ye_date = $ye_date,
      attain_level = $attain_level
    where id = ?");
    
    $sth->execute( $id );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}    

    print '<p><b>'. $lex{'Student Rubric Updated'}. "</b></p>\n";
    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"rubdeled.pl\">". $lex{'View/Edit Another Rubric'}. "</a> ]</p>\n";

    print "</body></html>\n";
    
    exit;
}
