#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Add Student Services' => 'Add Student Services',
	   'Main' => 'Main',
	   'School' => 'School',
	   'Save Student Services' => 'Save Student Services',
	   'Student' => 'Student',
	   'Previous Week' => 'Previous Week',
	   'Next Week' => 'Next Week',
	   'Userid' => 'Userid',
	   'Name' => 'Name',
	   'Period(s)' => 'Period(s)',
	   'Code' => 'Code',
	   'Missing Userid or Date!' => 'Missing Userid or Date!',

	   'Add Another Service Entry' => 'Add Another Service Entry',
	   'Student Services Added' => 'Student Services Added',
	   'Error' => 'Error',
	   'Please Log In' => 'Please Log In',

	   );


my $self = 'servadd.pl';
use DBI;
use CGI;
use CGI::Session;
use Time::JulianDay;
use Date::Business;


eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

# Open Database
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Add Student Services'};
print "</title>\n<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$iephome\">". $lex{Main};
print "</a> ] $firstname $lastname\n";
print '<center><h1>'. $lex{'Add Student Services'}. "</h1>\n";


if (not $schoolstart){ $schoolstart = $g_termstart{1};}
my ($styear,$stmonth,$stday) = split /-/,$schoolstart;
my ($endyear,$endmonth,$endday) = split /-/,$schoolend;
$startjd = julian_day($styear,$stmonth,$stday);
$endjd = julian_day($endyear,$endmonth,$endday);

my ($jd, $mondayjd, $currdate, $currsdate);
my ($day, $month, $year);

if ($arr{flag}) {
    delete $arr{flag};
    writeRecord();

} elsif ($arr{date}) { # if passed a date.

    # Generate a list from those dates. Assume year-mon-day
    ($year,$month,$day) = split /-/,$arr{date};

    $jd = julian_day($year,$month,$day);
    $dow = day_of_week($jd);
    $mondayjd = $jd - ($dow-1);

    # Check for date before start of year; reset to year start.
    #if ($mondayjd < $startjd ){ $mondayjd = $startjd;}

    if (length($month) == 1){ $month = "0".$month;}
    if (length($day) == 1){ $day = "0".$day;}
    $currsdate = "$year$month$day"; 
    $currdate = "$year-$month-$day";


} else {

    my @tim = localtime(time);
    $year = $tim[5] + 1900;
    $month = $tim[4] + 1;
    $day = $tim[3];

    $jd = julian_day($year,$month,$day);
    $mondayjd = $jd - ($tim[6]-1); #This will now give Monday of that week.
    if (length($month) == 1){ $month = "0".$month;}
    if (length($day) == 1){ $day = "0".$day;}
    $currdate = "$year-$month-$day";
    $currsdate = "$year$month$day";

} 

$dateobj = new Date::Business(DATE=>$currsdate);

# Setup Array and Hash to hold Dates and DOW Dates (Multi-Day Method)
my $weekcount = 1; # Number of weeks to do for entry. (normally 1 or 2)
mkDateData($mondayjd,$weekcount);
# creates @days and @datedata


$prevjd = $mondayjd - 7;

if ($prevjd < $startjd){ $prevjd = $startjd;}

($prevyear, $prevmonth, $prevday) = inverse_julian_day($prevjd);
$prevdate = "$prevyear-$prevmonth-$prevday";

print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">
<tr><td>
 <form action=\"$self\" method=\"post\">
 <input type=\"hidden\" name=\"name\" value=\"$teacherid\">
 <input type=\"hidden\" name=\"date\" value=\"$prevdate\">
 <input type=\"hidden\" name=\"method\" value=\"($method)\">
 <input type=\"hidden\" name=\"passwd\" value=\"$arr{passwd}\">
 <input type=\"submit\" value=\"<= ". $lex{'Previous Week'}. "\"></form>
 </td>\n";

$nextjd = $mondayjd + 7; 
if ($nextjd > $endjd){ $nextjd = $endjd;}
($nextyear, $nextmonth, $nextday) = inverse_julian_day($nextjd);
$nextdate = "$nextyear-$nextmonth-$nextday";

print "<td><form action=\"$self\" method=\"post\">
 <input type=\"hidden\" name=\"method\" value=\"($method)\">
 <input type=\"hidden\" name=\"name\" value=\"$teacherid\">
 <input type=\"hidden\" name=\"date\" value=\"$nextdate\">
 <input type=\"hidden\" name=\"passwd\" value=\"$arr{passwd}\">
 <input type=\"submit\" value=\"". $lex{'Next Week'}. " =>\"></form>
 </td></tr></table>\n\n";


# Start the form.
print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"flag\" value=\"1\">\n";
print "<div style=\"padding:0.3em;\"><input type=\"submit\" value=\"";
print $lex{'Save Student Services'}. "\"></div>\n";

# Get all/selected students
my @students;
my $sth = $dbh->prepare("select lastname, firstname, studnum from special
  $select order by lastname, firstname");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}    

print "<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\">\n";

# Get Userid Info
print "<tr style=\"background-color:#DDD; text-align:center;\">";
print "<td colspan=\"3\"><b>". $lex{'Userid'};
print "</b> <input type=\"text\" name=\"userid\" size=\"12\">&nbsp;&nbsp;";

# Get Date Info
print "<b>Date</b> <select name=\"date\">\n";
for ($i=1;$i<=5;$i++) {
    ($wkyear, $wkmonth, $wkday) = inverse_julian_day($mondayjd);
    $dow = day_of_week($mondayjd);
    print "<option";
    if ($wkmonth == $month and $wkday == $day) {
	print " selected";
    }
    print ">$week[$dow], $wkyear-$wkmonth-$wkday</option>\n";
    $mondayjd++;
}
print "</select></td></tr>\n";
print "<tr><th>". $lex{Name}. '</th><th>'. $lex{'Period(s)'};
print '</th><th>'. $lex{Code}. "</th></tr>\n";

# Loop through all students displaying name, etc.
while ( my ($lastname, $firstname, $studnum ) = $sth->fetchrow ) {

    print "<tr><td style=\"text-align:center;\"><b><i>$lastname</i>, $firstname</b></td>\n";
    print "<td><input type=\"text\" name=\"period:$studnum\" size=\"12\"></td>\n";
    print "<td><input type=\"text\" name=\"scode:$studnum\" size=\"12\"></td></tr>\n";
    print "<tr><td colspan=\"4\" style=\"background-color:#DDD;\">";
    print "<textarea name=\"comment:$studnum\" cols=\"65\" rows=\"3\"></textarea></td></tr>\n";

} # End of student loop.


print "</table>\n";

print "<p><input type=\"submit\" value=\"". $lex{'Save Student Services'}. "\"></p>
</form></body></html>\n";



#--------------
sub writeRecord {
#--------------

    # Die if missing userid or date fields.
    if (not $arr{userid} or not $arr{date}) {
	print '<h1>'. $lex{'Missing Userid or Date!'}. "</h1>\n";
	die;
    }
    my ($dow,$dt) = split /,/,$arr{date};
    my $date = $dbh->quote($dt);
    my $userid = $dbh->quote($arr{userid});

    foreach my $key (keys %arr) {

	# split key apart to get text and studnum;
	my ($desc,$studnum) = split /:/, $key;

	if ( $desc eq 'period' and $arr{$key} and $studnum) {
	    #print "D:$desc SN: $studnum  V:$arr{$key}<br>\n";
	    my @periods = split /,/ , $arr{$key};
	    my $scode = $dbh->quote($arr{"scode:$studnum"});
	    my $comment = $dbh->quote($arr{"comment:$studnum"});
	    my $category = $dbh->quote($arr{"category:$studnum"});
	    $studnum = $dbh->quote($studnum);

	    # Do insert for multiple periods
	    foreach my $period (@periods) {
		if ($period =~ /\d/) { # if we have a digit...
		    $period = $dbh->quote($period);
		    my $sth = $dbh->prepare("insert into services values (
                     $sql{default},$studnum,$userid,$date,$period,$category, $scode, $comment)");
		    $sth->execute;
		    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }    

    #print "SN: $studnum<br>\n";   print "UID: $userid<br>\n";  print "DT: $date<br>\n";
    # print "PER: $period<br>\n";  print "CAT: $category<br>\n"; print "CODE: $scode<br>\n";
    # print "COM: $comment<br>\n";

		}
	    }


	}
    }

    print '<p><b>'. $lex{'Student Services Added'}. "</b></p>\n";
    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self\">". $lex{'Add Another Service Entry'}. "</a> ]</p>\n";

    print "</body></html>\n";

    exit;

}


#-------------
sub mkDateData {
#-------------
    my ($jd, $weeks) = (@_);
    # Build an array of ISO dates and a hash using them
    # as keys to hash values of 'Mon Jan 6' format.
    # If one week, then just 5 values, if two wk then 10, etc.
    for (1..$weeks){
	for (1..5){
	    my ($yr,$mon,$day) = inverse_julian_day($jd);
	    my $dow = day_of_week($jd) + 1;
	    push @days, "$yr-$mon-$day";
	    $datedata{"$yr-$mon-$day"} = "$week[$dow], $month[$mon] $day";
	    $jd++;
	}
	$jd = $jd + 2; # skip over weekend.
    }
}
