#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.
#  Script to show rubrics to allow editing or deleting.

my %lex = ('View/Edit Services' => 'View/Edit Services',
	   'Main' => 'Main',
	   'School' => 'School',
	   'Date/Period' => 'Date/Period',
	   'Code' => 'Code',
	   'Category' => 'Category',
	   'Userid' => 'Userid',

	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Error' => 'Error',
	   'Please Log In' => 'Please Log In',

	   );

use DBI;
use CGI;
use CGI::Session;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "and school = $sdb ";


my $fieldlist = "services.id, services.studnum, services.userid, services.sdate, 
  services.speriod, services.category, services.scode, services.comment, special.lastname, special.firstname";

my $sth = $dbh->prepare("select $fieldlist from services, special 
  where services.studnum = special.studnum $select
  order by special.lastname, special.firstname, services.sdate, services.speriod");

$sth->execute;
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr;}
my $rows = $sth->rows;

# Show Page Header.
print "$doctype\n<html><head><title>". $lex{'View/Edit Services'}. "</title>
<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
</head><body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ]
$firstname $lastname
<center><h1>". $lex{'View/Edit Services'}. "</h1>\n";

my $currstud = -1;
my $oldstud;

for ($i=1; $i <= $rows; ++$i) {
    my ($id, $studnum, $userid, $sdate, $speriod, $category, 
	$scode, $comment, $lastname, $firstname) = $sth->fetchrow;
   
    $oldstud = $currstud;
    $currstud = $studnum;

    if ( $oldstud ne $currstud ) {  # We have a new student

	if ($i != 1) {  # close previous list
	    print "</table>";
	}

	print "<h3>$firstname $lastname</h3>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print '<tr><th>'. $lex{'Date/Period'}. '</th><th>'. $lex{Userid};
	print '</th><th>'. $lex{Code}. "</th>\n<th>". $lex{Category}. '</th>';
	print '<th>'. $lex{Edit}. '</th><th>'. $lex{Delete}. "</th></tr>\n";      
    }

    print "<tr><td><b>$sdate / $speriod</b></td><td>$userid</td>\n";
    print "<td>$scode</td><td>$category</td>\n";
    print "<td><a href=\"served.pl?id=$id\">". $lex{Edit}. "</a></td>\n";
    print "<td><a href=\"servdel.pl?id=$id\">". $lex{Delete}. "</a></td></tr>\n";

} # End of loop counter

print "</ul></body></html>\n";
