#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Edit Student Service' => 'Edit Student Service',
	   'Main' => 'Main',
	   'School' => 'School',
	   'Update Student Service' => 'Update Student Service',
	   'Student' => 'Student',
	   'Date' => 'Date',
	   'Period' => 'Period',
	   'Comment' => 'Comment',
	   'Userid' => 'Userid',
	   'Code' => 'Code',
	   'Category' => 'Category',
	   'or' => 'or',
	   'Other' => 'Other',
	   'View/Edit Another Service' => 'View/Edit Another Service',
	   'Student Service Updated' => 'Student Service Updated',
	   'Missing Development!' => 'Missing Development!',
	   'Not Logged In' => 'Not Logged In',
	   'Error' => 'Error',
	   'Please Log In' => 'Please Log In',

	   );


my $self = 'served.pl';

use DBI;
use CGI;
use CGI::Session;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

my $id = $arr{id};
delete $arr{id};

# Open Database
my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Edit Student Service'};
print "</title>\n<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$iephome\">". $lex{Main};
print "</a> ] $firstname $lastname\n";
print '<center><h1>'. $lex{'Edit Student Service'}. "</h1>\n";

if ($arr{flag}) {
    delete $arr{flag};
    updateRecord();
    die;
}


# Get record and then student name
my $sth = $dbh->prepare("select * from services where id = ?");
$sth->execute($id);
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my ($id1, $studnum, $userid, $sdate, $speriod,$category, $scode,
 $comment) = $sth->fetchrow;

$sth = $dbh->prepare("select lastname, firstname from special where studnum = ?");
$sth->execute($studnum);
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my ($lastname, $firstname) = $sth->fetchrow;


# Start the form.
print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"flag\" value=\"1\">
<input type=\"hidden\" name=\"id\" value=\"$id\">
<p><input type=\"submit\" value=\"". $lex{'Update Student Service'}. "\"></p>\n";


print "<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th align=\"center\" colspan=\"2\"><b>$firstname $lastname</b></th></tr>\n";


# Leave for now... Left again: July, 2008; delete in 2009 or later.
#print "<tr><td align=\"right\"><b>".
#$lex{'Development Area'}. "</b></td><td><select name=\"dev_area\"><option>$dev_area</option>\n";
#foreach my $dev (@development){
#    print "<option>$dev</option>\n";
#}
#print "</select><br>". $lex{or}. ' <b>'. $lex{Other};
#print "</b> <input type=\"text\" name=\"other\" size=\"24\"></td></tr>\n";


print "<tr><td align=\"right\"><b>". $lex{'Userid'}. "</b></td>\n";
print "<td><input type=\"text\" name=\"userid\" size=\"12\" value=\"$userid\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Date'}. "</b></td>\n<td>";
print "<input type=\"text\" name=\"sdate\" size=\"12\" value=\"$sdate\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Period'}. "</b></td>\n<td>";
print "<input type=\"text\" name=\"speriod\" size=\"6\" value=\"$speriod\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Code'}. "</b></td>\n<td>";
print "<input type=\"text\" name=\"scode\" size=\"8\" value=\"$scode\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Category'}. "</b></td>\n<td>";
print "<input type=\"text\" name=\"category\" size=\"12\" value=\"$category\"></td></tr>\n";

print "<tr><td colspan=\"2\"><b>". $lex{Comment}. "</b><br>\n";
print "<textarea name=\"comment\" cols=\"65\" rows=\"6\">$comment</textarea></td></tr>\n";

print "</table>\n";

print "<p><input type=\"submit\" value=\"". $lex{'Update Student Service'}. "\"></p>
</form></body></html>\n";



#--------------
sub updateRecord {
#--------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    # Die if missing student or dev fields.
    #if (not $arr{dev_area} and not $arr{other}) {
	#print '<h1>'. $lex{'Missing Development!'}. "</h1>\n";
	#die;
    #}

    # Filter
    my $comment = $dbh->quote($arr{comment});
    my $userid = $dbh->quote($arr{userid});
    my $sdate = $dbh->quote($arr{sdate});
    my $speriod = $dbh->quote($arr{speriod});
    my $scode = $dbh->quote($arr{scode});
    my $category = $dbh->quote($arr{category});

    my $sth = $dbh->prepare("update services set
     userid = $userid, sdate = $sdate, speriod = $speriod,
     category = $category, scode = $scode, comment = $comment
    where id = ?");
    
    $sth->execute( $id );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    print '<p><b>'. $lex{'Student Service Updated'}. "</b></p>\n";
    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"servdeled.pl\">". $lex{'View/Edit Another Service'}. "</a> ]</p>\n";

    print "</body></html>\n";

}
