#!/usr/bin/perl

#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'Main' => 'Main',
	   'Student Entry' => 'Student Entry',
	   'Not a Valid Number!' => 'Not a Valid Number!',

	   'Last Name' => 'Last Name',
	   'First Name' => 'First Name',
	   'Birthdate' => 'Birthdate',
	   'Student Number' => 'Student Number',
	   'Provincial Number' => 'Provincial Number',
	   'Designation Date' => 'Designation Date',
	   'DDPF Level' => 'DDPF Level',
	   'Designation' => 'Designation',
	   'Grade' => 'Grade',
	   'School' => 'School',
	   'Gender' => 'Gender',
	   'M' => 'M',
	   'F' => 'F',
	   'Medical Conditions' => 'Medical Conditions',
	   'Medication' => 'Medication',
	   'Equipment' => 'Equipment',
	   'Adaptations' => 'Adaptations',
	   'School/Home History' => 'School/Home History',
	   'Save Student Record' => 'Save Student Record',

	   'Contact' => 'Contact',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'The record is updated' => 'The record is updated',

	   'Student Search' => 'Student Search',
	   'last,first/last/initials' => 'last,first/last/initials',
	   'Search' => 'Search',
	   'You <b>must</b> enter a valid division student number!' => 
	     'You <b>must</b> enter a valid division student number!',
	   'Student Already Exists' => 'Student Already Exists',
	   'Use <b>Edit</b> to change existing record' => 
	     'Use <b>Edit</b> to change existing record',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'The record is now stored' => 'The record is now stored',
	   'Record the following error' => 'Record the following error',
	   'Please Log In' => 'Please Log In',
	   'Continue to Add Team Members' => 'Continue to Add Team Members',

	   );

my $self = 'spadd.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;
my $studnum = $arr{studnum};

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


print "$doctype\n<html><head><title>". $lex{'Student Entry'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
print "<center><h1>". $lex{'Student Entry'}. "</h1>\n";

if ( $arr{page} == 1 ) {
    delete $arr{page};
    writeRecord();
}

if ( not $studnum ){ # display entry error
    no_student_error();
}

my @sr; # student record
foreach my $database ( keys %dbase ) { # defined in global config file.

    my $dsn = "DBI:$dbtype:dbname=$database";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);
    my $sth = $dbh->prepare("select * from student where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }  

    my $rows = $sth->rows;
    if ($rows < 1) { next; } # skip to next database  

    # If we get here, we have a record...
    @sr = $sth->fetchrow;
    $school = "$dbase{$database} ($database)";
    last;
} # End of database loop

if ( not $sr[1] ){  # no student found!
    no_student_error( $lex{'Not a Valid Number!'} );
}


print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border = \"0\">\n";

print "<tr><td align=\"right\">". $lex{'Last Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"lastname\" size=\"25\" value=\"$sr[1]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'First Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"firstname\" size=\"25\" value=\"$sr[2]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Birthdate}. "</td>\n<td>";
print "<input type=\"text\" name=\"birthdate\" size=\"15\" value=\"$sr[8]\">";
print " (yyyy-mm-dd)</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Student Number'}. "</td><td>$studnum</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Provincial Number'}. "</td>\n<td>";
print "<input type=\"text\" name=\"provnum\" size=\"12\" value=\"$sr[57]\"></tr>\n";

print "<tr><td align=\"right\">". $lex{'Designation Date'}. "</td>\n<td>";
print "<input type=\"text\" name=\"desdate\" size=\"15\">\n";
print " (yyyy-mm-dd)</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'DDPF Level'}. "</td>\n<td>";
print "<select name=\"ddpflvl\"><option></option><option>Level 1</option>\n";
print "<option>Level 2</option></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Designation}. "</td>\n<td>";
print "<select name=\"designation\"><option></option>\n";
foreach my $desig ( @designate ) {
    print "<option>$desig</option>\n";
}
print "</select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Grade}. "</td>\n<td>";
print "<input type=\"text\" name=\"grade\" size=\"4\" value=\"$sr[5]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{School}. "</td>\n<td>";
print "$dbase{$schooldbase} ($schooldbase)\n";
print "<input type=\"hidden\" name=\"school\" value=\"$schooldbase\">\n";
print "</td></tr>\n";

print "<tr><td align=\"right\">". $lex{Gender}. "</td>\n<td>";
print "<select name=\"sex\"><option>$sr[7]</option>\n";
print "<option>". $lex{M}. "</option><option>". $lex{F};
print "</option></select></td></tr>\n";

print "<tr><td align=\"right\" valign=\"top\">". $lex{'Medical Conditions'}. "</td>\n<td>";
print "<textarea name=\"medical\" rows=\"6\" cols=\"70\">$sr[18]</textarea></td></tr>\n";

print "<tr><td align=\"right\" valign=\"top\">". $lex{Medication}. "</td>\n<td>";
print "<textarea name=\"medication\" rows=\"6\" cols=\"70\"></textarea></td></tr>\n";

print "<tr><td align=\"right\" valign=\"top\">". $lex{Equipment}. "</td>\n<td>";
print "<textarea name=\"equip\" rows=\"6\" cols=\"70\"></textarea></td></tr>\n";

print "<tr><td align=\"right\" valign=\"top\">". $lex{Adaptations}. "</td>\n<td>";
print "<textarea name=\"adapt\" rows=\"6\" cols=\"70\"></textarea></td></tr>\n";

print "<tr><td align=\"right\" valign=\"top\">". $lex{'School/Home History'}. "</td>\n<td>";
print "<textarea name=\"history\" rows=\"6\" cols=\"70\"></textarea></td></tr>\n";

print "<tr><td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"";
print $lex{'Save Student Record'}. "\"></td></tr></table>\n";

print "</form></body></html>\n";


#-------------------
sub no_student_error {
#-------------------

    my $message = shift;
    print "<p>$message</p>\n";

    print "<p>". $lex{'You <b>must</b> enter a valid division student number!'}. "</p>\n";

    print "<p align=\"left\"><b>". $lex{'Student Search'}. "</b><br>\n";
    print "<table cellpadding=\"2\" cellspacing=\"0\" border=\"1\"><tr><td>\n";
    print "<form action=\"studsearch.pl\" method=\"post\">\n";
    print "<b>". $lex{Name}. "</b> (". $lex{'last,first/last/initials'}. ")<br>\n";
    print "<input type=\"text\" name=\"student\" size=\"25\">\n";
    print "<input type=\"submit\" value=\"". $lex{Search}. "\">\n";
    print "</form></td></tr></table></p>\n";

    print "</center></body></html>\n";

    exit;

}

#--------------
sub writeRecord {
#--------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $dsn = "DBI:$dbtype:dbname=$dbase";
    my $dbh = DBI->connect($dsn,$user,$password);
    my $studnum = $arr{studnum}; # unquoted version for link to next script.

    # Check for existing student.
    my $sth = $dbh->prepare("select id from special where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;
    if ( $rows > 0 ) { 
	print '<h1>'. $lex{'Student Already Exists'}. q{. };
	print $lex{'Use <b>Edit</b> to change existing record'};
	print ".</h1></body></html>\n";
	die;
    }


    my @keys = keys %arr;
    my $keys = join(',', @keys);
	
    foreach my $k ( keys %arr ) {
	if ( $arr{$k} ) {
	    $arr{$k} = $dbh->quote( $arr{$k} );
	} else {
	    $arr{$k} = $sql{default};
	}
    }
    my $values = join(',', ( values %arr ));

    $sth = $dbh->prepare("insert into special ( $keys ) values ( $values )");
    $sth->execute;

    if ( not $DBI::errstr ) {
	print '<h3>'. $lex{'The record is now stored'}. "</h3>\n";
    } else {
	print '<h3>'. $lex{'There was an error storing your data'};
	print $lex{Contact}. " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Record the following error'}. ": $DBI::errstr</h3></p>\n";
    }

    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";

    print "<form action=\"tmadd.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Continue to Add Team Members'}. "\">\n";
    print "</form>\n";

    print "</p></center></body></html>\n";

    exit;

} # end of writeRecord
