#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Not Logged In' => 'Not Logged In',
	   'Main' => 'Main',
	   'View/Edit Special Needs Students' => 'View/Edit Special Needs Students',
	   'Select by School' => 'Select by School',
	   'Summary?' => 'Summary?',
	   'Special Needs Students' => 'Special Needs Students',
	   'Description' => 'Description',
	   'Name/ID' => 'Name/ID',
	   'Edit' => 'Edit',
	   'Report' => 'Report',
	   'Error' => 'Error',
	   'BDate' => 'BDate',
	   'Grade' => 'Grade',
	   'School' => 'School',
	   'Gender' => 'Gender',
	   'Studnum' => 'Studnum',
	   'ProvNum' => 'ProvNum',
	   'Designation' => 'Designation',
	   'Des Date' => 'Des Date',
	   'Medical' => 'Medical',
	   'Medication' => 'Medication',
	   'Equipment' => 'Equipment',
	   'Adaptations' => 'Adaptations',
	   'History' => 'History',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'spdeled.pl';

use DBI;
use CGI;
use CGI::Session;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
my %arr = $q->Vars;
my $summary = $arr{summary};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


my $sth = $dbh->prepare("select * from special $select order by lastname, firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

# Print Page Header.
print "$doctype\n<html><head><title>". $lex{'View/Edit Special Needs Students'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
print "<a name=\"top\">[ <a href=\"$iephome\">". $lex{Main};
print "</a> ] $firstname $lastname\n";
print "<center><h1>". $lex{'Special Needs Students'}. "</h1><p>$currdate</p>\n";
print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{'Name/ID'}. "</th><th>". $lex{Description}. "</th></tr>\n";

while ( my @arr = $sth->fetchrow ) {

    if ( $summary ){

	print "<tr><td>";

	print "<form action=\"sped.pl\" method=\"post\" style=\"display:inline;\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$arr[0]\">\n";
	print "<input type=\"submit\" value=\"". $lex{Edit}. "\">\n";
	print "</form>\n";

	print "<b>$arr[2] $arr[1]</b> ($arr[4])\n";
	print "</td><td>$arr[8] </td></tr>\n";

    } else { # print complete records

        print "<tr><td valign=\"top\"><table border=\"0\" cellspacing=\"0\" cellpadding=\"3\">\n";
	print "<tr><td colspan=\"2\" align=\"center\"><b>$arr[2] $arr[1]</b></td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{BDate}. "</em></td><td>$arr[3]</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{Grade}. "</em></td><td>$arr[9]</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{School}. "</em></td><td>$arr[10]</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{Gender}. "</em></td><td>$arr[11]</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{Studnum}. "</em></td><td> $arr[4]</td></tr>\n";
	print "<tr><td align=\"right\"><em>". $lex{ProvNum}. "</em></td><td> $arr[5]</td></tr>\n";
	print "</table>\n";

	print "<form action=\"sped.pl\" method=\"post\" style=\"display:inline;\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$arr[0]\">\n";
	print "<input type=\"submit\" value=\"". $lex{Edit}. "\">\n";
	print "</form>\n";

	print "</td>\n";
	print "<td valign=\"top\"><table cellpadding=\"3\">\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Designation};
	print "</em></td><td>$arr[8]</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{'DDPF Level'};
	print "</em></td><td>$arr[7]</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{'Des Date'};
	print "</em></td><td>$arr[6]</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Medical};
	print "</em></td><td>$arr[12]</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Medication};
	print "</em></td><td>$arr[13]</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Equipment};
	print "</em></td><td>$arr[14]</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{Adaptations};
	print "</em></td><td>$arr[15]</td></tr>\n";

	print "<tr><td align=\"right\" valign=\"top\"><em>". $lex{History};
	print "</em></td><td>$arr[16]</td></tr>\n";

	print "</table></td></tr>\n";

    } # end of If/Else
}

print "</table></center></body></html>\n";
