#!/usr/bin/perl

#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'Main' => 'Main',
	   'Edit Student' => 'Edit Student',
	   'Last Name' => 'Last Name',
	   'First Name' => 'First Name',
	   'Birthdate' => 'Birthdate',
	   'Student Number' => 'Student Number',
	   'Provincial Number' => 'Provincial Number',
	   'Designation Date' => 'Designation Date',
	   'DDPF Level' => 'DDPF Level',
	   'Designation' => 'Designation',
	   'Grade' => 'Grade',
	   'School' => 'School',
	   'Gender' => 'Gender',
	   'M' => 'M',
	   'F' => 'F',
	   'Medical Conditions' => 'Medical Conditions',
	   'Medication' => 'Medication',
	   'Equipment' => 'Equipment',
	   'Adaptations' => 'Adaptations',
	   'School/Home History' => 'School/Home History',
	   'Save Student Record' => 'Save Student Record',
	   'Edit More Students' => 'Edit More Students',
	   'Contact' => 'Contact',
	   'Summary?' => 'Summary?',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'The record is updated' => 'The record is updated',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'sped.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Edit Student'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ] $firstname $lastname\n";
print "<h1>". $lex{'Edit Student'}. "</h1>\n";


if ( $arr{page} ) {
    delete $arr{page};
    writeRecord();
}


my $sth = $dbh->prepare("select * from special where id = ?");
$sth->execute( $arr{id} );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }  
my @st = $sth->fetchrow;

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$st[0]\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border = \"0\">\n";

print "<tr><td align=\"right\">". $lex{'Last Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"lastname\" size=\"25\" value=\"$st[1]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'First Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"firstname\" size=\"25\" value=\"$st[2]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Birthdate}. "</td>\n<td>";
print "<input type=\"text\" name=\"birthdate\" size=\"15\" value=\"$st[3]\">";
print " (yyyy-mm-dd)</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Student Number'}. "</td><td>$st[4]</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Provincial Number'}. "</td>\n<td>";
print "<input type=\"text\" name=\"provnum\" size=\"12\" value=\"$st[5]\"></tr>\n";

print "<tr><td align=\"right\">". $lex{'Designation Date'}. "</td>\n<td>";
print "<input type=\"text\" name=\"desdate\" size=\"15\" value=\"$st[6]\">\n";
print " (yyyy-mm-dd)</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'DDPF Level'}. "</td>\n<td>";
print "<select name=\"ddpflvl\"><option>$st[7]</option><option>Level 1</option>\n";
print "<option>Level 2</option></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Designation}. "</td>\n<td>";
print "<select name=\"designation\"><option>$st[8]</option>\n";
foreach my $desig ( @designate ) {
    print "<option>$desig</option>\n";
}
print "</select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Grade}. "</td>\n<td>";
print "<input type=\"text\" name=\"grade\" size=\"4\" value=\"$st[9]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{School}. "</td>\n<td>";
print "<select name=\"school\"><option>$st[10]</option>\n";
foreach my $key ( keys %dbase ) {
    print "<option>$dbase{$key} ($key)</option>\n";
}
print "</select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Gender}. "</td>\n<td>";
print "<select name=\"sex\"><option>$st[11]</option>\n";
print "<option>". $lex{M}. "</option><option>". $lex{F};
print "</option></select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Medical Conditions'}. "</td>\n<td>";
print "<textarea name=\"medical\" rows=\"6\" cols=\"70\">$st[12]</textarea></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Medication}. "</td>\n<td>";
print "<textarea name=\"medication\" rows=\"6\" cols=\"70\">$st[13]</textarea></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Equipment}. "</td>\n<td>";
print "<textarea name=\"equip\" rows=\"6\" cols=\"70\">$st[14]</textarea></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Adaptations}. "</td>\n<td>";
print "<textarea name=\"adapt\" rows=\"6\" cols=\"70\">$st[15]</textarea></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'School/Home History'}. "</td>\n<td>";
print "<textarea name=\"history\" rows=\"6\" cols=\"70\">$st[16]</textarea></td></tr>\n";

print "<tr><td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"";
print $lex{'Save Student Record'}. "\"></td></tr></table>\n";

print "</form></body></html>\n";



#--------------
sub writeRecord {
#--------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $id = $arr{id}; # remove the record id from values to be updated.
    delete $arr{id}; 

    # fix school value, strip descriptive text, if present.
    if ( $arr{school} =~ m/\(/ ) { # if it has an opening parenthesis, then...
	my ($dud, $schooldbase) = split /\(/, $arr{school};
	chop $schooldbase;
	$arr{school} = $schooldbase;
    }

    foreach my $key ( keys %arr ) {
	my $sth = $dbh->prepare("update special set $key = ? where id = $id ");
	$sth->execute( $arr{$key} );
    }

    if (not $DBI::errstr){
	print "<p style=\"font-size:150%;\">". $lex{'The record is updated'}. ".</p>\n";
    } else {
	print "<p style=\"font-size:150%;\">";
	print $lex{'There was an error storing your data'}. q{. };
	print $lex{Contact}. " $adminname - $adminemail\n";
	print $lex{Error}. " $DBI::errstr </p>\n";
    }

    print "<table><tr><td valign=\"top\">";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ] $cookieuser</td>\n";
    print "<td><form action=\"spdeled.pl\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"school\" value=\"$arr{school}\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Edit More Students'}. "\">\n";

    print $lex{'Summary?'}. " <input type=\"checkbox\" name=\"summary\" value=\"1\">\n";
    print "</form></td></tr></table>\n";
    print "</center></body></html>\n";

    exit;

} # end of writeRecord
