#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Student Search/Add' => 'Student Search/Add',
	   'Main' => 'Main',
	   'Entry Error: No Student(s) found' => 'Entry Error: No Student(s) found',
	   'Name' => 'Name',
	   'Studnum' => 'Studnum',
	   'Sex' => 'Sex',
	   'Birthdate' => 'Birthdate',
	   'Grade' => 'Grade',
	   'HRm' => 'HRm',
	   'Add' => 'Add',
	   'last,first/last/initials' => 'last,first/last/initials',
	   'Student Number' => 'Student Number',
	   'Enter' => 'Enter',
	   'Student not found. Please try again' => 'Student not found. Please try again',
	   'Error' => 'Error',
	   'Please Log In' => 'Please Log In',
	   'Search' => 'Search',

	   );

my $self = 'studsearch.pl';


use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;
my $student = $arr{student};
delete $arr{student};

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";


# Print Page Header
print "$chartype\n<html><head><title>". $lex{'Student Search/Add'};
print "</title>\n<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
</head><body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ]
<center><h1>". $lex{'Student Search/Add'}. "</h1>\n";

my $fieldlist = 'lastname, firstname, initial, studnum, birthdate, grade, sex, homeroom';


# Switch to the school database to read
my $dsn = "DBI:$dbtype:dbname=$schooldbase";
my $dbh = DBI->connect($dsn,$guser,$gpassword);


if ($student =~ /\d+/) {  # we have a student number
    $studentnumber = $student;
    $sth = $dbh->prepare("select $fieldlist from student where studnum = ?");
    $sth->execute( $student );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

} else { # we have words with a comma (or initials)
    ($lastname,$firstname)  = split /\,/, $student;
    $firstname =~ s/^\s*//;
    $lastname =~ s/^\s*//;

    if ($lastname and $firstname){ # both entered.
	$sth = $dbh->prepare("select $fieldlist from student where 
          lastname = ? and firstname = ?");
	$sth->execute( $lastname, $firstname );
    } elsif ($lastname and not $firstname){ # only lastname
	if (length($lastname) == 2){ # search by initials: fi, li.
	    $fi = substr($lastname,0,1); $li = substr($lastname,1,1);
	    $li = $dbh->quote( $li. '%' );
	    $fi = $dbh->quote( $fi. '%' );
	    $sth = $dbh->prepare("select $fieldlist from student 
              where lastname $sql{like} $li and firstname $sql{like} $fi ");
	    $sth->execute;
	} else {
	    $sth = $dbh->prepare("select $fieldlist from student 
               where lastname = ? order by firstname");
	    $sth->execute( $lastname );
	}
    } else { # print an error....
	print '<p><b>'. $lex{'Entry Error: No Student(s) found'}.".</b></p>\n";
	print "</body></html>\n";
	die; 
    }

    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

} # End of words with a comma.

my $rows = $sth->rows;
if ( $rows > 0 ) { 

    # We have at least one record for this school.
    print "<h2>$dbase{$schooldbase}</h2>\n";
    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";
    print '<tr><th>'. $lex{Name}. '</th><th>'. $lex{Studnum}. '</th><th>';
    print $lex{'Sex'}. "</th>\n<th>". $lex{'Birthdate'}. '</th><th>'. $lex{'Grade'}. '</th><th>';
    print $lex{'HRm'}. "</th><th>". $lex{Add}. "</th></tr>\n";
  
    for ( my $i=1;$i<=$rows;$i++ ) {
	my ($lastname, $firstname, $initial, $studnum, $birthdate, 
	    $grade, $sex, $hroom) = $sth->fetchrow;

	print "<tr><td><b>$firstname $initial $lastname</b></td>\n";
	print "<td>$studnum</td><td>$sex</td><td>$birthdate</td><td>$grade</td><td>$hroom</td>\n";
	print "<td><form action=\"spadd.pl\" method=\"post\" style=\"display:inline;\">\n";
	print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
	print "<input type=\"submit\" value=\"". $lex{Add}. "\"></form></td></tr>";

    } # End of For Loop
 
    print "</table>\n\n";  

} else { # nobody found
    print "<center><h2>". $lex{'Student not found. Please try again'}. ".</h2>\n";
}

print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> ]</p>\n";
print '<h2>'. $lex{'Student Search/Add'}. "</h2>\n";
print "<form action=\"studsearch.pl\" method=\"post\"><b>". $lex{Name};
print "</b> (". $lex{'last,first/last/initials'};
print ") or <b>". $lex{'Student Number'};
print "</b> <input type=\"text\" name=\"student\" size=\"10\">\n";

print "<input type=\"submit\" value=\"". $lex{Search}. "\"></form>\n";
print "</center></body></html>\n";

