#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View Subjects' => 'View Subjects',
	   'Main' => 'Main',
	   'Objectives' => 'Objectives',
	   'Top' => 'Top',
	   'Error' => 'Error',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'subviewmain.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


print "$doctype\n<html><head><title>". $lex{'View Subjects'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
</head><body><a name=\"top\"></a>[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
print "<center><h1>". $lex{Objectives}. "</h1></center>\n";

print "<p>[ ";
# Print the hyperlinks.
$sth = $dbh->prepare("select distinct catnum, category from subject 
 order by category");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while ( my ( $catnum, $category)= $sth->fetchrow ) {
    print" <a href=\"#$catnum\">$category</a> |\n";
}
print "</p>\n";

my $sth = $dbh->prepare("select * from subject order by catnum, idnum");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;

my $newcat = "";
for ( my $i=1; $i <= $rows; ++$i ) {

    my @arr = $sth->fetchrow;
    $oldcat = $newcat;
    $newcat = $arr[1];

    if ($oldcat != $newcat) {
	print "</ul>\n" if $arr[0] != 1;
	print "<a name=\"$arr[1]\"></a><h2>$arr[1] $arr[2]\n";
	print "[ <a href=\"#top\">". $lex{Top}. "</a> ]</h2><ul>";
    }
    print "<li>$arr[3] $arr[4] $arr[5] $arr[6]</li>\n";
    
} # End of loop 

print "</ul><p>[ <a href=\"$iephome\">". $lex{Main}. "</a> ]</p></body></html>\n";
