#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

# This file is part of Open Admin for Schools.

my %lex = ('Team Builder' => 'Team Builder',
	   'Main' => 'Main',
	   'Please select the student team members' => 'Please select the student team members',
	   'Select Student' => 'Select Student',
	   'Add Members to the Student\'s Team' => 'Add Members to the Student\'s Team',
	   'Personnel' => 'Personnel',
	   'Name' => 'Name',
	   'Position' => 'Position',
	   'Userid' => 'Userid',
	   'Select' => 'Select',
	   'Signer' => 'Signer',
	   'Add More Team Members' => 'Add More Team Members',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Please record the following error' => 'Please record the following error',
	   'Your new team members are now stored' => 'Your new team members are now stored',
	   'Y' => 'Y',
	   'Please Log In' => 'Please Log In',
	   'Continue to Add Assessments' => 'Continue to Add Assessments',

	   );

my $self = 'tmadd.pl';

use DBI;
use CGI;
use CGI::Session;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "where school = $sdb ";

# Read in all special students and put in array
my $sth = $dbh->prepare("select lastname, firstname, studnum from special $select
  order by lastname, firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

my @students;
while ( my ( $lastname, $firstname, $studnum ) = $sth->fetchrow ) {
    my $studrec = "$lastname, $firstname ($studnum)";
    push @students, $studrec;
}
# Done pushing in students.


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Team Builder'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ] $firstname $lastname\n";
print "<center><h1>". $lex{'Team Builder'}. "</h1>\n";

if ( $arr{page} ) {
    delete $arr{page};
    writeRecord();
}


my $passedstudent;
if ( $arr{studnum} ) {
    my $sth = $dbh->prepare("select lastname, firstname from special
      where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;
    $passedstudent = "$lastname, $firstname ($arr{studnum})";
}


print "<p>". $lex{'Please select the student team members'}. ".</p>\n";

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

print "<table cellpadding=\"6\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><td align=\"center\"><b>". $lex{'Select Student'}. ":</b> \n";
print "<select name=\"student\"><option>$passedstudent</option>\n";
foreach my $student ( @students ) {
    print "<option>$student</option>\n";
}
print "</select></td></tr></table>\n";

print "<p></p><input type=\"submit\" value=\"";
print $lex{'Add Members to the Student\'s Team'}. "\">\n";

# Now pull in the personnel table.
my $sth = $dbh->prepare("select userid, lastname, firstname, jobtitle from personnel
 order by lastname, firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }    

# Now print Personnel
print "<h2>". $lex{Personnel}. "</h2>\n";
print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th>". $lex{Name}. "</th><th>". $lex{Position}. "</th><th>". $lex{Userid};
print "</th><th>". $lex{Select}. "</th><th>". $lex{Signer}. "</th></tr>\n";

while ( my ($userid, $lastname, $firstname, $jobtitle) = $sth->fetchrow ) {
    print "<tr><td><b>$lastname</b>, $firstname</td><td>$jobtitle</td>\n";
    print "<td>$userid</td><td align=\"center\">\n";
    print "<input type=\"checkbox\" name=\"per:$userid\" value=\"1\"></td>\n";
    print "<td><input type=\"checkbox\" name=\"per:$userid:sign\" value=\"1\"></td></tr>\n";
}
print "</table>\n";

    
my $dsn = "DBI:$dbtype:dbname=$schooldbase";
my $dbh = DBI->connect($dsn,$guser,$gpassword);

my $sth = $dbh->prepare("select sal, lastname, firstname, userid, position from staff
  order by lastname, firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;

print "<h2>$dbase{$schooldbase}</h2>\n";
print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"2\">\n";
print "<tr><th>". $lex{Name}. "</th><th>". $lex{Position}. "</th><th>". $lex{Userid};
print "</th><th>". $lex{Select}. "</th><th>". $lex{Signer}. "</th></tr>\n";

while ( my ($sal, $lastname, $firstname, $userid,$position) = $sth->fetchrow ) {
    print "<tr><td><b>$lastname</b>, $sal $firstname</td><td>$position</td>\n";
    print "<td>$userid</td><td align=\"center\"> ";
    print "<input type=\"checkbox\" name=\"$schooldbase:$userid\" value=\"1\"></td>\n<td>";
    print "<input type=\"checkbox\" name=\"$schooldbase:$userid:sign\" value=\"1\"></td></tr>\n";
}
print "</table>\n";

print "<p></p><input type=\"submit\" value=\"";
print $lex{'Add Members to the Student\'s Team'}. "\">\n";

print "</form></body></html>\n";



#--------------
sub writeRecord {
#--------------

    #foreach $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    if ( not $arr{student} ){
	print "<h1>No Student Entered. Please try again.</h1>\n";
	print "</body></html>\n";
	die;
    }

    my ($studname, $studnum) = split /\(/, $arr{student};
    chop $studnum; # remove trailing parens
    delete $arr{student};

    my $dsn = "DBI:$dbtype:$dbase";
    my $dbh = DBI->connect($dsn,$user,$password);

    foreach $key ( keys %arr ) {
	if ($arr{$key} ==1) { # We have a selection for team membership
	    my ($group, $userid, $sign) = split /:/,$key;
	    if ( $sign ){ next;} # skip over signing records
	    #print "U: $userid  G: $group S: $sign\n";

	    my $signer;
	    if ( $group eq 'per' ) {  # A user from personnel table.
		$sth1 = $dbh->prepare("select * from personnel where userid = ?");
		$sth1->execute( $userid );
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		my @member =$sth1->fetchrow;
		$user = "$member[3] $member[2] ($key)";
		$jobtitle = $member[4];
		$email = $member[7];
		$phone = $member[6];
		$val = $key.":sign";
		if ($arr{$val}){ $signer = $lex{Y};}
		#print "K: $key V:$val  S:$signer\n";

	    } else { # A teacher or TA in school

		$dsg = "DBI:$dbtype:$group";
		$dbg = DBI->connect($dsg,$guser,$gpassword);
		$sth1 = $dbg->prepare("select lastname, firstname,position,email 
                 from staff where userid = ?");
		$sth1->execute( $userid );
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		my ($lastname, $firstname, $position, $email) = $sth1->fetchrow; 
		$user = "$firstname $lastname ($key)";
		$jobtitle = $position;
		#$email = $member[7];
		$phone = $g_phone{$group};
		$val = $key.":sign";
		if ( $arr{$val} ){ $signer = $lex{Y}; }
		#print "K: $key V:$val  S:$signer\n";
	    }

	    my $sth = $dbh->prepare("insert into team values (
             $sql{default}, '$studnum', '$user', '$jobtitle',
             '$phone', '$email', '$signer')");
	    $sth->execute;
	    if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }

	} # End of If for course Entry

    } # End of Entry Loop


    if ( not $DBI::errstr ) {
	print "<h3>". $lex{'Your new team members are now stored'}. ".</h3>\n";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. ". \n";
	print $lex{Contact}. " $adminname <a href=\"mailto:$adminemail\">$adminname</a>\n";
	print $lex{'Please record the following error'}. ": $DBI::errstr\n";
    }

    print "<p>[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self?studnum=$studnum\">". $lex{'Add More Team Members'}. "</a> |\n";

    print "<form action=\"asadd.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Continue to Add Assessments'}. "\">\n";
    print "</form>\n";

    print "</p></center></body></html>\n";

    exit;

} # end of writeRecord
