#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Delete Team Member' => 'Delete Team Member',
	   'Student' => 'Student',
	   'Team Member' => 'Team Member',
	   'Are you sure you want to delete this record?' => 
	     'Are you sure you want to delete this record?',
	   'Yes, delete the record!' => 'Yes, delete the record!',
	   'Record Deletion Failed' => 'Record Deletion Failed',
	   'Contact' => 'Contact',
	   'Error' => 'Error',
	   'Record deleted' => 'Record deleted',
	   'Main' => 'Main',
	   'View/Delete Team Members' => 'View/Delete Team Members',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'tmdel.pl';

use CGI;
use DBI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;

eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;


# Print page header
print "$doctype\n<html><head><title>". $lex{'Delete Team Member'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body><center><h2>". $lex{'Delete Team Member'}. "</h2>\n";

if ( $arr{page} == 1 ) {
    delete $arr{page};
    deleteRecord();
}


# Get student number and team member userid
my $sth = $dbh->prepare("select studnum, userid from team where id = ?"); 
$sth->execute( $arr{id} );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
my ($studnum, $userid) = $sth->fetchrow;

# Now get student data
my $sth1 = $dbh->prepare("select lastname, firstname from special where studnum = ?"); 
$sth1->execute( $studnum );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
my ($lastname, $firstname) = $sth1->fetchrow;


print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"6\">\n";
print "<tr><td align=\"right\">". $lex{Student}. "</td>\n";
print "<td><b>$firstname $lastname ($studnum)</b></td></tr>\n";
print "<tr><td align=\"right\">". $lex{'Team Member'}. "</td><td><b>$userid</b>\n";
print "</td></tr></table>\n";

print "<p><em>". $lex{'Are you sure you want to delete this record?'}. "</em></p>\n";
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$arr{id}\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
print "<input type=\"submit\" value=\"". $lex{'Yes, delete the record!'};
print "\"></center></form></body></html>\n";


#---------------
sub deleteRecord {
#---------------

    my $sth = $dbh->prepare("delete from team where id = ?");
    $sth->execute( $arr{id} );

    if ( $DBI::errstr ) {
	print "<h1>\n";
	print $lex{'Record Deletion Failed'}. q{. };
	print $lex{Contact}. " $adminname<br>\n";
	print $lex{Error}. " $DBI::errstr</h1>\n";
    } else {
	print "<h2>". $lex{'Record deleted'}. ".</h2>\n";
    }

    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> |\n";
    print "<a href=\"tmvwdel.pl\">". $lex{'View/Delete Team Members'}. "</a> ]\n"; 
    print "</body></html>\n";

    exit;

}
