#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('View/Delete Teams' => 'View/Delete Teams',
	   'School' => 'School',
	   'Person' => 'Person',
	   'Role' => 'Role',
	   'Phone' => 'Phone',
	   'Email' => 'Email',
	   'Sign' => 'Sign',
	   'Delete' => 'Delete',
	   'Main' => 'Main',
	   'Error' => 'Error',
	   'Please Log In' => 'Please Log In',

	   );

use DBI;
use CGI;
use CGI::Session;

# Read config variables
eval require "ppp.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header;
    print "$doctype\n<html><head>\n";
    print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\"></head><body>\n";
    print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";
    print "<form action=\"login.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"userid\" value=\"$userid\">\n";
    print "<input type=\"hidden\" name=\"script\" value=\"$self\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Please Log In'}. "\">\n";
    print "</form></center></body></html>\n";
    die;
}

my $userid = $session->param('userid');
my $schooldbase = $session->param('schooldbase');

# Reset Login time
my $duration = $session->param('duration');
$session->expire('logged_in', $duration );

print $session->header;

# Get User Name
my $sth = $dbh->prepare("select lastname, firstname from educator where userid = ?");
$sth->execute( $userid );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

my $sdb = $dbh->quote( $schooldbase );
my $select = "and school = $sdb ";

my $sth = $dbh->prepare("select t.id, t.studnum, t.userid, t.jobtitle, 
   t.phone, t.email, t.sign from team as t, special as s 
   where s.studnum = t.studnum $select
   order by s.lastname, s.firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'View/Delete Teams'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">\n";
print "</head><body>[ <a href=\"$iephome\">". $lex{Main}. "</a> ] $firstname $lastname\n";
print "<h1>". $lex{'View/Delete Teams'}. "</h1>\n";

my $currstud = -1;

for ( my $i=1; $i <= $rows; ++$i) {
    my ( $id, $studnum, $userid, $jobtitle, $phone, $email, $sign ) = $sth->fetchrow;
  
    $oldstud = $currstud;
    $currstud = $studnum;     

    if ( $oldstud ne $currstud ) {  # We have a new student

	# Lookup Student Name
	$sth1 = $dbh->prepare("select lastname, firstname from special where studnum = ? ");
	$sth1->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname) = $sth1->fetchrow;
        if ( $i != 1 ) {  # close previous list
	    print "</table>";
	}

	print "<h3>$firstname $lastname ($currstud)</h3>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print "<tr><th>". $lex{Person}. "</th><th>". $lex{Role}. "</th><th>";
	print $lex{Phone}. "</th><th>". $lex{Email}. "</th><th>". $lex{Sign};
	print "</th><th>". $lex{Delete}. "</th></tr>\n";
    }
  
    print "<tr><td><b>$userid</b></td><td><i>$jobtitle</i></td>\n";
    print "<td>$phone</td><td><a href=\"mailto:$email\">$email</a></td>\n";
    print "<td align=\"center\">$sign</td>\n";
    print "<td>\n";
    print "<form action=\"tmdel.pl\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
    print "<input type=\"submit\"  value=\"". $lex{Delete}. "\">\n";
    print "</form></td></tr>\n";
     
} # End of loop counter

print "</ul></body></html>\n";
