#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Admin Attendance Entry' => 'Admin Attendance Entry',
	   'Error' => 'Error',
	   'Main' => 'Main',
	   'Attendance' => 'Attendance',
	   'Blank=All' => 'Blank=All',
	   'Attendance Date' => 'Attendance Date',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Attendance Entry' => 'Attendance Entry',
	   'Subject' => 'Subject',
	   'Enter Grade' => 'Enter Grade',
	   'Max Periods per Day not found for' => 'Max Periods per Day not found for',
	   'Submit Attendance' => 'Submit Attendance',
	   'Reason' => 'Reason',	   
	   'Student' => 'Student',
	   'Per' => 'Per',
	   'Attendance Date' => 'Attendance Date',
	   'Late' => 'Late',
	   'Separate Multiple Grades with a space' => 'Separate Multiple Grades with a space',
	   'Term not found' => 'Term not found',
	   'Student Not Found' => 'Student Not Found',
	   'Period(s)' => 'Period(s)',
	   'Clear Prev Attendance' => 'Clear Prev Attendance',
	   'Period' => 'Period',
	   'Reason' => 'Reason',
	   'Late' => 'Late',
	   'None' => 'None',

	   );

my $self = 'attaddall.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Set Date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";
my $currdate1 = "$month[$month] $day, $year";

print "$doctype\n<html><head><title>". $lex{'Admin Attendance Entry'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";

print "$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print " <a href=\"$attpage\">". $lex{Attendance}. "</a> ] $currdate1\n";
print "<center><h1>". $lex{'Admin Attendance Entry'}. "</h1></center>\n";

if ( $arr{grade} ) {
    doGradeAttendance();
} elsif ( $arr{homeroom} ) {
    doHomeroomAttendance();
} elsif ( $arr{subject} ) {
    doSubjectAttendance();
} elsif ( $arr{writeflag} ) {
    writeRecords();
} else {
    showStartPage();
}


#----------------
sub showStartPage {
#----------------
    
    # Find all teachers who do attendance and also record homerooms for them
    my $sth = $dbh->prepare("select distinct userid, homeroom from staff 
      where doatt = 'Y' order by lastname, firstname"); 
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    while ( my ( $userid, $homeroom ) = $sth->fetchrow ) {
	if ( $duplicates{$userid} ) { next; }

	if ( $homeroom ) {
	    push @homeroomteachers, $userid;
	}
	push @subjectteachers, $userid;
	$duplicates{$userid} = 1; # watch for duplicates
    }


    # Grade Entry
    print "<center>";
    print "<table cellpadding=\"3\" border=\"0\" cellspacing=\"0\">\n";
    print "<tr><th colspan=\"3\">". $lex{Grade}. q{ }. $lex{'Attendance Entry'}. "</th></tr>\n";
    print "<tr><td colspan=\"3\">";
    print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Enter Grade'}. "\">\n";
    print "<input type=\"text\" name=\"grade\" size=\"4\">\n";
    print $lex{'Blank=All'}. q{, }. $lex{'Separate Multiple Grades with a space'};
    print "</form></td></tr>\n";
    print "<tr><td colspan=\"3\">&nbsp;</td></tr>\n"; # spacer


    # Get Teacher Name, Homeroom Query
    my $sth1 = $dbh->prepare("select lastname, firstname, homeroom from staff where userid = ?");


    # Homeroom Entry
    print "<tr><th colspan=\"3\">". $lex{'Homeroom'}. q{ }. $lex{'Attendance Entry'};
    print "</th></tr>\n";
    my $count = 0;

    foreach my $userid ( @homeroomteachers ) {

	# Get Name and Homeroom
	$sth1->execute( $userid );
	my ( $lastname, $firstname, $homeroom ) = $sth1->fetchrow;

	if ( $count == 0 ) { print "<tr>"; }
	# Do Form.
	print "<td><form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"homeroom\" value=\"$userid\">\n";
	print "<input type=\"submit\" value=\"$lastname, $firstname\">\n";
	print "</form></td>\n";

	$count++;
	if ( $count % 3 == 0 ) { print "</tr>\n<tr>\n"; }
    }
    # Now clean up...
    my $remaining = 3 - ( $count % 3);
    for ( 1.. $remaining ) { print "<td></td>"; }
    print "</tr>\n";

    print "<tr><td colspan=\"3\">&nbsp;</td></tr>\n"; # put in spacer
    # End of Homeroom Entry



    # Now Start Subject Attendance Entry
    $count = 0;
    print "\n<tr><th colspan=\"3\">". $lex{Subject}. q{ }. $lex{'Attendance Entry'}. "</th></tr>\n\n";

    print "<tr>";
    foreach my $userid ( @subjectteachers ) {

	# Get Name and Homeroom
	$sth1->execute( $userid );
	my ( $lastname, $firstname, $homeroom ) = $sth1->fetchrow;

	# Do Form.
	print "<td><form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"subject\" value=\"$userid\">\n";
	print "<input type=\"submit\" value=\"$lastname, $firstname\">\n";
	print "</form></td>\n";

	$count++;
	if ( $count % 3 == 0 ) { print "</tr>\n<tr>\n"; }

    }
    # Now clean up...
    my $remaining = 3 - ( $count % 3);
    for ( 1.. $remaining ) { print "<td></td>"; }
    print "</tr>\n";

    print "</table>\n\n";
    # End of Subject Attendance Entry

    print "</body></html>\n";
    exit;

}


#------------------
sub doGradeAttendance {
#------------------

    # foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # Grades may be multiple space separated values.
    my @grades = split /\s/, $arr{grade};

    # Start of Form
    print "<center>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"writeflag\" value=\"grade\">\n";

    # show Date
    print "<div style=\"font-size:120%;\">". $lex{'Attendance Date'};
    print " <input type=\"text\" name=\"date\" id=\"date\" size=\"12\" value=\"$currdate\">\n";
    print "<button type=\"reset\" id=\"start_trigger\">...</button>\n";
    print "</div>\n";


    # Select by grade
    my $sth = $dbh->prepare("select lastname, firstname, studnum from student 
      where grade = ? order by lastname, firstname");

    # Loop through all grades
    foreach my $grade ( @grades ) {

	$sth->execute( $grade );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	my $maxppd;
	if ( $g_ppd{$grade} ) {
	    $maxppd = $g_ppd{$grade};
	} else {
	    print $lex{'Max Periods per Day not found for'}. q{ }. $lex{Grade}. " $grade\n";
	    print "</body></html>\n";
	    die;
	}


	print "<h1>". $lex{Grade}. " $grade</h1>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";  

	print "<tr><td colspan=\"5\" align=\"center\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";

	print "<tr><th>". $lex{Student}. "</th><th>";
	for my $p ( 1..$maxppd ) {
	    print $lex{Per}. " $p</th><th>";
	}
	print $lex{Reason}. "</th><th>". $lex{Late}. "</th></tr>\n";

	while (my ($lastname, $firstname, $studnum) = $sth->fetchrow){

	    print "<tr><td><b>$lastname</b>, $firstname</td>\n";
	    for my $p ( 1..$maxppd ) {
		print "<td><input type=\"checkbox\" name=\"$studnum:$p\" value=\"1\"></td>\n";
	    }
	    print "<td><select name=\"$studnum:Reason\"><option></option>\n";
    
	    foreach my $reason ( @attend ) {
		print "<option>$reason</option>\n";
	    }
	    print "<option></option></select></td>\n<td>";
	    print "<input type=\"text\" name=\"$studnum:Late\" size=\"4\"></td></tr>\n";

	}

	print "<tr><td colspan=\"5\" align=\"center\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";
	print "</table>\n";

    }  # Outer Loop here for each grade.


    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"date\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"start_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    })";

    print "</script>\n";
    print "</center></body></html>\n";

    exit;

}


#-----------------------
sub doHomeroomAttendance {
#-----------------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $userid = $arr{homeroom};
    delete $arr{homeroom};

    # Get homeroom for this userid
    my $sth = $dbh->prepare("select homeroom from staff where userid = ?");
    $sth->execute( $userid );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $homeroom = $sth->fetchrow;

    # Start of Form
    print "<center>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"writeflag\" value=\"homeroom\">\n";

    # show Date
    print "<div style=\"font-size:120%;\">". $lex{'Attendance Date'};
    print " <input type=\"text\" name=\"date\" id=\"date\" size=\"12\" value=\"$currdate\">\n";
    print "<button type=\"reset\" id=\"start_trigger\">...</button>\n";
    print "</div>\n";


    # Find largest PPD
    my $maxppd;
    my $sth1 = $dbh->prepare("select distinct grade from student where homeroom = ?");
    $sth1->execute( $homeroom );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my $grade = $sth1->fetchrow ) {
	if ( $g_ppd{$grade} > $maxppd ) {
	    $maxppd = $g_ppd{$grade};
	}
    }
    if ( not $maxppd ) {
	print $lex{'Max Periods per Day not found for'}. q{ }. $lex{Homeroom}. " $homeroom\n";
	print "</body></html>\n";
	die;
    }
    #print "Maxppd: $maxppd<br>\n";


    # Select students from homeroom
    $sth = $dbh->prepare("select lastname, firstname, studnum from student 
      where homeroom = ? order by lastname, firstname");

    $sth->execute( $homeroom );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    print "<h1>". $lex{Homeroom}. " $homeroom</h1>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";  

    print "<tr><td colspan=\"5\" align=\"center\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";

    print "<tr><th>". $lex{Student}. "</th><th>";
    for my $p ( 1..$maxppd ) {
	print $lex{Per}. " $p</th><th>";
    }
    print $lex{Reason}. "</th><th>". $lex{Late}. "</th></tr>\n";

    while (my ($lastname, $firstname, $studnum) = $sth->fetchrow){

	print "<tr><td><b>$lastname</b>, $firstname</td>\n";
	for my $p ( 1..$maxppd ) {
	    print "<td><input type=\"checkbox\" name=\"$studnum:$p\" value=\"1\"></td>\n";
	}
	print "<td><select name=\"$studnum:Reason\"><option></option>\n";
    
	foreach my $reason ( @attend ) {
	    print "<option>$reason</option>\n";
	}
	print "<option></option></select></td>\n<td>";
	print "<input type=\"text\" name=\"$studnum:Late\" size=\"4\"></td></tr>\n";

    }

    print "<tr><td colspan=\"5\" align=\"center\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";
    print "</table>\n";

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"date\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"start_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    })";

    print "</script>\n";
    print "</center></body></html>\n";

    exit;

}


#----------------
sub dateNormalize {
#----------------
    my $date = shift;
    my ($year,$month,$day) = split /-/, $date;
    if ( length( $month ) == 1 ) { $month = '0'. $month; } # prepend 0
    if ( length( $day ) == 1 ) { $day = '0'. $day; } # prepend 0
    $date = "$year$month$day";

    return $date;

}



#----------------------
sub doSubjectAttendance {
#----------------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    my $colnum = 5;


    my $userid = $arr{subject};
    delete $arr{subject};


    # Start of Form
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"writeflag\" value=\"subject\">\n";

    # show Date
    print "<div style=\"font-size:120%;\">". $lex{'Attendance Date'};
    print " <input type=\"text\" name=\"date\" id=\"date\" size=\"12\" value=\"$currdate\">\n";
    print "<button type=\"reset\" id=\"start_trigger\">...</button>\n";
    print "</div>\n";


    # Need the Term, to get the right subjects.
    my $term;
    my $cdate = dateNormalize( $currdate );
    foreach my $t ( sort keys %g_termstart ) {
	my $start = dateNormalize( $g_termstart{ $t } );
	my $end = dateNormalize( $g_termend{ $t } );

	if ( $cdate >= $start and $cdate <= $end ) { 
	    $term = $t; last;
	}
    }
    if ( not $term ) {
	print "<h1>". $lex{'Term not found'}. "</h1>\n";
	print "</body></html>\n";
	die;
    }
    #print "Term: $term<br>\n";


    #require "../lib/libschedule.pl" or die "Cannot open libschedule.pl!\n";

    # need $additionalcomments subject name to skip...
    require "../../etc/repcard.conf" or die "Cannot open repcard.conf!\n";


    # Get subjects taught this term by this teacher
    my $tempuser = '%('. $userid. ')';
    my $sth= $dbh->prepare("select subjsec, smdesc, description from subject
     where subject.teacher $sql{like} ? and 
     $term >= subject.startrptperiod and $term <= subject.endrptperiod");
    $sth->execute( $tempuser );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

    my $sth1 = $dbh->prepare("select count(*) from eval where subjcode = ?");

    while ( my ( $subjsec, $smdesc, $description ) = $sth->fetchrow ) {

	if ( $description eq $additionalcomments ) { next; } # skip additional comment subjects

	# Check for student enrollments
	$sth1->execute( $subjsec );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my $count = $sth1->fetchrow;
	if ($count < 1) { next; } # skip if no enrolled students.

	# Find largest PPD
	my $maxppd;
	my $sth1 = $dbh->prepare("select distinct s.grade from student as s, eval as e 
          where e.subjcode = ? and e.studnum = s.studnum and grade != ''");
	$sth1->execute( $subjsec );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	while ( my $grade = $sth1->fetchrow ) {
	    if ( $g_ppd{$grade} > $maxppd ) {
		$maxppd = $g_ppd{$grade};
	    }
	}
	if ( not $maxppd ) { $maxppd = 1; } # fallback to 1
	#print "Maxppd: $maxppd<br>\n";


	if ( not  $smdesc ) { # use description if not small description.
	    $description =~ s/\s+//g; # strip spaces.
	    $smdesc = substr($description,0, 7); 
	}


	# Get the Kids first... studnums.
	$sth1 = $dbh->prepare("select distinct s.studnum, s.lastname, s.firstname
          from eval as e, student as s where  subjcode = ? and e.studnum = s.studnum
          order by s.lastname, s.firstname");
	$sth1->execute( $subjsec );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	# Print Start of Subject Entry Table
	print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\" valign=\"top\" ";
	print "style=\"float:left; margin:1em;\">\n";
	print "<tr><th colspan=\"4\"><font size=+1>$description</font> ($subjsec)</th></tr>\n";
	print "<tr><th>". $lex{Student}. "</th><th>". $lex{'Period(s)'};
	print "</th><th>". $lex{Reason}. "</th><th>". $lex{Late}. "</th></tr>\n";
	print "<tr><td colspan=\"4\" align=\"center\">\n";
	print "<input type=\"reset\" value=\"". $lex{'Clear Prev Attendance'}. "\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";

	# Loop Through Students
	while ( my ( $studnum, $lastname, $firstname ) = $sth1->fetchrow ) {

	    if ( not $lastname ){  # student name not found.
		$lastname = "<span style=\"color:red;\">". $lex{'Student Not Found'}. "</span>";
	    }

	    print "<tr><td><b>$lastname</b>, $firstname</a></td><td>\n";

	    for my $p ( 1..$maxppd ){ 
		print $lex{Per}. $p;
		print " <input type=\"checkbox\" name=\"$studnum:$subjsec:$p\" value=\"1\">\n";
	    }
	    
	    print "</td><td><select name=\"$studnum:$subjsec:Reason\"><option></option>\n";
	    
    	    foreach my $reason ( @attend ){
		print "<option>$reason</option>\n";
	    }
	    print "</select></td>";
	    print "<td><input type=\"text\" name=\"$studnum:$subjsec:Late\" size=\"4\"></td></tr>\n";

	    print "</tr>\n";

	}

	print "<tr><td colspan=\"4\" align=\"center\">\n";
	print "<input type=\"reset\" value=\"". $lex{'Clear Prev Attendance'}. "\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";
	print "</table>\n\n\n";


    } # Outer Loop here for each subject.

    print "<script type=\"text/javascript\">
     Calendar.setup({
        inputField     :    \"date\", // id of the input field
        ifFormat       :    \"%Y-%m-%d\", // format of the input field
        button         :    \"start_trigger\", // trigger for the calendar (button ID)
        singleClick    :    false,        // double-click mode
        step           :    1             // show all years in drop-down boxes 
    })";

    print "</script>\n";
    print "</center></body></html>\n";

    exit;

}


#------------------
sub writeRecords {
#------------------

    my $mode = $arr{writeflag};
    delete $arr{writeflag};
    #print "Mode: $mode<br>\n";

    my $date = $arr{date};
    delete $arr{date};

    print "<center><div style=\"font-size:140%;\">". $lex{'Attendance Date'}. " $date</div>\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Student}. "</th><th>". $lex{Subject}. "</th><th>". $lex{Period}. "</th><th>";
    print $lex{Reason}. "</th><th>". $lex{Late}. "</th></tr>\n";

    my $sth1 = $dbh->prepare("select lastname, firstname from student where studnum = ?");
    my $sth2 = $dbh->prepare("select description from subject where subjsec = ?");
	    
    if ( $mode eq 'subject' ) {

	foreach my $key ( sort keys %arr ) {
	    if ( $arr{$key} ) {

		my ( $studnum, $subjsec, $period, $reason, $late );
		( $studnum, $subjsec, $period ) = split /:/, $key;
		if ( not $period or $period =~ m/\D/ ) { next; } 
		$reason = $arr{ "$studnum:$subjsec:Reason" };
		$late = $arr{ "$studnum:$subjsec:Late" };

		# Get Student Name and Subject Description
		$sth1->execute( $studnum );
		my ( $lastname, $firstname ) = $sth1->fetchrow;
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		$sth2->execute( $subjsec );
		my ( $description ) = $sth2->fetchrow;
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

		# Insert the Record
		my $sth = $dbh->prepare("insert into attend values (
                   $sql{default}, ? , ? , ? , ? , ? ,? )");
		$sth->execute( $studnum, $date , $reason, $period, $subject,$late );
		if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

		# Show Result
		print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td><td>";
		print "$description ($subjsec)</td><td>$period</td><td>$reason</td><td>$late</td></tr>\n";

	    }
	}

    } else {  # grade or homeroom method

	foreach my $key ( sort keys %arr ) {
	    if ( $arr{$key} ) {
		my ( $studnum, $subjsec, $period, $reason, $late );
		( $studnum, $period ) = split /:/, $key;
		if ( not $period or $period =~ m/\D/ ) { next; } 
		$reason = $arr{ "$studnum:Reason" };
		$late = $arr{ "$studnum:Late" };

		# Get Student Name
		$sth1->execute( $studnum );
		my ( $lastname, $firstname ) = $sth1->fetchrow;
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

		# Insert the Record
		my $sth = $dbh->prepare("insert into attend values (
                   $sql{default}, ? , ? , ? , ? , $sql{default} ,? )");
		$sth->execute( $studnum, $date, $reason, $period, $late );
		if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

		# Show Result
		print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td><td>";
		print $lex{None}. "</td><td>$period</td><td>$reason</td><td>$late</td></tr>\n";

	    }
	}

    }




    exit;

}
