#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


#### Attcheck.pl - check attendance table (attend) for duplicate
#### records, blank dates, and blank reasons. Link to something that
#### will allow it to be fixed...

my %lex = (
	   'Attendance Check' => 'Attendance Check',
	   'Main' => 'Main',
	   'Attendance' => 'Attendance',
	   'Duplicate Records' => 'Duplicate Records',
	   'Delete Duplicates' => 'Delete Duplicates',
	   'Name' => 'Name',
	   'Date' => 'Date',
	   'Period' => 'Period',
	   'Reason' => 'Reason',
	   'Delete' => 'Delete',
	   'No duplicates found' => 'No duplicates found',
	   'Blank Reasons' => 'Blank Reasons',
	   'Edit Reasons' => 'Edit Reasons',
	   'Edit' => 'Edit',
	   'Not Found' => 'Not Found',
	   'No empty reasons found' => 'No empty reasons found',
	   'Edit Reasons' => 'Edit Reasons',
	   'Back to Top' => 'Back to Top',
	   'Blank Dates' => 'Blank Dates',
	   'Edit Dates' => 'Edit Dates',
	   'No empty dates found' => 'No empty dates found',
	   'Duplicates Deleted' => 'Duplicates Deleted',
	   'Reasons Updated' => 'Reasons Updated',
	   'Update Dates' => 'Update Dates',
	   'Dates Updated' => 'Dates Updated',
	   'Subject' => 'Subject',
	   'Update Reasons' => 'Update Reasons',
	   'Error' => 'Error',
	   );

use DBI;
use CGI;


# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
%arr = $q->Vars;

$dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

# Page Head Section.
print "$doctype\n<html><head><title>". $lex{'Attendance Check'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "<a name=\"top\"></a>[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$attpage\">". $lex{Attendance}. "</a> ]<br><center>\n";


if ($arr{updateflag} == 2){  # We want to delete duplicates...
    delDuplicates();
}

if ($arr{updateflag} == 3){  # We want to edit reasons
    edReasons();
}

if ($arr{updateflag} == 4){  # We want to edit dates
    edDates();
}

if ($arr{updateflag} == 5){  # We want to update reasons
    updateReasons();
}

if ($arr{updateflag} == 6){  # We want to update dates
    updateDates();
}


# First... Find Duplicates.
$sth = $dbh->prepare("select attid, absdate, studentid, subjsec, period, reason
  from attend order by absdate, studentid, period");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die;}

$firstflag = 1;

while ( my ($id, $absdate, $studnum, $subjsec, $period,
	    $reason) = $sth->fetchrow){
    
    if ($prevdate eq $absdate and 
	$prevstud == $studnum and 
	$prevper == $period){ # We have a duplicate

	$sth1 = $dbh->prepare("select lastname, firstname from studentall
           where studnum = '$studnum'");
	$sth1->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my ($lastname, $firstname) = $sth1->fetchrow;
	if (not $lastname){ $lastname = 'Not Found';}

	if ($firstflag){
	    print '<center><h1>'. $lex{'Duplicate Records'}. "</h1>\n";
	    print "<form action=\"attcheck.pl\" method=\"post\">\n";
	    print "<input type=\"hidden\" name=\"updateflag\" value=\"2\">\n";
	    print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
	    print "<tr><td colspan=\"6\" align=\"center\">";
	    print "<input type=\"submit\" value=\"". $lex{'Delete Duplicates'}. "\"></td>";
	    print "</tr>\n<tr><th>". $lex{Name}. '</th><th>'. $lex{Date}. '</th><th>'. $lex{Period}. "</th>\n";
            print '<th>'. $lex{'Subject'}. '</th><th>'. $lex{Reason}. '</th><th>'. $lex{Delete}. "</th></tr>\n";
	    $firstflag = 0;
	}
	
	# Print Previous record
	print "<tr style=\"background:#BCF\"><td>$firstname $lastname ";
	print "($studnum)</td><td>$prevdate</td>";
	print "<td>$prevper</td><td>$prevsub</td>\n";
	print "<td>$prevrsn</td><td></td></tr>\n";

	# Print Current Record
	print "<tr><td>$firstname $lastname ($studnum)</td><td>$absdate</td>";
	print "<td>$period</td><td>$subjsec</td><td>$reason</td>\n";
	print "<td><input type=\"checkbox\" name=\"$id\" value=\"1\">";
	print "</tr>\n";

    }
    $prevdate = $absdate;
    $prevstud = $studnum;
    $prevper = $period;
    $prevsub = $subjsec;
    $prevrsn = $reason;

}


if ($firstflag){ 
    print "<b style=\"font-size: 150%\">". $lex{'No duplicates found'}. ".</b>\n";
} else {
    print "<tr><td colspan=\"6\" align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{'Delete Duplicates'}. "\"></td></tr>\n";
    print "</table></form>\n";
}

print "<p>[ <a href=\"#top\">Back to Top</a> ]</p>\n";

# Now look for blank reasons....

$sth = $dbh->prepare("select * from attend where reason is null or reason = ''
  order by absdate, period");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
my $firstblankflag = 1;

while (my ($id, $studnum,$absdate,$reason,$period,$subjsec) = $sth->fetchrow){
    if ($firstblankflag){ # write the table head section...
	print '<center><h1>'. $lex{'Blank Reasons'}. "</h1>\n";
	print "<form action=\"attcheck.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"updateflag\" value=\"3\">\n";
	print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
	print "<tr><td colspan=\"6\" align=\"center\">";
	print "<input type=\"submit\" value=\"". $lex{'Edit Reasons'}. "\"></td>";
	print "</tr>\n<tr><th>". $lex{Name}. '</th><th>'. $lex{Date}. '</th><th>'. $lex{Period}. "</th>\n";
	print '<th>'. $lex{'Subject'}. '</th><th>'. $lex{Reason}. '</th><th>'. $lex{Edit}. "</th></tr>\n";
	$firstblankflag = 0;
    }

    $sth1 = $dbh->prepare("select lastname, firstname from studentall
      where studnum = '$studnum'");
    $sth1->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
    my ($lastname, $firstname) = $sth1->fetchrow;
    if (not $lastname){ $lastname = "<font color=\"red\">". $lex{'Not Found'}. '</font>';}

    # Print Current Record
    print "<tr><td>$firstname $lastname ($studnum)</td><td>$absdate</td>";
    print "<td>$period</td><td>$subjsec</td><td>$reason</td>\n";
    print "<td><input type=\"checkbox\" name=\"$id\" value=\"1\">";
    print "</tr>\n";

}

if ($firstblankflag){ 
    print "<b style=\"font-size: 150%\">". $lex{'No empty reasons found'}. ".</b>\n";
} else {
    print "<tr><td colspan=\"6\" align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{'Edit Reasons'}. "\"></td></tr>\n";
    print "</table></form>\n";
}
print "<p>[ <a href=\"#top\">". $lex{'Back to Top'}. "</a> ]</p>\n";

#----------------------
# Now find blank dates.
#----------------------

$sth = $dbh->prepare("select * from attend where 
  absdate = '' order by absdate, period");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
$firstflag = 1;

while (my ($id, $studnum,$absdate,$reason,$period,$subjsec) = $sth->fetchrow){
    if ($firstflag){ # write the table head section...
	    print '<center><h1>'. $lex{'Blank Dates'}. "</h1>\n";
	    print "<form action=\"attcheck.pl\" method=\"post\">\n";
	    print "<input type=\"hidden\" name=\"updateflag\" value=\"4\">\n";
	    print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
	    print "<tr><td colspan=\"6\" align=\"center\">";
	    print "<input type=\"submit\" value=\"". $lex{'Edit Dates'}. "\"></td>";
	    print "</tr>\n<tr><th>". $lex{Name}. '</th><th>'. $lex{Date}. '</th><th>'. $lex{Period}. "</th>\n";
	    print '<th>'. $lex{'Subject'}. '</th><th>'. $lex{Reason}. '</th><th>'. $lex{Edit}. "</th></tr>\n";
	    $firstflag = 0;
    }

    # Get Name
    $sth1 = $dbh->prepare("select lastname, firstname from studentall
      where studnum = '$studnum'");
    $sth1->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
    my ($lastname, $firstname) = $sth1->fetchrow;
    if (not $lastname){ $lastname = "<font color=\"red\">". $lex{'Not Found'}. '</font>';}

    # Get Subject
    $sth1 = $dbh->prepare("select description from subject
      where subjsec = '$subjsec'");
    $sth1->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
    my $desc = $sth1->fetchrow;
    if (not $desc){ $desc = "<font color=\"red\">". $lex{'Not Found'}. '</font>';}

    # Print Current Record
    print "<tr><td>$firstname $lastname ($studnum)</td><td>$absdate</td>";
    print "<td>$period</td><td>$desc ($subjsec)</td><td>$reason</td>\n";
    print "<td><input type=\"checkbox\" name=\"$id\" value=\"1\">";
    print "</tr>\n";

}

if ($firstflag){ 
    print "<b style=\"font-size: 150%\">". $lex{'No empty dates found'}. ".</b>\n";
} else {
    print "<tr><td colspan=\"6\" align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{'Edit Dates'}. "\"></td></tr>\n";
    print "</table></form>\n";
}

print "<p>[ <a href=\"#top\">". $lex{'Back to Top'}. "</a> ]</p>\n";
print "</center></body></html>\n";



#====================== Functions ====================


#----------------
sub delDuplicates { # Delete duplicate attendance records
#----------------

    delete $arr{updateflag};

    foreach my $key (keys %arr){
	my $sth = $dbh->prepare("delete from attend where attid = '$key'");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
    }

    print '<h1>'. $lex{'Duplicates Deleted'}. ".</h1>\n";
    print "<p>[ <a href=\"$attpage\">". $lex{Attendance}. "</a> | ";
    print "<a href = \"attcheck.pl\">". $lex{'Attendance Check'}. "</a> ]</p>\n";
    print "</body></html>\n";

    exit;

}



#------------
sub edReasons { # edit reasons
#------------

    delete $arr{updateflag};

    print '<center><h1>'. $lex{'Edit Reasons'}. "</h1>\n";
    print "<form action=\"attcheck.pl\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"updateflag\" value=\"5\">\n";
    print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
    print "<tr><td colspan=\"5\" align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{'Update Reasons'}. "\"></td></tr>";
    print "</tr>\n<tr><th>". $lex{Name}. '</th><th>'. $lex{Date}. '</th><th>';
    print $lex{Period}. "</th>\n";
    print '<th>'. $lex{'Subject'}. '</th><th>'. $lex{Reason}. "</th></tr>\n";

    foreach my $key (keys %arr){
        #print "K:$key V:$arr{$key}<br>\n";
	my $sth = $dbh->prepare("select * from attend where attid = '$key'");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my ($id, $studnum,$absdate,$reason,$period,$subjsec) = $sth->fetchrow;

	# Get Name
	$sth1 = $dbh->prepare("select lastname, firstname from studentall
         where studnum = '$studnum'");
	$sth1->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my ($lastname, $firstname) = $sth1->fetchrow;
	if (not $lastname){ $lastname = "<font color=\"red\">". $lex{'Not Found'}. '</font>';}


	# Get Subject, if present...
	if ($subjsec) {
	    $sth1 = $dbh->prepare("select description from subject
             where subjsec = '$subjsec'");
	    $sth1->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	    my $desc = $sth1->fetchrow;
	    if (not $desc){ $desc = "<font color=\"red\">". $lex{'Not Found'}. '</font>';}
	    $desc .= " ($subjsec)";
	}


	# Print Current Record
	print "<tr><td>$firstname $lastname ($studnum)</td><td>$absdate</td>";
	print "<td>$period</td><td>$desc</td><td>\n";
	print "<select name=\"$id\"><option></option>\n";
	foreach my $rsn (@attend){
	    print "<option>$rsn</option>\n";
	}
	print "</select></td></tr>\n";

    }

    print "<tr><td colspan=\"5\" align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{'Update Reasons'}. "\"></td>";
    print "</table></form></body></html>\n";

    exit;
}


#----------------
sub updateReasons { # Write Reasons
#----------------

    delete $arr{updateflag};

    foreach my $key (keys %arr){
	#print "K:$key V:$arr{$key}<br>\n";
	my $sth = $dbh->prepare("update attend set reason = '$arr{$key}' 
          where attid = '$key'");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
    }

    print '<h1>'. $lex{'Reasons Updated'}. ".</h1>\n";
    print "<p>[ <a href=\"$attpage\">". $lex{Attendance}. "</a> | ";
    print "<a href = \"attcheck.pl\">". $lex{'Attendance Check'}. "</a> ]</p>\n";
    print "</body></html>\n";

    exit;
}


#------------
sub edDates { # edit dates
#------------

    delete $arr{updateflag};

    print '<center><h1>'. $lex{'Edit Dates'}. "</h1>\n";
    print "<form action=\"attcheck.pl\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"updateflag\" value=\"6\">\n";
    print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
    print "<tr><td colspan=\"5\" align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{'Update Dates'}. "\"></td>";
    print "</tr>\n<tr><th>". $lex{Name}. '</th><th>'. $lex{Date}. '</th><th>';
    print $lex{Period}. "</th>\n";
    print '<th>'. $lex{'Subject'}. '</th><th>'. $lex{Reason}. "</th></tr>\n";

    foreach my $key (keys %arr){
	#print "K:$key V:$arr{$key}<br>\n";
	my $sth = $dbh->prepare("select * from attend where attid = '$key'");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my ($id, $studnum,$absdate,$reason,$period,$subjsec) = $sth->fetchrow;

	# Get Name
	$sth1 = $dbh->prepare("select lastname, firstname from studentall
         where studnum = '$studnum'");
	$sth1->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my ($lastname, $firstname) = $sth1->fetchrow;
	if (not $lastname){ $lastname = "<font color=\"red\">". $lex{'Not Found'}. '</font>';}

	# Get Subject
	$sth1 = $dbh->prepare("select description from subject
         where subjsec = '$subjsec'");
	$sth1->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my $desc = $sth1->fetchrow;
	if (not $desc){ $desc = "<font color=\"red\">". $lex{'Not Found'}. '</font>';}

	# Print Current Record
	print "<tr><td>$firstname $lastname ($studnum)</td><td>";
	print "<input type=\"text\" name=\"$id\" size=\"12\" ";
	print "value=\"$absdate\"></td>";
	print "<td>$period</td><td>$desc ($subjsec)</td><td>$reason</td>\n";
	print "</tr>\n";

    }

    print "<tr><td colspan=\"5\" align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{'Update Dates'}. "\"></td>";
    print "</table></form></body></html>\n";

}


#----------------
sub updateDates { # Write Dates
#----------------

    delete $arr{updateflag};

    foreach my $key (keys %arr){
	#print "K:$key V:$arr{$key}<br>\n";
	my $sth = $dbh->prepare("update attend set absdate = '$arr{$key}' 
          where attid = '$key'");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
    }

    print '<h1>'. $lex{'Dates Updated'}. ".</h1>\n";
    print "<p>[ <a href=\"$attpage\">". $lex{Attendance}. "</a> | ";
    print "<a href = \"attcheck.pl\">". $lex{'Attendance Check'}. "</a> ]</p>\n";
    print "</body></html>\n";

}
