#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson
#  This file is part of Open Admin for Schools.

use DBI;
use CGI qw\escape unescape\;
use Date::Business;

my $studenttable = 'studentall';
# alter this to 'student' if you don't want to see withdrawn students.


my %lex = ('Attendance' => 'Attendance',
	   'Edit/Delete Attendance' => 'Edit/Delete Attendance',
	   'Main' => 'Main',
	   'Edit Attendance' => 'Edit Attendance',
	   'Student' => 'Student',
	   'Date' => 'Date',
	   'Subject' => 'Subject',
	   'Period/Reason' => 'Period/Reason',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'No Records Found' => 'No Records Found',
	   'Grade' => 'Grade',
	   'Today' => 'Today',
	   'Yesterday' => 'Yesterday',
	   'Error' => 'Error',

	   );


my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
 $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";
my $today = "$year-$mon-$mday";

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = CGI->new;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page header.
print "$doctype\n<html><head><title>" . $lex{'Edit Attendance'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print " $chartype\n</head><body><a name=\"top\"></a>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$attpage\">". $lex{Attendance}. "</a> ]\n";;
print "<center><h1>". $lex{'Edit/Delete Attendance'}."</h1>\n";

#foreach my $key ( keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

my $sth;
my $student;
if ( $arr{student} ) {
    $student = $arr{student};
    if ($student =~ /\d+/) {  # we have a student number
	push @studnum, $student; # only a single value
    } else { # we have some text.
	($lastname,$firstname)  = split /\,/, $student;
	$firstname =~ s/^\s*//;
	$lastname =~ s/^\s*//;
	if ($lastname and $firstname){ # both entered.
	    my $ln = $dbh->quote( $lastname );
	    my $fn = $dbh->quote( $firstname );
	    $sth = $dbh->prepare("select studnum from $studenttable
              where lastname = $ln and firstname = $fn ");

	} elsif ($lastname and not $firstname){ # only lastname (no comma)

	    if (length($lastname) == 2){ # search by initials: fi, li.
		my $fi = $dbh->quote( substr($lastname,0,1).'%' ); 
		my $li = $dbh->quote( substr($lastname,1,1).'%' );
		$sth = $dbh->prepare("select studnum from $studenttable
                 where lastname $sql{like} $li and firstname $sql{like} $fi");

	    } else {
		$ln = $dbh->quote( $lastname );
		$sth = $dbh->prepare("select studnum from $studenttable
                 where lastname = $ln order by firstname");
	    }
	}
    }

    if ( $sth ) {  # sth should be set above in one of 3 places
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
	while ( my $studnum = $sth->fetchrow) {
	    push @studnum, $studnum;
	}
    }

    if ( not @studnum ) { # no records
	print "<h3>". $lex{'No Records Found'}. "</h3>\n";
	print "</body></html>\n";
	die;
    }

    printStudents( @studnum );

}
# End of student only. 


# otherwise we have a date...
if ( $arr{date} ) {
    if ( lc( $arr{date} ) eq lc( $lex{Today} ) ){
	$sth = $dbh->prepare("select * from attend, $studenttable as s
         where attend.studentid = s.studnum and 
         attend.absdate = '$today' 
         order by attend.absdate desc, s.lastname, 
           s.firstname,attend.period");
    }

    if ( lc( $arr{date}) eq lc( $lex{Yesterday}) ){

	# Figure out yesterday using Date::Business
	my $btoday = new Date::Business();
	$btoday->prevb();
	my $yesterday = $btoday->image();

	$sth = $dbh->prepare("select * from attend, $studenttable as s 
         where attend.studentid = s.studnum and 
         attend.absdate = '$yesterday' 
         order by attend.absdate desc, s.lastname, 
         s.firstname, attend.period");

	$yesterday = substr($yesterday,0,4) . "-" . substr($yesterday,4,2) . 
	    "-" . substr($yesterday,6,2);
	$currdate = $yesterday;
    }
}

if ( $arr{datestart} ) { # We select a date range

    if ( not $arr{dateend} ) {$arr{dateend} = $today; }

    $arr{datestart} = $dbh->quote( $arr{datestart} );
    $arr{dateend} = $dbh->quote( $arr{dateend} );
    $sth = $dbh->prepare("select * from attend, $studenttable as s
     where attend.studentid = s.studnum and 
     to_days(attend.absdate) >= to_days( $arr{datestart} ) and 
     to_days(attend.absdate) <= to_days( $arr{dateend} ) 
     order by attend.absdate desc, s.lastname, 
      s.firstname, attend.period");
}

if ( not $sth ) { # if no dates, then find them ALL.
    $sth = $dbh->prepare("select * from attend, $studenttable as s 
     where attend.studentid = s.studnum 
     order by attend.absdate desc, s.lastname, s.firstname");
}

$sth->execute;
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr;}
$rows = $sth->rows;

if ( $rows < 1) { # no records
    print "<h3>". $lex{'No Records Found'}. "</h3>\n";
    print "</body></html>\n";
    die;
}

#print "<p>$currdate</p>\n";

print "<p>$studentname</p>";
print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";

print "<tr><th>".$lex{Student}."</th><th>".$lex{Date}."</th><th>".$lex{Subject};
print "</th><th>".$lex{'Period/Reason'}. "</th><th>". $lex{Edit}. "</th><th>";
print $lex{Delete}."</th></tr>\n";

$sth1 = $dbh->prepare("select description from subject where subjsec = ?"); 

$currstud = -1;
for ( $i=1; $i <= $rows; ++$i) {
    @arr = $sth->fetchrow;
    $name = escape($arr[9]." ".$arr[8]);


    $sth1->execute( $arr[5] );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
    $desc = $sth1->fetchrow;
  
    if ( not $desc ) {
	$desc = $lex{Grade}. ":$arr[12]";
    } else {
	$desc = $desc."($arr[5])";
    }

    $oldstud = $currstud; 
    $currstud = $arr[1];
    if ($currstud != $oldstud){
	if ($color eq "blue"){ 
	    $color = "gray";
	} else { 
	    $color = "blue";} 
    }
    print "<tr class=\"$color\"><td><b>$arr[1]:</b> $arr[8], $arr[9]</td>\n";
    print "<td>$arr[2]</td><td>$desc</td><td>$arr[4]- $arr[3]</td>\n";
    print "<td><a href=\"atted.pl?recnum=$arr[0]&name=$name\">\n";
    print $lex{Edit}. "</a></td><td><a href=\"attdel.pl?recnum=$arr[0]&name=$name\">\n";
    print $lex{Delete}. "</a></td></tr>\n";

}

print "</table></center></body></html>";


#----------------
sub printStudents {
#----------------

    my @studs = @_;
    my $sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");

    # print the anchor line of names
    if ($#studs > 0) { # Display a jump to line
	my $first = 1;
	foreach my $studnum (@studs) {
	    if ($first) { print "<p>[ "; $first = 0; } else { 
		print ' | ';
	    }

	    $sth->execute($studnum);
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my ($lastname, $firstname) = $sth->fetchrow;
	    print "<a href=\"#$studnum\">$firstname $lastname</a>\n";
	}
	print " ]</p>\n";

    }

    my $first = 1;

    foreach my $studnum ( @studs ) {

	$sth->execute( $studnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname) = $sth->fetchrow;

	if ( not $first ) { print "</table>\n"; } else { $first = 0; }

	print "<a name=\"$studnum\"></a>\n";
	print "<div style=\"font-size:130%; font-weight:bold; padding:0.8em;\">";
	print "$firstname $lastname&nbsp;&nbsp;[ <a href=\"#top\">Top</a> ]</div>\n";
	print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"1\">\n";
	print "<tr><th>".$lex{Date}."</th><th>".$lex{Subject};
	print "</th><th>".$lex{'Period/Reason'}."</th><th>".$lex{Edit};
	print "</th><th>".$lex{Delete}."</th></tr>\n";

	my $sth1 = $dbh->prepare("select attid, absdate, reason, period, subjsec from attend 
          where studentid = ? order by absdate desc, period");
	$sth1->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $name = escape($firstname.' '.$lastname);	
	my $sth2 = $dbh->prepare("select description from subject where subjsec = ?");


	my $currdate = -1;
	while ( my ($id, $absdate, $reason, $period, $subjsec) = $sth1->fetchrow) {
	    my $desc; # subjsec description
	    if ($subjsec) {
		$sth2->execute($subjsec);
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
		$desc = $sth2->fetchrow;
	    }
	    $prevdate = $currdate; $currdate = $absdate;
	    if ( $prevdate ne $currdate ) { # color switch
		if ( not $attrCol ) { 
		    $attrCol = "style=\"background-color:#D8D8D8;\"";
		} 
	    }

	    print "<tr $attrCol><td>$absdate</td><td>$desc $subjsec</td>";
	    print "<td>$period : $reason</td>\n";
	    print "<td><a href=\"atted.pl?recnum=$id&name=$name\">\n";
	    print $lex{Edit}."</a></td><td><a href=\"attdel.pl?recnum=$id&name=$name\">\n";
	    print $lex{Delete}."</a></td></tr>\n";

	} # End of Attendance Records
	print "</table>\n"; # final table

    }

    print "</body></html>\n";

    exit;

} # End of printStudents
