#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Update Record' => 'Update Record',
	   'Edit Attendance' => 'Edit Attendance',
	   'Student Number' => 'Student Number',
	   'Date' => 'Date',
	   'Reason' => 'Reason',
	   'Attendance' => 'Attendance',
	   'Your attendance update is now stored' => 'Your attendance update is now stored',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Please contact your network administrator at' => 
	     'Please contact your network administrator at',
	   'Please record the following error' => 'Please record the following error',
	   'Edit/Delete Another Record' => 'Edit/Delete Another Record',
	   'Today' => 'Today',
	   'Yesterday' => 'Yesterday',
	   'All' => 'All',
	   'Period' => 'Period',
	   'Subject-Section' => 'Subject-Section',
	   'min' => 'min',
	   'Late' => 'Late',
	   'Main' => 'Main',
	   'Error' => 'Error',

	   );

my $self = 'atted.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select * from attend where attid = ?"); 
$sth->execute( $arr{recnum} );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my ($attid, $studnum, $absdate, $reason, $period, $subjsec, $late) = $sth->fetchrow;


# Print Page Head.
print "$doctype\n<html><head><title>". $lex{'Edit Attendance'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$attpage\">". $lex{Attendance}. "</a> ]\n";

print "<center><h1>". $lex{'Edit Attendance'}. "</h1>\n";

if ( $arr{updateflag} ) {
    delete $arr{updateflag};
    updateRecord();
}

# Print Form Header
print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"attid\" value=\"$attid\">
<input type=\"hidden\" name=\"updateflag\" value=\"1\">\n";

# Get Student Name
$sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
$sth->execute( $studnum  );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

# Name and Student Number
print "<table><caption><b>$firstname $lastname</b></caption>\n";
print "<tr><td align=\"right\">". $lex{'Student Number'}. "</td>\n<td>$studnum</td></tr>\n";

# Date
print "<tr><td align=\"right\">". $lex{Date}. "</td>\n<td>";
print "<input type=\"text\" Name=\"absdate\" size=\"12\" value=\"$absdate\"></td></tr>\n";

# Reason
print "<tr><td align=\"right\">". $lex{Reason}. "</td><td><select name=\"reason\">
 <option>$reason</option>\n";
foreach my $reason ( @attend ) {  print "<option>$reason</option>\n"; }
print "</select></td></tr>\n";

# Period
print "<tr><td align=\"right\">". $lex{Period}. "</td>\n<td>";
print "<input type=\"text\" name=\"period\" size=\"4\" value=\"$period\"></td></tr>\n";

# Subjsec
print "<tr><td align=\"right\">". $lex{'Subject-Section'}. "</td>\n<td>";
print "<input type=\"text\" Name=\"subjsec\" size=\"12\" maxlength=\"32\" value=\"$subjsec\"></td></tr>\n";

# Late
print "<tr><td align=\"right\">". $lex{'Late'}. ' ('. $lex{min}. ")</td>\n<td>";
print "<input type=\"text\" Name=\"late\" size=\"4\" value=\"$late\"></td></tr>\n";

print "</table><p><input type=\"submit\" value=\"". $lex{'Update Record'}. "\">\n";
print "</form></center></body></html>\n";


#---------------
sub updateRecord {
#---------------

    my $sth = $dbh->prepare("update attend set
      absdate = ?, reason = ?, period = ?, 
      subjsec = ?, late = ?  where attid = ?");

    $sth->execute( $arr{absdate}, $arr{reason}, $arr{period} ,
		   $arr{subjsec}, $arr{late}, $arr{attid} );

    print '<h3>';
    if ( not $DBI::errstr ) {
	print $lex{'Your attendance update is now stored'}. ".</h3></p>";

    } else {
	print $lex{'There was an error storing your data'}. "<br>\n";
	print $lex{'Please contact your network administrator at'};
	print " <a href=\"mailto:$adminemail\">$adminemail</a><br>\n ";
	print $lex{'Please record the following error'}. "<br>\n";
	print $DBI::errstr;
    }

    print "</h3>\n";

    print "<p>[ <a href=\"$attpage\">". $lex{Attendance}. "</a> ]</p>\n";
    print "<p><form action=\"attdeled.pl\" method=\"post\">\n";
    print "<select name=\"date\"><option>". $lex{Today}. '</option><option>';
    print $lex{Yesterday}. "</option><option>". $lex{All}. "</option></select>\n";
    print "<input type=\"submit\" value=\"";
    print $lex{'Edit/Delete Another Record'}. "\"></form></p>\n";
    print "</center></body></html>\n";

    exit;

}
