#!/usr/bin/perl

#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = (
	   'Periods per Day not set in configuration file!' => 
	     'Periods per Day not set in configuration file!',
	   'Administration Attendance Entry' => 'Administration Attendance Entry',
	   'Attendance' => 'Attendance',
	   'Attendance Date' => 'Attendance Date',
	   'Student#' => 'Student#',
	   'Reason' => 'Reason',
	   'Periods' => 'Periods',
	   'Continue' => 'Continue',
	   'Student Number + Reason + Subject + Period Entry' => 
	     'Student Number + Reason + Subject + Period Entry',
	   'Enter 9 digits (5 digit student number + 1 digit reason + 2 digit subject + period)' =>
 	     'Enter 9 digits (5 digit student number + 1 digit reason + 2 digit subject + period)',
	   'using numeric keypad and tab key only' => 'using numeric keypad and tab key only',
	   'Student Alias + Period Entry' => 'Student Alias + Period Entry',
	   'Enter 4 digits (3 digit alias + 1 digit period)' => 
	     'Enter 4 digits (3 digit alias + 1 digit period)',
	   'Student Alias + Reason + Period Entry' => 'Student Alias + Reason + Period Entry',
	   'Enter 5 digits (3 digit alias + 1 digit reason + 1 digit period)' => 
	     'Enter 5 digits (3 digit alias + 1 digit reason + 1 digit period)',
	   'Student Alias + Subject + Period Entry' => 'Student Alias + Subject + Period Entry',
	   'Enter 6 digits (3 digit alias + 2 digit subject + period)' => 
	     'Enter 6 digits (3 digit alias + 2 digit subject + period)',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


$q = new CGI;
print $q->header( -charset, $charset ); 
%arr = $q->Vars;

# Split and get entry method desired.
my ($dud, $method) = split /\(/,$arr{method};
chop $method; # remove trailing paren.


my $maxppd = 0;  # Maximum periods per day
if (not %g_ppd){ 
    print $lex{'Periods per Day not set in configuration file!'};
    die;
}

foreach my $key (keys %g_ppd){
    if ($g_ppd{$key} > $maxppd){ $maxppd = $g_ppd{$key};}
} 

# Get Date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";
my $currdate1 = "@month[$month] $day, $year";

print "$doctype\n<html><head><title>". $lex{'Administration Attendance Entry'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>\n";
print "[ <a href=\"$attpage\">". $lex{Attendance}. "</a> ] $currdate1
<center><h1>". $lex{'Administration Attendance Entry'}. "</h1>\n";

# Print Form Start
print "<form action=\"attentry1.pl\" method=\"post\">
<p><b>". $lex{'Attendance Date'}. ":</b>
<input type=\"text\" name=\"date\" value=\"$currdate\" size=\"12\"></p>
<input type=\"hidden\" name=\"date1\" value=\"$currdate1\">
<input type=\"hidden\" name=\"maxppd\" value=\"$maxppd\">\n";



# ===== SN9 Student Number / Reason / Subject / Period ====
if ($method eq 'sn9') {  # Student Number, Reason, Subject, Period - 9 digits

    # print heading text.
    print '<h2>'. $lex{'Student Number + Reason + Subject + Period Entry'}. "</h2>\n";
    print $lex{'Enter 9 digits (5 digit student number + 1 digit reason + 2 digit subject + period)'}. "<br>\n";
    print $lex{'using numeric keypad and tab key only'}. ".<br>\n";

    print "<input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\"><tr>\n";
    print "<input type=\"hidden\" name=\"method\" value=\"$method\">\n";

    for ($i=1;$i<=120;$i++) { # Setup 30 Input Entries
	print "<td><input type=\"text\" name=\"studn$i\" size=\"11\"></td>\n";
	if (not ($i % 6)){ print "</tr><tr>\n";}
    }
    print "</tr></table>\n";
} # End of SN9 Method


# ============= SNAP ==============
if ($method eq 'snap') {
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
    print "<table cellspacing=\"0\" border=\"1\" cellpadding=\"3\">\n";
    print '<tr><th>'. $lex{'Student#'}. '</th><th>'. $lex{Reason};
    print '</th><th>'. $lex{Periods}. "</th></tr>\n";

    print "<input type=\"hidden\" name=\"method\" value=\"$method\">\n";

    for ($i=1;$i<=30;$i++) { # Setup 30 Input Entries
	my $student = "stud$i";
	my $reasnum = "reas$i";

	print "<tr><td><input type=\"text\" name=\"$student\" size=\"6\"></td>\n";
	print "<td><select name=\"$reasnum\"><option></option>\n";

	foreach my $reason (@attend){
	    print "<option>$reason</option>\n";
	}

	print "</select></td><td> \n";
	for (1..$maxppd){ 
	    print "P$_<input type=\"checkbox\" name=\"$i:$_\" value=\"1\">\n";
	}
	print "</td></tr>\n\n";
    }
    print "</table>\n";

} # End of SNAP method


# ============ SA4 Method ==============
if ($method eq 'sa4') {  # Student Alias, 4 digits

    print '<h2>', $lex{'Student Alias + Period Entry'}. "</h2>\n";
    print $lex{'Enter 4 digits (3 digit alias + 1 digit period)'}. "<br>\n";
    print $lex{'using numeric keypad and tab key only'}. ".<br>\n";
    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\"><tr>\n";
    print "<input type=\"hidden\" name=\"method\" value=\"$method\">\n";
    for ($i=1;$i<=30;$i++) { # Setup 30 Input Entries
	print "<td><input type=\"text\" name=\"studa$i\" size=\"6\"></td>\n";
	if (not ($i % 5)){ print "</tr><tr>\n";}
    }
    print "</tr></table>\n";

} # End of SA4 Method



# ============ SA5 Method ==============
if ($method eq 'sa5') {  # Student Alias, Reason, Period
    print '<h2>'. $lex{'Student Alias + Reason + Period Entry'}. "</h2>\n";
    print $lex{'Enter 5 digits (3 digit alias + 1 digit reason + 1 digit period)'}. "<br>\n";
    print $lex{'using numeric keypad and tab key only'}. ".<br>\n";
    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\"><tr>\n";
    print "<input type=\"hidden\" name=\"method\" value=\"$method\">\n";
    for ($i=1;$i<=30;$i++) { # Setup 30 Input Entries
	print "<td><input type=\"text\" name=\"studa$i\" size=\"6\"></td>\n";
	if (not ($i % 5)){ print "</tr><tr>\n";}
    }
    print "</tr></table>\n";

} # End of SA5 Method



# ================= SA6 Method =================
if ($method eq 'sa6') {  # Student Alias, Subject, Period - 6 digits
    print '<h2>'. $lex{'Student Alias + Subject + Period Entry'}. "</h2>\n";
    print $lex{'Enter 6 digits (3 digit alias + 2 digit subject + period)'}. "<br>\n";

    print $lex{'using numeric keypad and tab key only'}. ".<br>\n";
    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\"><tr>\n";

    print "<input type=\"hidden\" name=\"method\" value=\"$method\">\n";
    for ($i=1;$i<=30;$i++) { # Setup 30 Input Entries
	print "<td><input type=\"text\" name=\"studa$i\" size=\"8\"></td>\n";
	if (not ($i % 5)){ print "</tr><tr>\n";}
    }
    print "</tr></table>\n";
} # End of SA6 Method


print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></form>
</center></body></html>\n";
