#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = (
	   'Attendance Confirmation' => 'Attendance Confirmation',
	   'Attendance' => 'Attendance',
	   'Student' => 'Student',
	   'Subject' => 'Subject',
	   'Per' => 'Per',
	   'Reason' => 'Reason',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'No Subject' => 'No Subject',
	   'Save Attendance Records' => 'Save Attendance Records',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

$q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;
my $maxppd = $arr{maxppd};


print "$doctype\n<html><head><title>". $lex{'Attendance Confirmation'};
print "</title>\n<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>\n";
print "[ <a href=\"$attpage\">". $lex{Attendance}. "</a> ]<center>\n";
print '<h1>'. $lex{'Attendance Confirmation'}."</h1><p><b>$arr{date1}</b></p>\n";

print "<form action=\"attentry2.pl\" method=\"post\">
<input type=\"hidden\" name=\"date\" value=\"$arr{date}\">\n";

print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";

$dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

# ======= SN9 Method ======
if ($arr{method} eq 'sn9') {
    print '<tr><th>'. $lex{Student}. '</th><th>'. $lex{Subject}. '</th><th>';
    print $lex{Per}. '</th><th>'. $lex{Reason}. "</th>\n";
    for ($i = 0;$i<=120;$i++) {
	my $student = "studn$i";
	if ($arr{$student}) {
	    my $studnum = substr $arr{$student},0,5;
	    my $reason = substr $arr{$student},5,1;
	    $reason--;  # now used as offset to attend array
	    my $subject = substr $arr{$student},6,2;
	    my $period = substr $arr{$student},8,1;

	    # Get Student Information
	    $sth = $dbh->prepare("select lastname, firstname from studentall
               where studnum = '$studnum'");
	    $sth->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	    $rows = $sth->rows;
	    if ($rows != 1) {
		# No student alias/number for this....
		$studname = "<font color=\"red\">". $lex{'No Student(s) Found'}. "</font>";
	    } else { # we have a student
		my ($lastname, $firstname) = $sth->fetchrow;
		$studname ="$firstname $lastname ($studnum)";
	    }

	    my $subjsec;
	    # Now Check the Subject... remember using a subject alias...
	    $sth = $dbh->prepare("select description, subjsec from subject 
               where alias = '$subject'");
	    $sth->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	    $subrows = $sth->rows;
    	    if ($subrows < 1) {
		# No subject alias for this....
		$subname = "<font color=\"red\">". $lex{'No Subject'}. "</font>\n";
	    } else { # we have a student
		($subname, $subjsec) = $sth->fetchrow;
	    }
	    
	    print "<tr><td>$studname</td><td>$subname</td>";
            print "<td>$period</td><td>$attend[$reason]</td></tr>\n";
            print "<input type=\"hidden\" ";
	    print "name=\"$studnum:$period:$subjsec:$attend[$reason]:\"";
	    print "value=\"1\">\n";
	} # If we have an entered student.
    } # For Loop (30)

} # End of SN9 Method


# ------- Snap Method --------
if ($arr{method} eq 'snap') {
    for ($i = 0;$i<=30;$i++) {
	$studnum = "stud$i";
	$reasnum = "reas$i";

	if ($arr{$studnum}) { # We have a student entry
	    # Get Student Information
	    $sth = $dbh->prepare("select lastname, firstname, studnum from studentall
               where studnum = '$arr{$studnum}'");
	    $sth->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	    my ($lastname, $firstname, $studnum) = $sth->fetchrow;
	    $studname ="$firstname $lastname ($studnum)";

	    # Next lookup periods.
	    for (1..$maxppd){
		my $key = "$i:$_";
		if ($arr{$key}){
		    print "<tr><td>$studname</td><td>$arr{$reasnum}</td><td>$_</td></tr>\n";
		    print "<input type=\"hidden\" name=\"$studnum:$_:\:$arr{$reasnum}:\" value=\"1\">\n";
		}
            }

	} # End of If for Student Entry
    } # End of Counted Loop (30)
} # end of SNAP method


# === SA4 Method ===========
if ($arr{method} eq 'sa4') {
    for ($i = 0;$i<=30;$i++) {
	my $student = "studa$i";
	if ( $arr{$student} ) {
	    $alias = substr $arr{$student},0,3;
	    $period = substr $arr{$student},3,1;

	    # Get Student Information
	    $sth = $dbh->prepare("select lastname, firstname, studnum from student 
             where alias = ?");
	    $sth->execute( $alias );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    my $rows = $sth->rows;
	    if ( $rows < 1) { # no student
		$studname = "<font color=\"red\">". $lex{'No Student(s) Found'}. "</font>";
		print "<tr><td>$studname</td><td>$period</td></tr>\n";
	    } else { # we have a student
		my ($lastname, $firstname, $studnum) = $sth->fetchrow;
		$studname ="$firstname $lastname ($studnum)";
		print "<tr><td>$studname</td><td>$period</td></tr>\n";
		print "<input type=\"hidden\" name=\"$studnum:$period:\::\" value=\"1\">\n";
	    } # If we have an entered student.
	}
    } # For Loop (30)
} # SA4 Method End


# === SA5 Method ===========
if ($arr{method} eq 'sa5') {
    print '<tr><th>'. $lex{Student}. '</th><th>';
    print $lex{Per}. '</th><th>'. $lex{Reason}. "</th>\n";

    for ($i = 0;$i<=30;$i++) {
	my $student = "studa$i";
	if ($arr{$student}) {
	    $alias = substr $arr{$student},0,3;
	    $reason = substr $arr{$student},3,1;
	    $reason--;  # now used as offset to attend array
	    $period = substr $arr{$student},4,1;

	    # Get Student Information
	    $sth = $dbh->prepare("select lastname, firstname, studnum from student
              where alias = '$alias'");
	    $sth->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die;}
	    $rows = $sth->rows;
	    if ($rows != 1) { # No student alias for this....
		$studname = "<font color=\"red\">". $lex{'No Student(s) Found'}. "</font>";
		print "<tr><td>$studname</td><td>$reason</td><td>$period</td></tr>\n";
	    } else { # we have a student
		my ($lastname, $firstname, $studnum) = $sth->fetchrow;
		$studname ="$firstname $lastname ($studnum)";
		print "<tr><td>$studname</td><td>$attend[$reason]</td><td>$period</td></tr>\n";
		print "<input type=\"hidden\" name=\"$studnum:$period:\:$attend[$reason]:\" value=\"1\">\n";
	    }
	} # If we have an entered student.
    } # For Loop (30)
} # SA5 Method End



# ======= SA6 Method ======
if ($arr{method} eq 'sa6') {
    for ($i = 0;$i<=30;$i++) {
	my $student = "studa$i";
	if ($arr{$student}) {
	    my $alias = substr $arr{$student},0,3;
	    my $subject = substr $arr{$student},3,2;
	    my $period = substr $arr{$student},5,1;

	    # Get Student Information
	    my ($lastname, $firstname, $studnum);

	    $sth = $dbh->prepare("select lastname, firstname, studnum from student where alias = '$alias'");
	    $sth->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	    $rows = $sth->rows;
	    if ($rows != 1) {
		$studname = "<font color=\"red\">". $lex{'No Student(s) Found'}. "</font>";
		print "<tr><td>$studname</td><td>$period</td></tr>\n";
	    } else { # we have a student
		($lastname, $firstname, $studnum) = $sth->fetchrow;
		$studname ="$firstname $lastname ($studnum)";
	    }
	    # Now Check the Subject
	    $sth = $dbh->prepare("select description, subjsec from subject where alias = '$subject'");
	    $sth->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	    $subrows = $sth->rows;
    	    if ($subrows < 1) {
		# No subject alias for this....
		$subname = "<font color=\"red\">". $lex{'No Subject'}. "</font>\n";
	    } else { # we have a student
		($desc, $subjsec) = $sth->fetchrow;
		$subname = $desc;
	    }

	    print "<tr><td>$studname</td><td>$subname</td><td>$period</td></tr>\n";
            print "<input type=\"hidden\" name=\"$studnum:$period:$subjsec:\:\" value=\"1\">\n";
	    
	} # If we have an entered student.
    } # For Loop (30)

} # End of SA6 Method

print "</table><input type=\"submit\" value=\"". $lex{'Save Attendance Records'}. "\">\n";
print "</form></center></body></html>\n";

