#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Passed values will be method - snap,sa4,sa6; date, and then all the 
# "studnum:periods:subjsec:reason:late" with value of 1  

my %lex = ( 'Attendance Entry' => 'Attendance Entry',
	    'Your records are now stored' => 'Your records are now stored',
	    'Attendance' => 'Attendance',
	    'There was an error storing your data' => 'There was an error storing your data',
	    'Please contact your network administrator at' => 
	      'Please contact your network administrator at',
	    'Missing Student Number' => 'Missing Student Number',
	    'Reason or Date in Record' => 'Reason or Date in Record',
	    'Student Number' => 'Student Number',
	    'Reason' => 'Reason',
	    'Date' => 'Date',
	    'Skipping' => 'Skipping',
	    'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

$q = new CGI;
print $q->header( -charset, $charset ); 
%arr = $q->Vars;

# clean up date...
my $date = $arr{date};
delete $arr{date};


print "$doctype\n<html><head><title>". $lex{'Attendance Entry'}. "</title>
 <link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
 $chartype\n</head><body><center>\n";

$dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

foreach my $key ( keys %arr ) {
    #print "K: $key  V: $arr{$key}<br>\n";

    my ($studnum,$period,$subject,$reason,$late) = split /:/,$key;
    if ( not $studnum or not $reason or not $date ) {
	print $lex{'Missing Student Number'}. ', '. $lex{'Reason or Date in Record'}. "<br>\n";
	print $lex{'Student Number'}. ":<b>$studnum</b> ". $lex{'Reason'};
	print ":<b>$reason</b> ". $lex{'Date'}. ":<b>$date</b><br>\n";
	print $lex{'Skipping'}. "<br>\n";
	next; # skip
    }

    $sth = $dbh->prepare("insert into attend values (
       $sql{default},? ,? ,?, ? ,?, ?)");
    $sth->execute( $studnum, $date, $reason, $period, $subject, $late );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

} # End of ForEach loop


if ( not $DBI::errstr ) {
    print '<h3>'. $lex{'Your records are now stored'}. ".</h3>\n";

} else {
    print '<h3>'. $lex{'There was an error storing your data'}. ".\n";
    print $lex{'Please contact your network administrator at'};
    print " [ <a href=\"mailto:$adminemail\">$adminemail</a> ].";
    print "<br>$DBI::errstr</h3>\n";
}

print "<p>[ <a href=\"$attpage\">". $lex{Attendance}. "</a> ] \n";
print "</p></center></body></html>\n";

