#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

# This is the MD (Multi-Day) version of the attentry2.pl script
# It will accept attendance records for multiple days tacked on to the
# end of the exising record submission format from attentry1.pl.
# A colon: delimited record.

# Passed values will be "date" and then all the 
# "studnum:periods:subjsec:reason:late" with value of 1
# Note: this will now be  "studnum:period:subjsec:reason:late:date".  

my %lex = ( 'Multi-Day Attendance Entry' => 'Multi-Day Attendance Entry',
	    'Attendance' => 'Attendance',
	    'Your records are now stored' => 'Your records are now stored',
	    'There was an error storing your data' => 'There was an error storing your data',
	    'Please contact your network administrator at' => 
	      'Please contact your network administrator at',
	    'Please record the following error' => 'Please record the following error',
	    'Error' => 'Error',

	    );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

foreach my $key ( keys %arr) {
    my ( $studnum,$date,$period ) = split /:/,$key;
    $sth = $dbh->prepare("insert into attend ( studentid, absdate, reason, period )
      values ( ?, ?, ?, ? )");
    $sth->execute( $studnum, $date, $arr{$key}, $period);

} # End of ForEach loop

print "$doctype\n<html><head><title>";
print $lex{'Multi-Day Attendance Entry'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body><center>\n";

print '<h3>';
if (not $DBI::errstr ) {
    print $lex{'Your records are now stored'}. ".</h3></p>";
} else {
    print $lex{'There was an error storing your data'}. "\n";
    print $lex{'Please contact your network administrator at'};
    print " <a href=\"mailto:$adminemail\">$adminemail</a>\n ";
    print $lex{'Please record the following error'};
    print $DBI::errstr;
}
print "</h3>\n";

print "<p>[ <a href=\"$attpage\">". $lex{Attendance}. "</a> ] \n";
print "</p></center></body></html>\n";
