#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

use DBI;
use CGI;

my %lex = ('Power Delete Attendance' => 'Power Delete Attendance',
	   'Name' => 'Name',
	   'Subject' => 'Subject',
	   'Period' => 'Period',
	   'Reason' => 'Reason',
	   'Date' => 'Date',
	   'Delete' => 'Delete',
	   'Selected Records' => 'Selected Records',
	   'There will be no confirmation of deletion.' => 
	     'There will be no confirmation of deletion.',
	   'Record(s) Deleted' => 'Record(s) Deleted',
	   'There was an error deleting your data' => 'There was an error deleting your data',
	   'Attendance' => 'Attendance',
	   'Records' => 'Records',
	   'Error' => 'Error',
	   'Main' => 'Main',
	   'Attendance' => 'Attendance',
	   'Red = Withdrawn' => 'Red = Withdrawn',
	   'Not Found' => 'Not Found',



	    );


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

# Get Date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";
my $currdate1 = "@month[$month] $day, $year";


$dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


# Print Page Head
print "$doctype\n<html><head><title>". $lex{'Power Delete Attendance'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$attpage\">". $lex{Attendance}. "</a> ]\n";

if (not $arr{date}){
    $date = $currdate;
} elsif (not ($arr{date} =~ m/[-]/)){ #We have a date, check for "-" presence
    $day = substr($arr{date},4,2);
    $month = substr($arr{date},2,2);
    $year = "20".substr($arr{date},0,2);
    $date = "$year-$month-$day";  # Date to reset
} else {
    $date = $arr{date};
}

print "<center><h1>". $lex{'Power Delete Attendance'}. "</h1>Date: <b>$date</b>\n";


if ( $arr{deleteflag} ) {
    delete $arr{deleteflag};
    deleteRecord();
}

# Setup Form
print "<form action=\"attpwrdel.pl\" method=\"post\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<input type=\"hidden\" name=\"deleteflag\" value=\"1\">\n";


$sth = $dbh->prepare("select * from attend 
  where absdate = ? order by studentid, period");
$sth->execute( $date );
if ($DBI::errstr){ print $DBI::errstr; die;}
$rows = $sth->rows;

print "<caption>". $lex{Records}. ": <b>$rows</b>&nbsp;&nbsp;<font color=\"red\">";
print $lex{'Red = Withdrawn'}. "</font></caption>\n";

print "<tr><th>". $lex{Name}. "</th><th>". $lex{Subject}. "</th><th>";
print  $lex{Period}. "</th><th>". $lex{Reason}. "</th>\n<th>";
print  $lex{Date}. "</th><th>". $lex{Delete}. "</th></tr>\n";

my $sth1 = $dbh->prepare("select lastname,firstname from student where studnum = ?");

$currstud = -1;

for ( 1..$rows ) {
    my ($attid, $studnum, $absdate, $reason, $period, $subjsec,$late) = $sth->fetchrow;
    my ($lastname, $firstname, $name); # setup these vars...

    # Get the Name from Student
    $sth1->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die;}
    my ( $lastname, $firstname ) = $sth1->fetchrow;

    if ( not $lastname ){
	my $sth2 = $dbh->prepare("select lastname,firstname from studentall
         where studnum = ?");
	$sth2->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	( $lastname, $firstname ) = $sth2->fetchrow;
	if ( not $lastname ) { $lastname = $lex{'Not Found'}; }
	$name = "<font color=\"red\"><b>$lastname</b>, $firstname</font>";
    } else {
	$name = "<b>$lastname</b>, $firstname";
    }
    

    $oldstud = $currstud; 
    $currstud = $studnum;
    if ($currstud != $oldstud){ # reset color
	if ($color eq 'blue'){ $color = 'gray';	} else { $color = 'blue';} 
    }
    print "<tr class=\"$color\"><td>$name ($studnum)</td>\n";
    print "<td>$subjsec</td><td>$period</td><td>$reason</td>\n";
    print "<td>$absdate</td><td><input type=\"checkbox\" name=\"$attid\" value=\"1\">";
    print "</td></tr>\n";
}

print "</table>\n";
print "<input type=\"submit\" value=\"". $lex{Delete}. ' ';
print $lex{'Selected Records'}. "\"></form>\n";

print "<div style=\"color:red;\">";
print $lex{'There will be no confirmation of deletion.'}. "</div>\n";
print "</center></body></html>\n";


#---------------
sub deleteRecord {
#---------------

    foreach my $key ( keys %arr ) { 

	#print "Key: $key  Value: $arr{$key}<br>\n" ;
	$sth = $dbh->prepare("delete from attend where attid = ?");
	$sth->execute( $key );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

    }

    if ( not $DBI::errstr ) {
	print "<h3>". $lex{'Record(s) Deleted'}."</h3>";
    } else {
	print "<h3>". $lex{'There was an error deleting your data'};
	print $DBI::errstr, "</h3>\n";
    }

    print "<p>[ <a href=\"$attpage\">". $lex{Attendance}. "</a> ]</p>\n";
    print "</body></html>\n";

    exit;

}
