#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Reset Attendance Reasons' => 'Reset Attendance Reasons',
	   'Main' => 'Main',
	   'Attendance' => 'Attendance',
	   'Reset Date' => 'Reset Date',
	   'Name' => 'Name',
	   'Reason' => 'Reason',
	   'Period' => 'Period',
	   'Date' => 'Date',
	   'Continue' => 'Continue',
	   'Record(s) Updated' => 'Record(s) updated',
	   'Attendance' => 'Attendance',
	   'Records' => 'Records',
	   'Red = Withdrawn' => 'Red = Withdrawn',
	   'Error' => 'Error',
	   'Record the following error' => 'Record the following error',

	   );

my $self = 'attrsnreset.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

# Get Date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";
my $currdate1 = "@month[$month] $day, $year";

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $date;
if ( not $arr{date} ) {
    $date = $currdate;
} else {
    $date = $arr{date};
}


# Main Page Header.
print "$doctype\n<html><head><title>". $lex{'Reset Attendance Reasons'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print " <a href=\"$attpage\">". $lex{Attendance}. "</a> ]\n";

# Start of Page
print "<center><h1>". $lex{'Reset Attendance Reasons'}. "</h1>
<p><b>". $lex{'Reset Date'}. "</b> $date</p>\n";


if ( $arr{updateflag} ) {
    delete $arr{updateflag};
    updateReason();
}


# Start of form setup.
print "<form action=\"$self\" method=\"post\">
<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<input type=\"hidden\" name=\"updateflag\" value=\"1\">\n";

print "<tr><th>". $lex{Name}. "</th><th>". $lex{Reason}. "</th>\n<th>"; 
print $lex{Period}. "</th><th>". $lex{Date}. "</th></tr>\n";


my $sth = $dbh->prepare("select a.* from attend as a, studentall as s
  where s.studnum = a.studentid and a.absdate = ? order by s.lastname, s.firstname, a.period");
$sth->execute( $date );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
my $rows = $sth->rows;
print "<caption>". $lex{Records}. ": <b>$rows</b>&nbsp;&nbsp;<font color=\"red\">";
print $lex{'Red = Withdrawn'}. "</font></caption>\n";


my $sth1 = $dbh->prepare("select lastname,firstname from student
  where studnum = ?");

while ( my ($attid, $studnum, $absdate, $reason, $period, $subjsec,$late) = 
	$sth->fetchrow ) {

    my ($lastname, $firstname, $name); # setup these vars...

    # Get the Name from Student
    $sth1->execute($studnum);
    if ($DBI::errstr){ print $DBI::errstr; die;}
    ($lastname, $firstname) = $sth1->fetchrow;
    if (not $lastname){
	my $sth2 = $dbh->prepare("select lastname,firstname from studentall
         where studnum = '$studnum'");
	$sth2->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	($lastname, $firstname) = $sth2->fetchrow;
	if (not $lastname) { $lastname = 'Not Found'; }
	$name = "<font color=\"red\"><b>$lastname</b>, $firstname</font>";
    } else {
	$name = "<b>$lastname</b>, $firstname";
    }

    $oldstud = $currstud; 
    $currstud = $studnum;
    if ($currstud != $oldstud){ # reset color
	if ($color eq 'blue'){ $color = 'gray';	} else { $color = 'blue';} 
    }
    print "<tr class=\"$color\"><td>$name ($studnum)</td>\n";
    print "<td><select name=\"$attid\"><option>$reason</option>\n";

    foreach my $reason ( @attend ) {
	print "<option>$reason</option>\n";
    }
    print "</select></td><td>$period</td><td>$date</td></tr>\n\n";

}

print "</table>\n";
print "<input type=\"submit\" value=\"". $lex{Continue};
print "\"></form></center></body></html>\n";



#---------------
sub updateReason {
#---------------

    my $sth = $dbh->prepare("update attend set reason = ? where attid = ?");

    foreach my $key ( keys %arr ) { 
	#print "Key: $key  Value:$arr{$key}\n<br>" ;
	$sth->execute( $arr{$key}, $key );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    }

    if (not $DBI::errstr ) {
	print "<h3>". $lex{'Record(s) Updated'}."</h3>\n";
    } else {
	print "<h3>". $lex{'Record the following error'}. " \n";
	print $DBI::errstr, "</h3>\n";
    }

    print "<p>[ <a href=\"$attpage\">". $lex{Attendance}. "</a> ]</p></body></html>\n";

    exit;

}
