#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Attendance' => 'Attendance',
	   'No Absences found' => 'No Absences found',
	   'Student Not Found' => 'Student Not Found',
	   'View Attendance' => 'View Attendance',
	   'Name' => 'Name',
	   'Date' => 'Date',
	   'Reason' => 'Reason',
	   'Period' => 'Period',
	   'Subject' => 'Subject',
	   'Homeroom' => 'Homeroom',
	   'Phone' => 'Phone',
	   'Start Date' => 'Start Date',
	   'End Date' => 'End Date',
	   'Student' => 'Student',
	   'Home' => 'Home',
	   'Work' => 'Work',
	   'Error' => 'Error',

	   );

my $self = 'attview.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


print "$doctype\n<html><head><title>". $lex{'View Attendance'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> |
 <a href=\"$attpage\">". $lex{Attendance}. "</a> ]\n";


my $select;
my $header;
my $student;
if ($arr{startdate}) {
    $select = "and to_days(attend.absdate) >= to_days('$arr{startdate}') and ".
	"to_days(attend.absdate) <= to_days('$arr{enddate}') ";
    $header = "<em>". $lex{'Start Date'}. ":</em> $arr{startdate} <em>".
    $lex{'End Date'}. ":</em>$arr{enddate}";

} elsif ($arr{startclass}) {
    $select = "and studentall.homeroom >= '$arr{startclass}' and 
      studentall.homeroom <= '$arr{endclass}'";
    $header = "<em>Start Class:</em> $arr{startclass} <em>End Class:</em> $arr{endclass}";
} elsif ($arr{student}) {
    $student = $arr{student};

    # Setup the Search
    if ($student =~ /\d+/) {  # we have a student number
	$select = "and studentall.studnum = '$arr{student}'";
    } else { # we have words hopefully with a comma
	($lastname,$firstname)  = split /\,/, $student;
	$firstname =~ s/^\s*//;
	$lastname =~ s/^\s*//;
	if ($lastname and $firstname){ # both entered.
	    $select = "and studentall.lastname = '$lastname' ".
		"and studentall.firstname = '$firstname'";
	} elsif ($lastname and not $firstname){ # only lastname (no comma)
	    if (length($lastname) == 2){ # search by initials: fi, li.
		$fi = substr($lastname,0,1); $li = substr($lastname,1,1);
		$select = "and studentall.lastname like '$li%' ". 
		    "and studentall.firstname like '$fi%'";
	    } else {
		$select = "and studentall.lastname = '$lastname'";
	    }
	} else { # print an error....
	    #&mkSearchError;
	    print '<b>'. $lex{'Student Not Found'}. ".</b>\n";
	    print "</body></html>\n";
	    die; 
	}

    } # Last Else

    # Find their name...
    $sth = $dbh->prepare("select lastname, firstname from studentall
      where studnum = ?");
    $sth->execute( $arr{student} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow;
    $header = "<em>". $lex{Student}. ": <b>$firstname $lastname</b> ($arr{student})</em>\n";
}



my $orderby = "studentall.lastname, studentall.firstname, attend.absdate desc, attend.period";
if ($arr{startdate}){ # If sorting by date, alter sort order.
    $orderby = "attend.absdate desc, studentall.lastname, studentall.firstname, attend.period";
}

my @fields = "attend.attid, attend.studentid, attend.absdate, attend.reason, attend.period, 
 attend.subjsec, attend.late";
my $sth = $dbh->prepare("select @fields from attend, studentall
 where attend.studentid = studentall.studnum $select order by $orderby");

# , studentall 
# where attend.studentid = studentall.studnum $select 
# order by $orderby");

$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

$rows = $sth->rows;
#print "Rows: $rows";

if ($rows < 1){
    print "<h1>$header</h1>\n";
    print '<b>'. $lex{'No Absences found'}. ".</b></body></html>\n";
    die;
}

print '<center><h1>'. $lex{'View Attendance'}. "</h1>\n";
print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<caption>$header</caption>\n";
print '<tr><th>'. $lex{Name}. '</th><th>'. $lex{Date}. '</th><th>';
print $lex{Reason}. "</th>\n<th>". $lex{Period}. '</th><th>';
print $lex{Subject}. q{/}. $lex{Homeroom}. '</th><th>'. $lex{Phone}. "</th></tr>\n";

while ( my ( $attid, $studnum, $absdate, $reason, $period, $subjsec, $late) = 
	$sth->fetchrow ) {

    # Get Student Information
    my $sth1 = $dbh->prepare("select lastname, firstname, grade, homeroom, hphone1, 
     wphone1, hphone2, wphone2 from studentall where studnum = ? ");
    $sth1->execute( $studnum );
    if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr;}

    my ($lastname,$firstname, $grade, $homeroom, $hphone1, $wphone1, 
	$hphone2, $wphone2) = $sth1->fetchrow;
    
    # Get Subject/Teacher Information
    my $subject_or_homeroom;
    if ($subjsec){
	$sth1 = $dbh->prepare("select description, teacher from subject 
         where subjsec = ?");
	$sth1->execute( $subjsec );
	if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr;}
	my ($desc, $teacher) = $sth1->fetchrow;
	$subject_or_homeroom = "$desc - $teacher";
    } elsif ($homeroom) {
	$sth1 = $dbh->prepare("select lastname, firstname from staff where homeroom = ?");
	$sth1->execute( $homeroom );
	if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr;}
	my ($lname, $fname) = $sth1->fetchrow;
	$subject_or_homeroom = "$homeroom ($fname $lname)";
    }

    print "<tr><td><a href=\"$self?student=$studnum\"><b>$lastname</b>, $firstname</a></td>\n";
    print "<td>$absdate</td><td>$reason</td><td>$period</td>\n";

    # Print either subject (if given) or homeroom (if found)
    print "<td>$subject_or_homeroom</td>\n";

    print "<td>". $lex{Home}. " 1: $hphone1 ". $lex{Work}. " 2: $wphone1<br>\n";
    print $lex{Home}. " 2: $hphone2 ". $lex{Work}. " 2: $wphone2</td></tr>\n";

}

print "</table></center></body></html>\n";
