#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Teacher Attendance Check' => 'Teacher Attendance Check',
	   'Main' => 'Main',
	   'Attendance' => 'Attendance',
	   'Not Found' => 'Not Found',
	   'Date' => 'Date',
	   'Name' => 'Name',
	   'Date/Time' => 'Date/Time',
	   'Error' => 'Error',
	   'Zero times represent entries from other days' => 
	     'Zero times represent entries from other days',

	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $currdate;
if (not $arr{date}) {
  my @tim = localtime(time);
  my $year = @tim[5] + 1900;
  my $month = @tim[4] + 1;
  my $day = @tim[3];
  $currdate = "$year-$month-$day";
} else {
    $currdate = $arr{date};
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select lastname, firstname, userid from staff
  where doatt = 'Y' order by lastname, firstname");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my $records = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'Teacher Attendance Check'}. "</title>
 <link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
 $chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> | 
 <a href=\"$attpage\">". $lex{Attendance}. "</a> ]
 <center><h1>". $lex{'Teacher Attendance Check'}. "</h1>\n";


print "<div style=\"padding:0.5em;\">". $lex{Date}. ":</b> $currdate<br>";
print $lex{'Zero times represent entries from other days'}. "</div>\n";

print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">
 <tr><th>", $lex{Name}. '</th><th>'. $lex{'Date/Time'}. "</th></tr>\n";

for (1..$records) {  # Do one teacher after the other...
    my ($lastname, $firstname, $userid) = $sth->fetchrow;
    $sth1 = $dbh->prepare("select * from tattend 
     where techid = ? and to_days(date) = to_days('$currdate')");
    $sth1->execute( $userid ) ;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
    my $rows = $sth1->rows;
    if ($rows < 1) {
	print "<tr><td><b>$firstname $lastname</b></td>";
	print '<td>',$lex{'Not Found'}. "</td></tr>\n";
    } else {
	for (1..$rows) {
	    my ($id, $userid, $tdate) = $sth1->fetchrow;
	    print "<tr><td><b>$firstname $lastname</b></td>";
	    print "<td>$tdate</td></tr>\n";
	}
    }
    print "<tr><td colspan=\"2\" style=\"background:#BBB;height:5px;\">";
    print "</td></tr>\n";
}
print "</table></body></html>\n";
