#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Check Student Attendance' => 'Check Student Attendance',
	   'Main' => 'Main',
	   'Attendance' => 'Attendance',
	   'Attendance Check' => 'Attendance Check',
	   'Name' => 'Name',
	   'Days' => 'Days',
	   'HRoom' => 'HRoom',
	   'Grade' => 'Grade',
	   'Start' => 'Start',
	   'End' => 'End',
	   'Periods Per Day or Grade not correctly set for' => 
	     'Periods Per Day or Grade not correctly set for',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

# This script looks for student attendance records with a reason field 
# containing "Absent Unexcused". If you change the reason types, this 
# script won't work. Change the value of the variable below.

my $absreason = $absentUnexcused; # comes from admin.conf

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my ( $sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

# Passed in days to start flagging at
my $days = $arr{days};

my ($sy,$sm,$sd) = split /-/, $arr{startdate};
my $startdate = $month[$sm]. " $sd, $sy";
my ($ey,$em,$ed) = split /-/, $arr{enddate};
my $enddate = $month[$em]. " $ed, $ey";


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $select;
if ( $arr{startdate} ) {
    $select = "and to_days(attend.absdate) >= to_days('$arr{startdate}')".
	" and to_days(attend.absdate) <= to_days('$arr{enddate}')";
}

my $sth = $dbh->prepare("select student.studnum, count(*) as missed, 
 student.firstname, student.lastname, student.homeroom, 
 student.grade from attend, student 
 where attend.studentid = student.studnum and 
 attend.reason = '$absreason' $select group by attend.studentid
 order by missed desc, student.lastname, student.firstname");

$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'Check Student Attendance'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$attpage\">". $lex{Attendance}. "</a> ]\n";

print "<center><h1>$schoolname ". $lex{'Attendance Check'}. "</h1><h3>$currdate</h3>\n";
print '<b>'. $lex{Start}. ":</b> $startdate <b>". $lex{End}. ":</b> $enddate\n";
print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print '<tr><th>'. $lex{Name}. '</th><th>'. $lex{Days}. '</th><th>'. $lex{HRoom};
print '</th><th>'. $lex{Grade}. "</th></tr>\n";

while ( my ( $studnum, $count, $firstname, $lastname, $homeroom, $grade ) = 
	$sth->fetchrow ) {

    my $ppd = $g_ppd{ $grade };
    if ( not $ppd ) {
	my $sth1 = $dbh->prepare("select studid from student where studnum = ?");
	$sth1->execute( $studnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $id = $sth1->fetchrow;
	
	print "<p><b>". $lex{'Periods Per Day or Grade not correctly set for'};
	print " <a href=\"studed.pl?recnum=$id\">$firstname $lastname</a> ";
	print $lex{Grade}. " $grade.</b></p></body></html>\n";
	die;
    }
    my $absent = $count / $ppd;
    if ( $absent >= $days ) {
	print "<tr><td><b>$lastname</b>, $firstname</td><td>$absent</td>";
	print "<td>$homeroom</td><td>$grade</td></tr>\n";
    }
}

print "</table></center></body></html>\n";
