#! /usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

use DBI;
use CGI;
use Date::Business;

my %lex = ('Attendance' => 'Attendance',
	   'Perfect Attendance' => 'Perfect Attendance',
	   'Report' => 'Report',
	   'not found' => 'not found',
	   'Name' => 'Name',
	   'Student Number' => 'Student Number',
	   'Start Date' => 'Start Date',
	   'End Date' => 'End Date',
	   'Error' => 'Error',

	   );

my $self = 'rptattperf.pl';

# Get passed date for perfect attendance (inclusive)

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

# Get Date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";
my $currdate1 = "@month[$month] $day, $year";

my $q = new CGI;
my %arr = $q->Vars;
print $q->header( -charset, $charset );

my $startdate = $arr{startdate};
my $enddate = $arr{enddate};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>";
print  $lex{'Perfect Attendance'}. q{ }. $lex{Report};
print "</title>\n<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">";
print "$chartype\n</head><body>\n";
print "[ <a href=\"$attpage\">". $lex{Attendance}. "</a> ]<center>\n";

if ( not $startdate) { $startdate = $schoolstart; }
if ( not $enddate) { $enddate = $currdate; }

print '<h1>';
print $lex{'Perfect Attendance'}. q{ }. $lex{Report};
print "</h1>\n<b>". $lex{'Start Date'}. ":</b> $startdate<br><b>";
print $lex{'End Date'}. ":</b> $enddate\n";


# @ignore_reason should be defined in /etc/admin.conf to give reasons to ignore.
# It lists the attend reason indexes to ignore...
my $reason_string;
print "<p><span style=\"border:1px solid black; padding:1em;\">Reasons ignored:<b> \n";
foreach my $index (@ignore_reason) {
    print $attend[$index],', ';
    $reason_string .= "and reason != '$attend[$index]' ";
}
print "</b></span></p>\n";
# print "The reason string is: $reason_string<br>\n";



print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th>";
print $lex{Name}. ' ('. $lex{'Student Number'}. ')';
print "</th></tr>\n";


my $sth = $dbh->prepare("select lastname, firstname, studnum from student 
  order by lastname, firstname");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

my $noperfect = 1;  # flag in case no perfect attendance

while ( my ($lastname, $firstname, $studnum) = $sth->fetchrow ) {

    # Now do the query to find student numbers.
    $sth1 = $dbh->prepare("select count(*) from attend where
       studentid = ? and
       to_days(attend.absdate) >= to_days('$startdate') and 
       to_days(attend.absdate) <= to_days('$enddate')
       $reason_string");
    $sth1->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth1->fetchrow;
    if ( $count < 1) {
	$noperfect = 0;
	print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td></tr>\n";
    }
}

# In case of no perfect attendance...
if ( $noperfect ) {
    print "<tr><td><b>". $lex{'Perfect Attendance'}. q{ };
    print $lex{'not found'}. "</b></td></tr>\n";
}

print"</table><p>[ <a href=\"$attpage\">". $lex{Attendance}. "</a> ]
</body></html>\n";
