#!/usr/bin/perl
#  Copyright 2001-2009  Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# To Do: Fix use of index arrays here, use named vars instead.

my %lex = ('Attendance Phone List' => 'Attendance Phone List',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Main' => 'Main',
	   'Attendance' => 'Attendance',
	   'Name' => 'Name',
	   'HRoom' => 'HRoom',
	   'Grade' => 'Grade',
	   'Emergency' => 'Emergency',
	   'Parent 1' => 'Parent 1',
	   'Parent 2' => 'Parent 2',
	   'Hr' => 'Hr',
	   'Gr' => 'Gr',
	   'Yesterday' => 'Yesterday',
	   'Today' => 'Today',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;
use Date::Business;
use Time::JulianDay;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";
my $today = "$year-$mon-$mday";

# Figure out yesterday using Date::Business
my $btoday = new Date::Business();
$btoday->prevb();
my $yesterday = $btoday->image();
my ($y,$m,$d) = unpack("A4, A2, A2", $yesterday);
$yesterday = "$y-$m-$d";

my $q = new CGI;
my %arr = $q->Vars;
print $q->header( -charset, $charset );

#foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $absdate;
if ( $arr{qdate} eq $lex{'Yesterday'} ){
    $absdate = $yesterday;
} elsif ( $arr{qdate} eq $lex{'Today'} ) {
    $absdate = $today;
} elsif ( $arr{date} ){
    $absdate = $arr{date};
} else {
    $absdate = $today;
}

my ($y,$m,$d) = split /-/, $absdate;
my $absjd = julian_day($y,$m,$d);
my $dow = day_of_week($absjd);
my $currabsdate = "$dow[$dow], $month[$m] $d, $y";


# Create mapping hash between name and the array index variable of value.
my %m;
my $sth = $dbh->prepare("select fieldid, arrayidx from meta where tableid = 'student' 
  order by arrayidx");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
while (my ($fi,$idx) = $sth->fetchrow) {
    $m{$fi} = $idx;
}

# find students on that day.
my $sth = $dbh->prepare("select distinct a.studentid, s.lastname, s.firstname 
 from attend as a, studentall as s 
 where s.studnum = a.studentid
 and absdate = ?
 and reason $sql{like} '%$absentString%' 
 group by studentid order by s.lastname, s.firstname");

$sth->execute( $absdate );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my $studrows = $sth->rows;


print "$doctype\n<html><head><title>". $lex{'Attendance Phone List'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$attpage\">". $lex{Attendance}. "</a> ]\n";


if ( $studrows < 1) {
    print "<h1>". $lex{'No Student(s) Found'}. " - $currabsdate</h1></center>\n";
    print "</body></html>\n";
    die;
}


print "<center><h1>". $lex{'Attendance Phone List'}. "</h1><h4>$currabsdate</h4>\n";
print "<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Name}. "<br>". $lex{HRoom}. "-". $lex{Grade}. '</th><th>'. $lex{'Parent 1'};
print '</th><th>'. $lex{'Parent 2'}. '</th><th>'. $lex{Emergency}. "</th></tr>\n";


while ( my ($studnum, $lastname, $firstname) = $sth->fetchrow ) {

    my $wdflag = 0;
    my $sth = $dbh->prepare("select * from student where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    $studrow = $sth->rows;
    if ( $studrow < 1 ) {
	$sth = $dbh->prepare("select * from studentwd where studnum = ?");
	$sth->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$wdflag = 1;
    }
    my @arr = $sth->fetchrow;
    if ($wdflag) {
	$arr[1] = "<font color=\"red\">WD</font> $arr[1]";
    }

    print "<tr><td valign=\"top\"><b>$arr[1]</b>, $arr[2] $arr[3]</b><br>\n";
    print "&nbsp;&nbsp;<b>". $lex{Hr}. ":</b>$arr[6] <b>". $lex{Gr}. ":</b>$arr[5]</td>\n";

    $parent1name = $arr[29];
    $parent2name = $arr[40];
    
    print "<td valign=\"top\">";
    if ($arr[27]) { print "<b>$arr[27]</b> "; }
    print "$parent1name&nbsp;&nbsp;H:$arr[30]<br>W:$arr[31]&nbsp;C:$arr[32]</td>\n";

    print "<td valign=\"top\">";
    if ($arr[38]) { print "<b>$arr[38]</b> "; }
    print "$parent2name&nbsp;&nbsp;H:$arr[41]<br>W:$arr[42]&nbsp;C:$arr[43]</td>\n";

    print "<td valign=\"top\">";
    if ($arr[49]) { print "<b>$arr[49]</b> "; }
    print "$arr[50]&nbsp;&nbsp;H:$arr[51]<br>W:$arr[52]&nbsp;C:$arr[53]</td></tr>\n";

}

print "</table></center></body></html>\n";
