#! /usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Student Daily Attendance Report
# Get students absent on current date (or entered date)

my %lex = ('Student' => 'Student',
	   'Daily Attendance Report' => 'Daily Attendance Report',
	   'Attendance' => 'Attendance',
	   'Date format Error' => 'Date format Error',
	   'Student' => 'Student',
	   'Today' => 'Today',
	   '1 week (incl today)' => '1 week (incl today)',
	   '2 weeks (incl today)' => '2 weeks (incl today)',
	   'Discipline' => 'Discipline',
	   'Error' => 'Error',
	   'Selected' => 'Selected',

	   );


use DBI;
use CGI;
use Date::Business;

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
if (length($day) == 1){ $day = '0'.$day;}
if (length($month) == 1){ $month = '0'.$month;}
my $currdate = "$year-$month-$day";
my $currdate1 = "@month[$month] $day, $year";

my $q = new CGI;
my %arr = $q->Vars;
print $q->header( -charset, $charset );

print "$doctype\n<html><head><title>". $lex{Student};
print q{ }. $lex{'Daily Attendance Report'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$attpage\">". $lex{Attendance}. "</a> ]
<center><h1>". $lex{Student}. ' '. $lex{'Daily Attendance Report'}. "</h1>\n";

my $date = $arr{date};
if ( not $date ){ $date = $currdate;}
if ( length($date) < 6){ 
    print '<h1>'. $lex{'Date format Error'};
    print ": (yymmdd)</h1></body></html>\n";
}

print "<b>". $lex{Selected}. ": $date</b>\n";
$date =~ s/-//g; # Strip Hyphens.

# Get 5,10,20 days ago. 
# Date format: CCYYMMDD
$now = new Date::Business(DATE=>$compressdate);
$now->subb('5');
$fivedaysago = $now->image;
$now->subb('5');
$tendaysago = $now->image;
$now->subb('10');
$twentydaysago = $now->image;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Find the kids that are away today;
$sth=$dbh->prepare("select distinct attend.studentid from attend
  left outer join student on attend.studentid = student.studnum 
  where absdate = ? order by student.lastname,student.firstname");

$sth->execute( $date );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
$studary = $sth->fetchall_arrayref;

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print '<tr><th>'. $lex{Student}. '</th><th>'. $lex{Today}. "<br>($date)</th>\n";
print '<th>'. $lex{'1 week (incl today)'}. "<br>($fivedaysago)</th>\n";
print '<th>'. $lex{'2 weeks (incl today)'}. "<br>($tendaysago)</th>\n";
print '<th>'. $lex{Discipline}. "</th></tr>\n";

foreach my $rowary ( @$studary ) {

    my $studnum = $$rowary[0];

    # Get Student Name
    $sth1=$dbh->prepare("select lastname,firstname from student where studnum = ?");
    $sth1->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die;}
    my ($lastname,$firstname) = $sth1->fetchrow;

    # Get Today's Data
    $sth1=$dbh->prepare("select distinct reason, count(reason) from attend 
      where absdate = ? and studentid = ? group by reason");
    $sth1->execute( $date, $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    $reasonary = $sth1->fetchall_arrayref;
    my $currentabs = "";
    foreach my $reasonrow ( @$reasonary ) {
	$currentabs .= "<tr><td>$$reasonrow[0]</td><td>$$reasonrow[1]</td></tr>";
    }

    # Get 5 days Data
    $sth1=$dbh->prepare("select distinct reason, count(reason) from attend 
      where to_days(absdate) <= to_days('$date') and 
      to_days(absdate) >= to_days('$fivedaysago') and
      studentid = ? group by reason");
    $sth1->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    $fivereasonary = $sth1->fetchall_arrayref;
    my $fiveDayAbs = "";
    foreach $reasonrow ( @$fivereasonary ){
	$fiveDayAbs .= "<tr><td>$$reasonrow[0]</td><td>$$reasonrow[1]</td></tr>";
    }


    # Get 10 days Data
    $sth1=$dbh->prepare("select distinct reason, count(reason) from attend 
      where to_days(absdate) <= to_days($date) and 
      to_days(absdate) >= to_days($tendaysago) and
      studentid = '$studnum' group by reason");
    $sth1->execute;
    if ($DBI::errstr){ print $DBI::errstr; die;}
    $tenreasonary = $sth1->fetchall_arrayref;
    my $tenDayAbs = "";
    foreach my $reasonrow ( @$tenreasonary ) {
	$tenDayAbs .= "<tr><td>$$reasonrow[0]</td><td>$$reasonrow[1]</td></tr>";
    }

    # Get Discipline Data
    $sth1=$dbh->prepare("select date,infraction from discipline
      where userid = ? and
      infraction $sql{like} '%unexcused%' order by date desc");
    $sth1->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die;}
    $discary = $sth1->fetchall_arrayref;
    my $discTable = "";
    foreach $infract (@$discary){
	$discTable .= "<tr><td>$$infract[0]</td><td>$$infract[1]</td></tr>";
    }

    # print stuff
    print "<tr><td>$firstname $lastname ($studnum)</td><td><table>\n";
    print "$currentabs</table></td><td><table>$fiveDayAbs</table></td>\n";
    print "<td><table>$tenDayAbs</table></td><td><table>$discTable</table></td></tr>\n";
}

print "</table></body></html>\n";
