#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson
#  Updates by Kevin Waddell

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#Les: modified formatting on lines 155 and 168 

my %lex = ('Student Discipline' => 'Student Discipline',
	   'Student Search' => 'Student Search',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Discipline Entry' => 'Discipline Entry',
	   'Date' => 'Date',
	   'Student Number' => 'Student Number',
	   'Infraction' => 'Infraction',
	   'Description' => 'Description',
	   'Action Taken' => 'Action Taken',
	   'Repeated Behavior Consequence' => 'Repeated Behavior Consequence',
	   'Parental Contact' => 'Parental Contact',
	   'None' => 'None',
	   'Phoned' => 'Phoned',
	   'Letter' => 'Letter',
	   'Interview (caregiver)' => 'Interview (caregiver)',
	   'Private (to Admin)' => 'Private (to Admin)',
	   'Author' => 'Author',
	   'Save Record' => 'Save Record',
	   'Student (Last,First/Last/Initials/Studnum)' => 
	     'Student (Last,First/Last/Initials/Studnum)',
	   'Search' => 'Search',
	   'Add' => 'Add',
	   'Student' => 'Student',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Please search again' => 'Please search again',
	   'Error' => 'Error',

	  );


my $self = 'discadd0.pl';

use DBI;
use CGI;

my @time = localtime(time);
my $year = $time[5] + 1900;
my $month = $time[4] + 1;
my $currdate = "$year-$month-$time[3]";

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Start of HTML Document.
print "$doctype\n<html><head><title>". $lex{'Student Discipline'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | ";
print "<a href=\"$discpage\">". $lex{Discipline}. "</a> ]\n";

print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"submit\" value=\"". $lex{Search}. "\">\n";
print "<input type=\"text\" name=\"student\" size=\"30\">\n";
print $lex{'Student (Last,First/Last/Initials/Studnum)'}. "</form>\n";


if ( $arr{student} ) {
    selectStudent( $arr{student} );
    die;
}

if ( not $arr{studnum} ) {
    print "<h1>". $lex{'No Student(s) Found'}. ".  ". $lex{'Please search again'}. ".</h1>\n";
    die;
}


# Get student name.
my $sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
$sth->execute( $arr{studnum} );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my ($lastname, $firstname) = $sth->fetchrow;


# Stuff Infractions into an array.
my @infarray;
my $sth = $dbh->prepare("select name from infraction order by name");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while (my $name = $sth->fetchrow ) {
   push @infarray, $name;
}


# Load Teachers Into Array
my %teacher;
$sth = $dbh->prepare("select lastname, firstname, userid from staff
  order by lastname,firstname");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die;}
while (my ($lastname, $firstname, $userid) = $sth->fetchrow ){
    $teacher{$userid} = "$lastname, $firstname ($userid)";
}


print "<h1>". $lex{'Discipline Entry'}. "</h1>\n";

print "<form action=\"discadd1.pl\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"studnum\" value=\"$arr{studnum}\">\n";
print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"0\">\n";
print "<tr><td></td><td><input type=\"submit\" value=\"". $lex{'Save Record'}. "\"></td></tr>\n";
print "<tr><td align=\"right\"><b>". $lex{Date}. "</b></td>
<td><input type=\"text\" name=\"date\" size=\"12\" value=\"$currdate\"></td>
</tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Student Number'}. "</b></td>
<td>$arr{studnum}</td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Student}. "</td>\n";
print "<td>$firstname $lastname</td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Infraction};
print "</b></td><td><select name=\"mistake\">\n";

foreach my $inf ( @infarray ) {
    print "<option>$inf</option>\n";
}

print "</select></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Description}. "</b></td>
<td><textarea name=\"description\" cols=\"60\" rows=\"6\"></textarea></td>
</tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Action Taken'}. "</b></td>
<td><textarea name=\"action\" cols=\"60\" rows=\"4\"></textarea></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Repeated Behavior Consequence'}. "</b></td>
<td><textarea name=\"ifrepeat\" rows=\"4\" cols=\"60\"></textarea></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Parental Contact'}. "</b></td>\n<td>";
print $lex{None}. " <input type=\"radio\" name=\"parent\" value=\"none\" checked>&nbsp;&nbsp;\n";
print $lex{Phoned}. " <input type=\"radio\" name=\"parent\" value=\"phoned\">&nbsp;&nbsp;\n";
print $lex{Letter}. " <input type=\"radio\" name=\"parent\" value=\"letter\">&nbsp;&nbsp;\n";
print $lex{'Interview (caregiver)'}. " <input type=\"radio\" name=\"parent\" value=\"interview\">";
print "</td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Private (to Admin)'}. "</b></td>\n";
print "<td><input type=\"checkbox\" name=\"private\" value=\"Y\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Author'};
print "</b></td><td><select name=\"author\">\n";

foreach my $val (sort values %teacher) {
  print "<option>$val</option>\n";
}

print "</select></td></tr>\n";
print "<tr><td></td><td><input type=\"submit\" value=\"". $lex{'Save Record'}. "\"></td></tr>\n";
print "</table></form></body></html>\n";


#----------------
sub selectStudent {
#----------------

    my $student = shift;

    print "<center><h1>". $lex{'Discipline Entry'}. "</h1>\n";

    # Setup the Search
    if ($student =~ /\d+/) {  # we have a student number
	$sth = $dbh->prepare("select lastname, firstname, studnum from studentall where studnum = ?");
	$sth->execute( $student );

    } else { # we have words hopefully with a comma
	($lastname,$firstname)  = split /\,/, $student;
	$firstname =~ s/^\s*//;
	$lastname =~ s/^\s*//;
	if ($lastname and $firstname){ # both entered.
	    $sth = $dbh->prepare("select  lastname, firstname, studnum from studentall 
             where lastname = ? and firstname = ?");
	    $sth->execute( $lastname, $firstname );

	} elsif ($lastname and not $firstname){ # only lastname (no comma)
	    if (length($lastname) == 2){ # search by initials: fi, li.
		my $fi = substr($lastname,0,1). '%'; 
		my $li = substr($lastname,1,1). '%';
		$sth = $dbh->prepare("select lastname, firstname, studnum from studentall 
                 where lastname $sql{like} ? and firstname $sql{like} ?");
		$sth->execute( $li, $fi );

	    } else {
		$sth = $dbh->prepare("select lastname, firstname, studnum from studentall 
                  where lastname = ? order by firstname");
		$sth->execute( $lastname );
	    }
	} else { # print an error....
	    showSearchForm();
	    print "</body></html>\n";
	    die;
	}

    } # Last Else
    # We should now have a $sth defined.

    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;

    if ($rows < 1) { 
	print "<h1>". $lex{'No Student(s) Found'}. ".  ". $lex{'Please search again'}. ".</h1>\n";
	showSearchForm();
	print "</body></html>\n"; 
	die; 
    }
 

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>Student</th><th></th></tr>\n";


    for (1..$rows){
	my ($lastname, $firstname, $studnum) = $sth->fetchrow;
	print "<tr><td>$firstname $lastname ($studnum)</td><td>\n";
	print "<form action=\"$self\" method=\"post\"><input type=\"submit\" value=\"". $lex{Add}. "\">\n";
	print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\"></form></td></tr>\n";

    }

    print "</table>\n";
    
    showSearchForm();
    print "</center></body></html>\n";


}



#----------------
sub showSearchForm {
#----------------

    print "<div style=\"padding:1em 0.2em;\">\n";
    print "<b>". $lex{'Student Search'}. "</b><br>\n";

    print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"submit\" value=\"". $lex{Search}. "\">\n";
    print "<input type=\"text\" name=\"student\" size=\"30\"><br>\n";
    print $lex{'Student (Last,First/Last/Initials/Studnum)'}. "\n";
    print "</form></div>\n";

}

