#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson
#  Update by Kevin Waddell

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Discipline' => 'Discipline',
	   'Delete Discipline Records' => 'Delete Discipline Records',
	   'Student' => 'Student',
	   'Recs' => 'Recs',
	   'First' => 'First',
	   'Last' => 'Last',
	   'Delete' => 'Delete',
	   'Main' => 'Main',
	   'Withdrawn' => 'Withdrawn',
	   'Not Found' => 'Not Found',
	   'Error' => 'Error',

	  );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = CGI->new;
print $q->header( -charset, $charset ); 


my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
    $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# put student id's into array.
my @studarray;
$sth = $dbh->prepare("select distinct userid from discipline");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
$studrows = $sth->rows;
for ( 1..$studrows ) {
    my $studnum = $sth->fetchrow;
    push @studarray,$studnum;
}

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Delete Discipline Records'};
print q{ - }.  $lex{Student}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$discpage\">". $lex{Discipline}. "</a> ]\n";

print "<center><h1>". $lex{'Delete Discipline Records'}. q{ - }.  $lex{Student};
print "</h1><h3>$currdate</h3>\n";

print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";

print "<form action=\"discbulkdel1.pl\" method=\"post\">\n";
print "<tr><th>". $lex{Student}. "</th><th>". $lex{Recs}. "</th>\n";
print "<th>". $lex{First}. "</th><th>". $lex{Last}. "</th>\n";
print "<th>". $lex{Delete}. "</th></tr>\n";
print "<tr><td colspan=\"5\" align=\"center\">\n";
print "<input type=\"submit\" value=\"";
print $lex{'Delete Discipline Records'}. q{ - }. $lex{Student};
print "\"></td></tr>\n";


foreach my $studnum ( @studarray ) {

    # Find Student Name, first in student, then in studentwd 
    $sth1 = $dbh->prepare("select lastname,firstname from student where studnum = ?");
    $sth1->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    $studrows = $sth1->rows;
    my $wdflag;
    if ( $studrows < 1 ) {
	$sth1 = $dbh->prepare("select lastname,firstname from studentwd where studnum = ?");
	$sth1->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

	$wdflag= "<font color=red>". $lex{Withdrawn}. "</font>";
    }

    my ($lastname,$firstname) = $sth1->fetchrow;
    if ( not $lastname ) { $lastname = $lex{'Not Found'}; }
    
    # Count the number of records.
    $sth1 = $dbh->prepare("select count(date) from discipline where userid = ?");
    $sth1->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $disccount = $sth1->fetchrow;


    # Select Earliest Record
    $sth1 = $dbh->prepare("select min(date) from discipline where userid = ?");
    $sth1->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $discmin = $sth1->fetchrow;


    # Select Latest Record
    $sth1 = $dbh->prepare("select max(date) from discipline where userid = ?");
    $sth1->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $discmax = $sth1->fetchrow;


    print "<tr><td><i>$wdflag $lastname</i>, $firstname ($studnum)</td>\n";
    print "<td>$disccount</td><td>$discmin</td><td>$discmax</td>\n";
    print "<td align=\"center\">";
    print "<input type=\"checkbox\" name=\"$studnum\" value=\"1\"></td></tr>\n";

}

print "<tr><td colspan=\"5\" align=\"center\">\n";
print "<input type=\"submit\" value=\"";
print $lex{'Delete Discipline Records'}. q{ - }. $lex{Student}. "\"></td></tr>\n";
print "</table></center></body></html>\n";
