#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson
#  Update by Kevin Waddell

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Discipline Record Deletion by Date' => 'Discipline Record Deletion by Date',
	   'Delete all discipline records before' => 'Delete all discipline records before',
	   'Delete the Record(s)' => 'Delete the Record(s)',
	   'No, Go back to Discipline Page' => 'No, Go back to Discipline Page',
	   'Please enter a date' => 'Please enter a date',
	   'Record Deletion Failed. Please contact' => 'Record Deletion Failed. Please contact',
	   'Student Discipline Records deleted from before' => 
	     'Student Discipline Records deleted from before',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Error' => 'Error',
	   'Yes' => 'Yes',

	   );

my $self = 'discdatedel.pl';

use CGI;
use DBI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


# Page Header.
print "$doctype\n<html><head><title>". $lex{'Discipline Record Deletion by Date'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\"> 
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | ";
print "<a href=\"$discpage\">". $lex{Discipline}. "</a> ]<center>\n";

if ( $arr{page} == 1 ) {
    delete $arr{page};
    deleteRecords();
}

if ( not $arr{date} ){ 
    print "<h1>". $lex{'Please enter a date'}. "</h1>\n";
    print "</center></body></html>\n";
    die;
}

my ( $year, $month, $day, $date);
if ( length( $arr{date} ) == 6 ) { # older yymmdd format
    #split date into year, month, day
    $year = substr( $arr{date},0,2);
    $year = "20".$year;
    $month = substr( $arr{date},2,2);
    $day = substr( $arr{date},4,2);
    $date = "$year-$month-$day";
} else {
    ($year, $month, $day ) = split /-/, $arr{date};
    $date = $arr{date};
}

my $displaydate = "$month[$month] $day, $year";


print "<h1>". $lex{'Delete all discipline records before'}. "<br>$displaydate?</h1>\n";
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"deletedate\" value=\"$date\">\n";
print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
print "<input type=\"submit\" value=\"". $lex{Yes}. q{, }. $lex{'Delete the Record(s)'}. "\">\n";
print "</form>\n";

print "<p><a href=\"$discpage\" class=\"button\">";
print $lex{'No, Go back to Discipline Page'}. "</a></p> </center></body></html>\n";


#----------------
sub deleteRecords {
#----------------

    #foreach my $key (sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    my ($year, $month, $day ) = split /-/, $arr{deletedate};
    my $displaydate = "$month[$month] $day, $year";


    my $dsn = "DBI:$dbtype:dbname=$dbase";
    my $dbh = DBI->connect($dsn,$user,$password);

    my $sth = $dbh->prepare("delete from discipline where date < ?");
    $sth->execute( $arr{deletedate} );

    if ($DBI::errstr) {
	print $lex{'Record Deletion Failed. Please contact'}. " $adminname<br>\n";
	print "$DBI::errstr\n";
    } else {
	print "<h1>". $lex{'Student Discipline Records deleted from before'}. " $displaydate</h1>\n";
    }

    print "</center></body></html>\n";

    exit;

}

