#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson
#  Update by Kevin Waddell

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Edit Discipline Records' => 'Edit Discipline Records',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Edit/Delete Discipline Records' => 'Edit/Delete Discipline Records',
	   'Discipline Record' => 'Discipline Record',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Not Found' => 'Not Found',

	  );	   

use DBI;
use CGI;

my @month = ('January','February','March','April','May','June','July',
	     'August','September','October','November','December');
my @dow = ('Sunday','Monday','Tuesday','Wednesday',
	   'Thursday','Friday','Saturday');

my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
    $yday, $iddst) = localtime(time);
$year = $year + 1900;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = CGI->new;
print $q->header; 

require "../../etc/admin.conf" or die "Cannot read admin.conf!";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Edit Discipline Records'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> | 
<a href=\"$discpage\">". $lex{Discipline}. "</a> ]\n";

print "<center><h1>". $lex{'Edit/Delete Discipline Records'}. "</h1><h3>$currdate</h3>\n";

print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{'Discipline Record'}. "</th><th>". $lex{Edit};
print "</th><th>". $lex{Delete}. "</th></tr>\n";

my $sth = $dbh->prepare("select id, date, userid from discipline order by date desc, userid");
$sth->execute;
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }

while ( my ($id, $date, $studnum) = $sth->fetchrow ) {

    my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
    $sth1->execute( $studnum );
    my ($lastname, $firstname) = $sth1->fetchrow;
    if (not $lastname) { $lastname = '<span style="color:red;">'. $lex{'Not Found'}. '</span>'; }
  
    print "<tr><td><b>$date</b> $firstname $lastname ($studnum)</td>\n";
    print "<td><a href=\"disced0.pl?id=$id\">". $lex{Edit}. "</a></td>\n";
    print "<td><a href=\"discdel0.pl?id=$id\">". $lex{Delete}. "</a></td></tr>\n";
}

print "</table></center></body></html>\n";
