#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson
#  Update by Kevin Waddell

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Edit Discipline' => 'Edit Discipline',
	   'Your record update is now stored in the database.' => 
	     'Your record update is now stored in the database.',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Please contact your network adminstrator at' => 
	     'Please contact your network adminstrator at',
	   'Please record the following error' => 'Please record the following error',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Error' => 'Error',

	  );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $description = $dbh->quote( $arr{description} );
my $action = $dbh->quote( $arr{action} );
my $ifrepeat = $dbh->quote( $arr{ifrepeat} );
my $date = $dbh->quote( $arr{date} );
my $userid = $dbh->quote( $arr{userid} );
my $infraction = $dbh->quote( $arr{infraction} );
my $parent = $dbh->quote( $arr{parent} );

if ( not $arr{private} ) { 
    $private = $sql{default};
} else {
    $private = $dbh->quote( $arr{private} );
}


$sth = $dbh->prepare("update discipline set
 date = $date, userid = $userid, infraction = $infraction,
 description = $description, action= $action, 
 ifrepeat = $ifrepeat, parent = $parent,
 private= $private 
where id = ?");

$sth->execute( $arr{id} );

#======== HTML Output ==================================

print "$doctype\n<html><head><title>". $lex{'Edit Discipline'}. "</title>\n
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

if (not $DBI::errstr ) {
   print "<h3>". $lex{'Your record update is now stored in the database.'}. "</h3></p>";
} else {
   print "<h3>". $lex{'There was an error storing your data'}. "<br>\n";
	print $lex{'Please contact your network adminstrator at'};
	print " <a href=\"mailto:$adminemail\">$adminemail</a><br>\n ";
	print $lex{'Please record the following error'}. " $DBI::errstr;</h3>\n";
}
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | ";
print "<a href=\"$discpage\">". $lex{Discipline}. "</a> ]</p>\n";

print "</body></html>\n";
