#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson
#  Update by Kevin Waddell

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View Discipline Records' => 'View Discipline Records',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'View Discipline Entries' => 'View Discipline Entries',
	   'Name' => 'Name',
	   'Infract/Par' => 'Infract/Par',
	   'Description' => 'Description',
	   'Action' => 'Action',
	   'Parent' => 'Parent',
	   'Priv' => 'Priv',
	   'Repeat' => 'Repeat',
	   'Error' => 'Error',

	  );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select date, userid, infraction, description, action, 
 ifrepeat, parent, author, private from discipline order by date desc, userid");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

print "$doctype\n<html><head><title>". $lex{'View Discipline Records'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | ";
print "<a href=\"$discpage\">". $lex{Discipline}. "</a> ]\n";

print "<center><h1>". $lex{'View Discipline Entries'}. "</h1>\n";
print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Name}. "</th><th>". $lex{'Infract/Par'}. "</th>
<th>". $lex{Description}. "</th><th>". $lex{Action}. "</th></tr>\n";

my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum= ?");

while ( my ( $date, $userid, $infraction,$description, $action, $ifrepeat, 
	     $parent, $author, $private) = $sth->fetchrow){
    $sth1->execute( $userid );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth1->fetchrow;

    print "<tr><td><b>$date<br>$firstname $lastname</b><br>($userid)</td>\n";
    print "<td>$infraction<br><b>". $lex{Parent}. ":</b> $parent<br><b>";
    print $lex{Priv}. ":</b> $private</td><td>$description</td><td>$action<br><b>";
    print $lex{Repeat}. ":</b> $ifrepeat</td></tr>\n";
}

print "</table></center></body></html>\n";

