#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View Discipline Entries' => 'View Discipline Entries',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Start' => 'Start',
	   'End' => 'End',
	   'Name' => 'Name',
	   'Infract/Par' => 'Infract/Par',
	   'Description' => 'Description',
	   'Action' => 'Action',
	   'Error' => 'Error',
	   'Student Not Found' => 'Student Not Found',

	   );

use DBI;
use CGI;

my @time = localtime(time);
my $year = $time[5] + 1900;
my $month = $time[4] + 1;
my $currdate = "$year-$month-$time[3]";

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
%arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

if ( not $arr{edate} ) {
    $arr{edate} = $currdate;
}    
if ( not $arr{sdate} ) {
    $arr{sdate} = $schoolstart;
}


if ($arr{sort} eq 'a') {
    $sortorder = "date, userid";
} else {
    $sortorder = "date desc, userid";
}

$sth = $dbh->prepare("select * from discipline 
  where to_days(discipline.date) >= to_days('$arr{sdate}') and 
  to_days(discipline.date) <= to_days('$arr{edate}') 
  order by $sortorder");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
$rows = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'View Discipline Entries'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> | 
<a href=\"$discpage\">". $lex{Discipline}. "</a> ]\n";

print "<center><h1>". $lex{'View Discipline Entries'}. "</h1>
<p><b>". $lex{Start}. ":</b> $arr{sdate} <b>". $lex{End}. ":</b> $arr{edate}</p>\n
<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">
<tr><th>". $lex{Name}. "</th><th>". $lex{'Infract/Par'}. "</th><th>". $lex{Description}. "</th>
<th>". $lex{Action}. "</th></tr>\n";

while (my @arr = $sth->fetchrow){

    $sth1 = $dbh->prepare("select lastname, firstname, studnum from studentall where studnum = ?");
    $sth1->execute( $arr[2] );
    my ($lastname, $firstname, $studnum) = $sth1->fetchrow;
    if (not $lastname) { $lastname = '<span style="color:red;">'. $lex{'Student Not Found'}. '</span>'; }

    print "<tr><td><b>$arr[1]<br>$lastname</b>, $firstname</b><br>($studnum)</td>\n";

    print "<td>$arr[3]<br>($arr[8])<br><b>Parent:</b> $arr[7]<br>\n";
    print "<b>Priv:</b> $arr[9]</td><td>$arr[4]</td><td>$arr[5]<br>\n";
    print "<b>Repeat:</b> $arr[6]</td></tr>\n";
}

print "</table></center></body></html>\n";

