#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Student Infractions by Date' => 'Student Infractions by Date',
	   'Main' => 'Main',
	   'Discipline' => 'Discipline',
	   'Click on Student Name to view their records' => 
	     'Click on Student Name to view their records',
	   'only' => 'only',
	   'Student' => 'Student',
	   'Last,First/Last/Initials/Studnum' => 
	     'Last,First/Last/Initials/Studnum',	   
	   'Search' => 'Search',
	   'Error' => 'Error',

	   );

my $self = 'rptstud.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $student = $arr{student};
delete $arr{student};
# summary also passed.

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Student Infractions by Date'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$discpage\">". $lex{Discipline}. "</a> ]\n";

print "<table width=\"100%\"><tr><td align=\"center\"><h1>";
print $lex{'Student Infractions by Date'}. "</h1></td>";
print "<td align=\"right\">\n";

showSearchForm();

print "</td></tr></table><p><b>". 
$lex{'Click on Student Name to view their records'}. " <i>". $lex{only}. "</i></b></p>\n";


# Setup the Search
if ($student =~ /\d+/) {  # we have a student number
    $studnum = $student;
    $sth = $dbh->prepare("select lastname, firstname, studnum from studentall
     where studnum = '$studnum'");
} else { # we have words hopefully with a comma
    ($lastname,$firstname)  = split /\,/, $student;
    $firstname =~ s/^\s*//;
    $lastname =~ s/^\s*//;
    if ($lastname and $firstname){ # both entered.
	$sth = $dbh->prepare("select lastname, firstname, studnum 
          from studentall where lastname = '$lastname' 
          and firstname = '$firstname' order by lastname, firstname");
    } elsif ($lastname and not $firstname){ # only lastname (no comma)
	if (length($lastname) == 2){ # search by initials: fi, li.
	    $fi = substr($lastname,0,1); $li = substr($lastname,1,1);
	    $sth = $dbh->prepare("select lastname,firstname, studnum
              from studentall
              where lastname $sql{like} '$li%' and firstname $sql{like} '$fi%'
              order by lastname, firstname");
	} else {
	    $sth = $dbh->prepare("select lastname, firstname, studnum 
            from studentall where lastname = '$lastname' 
            order by lastname, firstname");
	}
    } else { # print an error....
	$sth = $dbh->prepare("select lastname, firstname, studnum 
         from studentall order by lastname, firstname");
    }
} # Last Else

$sth->execute;
if ($DBI::errstr) {print "Error: $DBI::errstr"; die;}
$rows = $sth->rows;

while (my ($lastname, $firstname,$studnum) = $sth->fetchrow){
# Loop through each found student.

    $sth1 = $dbh->prepare("select * from discipline
      where userid = '$studnum' and infraction != 'Withdrew from School' 
      order by date desc");
    $sth1->execute;
    if ($DBI::errstr) {print "Error: $DBI::errstr"; }
    my $discrows = $sth1->rows;
    if (not $discrows){ next; } # skip kids without discipline entries.

    print "<h2><a href=\"$self?student=$studnum\">$firstname $lastname</a>";
    print " ($studnum)</h2><ul>\n";      

    while ( my @arr = $sth1->fetchrow){
	if (! $arr{summary}){
	    print "<li><i>$arr[1]</i> [ <b>$arr[3]</b> ] <i>($arr[8])</i> ";
	    print "$arr[4] $arr[5] <i>If repeated,</i> $arr[6]";
	    print "<i>Parent:</i>$arr[7] <i>Priv:</i> $arr[9]</li>\n";
	}
    }

    print "</ul><p></p>"; 

}

print "</ul>[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$discpage\">". $lex{Discipline}. "</a> ]\n";
showSearchForm();
print "</body></html>\n";



#-----------------
sub showSearchForm {
#-----------------

    print "<div style=\"text-align:left;padding:0.3em;\">\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"submit\" value=\"". $lex{Search}. "\">\n";
    print " <input type=\"text\" name=\"student\" size=\"30\">\n";
    print $lex{Student}. " (". $lex{'Last,First/Last/Initials/Studnum'}. ")\n";

    print "</form></div>\n";

}

