#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Group Email' => 'Group Email',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Main' => 'Main',
	   'Blank=All' => 'Blank=All',
	   'Select' => 'Select',
	   'Values' => 'Values',
	   'Group' => 'Group',
	   'Student Email' => 'Student Email',
	   'Parent 1 Email' => 'Parent 1 Email',
	   'Parent 2 Email' => 'Parent 2 Email',
	   'Separate with Spaces' => 'Separate with Spaces',
	   'Subject' => 'Subject',
	   'Message' => 'Message',
	   'Continue' => 'Continue',
	   'Student' => 'Student',
	   'Checked' => 'Checked',
	   'Email Sent!' => 'Email Sent!',
	   'Error' => 'Error',

	   );

my $self = 'emailgroup.pl';

use CGI;
use DBI;


# calc current date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " :$@<br>\n";
    die $lex{Error}. " :$@<br>\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $checked = $arr{checked};
delete $arr{checked};


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Show page Header
print "$doctype\n<html><head><title>". $lex{'Group Email'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body style=\"padding:1em;\">\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";
print "<center><h1>". $lex{'Group Email'}. "</h1>\n";

if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) { # Select Students, Parents to receive email.
    delete $arr{page};
    selectRecipients();

} elsif ( $arr{page} == 2 ) { # post the Mail
    delete $arr{page};
    postEmail();

} elsif ( $arr{page} == 3 ) { # Write Emails to File or System.

} 



#----------------
sub showStartPage {
#----------------

    # Setup the form and start of table.
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";
    
    print "<tr><td align=\"right\">". $lex{Group}. "</td><td align=\"left\">\n";
    print "<select name=\"groupType\"><option>". $lex{Grade}. "</option>\n";
    print "<option>". $lex{Homeroom}. "</option></select>\n";
    print "</td></tr>\n";

    print "<tr><td align=\"right\">". $lex{Values}. "</td><td align=\"left\">\n";
    print "<input type=\"text\" name=\"groupValue\" size=\"25\"><br>\n";
    print $lex{'Separate with Spaces'}. q{, }. $lex{'Blank=All'}. "</td></tr>\n";

    print "<tr><td align=\"right\">". $lex{Select}. "</td><td align=\"left\">\n";
    print "<input type=\"checkbox\" name=\"selStudent\" value=\"1\"> ";
    print $lex{'Student Email'}. "<br>\n";

    print "<input type=\"checkbox\" name=\"selPar1\" value=\"1\"> ";
    print $lex{'Parent 1 Email'}. "<br>\n";

    print "<input type=\"checkbox\" name=\"selPar2\" value=\"1\"> ";
    print $lex{'Parent 2 Email'}. "<br>\n";

    print "<tr><td align=\"right\">". $lex{Checked}. "?</td><td align=\"left\">\n";
    print "<input type=\"checkbox\" name=\"checked\" value=\"checked\"></td></tr>\n";

    print "<tr><td align=\"center\" colspan=\"2\">";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\">";
    print "</td></tr>\n";

    print "</table></form>\n";
    print "</body></html>\n";

    exit;

}



#-------------------
sub selectRecipients { # Choose students/parents to email to and put in message
#-------------------

    # foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    # Get passed group values
    my @group = split /\s/, $arr{groupValue}; # split into array based on spaces
    delete $arr{groupValue};
    #print "Group", @group, "<br>\n";

     
    my $groupType;
    if ( $arr{groupType} eq $lex{Grade} ) {
	$groupType = 'grade';
    } else {
	$groupType = 'homeroom';
    }
    delete $arr{groupType};


    # Select students, sorted by lastname, firstname,
    my $select;
    if ( $arr{group_name} ) {
	my ($dud, $group_name) = split /\(/, $arr{group_name};
	$group_name =~ s/\)//g;
	#print "The group name is: $group_name<br>\n";

	my @values = split / /, $arr{group_value};
	if (@values) {
	    $select = 'where ';
	    $first = 1;
	    foreach my $value ( @values ) {
		$value = $dbh->quote( $value );
		if ( not $first ) { $select .= ' or '; }
		$select .= "$group_name = $value ";
		$first = 0;
	    }
	}
    }

    #if ($select) { print "Select: $select<br>\n"; }

    
    my $sth = $dbh->prepare("select lastname, firstname, studnum, 
       email, par1_email, par2_email from student 
       $select order by lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }


    # Setup the form and start of table.
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";

    print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";

    print "<tr><td colspan=\"2\"><b>". $lex{Subject};
    print "</b> <input type=\"text\" name=\"subject\" size=\"20\"></td></tr>\n";

    print "<tr><td align=\"left\" colspan=\"2\"><b>". $lex{Message};
    print "</b><br><textarea name=\"message\" rows=\"10\" cols=\"60\"></textarea></td></tr>\n";

    print "<tr><th colspan=\"2\"><input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";
    #print "<tr><th>". $lex{Student}. "</th><th>". $lex{Select}. "</th></tr>\n";

    # Loop through the students
    while ( my ($lastname, $firstname, $studnum, $email, $par1_email, $par2_email ) = $sth->fetchrow ) {

	 print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td><td align=\"left\">\n";
	 if ( $email and $arr{selStudent} ) {
	     print "<input type=\"checkbox\" name=\"$email\" value=\"1\" $checked> $email&nbsp;&nbsp;| ";
	 }
	 if ( $par1_email and $arr{selPar1} ) {
	     print "<input type=\"checkbox\" name=\"$par1_email\" value=\"1\" $checked> $par1_email&nbsp;&nbsp;| ";
	 }
	 if ( $par2_email and $arr{selPar2} ) {
	     print "<input type=\"checkbox\" name=\"$par2_email\" value=\"1\" $checked> $par2_email&nbsp;&nbsp;| ";
	 }
	 
	 print "</td></tr>\n";
     }


     # Print Submit Row
     print "<tr><th colspan=\"4\" align=\"center\">";
     print "<input type=\"submit\" value=\"". $lex{'Continue'}. "\"></th></tr>\n";
    
     print "</table>\n</form></center></body></html>\n";
    
     exit;

 }



#------------
sub postEmail  {
#------------

    delete $arr{page}; # don't need no writeflag

    my $subject = $dbh->quote( $arr{subject} );
    delete $arr{subject};

    my $message = $dbh->quote( $arr{message} );
    delete $arr{message};

    print "<div style=\"text-align:left;\">\n<ul>\n";


    foreach my $key (sort keys %arr) { 
	#print "K:$key V:$arr{$key}<br>\n"; 

	$key =~ s/@/\\@/;
	$emailaddress = "$key";

	# Watch which one is ACTIVE!

	# CHANGE THIS TO YOUR MAILER's BINARY FILE (assuming a sendmail equivalent)
	#open (SENDMAIL,"| /usr/sbin/sendmail -t");
	open (SENDMAIL,">>emailtest");   
	if (not SENDMAIL){
	    print "Sendmail Error! File not opened\n";
	    die;
	}

	# CHANGE RETURN ADDRESS TO YOUR SITE...
	print SENDMAIL "From: OpenAdmin Messaging System <no-reply\@yoursite.net>\n";
	print SENDMAIL "To: $emailaddress \n";
	print  "<li>$emailaddress</li> \n";
	print SENDMAIL "Subject: $subject \n";
	print SENDMAIL "X-Mailer: Open Admin Messaging System \n\n";

	print SENDMAIL "$message\n\n";

	close (SENDMAIL);

    }

    print "</div>\n";

    print "<h1>". $lex{'Email Sent!'}. "</h1>\n";

    # For demonstration purposes only...
    #system("mv emailtest $downloaddir");
    #print "<h1><a href=\"$webdownloaddir/emailtest\">";
    #print "Email Demonstration File (text format)</a></h1>\n";

    print "<p>[ <a href=\"$homepage\">Main</a> ]</p></center></body></html>\n";

    exit;

} # End of postMail
