#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = (
	   'Division Wide Enrollment' => 'Division Wide Enrollment',
	   'Student Not Found' => 'Student Not Found',
	   'There was an error removing the student from the student database' =>
	     'There was an error removing the student from the student database',
	   'Please contact' => 'Please contact',
	   'Main' => 'Main',
	   'Your student is now inserted in the student database' => 
	     'Your student is now inserted in the student database',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

# print page header.
print "$doctype\n<html><head><title>". $lex{'Division Wide Enrollment'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";


# strip off leading text...
$arr{entrytype} =~ s/(.*)\((.*)\)/$2/;

if ( not -e "$globdir/global.conf" ) {
    print "Cannot read the global.conf file!";
    print "</body></html>\n";
    die;
}

unless (require "$globdir/global.conf") {
    print "Cannot read the global.conf file!";
    die "Cannot read the global.conf file!";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Passed Values
$studnum = $arr{studnum};
$database = $arr{database};


# Open the Source Database, using global $database name.
$dsn1 = "DBI:$dbtype:dbname=$database";
$dbh1 = DBI->connect($dsn1,$guser,$gpassword);


my %m;
# Create mapping hash between name and the array index variable of value.
# This will remove dependency on array index values with restructured student tables.
$sth = $dbh->prepare("select fieldid, arrayidx from meta where tableid = 'student' order by arrayidx");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die "$DBI::errstr";}
while (my ($fi,$idx) = $sth->fetchrow) {
    $m{$fi} = $idx;
}


# Get withdrawn student in another school.
$sth = $dbh1->prepare("select * from studentwd where studnum = '$studnum'"); 
$sth->execute;
if ($DBI::errstr){print $DBI::errstr; die;}
$rows = $sth->rows;
@arr = $sth->fetchrow;

foreach $key (@arr){
   $key =~ s/'/''/g;
}

if ($rows < 1) { #Error!
    print '<h1>'. $lex{'Student Not Found'}. "!</h1></body></html>\n";
    die;
}

# Note: We don't change local student numbers, since we have a unique
# division wide student number.


$arr[0] = $sql{default};  # reset the studid/id.
$arr[$m{alias}] = '';     # reset the alias.
foreach my $student (@arr){ 
  $student =~ s/'/''/g;
  $student = "\'".$student."\',";
}
chop $arr[$#arr]; # Chop trailing comma in last element

$sth = $dbh->prepare("insert into student values (@arr)");
$sth->execute;


if (not $DBI::errstr ) {
    print '<h3>'. $lex{'Your student is now inserted in the student database'}. ".</h3>";
    chop $arr[$m{provnum}]; # Get rid of trailing ",".
    $sth2 = $dbh->prepare("insert into transfer values (
      $sql{default},'$studnum','$arr{date}','enrol',
      '$arr{description}', '$arr{entrytype}',NULL,'$arr{prov}',
      '$arr{country}','Y',$arr[$m{lastname}] $arr[$m{firstname}] $arr[$m{initial}] $arr[$m{birthdate}] $arr[$m{provnum}])");
 
    $sth2->execute;
    if ($DBI::errstr) { print $DBI::errstr; }

} else {
    print '<h3>'. $lex{'There was an error removing the student from the student database'}."\n";
    print $lex{'Please contact'}. " $adminname [ ";
    print "<a href=\"mailto:$adminemail\">$adminemail</a><br>\n";
    print $DBI::errstr. "</h3>\n";
    die $DBI::errstr;

}

print "<p>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]</p></body></html>\n";
