#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View Withdrawn Students' => 'View Withdrawn Students',
	   'Name' => 'Name',
	   'Number' => 'Number',
	   'Grade' => 'Grade',
	   'Gender' => 'Gender',
	   'Birthdate' => 'Birthdate',
	   'Ident#' => 'Ident#',
	   'Main' => 'Main',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

if ( not -e "$globdir/global.conf" ) {
    print "Cannot read the global.conf file!";
    print "</body></html>\n";
    die;
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
    $yday, $iddst) = localtime(time);
$year = $year + 1900;
$month++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


# HTML Heading Material
print "$doctype\n<html><head><title>". $lex{'View Withdrawn Students'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

print "$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]<center>
<h1>". $lex{'View Withdrawn Students'}. "</h1><h3>$currdate</h3>\n";


foreach $database (keys %dbase) { #defined in global config file.

    $dsn = "DBI:$dbtype:dbname=$database";
    $dbh = DBI->connect($dsn,$guser,$gpassword);

    my %m;
    if (not %m) {  # only do this once...
	# Create mapping hash between name and the array index variable of value.
	# This will remove dependency on array index values with restructured student tables.
	$sth = $dbh->prepare("select fieldid, arrayidx from meta 
          where tableid = 'student' order by arrayidx");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die "$DBI::errstr";}
	while (my ($fi,$idx) = $sth->fetchrow) {
	    $m{$fi} = $idx;
	}
    }	
    

    my $select;
    if ( $arr{grade} ) {
	my $gr = $dbh->quote( $arr{grade} );
	$select = "where grade = $gr";
    }

    $sortorder = "lastname, firstname";
    if ($arr{sortorder} eq "birthdate") {
	$sortorder = "birthdate";
    } 

    $sth = $dbh->prepare("select * from studentwd 
     $select order by $sortorder");
    $sth->execute;
    if ($DBI::errstr){print $DBI::errstr; die;}
    $rows = $sth->rows;
    
    print "<h1>$dbase{$database}</h1>\n";
    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";
    print '<tr><th>'. $lex{Name}. '</th><th>'. $lex{Number}. "</th>\n<th>";
    print $lex{Grade}. '</th><th>'. $lex{Gender}. '</th><th>'. $lex{Birthdate};
    print '</th><th>'. $lex{'Ident#'}."</th></tr>\n";

    while ( my @arr = $sth->fetchrow ) {
	print "<tr><td><b>$arr[$m{lastname}], $arr[$m{firstname}] $arr[$m{initial}]</b></td>\n";
	print "<td>$arr[$m{studnum}]</td><td>$arr[$m{grade}]</td><td>$arr[$m{sex}]</td>\n";
	print "<td>$arr[$m{birthdate}]</td><td>$arr[$m{provnum}]</td></tr>\n\n";
    }
  
    print "</table>\n";

}  # End of Database reading Loop.

print "</center></body></html>\n";
