#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Main Student Entry/Withdrawal Script. It decides the "direction" of scripts
#  New Entry: (enroll) -> sentry1.pl
#  Withdraw            -> withdraw.pl
#  Re-Enroll           -> reenrol.pl
#  Enroll from Other School (in division) ->globenrol.pl

my %lex = ('Student Entry' => 'Student Entry',
	   'Main' => 'Main',
	   'You are entering a new student' => 'You are entering a new student',
	   'Add a New Student' => 'Add a New Student',
	   'Enrollment Reason' => 'Enrollment Reason',
	   'Province Code' => 'Province Code',
	   'if transfer from other province' => 'if transfer from other province',
	   'if transfer to other province' => 'if transfer to other province',
	   'if transfer to other country' => 'if transfer to other country',
	   'if transfer from other country;<br><b>not</b> exchange student' => 
	     'if transfer from other country;<br><b>not</b> exchange student',
	   'Country Code' => 'Country Code',
	   'Pre-registration Entry' => 'Pre-registration Entry',
	   'All other fields may be left blank if selected' => 
	     'All other fields may be left blank if selected',
	   'Waiting List Entry' => 'Waiting List Entry',
	   'Description' => 'Description',
	   'Student Withdrawal' => 'Student Withdrawal',
	   'Date' => 'Date',
	   'Withdrawal Reason' => 'Withdrawal Reason',
	   'Withdraw the Student' => 'Withdraw the Student',
	   'Entry Reason' => 'Entry Reason',
	   'Re-enrol the Student' => 'Re-enrol the Student',
	   'Enrol the Student' => 'Enrol the Student',
	   'Name' => 'Name',
	   'Enrol Student from Other School' => 'Enrol Student from Other School',
	   'Clone Existing Student' => 'Clone Existing Student',
	   'last' => 'last',
	   'first or last or initials' => 'first or last or initials',
	   'Student Number' => 'Student Number',
	   'or' => 'or',
	   'Error' => 'Error',
	   'Student not found' => 'Student not found',
	   'Student must be preregistered/waiting list student' => 
	     'Student must be preregistered/waiting list student',
	   'Please use their functions to transfer to active student table' =>
	     'Please use their functions to transfer to active student table',
	   'Yes' => 'Yes',
	   'Cannot open' => 'Cannot open',

	   );

use DBI;
use CGI;

eval { require "../../etc/admin.conf"; };
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@<br>\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
    $yday, $iddst) = localtime(time);
$year = $year + 1900; 
$mon++;
$wday++;
#my $currdate = "$dow[$wday], $month[$mon] $mday, $year";
my $currsdate = "$year-$mon-$mday";

# Print Page Header
print "$doctype\n<head><title>". $lex{'Student Entry'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
<style type=\"text/css\">
 body {margin: 2em;}
</style>
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";


if ( not -e "$globdir/global.conf" ) {
    print $lex{'Cannot open'}. " global.conf file!";
    print "</body></html>\n";
    die;
}


# Read database names and also the global enrol/withdraw reasons.
eval { require "$globdir/global.conf"; };
if ( $@ ) {
    print "<h3>". $lex{'Cannot open'}. " global.conf:\n $@</h3>\n";
    die $lex{'Cannot open'}. " global.conf: $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


my $studnum = $arr{studentnumber};
my ($rows, @arr, $rowswd, @arrwd, $rowsgwd, @arrgwd);


if ( $studnum ) {  # We have a student number entered.
    my $found = 0;

    # First try to get it out of local student table;
    $sth = $dbh->prepare("select * from student where studnum = ?"); 
    $sth->execute( $studnum );
    if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr; }
    $rows = $sth->rows;
    if ( $rows > 0 ) { $found = 1; }
    @arr = $sth->fetchrow;

    if ( not $found ) {
	# Look in local withdrawn student table for that student #.
	$sth1 = $dbh->prepare("select * from studentwd where studnum = ?"); 
	$sth1->execute( $studnum );
	if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr; }
	$rowswd = $sth1->rows;
	if ( $rowswd > 0 ) { $found = 1; }
	@arrwd = $sth1->fetchrow;

    }
 
    if ( not $found ) { # look in all wd tables.

	foreach $database (keys %dbase) { #defined in global config file.

	    my $dsn1 = "DBI:$dbtype:dbname=$database";
	    my $dbh1 = DBI->connect($dsn1,$guser,$gpassword);

	    my $sth2 = $dbh1->prepare("select * from studentwd where studnum = ?"); 
	    $sth2->execute( $studnum );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    $rowsgwd = $sth2->rows;
	    @arrgwd = $sth2->fetchrow;

	    $gldbase = $database; # stores correct dbase to pass.
	    if ($rowsgwd) { # found a student
		$found = 1;
		last; 
	    };
	} # ForEach Loop through all withdrawn tables
	
    }

    if ( not $found ) { # Must be preregistered/waiting list student
	print "<center><div style=\"padding:1em;border:1px solid gray;width:30em;\"><b>";
	print $lex{'Student not found'}. ". \n";
	print $lex{'Student must be preregistered/waiting list student'}. ". \n";
	print $lex{'Please use their functions to transfer to active student table'}. ".\n";
	print "</b></div></center></body></html>\n";
	exit 0;
    }
    
} # End of section with student # entered.


# No student number entered or not in student table and not in withdrawn.
if ( not $studnum or ( $rows < 1 and $rowswd < 1 and $rowsgwd < 1 ) ) { 
    # ========== ADD NEW STUDENT =============

    print '<center><h1>'. $lex{'You are entering a new student'}. ".</h1>\n";
    print "<form action=\"sentry1.pl\" method=\"post\">\n";
    #print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
    print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"0\">\n";
    print "<tr><td align=\"right\"><b>". $lex{'Enrollment Reason'}. "</b></td>\n";
    print "<td><select name=\"entrytype\">\n";

    foreach $type (sort keys %g_enrol){
	print "<option>$g_enrol{$type} ($type)</option>\n";
    }

    print "</select></td></tr>\n";
    print "<tr><td align=\"right\"><b>". $lex{'Province Code'}. "</b><br>\n(<i>";
    print $lex{'if transfer from other province'};
    print "</i>)</td>\n<td><input type=\"text\" name=\"prov\" size=\"4\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{'Country Code'}. "</b><br>\n(<i>";
    print $lex{'if transfer from other country;<br><b>not</b> exchange student'};
    print "</i>)</td>\n<td><input type=\"text\" name=\"country\" size=\"4\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{'Pre-registration Entry'}. '</b><br><i>'. "\n";
    print $lex{'All other fields may be left blank if selected'}. "</i></td>\n";
    print "<td><input type=\"checkbox\" name=\"prereg\" value=\"1\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{'Waiting List Entry'}. '</b><br><i>'. "\n";
    print $lex{'All other fields may be left blank if selected'}. "</i></td>\n";
    print "<td><input type=\"checkbox\" name=\"waitlist\" value=\"1\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{'Clone Existing Student'}. "</b></td>\n";
    print "<td><b>". $lex{Name}. "</b>(". $lex{last}. ','. $lex{'first or last or initials'};
    print ") ". $lex{or}. " <b>". $lex{'Student Number'}. "</b><br>\n";
    print "<input type=\"text\" name=\"clone\" size=\"30\">\n";    
    print "</td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{Description}. "</b></td>\n<td>";
    print "<textarea name=\"description\" rows=\"3\" cols=\"50\"></textarea></td></tr>\n";

    print "<tr><td></td><td><input type=\"submit\" value=\" ". $lex{'Add a New Student'};
    print "\"></td></tr>\n</table></form></body></html>\n";

}

elsif ($rows == 1 ) {  # we have a student in current table to withdraw
    # ======== WITHDRAW STUDENT ==========

    print '<center><h1>'. $lex{'Student Withdrawal'}. "</h1>\n";
    print "<p>". $lex{Name}. ": <b>$arr[2] $arr[3] $arr[1]</b></p>\n";

    print "<form action=\"withdraw.pl\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
    print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"0\">\n";
    print "<tr><td align=\"right\"><b>". $lex{Date}. "</b></td>\n";

    print "<td><input type=\"text\" size=\"10\" name=\"date\" value=\"$currsdate\"></td></tr>\n";
    print "<tr><td align=\"right\"><b>". $lex{'Withdrawal Reason'}. "</b></td>\n";
    print "<td><select name=\"exittype\">\n";

    foreach my $type (sort keys %g_wdraw){
        print "<option>$g_wdraw{$type} ($type)</option>\n";
    }

    print "</select></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{'Province Code'}. '</b><br>(<i>';
    print $lex{'if transfer to other province'};
    print "</i>)</td><td><input type=\"text\" name=\"prov\" size=\"4\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{'Country Code'}. '</b><br>(<i>';
    print $lex{'if transfer to other country'}. "</i>)</td>\n";
    print "<td><input type=\"text\" name=\"country\" size=\"4\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{Description}. "</b></td>\n<td>";
    print "<textarea name=\"description\" rows=\"3\" cols=\"50\"></textarea></td></tr>\n";

    print "<tr><td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"";
    print $lex{Yes}. q{, }. $lex{'Withdraw the Student'}. "\"></td></tr>\n";
    print "</table></form></body></html>\n";


} elsif ($rowswd == 1) {  # we have an old student returning 
    # =========== RE-ENROLL STUDENT ==============

    print '<center><h1>'. $lex{'Re-enrol the Student'}. "</h1>\n";
    print "<p>". $lex{Name}. ": <b>$arrwd[2] $arrwd[3] $arrwd[1]</b></p>\n";
    print "<form action= \"reenrol.pl\" method= \"post\">\n";
    print "<input type= \"hidden\" name= \"studnum\" value= \"$studnum\">\n";
    print "<p>". $lex{Date};
    print ": <input type=\"text\" size=\"10\" name=\"date\" value=\"$currsdate\"></p>\n";
    print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"0\">\n";
    print "<tr><td align=\"right\"><b>". $lex{'Entry Reason'}. "</b></td><td>\n";
    print "<select name=\"entrytype\">\n";

    foreach $type (sort keys %g_enrol){
	print "<option>$g_enrol{$type} ($type)</option>\n";
    }

    print "</select></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{'Province Code'}. '</b><br>(<i>'. "\n";
    print $lex{'if transfer from other province'};
    print "</i>)</td><td><input type=\"text\" name=\"prov\" size=\"4\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{'Country Code'}. "</b><br>(<i>\n";
    print $lex{'if transfer to other country'}. "</i>)</td>\n";
    print "<td><input type=\"text\" name=\"country\" size=\"4\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{Description}. "</b></td>\n<td>";
    print "<textarea name=\"description\" rows=\"3\" cols=\"50\"></textarea></td></tr>\n";

    print "<tr><td></td><td><input type= \"submit\" value=\"". $lex{Yes}. q{, };
    print $lex{'Re-enrol the Student'};
    print "\"></td></tr></form></body></html>\n";

}

elsif ($rowsgwd == 1) {  # we have a student from another school enrolled.
    # ========= NEW GLOBAL ENROLLMENT ===============

    print "<center><h1>". $lex{'Enrol Student from Other School'}. "</h1>\n";
    print "<p>". $lex{Name}. ": <b>$arrgwd[2] $arrgwd[3] $arrgwd[1]</b></p>\n";
    print "<form action= \"globenrol.pl\" method= \"post\">\n";
    print "<input type= \"hidden\" name= \"studnum\" value= \"$studnum\">\n";
    print "<input type= \"hidden\" name= \"database\" value= \"$gldbase\">\n";
    print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"0\">\n";

    print "<tr><td align=\"right\" width=\"30%\"><b>". $lex{Date}. "</b></td><td>\n";
    print "<input type=\"text\" size=\"10\" name=\"date\" value=\"$currsdate\"></td></tr>\n";

    print "<tr><td align=\"right\" width=\"30%\"><b>". $lex{'Entry Reason'}. "</b></td><td>\n";
    print "<select name=\"entrytype\">\n";

    foreach my $type (sort keys %g_enrol){
	print "<option>$g_enrol{$type} ($type)</option>\n";
    }

    print "</select></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{'Province Code'}. "</b><br>(<i>\n";
    print $lex{'if transfer from other province'};
    print "</i>)</td>\n<td><input type=\"text\" name=\"prov\" size=\"4\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{'Country Code'}. "</b><br>(<i>\n";
    print $lex{'if transfer to other country'}. "</i>)</td>\n";
    print "<td><input type=\"text\" name=\"country\" size=\"4\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{Description}. "</b></td><td>\n";
    print "<textarea name=\"description\" rows=\"3\" cols=\"50\"></textarea></td></tr>\n";

    print "<tr><td></td><td><input type= \"submit\" value=\"". $lex{Yes}. q{, };
    print $lex{'Enrol the Student'}. "\"></td></tr>\n";
    print "</form></body></html>\n";

  
} else { # If we get here we have a programming error....

    print"<center><h1>Programming/Data Error!</h1>Student Rows: $rows ";
    print "Withdrawn Student Rows: $rowswd<br>\n";
    print "<p>Please contact your network administrator</p></body></html>\n";

}
