#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Language Support
my %lex = ('The <i>Tab Key</i> = next field.' => 'The <i>Tab Key</i> = next field.',
	   '<i>Shift+Tab</i> = previous field.' => '<i>Shift+Tab</i> = previous field.',
	   'The <i>Space Bar</i> selects a checkbox.' => 
	     'The <i>Space Bar</i> selects a checkbox.',
	   'The <i>Up/Down Arrow</i> keys select pulldown menus.' => 
	     'The <i>Up/Down Arrow</i> keys select pulldown menus.',
	   'The <i>Mouse</i> kills key entry productivity.' => 
	     'The <i>Mouse</i> kills key entry productivity.',
	   'No Entry' => 'No Entry',
	   'Add Student' => 'Add Student',
	   'Unable to open template file' => 'Unable to open template file',
	   'Save Record' => 'Save Record',
	   'Student Table' => 'Student Table',
	   'Pre-Registration' => 'Pre-Registration',
	   'Waiting List' => 'Waiting List',
	   'Required Field' => 'Required Field',
	   'Bold' => 'Bold',
	   'Enrollment Date' => 'Enrollment Date',
	   'Entry Error' => 'Entry Error',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Clone this record' => 'Clone this record',
	   'Error' => 'Error',
	   'Main' => 'Main',
	   
	   );

my $self = 'sentry1.pl';

use CGI;
use DBI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "../../lib/libmeta.pl";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

# strip off leading text...
$arr{entrytype} =~ s/(.*)\((.*)\)/$2/;


my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";

$dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Add Student'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body><h1>". $lex{'Add Student'}. "</h1>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

if ( $arr{clone} ) {
    showCloneResults( $arr{clone} );
}


print "<div style=\"position:absolute;top:0;right:0;width:60%;\"><p>
 &quot;$lex{'The <i>Tab Key</i> = next field.'}&quot;
 &quot;$lex{'<i>Shift+Tab</i> = previous field.'}&quot;
 &quot;$lex{'The <i>Space Bar</i> selects a checkbox.'}&quot;
 &quot;$lex{'The <i>Up/Down Arrow</i> keys select pulldown menus.'}&quot;
 &quot;$lex{'The <i>Mouse</i> kills key entry productivity.'}&quot;</p></div>

<form action=\"sentry2.pl\" method=\"post\">
<input type=\"hidden\" name=\"prereg\" value=\"$arr{prereg}\">
<input type=\"hidden\" name=\"description\" value=\"$arr{description}\">
<input type=\"hidden\" name=\"entrytype\" value=\"$arr{entrytype}\">
<input type=\"hidden\" name=\"prov\" value=\"$arr{prov}\">
<input type=\"hidden\" name=\"country\" value=\"$arr{country}\">
<input type=\"hidden\" name=\"waitlist\" value=\"$arr{waitlist}\">\n";

if ( $arr{waitlist} ) {
    print "<input type=\"submit\" ";
    print "value=\"". $lex{'Save Record'}. " - ". $lex{'Waiting List'}. "\">\n";
} elsif ( $arr{prereg} ) {
    print "<input type=\"submit\" ";
    print "value=\"". $lex{'Save Record'}. " - ". $lex{'Pre-Registration'}. "\">\n";
} else {
    print "<input type=\"submit\" value=\"". $lex{'Save Record'}. " - ";
    print $lex{'Student Table'}. "\">\n";
}


print "<span style=\"background-color:#D8D8D8;border:1px solid black; padding:0.5em;\">
<b>". $lex{'Enrollment Date'}. "</b>
<input type=\"text\" name=\"enroldate\" value=\"$currdate\" size=\"12\">
&nbsp;&nbsp;[ <b>". $lex{Bold}. "</b> = ". $lex{'Required Field'}. " ]</span>
<!-- Template Should Begin Here -->\n";


# Read in Template
unless (open (FH,"<../../template/student.tpl")) {
    print $lex{'Unable to open template file'}. ": $!\n";
    die $lex{'Unable to open template file'}. ": $!\n";
}
my $text;
{ local $/; $text = <FH>; close FH;}

# Create meta hash - %fields fieldid => fieldname
my $sth = $dbh->prepare("select id, fieldid, fieldname, required from meta
  where tableid = 'student'"); # order doesn't matter.
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while (my ($id, $fieldid, $fieldname, $required) = $sth->fetchrow) {
    if ( uc($required) eq 'Y') {
	$fields{$fieldid} = "<b>$fieldname</b>";
    } else {
	$fields{$fieldid} = $fieldname;
    }
}

# Now put replacement text back in.
$text =~ s{\<\*(.*?)\*\>}
          { exists($fields{$1}) 
		  ? $fields{$1} 
	          : $1
          }gsex;


# now parse for form entry replacement elements  <*name*> 
while ( $text =~ m/\<\@(.*)\@\>/g){
    push @fields, $1;
}

# get replacement values for fields
foreach my $val ( @fields ) {
    if ( $val eq 'studnum' ){ $values{studnum} = $lex{'No Entry'}; next; }
    $values{$val} = metaput('student',$val, $arr{clonestudnum}, 'edit');
}


# now put back into $text variable...
$text =~ s{\<\@(.*?)\@\>}
          { exists($values{$1}) 
		  ? $values{$1} 
	          : "$values{$1}-$1"
          }gsex;

print $text,"\n";

if ( $arr{waitlist} ) {
    print "<input type=\"submit\" ";
    print "value=\"". $lex{'Save Record'}. " - ". $lex{'Waiting List'}. "\">\n";
} elsif ( $arr{prereg} ) {
    print "<input type=\"submit\" ";
    print "value=\"". $lex{'Save Record'}. " - ". $lex{'Pre-Registration'}. "\">\n";
} else {
    print "<input type=\"submit\" value=\"". $lex{'Save Record'}. " - ". $lex{'Student Table'}. "\">\n";
}

print "</form></body></html>\n";


#-------------------
sub showCloneResults {
#-------------------

    my $student = shift;

    # Setup the Search
    if ($student =~ /\d+/) {  # we have a student number
	$sth = $dbh->prepare("select studnum, lastname, firstname from student 
           where studnum = ?");
	$sth->execute( $student );
    } else { # we have words hopefully with a comma
	($lastname,$firstname)  = split /\,/, $student;
	$firstname =~ s/^\s*//;
	$lastname =~ s/^\s*//;
	if ($lastname and $firstname){ # both entered.
	    $sth = $dbh->prepare("select studnum, lastname, firstname from student 
              where lastname = ? and firstname = ?");
	    $sth->execute( $lastname, $firstname );

	} elsif ($lastname and not $firstname){ # only lastname (no comma)

	    if (length($lastname) == 2){ # search by initials: fi, li.
		$fi = substr($lastname,0,1). '%'; 
		$li = substr($lastname,1,1). '%';
		$sth = $dbh->prepare("select studnum, lastname, firstname from student 
                  where lastname $sql{like} ? and firstname $sql{like} ?");
		$sth->execute( $li, $fi );

	    } else {

		$sth = $dbh->prepare("select studnum, lastname, firstname from student 
                 where lastname = ? order by firstname");
		$sth->execute( $lastname );
	    }
	} else { # print an error....
	    print '<p><b>'. $lex{'Entry Error'}. ': '. $lex{'No Student(s) Found'}.".</b></p>\n";
	    print "</body></html>\n";
	    return; 
	}

    } # Last Else


    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    $rows = $sth->rows;
    if ($rows < 1) { 
	print '<p><b>'. $lex{'No Student(s) Found'}. ".</b></p>\n";
	print "</body></html>\n"; 
	return; 
    } 


    delete $arr{clone}; # remove so will correctly load on looping...

    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";

    # Loop through and display all records.
    while ( my ( $studnum, $lastname, $firstname ) = $sth->fetchrow ) {

	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	print "<tr><td>";
	print "<form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"clonestudnum\" value=\"$studnum\">\n";

	foreach my $key (keys %arr) {
	    print "<input type=\"hidden\" name=\"$key\" value=\"$arr{$key}\">\n";
	    #print "K:$key V:$arr{$key}<br>\n";
	}
	print "$firstname $lastname ($studnum)\n";
	print "<input type=\"submit\" value=\"". $lex{'Clone this record'}. "\">\n";
	print "</form></td></tr>\n";

    } # End of Loop

    print "</table></body></html>\n";

    exit;

}
