#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Name' => 'Name',
	   'Date' => 'Date',
	   'Description' => 'Description',
	   'Are you sure you want to delete this record?' => 
	     'Are you sure you want to delete this record?',
	   'Main' => 'Main',
	   'Delete Transfers' => 'Delete Transfers',
	   'Record Deletion Failed' => 'Record Deletion Failed',
	   'Please contact' => 'Please contact',
	   'Record Deleted' => 'Record Deleted',
	   'Edit/View Another Record' => 'Edit/View Another Record',
	   'Error' => 'Error',
	   'Name' => 'Name',
	   'Date' => 'Date',
	   'Delete the Record(s)' => 'Delete the Record(s)',
	   'Student Not Found' => 'Student Not Found',
	   'Type' => 'Type',
	   'Yes' => 'Yes',

	   );

my $self = 'transdel.pl';

use CGI;
use DBI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Delete Transfers'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\"> 
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]<center>\n";

if ( $arr{deleteflag} ) {
    deleteRecord();
}

$sth = $dbh->prepare("select studnum, type, lastname, firstname, middlename, 
 date, description from transfer where id = ?"); 
$sth->execute( $arr{id} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my ( $studnum, $type, $lastname, $firstname, $middlename, $date, $description ) = 
    $sth->fetchrow;

if ( not $studnum ) {
    print "<h1>". $lex{'Student Not Found'}. "</h1>\n";
    print "</body></html>\n";
    die;
}


print "<center><h1>". $lex{'Delete Transfers'}. "</h1>\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

print "<tr><td align=\"right\"><b>". $lex{Type}. "</b></td><td>$type</td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Name}. "</b></td>\n";
print "<td>$firstname $middlename $lastname ($studnum)</td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Date}. "</b></td>\n";
print "<td>$date</td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{Description};
print "</b><td>$description</td></tr></table>\n";

print '<p><em>'. $lex{'Are you sure you want to delete this record?'};
print "</em></p><form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$arr{id}\">\n";
print "<input type=\"hidden\" name=\"deleteflag\" value=\"1\">\n";
print "<input type=\"submit\" value=\"". $lex{Yes}. q{, }. $lex{'Delete the Record(s)'}. "\">\n";

print "</center></form></body></html>\n";



#---------------
sub deleteRecord {
#---------------

    delete $arr{deleteflag};

    my $sth = $dbh->prepare("delete from transfer where id = ?");
    $sth->execute( $arr{id} );
    
    if ( $DBI::errstr ) {
	print $lex{'Record Deletion Failed'}. q{ }. $lex{'Please contact'};
	print " $adminname<br>$DBI::errstr\n";
    } else {
	print '<h1>', $lex{'Record Deleted'}. ".</h1>\n";
    }

    print "<table cellpadding=\"0\"><tr><td valign=\"top\">\n";

    print "<form action=\"transview.pl\" method=\"post\">\n";
    print "[ <input type=\"submit\" value=\"". $lex{'Edit/View Another Record'}. "\">\n";
    print "<select name=\"sort\"><option>". $lex{Date}. "</option><option>";
    print $lex{Name}. "</option></select></form>\n";

    print "</td><td valign=\"top\">| <a href=\"$homepage\">". $lex{Main}. "</a> ]</td>\n";
    print "</tr></table></center></body></html>\n";

    exit;

}
