#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ( 'Edit Transfers' => 'Edit Transfers',
	    'Main' => 'Main',
	    'Last Name' => 'Last Name',
	    'First Name' => 'First Name',
	    'Middle Name' => 'Middle Name',
	    'Birthdate' => 'Birthdate',
	    'Update Entry' => 'Update Entry',
	    'Edit Another Record' => 'Edit Another Record',
	    'Your update is now stored' => 'Your update is now stored',
	    'There was an error storing your data' => 'There was an error storing your data',
	    'Please contact' => 'Please contact',
	    'Error' => 'Error',
	    'Student Number' => 'Student Number',
	    'Date' => 'Date',
	    'Type' => 'Type',
	    'Entry Type' => 'Entry Type',
	    'Exit Type' => 'Exit Type',
	    'Province' => 'Province',
	    'Country' => 'Country',
	    'Description' => 'Description',
	    'Identity Number' => 'Identity Number',

	   );

my $self = 'transed.pl';

use CGI;
use DBI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

$q = new CGI;
print $q->header( -charset, $charset ); 
%arr = $q->Vars;

$dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

# Print Page Head
print "$doctype\n<html><head><title>". $lex{'Edit Transfers'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

if ( $arr{updateflag} ) {
    delete $arr{updateflag};
    updateRecord();
}


$sth = $dbh->prepare("select * from transfer where id = ?"); 
$sth->execute( $arr{id} );
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr;}
@arr = $sth->fetchrow;


# Top of Page
print '<h1>'. $lex{'Edit Transfers'}. "</h1>
<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"updateflag\" value=\"1\">\n";


print "<input type=\"hidden\" name=\"id\" value=\"$arr{id}\">\n";
print "<table>\n";

print "<tr><td align=\"right\">". $lex{'Student Number'};
print "</td><td><b>$arr[1]</b></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Last Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"lastname\" size=\"20\" value=\"$arr[10]\" ";
print "maxlength=\"40\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'First Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"firstname\" size=\"20\" value=\"$arr[11]\" ";
print "maxlength=\"40\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Middle Name'}. "</td>\n<td>";
print "<input type=\"text\" name=\"middlename\" size=\"20\" value=\"$arr[12]\" ";
print "maxlength=\"40\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Birthdate}. "</td>\n<td>";
print "<input type=\"text\" name=\"birthdate\" size=\"12\" value=\"$arr[13]\">\n";
print "</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Identity Number'}. "</td>\n<td>";
print "<input type=\"text\" name=\"provnum\" size=\"11\" value=\"$arr[14]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Date}. "</td>\n<td>";
print "<input type=\"text\" name=\"date\" size=\"11\" value=\"$arr[2]\" ";
print "maxlength=\"11\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Type}. "</td>\n<td>";
print "<input type=\"text\" name=\"type\" size=\"10\" value=\"$arr[3]\" ";
print "maxlength=\"10\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Entry Type'}. "</td>\n<td>";
print "<input type=\"text\" name=\"entrytype\" size=\"4\" value=\"$arr[5]\" ";
print "maxlength=\"8\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Exit Type'}. "</td>\n<td>";
print "<input type=\"text\" name=\"exittype\" size=\"4\" value=\"$arr[6]\" ";
print "maxlength=\"8\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Province}. "</td>\n<td>";
print "<input type=\"text\" name=\"prov\" size=\"8\" value=\"$arr[7]\" ";
print "maxlength=\"8\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Country}. "</td>\n<td>";
print "<input type=\"text\" name=\"country\" size=\"8\" value=\"$arr[8]\" ";
print "maxlength=\"8\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Description}. "</td>\n<td>";
print "<input type=\"text\" name=\"description\" size=\"60\" value = \"$arr[4]\" ";
print "maxlength=\"255\"></td></tr>\n";

print "<tr><td></td><td><input type=\"submit\" value=\"". $lex{'Update Entry'};
print "\"></td></tr>\n";

print "</table></form></body></html>\n";


#---------------
sub updateRecord {
#---------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $id = $arr{id};
    delete $arr{id};
    
    foreach my $key ( sort keys %arr ) { 
	$sth = $dbh->prepare("update transfer set $key = ? where id = ?");
	$sth->execute( $arr{$key}, $id );
    }

    if ( not $DBI::errstr ) {
	print '<h3>'. $lex{'Your update is now stored'}. ".</h3>\n";
    } else {
	print '<h3>'. $lex{'There was an error storing your data'}. ".<br>\n";
	print $lex{'Please contact'};
	print " $adminname <a href=\"mailto:$adminemail\">$adminemail</a> ]<br>\n";
	print $DBI::errstr, "\n";
    }

    print "<p>[ <a href=\"transview.pl\">". $lex{'Edit Another Record'}. "</a> | ";
    print "<a href=\"$homepage\">". $lex{Main}. "</a> ]</p></body></html>\n";

    exit;

}
