#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View/Edit Transfer Records' => 'View/Edit Transfer Records',
	   'Name' => 'Name',
	   'Bdate' => 'Bdate',
	   'Ident' => 'Ident',
	   'Date' => 'Date',
	   'Type' => 'Type',
	   'Description' => 'Description',
	   'Delete' => 'Delete',
	   'Not Found' => 'Not Found',
	   'Main' => 'Main',
	   'Sort by Date' => 'Sort by Date',
	   'Sort by Student' => 'Sort by Student',
	   'Error' => 'Error',
	   'Click on <b>Name</b> to Edit Record' => 'Click on <b>Name</b> to Edit Record',


	   );

my $self = 'transview.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

if ( uc($arr{sort}) eq uc($lex{Name}) ){
    $sort = 'order by lastname, firstname,studnum, date desc';
} else { # sort by date
    $sort = 'order by date desc, lastname, firstname';
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

$sth = $dbh->prepare("select * from transfer $sort");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}


print "$doctype\n<html><head><title>". $lex{'View/Edit Transfer Records'}. "</title>
 <link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
 $chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$self?sort=". $lex{Date}. "\">". $lex{'Sort by Date'}. "</a> |\n";
print "<a href=\"$self?sort=". $lex{Name}. "\">". $lex{'Sort by Student'}. "</a> ]\n";

print "<center><h1>". $lex{'View/Edit Transfer Records'}. "</h1>\n";

print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";
print '<caption>'. $lex{'Click on <b>Name</b> to Edit Record'}. "</caption>\n";
print '<tr><th>'. $lex{Name}. '</th><th>'. $lex{Bdate}. q{/}. $lex{Ident};
print '</th><th>'. $lex{Date}. '</th><th>'. $lex{Type}. '</th><th>';
print $lex{Description}. '</th><th>'. $lex{Delete}. "</th></tr>\n";

$currdate = -1;


while ( my ( $id, $studnum, $date, $type, $description, $entrytype,
  $exittype, $prov, $country, $utag, $lastname, $firstname, $middlename,
  $birthdate, $provnum ) = $sth->fetchrow) {
    
    $olddate = $currdate;
    if ( $arr{sort} eq $lex{Date} ){ 
	$currdate = $date; 
    } else { 
	$currdate = $studnum; 
    } # studnum

    if ( $currdate ne $olddate ) {
	if ($color eq "blue"){ $color = "gray";} else { $color = "blue"; } 
    }
    
    if ( not $lastname ) { # no lastname...
	my $sth1 = $dbh->prepare("select lastname, firstname from studentall 
         where studnum = ?");
	$sth1->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth1->fetchrow;
	if ( not $lastname ) { # still no lastname....
	    $lastname = '<font color="red">'. $lex{'Not Found'}. '</font>';
	}
    }

    print "<tr class=\"$color\"><td><a href=\"transed.pl?id=$id\">\n";
    print "<b>$lastname</b>, $firstname $middlename ($studnum)</a></td>\n";
    print "<td>$birthdate / $provnum</td><td>$date</td><td>$type</td><td>$description</td>\n";
    print "<td><a href=\"transdel.pl?id=$id\">". $lex{Delete}. "!</a></td></tr>\n";

}

print "</table></body></html>\n";
