#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

use CGI;
use DBI;

my %lex = ( 'Delete Waiting List Member' => 'Delete Waiting List Member',
	    'Main' => 'Main',
	    'Eoy' => 'Eoy',
	    'Are you sure you want to delete this record?' => 
	      'Are you sure you want to delete this record?',
	    'Delete the Record' => 'Delete the Record',
	    'Record Deletion Failed' => 'Record Deletion Failed',
	    'Please contact' => 'Please contact',
	    'View Waiting List' => 'View Waiting List',
	    'deleted' => 'deleted',
	    'Name' => 'Name',
	    'Enrol Date' => 'Enrol Date',
	    'Wait Number' => 'Wait Number',
	    'Description' => 'Description',
	    'Error' => 'Error',
	    'Yes' => 'Yes',

	    );

my $self = 'waitdel.pl';

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

$sth = $dbh->prepare("select studnum, enroldate, waitnumber, description 
  from prereg_waitlist where id = ?"); 
$sth->execute( $arr{id} );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ($studnum, $enroldate, $waitnumber, $description) = $sth->fetchrow;


$sth = $dbh->prepare("select lastname, firstname from prereg where studnum = ?");
$sth->execute( $studnum );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;

print "$doctype\n<html><head><title>".$lex{'Delete Waiting List Member'}."</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n[ <a href=\"$homepage\">";
print $lex{Main}, "</a> | <a href=\"$eoypage\">";
print $lex{Eoy}, "</a> ]<center><h1>";
print $lex{'Delete Waiting List Member'}. "</h1>\n";

if ( $arr{deleteflag} ) {
    deleteRecord();
}

print "<table>
 <tr><td align=\"right\"><b>". $lex{'Name'}. "</b></td><td>$firstname $lastname</td></tr>
 <tr><td align=\"right\"><b>". $lex{'Enrol Date'}. "</b></td><td>$enroldate</td></tr>
 <tr><td align=\"right\"><b>". $lex{'Wait Number'}. "</b></td><td>$waitnumber</td></tr>
 <tr><td align=\"right\"><b>". $lex{'Description'}. "</b></td><td>$description</td></tr>
 </table>\n";

print "<p><em>".$lex{'Are you sure you want to delete this record?'}."</em></p>
 <form action=\"$self\" method=\"post\">
 <input type=\"hidden\" name=\"itemid\" value=\"$arr{id}\">
 <input type=\"hidden\" name=\"name\" value=\"$firstname $lastname\">
 <input type=\"hidden\" name=\"studnum\" value=\"$studnum\">
 <input type=\"hidden\" name=\"deleteflag\" value=\"1\">
 <input type=\"submit\" value=\"".$lex{Yes}. q{, }. $lex{'Delete the Record'}."\"></center>
 </form></body></html>\n";


#---------------
sub deleteRecord {
#---------------

    delete $arr{deleteflag}; # don't need this...
    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    $sth = $dbh->prepare("delete from prereg_waitlist where id = ?");
    $sth->execute( $arr{itemid} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    $sth = $dbh->prepare("delete from prereg where studnum = ?");
    $sth->execute( $arr{studnum} );

    if ( $DBI::errstr ) {
	print $lex{'Record Deletion Failed'}. q{. }. $lex{'Please contact'}. " $adminname<br>\n";
	print $DBI::errstr."\n";
    } else {
	print "<h1>$arr{name} ". $lex{deleted}. ".</h1>\n";
    }

    print "<p>[ <a href=\"waitview.pl\">". $lex{'View Waiting List'}. "</a> ]</p>\n";
    print "</center></body></html>\n";

    exit;
}
