#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ( 'Waiting List Select' => 'Waiting List Select',
	    'Please select waiting list students to transfer into normal student table' =>
	      'Please select waiting list students to transfer into normal student table',
	    'Student' => 'Student',
	    'Select' => 'Select',
	    'Wait#' => 'Wait#',
	    'Date' => 'Date',
	    'Description' => 'Description',
	    'Add Waiting List Students to Student Table' => 
	      'Add Waiting List Students to Student Table',
	    'Main' => 'Main',
	    'Duplicate Student Number' => 'Duplicate Student Number',
	    'Skipping' => 'Skipping',
	    'Your waiting list students are now in the student table' => 
	      'Your waiting list students are now in the student table',
	    'There was an error storing your data' => 'There was an error storing your data',
	    'Contact' => 'Contact',
	    'There was an error removing the student from the prereg/waitlist student table' =>
	      'There was an error removing the student from the prereg/waitlist student table',
	    'Error' => 'Error',

	   );

my $self = 'waitxfer.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


print "$doctype\n<html><head><title>". $lex{'Waiting List Select'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

if ($arr{updateflag}) {
    delete $arr{updateflag};
    doTransfers();
}


my $sth = $dbh->prepare("select * from prereg_waitlist order by waitnumber");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }


print '<center><h1>'. $lex{'Waiting List Select'}. "</h1>\n<p>";
print $lex{'Please select waiting list students to transfer into normal student table'};
print "</p>\n"; 

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"updateflag\" value=\"1\">\n";

print "<table  border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Student}. '</th><th>'. $lex{'Wait#'}.'</th><th>'. $lex{Date}.'</th><th>';
print $lex{Description}.'</th><th>'. $lex{Select}. "</th></tr>\n";

my $sth1 = $dbh->prepare("select lastname, firstname from prereg where studnum = ?");

while ( my ( $id, $studnum, $enroldate, $waitnumber, $description) = $sth->fetchrow ) {

    $sth1->execute($studnum);
    my ($lastname, $firstname) = $sth1->fetchrow;

    print "<tr><td><b>$lastname</b> $firstname ($studnum)</td>\n";
    print "<td align=\"center\">$waitnumber</td><td>$enroldate</td>\n";
    print "<td>$description</td><td align=\"center\">";
    print "<input type=\"checkbox\" name=\"$studnum\" value=\"1\"></td></tr>\n";

} # End of loop

print "<tr><td colspan=\"5\" align=\"center\">";
print "<input type=\"submit\" value=\"";
print $lex{'Add Waiting List Students to Student Table'};
print "\"></td></tr></table></form></body></html>\n";


#--------------
sub doTransfers {
#--------------

    foreach my $key ( keys %arr) {

	my $sth = $dbh->prepare("select * from prereg where studnum = ?");
	$sth->execute( $key );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	@student = $sth->fetchrow;
	
	# Check for existing student number.
	$sth = $dbh->prepare("select count(*) from student where studnum = ?");
	$sth->execute( $key );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my $count = $sth->fetchrow;
	if ( $count  > 0 ){ # We have a duplicate record coming out of prereg.
	    print '<h1>'. $lex{'Duplicate Student Number'};
	    print " - $student[2] $student[1]</h1>\n<h1>";
	    print $lex{Skipping}. "</h1>\n";
	    next;
	}

	# Prepare student array for record entry
	$student[0] = $sql{default};  # reset the studid/id
	foreach $student (@student){ 
	    #$student =~ s/'/''/g;
	    $student = "\'".$student."\',";
	}
	chop $student[$#student]; # Chop trailing comma in last element

	$sth = $dbh->prepare("insert into student values (@student)");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

	my $entrytype = '18'; # New Enrollment, no previous schooling.

	$sth2 = $dbh->prepare("insert into transfer values (
         $sql{default}, '$key', now(),'enrol', 'Preregistration','$entrytype', $sql{default},
         $sql{default} ,$sql{default},'Y', $student[1] $student[2] $student[3] $student[8]
         $sql{ddfault} )"); 

	# NOTE: The student fields already have single quotes and trailing comma!
	$sth2->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

	# Now delete record from existng prereg and prereg_waitlist
	$sth = $dbh->prepare("delete from prereg where studnum = ?"); 
	$sth->execute( $key );

	$sth = $dbh->prepare("delete from prereg_waitlist where studnum = ?"); 
	$sth->execute( $key );


	if ( $DBI::errstr) {
	    print '<h3>';
	    print $lex{'There was an error removing the student from the prereg/waitlist student table'};
	    print ".<br>\n". $lex{Contact};
	    print " $adminname [ <a href=\"mailto:$adminemail\">$adminemail</a> ]<br>\n";
	    print "$DBI::errstr</h3>";
	    die;
	}


    } # end of Loop 

    if (not $DBI::errstr ) {
	print '<h3>'. $lex{'Your waiting list students are now in the student table'}. ".</h3>\n";

    } else {
	print '<h3>'. $lex{'There was an error storing your data'}. ".<br>\n";
	print $lex{Contact};
	print " $adminname [ <a href=\"mailto:$adminemail\">$adminemail</a> ]<br>\n";
	print $DBI::errstr, "\n";

    }

    print "<p>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]</p></body></html>\n";

    exit;

}
