#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Withdraw Student' => 'Withdraw Student',
	   'Student Not Found' => 'Student Not Found',
	   'Your student is now moved to the withdrawn student table' =>
	     'Your student is now moved to the withdrawn student table',
	   'There was an error removing the student from the student database' =>
	     'There was an error removing the student from the student database',
	   'Please contact' => 'Please contact',
	   'Main' => 'Main',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

$q = new CGI;
print $q->header( -charset, $charset ); 
%arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my %m;
# Create mapping hash between name and the array index variable of value.
# This will remove dependency on array index values with restructured student tables.
$sth = $dbh->prepare("select fieldid, arrayidx from meta 
  where tableid = 'student' order by arrayidx");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die "$DBI::errstr";}
while (my ($fi,$idx) = $sth->fetchrow) {
    $m{$fi} = $idx;
}


my $studnum = $arr{studnum};
my $description = $arr{description};
my ($dud, $exittype) = split /\(/,$arr{exittype};
chop $exittype; # remove trailing bracket.


# Page Header.
print "$doctype\n<html><head><title>". $lex{'Withdraw Student'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

#foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

$sth = $dbh->prepare("select * from student where studnum = '$studnum'"); 
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
$rows = $sth->rows;
@student = $sth->fetchrow;

if ($rows < 1) { #Error!
    print '<h1>'. $lex{'Student Not Found'}. "!</h1></body></html>\n";
    die;
}

$student[0] = $sql{default};  # reset the studid/id.
$student[$m{alias}] = '';     # reset the alias; use mapping hash
foreach my $student (@student){ 
    $student =~ s/'/''/g;
    if ($student eq $sql{default}) { $student = $student.",";}
    else {$student = "\'".$student."\',";}
}
chop $student[$#student]; # Chop trailing comma in last element

$sth = $dbh->prepare("insert into studentwd values (@student)");
$sth->execute;


if ( not $DBI::errstr){

    print '<h3>'. $lex{'Your student is now moved to the withdrawn student table'}. ".</h3>";
    $sth = $dbh->prepare("delete from student where studnum = ?"); 
    $sth->execute( $studnum );
    if ( $DBI::errstr) {
	print '<h3>';
        print $lex{'There was an error removing the student from the student database'}.". \n";
	print $lex{'Please contact'}. " $adminname [ ";
	print "<a href=\"mailto:$adminemail\">$adminemail</a><br>\n";
	print $DBI::errstr. "</h3>\n";
	die $DBI::errstr;
    }

    $description =~ s/'/''/g;

    # Insert a transfer record...
    chop $student[$m{provnum}]; # remove trailing comma from provnum (state number)
    $sth2 = $dbh->prepare("insert into transfer values (
      $sql{default},'$studnum','$arr{date}','withdraw','$description', NULL,
      '$exittype','$arr{country}','$arr{prov}', 'Y',
      $student[$m{lastname}] $student[$m{firstname}] $student[$m{initial}] $student[$m{birthdate}] $student[$m{provnum}] )"); 
      # no entrytype since this is a withdrawal.
 
    $sth2->execute;
    if ($DBI::errstr) { print "Entry Table error: $DBI::errstr\n"; }

} else { # database error

    print '<h3>'. $lex{'There was an error removing the student from the student database'}." \n";
    print $lex{'Please contact'}. " $adminname [ ";
    print "<a href=\"mailto:$adminemail\">$adminemail</a><br>\n";
    print $DBI::errstr. "</h3>\n";
    die $DBI::errstr;

}

print "<p>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]</p></body></html>\n";
