#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View Configuration Files' => 'View Configuration Files',
	   'Start/End of Year Page' => 'Start/End of Year Page',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Picture' => 'Picture',
	   'Schedule' => 'Schedule',
	   'Transcript' => 'Transcript',
	   'Configuration' => 'Configuration',
	   'current stored term' => 'current stored term',
	   'Term File' => 'Term File',
	   'Student Number File' => 'Student Number File',
	   'next available student number' => 'next available student number',
	   'Main Configuration File' => 'Main Configuration File',
	   'Error' => 'Error',

	   );


use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;
print $q->header( -charset, $charset );


print "$doctype\n<html><head><title>". $lex{'View Configuration Files'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body><a name=\"top\"></a>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";

print "<a href=\"$eoypage\">". $lex{'Start/End of Year Page'}. "</a> ]\n";


# Read Term File
open (TERM,"<../../etc/term") or die "Cannot open term file!";
my $term = <TERM>;
close TERM;

# Read Student Number file
open (STUDNUM,"<../../etc/studentnumber") or die "Cannot open studentnumber file!";
my $studnum = <STUDNUM>;
close STUDNUM;

# Read config file
open (CNF,"<../../etc/admin.conf") or die "Cannot open admin.conf!";

print "<h1>". $lex{'View Configuration Files'}. "</h1>\n";
print "[ <a href=\"#repcard\">". $lex{'Report Card'}. q{ }. $lex{Configuration}. "</a>";
print " | <a href=\"#image\">". $lex{Picture}. q{ }. $lex{Configuration}. "</a>";
print " | <a href=\"#schedule\">". $lex{Schedule}. q{ }. $lex{Configuration}. "</a>\n";
print " | <a href=\"#transcript\">". $lex{Transcript}. q{ }. $lex{Configuration}. "</a> ]\n";


print "<p style=\"font-size: 130%;\"><b>";
print $lex{'Term File'}. ":</b> $term (". $lex{'current stored term'}. ")</p>\n";
print "<p style=\"font-size: 130%;\"><b>". $lex{'Student Number File'}. ":</b> $studnum (";
print $lex{'next available student number'}. ")</p>\n";
print "<p style=\"font-size: 130%;\"><b>". $lex{'Main Configuration File'};
print " (admin.conf):</b></p>\n";
print "<pre>\n";

while (<CNF>) {
   $_ =~ s/password.*/password \*\*hidden\*\*/;
   print $_;
}
print "</pre>\n";

#--------------
# Read and display report card file
open (REP,"<../../etc/repcard.conf") or die "Cannot open repcard.conf!";
print "<a name=\"repcard\"></a>\n"; # anchor for report card config.
print "<p style=\"font-size: 130%;\">[ <a href=\"#top\">Top</a> ] ";
print "<b>". $lex{'Report Card'}. q{ }. $lex{Configuration}. ":</b></p>\n";
print "<pre>\n";
while (<REP>) {
    #$_ =~ s/password.*/password \*\*hidden\*\*/;
    print $_;
}
print "</pre>\n";


# Image Configuration

open (IMG,"<../../etc/image.conf") or die "Cannot open image.conf!";
print "<a name=\"image\"></a>\n"; # anchor for picture config.
print "<p style=\"font-size: 130%;\">[ <a href=\"#top\">Top</a> ] ";
print "<b>". $lex{Picture}. q{ }. $lex{Configuration}. ":</b></p>\n";
print "<pre>\n";
while (<IMG>) {
    #$_ =~ s/password.*/password \*\*hidden\*\*/;
    print $_;
}
print "</pre>\n";


# Schedule

# Read and display schedule configuration file
open (SCH,"<../../etc/schedule.conf") or die "Cannot open schedule.conf!";
print "<a name=\"schedule\"></a>\n"; # anchor for schedule config
print "<p style=\"font-size: 130%;\">[ <a href=\"#top\">Top</a> ] ";
print "<b>". $lex{Schedule}. q{ }. $lex{Configuration}. ":</b></p>\n";
print "<pre>\n";
while (<SCH>) {
    #$_ =~ s/password.*/password \*\*hidden\*\*/;
    print $_;
}
print "</pre>\n";


# Transcripts

# Read and display transcript configuration file
open (TR,"<../../etc/transcript.conf") or die "Cannot open transcript.conf!";
print "<a name=\"transcript\"></a>\n"; # anchor for transcript config
print "<p style=\"font-size: 130%;\">[ <a href=\"#top\">Top</a> ] ";
print "<b>". $lex{Transcript}. q{ }. $lex{Configuration}. ":</b></p>\n";
print "<pre>\n";
while (<TR>) {
    print $_;
}
print "</pre>\n";


print "</body></html>\n";
