#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Date Entry' => 'Date Entry',
	   'Eoy' => 'Eoy',
	   'Main' => 'Main',
	   'Type' => 'Type',
	   'StatHol' => 'StatHol',
	   'Inservice' => 'Inservice',
	   'Holiday' => 'Holiday',
	   'Other' => 'Other',
	   'Description' => 'Description',
	   'Day In Cycle' => 'Day In Cycle',
	   'No' => 'No',
	   'Yes' => 'Yes',
	   'Save Date' => 'Save Date',
	   'Date' => 'Date',
	   'Add Another Date' => 'Add Another Date',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Please record the following error' => 'Please record the following error',
	   'Contact' => 'Contact',
	   'The date is now stored' => 'The date is now stored',
	   'Error' => 'Error',

	   );

my $self = 'dateadd.pl';

use DBI;
use CGI;

# Read Config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset => $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


print "$doctype\n<html><head><title>". $lex{'Date Entry'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";

print "$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$eoypage\">". $lex{Eoy}. "</a> ]\n";

print "<center><h1>". $lex{'Date Entry'}. "</h1><hr width=\"30%\">\n";

# Write the records.
if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    writeDates();
}


print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"writeflag\" value=\"1\">
<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

print "<tr><td align=\"right\">". $lex{Date}. " </td>
<td><input type=\"text\" name=\"date\" id=\"date\" size=\"10\">
<button type=\"reset\" id=\"start_trigger\">...</button></tr>\n";


print "<tr><td align=\"right\">". $lex{Type}. " </td>\n";
print "<td><select name=\"type\">\n";
print "<option>". $lex{StatHol}. "</option><option>". $lex{Inservice}. "</option>\n";
print "<option>". $lex{Holiday}. "</option><option>". $lex{Other};
print "</option></select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Description}. " 1 </td>\n";
print "<td><input type=\"text\" Name=\"field1\" size=\"30\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Description}. " 2 </td>\n";
print "<td><input type=\"text\" Name=\"field2\" size=\"30\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Day In Cycle'}. "? </td>\n";
print "<td><select name=\"dayincycle\"><option>". $lex{No};
print "</option><option>". $lex{Yes};
print "</option></select></td></tr>\n";

print "<tr><td colspan=\"2\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{'Save Date'};
print "\"></td></tr></table>\n";

print "</center></form></center>\n";

print "<script type=\"text/javascript\">
  Calendar.setup({
    inputField     :    \"date\", // id of the input field
    ifFormat       :    \"%Y-%m-%d\", // format of the input field
    button         :    \"start_trigger\", // trigger for the calendar (button ID)
    singleClick    :    false,        // double-click mode
    step           :    1             // show all years in drop-down boxes (instead of every other year as default)
    });
</script>\n";

print "</body></html>\n";


#-------------
sub writeDates {
#-------------

    # Check for Yes/No values in dayincycle.
    if ( $arr{dayincycle} eq $lex{No} ) {
	$arr{dayincycle} = 'N';
    } # We can leave the yes values...(?). Cursory testing is yes.


    foreach my $key ( keys %arr ) {
	#print "K:$key V: $arr{$key}<br>\n";
	$arr{$key} = $dbh->quote( $arr{$key} );
    }


    $sth = $dbh->prepare("insert into dates values (
      $sql{default}, $arr{date}, $arr{type}, $arr{field1},
      $arr{field2}, $arr{dayincycle} )");
    if ($DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    $sth->execute;

    if ( not $DBI::errstr ) {
	print "<h3>". $lex{'The date is now stored'}. ".</h3>";
    } else {
	print "<h3>". $lex{'There was an error storing your data'};
        print $lex{Contact}. " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Please record the following error'}. ": $DBI::errstr \n";
    }

    print "<p>[ <a href=\"$eoypage\">". $lex{Eoy}. "</a> |\n";
    print " <a href=\"$self\">". $lex{'Add Another Date'}. "</a> ]\n";
    print "</p></center></body></html>\n";

    exit;

}
