#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

use DBI;
use CGI;

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Edit Dates' => 'Edit Dates',
	   'Date' => 'Date',
	   'Type' => 'Type',
	   'Description' => 'Description',
	   'Day in Cycle' => 'Day in Cycle',
	   'Y' => 'Y',
	   'N' => 'N',
	   'Update Record' => 'Update Record',
	   'Your update is now stored' => 'Your update is now stored',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Record the following error' => 'Record the following error',
	   'Edit Another Date' => 'Edit Another Date',
	   'Eoy' => 'Eoy',

	   );

my $self = 'dated.pl';


# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

print "$doctype\n<html><head><title>". $lex{'Edit Dates'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\" ";
print "href=\"/js/calendar-blue.css\" title=\"blue\">\n";
print "<script type=\"text/javascript\" src=\"/js/calendar.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/lang/calendar-en.js\"></script>\n";
print "<script type=\"text/javascript\" src=\"/js/calendar-setup.js\"></script>\n";

print "$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print " <a href=\"$eoypage\">". $lex{Eoy}. "</a> ]\n";
print "<center><h1>". $lex{'Edit Dates'}. "</h1>\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    updateRecord();
}


my $sth = $dbh->prepare("select * from dates where id = ?"); 
$sth->execute( $arr{id} ) ;
my ( $id, $date, $type, $desc1, $desc2, $dayincycle ) = $sth->fetchrow;

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

print "<tr><td align=\"right\">". $lex{Date}. "</td>\n<td>";
print "<input type=\"text\" name=\"date\" id=\"date\" size=\"10\" value=\"$date\">
<button type=\"reset\" id=\"start_trigger\">...</button></tr>\n";


print "<tr><td align=\"right\">". $lex{Type}. "</td>\n<td>";
print "<input type=\"text\" Name=\"type\" size=\"15\" value=\"$type\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Description}. "</td>\n<td>";
print "<input type=\"text\" name=\"desc1\" size=\"35\" value=\"$desc1\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Description}. " 2</td>\n<td>";
print "<input type=\"text\" Name=\"desc2\" size=\"35\" value=\"$desc2\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Day in Cycle'}. "</td>\n<td>";
print "<select name=\"dayincycle\"><option>$dayincycle</option>\n";
print "<option>". $lex{Y}. "</option><option>". $lex{N}. "</option></select></td></tr>\n";

print "</table>\n";
print "<p><input type=\"submit\" value=\"". $lex{'Update Record'}. "\"></p>\n";
print "</form></center>\n";

print "<script type=\"text/javascript\">
  Calendar.setup({
    inputField     :    \"date\", // id of the input field
    ifFormat       :    \"%Y-%m-%d\", // format of the input field
    button         :    \"start_trigger\", // trigger for the calendar (button ID)
    singleClick    :    false,        // double-click mode
    step           :    1             // show all years in drop-down boxes (instead of every other year as default)
    });
</script>\n";

print "</body></html>\n";


#---------------
sub updateRecord {
#---------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $sth = $dbh->prepare("update dates set date = ?, type = ?, desc1 = ?, 
      desc2 = ?, dayincycle = ? where id = ?");

    $sth->execute( $arr{date}, $arr{type}, $arr{desc1}, $arr{desc2},
		   $arr{dayincycle}, $arr{id} );

    if ( not $DBI::errstr ) {
	print "<h3>". $lex{'Your update is now stored'}. "</h3></p>";

    } else {
	print "<h3>". $lex{'There was an error storing your data'}; 
	print $lex{Contact}. " $adminname <a href=\"mailto:$adminemail\">$adminemail</a> \n"; 
	print $lex{'Record the following error'}. ": $DBI::errstr \n";
    }

    print "[ <a href=\"datedeled.pl\">". $lex{'Edit Another Date'}. "</a> |\n";
    print "<a href=\"$eoypage\">". $lex{Eoy}. "</a> ]</p></body></html>\n";

    exit;

}
