#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

use DBI;
use CGI;
use Time::JulianDay;

my %lex = ('View Date Records' => 'View Date Records',
	   'Eoy' => 'Eoy',
	   'Main' => 'Main',
	   'Dates' => 'Dates',
	   'School Year' => 'School Year',
	   'School Start' => 'School Start',
	   'School End' => 'School End',
	   'Term' => 'Term',
	   'Date' => 'Date',
	   'Type' => 'Type',
	   'Description' => 'Description',
	   'Day In Cycle' => 'Day In Cycle',
	   'Grade Grouping' => 'Grade Grouping',
	   'Error' => 'Error',
	   'Day' => 'Day',

	   );


# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select * from dates order by date");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'View Date Records'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$eoypage\">". $lex{Eoy}. "</a> ]\n";
print "<center><h1>$schoolname ". $lex{Dates}. "</h1>\n";

# Print Term Dates stored in /etc/admin.conf
print "<table cellpadding=\"3\" border=\"0\" cellspacing=\"0\">\n";
print "<tr><td>". $lex{'School Year'}. " <b>$schoolyear</b></td></tr>\n";
print "<tr><td>". $lex{'School Start'}. " <b>$schoolstart</b></td></tr>\n";
print "<tr><td>". $lex{'School End'}. " <b>$schoolend</b></td></tr>\n";

foreach my $trm ( sort keys %g_termstart ) {
    if ( ref( $g_termstart{$trm} ) eq 'ARRAY') {
	print "<tr><td><div style=\"border:1px solid gray\">\n";
	print "<h2>". $lex{'Grade Grouping'}. " $trm<br>\n";
	foreach my $grade (sort keys %g_termtype) {
	    if ($g_termtype{$grade} eq $trm) { print "$grade "; }
	}
	print "</h2>\n";
	for my $t ( 1..$#{ $g_termstart{$trm} } ) {
	    print $lex{Term}. " $t : $g_termstart{$trm}[$t] - ";
	    print "$g_termend{$trm}[$t]<br>\n";
	}
	print "</div></td></tr>\n";
	next;
    }

    print "<tr><td>". $lex{Term}. " $trm: $g_termstart{$trm}\n";
    print "- $g_termend{$trm}</td></tr>\n";
}

print "</table><p></p>\n";

# Print the Stored Dates (in Dates Table)
print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Date}. "</th><th>". $lex{Day}. "</th><th>". $lex{Type}. "</th>\n<th>";
print $lex{Description}. " 1</th><th>". $lex{Description}. " 2</th>\n<th>";
print $lex{'Day In Cycle'}. "</th></tr>\n";

while ( my ( $id, $date, $type, $desc1, $desc2, $dayincycle ) = $sth->fetchrow ) {

    my $jd = julian_day( split( /-/, $date ) );
    my $dow = day_of_week($jd) + 1;

    print "<tr><td><b>$date</b></td><td>$dow[$dow]</td><td>$type</td><td>$desc1</td>\n";
    print "<td>$desc2</td><td align=\"center\">$dayincycle</td></tr>";

}

print "</table></body></html>\n";
