#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


# *** Outline ***
# Edit Function to permanently remove students which are already
# withdrawn and will never be registered in this or other division
# schools (ie. graduate, etc)

my %lex = ('Main' => 'Main',
	   'Eoy' => 'Eoy',
	   'Error' => 'Error',
	   'Delete Withdrawn Students' => 'Delete Withdrawn Students',
	   'Delete Selected Students' => 'Delete Selected Students',
	   'Delete demographics, discipline, attendance, and evaluation records' =>
	     'Delete demographics, discipline, attendance, and evaluation records',
	   'Birthdate' => 'Birthdate',
	   'Age' => 'Age',
	   'Transfers' => 'Transfers',
	   'Delete' => 'Delete',
	   'Student' => 'Student',
	   'Record the following error' => 'Record the following error',
	   'Contact' => 'Contact',
	   'Records Deleted' => 'Records Deleted',

	   );


my $self = 'permdel.pl';

use DBI;
use CGI;

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

# Get Date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";
my $currdate1 = "@month[$month] $day, $year";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Delete Withdrawn Students'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$eoypage\">". $lex{Eoy}. "</a> ]\n";

print "<center><h1>". $lex{'Delete Withdrawn Students'}. "</h1>\n";

if ( $arr{deleteflag} ) {
    delete $arr{deleteflag};
    deleteRecords();
}

my $sth = $dbh->prepare("select lastname, firstname, initial, studnum, birthdate
  from studentwd 
  order by birthdate, lastname, firstname");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die "$DBI::errstr : $! \n";}

my $sth1 = $dbh->prepare("select date,type from transfer
 where studnum = ? order by date desc");

print "<p>";
print $lex{'Delete demographics, discipline, attendance, and evaluation records'};
print "</p>\n";

print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";

print "<tr><th>". $lex{Student}. "</th><th>". $lex{Age}. " (";
print $lex{Birthdate}. ")</th><th>". $lex{Transfers}. "</th><th>";
print $lex{Delete}. "</th></tr>\n";

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"deleteflag\" value=\"1\">\n";

print "<tr><td colspan=\"3\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{'Delete Selected Students'};
print "\"></td></tr>\n";

while ( my ( $lastname, $firstname, $initial, $studnum, $birthdate ) = $sth->fetchrow ) {

   # Get any enrollment records...
   my $transfers;
   $sth1->execute( $studnum );
   while ( my ($date,$type) = $sth1->fetchrow) {
       $transfers .= "$date - $type<br>\n";
   }

   my ($age,$mo) = split /:/,&calcAge( $studnum, $currdate );
   print "<tr><td><b>$lastname</b>, $firstname $initial ( $studnum )</td>\n";
   print "<td><b>$age yr</b> $mo mo ($birthdate)</td><td>$transfers</td>\n";
   print "<td><input type=\"checkbox\" name=\"$studnum\" value=\"1\"></td></tr>\n";
}

print "<tr><td colspan=\"3\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{'Delete Selected Students'}. "\"></td></tr>\n";
print "</table></center></form>";
print "</body></html>\n";



########## Functions ##################

#----------
sub calcAge {
#----------

    # Passed (birthdate, $currdate)
    my $birthDate = shift;
    my $currentDate = shift;
    my ($byear,$bmonth,$bday) = split /-/,$birthDate;
    my ($cyear,$cmonth,$cday) = split /-/,$currentDate;
    my $age = $cyear - $byear;
    my $month = $cmonth - $bmonth;

    if ($cmonth < $bmonth){
	$month = $month + 12;
	if ($cday < $bday){ $month--;}
	$age--;
    }
    elsif ($cmonth == $bmonth and $cday < $bday){
	$age--; 
	$month = 11;
    } elsif ($cmonth > $bmonth and $cday < $bday) {
	$month--;
    }
    return "$age:$month";
}

#----------------
sub deleteRecords {
#----------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    foreach my $studnum ( keys %arr ) { 

	# Remove Student record
	my $sth = $dbh->prepare("delete from studentwd where studnum = ?");
	$sth->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

	# Remove Discipline records
	$sth = $dbh->prepare("delete from discipline where userid = ?");
	$sth->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    
	# Remove Attendance Records
	$sth = $dbh->prepare("delete from attend where studentid = ?");
	$sth->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

	# Remove Evaluation Records
	$sth = $dbh->prepare("delete from eval where studnum = ?");
	$sth->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

	# Remove Gradebook Scores
	$sth = $dbh->prepare("delete from gbscore where studnum = ?");
	$sth->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

    }

    if ( not $DBI::errstr ) {
	print "<h3>". $lex{'Records Deleted'}. "</h3>\n";

    } else {
	print "<h3>". $lex{Error}. q{. }. $lex{Contact};
	print " $adminname <a href=\"mailto:$adminemail\">$adminemail</a> \n";
	print $lex{'Record the following error'}. ": $DBI::errstr</h3>\n";

    }

    print "<p>[ <a href=\"$eoypage\">". $lex{Eoy}. "</a> ]</p></body></html>\n";

    exit;

} # end of deleteRecords
