#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('You cannot set both promote and demote!' => 
	     'You cannot set both promote and demote!',
	   'Main' => 'Main',
	   'Eoy' => 'Eoy',
	   'Reset Grade Assignment' => 'Reset Grade Assignment',
	   'Student' => 'Student',
	   'New Grade' => 'New Grade',
	   'Hr/Gr' => 'Hr/Gr',
	   'Update Grades' => 'Update Grades',
	   'Hrm' => 'Hrm',
	   'Gr' => 'Gr',
	   'Your update to student grades is now stored.' => 
	     'Your update to student grades is now stored.',
	   'There was an error storing your data' => 
	     'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Record the following error' => 'Record the following error',
	   'Error' => 'Error',

	   );

my $self = 'resetgrade.pl';


use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

$q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $promote = $arr{promote};
my $demote = $arr{demote};

if ( $demote and $promote ){
    print $lex{'You cannot set both promote and demote!'}. "\n";
    die;
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Reset Grade Assignment'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$eoypage\">". $lex{Eoy}. "</a> ]\n";

print "<center><h1>$schoolname ". $lex{'Reset Grade Assignment'}. "</h1>\n";

if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    resetGrades();
}


# Stuff all grades into an array;
my $sth = $dbh->prepare("select distinct grade from student");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die;}
my $rows = $sth->rows;
my @gradearray;
for ( 1..$rows ){
    $grade = $sth->fetchrow;
    push @gradearray,$grade;
}
@gradearray = sort @gradearray;


# Start Form
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";

print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Student}. "</th><th>". $lex{'Hr/Gr'}. "</th><th>";
print $lex{'New Grade'}. "</th></tr>\n";

print "<tr><td colspan=\"3\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{'Update Grades'}. "\"></td></tr>\n";


my $sth = $dbh->prepare("select studid, lastname, firstname, grade, 
 homeroom from student order by homeroom, grade, lastname,firstname");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

while ( my ($studid, $lastname, $firstname, $grade, $homeroom) = $sth->fetchrow ) {

    my $newgrade;
    if ( $promote ){
	if ($grade eq 'PPK'){ $newgrade = 'PK'; }
	elsif ( $grade eq 'PK'){ $newgrade = 'K'; }
	elsif ( $grade eq 'K'){ $newgrade = '1'; }
	else { $newgrade = $grade + 1; }
    } elsif ( $demote ){
	if ($grade eq 'PK'){ $newgrade = 'PPK';}
	elsif ($grade eq 'K'){ $newgrade = 'PK';}
	elsif ($grade == '1'){ $newgrade = 'K';}
	else { $newgrade = $grade - 1;}
    } else {
	$newgrade = $grade;
    }

    print "<tr><td><b>$lastname</b>, $firstname</td><td>". $lex{Hrm};
    print ":$homeroom / ". $lex{Gr}. ":$grade</td>\n";
    print "<td><select name=\"$studid\"><option>$newgrade</option>\n";
      
    foreach my $grade ( @gradearray ) {
	print "<option>$grade</option>\n";
    }
 
    print "</select></td></tr>\n\n";

} # End of loop 

print "<tr><td colspan=\"3\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{'Update Grades'}. "\"></td></tr>\n";
print "</table></form></body></html>\n";


#--------------
sub resetGrades {
#--------------

    #foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    $sth = $dbh->prepare("select grade from student where studid = ?");
    $sth1 = $dbh->prepare("update student set grade = ? where studid = ?");

    foreach my $key ( keys %arr ) { 

	# Get Current Grade
	$sth->execute( $key );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $grade = $sth->fetchrow;

	# Update if necessary
	if ( $grade ne $arr{$key} ){ # different; do an update
	    $sth1->execute( $arr{$key}, $key );
	    #print "K:$key V:$arr{$key}<br>\n";
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	}
    }

    if (not $DBI::errstr ) {
	print "<h3>". $lex{'Your update to student grades is now stored.'}. "</h3>\n";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. "\n";
	print $lex{Contact}. " $adminname at <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Record the following error'}. ": $DBI::errstr \n";
    }
    print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | <a href=\"$eoypage\">". $lex{Eoy};
    print "</a> ]</p></body></html>\n";

    exit;

}
