#!/usr/bin/perl
# Copyright Les Richardson 2001-2009

my %lex = ('Homeroom Assignment' => 'Homeroom Assignment',
	   'Update Homerooms' => 'Update Homerooms',
	   'Student' => 'Student',
	   'Hroom:Teacher' => 'Hroom:Teacher',
	   'Not Defined' => 'Not Defined',
	   'Not Found' => 'Not Found',
	   'Grade' => 'Grade',
	   'Main' => 'Main',
	   'Eoy' => 'Eoy',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Record the following error' => 'Record the following error',
	   'Error' => 'Error',
	   'Your update is now stored' => 'Your update is now stored',

	   );

my $self = 'resethroom.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Start Page Head
print "$doctype\n<html><head><title>". $lex{'Homeroom Assignment'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$eoypage\">". $lex{Eoy}. "</a> ]\n";

print "<center><h1>". $lex{'Homeroom Assignment'}. "</h1>\n";

# update records if necessary.
if ( $arr{flag} ) {
    delete $arr{flag};
    resetRecords();
}


# Read teachers into a data structure
my $sth = $dbh->prepare("select lastname, firstname, grade, homeroom 
 from staff where homeroom != '' order by grade, lastname, firstname");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


# Put Teachers into Data Struct
while ( my ( $lastname, $firstname, $grade, $homeroom ) = $sth->fetchrow ){

    if ( not $grade ) { next; } # skip staff without grade, since also needed.
    if ( not $homeroom{ $grade } ) {
	$homeroom{ $grade } = { }; # hash constructor
    }
    if ( not $homeroom{$grade}->{$homeroom} ) {
	$homeroom{$grade}->{$homeroom} = [ ]; # array constructor
    }
    push @{ $homeroom{$grade}->{$homeroom} }, "$firstname $lastname";
}

# Now test construction
#foreach my $grade ( sort keys %homeroom ) {
#    foreach my $hrm (sort keys %{ $homeroom{$grade} } ) {
#        foreach my $name ( @{ $homeroom{$grade}->{$hrm} } ){
#	    print "Name: $name  Hr:$hrm Gr:$grade<br>\n";
#	}
#    }
#}


$sth = $dbh->prepare("select studid, lastname, firstname, grade, homeroom from student 
  order by grade, lastname, firstname");
$sth->execute;


print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"flag\" value=\"1\">\n";
print "<input type=\"submit\" value=\"". $lex{'Update Homerooms'}. "\">\n";


my $currgrade = "-1";
my $oldgrade;

while ( my ( $studid, $lastname, $firstname, $grade, $homeroom ) = $sth->fetchrow ) {
    $oldgrade = $currgrade;
    $currgrade = $grade;
    if (not $currgrade){ $currgrade = $lex{'Not Defined'}; }

    if ( $oldgrade ne $currgrade ) { # we have a new grade
	unless ( $oldgrade eq '-1' ){ print "</table>\n\n";}
	print "<p></p><table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
	print "<caption><b>". $lex{Grade}. ": $currgrade</b></caption>\n";
	print "<tr><th>". $lex{Student}. '</th><th>'. $lex{'Hroom:Teacher'}. "</th></tr>\n";
	

	# setup homeroom/teacher choices for this grade
	%hrtable = (); # empty table
	foreach my $hrm ( keys %{ $homeroom{$currgrade} } ) {
	    my $teachernames;
	    foreach my $name ( @{ $homeroom{$currgrade}->{$hrm} } ) {
		$teachernames .= $name. '/';
	    }
	    chop $teachernames; # remove trailing slash;
	    if ( not $teachernames ){ $teachernames = $lex{'Not Found'}; }
	    $hrtable{$hrm} = $teachernames;
	}

    }

    print "<tr><td><b>$lastname</b>, $firstname</td>\n<td>";
    print "<select name=\"$studid\"><option>$homeroom:$hrtable{$homeroom}</option>\n";

    foreach my $hr ( sort keys %hrtable ) {
	if ( $hr eq $homeroom ) { next; }
	print "<option>$hr:$hrtable{$hr}</option>";
    }

    print "</select></td></tr>\n";

} # End of Student Loop

print "</table><input type=\"submit\" value=\"". $lex{'Update Homerooms'}. "\">
 </form></body></html>\n";


#---------------
sub resetRecords {
#---------------

    #foreach my $key ( keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    foreach my $key ( keys %arr ) {
	my ($rmnum, $teacher) = split /:/,$arr{$key};
	$rmnum =~ s/://;
	#print "Room: $rmnum  Snum: $key \n<br>" ;

	$sth = $dbh->prepare("update student set homeroom = ? where studid = ?");
	$sth->execute( $rmnum, $key );
	if ($DBI::errstr ) { print $DBI::errstr; }
    }


    if ( not $DBI::errstr ) {
	print '<p>'. $lex{'Your update is now stored'}. "</p>";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. "\n";
	print $lex{Contact}. " $adminname at <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Record the following error'}. ": $DBI::errstr \n";
    }
    print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | <a href=\"$eoypage\">". $lex{Eoy};
    print "</a> ]</p></body></html>\n";

    exit;

}
