#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

%lex = ( 'Staff Member Entry' => 'Staff Member Entry',
	 'Staff' => 'Staff',
	 'Main' => 'Main',
	 'Eoy' => 'Eoy',
	 'Unable to open template file:' => 'Unable to open template file:',
	 'The staff member is now stored in the database' => 
	   'The staff member is now stored in the database',
	 'Start/End of Year Page' => 'Start/End of Year Page',
	 'Add Another Staff Member' => 'Add Another Staff Member',
	 'Add Another <font color=red>Prereg</font> Staff Member' => 
	   'Add Another <font color=red>Prereg</font> Staff Member',
	 'There was an error storing your data' => 'There was an error storing your data',
	 'Please record the following error' => 'Please record the following error',
	 'Please contact' => 'Please contact',
	 'Add Staff Member Information' => 'Add Staff Member Information',
	 'Warning! You should have a unique userid for each staff.' => 
	     'Warning! You should have a unique userid for each staff.',
	 'This userid exists already exists.' => 'This userid exists already exists.',
	 'Ignore this warning if you are creating another entry' => 
	     'Ignore this warning if you are creating another entry',
	 'for the same staff.' => 'for the same staff.',
	 'You MUST have a unique userid and a password and staff position.' => 
	   'You MUST have a unique userid and a password and staff position.',
	 'Please go back and try again.' => 'Please go back and try again.',
	 'Preregistration' => 'Preregistration',
	 'Required Field' => 'Required Field',
	 'Bold' => 'Bold',
	 'Error' => 'Error',
	 'Password Error' => 'Password Error',

	 );

use CGI;
use DBI;
use Data::Password qw(:all);  # for password checking...

my $self = 'staffadd.pl';

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../../lib/libmeta.pl";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


# Select table to add to; staff or prereg_staff;
my ($table, $tableview);
if ( $arr{tbl} ){ # add to prereg_staff table
    $table = 'prereg_staff';
    $tableview = '<font color=red>'. $lex{Preregistration}. '</font>'. q{ }. $lex{Staff};
} else {
    $table = 'staff';
    $tableview = $lex{Staff};
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>\n";
print $lex{Staff}. q{ }. $lex{'Staff Member Entry'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

print "$chartype\n</head><body>[ <a href=\"$homepage\">";
print $lex{Main}, "</a> | <a href=\"$eoypage\">";
print $lex{Eoy}, "</a> ]<center><h1>";

print $tableview. q{ }. $lex{'Staff Member Entry'}. "</h1>\n";

if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    writeRecord();
}

print "<p><b>". $lex{Bold}. "</b> = ". $lex{'Required Field'}. "<hr></p>\n";


# Read in Template
unless (open (FH,"<../../template/staff.tpl")) {
    print $lex{'Unable to open template file:'},"$!\n";
    die $lex{'Unable to open template file:'},"$!\n";
}
my $text;
{ local $/; $text = <FH>; close FH;}

# Parse for simple field replacement / highlighting  <*name*> elements
while ( $text =~ m/\<\*(.*)\*\>/g){
    push @replace, $1;
}

#print "<br>Replacements:<br>\n",@replace,"<br>\n";

# Create Hash to hold replacement text.
foreach my $val (@replace){
    $replacement{$val} = metaReplace('staff',$val);
}

#print "<br>Replacement Text<br>\n",%replacement,"<br>\n";

# Now put replacement text back in.
$text =~ s{\<\*(.*?)\*\>}
          { exists($replacement{$1}) 
		? $replacement{$1} 
	        : $1
          }gsex;

# now parse for form entry replacement elements  <@name@> 
# Extract fields from template
while ( $text =~ m/\<\@(.*)\@\>/g){
    push @fields, $1;
}

# Preprocess Template for Values 
#$text =~ s/\<\@studnum\@\>/$studnum/;


# get replacement values for fields
foreach my $val (@fields){
    $values{$val} = metaput('staff',$val,$studnum,'edit');
}

# now put field values back into $text variable...
$text =~ s{ \<\@(.*?)\@\> }
{ exists($values{$1}) 
      ? $values{$1} 
  : "$values{$1}-$1"
  }gsex;

# print top of form, then $text, then bottom of page.
print "<form action=\"$self\" method=\"post\"> 
<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";

if ( $table eq 'prereg_staff' ) {
    print "<input type=\"hidden\" name=\"tbl\" value=\"prereg\">\n";
}

print $text,"\n";

print "<input type=\"submit\" value=\"". $lex{'Add Staff Member Information'}. "\">\n";
print "</center></form></center></body></html>\n";



#--------------
sub writeRecord {
#--------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    # Make sure we have userid, password, and position filled....
    if ( not $arr{userid} or not $arr{position} or not $arr{passwd} ){
	print "<h1>". $lex{'You MUST have a unique userid and a password and staff position.'};
	print "\n";
	print $lex{'Please go back and try again.'}. "</h1></body></html>\n";
	exit;
    }

    # Make sure userid doesn't already exist...else warn.
    $sth = $dbh->prepare("select count(*) from $table where userid = ?");
    $sth->execute( $arr{userid} );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    if ( my $count = $sth->fetchrow ) {
	print "<h1>";
	print $lex{'Warning! You should have a unique userid for each staff.'};
	print "<br>". $lex{'This userid exists already exists.'};
	print "<br>\n";
	print $lex{'Ignore this warning if you are creating another entry'}. "<br>\n";
	print $lex{'for the same staff.'}. "</h1>\n";
    }

    # Check for password quality using Data::Password module.
    $MINLEN = $password_minlen;  # from admin.conf settings.
    $MAXLEN = $password_maxlen;
    $DICTIONARY = 4;
    if ( IsBadPassword( $arr{passwd} )) {
	print "<h1 style=\"color:red;\">". $lex{'Password Error'}. "<br>\n";
	print IsBadPassword( $arr{passwd} );
	print "</h1></body></html>\n";
	die IsBadPassword( $arr{passwd} );
    }


    # Create an entry array called "@fields" storing fieldid values.
    $sth = $dbh->prepare("select fieldid from meta
      where tableid = 'staff' order by arrayidx");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    while (my $fld = $sth->fetchrow){
	push @fields,$fld;
    }

    # Populate Hash "%values" with key (ie. fieldid) and value as value
    foreach my $key (keys %arr){
	my ($tb,$fld) = split /:/,$key;
	if ($arr{$key} and $key){ $values{$key} = $arr{$key};}
	#print "K: $key FLD: $fld VAL: $arr{$key}<br>\n";
    }

    #print "<br><br>Hash Values:\n";
    #print %values,"<br>\n";

    # Now run through @fields array and repopulate with values from hash.
    foreach my $fld (@fields){
	if ($values{$fld}){ # if matching hash value exists, use it.
	    $fld = $dbh->quote( $values{$fld} ). q{,}; # fieldid replaced with actual field value.
	} else {
	    $fld = "$sql{default},"; # NULL value
	}
    }
    chop $fields[$#fields]; # chop trailing comma.

    #print "<br><br>Populated Fields Array:",@fields,"<br>\n";


    $sth = $dbh->prepare("insert into $table values (@fields)");
    $sth->execute;

    if (not $DBI::errstr ) {
	print "<h3>";
	print $lex{'The staff member is now stored in the database'};
	print ".</h3></p>";
    } else {
	print "<h3>".$lex{'There was an error storing your data'};
	print $lex{'Please contact'}. " $adminname - ";
	print "<a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Please record the following error'}. " $DBI::errstr";
	print "</h3>\n";
    }

    print "<p>[ <a href=\"$homepage\">".$lex{Main}."</a> | <a href=\"$eoypage\">";
    print $lex{'Start/End of Year Page'};
    print "</a> | \n";
    if ( $arr{tbl} ) {
	print "<a href=\"$self?tbl=prereg\">";
	print $lex{'Add Another <font color=red>Prereg</font> Staff Member'}."</a> ]\n";
    } else {
	print "<a href=\"$self\">". $lex{'Add Another Staff Member'};
	print "</a> ]\n";
    }
    print "</p></center></body></html>\n";

    exit;

}
