#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Edit/Delete' => 'Edit/Delete',
	   'Staff' => 'Staff',
	   'Preregistration' => 'Preregistration',
	   'Main' => 'Main',
	   'Eoy' => 'Eoy',
	   'Staff Member' => 'Staff Member',
	   'User Id' => 'User Id',
	   'Room' => 'Room',
	   'Subject Count' => 'Subject<br>Count',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Error' => 'Error',
	   'Edit/Delete' => 'Edit/Delete',
	   
	   );


use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


# Select table to view; staff or prereg_staff;
my ($table, $tableview);
if ( $arr{tbl} ){ # view prereg_staff table
    $table = 'prereg_staff';
    $tableview = '<font color=red>'. $lex{Preregistration}. q{ }. $lex{Staff}. '</font>';
} else {
    $table = 'staff';
    $tableview = $lex{Staff};
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Edit/Delete'}. q{ }. $lex{Staff}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head>\n";
print "<body>[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print " <a href=\"$eoypage\">". $lex{Eoy}. "</a> ]\n";

print "<center><h1>". $lex{'Edit/Delete'}. " $tableview</h1>\n";


# select values from staff/prereg_staff table.
$sth = $dbh->prepare("select id, lastname, firstname, userid, homeroom 
  from $table order by lastname, firstname");
$sth->execute;
if (DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }


print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{'Staff Member'}. "</th><th>". $lex{'User Id'};
print "</th><th>". $lex{'Room'}. "</th><th>". $lex{'Subject Count'}. "</th><th>";
print $lex{Edit}. "</th><th>";
print $lex{Delete}. "</th></tr>\n";

my $sth1 = $dbh->prepare("select count(*) from subject
  where teacher like ?"); 

while (my ($id, $lastname, $firstname, $userid, $homeroom) = $sth->fetchrow) {

    $sth1->execute("%$userid%");
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth1->fetchrow;

    print "<tr><td><b>$lastname</b>, $firstname</td><td>$userid</td>\n";
    print "<td>$homeroom</td><td>$count</td>\n";

    if ( $arr{tbl} ) {
	print "<td><a href=\"staffed.pl?id=$id&tbl=prereg\">". $lex{Edit}. "</a></td>\n";
	print "<td><a href=\"staffdel.pl?id=$id&tbl=prereg\">". $lex{Delete}. "</a></td></tr>\n";
    } else {
	print "<td><a href=\"staffed.pl?id=$id\">". $lex{Edit}. "</a></td>\n";
	print "<td><a href=\"staffdel.pl?id=$id\">". $lex{Delete}. "</a></td></tr>\n";
    }
}

print "</table></center></body></html>\n";
