#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#  Withdraw Promoted Students from a particular grade. Grade is passed
#   as grade.

my %lex = ('Main' => 'Main',
	   'Eoy' => 'Eoy',
	   'Withdraw Graduating Students' => 'Withdraw Graduating Students',
	   'Uncheck students not graduating' => 'Uncheck students not graduating',
	   'Name' => 'Name',
	   'Select' => 'Select',
	   'Student(s) Not Found' => 'Student(s) Not Found',
	   'Withdraw Selected Students' => 'Withdraw Selected Students',
	   'Withdraw' => 'Withdraw',
	   'Transfer' => 'Transfer',
	   'Graduation' => 'Graduation',
	   'Error' => 'Error',
	   'Insert' => 'Insert',


	   );

my $self = 'withdrawprom.pl';

use DBI;
use CGI;


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;
$grade = $arr{grade}; # passed grade


print "$doctype\n<html><head><title>". $lex{'Withdraw Graduating Students'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print " <a href=\"$eoypage\">". $lex{Eoy}. "</a> ]\n";

print "<center><h1>". $lex{'Withdraw Graduating Students'}. "</h1>\n";

if ( $arr{withdrawflag} ) {
    delete $arr{withdrawflag};
    withdrawStudent();
}


print "<p>". $lex{'Uncheck students not graduating'}. ".</p>\n";

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"withdrawflag\" value=\"1\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

print "<tr><th>". $lex{Name}. "</th><th>". $lex{Select}. "</th></tr>\n"; 

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select lastname, firstname, studnum from student 
  where grade = ? order by lastname, firstname");
$sth->execute( $grade );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my $first = 1;

while ( my ( $lastname, $firstname, $studnum) = $sth->fetchrow ) {
    print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td>\n";
    print "<td><input type=\"checkbox\" name=\"$studnum\" value=\"1\" checked>\n";
    print "</td></tr>\n";
    $first = 0; 
}

if ( $first ) { # No Records
    print "<tr><td colspan=\"2\" align=\"center\"><b>\n";
    print $lex{'Student(s) Not Found'}. "</b></td></tr></table>\n";
    print "</form></center></body></html>\n";
} else {
    print "<tr><td colspan=\"2\" align=\"center\">\n<input type=\"submit\" ";
    print "value=\"". $lex{'Withdraw Selected Students'}. "\"></td></tr></table>\n";
    print "</form></center></body></html>\n";
}



#------------------
sub withdrawStudent {
#------------------

    foreach my $studnum ( keys %arr ) { # loop through passed student numbers

	# Get Student Info
	$sth = $dbh->prepare("select * from student where studnum = ?"); 
	$sth->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; next; }

	my $rows = $sth->rows;
	if ($rows < 1){ 
	    print "<tr><td>". $lex{'Student(s) Not Found'}. ": $studnum</td></tr>\n";
	    next;
	}

	my @student = $sth->fetchrow;

	# Move the student record
	$student[0] = undef;  # reset the studid.
	$student[63] = '';     # reset the alias.
	foreach $student ( @student ){ 
	    $student =~ s/'/''/g; # Watch for hyphenated names, etc.
	    $student = "\'".$student."\',";
	}
	chop $student[$#student]; # Chop trailing comma in last element

	$sth = $dbh->prepare("insert into studentwd values ( @student )");
	$sth->execute;
	if ( $DBI::errstr ) { 
	    print "<tr><td>". $lex{Insert}. q{ }. $lex{Error}. " $student[2] $student[1]";
	    print "</td></tr>\n";
	    next;
	}

	$sth = $dbh->prepare("delete from student where studnum = ?"); 
	$sth->execute( $studnum );
	if ( $DBI::errstr) {
	    print "<tr><td><font color=\"red\">". $lex{Withdraw}. q{ }. $lex{Error};
	    print " $student[2] $student[1]: $DBI::errstr</font></td></tr>\n";
	} else {
	    print "<tr><td>".  $lex{Withdraw}. " - $student[2] $student[1] ". ".</td></tr>\n";
	}

	chop $student[57]; # remove trailing comma
	my $grad = $lex{Graduation};

	$sth2 = $dbh->prepare("insert into transfer values (
         $sql{default},'$studnum',now(),'withdraw','$grad', NULL,
         '$exittype','$country','$prov', 'Y',
         $student[1] $student[2] $student[3] $student[8] $student[57])"); 
	# no entrytype since this is a withdrawal.
 
	$sth2->execute;
	if ($DBI::errstr) { 
	    print "<tr><td><font color=\"red\">". $lex{Transfer}. q{ }. $lex{Error};
	    print " - $student[2] $student[1]: $DBI::errstr\n"; 
	}

    } # End of Student Withdrawal Loop

    print "</table><p>[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$eoypage\">". $lex{Eoy}. "</a> ]</p></body></html>\n";

    exit;

}
