#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Export' => 'Export',
	   'Export Staff Data' => 'Export Staff Data',
	   'Combine failed on input' => 'Combine failed on input',
	   'Download CSV File' => 'Download CSV File',
	   'CSV (Comma Separated Value) can be directly imported into Open Office' =>
	     'CSV (Comma Separated Value) can be directly imported into Open Office',
	   'Note' => 'Note',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;
use Text::CSV_XS;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
print $q->header( -charset, $charset );


my $csv = Text::CSV_XS->new( {binary => 1} );

# Open output file
my $fileName = "teacher$$.csv";
open (EX,">$fileName") || die "Can't open Export file $fileName";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);
my $sth = $dbh->prepare("select * from staff order by lastname,firstname");

$sth->execute;

print "$doctype\n<html><head><title>". $lex{'Export Staff Data'}. "</title>
<link rel=\"stylesheet\" type=\"text/css\" href=\"$css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$exppage\">". $lex{Export}. "</a> ]\n";

print "<center><h1>". $lex{'Export Staff Data'}. "</h1>\n";

while (my @arr = $sth->fetchrow) {
    shift @arr; # remove first element - teachid, not useful.
    foreach my $element (@arr) {  # strip CR/LF
	$element =~ s/\n/ /g;
	$element =~ s/\r/ /g;
    }  

    if ($csv->combine(@arr)) {
	my $record = $csv->string;
	print EX $record, "\r\n";
    } else {
	my $err = $csv->error_input;
	print $lex{'Combine failed on input'}. ": $err\n\n";
    }
}

close EX;
system("mv $fileName $downloaddir");

print "<p><a href=\"$webdownloaddir/$fileName\">
 <font size=+2>". $lex{'Download CSV File'}. "</font></a></p>\n";

print "<p><strong>". $lex{Note}. ":</strong>";
print $lex{'CSV (Comma Separated Value) can be directly imported into Open Office'};
print "</p></center>\n</body></html>\n";
