#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Main' => 'Main',
	   'Export' => 'Export',
	   'Student' => 'Student',
	   'Gr' => 'Gr',
	   'Select' => 'Select',
	   'Download CSV File of Withdrawn Students' => 'Download CSV File of Withdrawn Students',
	   'Error' => 'Error',
	   'Students' => 'Students',

	   );


my $self = 'expwdstud.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{Export}. q{ }. $lex{Students}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main};
print "</a> | <a href=\"$exppage\">". $lex{Export}. "</a> ]\n";

print "<center><h1>$schoolname - ". $lex{Export}. q{ }. $lex{Students}. "</h1>\n";


if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    writeRecords();
}


# Show students to select.
$sth = $dbh->prepare("select studid, lastname, firstname, grade, 
  studnum from studentwd order by lastname,firstname");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
$rows = $sth->rows;

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";
print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Student}. "</th><th>". $lex{Gr}. "</th><th>". $lex{Student};
print " #</th><th>". $lex{Select}. "</th></tr>\n";

for ($i=1; $i <= $rows; ++$i) {
    my @arr = $sth->fetchrow;
  
    print "<tr><td><b>$arr[1]</b>, $arr[2] </td><td>$arr[3]</td><td>$arr[4]</td>\n";
    print "<td align=\"center\"><input type=\"checkbox\" name=\"$arr[0]\" value=\"1\"></td></tr> \n";

} # End of loop

print "<tr><td colspan=\"4\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{Export}. q{ }. $lex{Students}. "\"></td></tr>\n";
print "</table></form></body></html>\n";


#---------------
sub writeRecords {
#---------------

    my $csv = Text::CSV_XS->new( {binary => 1} );

    # Open output file
    my $fileName = "wdstud$$.csv";
    open (EX,">$fileName") || die "Can't open Export file $fileName";

    foreach my $key (keys %arr) {

	#print "Key: $key  Value: $arr{$key}\n";
	if ($arr{$key} == 1) {
	    $sth = $dbh->prepare("select * from studentwd where studid = ?");
	    $sth->execute( $key );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my @student = $sth->fetchrow;

	    foreach $element (@student) {  # strip CR/LF
		$element =~ s/\n/ /g;
		$element =~ s/\r/ /g;
	    }  

	    if ($csv->combine(@student)) {
		my $record = $csv->string;
		print EX $record, "\r\n";
	    } else {
		my $err = $csv->error_input;
		print "Combine failed on input: ",$err,":\n\n";
	    }
	} #end of IF value == 1;

    }  # End of Loop

    close EX;
    system("mv $fileName $downloaddir");

    print "<p><a href=\"$webdownloaddir/$fileName\">\n";
    print $lex{'Download CSV File of Withdrawn Students'}. "</a></p>\n";

    print "</body></html>\n";

    exit;

}
