#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Delete Fees' => 'Delete Fees',
	   'Main' => 'Main',
	   'Fees' => 'Fees',
	   'Withdrawn Students' => 'Withdrawn Students',
	   'No' => 'No',
	   'Delete Charges' => 'Delete Charges',
	   'Current Students' => 'Current Students',
	   'Record(s) Deleted' => 'Record(s) Deleted',
	   'Delete More Records' => 'Delete More Records',
	   'Error' => 'Error',

	   );

my $self = 'assessdeled.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Page Header
print "$doctype\n<html><head><title>". $lex{'Delete Fees'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$feespage\">". $lex{'Fees'}. "</a> ]\n";

print "<h1>". $lex{'Delete Fees'}. "</h1>\n";


if ( not $arr{studnum} ) {
    showStartPage();
} else {
    if ( not $arr{deleteflag} ) {
	selectTransactions( $arr{studnum} );
    } else {
	# remove extra hash elements
	delete $arr{deleteflag};
	delete $arr{studnum};

	deleteTransactions();
    }
}


#---------------------
sub selectTransactions {
#---------------------
    my $studnum = shift;

    # Display student name
    my $sth = $dbh->prepare("select lastname, firstname from studentall
     where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow;
    print "<h3>$firstname $lastname</h3>\n";

    # Find and display the transactions
    $sth = $dbh->prepare("select id, trans_date, name, description, total 
     from fees_jrl where trans_type = 'chg' and paid_id is NULL and studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    # Start form and table
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Delete Charges'}. "\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
    print "<input type=\"hidden\" name=\"deleteflag\" value=\"1\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

    while ( my ($id, $trans_date, $name, $description, $total ) = $sth->fetchrow ) {

	print "<tr><td><input type=\"checkbox\" name=\"$id\" value=\"1\"></td>\n";
	print "<td>$trans_date</td><td>$name</td><td>$description</td><td>$total</td></tr>\n";

    }

    print "</table></form>\n";
    print "</body></html>\n";

    exit;

}


#----------------
sub showStartPage {
#----------------

    # Find outstanding Bills
    my $sth1 = $dbh->prepare("select lastname, firstname from studentall
     where studnum = ?");

    my $sth = $dbh->prepare("select distinct studnum from fees_jrl as f 
     where f.trans_type = 'chg' and f.paid_id is NULL");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my %students;
    while ( my $studnum = $sth->fetchrow ) {

	$sth1->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname) = $sth1->fetchrow;

	$students{"$lastname:$firstname:$studnum"} = $studnum;
    }

    my $sth2 = $dbh->prepare("select count(*) from student
     where studnum = ?");
    
    my (@active, @inactive);
    foreach my $key ( sort keys %students ) {
	my ($ln, $fn, $studnum ) = split /:/, $key;

	$sth2->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	if ( $sth2->fetchrow ) { # if true (1), then active student
	    push @active, $studnum;
	} else { # withdrawn
	    push @inactive, $studnum;
	}
	    
    }

    # Now parse each array, starting with withdrawn.
    print "<h3>". $lex{'Withdrawn Students'}. "</h3>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

    if ( not @inactive ) { # no withdrawn students
	print "<tr><td>". $lex{No}. q{ }. $lex{'Withdrawn Students'}. "</td></tr>\n";
    } else {
	foreach my $studnum ( @inactive ) {
	    $sth1->execute( $studnum );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my ($lastname, $firstname) = $sth1->fetchrow;

	    print "<tr><td>$firstname $lastname</td><td>\n";
	    print "<form action=\"$self\" method=\"post\">\n";
	    print "<input type=\"submit\" value=\"". $lex{'Delete Charges'}. "\">\n";
	    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\"></form>\n";
	    print "</td></tr>\n";

	}
    }

    print "</table><p></p>\n";


    # Now do active students
    print "<h3>". $lex{'Current Students'}. "</h3>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

    if ( not @active ) { # no Active students
	print "<tr><td>". $lex{No}. q{ }. $lex{'Current Students'}. "</td></tr>\n";
    } else {
	foreach my $studnum ( @active ) {
	    $sth1->execute( $studnum );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my ($lastname, $firstname) = $sth1->fetchrow;

	    print "<tr><td>$firstname $lastname</td><td>\n";
	    print "<form action=\"$self\" method=\"post\">\n";
	    print "<input type=\"submit\" value=\"". $lex{'Delete Charges'}. "\">\n";
	    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\"></form>\n";
	    print "</td></tr>\n";

	}
    }


    print "</table></body></html>\n";

    exit;

}


#---------------------
sub deleteTransactions {
#---------------------

    #foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $sth = $dbh->prepare("delete from fees_jrl where id = ?");

    # Loop through all id's and remove.
    foreach my $id ( keys %arr ) {
	$sth->execute( $id );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    }

    print "<h1>". $lex{'Record(s) Deleted'}. "</h1>\n";

    print "[ <a href=\"$self\">". $lex{'Delete More Records'}. "</a> ]\n";
    print "</body></html>\n";

    exit;

}
