#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = (
	   'View Invoices' => 'View Invoices',
	   'Fees' => 'Fees',
	   'Main' => 'Main',
	   'No Records Found' => 'No Records Found',
	   'Invoice' => 'Invoice',
	   'Top' => 'Top',
	   'Date' => 'Date',
	   'Name' => 'Name',
	   'Description' => 'Description',
	   'Subtotal' => 'Subtotal',
	   'Tax' => 'Tax',
	   'Total' => 'Total',
	   'Owing' => 'Owing',
	   'Paid' => 'Paid',
	   'Error' => 'Error',

	   );

my $self = 'invoiceview.pl';

use DBI;
use CGI;
use Cwd;
use Number::Format qw(round);

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'View Invoices'}. "</title>
 <link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
 </head><body><a name=\"top\"></a>[ <a href=\"$tchpage\">". $lex{Main}. "</a> |\n";
print "<a href=\"/fees.html\">". $lex{Fees}. "</a> ]\n";


# Find Distinct Invoice Numbers (and not Receipt Numbers); push into invnums array
my @invnums;
my $sth = $dbh->prepare("select distinct invoice_number from fees_jrl 
 where invoice_number is not null and trans_type = 'chg' order by invoice_number");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while (my $invnum = $sth->fetchrow ) {
    push @invnums, $invnum;
}

print "<center><h1>". $lex{'View Invoices'}. "</h1>\n";

if (not @invnums) {
    print "<p>". $lex{'No Records Found'}. "</p>\n";
    print "</body></html>\n";
    exit;
}


print "<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\">\n";

foreach my $invnum (@invnums ) {
    printInvoice( $invnum );
}


print "</table>\n";
print "<p>[ <a href=\"$feespage\">". $lex{Fees}. "</a> | <a href=\"#top\">". $lex{Top}. "</a> ]</p>\n";
print "</center></body></html>\n";



#---------------
sub printInvoice {
#---------------

    my $invnum = shift;
    
    my $sth = $dbh->prepare("select * from fees_jrl where invoice_number = ? order by trans_date");
    $sth->execute( $invnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $first = 1;

    my $sth1 = $dbh->prepare("select lastname, firstname from studentall
      where studnum = ?");

    my ($grandTotal, $grandTax, $grandSubtotal, $grandPaid, $grandOwing);

    while ( my ($id, $studnum, $trans_date, $trans_type, $name,
     $description, $subtotal, $tax1, $tax1_name, $tax2, $tax2_name, $tax3,
     $tax3_name, $tax4, $tax4_name, $total, $invoice_number, $invoice_date,
     $paid_id, $paid_part_id, $paid_part_amt) = $sth->fetchrow ) {

	if ( $first ) {

	    # Get Student Name...
	    $sth1->execute( $studnum );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my ($lastname, $firstname) = $sth1->fetchrow;

	    print "<tr><th colspan=\"3\">$firstname $lastname ($studnum)</th><th colspan=\"5\">";
	    print $lex{Invoice}. " $invoice_number - $invoice_date</th></tr>\n";

	    print "<tr><th>". $lex{Date}. "</th><th>". $lex{Name}.   "</th>\n<th>";
	    print $lex{Description};

	    print "</th><th>". $lex{Subtotal}. "</th><th>". $lex{Tax}. "</th><th>". $lex{Total};
	    print "</th><th>". $lex{Paid}. "</th><th>". $lex{Owing}. "</th></tr>\n";

	    $first = 0;
	}

	$subtotal = round( $subtotal, 2);
	my $totaltax = round( $tax1 + $tax2 + $tax3 + $tax4, 2);

	my $paid = 0;
	if ( $paid_id ) { 
	    $paid = $total; 
	} elsif ( $paid_part_id ) {
	    $paid = $paid_part_amt;
	}
	$paid = round( $paid, 2);

	my $owing = round( $total - $paid, 2);

	$grandSubtotal += $subtotal;
	$grandTax += $totaltax;
	$grandTotal += $total;
	$grandPaid += $paid;
	$grandOwing += $owing;

	print "<tr><td>$trans_date</td><td>$name</td><td>$description</td><td>$subtotal</td>\n";
	print " <td>$totaltax</td><td>$total</td><td>$paid</td><td>$owing</td></tr>\n";
    }

    print "<tr style=\"background-color:#DDD;\"><td></td><td></td><td>";
    print $lex{Total}. "</td><td>". round($grandSubtotal, 2), "</td>\n";
    print " <td>". round( $grandTax, 2). "</td><td>". round( $grandTotal, 2);
    print "</td><td>". round( $grandPaid, 2). "</td><td>";
    print round( $grandOwing, 2), "</td></tr>\n";
    

} # End of printInvoice;
