#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Payments' => 'Payments',
	   'Main' => 'Main',
	   'Fees' => 'Fees',
	   'Student' => 'Student',
	   'Search' => 'Search',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Please search again' => 'Please search again',
	   'Last,First/Last/Initials/Studnum' => 'Last,First/Last/Initials/Studnum',
	   'Accept Payment' => 'Accept Payment',
	   'Date' => 'Date',
	   'Total Payment' => 'Total Payment',
	   'Recalculate' => 'Recalculate',
	   'Payment' => 'Payment',
	   'Paid' => 'Paid',
	   'Received On Acct' => 'Received On Acct',
	   'Action' => 'Action',
	   'Payment Error' => 'Payment Error',
	   'Payment' => 'Payment',
	   'Payment is larger than charged amount' => 'Payment is larger than charged amount',
	   'Go back and try again' => 'Go back and try again',
	   'Print Receipt' => 'Print Receipt',
	   'Payment Completed' => 'Payment Completed',
	   'Cannot sysopen receipt number file.' => 'Cannot sysopen receipt number file.',
	   'Cannot rewind receipt number file' => 'Cannot rewind receipt number file',
	   'Cannot truncate receipt number file' => 'Cannot truncate receipt number file',
	   'Cannot write to receipt number file' => 'Cannot write to receipt number file',
	   'Cannot close receipt number file' => 'Cannot close receipt number file',
	   'Payee' => 'Payee',
	   'Error' => 'Error',

	  );


my $self = 'payment.pl';

use DBI;
use CGI;
use Number::Format qw(round);

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my @time = localtime(time);
my $year = $time[5] + 1900;
my $month = $time[4] + 1;
my $currdate = "$year-$month-$time[3]";

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Start of HTML Document.
print "$doctype\n<html><head><title>". $lex{Payment}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body onload=\"document.forms[0].elements[1].focus()\" ";
print "style=\"padding-top:1em;\">\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | ";
print "<a href=\"$feespage\">". $lex{Fees}. "</a> ]\n";


if ( not $arr{page} ) {
    showSearchForm();
}

if ( $arr{page} == 1 ) {
    selectStudent( $arr{student} );
} elsif ( $arr{page} == 2 ) {
    selectTransactions( $arr{studnum} );
} elsif ( $arr{page} == 3 ) {
    if ( $arr{submit} eq $lex{Recalculate} ) { # recalculating...
	selectTransactions( $arr{studnum} );
    } else {
	acceptPayment();
    }
}



#---------------------
sub selectTransactions {
#---------------------

    my $studnum = shift;

    # Get student name.
    my $sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth->fetchrow;

    my (@trans, $recalcmode);
    if ( $arr{page} == 3 ) { # We are doing a recalc
	$recalcmode = 1; # turn on recalc mode
	delete $arr{page};
	my $sth = $dbh->prepare("select trans_type from fees_jrl where id = ?");
	foreach my $id (sort keys %arr) {
	    if ( $id =~ /\d/ ) {  # all id's are digits.
		$sth->execute( $id );
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
		my $type = $sth->fetchrow;
		if ( $type eq 'roa' ) {
		    push @trans, $id;
		} else {
		    push @pay, $id;
		}
	    }
	}
	push @trans, @pay;  # put the roa transactions at start of the array.
    
    } else {
	# Get student transactions
	# paid_id is null until full payment made.

	my $sth = $dbh->prepare("select id, total, trans_type from fees_jrl where studnum = ? and 
         paid_id is null and (trans_type = 'chg' or trans_type = 'roa') order by trans_date");
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$sth->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	while ( my ($id, $total, $type) = $sth->fetchrow ) {
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    if ( $type eq 'roa' ) {
		push @trans, $id;
	    } else {
		push @pay, $id;
	    }
	}
	push @trans, @pay; # put the roa transactions at start of the array.

    }

    print "<h1>". $lex{Payments}. "</h1>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";
    print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";

    #print "<tr><td><input type=\"submit\" name=\"submit\" value=\"". $lex{'Accept Payment'}. "\">";
    #print "</td><td></td></tr>\n";

    if ( $recalcmode ) { $currdate = $arr{date}; }
    print "<tr><td align=\"right\"><b>". $lex{Date}. "</b></td>\n";
    print "<td><input type=\"text\" name=\"date\" size=\"11\" value=\"$currdate\"></td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{Student}. "</td>\n";
    print "<td>$firstname $lastname ($arr{studnum})</td></tr>\n";

    print "<tr><td align=\"right\"><b>". $lex{Payee}. "</td>\n";
    print "<td><input type=\"text\" name=\"payee\" size=\"25\" value=\"$arr{payee}\"></td></tr>\n";


    my $totalOwing;
    $sth = $dbh->prepare("select total, name, description, trans_type from fees_jrl where id = ?");

    foreach my $id ( @trans )  {

	$sth->execute( $id );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my ($total, $name, $description, $type) = $sth->fetchrow;
	my $originaltotal = $total;
	if ( $recalcmode ) { 
	    $total = round( $arr{$id}, 2); 
	} # override value if recalc

	$totalOwing += $total;

	print "<tr style=\"background-color:#DDD;\"><td align=\"right\">";
	if ( $name ) { print "<i>$name</i>"; }
	if ( $name and $description ) { print " - "; }
	if ( $description ) { print $description; }
	print " $originaltotal</td>\n";

	print "<td align=\"left\">";
	if ( $type eq 'roa' ) {
	    print "<input type=\"hidden\" name=\"$id\" value=\"$total\">$total\n";
	} else {
	    print "<input type=\"text\" name=\"$id\" value=\"$total\" size=\"8\" checked>\n";
	}
	print "</td></tr>\n";

    }

    $totalOwing = round( $totalOwing, 2);

    print "<tr><td align=\"right\"><b>". $lex{'Total Payment'}. "</td>\n";
    print "<td>$totalOwing</td></tr>\n";

    print "<tr><td align=\"center\"><input type=\"submit\" name=\"submit\" value=\"";
    print $lex{'Recalculate'}. "\"></td>\n";

    print "<td align=\"center\"><input type=\"submit\" name=\"submit\" ";
    print "value=\"". $lex{'Accept Payment'}. "\"></td></tr>\n";

    print "</table></form></body></html>\n";

    exit;

} # End of selectTransactions;




#----------------
sub acceptPayment {
#----------------

    # delete unneeded hash elements.
    delete $arr{submit};
    delete $arr{page};

    #Passed: studnum, date, payee and ids and amount paid on each of the transactions.
    #foreach my $key (sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # remove other elements to leave only record id's of the transactions.
    my $studnum = $arr{studnum};
    delete $arr{studnum};
    my $date = $arr{date};
    delete $arr{date};
    my $payee = $arr{payee};
    delete $arr{payee};


    # Loop through records and check for overpayment
    my $failflag; # if an overpayment, fail
    my (@fullpay, $currentRoaTotal); 
    # @full - list of fullpayment transaction; # roatotal - amount for a roapayment.
    my $sth = $dbh->prepare("select total, trans_type from fees_jrl where id = ?");
    foreach my $id ( sort keys %arr ) {
	$sth->execute( $id );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	while (my ( $total, $trans_type ) = $sth->fetchrow ) {
	    $payment += $arr{$id}; # The payment IS the total of records passed(with reverse sign)
	    #print "T: $trans_type  Total: $total<br>\n";
	    if ( $trans_type eq 'chg' and ( $arr{$id} > $total )) {
		$failflag = 1; last; 
	    } elsif ( $trans_type eq 'chg' and ( $total == $arr{$id} )) {
		push @fullpay, $id;
	    } elsif ( $trans_type eq 'chg' and ( $arr{$id} < $total )) {
		$currentRoaTotal += $arr{$id};
	    } elsif ( $trans_type eq 'roa' ) {
		push @fullpay, $id; # put this in to be marked paid with this x-action.
	    } else { # programming error
		print "$id - $trans_type - $total - $arr{$id}<br>\n";
		print "Programming Error: Contact Les Richardson!\n";
		exit;
	    }
	}

    }

    # Fail if over payment.
    if ( $failflag ) { # Error: overpaid on a transaction
	print "<b>". $lex{'Payment Error'}. "</b>: ";
	print $lex{'Payment is larger than charged amount'}. ".<br>\n";
	print $lex{'Go back and try again'}. "\n";
	print "</body></html>\n";
	exit;
    }

    #print "Payment: $payment<br> Curr ROA: $currentRoaTotal\n";
    #print "<br>FullPay:", @fullpay, "<br>\n";

    my ($receiptnumber, $payid);
    
    if ( @fullpay ) {
	my $timetag = time();
	#print "Timetag: $timetag<br>\n";

	# Add a payment record to the fees_jrl table: studnum, date,
	# payment and id strings and total.

	$sth = $dbh->prepare("insert into fees_jrl values(
         $sql{default}, '$studnum', '$date','pay','$lex{Payment}',
         '$timetag', $sql{default}, $sql{default}, $sql{default},
         $sql{default}, $sql{default}, $sql{default}, $sql{default},
         $sql{default}, $sql{default}, '-$payment', $sql{default},
         $sql{default} )"); 

	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$sth->execute; 
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

	# Get the id for this new added record. (this student, this date, this time)
	$sth = $dbh->prepare("select id from fees_jrl 
         where trans_date = '$date' and studnum = '$studnum' and 
         trans_type = 'pay' and description = $timetag");
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$payid = $sth->fetchrow;
	# print "Pay ID: $payid<br>\n";

	$receiptnumber = getReceiptNumber();


	# Now mark the records paid... (skip receipt update for the roa transactions )
	$sth = $dbh->prepare("update fees_jrl set paid_id = $payid where id = ?");
	$sth1 = $dbh->prepare("update fees_jrl set receipt = $receiptnumber where id = ?");
	$sth2 = $dbh->prepare("select trans_type from fees_jrl where id = ?");
	
	foreach my $id ( @fullpay ) { # skip the receipt update on roa types
	                              #(since set by prev payment)

	    # Set Paid_id value (ie. item is paid)
	    $sth->execute( $id );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

	    # Get Type 
	    $sth2->execute( $id );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my $type = $sth2->fetchrow;

	    if ( $type ne 'roa' ) { # set the recipt number
		$sth1->execute( $id );
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    }
	}


    }


    # run through transactions to generate description for payment.
    my $payment_description = $lex{Paid}. ": ";

    foreach my $id ( @fullpay ) {
	$payment_description .= "$id ";
    }

    #print "INV DESC: $payment_description<br>$payee<br>\n";
    $payment_description .= '('. $lex{Payee}. ": $payee)";


    my $roaid; # id of record for Received on Account (roa)
    if ( $currentRoaTotal ) { # write a new ROA record

	if ( not $receiptnumber ) { # if we didn't get one above, get one now...
	    $receiptnumber = getReceiptNumber();
	}

	$currentRoaTotal = $dbh->quote( -$currentRoaTotal );
	
	my $payment_description = $lex{'Received On Acct'}. ' ('. $lex{Payee}. ": $payee)";
	$payment_description = $dbh->quote( $payment_description );

	# Add a roa record to the fees_jrl table:
	my $sth = $dbh->prepare("insert into fees_jrl 
         ( studnum, trans_date, trans_type, name, total, receipt ) values(
         '$studnum', '$date','roa', $payment_description , $currentRoaTotal, '$receiptnumber' )");

	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }


	$sth = $dbh->prepare("select id from fees_jrl 
          where studnum = ? and trans_date= ? and trans_type = 'roa'and total = $currentRoaTotal");
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$sth->execute( $studnum, $date );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$roaid = $sth->fetchrow;
	print "ROA Id: $roaid<br>\n";

    } 


    # update payment transaction here...
    if ( $payid ) {
	$sth = $dbh->prepare("update fees_jrl set description = ?, receipt = ? where id = ?");
	$sth->execute( $payment_description, $receiptnumber, $payid );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    } else { # no $payid, so must be a ROA payment.
	$payid = $roaid; # just for link below to provide a link for the roa transaction.
    }

    print "<h1>". $lex{'Payment Completed'}. "</h1>";
    print "[ <a href=\"receipt.pl?page=3&payid=$payid\">". $lex{'Print Receipt'}. "</a> ]\n";

    exit;

} # End of AcceptPayment.



#----------------
sub selectStudent {
#----------------

    my $student = shift;

    print "<h1>". $lex{'Payments'}. "</h1>\n";

    # Setup the Search
    if ($student =~ /\d+/) {  # we have a student number
	$sth = $dbh->prepare("select lastname, firstname, studnum from studentall 
          where studnum = ?");
	$sth->execute( $student );

    } else { # we have words possibly with a comma
	($lastname,$firstname)  = split /\,/, $student;
	$firstname =~ s/^\s*//;
	$lastname =~ s/^\s*//;
	if ($lastname and $firstname){ # both entered.
	    $sth = $dbh->prepare("select  lastname, firstname, studnum from studentall 
             where lastname = ? and firstname = ?");
	    $sth->execute( $lastname, $firstname );

	} elsif ($lastname and not $firstname){ # only lastname (no comma)
	    if (length($lastname) == 2){ # search by initials: fi, li.
		my $fi = substr($lastname,0,1). '%'; 
		my $li = substr($lastname,1,1). '%';
		$sth = $dbh->prepare("select lastname, firstname, studnum from studentall 
                 where lastname $sql{like} ? and firstname $sql{like} ?");
		$sth->execute( $li, $fi );

	    } else {
		$sth = $dbh->prepare("select lastname, firstname, studnum from studentall 
                  where lastname = ? order by firstname");
		$sth->execute( $lastname );
	    }
	} else { # print an error....
	    showSearchForm();
	    print "</body></html>\n";
	    die;
	}

    } # Last Else
    # We should now have a $sth defined.

    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;

    if ($rows < 1) { 
	print "<h1>". $lex{'No Student(s) Found'}. ".  ". $lex{'Please search again'}. ".</h1>\n";
	showSearchForm();
	print "</body></html>\n"; 
	die; 
    }
 

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Student}. "</th><th>". $lex{Action}. "</th></tr>\n";


    for (1..$rows){
	my ($lastname, $firstname, $studnum) = $sth->fetchrow;
	print "<tr><td>$firstname $lastname ($studnum)</td><td>\n";

	print "<form action=\"$self\" method=\"post\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Accept Payment'}. "\">\n";

	print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";

	print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
	print "</form></td></tr>\n";

    }

    print "</table>\n";
    
    if ( $rows > 20 ) { # only show if lots of records
	showSearchForm();
    }

    print "</body></html>\n";

    exit;

}



#----------------
sub showSearchForm {
#----------------

    print "<div style=\"padding:1em 0.2em;\">\n";
    print "<b>". $lex{Student}. q{ }. $lex{Search}. "</b><br>\n";

    print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"submit\" value=\"". $lex{Search}. "\">\n";
    print "<input type=\"text\" name=\"student\" size=\"30\"><br>\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";
    print $lex{Student}. " (". $lex{'Last,First/Last/Initials/Studnum'}. ")}. \n";
    print "</form></div>\n";

    exit;

}



#-------------------
sub getReceiptNumber {
#-------------------

    use Fcntl qw(:DEFAULT :flock);

    # Get receipt number and update file.
    sysopen (RNUM, "../../etc/receiptnumber", O_RDWR | O_CREAT) or 
	die $lex{'Cannot sysopen receipt number file.'};

    flock(RNUM,LOCK_EX);

    my $recnum = <RNUM> || 0;
    chomp $recnum;
    seek(RNUM,0,0) or die $lex{'Cannot rewind receipt number file'}. ": $!\n";
    truncate(RNUM,0) or die $lex{'Cannot truncate receipt number file'}. ": $!\n";

    my $recnum = $recnum + 1;
    print RNUM $recnum or die $lex{'Cannot write to receipt number file'}. ": $!\n";
    close RNUM or die $lex{'Cannot close receipt number file'}. ": $! \n";

    return $recnum;

}


