#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Create Predefined Fees' => 'Create Predefined Fees',
	   'Save Predefined Fee' => 'Save Predefined Fee',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Main' => 'Main',
	   'Fees' => 'Fees',
	   'Subject-Section' => 'Subject-Section',
	   'Name' => 'Name',
	   'Description' => 'Description',
	   'Amount' => 'Amount',
	   'Percent Discount' => 'Percent Discount',
	   'Group' => 'Group',
	   'Your record is now stored.' => 'Your record is now stored.',
	   'Add More Predefined Fees' => 'Add More Predefined Fees',
	   'Profile' => 'Profile',
	   'Student Number' => 'Student Number',
	   'Profile Overrides Group/Value' => 'Profile Overrides Group/Value',
	   'Error' => 'Error',

	   );

my $self = 'predefadd.pl';


use CGI;
use DBI;
use Cwd;


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "../../etc/fees.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

# calc current date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day";

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $checked = $arr{checked};
delete $arr{checked};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get current dir so know what CSS to display;
#if (getcwd() =~ /tcgi/){ # we are in tcgi
#    $css = $tchcss;
#}

# Show page Header
print "$doctype\n<html><head><title>". $lex{'Create Predefined Fees'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$feespage\">". $lex{Fees}. "</a> ]\n";

print "<center><h1>". $lex{'Create Predefined Fees'}. "</h1>\n";

if ( $arr{writeflag} ){ # Write values and exit;
    updateRecord();
}


# Setup the form and start of table.
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";
print "<table cellpadding=\"3\" border=\"0\" cellspacing=\"0\">\n";

print "<tr><td align=\"right\">". $lex{Name}. "</td><td align=\"left\">\n";
print "<input type=\"text\" name=\"name\" size=\"12\" maxlength=\"16\">\n";
print "</td></tr>\n";

print "<tr><td align=\"right\">". $lex{Description}. "</td><td align=\"left\">\n";
print "<input type=\"text\" name=\"description\" size=\"30\" maxlength=\"255\">\n";
print "</td></tr>\n";

print "<tr><td align=\"right\">". $lex{Amount}. "</td><td align=\"left\">\n";
print "<input type=\"text\" name=\"amount\" size=\"6\">\n";
print "</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Percent Discount'}. "</td><td align=\"left\">\n";
print "<input type=\"text\" name=\"discount\" size=\"3\">\n";
print "</td></tr>\n";

for my $i (1..4) {
    #print "Tax $i: $tax[$i]<br>\n";
    if ( $tax[$i] ) {
	my $fieldname = 'tax'. $i. '_flag';
	print "<tr><td align=\"right\">$tax[$i]->{'name'}</td><td align=\"left\">\n";
	print "<input type=\"checkbox\" name=\"$fieldname\" value=\"1\">\n";
	print "</td></tr>\n";
    }
}


# Profile...
print "<tr><td align=\"right\">". $lex{Profile}. "</td><td align=\"left\">\n";
print "<select name=\"profile\"><option></option>";
foreach my $key (keys %profiles) {
    print "<option>$key ($profiles{$key})</option>\n";
}
print "</select> ". $lex{'Profile Overrides Group/Value'}. "</td></tr>\n";


# Group and Value
print "<tr><td align=\"right\">". $lex{Group}. "</td><td align=\"left\">\n";
print "<select name=\"group_name\"><option></option>\n";
print "<option>". $lex{Grade}. "</option>\n";
print "<option>". $lex{Homeroom}. "</option>\n";
#print "<option>". $lex{'Subject-Section'}. "</option>\n";
print "<option>". $lex{'Student Number'}. "</option>\n";
print "</select> <input type=\"text\" name=\"group_value\" size=\"7\"></td></tr>\n";


# Print Submit Row
print "<tr><td colspan=\"4\" align=\"center\">";
print "<input type=\"submit\" value=\"". $lex{'Save Predefined Fee'}. "\"></td></tr>\n";

print "</table>\n</form></center></body></html>\n";



#---------------
sub updateRecord {
#---------------

    delete $arr{writeflag}; # don't need writeflag
    #foreach my $key (keys %arr){ print "K: $key VAL: $arr{$key}<br>\n"; }


    # process profile if present; it will override the group name and group value.
    my ($group_name, $group_value);
    if ( $arr{profile} ) { # split and quote them;
	my ($trash, $group) = split /\(/, $arr{profile};
	$group =~ s/\)//; # remove trailing parenthesis;
	( $group_name, $group_value ) = split /:/, $group;
	$group_name = $dbh->quote( $group_name );
	$group_value = $dbh->quote( $group_value );
    } else { # just quote from %arr
	$group_name = $dbh->quote( $arr{group_name} );
	$group_value = $dbh->quote( $arr{group_value} );
    }

    # remove unused values
    delete $arr{profile};
    delete $arr{group_name};
    delete $arr{group_value};


    # Quote the rest of the fields.
    foreach my $key ( keys %arr ) {
	if ( $arr{$key} ) {
	    $arr{$key} = $dbh->quote( $arr{$key} );
	} else {
	    $arr{$key} = $sql{default};
	}
    }

    # fill in any missing tax fields with NULL's (max is 4)
    for my $i (1..4) {
	$fieldname = 'tax'. $i. '_flag';
	if ( not $arr{$fieldname} ) {
	    #print "No Fieldname:  $fieldname <br>\n";
	    $arr{$fieldname} = $sql{default};
	}
    }


    my $sth = $dbh->prepare("insert into fees_predefined values (
      $sql{default}, $arr{name}, $arr{description}, $arr{amount}, $arr{discount}, 
      $arr{tax1_flag}, $arr{tax2_flag}, $arr{tax3_flag}, $arr{tax4_flag}, 
      $group_name, $group_value ) ");
    $sth->execute;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }


    print "<b>". $lex{'Your record is now stored.'}. "</b>\n";
    print "<p>[ <a href=\"$self\">". $lex{'Add More Predefined Fees'}. "</a> | ";
    print "<a href=\"$feespage\">". $lex{Fees}. "</a> ]</p></body></html>\n";

    exit;

} # End of updateRecord
