#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Record Deleted' => 'Record Deleted',
	   'View Predefined Fees' => 'View Predefined Fees',
	   'Name' => 'Name',
	   'Description' => 'Description',
	   'Amount' => 'Amount',
	   'Discount' => 'Discount',
	   'Tax1' => 'Tax1',
	   'Tax2' => 'Tax2',
	   'Tax3' => 'Tax3',
	   'Tax4' => 'Tax4',
	   'Group Name' => 'Group Name',
	   'Group Value' => 'Group Value',
	   'Delete' => 'Delete',
	   'Grade' => 'Grade',
	   'Fees' => 'Fees',
	   'Main' => 'Main',
	   'No Records Found' => 'No Records Found',
	   'Top' => 'Top',
	   'Delete' => 'Delete',
	   'Error' => 'Error',

	   );

my $self = 'predefview.pl';

use DBI;
use CGI;
use Cwd;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

if ( $arr{group} eq $lex{Grade} ){ 
    $group = 'grade';
} else {
    $group = 'homeroom';
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get current dir so know what CSS to display;
#if (getcwd() =~ /tcgi/){ # we are in tcgi
#    $css = $tchcss;
#}

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'View Predefined Fees'}. "</title>
 <link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
 </head><body><a name=\"top\"></a>[ <a href=\"$tchpage\">". $lex{Main}. "</a> |\n";
print "<a href=\"/fees.html\">". $lex{Fees}. "</a> ]\n";

if ( $arr{id} ){ # passed an id to delete...
    deleteRecord();
}


my $sth = $dbh->prepare("select * from fees_predefined order by name");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;

print "<center><h1>". $lex{'View Predefined Fees'}. "</h1>\n";

if ($rows < 1 ) {
    print "<p>". $lex{'No Records Found'}. "</p>\n";
    print "</body></html>\n";
    die;
}

print "<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Name}. "</th><th>". $lex{Description}. "</th><th>\n";
print $lex{Amount}. "</th><th>". $lex{Discount}. "</th><th>". $lex{Tax1};
print "</th><th>". $lex{Tax2}. "</th><th>". $lex{Tax3}. "</th>\n";

print "<th>". $lex{Tax4}. "</th><th>". $lex{'Group Name'};
print "</th><th>". $lex{'Group Value'}. "</th>\n";
print "<th>". $lex{Delete}. "</th></tr>\n";

my $colcolor = 'gray'; # tr colors are blue or gray;
#my $currprofile = -1;

while ( my ($id,$name, $description, $amount, $discount, 
 $tax1_flag, $tax2_flag, $tax3_flag, $tax4_flag, 
 $group_name, $group_value) = $sth->fetchrow ) {

    $prevprofile = $currprofile;
    $currprofile = $profile;

    if ($colcolor eq 'blue'){ 
	$colcolor = 'gray';
    } else { 
	$colcolor = 'blue';
    }
    
    print "<tr class=\"$colcolor\"><td>$name</td>\n";
    print "<td>$description</td><td>$amount</td><td>$discount</td><td>$tax1_flag</td>\n";
    print "<td>$tax2_flag</td><td>$tax3_flag</td><td>$tax4_flag</td><td>$group_name</td>\n";
    print "<td>$group_value</td><td><a href=\"$self?id=$id\">". $lex{Delete}. "</a></tr>\n";

}

print "</table>\n";
print "<p>[ <a href=\"$feespage\">". $lex{Fees}. "</a> |\n";
print " <a href=\"#top\">". $lex{Top}. "</a> ]</p>\n";
print "</center></body></html>\n";



#---------------
sub deleteRecord { # delete a single record
#---------------

    my $sth = $dbh->prepare("delete from fees_predefined where id = ?");
    $sth->execute( $arr{id} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

    print "<div style=\"border:1px solid gray;margin:0.5em;\">\n";
    print "<h1>". $lex{'Record Deleted'}. "</h1></div>\n";

}
