#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View Transactions' => 'View Transactions',
	   'Main' => 'Main',
	   'Error' => 'Error',
	   'Fees' => 'Fees',
	   'Student Number' => 'Student Number',
	   'Date' => 'Date',
	   'Type' => 'Type',
	   'Name' => 'Name',
	   'Description' => 'Description',
	   'Amount' => 'Amount',
	   'Paid_ID' => 'Paid_ID',
	   'Receipt' => 'Receipt',
	   'Id' => 'Id',
	   'No Records Found' => 'No Records Found',
	   'Continue' => 'Continue',

	   );

use DBI;
use CGI;

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    print $lex{Error}. " $@<br>\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


print "$doctype\n<html><head><title>". $lex{'View Transactions'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$feespage\">". $lex{Fees}. "</a> ]\n";

print "<center><h1>". $lex{'View Transactions'}. "</h1>\n";


if ( not $arr{page} ) {
    showStartPage();
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    showTransactions();
}

#-------------------
sub showTransactions {
#-------------------


    # Find student name
    my $sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
    $sth->execute( $arr{studnum} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;

    print "<div><b>$firstname $lastname</b></div>\n";

    # Print Table Header
    print "<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";
    print "<tr><th>". $lex{Id}. "</th><th>".$lex{Date}. "</th><th>". $lex{Type}. "</th><th>". $lex{Name}. "</th><th>".$lex{Description}. "</th><th>";
    print $lex{Amount}. "</th><th>". $lex{'Paid_ID'}. "</th><th>". $lex{Receipt}. "</th></tr>\n";

    # Find  student transactions.
    my $sth = $dbh->prepare("select id, trans_date, trans_type, name, description, total, paid_id, receipt from fees_jrl
     where studnum = ? order by trans_date");
    $sth->execute( $arr{studnum} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $first = 1;

    while ( my ($id, $trans_date, $trans_type, $name, $description, $total, $paid_id, $receipt ) = $sth->fetchrow ) {
	print "<tr><td>$id</td><td>$trans_date</td><td>$trans_type</td><td>$name</td><td>$description</td>\n";
	print "<td>$total</td><td>$paid_id</td><td>$receipt</td></tr>\n";
	$first = 0;
    }


    print "</table></center>";

    if ( $first ) {
	print "<h1>". $lex{'No Records Found'}. "</h1>\n";
    }

    print "</body></html>\n";

    exit;

}


#----------------
sub showStartPage {
#----------------


    print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"0\">\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";


    print "<tr><td>". $lex{'Student Number'}. "</td><td><input type=\"text\" name=\"studnum\" size=\"8\">\n";
    print "</td></tr>\n";


    print "<tr><td><input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";
    print "</form></table></body></html>\n";
    

    exit;


}
