#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ( 'Last,First or Stud#' => 'Last,First or Stud#',
	    'Associate People &amp; Pictures' => 'Associate People &amp; Pictures',
	    'Associate' => 'Associate',
	    'No Pictures Found' => 'No Pictures Found',
	    'No Student(s) Found' => 'No Student(s) Found',
	    'Main' => 'Main',
	    'Export' => 'Export',
	    'Error' => 'Error',
	    'Delete Failed' => 'Delete Failed',
	    'File already exists' => 'File already exists',
	    'Deleted' => 'Deleted',
	    'Renaming' => 'Renaming',

	   );


use CGI;
use DBI;


my $tempimage = "temp$$.jpg";
my $self = 'associate.pl';

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../../etc/image.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
my %arr= $q->Vars;
print $q->header( -charset, $charset );

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Associate People &amp; Pictures'}. "</title>
<link rel=\"stylesheet\" type=\"text/css\" href=\"$css\">
<style type=\"text/css\">body { background-color: #DC9;}
div.pic { float:left; height:$divheight px; width:$divwidth px; padding: 10px; 
 border: 1px solid; border-color:#AAA #AAA #444 #444; margin:3px; 
 background-color: #EEE;
}
</style>
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$exppage\">". $lex{Export}. "</a> ]\n";

print "<h1>". $lex{'Associate People &amp; Pictures'}. "</h1>\n";

if ( $arr{associateflag} ) {
    delete $arr{associateflag};
    associate();  # do associate function.
}


# Read Files in bigpic folder
opendir (DH,"$picdir") || die "Cannot open $picdir directory!\n";
my @files = grep !/^\./, readdir DH;
close DH;

if ( not @files ) { 
    print "<p>". $lex{'No Pictures Found'}. "</p></body></html>\n";
    die;
}

# Populate Hash with student numbers of students who have pic indicated.
my $sth = $dbh->prepare("select studnum, studid from student where pic = 'Y'");
$sth->execute;
while ( my ( $studnum, $id ) = $sth->fetchrow ){
    $studnum{$studnum} = '1';
}

#print "Existing Student Pics:<br>";
#foreach my $val (keys %studnum){ print "$val<br>\n";}

#print "Size: $#files<br>\n";
#foreach my $f (@files){ print "$f<br>\n";}
#print "<br><br>\n";


# Go through @files (pictures) and remove those that exist in student
# hash (ie. already associated.)
START:
for(0..$#files){
    my ($fn,$ext) = split /\./,$files[$_];
    if ($studnum{$fn}){ # if already associated...
	my $removed = splice(@files, $_, 1);  # remove from @files array
	#print "We are splicing $_ ...$removed<br>\n";
	goto START;
    }
}

#print "Index: $#files<br>\n";
#foreach my $f (@files){ print "$f<br>\n";}
#print "<br><br>\n";

# Now Display the pictures...
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"associateflag\" value=\"1\">\n";
print "<input type=\"submit\" value=\"". $lex{Associate}. "\">\n";

foreach my $file ( @files ){ # Do files one after another.

    print "<div class=\"pic\"><img src=\"$picdirurl/$file\" alt=\"$file\" ";
    print "height=\"$thumbheight\"><br>$file<br>\n";
    print $lex{'Last,First or Stud#'}. "<br>\n";  # last,first or studnum
    print "<input type=\"text\" name=\"$file\" size=\"20\"></div>\n\n";
}

print "<div style=\"clear:left;\">";
print "<input type=\"submit\" value=\"$associatevalue\"></div>\n";
print "</form></body></html>\n";



#-----------
sub doDelete { # Delete Picture files
#-----------

    my $filename = shift;
    my $result = system ("rm -f $picdir/$filename");
    if ( $result ){ 
	print $lex{Error}. q{ }. $lex{'Delete Failed'}. " $filename:  $?<br>\n";
    } else {
	print "$filename ". $lex{Deleted}. "<br>\n";
    }

}



#------------
sub associate {  # do the association
#------------

    # passed filenames and matching student number or student names.

    # for each key:value picture:student passed 1) check for digits or
    # name and look up student. 2) If present, then check for existing
    # image file. 3) If not present then rename passed key file to
    # student#.jpg, and update student record to Y in pic field.

    my $sth;

    foreach my $key (keys %arr){

	if ( $arr{$key} ) { # We have a passed value for student; $key is filename.

	    my ($studnum, $lastname, $firstname);  # local values

	    if ($arr{$key} =~ m/,/){
		# Strip whitespace
		$arr{$key} =~ s/^\s+//g;
		$arr{$key} =~ s/\s+$//g;
		($lastname, $firstname) = split /,/,$arr{$key};
		$firstname =~ s/^\s+//g;
		
		
		# Now find student number
		$sth = $dbh->prepare("select studnum from student 
                    where lastname = '$lastname' and firstname = '$firstname'");
		$sth->execute;
		if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
		$studnum = $sth->fetchrow;

		if (not $studnum){ 
		    print "$nostudentfound $arr{$key}<br>\n";
		    next;
		} 

	    } elsif ($arr{$key} =~ m/\d/){

		#print "We have a digit for $arr{$key}<br>\n";

		# Now verify student number
		$sth = $dbh->prepare("select lastname, firstname from student 
                    where studnum = ?");
		$sth->execute( $arr{$key} );
		if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
		my ( $lastname, $firstname ) = $sth->fetchrow;

		if ( not $lastname ) { 
		    print $lex{'No Student(s) Found'}. ": $arr{$key}<br>\n";
		    next;
		} else {
		    $studnum = $arr{$key};
		}

	    } else { # No student found.
		print "<br>". $lex{'No Student(s) Found'}. " $arr{$key}<br>\n";
		next;
	    }

	    my $newfilename = "$studnum.jpg";
	    #print "Filename: $newfilename  Name: $firstname $lastname<br>\n";

	    # We have correct val 4 studnum; $lastname,$firstname are defined.
	    #check for existence of file already.
	    if (-e $newfilename){
		print $lex{'File already exists'}. ": $firstname $lastname ";
		print "($newfilename)<br>\n";
		next;
	    } else { 

              # We can rename current file and update student pic field to 'Y';
		print $lex{Renaming}. ": $key &gt; $newfilename<br>\n";
		rename "$picdir/$key", "$picdir/$newfilename";
		rename "$tndir/$key", "$tndir/$newfilename";
		$sth = $dbh->prepare("update student set pic = 'Y' where studnum = ?");
		$sth->execute( $studnum );
		if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	    }


	} # End of If passed a value

    } # End of Loop of %arr hash.


}
