#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Export' => 'Export',
	   'Error' => 'Error',
	   'Add Images' => 'Add Images',
	   'File Processing' => 'File Processing',
	   'Cannot open file' => 'Cannot open file',
	   'Resizing and Adding to picture folders Complete' =>
	     'Resizing and Adding to picture folders Complete',
	   'Maximum File Upload size exceeded!' => 'Maximum File Upload size exceeded!',
	   'Uploaded' => 'Uploaded',
	   'Library type not recognized' => 'Library type not recognized',
	   'jpg files found' => 'jpg files found',
	   'Continue' => 'Continue',

	   );


use CGI;
use DBI;

my $self = 'imageadd.pl';

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../../etc/image.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
my %arr= $q->Vars;
print $q->header( -charset, $charset );

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Add Images'}. "</title>
<link rel=\"stylesheet\" type=\"text/css\" href=\"$css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$exppage\">". $lex{Export}. "</a> ]\n";

# Processing Loop
if ( $arr{uploadflag} ){  # Now process the images
    delete $arr{uploadflag};
    doProcessing();
}

print "<h1>". $lex{'Add Images'}. "</h1>\n";

my $file = $q->param("filename"); 
my $name; my $ext; 

if ($file ne "") {
    $fileName = $file;  # fileName is output filename, file is input.
    $fileName =~ s!^.*(\\|\/)!!; 
    $filename = lc($filename);
    @name = split /\./, $fileName; # split on dots.
    $ext = $name[$#name];  # last element is the extension.
    unless ($ext eq 'jpg' or $ext eq 'zip' or $ext eq 'tgz'){
	print "<b>The file must be a jpg, zip, or tgz file!</b>";
	print "</body></html>\n";
	die;
    }

    pop(@name); # pull off extension.
    foreach $n (@name){ $name .= "$n.";} # assemble name 
    chop; # remove trailing dot
    
    #print "Name: $name Extension: $ext<br>\n";

    open (OUTFILE, ">$fileName") || 
	die $lex{'Cannot open file'}. " $fileName\n"; 
    my $bufcount = 0;
    while (my $bytesread = read($file, my $buffer, 1024)) { 
        print OUTFILE $buffer;
        $bufcount++;
        if ($bufcount > $maxbufcount){
           print "<h1>". $lex{'Maximum File Upload size exceeded!'};
	   print "($maxbufcount K)</h1>\n";
	   print "</body></html>\n";
	   die $lex{'Maximum File Upload size exceeded!'}. "\n";
        }
    } 

    close (OUTFILE);
}

# Process Library Files
if ( $ext eq 'zip' or $ext eq 'tgz' ) {
    doLibrary($ext); # put any jpg's in compressed library into working dir.

} elsif ($ext eq 'jpg') {  # move single jpg into working.
    system("mv $fileName ./working");

} else {

    print $lex{Error}. q{ }. $lex{'Cannot open file'}. ": $ext\n";
    print "</body></html>\n";
    die;
}


print "<p style=\"font-size: 150%;\">$fileName ". $lex{Uploaded}. "</p><p>\n";

print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"filename\" value=\"$fileName\">
<input type=\"hidden\" name=\"uploadflag\" value=\"1\">
<input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
print "</form></p></body></html>\n";



#------------
sub doLibrary { # uncompress lib and place any .jpg files into working folder.
#------------

    my $extension = shift;

    # Create a folder to do the zip in.
    my $tempdir = "templib$$";
    mkdir $tempdir;

    if ( $extension eq 'zip' ){
	system("unzip $fileName -d $tempdir >/dev/null");

    } elsif ($extension eq 'tgz'){
	system("tar xvz -C  $tempdir -f $fileName >/dev/null");
    #} elsif ($extension eq 'bz2'){
	#system("bunzip2 xvj -C  $tempdir -f $fileName ");

    } else {
	print $lex{Error}. q{ }. $lex{'Library type not recognized'}. ".<br>\n";
	print "</body></html>\n";
	die;
    }

    # Count the number of .jpg files...
    my $filecount;
    opendir(DH,"$tempdir") or die "Cannot open dir $tempdir!: $!";
    my @files = readdir(DH);
    foreach my $fn (@files){
	if ($fn eq '.' or $fn eq '..'){ next;}
	my $newname = $fn;
	$newname =~ s/\s//g; # strip space.
	$newname = lc($newname); # rename them to lowercase.
	rename("$tempdir/$fn","$tempdir/$newname") or 
	    warn "Could not rename files because $!<br>\n";
	if ($newname =~ m/\.jpg/){ $filecount++;}
    }
    closedir(DH);
    print "$filecount ". $lex{'jpg files found'}. ".<br>\n";

    system("cp $tempdir/*.jpg ./working");
    system("rm -f $tempdir/*");
    rmdir $tempdir;
    unlink $fileName;

}


#--------
sub doTgz {  # uncompress tgz and replace jpg's into working dir.
#--------
    # Create a folder to do the zip in.
    my $tempdir = "temptgz$$";
    mkdir $tempdir;


    # Count the number of .jpg files...
    my $filecount;
    opendir(DH,"$tempdir") or die "Cannot open dir $tempdir!: $!";
    while ( defined ($filename = readdir(DH))){
	if ($filename =~ m/\.jpg/){ $filecount++;}
    }
    closedir(DH);
    print "$filecount jpg files found.<br>\n";

    system("cp $tempdir/*.jpg ./working");
    system("rm -f $tempdir/*");
    rmdir $tempdir;
    unlink $fileName;

}

#---------------
sub doProcessing {  # Process any images in the working directory
#---------------

    my $tempimage = "temp$$.jpg";
    #my $temp1image = "temp1$$.jpg";

    print "<h1>". $lex{'File Processing'}. "</h1>\n";
    #print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

    # Read Files in working folder (skip dot files)
    opendir (DH,"working") || die $lex{'Cannot open file'}. " $!\n";
    my @files = grep !/^\./, readdir DH;
    close DH;

    foreach my $file (@files){ # Do files one after another.

	#print "<tr><td>$file</td>";

	# Process image
	$res = system("$convertprog ./working/$file -resize x$imageheight ./working/$tempimage");
	if ($res){ print "Convert Image: $res<br>\n";}

	#my $combined = $imagewidth.'x'.$imageheight.'+0+0';
	#print "Comb: $combined<br>\n";
	#$res = system("$convertpro ./working/$tempimage -crop $combined ./working/$temp1image");
	#if ($res){ print "Thumbnail: $res<br>\n";}

	$res = system("mv ./working/$tempimage  $picdir/$file");
	if ($res){ print "Move: $res<br>\n";}

	# Now process thumbnail
	system("$convertprog ./working/$file -resize x$thumbheight ./working/$tempimage");
	#my $combined = '125'.'x'.$thumbheight.'+0+0';
	#print "Thumbnail: $combined<br>\n";
	#system("$convertprog ./working/$tempimage -crop $combined ./working/$temp1image");
	
	$res = system("mv ./working/$tempimage  $tndir/$file");
	if ($res){ print "Move: $res<br>\n";}

	
	print "<div style=\"float:left; margin:2px; border:1px solid gray; padding:3px;\">\n";
	print "<img src=\"$tndirurl/$file\"><br>$file</div>\n";

	unlink("./working/$file");
	system("rm -f working/temp*.jpg");
    }

    print "<br clear=\"left\"><b>". $lex{'Resizing and Adding to picture folders Complete'};
    print "</p></body></html>\n";

    exit;

}
