#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Student Picture View. View Students who have pictures.

my %lex = ('Main' => 'Main',
	   'Export' => 'Export',
	   'View Students by Grade' => 'View Students by Grade',
	   'No Pictures Found' => 'No Pictures Found',
	   'Grade' => 'Grade',
	   'Record Updated' => 'Record Updated',
	   'Delete Failed' => 'Delete Failed',
	   'Error' => 'Error',

	   );

my $self = 'studpicview.pl';

use CGI;
use DBI;

my $picsPerPage = 10;  # default value

my $viewdir = $tndir;
my $viewheight = 75;
my $divheight = 120;
my $divwidth = 80;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../../etc/image.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
my %arr= $q->Vars;
print $q->header( -charset, $charset );

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'View Students by Grade'}. "</title>
<link rel=\"stylesheet\" type=\"text/css\" href=\"$css\">
<style type=\"text/css\">
body { background-color: #DC9;}
div.pic { float:left; height:$divheight px; width:$divwidth px; padding: 10px; 
 border: 1px solid; border-color:#AAA #AAA #444 #444; margin:3px; 
 background-color: #EEE;
}
</style>
$chartype\n</head><body>\n";

print "<div style=\"float:left\">[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$exppage\">". $lex{Export}. "</a> ]&nbsp;&nbsp;</div>\n";

my $sth = $dbh->prepare("select count(pic) from student where pic = 'Y'");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
my $piccount = $sth->fetchrow;

if (not $piccount){ 
    print "<p>". $lex{'No Pictures Found'}. ".</p></body></html>\n";
    die;
} 

my $sth = $dbh->prepare("select lastname, firstname, studnum, grade, homeroom
 from student where pic = 'Y' order by grade, lastname, firstname");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

print "<div style=\"float:left\"><h1 style=\"margin:0; padding:0;\">
&nbsp;". $lex{'View Students by Grade'}. "</h1></div><br clear=\"left\">\n";

my $firstflag = 1;
$currgrade = -1;

while ( my ( $lastname, $firstname, $studnum, $grade, $homeroom ) = 
	$sth->fetchrow){

    $oldgrade = $currgrade;
    $currgrade = $grade;
    if ($currgrade ne $oldgrade) { # We have a new grade
	print "<br clear=\"left\"><h1>". $lex{Grade}. " $currgrade</h2>\n";
    }
    print "<div class=\"pic\"><a href=\"$picdirurl/$studnum.jpg\">";
    print "<img src=\"$tndirurl/$studnum.jpg\" ";
    print "height=\"$viewheight\"></a>";
    print "<br><b>$firstname $lastname</b><br>($studnum) ";
    print $lex{Grade}. " $grade</div>\n\n";

}

print "</body></html>\n";



#-----------
sub doDelete { # Delete Picture files
#-----------

    my $filename = shift;
    my $result = system ("rm -f $picdir/$filename");
    my $result = system ("rm -f $tndir/$filename");

    if ($result){ 
	print $lex{Error}. q{ }. $lex{'Delete Failed'}. ": $filename $?<br>\n";

    } else {
	print "$filename removed successfully.<br>\n";
	
	# If associated, removed picture tag in student record
	my ($studnum,$ext) = split /\./,$filename;
	if ($studnum =~ m/\d/){
	    my $sth = $dbh->prepare("update student set pic = NULL 
             where studnum = ?");
	    $sth->execute( $studnum );
	    if ( $DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	    print $lex{'Record Updated'}. "<br>\n";
	}
    }
}
