#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Metaedit.pl - edit meta table for formtype, default values.

my %lex = ('Main' => 'Main',
	   'Eoy' => 'Eoy',
	   'Save Changes' => 'Save Changes',
	   'Meta Attribute Edit' => 'Meta Attribute Edit',
	   'Field Id' => 'Field Id',
	   'Field Name' => 'Field Name',
	   'Defaults' => 'Defaults',
	   'Form Type' => 'Form Type',
	   'View Size' => 'View Size',
	   'Reqd(Y)' => 'Reqd(Y)',
	   'Edit Table' => 'Edit Table',
	   'Your fields have been updated.' => 'Your fields have been updated.',
	   'Edit more records' => 'Edit more records',
	   'Please select table to edit.' => 'Please select table to edit.',
	   'Error' => 'Error',
	   'Table' => 'Table',

	   );

$self = 'metaedit.pl';

$notes = 'The <b>Defaults</b> for <b>Select Form Entry</b>:
Separate items with a space (First Second),
Join multiword entries with underscore character (which will be
stripped)(First_One Second_One),
Items with leading tilde (~Choose_One~) will be ignored during student
entry.<br>
<b>Textarea Boxes</b>: put rows and cols in the viewsize field
separated with an x (ie. 6x80)';

use DBI;
use CGI;

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:mysql:$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Meta Attribute Edit'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print " <a href=\"$eoypage\">". $lex{Eoy}. "</a> ]\n";

if ( not $arr{tableid} ) { # load and display table choices.
    showTables();
}

if ( $arr{flag} ) { # write the updates
    updateTable();
}


# Select table rows to update
my $sth = $dbh->prepare("select id, fieldid, fieldname, defaultvalue,
 formtype,viewsize,required
 from meta where tableid = '$arr{tableid}' order by arrayidx");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

# section header
print "<center><h1>". $lex{'Meta Attribute Edit'}. "</h1>\n";
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"flag\" value=\"1\">\n";
print "<input type=\"hidden\" name=\"tableid\" value=\"$arr{tableid}\">\n";

print "<h1>", ucfirst($arr{tableid}), q{ }. $lex{Table}. "</h1>\n";

print "<input type=\"submit\" value=\"". $lex{'Save Changes'}. "\">\n";
print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">
  <tr><td colspan=\"7\" style=\"background-color:#EEE;\">$notes</td></tr>
  <tr><th>". $lex{'Field Id'}. "</th><th>". $lex{'Field Name'}. "</th><th>". $lex{Defaults};
print "</th><th>". $lex{'Form Type'}. "</th><th>". $lex{'View Size'}. "</th><th>". $lex{'Reqd(Y)'}. "</th></tr>\n";

while ( my ( $id, $fieldid, $fieldname, $default,$formtype,$viewsize,$required ) 
	= $sth->fetchrow){
    print "<tr><td>$fieldid</td><td>";
    print "<input type=\"text\" name=\"$id:fieldname\" value=\"$fieldname\" ";
    print "size=\"15\"></td><td>";
    print "<input type=\"text\" name=\"$id:defaultvalue\" value=\"$default\" ";
    print "size=\"40\"></td><td>";

    print "<select name=\"$id:formtype\"><option>$formtype</option>";
    print "<option>text</option><option>select</option>";
    print "<option>textarea</option><option>checkbox</option></select></td>\n";
    print "<td><input type=\"text\" name=\"$id:viewsize\" value=\"$viewsize\"";
    print " size=\"5\"></td>\n";
    print "<td><input type=\"text\" name=\"$id:required\" ";
    print " value=\"$required\" size=\"2\"></td></tr>\n";
}

print "</table><input type=\"submit\" value=\"". $lex{'Save Changes'}. "\">\n";
print "</form></body></html>";


#-------------
sub showTables { # show tables to choose from
#-------------

    # Get the table choices
    my $sth = $dbh->prepare("select distinct tableid from meta order by tableid");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

    print "<h1>". $lex{'Please select table to edit.'}. "</h1>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<select name=\"tableid\">";

    while ( my $tableid = $sth->fetchrow){
	print "<option>$tableid</option> ";
    }

    print "</select><input type=\"submit\" value=\"". $lex{'Edit Table'}. "\">";
    print "</form></body></html>\n";

    exit;

}


#--------------
sub updateTable { # write updates to meta table.
#--------------

    delete $arr{flag}; # no longer required.
    delete $arr{tableid}; # not required.

    foreach my $key (keys %arr){
	my ($id, $field) = split /:/,$key;
	my $value = $dbh->quote( $arr{$key} );

	#print "K: $key  ID: $id  FIELD: $field  VAL: $arr{$key}<br>\n";

	$sth = $dbh->prepare("update meta set $field = $value 
            where id = $id");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
    }

    print "<p>". $lex{'Your fields have been updated.'}. "</p>\n";
    print "[ <a href=\"$self\">". $lex{'Edit more records'}. "</a> ]";
    print "</body></html>\n";

    exit;

} # End of Update Table
