#! /usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# NOTE: This file is just an older version of customclasslist. Change
# existing customclasslist to print this table and remove this
# file. Perhaps allow passed table value?  TODO.

my %lex = ('Empty Class List' => 'Empty Class List',
	   'Main' => 'Main',
	   'Eoy' => 'Eoy',
	   'Rm' => 'Rm',
	   'Classlist' => 'Classlist',
	   'Students' => 'Students',
	   'View/Download Empty Classlists' => 'View/Download Empty Classlists',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

my $maxlines = 26;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
$mon++; $wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


print "$doctype\n<html><head><title>". $lex{'Empty Class List'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$eoypage\">". $lex{Eoy}. "</a>]\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $shortname = "eclasslist$$";
my $fileName = "$shortname.tex";

open(TEX,">$fileName") || die "Can't open tex file";

print TEX "\\documentclass[12pt,letterpaper]{article}
\\pagestyle{empty}
\\setlength{\\textwidth}{7.8in}
\\setlength{\\textheight}{10.6in}
\\setlength{\\hoffset}{-0.8in}
\\setlength{\\voffset}{-1.4in}
\\addtolength{\\evensidemargin}{-1in}
\\addtolength{\\oddsidemargin}{-1in}
\\setlength{\\tabcolsep}{3.5pt}\n";

print TEX "\\begin{document}\n";

$sth = $dbh->prepare("select * from preset order by homeroom,lastname,firstname");
$sth->execute;
$rows = $sth->rows;

$curroom = -1;

for ($i=1; $i<=$rows; $i++) {
   
   $oldroom = $curroom;
   @arr = $sth->fetchrow;

   $curroom = $arr[6];

if ($oldroom eq $curroom) { # We have another record for same page
  $linecount++;
  $studcount++;
  if ($linecount > $maxlines) { # We'll print a new page header here
   # New Page Header
   $linecount = 0;
   print TEX <<"EONPH";

\\end{tabular}\\\\
\\newpage
\\begin{tabular}{|p{48mm}|p{16mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}| }
{\\small $schoolname $lex{Classlist} } & & & & & & & & & & & & & & & & & \\\\
{\\small $currdate} \\bigskip & & & & & & & & & & & & & & & & & \\\\
{\\Large $teacher[1] $teacher[3] $teacher[2]} & $lex{Rm}: $curroom & & & & & & & & & & & & & & & & \\\\

\\hline
EONPH
} # End of New Page Header due to too large class

print TEX  <<"EOR";
\\vspace{0.4pt}$arr[1], $arr[2] $arr[3]\\vspace{0.8pt} & \\vspace{0.4pt}$arr[4]-$arr[7]\\vspace{0.8pt} &  &  & & & & & & & & & & & & & & \\\\
\\hline  
EOR

   } else {  # We are starting a new page

  # Get Teacher Name for the room.
  $sth1 = $dbh->prepare("select * from preteacher where homeroom = '$curroom' ");
  $sth1->execute;
  @teacher = $sth1->fetchrow;
  
  if ($i != 1) {
   $studcount++;
   print TEX "\\vspace{0.5pt} $lex{Students}: $studcount\\vspace{1pt} & & & & & & & & & & & & & & & & &  \\\\
  \\hline
  \\end{tabular}
   
  \\newpage \n";
  }

  $linecount = 0;
  $studcount = 0;
  print TEX  <<"EOP";  

\\begin{tabular}{|p{50mm}|p{16mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}| p{6mm}|p{6mm}|p{6mm}|p{6mm}|p{6mm}|}
  
{\\small $schoolname $lex{Classlist} } & & & & & & & & & & & & & & & & &\\\\
{\\small $currdate} \\bigskip & & & & & & & & & & & & & & & & & \\\\
{\\Large $teacher[1] $teacher[3] $teacher[2]} & $lex{Rm}: $curroom & & & & & & & & & & & & & & & & \\\\

\\hline

\\vspace{0.4pt}$arr[1], $arr[2] $arr[3]\\vspace{0.8pt} & \\vspace{0.4pt}$arr[4]-$arr[7]\\vspace{0.8pt} &  &  & & & & & & & & & & & & & & \\\\
\\hline 
EOP

   }   


}  # End of For loop

$studcount++;
print TEX "\\vspace{0.5pt} $lex{Students}: $studcount\\vspace{1pt} & & & & & & & & & & & & & & & & & \\\\ 
\\hline
\\end{tabular}\\\\
\\end{document}";
close TEX;

system("$pdflatex $fileName >/dev/null");
system("mv $shortname.pdf $downloaddir");
system("rm -f $shortname.*");

print "<h1><a href=\"$webdownloaddir/$shortname.pdf\">". $lex{'View/Download Empty Classlists'}. "</a></h1>\n";
#print "<p>[ <a href=\"$eoypage\">". $lex{Eoy}. "</a> ]</p>\n":
print "</body></html>\n";
