#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Find Blank or Null entries for marks for a particular term.

my %lex = ('Find Empty Mark Entries' => 'Find Empty Mark Entries',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Student Name' => 'Student Name',
	   'Course' => 'Course',
	   'Gr' => 'Gr',
	   'Not Found' => 'Not Found',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

open(TERM, "../../etc/term") || die "Can't find the term number!";
$term = <TERM>;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select  studnum, subjcode from eval
  where (a1 = '' or a1 is null) and term = ? 
  order by subjcode, studnum");
$sth->execute( $term );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Find Empty Mark Entries'}. "</title>
 <link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
 $chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]
 <center><h1>". $lex{'Find Empty Mark Entries'}. "</h1>\n";
print "<table  cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print '<tr><th>'. $lex{Course}. '</th><th>'. $lex{'Student Name'}. "</th></tr>\n"; 

my $sth1 = $dbh->prepare("select lastname,firstname from student 
 where studnum = ?");

$sth2 = $dbh->prepare("select description,grade from subject 
 where subjsec = ?");

while ( my ($studnum,$subjsec) = $sth->fetchrow ) {

    # Get the student's name
    $sth1->execute($studnum);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($lastname,$firstname) = $sth1->fetchrow;
    if (not $lastname) { $lastname = '<font color=red>'. $lex{'Not Found'}. '</font>'; }

    # Get the subject description
    $sth2->execute($subjsec);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($description,$grade) = $sth2->fetchrow;
    
    print  "<tr><td><b>$description</b> ($subjsec) ". $lex{'Gr'}. " $grade</td>
     <td>$firstname $lastname ($studnum)</td></tr>\n";
}

print "</table></body></html>\n";

