#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#  Description: Grade based subject enrollment. List all the students
#   for all the subjects in that grade. Deselect those that you don't
#   have in those subjects.

my %lex = ('Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Student Group' => 'Student Group',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Continue' => 'Continue',
	   'Show Withdrawn Students' => 'Show Withdrawn Students',
	   'Add Subject Enrollments' => 'Add Subject Enrollments',
	   'Checked' => 'Checked',
	   'Blank=All' => 'Blank=All',
	   'Separate with Spaces' => 'Separate with Spaces',
	   'Starts with' => 'Starts with',
	   'Terms' => 'Terms',
	   'Start' => 'Start',
	   'End' => 'End',
	   'Student' => 'Student',
	   'Selection' => 'Selection',
	   'Subject' => 'Subject',
	   'Grade(s)' => 'Grade(s)',
	   'Starts with' => 'Starts with',
	   'Subjects' => 'Subjects',
	   'Students' => 'Students',
	   'Your records are now stored' => 'Your records are now stored',
	   'Record exists for' => 'Record exists for',
	   'Your records are now stored' => 'Your records are now stored',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Please record the following error' => 'Please record the following error',
	   'Error' => 'Error',
	   'Checked' => 'Checked',
	   'Term' => 'Term',
	   'Not Found' => 'Not Found',
	   'Skip' => 'Skip',
	   'And' => 'And',
	   'Or' => 'Or',
	   'Name' => 'Name',


	   );

my $self = 'enroladdall.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $grade = $arr{grade};
my $checked = $arr{checked};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Add Subject Enrollments'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

print "<center><h1>". $lex{'Add Subject Enrollments'}. "</h1>\n";

if ( not $arr{page} ) {
    showStartPage();
}

if ( $arr{page} == 1 ) {
    delete $arr{page};
    selectGroups();
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    selectSubjStud();
} elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    writeRecords();
}


#----------------
sub showStartPage {
#----------------

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<center><div style=\"padding:1em;margin:0.5em 5em;border:1px solid gray;\">\n";
    print "<div style=\"color:white; background-color:blue; font-size:150%;\">\n";
    print $lex{'Student'}. q{ }. $lex{'Selection'}. "</div>\n";
    print "<table border=\"0\" cellpadding=\"3\" cellspacing=\"0\">\n";

    print "<tr><td align=\"right\">". $lex{'Student Group'}. "</td>\n<td align=\"left\">";
    print "<select name=\"group\"><option>". $lex{Grade}. "</option><option>";
    print $lex{Homeroom}. "</option></select>\n";
    print "<input type=\"input\" name=\"groupid\" size=\"12\">\n";
    print $lex{'Separate with Spaces'}. q{, }. $lex{'Blank=All'}. "</td></tr>\n";

    print "<tr><td align=\"right\">". $lex{'Show Withdrawn Students'}. "</td>\n";
    print "<td align=\"left\">";
    print "<input type=\"checkbox\" name=\"showwithdrawn\" value=\"1\">";
    print "</td></tr>\n";

    print "<tr><td align=\"right\">";
    print $lex{Checked}. "?</td>\n<td>";
    print "<input type=\"checkbox\" name=\"studcheck\" value=\"CHECKED\"></td></tr>\n";

    print "</table></div>\n";


    # Now Subject Selection.

    print "<center><div style=\"padding:1em;margin:0.5em 5em;border:1px solid gray;\">\n";
    print "<div style=\"color:white; background-color:blue; font-size:150%;\">\n";
    print $lex{'Subject'}. q{ }. $lex{'Selection'}. "</div>\n";
    print "<table border=\"0\" cellpadding=\"3\" cellspacing=\"0\">\n";

    # Search by Subject Name (Description)
    print "<tr><td align=\"right\">";
    print $lex{'Starts with'}. "</td>\n<td>";
    print "<input type=\"input\" name=\"subjname\" size=\"16\"></td></tr>\n";

    print "<tr><td align=\"right\"></td><td align=\"left\"><b>";
    print $lex{Or}. "</b></td></tr>\n";

    print "<tr><td align=\"right\">";
    print $lex{'Grade(s)'}. "</td>\n<td>";
    print "<input type=\"input\" name=\"grade\" size=\"12\"> ";
    print $lex{'Separate with Spaces'}. "</td></tr>\n";

    print "<tr><td align=\"right\"></td><td align=\"left\"><b>";
    print $lex{Or}. "</b></td></tr>\n";

#    Replace the two lines above with this once ready to do AND operations.
#    print "<tr><td></td><td align=\"left\"><select name=\"selecttype\">\n";
#    print "<option>". $lex{Or}. "</option><option>". $lex{And}. "</option></select>\n";
#    print "</td></tr>\n";

    print "<tr><td align=\"right\">";
    print $lex{Terms}. q{ (}. $lex{Start}. '-', $lex{End}. ")</td>\n<td>";
    print "<input type=\"input\" name=\"term\" size=\"12\"> 3-4 6-8\n";
    print $lex{'Separate with Spaces'}. "</td></tr>\n";

    print "<tr><td align=\"right\">";
    print $lex{Checked}. "?</td>\n<td>";
    print "<input type=\"checkbox\" name=\"subjcheck\" value=\"CHECKED\"></td></tr>\n";

    print "<tr><td></td><td><input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
    print "</td></tr>\n</form></div></body></html>\n";

    exit;

}



#-----------------
sub selectGroups { # select groups of students and subjects to enrol.
#-----------------

    # foreach my $key ( sort keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }


    my $table = 'student'; # overridden to studentall if show withdrawn selected.
    my $group;
    if ( $arr{group} eq $lex{Grade} ) {
	$group = 'grade';
    } else {
	$group = 'homeroom';
    }

    if ( $arr{showwithdrawn} ) { # change to both student tables.
	$table = 'studentall';
    }
    
    my $studcheck = $arr{studcheck};
    my $subjcheck = $arr{subjcheck};
    my @groups = split /\s/, $arr{groupid};

    my $select;
    my $orderby;
    if ( not @groups ) { # select all students 
	my $sth = $dbh->prepare("select lastname, firstname, studnum, $group from $table
          order by lastname, firstname");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	while ( my ( $lastname, $firstname, $studnum, $grp ) = $sth->fetchrow ) {
	    push @students, $studnum;
	    $students{$studnum} = "$lastname, $firstname ($grp)";
	}

    } else { # we have groups of students

	my $sth = $dbh->prepare("select lastname, firstname, studnum, $group from $table
          where $group = ? order by lastname, firstname");

	foreach my $grp ( @groups ) {
	    $sth->execute( $grp );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    while ( my ( $lastname, $firstname, $studnum, $grp ) = $sth->fetchrow ) {
		push @students, $studnum;
		$students{$studnum} = "$lastname, $firstname ($grp)";
	    }
	}
    }
    # All students now in @students and %students;


    # Now do Subject Selection.
    my ( @subjects_name, %subjects_name);

    # Search by description if any...
    if ( $arr{subjname} ) { 

	# Find all subjects with this name.
	my $sth = $dbh->prepare("select description, subjsec from subject 
             where description like ? order by description");
	$desc = $arr{subjname}. '%';
	$sth->execute( $desc );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	while ( my ( $description, $subjsec ) = $sth->fetchrow ) {
	    push @subjects_name, $subjsec;
	    $subjects_name{$subjsec} = $description;
	}
	
    }


    # Search by grades, if any.
    my ( @subjects_grade, %subjects_grade);

    if ( $arr{grade} ) { 
	my @grades = split /\s/, $arr{grade};
	
	foreach my $gr (sort  @grades ) {
	    # Find all subjects in this grade...
	    my $sth = $dbh->prepare("select description, subjsec from subject 
                 where grade = ? order by description");
	    $sth->execute( $gr );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    
	    while ( my ( $description, $subjsec ) = $sth->fetchrow ) {
		push @subjects_grade, $subjsec;
		$subjects_grade{$subjsec} = $description;
	    }
	}
    }


    # Find all subjects for these terms
    my ( @subjects_term, %subjects_term);
    if ( $arr{term} ) {
	$sth = $dbh->prepare("select description, subjsec from subject 
         where startrptperiod = ? and endrptperiod = ? order by description");

	my @termgroups = split /\s+/, $arr{term};
	foreach my $val ( @termgroups ) {
	    my ( $start, $end ) = split /-/, $val;
	    $sth->execute( $start, $end );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    
	    while ( my ( $description, $subjsec ) = $sth->fetchrow ) {
		push @subjects_term, $subjsec;
		$subjects_term{$subjsec} = $description;
	    }
	}
    }

    # selecttype eq 'and' and we are doing double selection by both terms AND grades
    # Now do some fancy intersections of them...
    


    # Now should have @subjects and %subjects populated.
    #print "Subjects:",  @subjects, "<br>\n";

    # Print Form start
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";

    # Get Checkbox state (for next page for select particular subject-student enrol).
    print "<p align=\"left\"><span style=\"border:1px solid gray; ";
    print "margin:1em 2em; padding:1em; text-align:left;\">";
    print $lex{Checked}. "?</td>\n<td>";
    print "<input type=\"checkbox\" name=\"checked\" value=\"CHECKED\"></td></tr>\n";
    print "</span></p>\n";

    # Print Student Information.
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\" ";
    print "style=\"float:left;margin:1em;\">\n";

    print "<tr><td align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";

    
    foreach my $studnum ( @students ){  #loop through students

	my ($dud, $grp) = split /\(/, $students{$studnum};
	chop $grp; # remove trailing parens.
	$oldgrp = $currgrp;
	$currgrp = $grp;
	if ( $currgrp ne $oldgrp ) { # switch colors;
	    if ( $class eq 'blue' ) { $class = 'gray'; } else { $class = 'blue'; }
	}

	print "<tr class=\"$class\"><td>";
	print "<input type=\"checkbox\" name=\"$students{$studnum}:ST:$studnum\" ";
	print "value=\"1\" $studcheck>\n";
	print " $students{$studnum}</td></tr>\n";

    }

    print "<tr><td align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";
    print "</table>\n";


    # Print Subject Information, now
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\" ";
    print "style=\"float:left;margin:1em;\">\n";

    print "<tr><td align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";


    $sth = $dbh->prepare("select startrptperiod, endrptperiod, teacher from subject 
      where subjsec = ?");

    if ( @subjects_name ) {
	print "<tr><th>". $lex{Name}. " $arr{subjname}</th></tr>\n";
	foreach my $subjsec ( @subjects_name ){  # loop through subjects by Name

	    $sth->execute( $subjsec );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my ( $startterm, $endterm, $teacher ) = $sth->fetchrow;
	    my ($tname, $dud) = split /\(/, $teacher; # strip userid.
	
	    print "<tr class=\"gray\"><td>";
	    print "<input type=\"checkbox\" name=\"$subjects_name{$subjsec}:SU:$subjsec\" ";
	    print "value=\"1\" $subjcheck>\n";
	    print " $subjects_name{$subjsec} ($subjsec) $tname &ndash; ". $lex{Terms};
	    print " $startterm\-$endterm</td></tr>\n";
	}
    }

    if ( @subjects_grade ) {
	print "<tr><th>". $lex{'Grade(s)'}. " $arr{grade}</th></tr>\n";
	foreach my $subjsec ( @subjects_grade ){  # loop through subjects by Name

	    $sth->execute( $subjsec );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my ( $startterm, $endterm, $teacher ) = $sth->fetchrow;
	    my ($tname, $dud) = split /\(/, $teacher; # strip userid.	

	    print "<tr class=\"gray\"><td>";
	    print "<input type=\"checkbox\" name=\"$subjects_grade{$subjsec}:SU:$subjsec\" ";
	    print "value=\"1\" $subjcheck>\n";
	    print " $subjects_grade{$subjsec} ($subjsec) $tname &ndash; ". $lex{Terms};
	    print " $startterm\-$endterm</td></tr>\n";
	}
    }


    if ( @subjects_term ) {
	print "<tr><th>". $lex{Terms}. " $arr{term}</th></tr>\n";
	foreach my $subjsec ( @subjects_term ){  # loop through subjects by Name

	    $sth->execute( $subjsec );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my ( $startterm, $endterm, $teacher ) = $sth->fetchrow;
	    my ($tname, $dud) = split /\(/, $teacher; # strip userid.	

	    print "<tr class=\"gray\"><td>";
	    print "<input type=\"checkbox\" name=\"$subjects_term{$subjsec}:SU:$subjsec\" ";
	    print "value=\"1\" $subjcheck>\n";
	    print " $subjects_term{$subjsec} ($subjsec) $tname &ndash; ". $lex{Terms};
	    print " $startterm\-$endterm</td></tr>\n";
	}
    }


    print "<tr><td align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";
    print "</form></table></body></html>\n";

    exit;

}




#-----------------
sub selectSubjStud {
#-----------------

    # foreach my $key ( sort keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    # select Student-Subject enrollments - one student in one subject;
    my $checked = $arr{checked};
    delete $arr{checked};


    foreach my $key ( sort keys %arr) {
	my ($dud, $sigil, $value ) = split /:/, $key;
	if ( $sigil eq 'ST' ) {
	    push @students, $value; 
	} elsif ( $sigil eq 'SU' ) { 
	    push @subjects, $value; 
	} else { # problems!
	    print $lex{Error}. " $key<br>\n";
	}

    }

    # Find subject descriptions / student name
    my $sth = $dbh->prepare("select description from subject where subjsec = ?");
    my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");


    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";

    print "<div style=\"text-align:left;\">\n";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></div>\n";

    foreach my $subjsec ( @subjects ) {

	# Get Subject Description
	$sth->execute( $subjsec );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $description = $sth->fetchrow;
	
	# Print Table Heading
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\" ";
	print "style=\"float:left;margin:1em;\">\n";
	print "<tr><th>$description ($subjsec)</th></tr>\n";

	foreach my $studnum ( @students ) {

	    # Get Student Name
	    $sth1->execute( $studnum );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    my ( $lastname, $firstname ) = $sth1->fetchrow;

	    # print a current table row
	    print "<tr><td>";
	    print "<input type=\"checkbox\" name=\"$subjsec:$studnum\" value=\"1\" $checked>\n";
	    print "<b>$lastname,</b> $firstname</td>\n";

	}

	print "</table>\n";

    }

    print "<br clear=\"left\">\n";
    print "<div style=\"text-align:left;\">\n";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></div>\n";

    print "</form></body></html>\n";

    exit;


} # end of selectSubjects



#---------------
sub writeRecords {
#---------------
    
    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    print "</h1>\n<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print '<tr><th>'. $lex{Students}. '</th><th>'. $lex{Subjects};
    print '</th><th>'. $lex{Terms}. "</th></tr>\n";

    my $sth = $dbh->prepare("select description, startrptperiod, endrptperiod 
     from subject where subjsec = ?");
    my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");

    foreach my $key ( sort keys %arr ) {  # $key contains studnum:subjsec 

	my ( $subjsec, $studnum ) = split(/:/,$key);
       
	# Read the subject information
	$sth->execute( $subjsec );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my ( $description, $startterm, $endterm ) = $sth->fetchrow;

	# Get Student Name
	$sth1->execute( $studnum );
	if ( $DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth1->fetchrow;
	if ( not $lastname ) { 
	    $lastname = "<span style=\"color:red;\">". $lex{'Not Found'}. '</span>'; 
	}

	# Check for the existence of the same record(s),
	# one for each term for each student in each subject.
	my ( $term, %terms );

	$sth2 = $dbh->prepare("select term from eval
          where subjcode = ? and studnum = ? order by term");
	$sth2->execute( $subjsec, $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}


	# Put existing term records in the 'terms' hash; check for dups.
	while ( my $term = $sth2->fetchrow ) {
	    if ( $terms{$term} ) {
		print $lex{'Record exists for'}. q{ }. $lex{Term}. ": $term ". 
		print " $description ($subjsec) - $lastname, $firstname ($studnum).<br>\n";
		# miss steak? next;
	    } else { # add to hash.
		$terms{$term} = 1;
	    }
	}

	# print line for this record.
	print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td>";
	print "<td>$description ($subjsec)</td>\n<td> ";


	# Loop through and check where term is missing...
	for ( my $i = $startterm; $i <=$endterm; $i++ ) {
	    if ( not $terms{$i} ){ # fill in holes!
		$sth3 = $dbh->prepare("insert into eval ( subjcode, studnum, term )
                  values ( ?, ?, ? )");
		$sth3->execute( $subjsec, $studnum, $i ); # $i is the term
		if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
		print " $i ";
	    } else { 
		print '('. $lex{Skip}. " $i) ";
	    }
	} # Loop for Terms
	print "</td></tr>\n"; # end of printed row
	
    } # Next Student/Subject combination.

    if ( not $DBI::errstr ) {
	print "</table>\n";
	print "<h3>". $lex{'Your records are now stored'}. ".</h3></p>\n";
    } else {
	print "</table><p>". $lex{'There was an error storing your data'}. ".\n";
	print $lex{'Contact'};
	print " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Please record the following error'}. ": $DBI::errstr</p>\n";
    }

    print "<p>[ <a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";
    print "</p></center></body></html>\n";

    exit;

} # End of writeRecords
