#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my $self = 'enrolstudview.pl';

my %lex = ('Student Subject Enrollment Search' => 'Student Subject Enrollment Search',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Please search again' => 'Please search again',
	   'not enrolled in any subjects' => 'not enrolled in any subjects',
	   'Search' => 'Search',
	   'Student (Last,First/Last/Initials/Studnum)' => 
	     'Student (Last,First/Last/Initials/Studnum)',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Error' => 'Error',
	   'Student Name' => 'Student Name',
	   'Student Number' => 'Student Number',
	   'Subject' => 'Subject',
	   'Teacher' => 'Teacher',
	   'Term' => 'Term',
	   
	   );


use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;
my $student = $arr{student};

$dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

# Print Html Head
print "$doctype\n<html><head><title>". $lex{'Student Subject Enrollment Search'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";
print "<center><h1>". $lex{'Student Subject Enrollment Search'}. "</h1>\n";

mkSearchError();
if ( not $student ) { exit; }

# Setup the Search
if ( $student =~ /\d+/ ) {  # we have a student number
    $sth = $dbh->prepare("select studnum from studentall where studnum = ?"); # req'd.
    $sth->execute( $student );
} else { # we have words hopefully with a comma
    ( $lastname, $firstname )  = split /\,/, $student;
    $firstname =~ s/^\s*//;
    $lastname =~ s/^\s*//;

    if ( $lastname and $firstname ){ # both entered.

	$sth = $dbh->prepare("select studnum from studentall 
         where lastname = ? and firstname = ?");
	$sth->execute( $lastname, $firstname );

    } elsif ( $lastname and not $firstname ){ # only lastname (no comma)

	if ( length( $lastname ) == 2){ # search by initials: fi, li.
	    $fi = substr($lastname,0,1); $li = substr($lastname,1,1);
	    $fi = $fi. '%'; $li = $li. '%';
	    $sth = $dbh->prepare("select studnum from studentall 
              where lastname $sql{like} ?  and firstname $sql{like} ?");
	    $sth->execute( $li, $fi );

	} else { # lastname only
	    $sth = $dbh->prepare("select studnum from studentall 
             where lastname = ? order by firstname");
	    $sth->execute( $lastname );

	}
    } else { # print an error....
	mkSearchError();
	print "</body></html>\n";
	die;
    }

} # End of Search.

if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;
if ($rows < 1) { 
    print "<h1>". $lex{'No Student(s) Found'}. q{.  }. $lex{'Please search again'}. ".</h1>\n";
    print "</body></html>\n";
    die; 
} 

my @student = ();
while ( my $sn = $sth->fetchrow ) {
    push @students, $sn;
}
my $first = 1;

# Now loop through all students found.
foreach my $studnum ( @students ) {

    my $sth = $dbh->prepare("select s.lastname, s.firstname, 
     e.studnum, e.subjcode, e.term 
     from eval as e, studentall as s 
     where s.studnum = e.studnum and  s.studnum = ? 
     order by e.subjcode, e.term");

    $sth->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;

    if ( $rows < 1 ) { 

	my $sth3 = $dbh->prepare("select lastname, firstname from studentwd where studnum = ?");
	$sth3->execute( $studnum );
	if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname) = $sth3->fetchrow;

	if ( not $lastname ){ # look in student table...
	    $sth3 = $dbh->prepare("select lastname, firstname from student where studnum = ?");
	    $sth3->execute( $studnum );
	    if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr; }
	    my ($lastname, $firstname) = $sth3->fetchrow;
	    $name = "<span style=\"font-size: 140%;\">$firstname $lastname</span>";
	} else { # found in studentwd
	    $name = "<span style=\"color:red; font-size:140%; font-weight:bold;\">$firstname $lastname</span>";
	}

	print "<p></p><table cellpadding=\"3\" cellspacing=\"0\"  border=\"1\">\n";
	print "<tr><th>". $lex{'Student Name'}. "</th></tr>\n";
	print "<tr><td>$name ($studnum) ". $lex{'not enrolled in any subjects'}. ".</td>";
	print "</tr></table><p></p>\n";
	next;
    } # End of If Rows < 1 (not enrolled)

    if ( not $first ){ print "</table><p>&nbsp;</p>\n";} else { $first = 0;}
    print "<b>". $lex{'Student Number'}. ": $studnum</b>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{'Student Name'}. "</th><th>". $lex{Subject}. "</th><th>";
    print $lex{Teacher}. "</th><th>". $lex{Term}. "</th></tr>\n"; 

    while ( my ( $lastname, $firstname, $studnum, $subjsec, $term ) = $sth->fetchrow ) {

	my $sth2 = $dbh->prepare("select description, teacher from subject where subjsec = ?");
	$sth2->execute( $subjsec );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my ($description, $teacher) = $sth2->fetchrow;
	
	print  "<tr><td><b>$lastname</b>, $firstname</td>";
	print "<td>$description ($subjsec)</td><td>$teacher</td>\n";
	print "<td align=\"center\">$term</td></tr>\n";

    }

    print "</table><p></p>\n";

}

mkSearchError();
print "</body></html>\n";


#----------------
sub mkSearchError {
#----------------

    print "<div style=\"border: 1px solid gray;padding:1em; width:400px;\">\n";
    print "<b>". $lex{'Student Subject Enrollment Search'}. "</b><br>\n";

    print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"submit\" value=\"". $lex{Search}. "\">\n";
    print "<input type=\"text\" name=\"student\" size=\"30\"><br>\n";
    print $lex{'Student (Last,First/Last/Initials/Studnum)'}. "\n";
    print "</form></div>\n";

}
