#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Subject' => 'Subject',
	   'Term' => 'Term',
	   'Comment' => 'Comment',
	   'Mark' => 'Mark',
	   'No Student Found' => 'No Student Found',
	   'Edit/Delete Subject Enrollments' => 
	     'Edit/Delete Subject Enrollments',
	   'Delete Subject Enrollment' => 
	     'Delete Subject Enrollment',
	   'Contact' => 'Contact',
	   'Record deleted' => 'Record deleted',
	   'Are you sure you want to delete this record?' => 
	     'Are you sure you want to delete this record?',
	   'Delete the Record' => 'Delete the Record',
	   'Delete' => 'Delete',
	   'Error' => 'Error',
	   'Yes' => 'Yes',

	   );

my $self = 'evaldel.pl';

use CGI;
use DBI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Edit/Delete Subject Enrollments'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> |\n";
print "<a href=\"evaldeled.pl\">". $lex{'Edit/Delete Subject Enrollments'}. "\n";
print "</a> ]\n";

print "<center><h1>". $lex{'Delete Subject Enrollment'}. "</h1>\n";

if ( $arr{itemid} ) {
    deleteRecord( $arr{itemid} );
} elsif ( $arr{deleteflag} ) {
    delete $arr{deleteflag};
    deleteAltRecs( $arr{studnum}, $arr{subjsec} );
} elsif ( $arr{subjsec} ) {
    showAltRecs( $arr{studnum}, $arr{subjsec} );
} 


my $sth = $dbh->prepare("select * from eval where id = ?"); 
$sth->execute( $arr{id} );
my @arr = $sth->fetchrow;

# Lookup Student Name
$sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?"); 
$sth->execute( $arr[2] );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my ( $lastname, $firstname ) = $sth->fetchrow;
if ( not $lastname ) {
    $lastname = "<font color=\"red\">". $lex{'No Student Found'}. "</font>";
}

print "<div style=\"font-size:150%;\">$firstname $lastname</div>\n";

print "<table><tr><td align=right>". $lex{Subject}. "</td><td>$arr[1]</td></tr>\n";
print "<tr><td align=\"right\"><b>". $lex{Term}. "</b></td><td>$arr[4]</td></tr>\n";
print "<tr><td align=\"right\"><b>". $lex{Comment}. "</b></td><td>$arr[6]</td></tr>\n";
print "<tr><td align=\"right\"><b>". $lex{Mark}. "</b></td><td>$arr[7]</td></tr>\n";
print "<tr><td align=\"right\"></td><td>$arr[8]</td></tr>\n";
print "<tr><td align=\"right\"></td><td>$arr[9]</td></tr>\n";
print "<tr><td align=\"right\"></td><td>$arr[10]</td></tr></table>\n";

print "<p><em>". $lex{'Are you sure you want to delete this record?'}. "</em></p>\n";
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"itemid\" value=\"$arr{id}\">\n";
print "<input type=\"hidden\" name=\"subjsec\" value=\"$arr[1]\">\n";
print "<input type=\"submit\" value=\"". $lex{Yes}. q{, }. $lex{'Delete the Record'};
print "\"></center>\n";

print "</form></body></html>\n";


#---------------
sub deleteRecord {
#---------------

    my $id = shift;

    # Get studnum and subjsec
    my $sth = $dbh->prepare("select studnum, subjcode from eval where id = ?");
    $sth->execute( $id );
    my ( $studnum, $subjsec ) = $sth->fetchrow;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr;}

    # Get Description for Subject
    $sth = $dbh->prepare("select description from subject where subjsec = ?");
    $sth->execute( $subjsec );
    my $description = $sth->fetchrow;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }


    # Delete the record.
    $sth = $dbh->prepare("delete from eval where id = ?");
    $sth->execute( $id );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

    if ( $DBI::errstr ) {
	print "<h3>". $lex{Error}. q{. $DBI::errstr }. $lex{Contact}. " $adminname</h3>\n";
    } else {
	print "<h3>". $lex{'Record deleted'}. ".</h3>\n";
    }

    print "<form action=\"evaldeled.pl\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">";
    print "<input type=\"submit\" value=\"$description\">\n";
    print "<form></center></body></html>\n";

    exit;
}


#--------------
sub showAltRecs {
#--------------

    my ( $studnum, $subjsec ) = @_;

    # Lookup Student Name
    $sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?"); 
    $sth->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname ) = $sth->fetchrow;
    if ( not $lastname ) {
	$lastname = "<font color=\"red\">". $lex{'No Student Found'}. "</font>";
    }
    
    # Get Description for Subject
    $sth = $dbh->prepare("select description from rc_subject where subjsec = ?");
    $sth->execute( $subjsec );
    my $description = $sth->fetchrow;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

    print "<div style=\"font-size:150%;\">$firstname $lastname<br>";
    print "$description ($subjsec)</div>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"deleteflag\" value=\"1\">\n";
    print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
    print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Term}. "</th><th>". $lex{Delete}. "</th></tr>\n";
 
    my $sth = $dbh->prepare("select distinct e.term from rc_obj_eval as e
      left outer join rc_objective as o on e.objid = o.id
      where e.studnum = ? and o.subjsec = ?");
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    $sth->execute( $studnum, $subjsec );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    while ( my $term = $sth->fetchrow ) {
	print "<tr><td align=\"center\">$term</td><td>";
	print "<input type=\"checkbox\" size=\"4\" name=\"t$term\" value=\"1\">";
	print "</td></tr>\n";
    }

    print "</table>\n";
    print "<input type=\"submit\" value=\"". $lex{Yes}. q{ }. $lex{'Delete the Record'}. "\">\n";
    print "</form></body></html>\n";

    exit;

}


#----------------
sub deleteAltRecs {
#----------------

    my $studnum = $arr{studnum};
    delete $arr{studnum};
    my $subjsec = $arr{subjsec};
    delete $arr{subjsec};

    # Get Description for Subject
    my $sth = $dbh->prepare("select description from rc_subject where subjsec = ?");
    $sth->execute( $subjsec );
    my $description = $sth->fetchrow;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

    $sth = $dbh->prepare("delete from rc_obj_eval where id = ?");

    my $sth1 = $dbh->prepare("select e.id from rc_obj_eval as e
      left outer join rc_objective as o on e.objid = o.id
      where o.subjsec = ? and e.studnum = ? and e.term = ?"); 

    foreach my $key ( sort keys %arr ) {
	$key =~ s/t//; # remove 't'
	#print "Term: $key<br>\n";

	$sth1->execute( $subjsec, $studnum, $key );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	while ( my $id = $sth1->fetchrow ) { # loop over all records for this term.
	    $sth->execute( $id ); # delete record
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	}

    }

    if ( $DBI::errstr ) {
	print "<h3>". $lex{Error}. q{. $DBI::errstr }. $lex{Contact}. " $adminname</h3>\n";
    } else {
	print "<h3>". $lex{'Record deleted'}. ".</h3>\n";
    }

    print "<form action=\"evaldeled.pl\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">";
    print "<input type=\"hidden\" name=\"mode\" value=\"alt\">";
    print "<input type=\"submit\" value=\"$description\">\n";
    print "<form></center></body></html>\n";

    exit;

}

