#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Report Card' => 'Report Card',
	   'Main' => 'Main',
	   'Subject-Section' => 'Subject-Section',
	   'Grade' => 'Grade',
	   'Edit/Delete' => 'Edit/Delete',
	   'PowerDelete' => 'PowerDelete',
	   'Error' => 'Error',
	   'Group' => 'Group',
	   'Student' => 'Student',
	   'Term' => 'Term',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Edit/Delete Subject Enrollments' => 'Edit/Delete Subject Enrollments',
	   'Withdrawn' => 'Withdrawn',
	   'Alternate Report Card System' => 'Alternate Report Card System',
	   'Alt Edit' => 'Alt Edit',

	   );

my $self = 'evaldeled.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Page Header
print "$doctype\n<html><head><title>". $lex{'Edit/Delete Subject Enrollments'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> |\n";
print "<a href=\"#alternate\">". $lex{'Alt Edit'}. "</a> ]\n";

print "<center><h1>". $lex{'Edit/Delete Subject Enrollments'}. "</h1>\n";

#foreach my $key ( keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

if ( $arr{subjsec} ) {
    if ( $arr{mode} eq 'alt' ) {
	showAltStudents( $arr{subjsec} );
    } else {
	showStudents( $arr{subjsec} );
    }
}

# Show Main Eval Subjects
my $sth = $dbh->prepare("select subjsec, description, grade from subject 
 order by grade, description");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }


# Print Table Heading.
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th>". $lex{'Subject-Section'}. "</th><th>". $lex{'Grade'};
print "</th><th></th><th></th></tr>\n";

my $sth1 = $dbh->prepare("select count(*) from eval where subjcode = ?");

while ( my ( $subjsec, $description, $grade ) = $sth->fetchrow ) {

    # Count values in eval table; skip if none...
    $sth1->execute( $subjsec );
    my $count = $sth1->fetchrow;
    if ( $count < 1 ) { next; }

    print "<tr><td><b>$description</b> ($subjsec)</td><td>". $lex{Grade}. " $grade</td>\n";

    print "<td><form action=\"$self\"  method=\"post\">\n";
    print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Edit/Delete'}. "\"></form></td>\n";

    print "<td><form action=\"evalpwrdel.pl\" method=\"post\">";
    print "<input type=\"hidden\" name=\"subj\" value=\"$subjsec\">\n";
    print " Chk <input type=\"checkbox\" name=\"checked\" value=\"checked\">\n";
    print "<input type=\"submit\" value=\"". $lex{'PowerDelete'}. "\"></form></td></tr>\n";

}
print "</table>\n";

print "<div style=\"border:1px solid gray; background-color:#DDD; padding:1em;\">\n";
print "<a name=\"alternate\"></a>\n"; 
print "<h1>". $lex{'Alternate Report Card System'}. "</h1>\n";


showAltSubjects();

print "</div></center></body></html>\n";



#------------------------
sub showAltSubjects {
#------------------------

    my $sth = $dbh->prepare("select subjsec, description, studgrpname, studgrpvalue 
      from rc_subject 
      order by studgrpname, studgrpvalue, description");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    # Print Table Heading.
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{'Subject-Section'}. "</th><th>". $lex{'Group'};
    print "</th><th></th><th></th></tr>\n";

    my $sth1 = $dbh->prepare("select count(e.id) from rc_obj_eval as e 
      left outer join rc_objective as o on o.id = e.objid where o.subjsec = ?"); 

    while ( my ($subjsec, $description, $studgrpname, $studgrpvalue ) = $sth->fetchrow ) {

	# Count values in eval table; skip if none...
	$sth1->execute( $subjsec );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $count = $sth1->fetchrow;
	#print "Subjsec: $subjsec $description Count:$count<br>\n";	

	if ($count < 1) { next; }

	print "<tr><td><b>$description</b> ($subjsec)</td><td> $studgrpname $studgrpvalue</td>\n";
	
	print "<td><form action=\"$self\"  method=\"post\">\n";
	print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
	print "<input type=\"hidden\" name=\"mode\" value=\"alt\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Edit/Delete'}. "\"></form></td>\n";
	
	print "<td><form action=\"evalpwrdel.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
	print " Chk <input type=\"checkbox\" name=\"checked\" value=\"checked\">\n";
	print "<input type=\"submit\" value=\"". $lex{'PowerDelete'}. "\"></form></td></tr>\n";

    }

    print "</table></center></body></html>\n";

    exit;

}  # end of showAltSubjects



#---------------
sub showStudents {
#---------------

    # Expect to be passed a subject-section code.
    my $subjsec = shift;

    # Find subject name
    $sth = $dbh->prepare("select description from subject where subjsec = ?");
    $sth->execute( $subjsec );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $description = $sth->fetchrow;

    # Find students and terms
    my @studnumarray;
    $sth = $dbh->prepare("select studnum,id,term from eval where subjcode = ?");
    $sth->execute( $subjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;
    for (1..$rows){
	my ($studnum,$id,$term) = $sth->fetchrow;
	push @studnumarray,"$studnum:$id:$term";
    }

    # Now get the matching names (if not withdrawn)
    foreach $studnum ( @studnumarray ) {
	( $studnum,$id,$term ) = split /:/,$studnum;
	my $sth = $dbh->prepare("select lastname, firstname from student where studnum = ?");
	$sth->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die;}
	$rows = $sth->rows;

	my $wdflag;
	if ( $rows < 1 ) {  # Look in studentwd (withdrawn students)
	    $sth = $dbh->prepare("select lastname, firstname from studentwd where studnum = ?");
	    $sth->execute( $studnum );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
	    $wdflag = "<font color=red>". $lex{'Withdrawn'}. "!</font>";  # Withdrawn Flag
	}
	my ($lastname,$firstname) = $sth->fetchrow;
	push @evalarray, "$lastname, $firstname $wdflag:$studnum:$id:$term";
    
    }

    @evalarray = sort @evalarray;
    # We now have an array of sorted kids for this subject

    print "<div style=\"font-size:150%;font-weight:bold;\">\n";
    print "$description ($subjsec)</div>\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Student}. "</th><th>". $lex{Term}. "</th><th>";
    print $lex{Edit}. "</th><th>". $lex{Delete}. "</th></tr>\n";

    foreach my $record ( @evalarray ) {
	my ($name,$studnum,$id,$term) = split /:/,$record;
	print "<tr><td>$name ($studnum)</td><td align=\"center\">$term</td>\n";

	print "<td><form action=\"evaled.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$id\">";
	print "<input type=\"submit\" value=\"". $lex{Edit}. "\"></form></td>\n";

	print "<td><form action=\"evaldel.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"id\" value=\"$id\">";
	print "<input type=\"submit\" value=\"". $lex{Delete}. "\"></form></td></tr>\n";

    }

    print "</table></center></body></html>\n";

    exit;

} # end of showStudents



#------------------
sub showAltStudents {
#------------------

    # Expect to be passed a subject-section code. (called subjcode in eval)
    my $subjsec = shift;

    # Find subject name
    $sth = $dbh->prepare("select description from rc_subject where subjsec = ?");
    $sth->execute( $subjsec );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $description = $sth->fetchrow;


    # Find students, objectives, and terms.
    my $sth = $dbh->prepare("select distinct e.studnum from rc_obj_eval as e 
      left outer join rc_objective as o on o.id = e.objid where o.subjsec = ?"); 
    $sth->execute( $subjsec );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    # Find Student Name
    my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");

    # Loop through all students enroled in subject
    while ( my $studnum = $sth->fetchrow ) {

	$sth1->execute( $studnum );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth1->fetchrow;
	$students{"$lastname, $firstname"} = $studnum;
    }

    # We now have an array of sorted kids for this subject
    print "<div style=\"font-size:150%;font-weight:bold;\">\n";
    print "$description ($subjsec)</div>\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Student}. "</th><th>";
    print $lex{Edit}. "</th><th>". $lex{Delete}. "</th></tr>\n";

    foreach my $name ( sort keys %students ) {
	my $studnum = $students{$name};
	print "<tr><td>$name ($studnum)</td>\n";

	print "<td><form action=\"evaled.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
	print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
	#print "<input type=\"hidden\" name=\"mode\" value=\"alt\">\n";
	print "<input type=\"submit\" value=\"". $lex{Edit}. "\"></form></td>\n";

	print "<td><form action=\"evaldel.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
	print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
	#print "<input type=\"hidden\" name=\"mode\" value=\"alt\">\n";
	print "<input type=\"submit\" value=\"". $lex{Delete}. "\"></form></td></tr>\n";

    }

    print "</table></center></body></html>\n";

    exit;

} # end of showAltStudents
