#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ( 'Edit Evaluation Records' => 'Edit Evaluation Records',
	    'Report Card' => 'Report Card',
	    'Main' => 'Main',
	    'Update Record(s)' => 'Update Record(s)',
	    'Mark' => 'Mark',
	    'Subject-Section' => 'Subject-Section',
	    'Student' => 'Student',
	    'Comment' => 'Comment',
	    'Error' => 'Error',
	    'Objective' => 'Objective',
	    'Term' => 'Term',
	    'Evaluation' => 'Evaluation',
	    'Record(s) Updated' => 'Record(s) Updated',
	    'Contact' => 'Contact',
	    'Edit' => 'Edit',

	   );

my $self = 'evaled.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    print $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Edit Evaluation Records'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";
print "<center><h1>". $lex{'Edit Evaluation Records'}. "</h1>\n";


if ( $arr{studnum} ) { # edit the alt repcard system records
    editStudent( $arr{studnum}, $arr{subjsec} );
} elsif ( $arr{writealt} ) {
    delete $arr{writealt};
    updateAltRecords();
} elsif ( $arr{writeflag} ) {
    delete $arr{writeflag};
    updateRecord();
}


# Asumme this is passed; record to edit $arr{id}
my $sth = $dbh->prepare("select * from eval where id = ?"); 
$sth->execute( $arr{id} );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
my @arr = $sth->fetchrow;
my $studnum = $arr[2]; # simpler to remember
my $subjsec = $arr[1];

# Now find the evaluation codes for this subject.
$sth = $dbh->prepare("select * from subject where subjsec = ?"); 
$sth->execute( $subjsec );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr;}
my @subject = $sth->fetchrow;

# Student Name
$sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?"); 
$sth->execute( $studnum );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr;}
my ( $lastname, $firstname ) = $sth->fetchrow;


print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"id\" value=\"$arr[0]\">
<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";

print "<table><tr><td align=\"right\">". $lex{'Subject-Section'}. "</td>";
print "<td>$subjsec</td></tr>\n";

print "<tr><td align=\"right\">". $lex{Student};
print "</td><td>$firstname $lastname ($studnum)</td></tr>\n";

print "<tr><td align=\"right\">". $lex{Term}. "</td><td>\n";
print "<input type=\"text\" name=\"term\" size=\"4\" value=\"$arr[4]\" maxlength=\"4\">";
print "</td></tr>\n";

print "<tr><td align=\"right\">". $lex{Comment}. "</td><td>\n";
print "<textarea name=\"comment\" rows=\"4\" cols=\"60\">$arr[6]</textarea></td></tr>\n";


my $ansnum = 0;
for my $i ( 7..26 ) {

    $ansnum++; 
    my $ansname = "A$ansnum";
    my $subjindex = $i + 3;

    if ( $subject[$subjindex] or $ansnum == 1) { # If we have an eval outcome
	if ( not $subject[$subjindex] ){ $subject[$subjindex] = $lex{Mark}; }
	print "<tr><td align=\"right\">$subject[$subjindex]</td>\n";
	print "<td><input type=\"text\" name=\"$ansname\" size=\"12\" ";
	print "maxlength = \"12\" value=\"$arr[$i]\">";
	print "</td></tr>\n";
    }
}

print "</table><p><input type=\"submit\" value=\"". $lex{'Update Record(s)'}. "\">\n";
print "</form></center></body></html>\n";


#--------------
sub editStudent {
#--------------

    my ( $studnum, $subjsec ) = @_;
    #print "Student: $studnum Subj: $subjsec<br>\n";

    # Student Name
    $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?"); 
    $sth1->execute( $studnum );
    my ($lastname, $firstname ) = $sth1->fetchrow;
    print "<h1>$firstname $lastname \n";

    # Subject Description
    my $sth1 = $dbh->prepare("select description from rc_subject where subjsec = ?"); 
    $sth1->execute( $subjsec );
    my $subjectdescription = $sth1->fetchrow;
    print "&mdash; $subjectdescription</h1>\n";

    # Prepare for Objective Description / Choices
    $sth1 = $dbh->prepare("select description from rc_objective where id = ?"); 
    $sth2 = $dbh->prepare("select choice from rc_obj_choice where objid = ? order by choice"); 


    # Get Objectives for this student for this subject
    my $sth = $dbh->prepare("select e.id, e.objid, e.term, e.eval from rc_obj_eval as e 
      left outer join rc_objective as o on o.id = e.objid 
      where o.subjsec = ? and e.studnum = ? 
      order by e.term, o.groupname, o.groupseq");
   
    $sth->execute( $subjsec, $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errrstr; }


    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"writealt\" value=\"1\">\n";

    print "<div style=\"padding:0.3em;\">";
    print "<input type=\"submit\" value=\"". $lex{'Update Record(s)'}. "\"></div>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Objective}. "</th><th>". $lex{Term}. "</th><th>";
    print $lex{Evaluation}. "</th></tr>\n";

    # Loop through all eval records for all objectives, terms for this subject
    while ( my ( $id, $objid, $term, $eval ) = $sth->fetchrow ) {
	my $description;
	if ( $objectives{$objid} ) { # check for presence in hash.
	    $description = $objectives{$objid};
	} else {
	    $sth1->execute( $objid ); # if not, put it in...
	    $description = $sth1->fetchrow;
	    $objectives{$objid} = $description;
	}

	print "<tr><td>$description </td><td align=\"center\">$term</td><td>\n";
	print "<select name=\"$id\"><option>$eval</option>\n";
	$sth2->execute( $objid );
	while ( my $choice = $sth2->fetchrow ) {
	    print "<option>$choice</option>";
	}
	if ( $eval ) { print "<option></option>\n"; } # to allow reset to nothing.
	print "</select></td></tr>\n";

    }

    print "</table><div style=\"padding:0.3em;\">";
    print "<input type=\"submit\" value=\"". $lex{'Update Record(s)'}. "\"></div>\n";
    print "</form></center></body></html>\n";

    exit;

}


#---------------
sub updateRecord {
#---------------

    my $id = $arr{id};
    delete $arr{id};

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # Get subjsec and description
    my $sth = $dbh->prepare("select subjcode from eval where id = ?");
    $sth->execute( $id );
    my $subjsec = $sth->fetchrow;

    $sth = $dbh->prepare("select description from subject where subjsec = ?");
    $sth->execute( $subjsec );
    my $description = $sth->fetchrow;


    foreach my $key ( sort keys %arr ) { 
	my $sth = $dbh->prepare("update eval set $key = ? where id = $id");
	$sth->execute( $arr{$key} );
    }

    if ( not $DBI::errstr ) { 
	print "<h3>". $lex{'Record(s) Updated'}. "</h3>\n";
    } else { 
	print '<h3>'. $lex{Error}. " $DBI::errstr<br>\n";
	print $lex{Contact};
	print " $adminname <a href=\"mailto:$adminemail\">$adminemail</a> ]</h3>\n";
    }

    print "<p>[ <a href=\"$reppage\">". $lex{'Report Card'}. "</a> | \n";
    print "<form action=\"evaldeled.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Edit Evaluation Records'}. "\">\n";
    print "</form>\n";

    print "<form action=\"evaldeled.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Edit'}. " $description\"></form>\n";
    print "</body></html>\n";

    exit;

}



#-------------------
sub updateAltRecords {
#-------------------

    my $sth1 = $dbh->prepare("select s.description, s.subjsec from rc_subject as s
      left outer join rc_objective as o on s.subjsec = o.subjsec
      left outer join rc_obj_eval as e on o.id = e.objid
      where e.id = ?");
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


    my $sth = $dbh->prepare("update rc_obj_eval set eval = ? where id = ?");
    # Check against existing value
    my $sth1 = $dbh->prepare("select eval from rc_obj_eval where id = ?"); 
    my $count = 0;
    my $id;
    
    foreach my $key ( sort keys %arr ) { 

	# skip if unchanged
	$sth1->execute( $key );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $eval = $sth1->fetchrow;
	if ( $eval eq $arr{$key} ) { next; }

	# reset eval value
	$sth->execute( $arr{$key}, $key );
	$count++;
	$id = $key; # need single id to find name of subject

    }

    $sth->execute( $id );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $description, $subjsec ) = $sth1->fetchrow;


    if ( not $DBI::errstr ) { 
	print "<h3>$count ". $lex{'Record(s) Updated'}. "</h3>\n";
    } else { 
	print '<h3>'. $lex{Error}. " $DBI::errstr<br>\n";
	print $lex{Contact};
	print " $adminname <a href=\"mailto:$adminemail\">$adminemail</a> ]</h3>\n";
    }

    print "<p>[ <a href=\"$reppage\">". $lex{'Report Card'}. "</a> | \n";
    print "<form action=\"evaldeled.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Edit Evaluation Records'}. "\">\n";
    print "</form>\n";

    print "<form action=\"evaldeled.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
    print "<input type=\"hidden\" name=\"mode\" value=\"alt\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Edit'}. " $description\"></form>\n";
    print "</body></html>\n";

    exit;

}
