#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('POWER Delete Evaluation/Subject Enrollment Records' => 
	     'POWER Delete Evaluation/Subject Enrollment Records',
	   'No Subject Found!' => 'No Subject Found!',
	   'Erase Checked Records' => 'Erase Checked Records',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Name' => 'Name',
	   'Delete' => 'Delete',
	   'Withdrawn' => 'Withdrawn',
	   'NOTE' => 'NOTE',
	   'There is NO confirmation checking' => 'There is NO confirmation checking',
	   'These records are deleted immediately upon clicking this button!' =>
	     'These records are deleted immediately upon clicking this button!',
	   'Your selected evaluation records are now erased' => 
	     'Your selected evaluation records are now erased',
	   'Edit/Delete Enrollment/Evaluation Records' => 
	     'Edit/Delete Enrollment/Evaluation Records',
	   'Error' => 'Error',
	   'Contact' => 'Contact',
	   'Please record the following error' => 'Please record the following error',
	   'There was an error storing your data' => 'There was an error storing your data',

	   );

my $self = 'evalpwrdel.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;
my $subjsec = $arr{subj};
my $checked = $arr{checked};


# HTML Header
print "$doctype\n<html><head>\n<title>";
print $lex{'POWER Delete Evaluation/Subject Enrollment Records'}. "\n";
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

print "<center><h1>". $lex{'POWER Delete Evaluation/Subject Enrollment Records'}. "</h1>\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


if ( $arr{flag} ) {
    delete $arr{flag};
    deleteRecords();
}


# Find and print subject name...
my $sth = $dbh->prepare("select description from subject where subjsec = ?");
$sth->execute( $subjsec );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
my $description = $sth->fetchrow;
if ( not $description ){ $description = $lex{'No Subject Found!'}; }

print "<div style=\"font-size:150%;font-weight:bold;\">$description 
($subjsec)</div>\n";

my $sth = $dbh->prepare("select distinct e.studnum, s.lastname, s.firstname 
 from eval as e 
 left outer join studentall as s on e.studnum = s.studnum
 where e.subjcode = ?  group by e.studnum
 order by s.lastname, s.firstname");

# Previous select to find all values for individual edits...
# my $sth = $dbh->prepare("select eval.id, eval.term, eval.comment, eval.a1,
#  eval.studnum, studentall.lastname, studentall.firstname from eval 
#  left outer join studentall on eval.studnum = studentall.studnum
#  where eval.subjcode = ? 
#  order by studentall.lastname, studentall.firstname, eval.term");

$sth->execute( $subjsec );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }


# Table/Form start
print "<form action=\"$self\" method=\"post\">";
print "<input type=\"hidden\" name=\"flag\" value=\"1\">\n";
print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
print "<input type=\"submit\" value=\"". $lex{'Erase Checked Records'}. "\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th>". $lex{Name}. "</th><th>". $lex{Delete}. "</th></tr>\n";

my $sth1 = $dbh->prepare("select lastname,firstname from student where studnum = ?");

while ( my ( $studnum, $lastname,$firstname ) = $sth->fetchrow ){

    # Get the Name to check which table student is in...
    $sth1->execute( $studnum );
    if ($DBI::errstr){ print $DBI::errstr; die;}
    my ($currlastname, $currfirstname) = $sth1->fetchrow;

    my $name; # combined name
    if (not $currlastname){ 
	$name = "<font color=\"red\">". $lex{Withdrawn}. "<b>$lastname</b>, $firstname</font>";
    } else {
	$name = "<b>$lastname</b>, $firstname";
    }

    print "<tr><td>$name ($studnum)</td>\n<td>";
    print "<input type=\"checkbox\" name=\"$studnum\" value=\"1\" $checked></td></tr>\n";
}

print "</table>\n";
print "<input type=\"submit\" value=\"". $lex{'Erase Checked Records'}. "\"></form>\n";
print "<p><b>". $lex{'NOTE'}. ":</b> ". $lex{'There is NO confirmation checking'}. ".<br>\n"; 
print $lex{'These records are deleted immediately upon clicking this button!'}. "</p>\n";

print "</center></body></html>\n";


#----------------
sub deleteRecords {
#----------------

    my $subjsec = $arr{subjsec};
    delete $arr{subjsec};

    #foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    
    my $sth = $dbh->prepare("delete from eval where studnum = ? and subjcode = ?");

    foreach my $studnum ( keys %arr ) { 

	$sth->execute( $studnum, $subjsec );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

    }

    if ( not $DBI::errstr ) {
	print "<h3>". $lex{'Your selected evaluation records are now erased'}. ".</h3>\n";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. ". \n";
	print $lex{Contact}. " $adminname <a href=\"mailto:$adminemail\">$adminemail</a> \n"; 
	print $lex{'Please record the following error'}. ": $DBI::errstr \n";
    }

    print "<p>[ <a href=\"evaldeled.pl\">";
    print $lex{'Edit/Delete Enrollment/Evaluation Records'}. "</a> | \n";
    print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]</p>\n";

    print "</body></html>\n";

    exit;

}
