#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#  Description: Class based subject enrollment. List all the students
#   for all the subjects in that class. Deselect those that you don't
#   have in those subjects.

my %lex = ( 'Subject Enrollment by Homeroom' => 'Subject Enrollment by Homeroom',
	    'Report Card Page' => 'Report Card Page',
	    'Main' => 'Main',
	    'Continue' => 'Continue'
	   );

use DBI;
use CGI;

unless (require "../../etc/admin.conf") {
    print "Cannot open admin.conf!";
    die "Cannot open admin.conf!";
}

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

my $homeroom = $arr{homeroom};
delete $arr{homeroom};

my $checked = $arr{checked};
delete $arr{checked};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Subject Enrollment by Homeroom'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | 
<a href=\"$reppage\">". $lex{'Report Card Page'}. "</a> ]\n";

# Put all students of that homeroom into a student array
my $sth = $dbh->prepare("select lastname, firstname, initial, studnum
 from student where homeroom = '$homeroom' 
 order by grade, lastname, firstname");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
while (my ($lastname, $firstname, $initial, $studnum) = $sth->fetchrow) {
    push @studarray, "$lastname, $firstname $initial:$studnum";
}

print "<center><h1>". $lex{'Subject Enrollment by Homeroom'};
print "</h1><form action=\"enroladd1.pl\" method=\"post\"> 
<input type=\"submit\" value=\"". $lex{'Continue'}. "\">\n";

# Note: We are passing control to a common entry script enroladd1 that
#  is also used by the Add by Grade subject enrollment scripting.

my $sth = $dbh->prepare("select description from subject where subjsec = ?");

foreach my $key (keys %arr){ #loop through passed subjects;

    $sth->execute($key);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
    my $description = $sth->fetchrow;
    
    print "<div style=\"float:left;\">";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\" style=\"background-color:#EEE;\">\n";
    print "<tr><th colspan=\"2\">$description ($key)</th></tr>\n";
    foreach $student (@studarray) {
	my ($name,$studnum) = split /:/,$student;
	print "<tr><td>$name ($studnum)</td>\n";
	print "<td><input type=\"checkbox\" name=\"$studnum:$key\" ";
	print "value=\"1\" $checked></td></tr>\n";
    }
    print "</table></div>\n\n";
} # End of Enrollment Loop

print "</center></form></center></body></html>\n";




