#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Subject Enrollment' => 'Subject Enrollment',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Subject Enrollment' => 'Subject Enrollment',
	   'Additional Subjects' => 'Additional Subjects',
	   'Enter Subject-Section Code' => 'Enter Subject-Section Code',
	   'Enroll Student' => 'Enroll Student',
	   'Please enter a Student Number' => 'Please enter a Student Number',
	   'Student not found' => 'Student not found',
	   'Please Select Student' => 'Please Select Student',
	   'Continue' => 'Continue',
	   'Grade' => 'Grade',
	   'Subjects Already Enrolled' => 'Subjects Already Enrolled',
	   'No Subjects' => 'No Subjects',
	   'Subject' => 'Subject',
	   'Select' => 'Select',
	   
	   );


use DBI;
use CGI;

require "../../etc/admin.conf" or die "Cannot open admin.conf!";

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

# Page Header
print "$doctype\n<html><head><title>". $lex{'Subject Enrollment'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

if (not $arr{student}){
    print "<h3>". $lex{'Please enter a Student Number'}. "!</h3>\n";
    print "</body></html>\n";
    die;
}

my $student = $arr{student};
my $checked = $arr{checked};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my ($firstname, $lastname);
if ($student =~ m/\D/) { # not a digit... try to find him/her.
    ($lastname,$firstname)  = split /\,/, $student;
    $firstname =~ s/^\s*//;
    $lastname =~ s/^\s*//;
    if ($lastname and $firstname){ # both entered.
	$sth = $dbh->prepare("select * from student 
        where lastname = '$lastname' and 
         firstname = '$firstname'");
    } elsif ($lastname and not $firstname){ # only lastname (no comma)
	if (length($lastname) == 2){ # search by initials: fi, li.
	    $fi = substr($lastname,0,1); $li = substr($lastname,1,1);
	    $sth = $dbh->prepare("select * from student 
              where lastname $sql{like} '$li%' and firstname $sql{like} '$fi%'");
	} else {
	    $sth = $dbh->prepare("select * from student 
             where lastname = '$lastname' order by firstname");
	}
    } else { # print an error....
	print "<h1>Student not found!</h1>\n";
	print "</body></html>\n";
	die; 
    }
}


# Get the Student Information
if (not $sth) { # must have been a digit for student number...
    $student = $dbh->quote($student);
    $sth = $dbh->prepare("select * from student where studnum = $student ");
}

$sth->execute;
if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr;}

$studrows = $sth->rows;
if ($studrows < 1){ 
    print "<h1>". $lex{'Student not found'}. ".</h1></body></html>";
    die;
} elsif ($studrows > 1) { # We have more than 1 student... allow selection.
    print "<br><h3><b>". $lex{'Please Select Student'}. ".</b></h3>\n";
    print "<form action=\"enrolstud0.pl\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"checked\" value=\"$checked\">\n";
    while (my @student = $sth->fetchrow) {
       print "<input type=\"radio\" name=\"student\" value=\"$student[4]\">\n";
       print "$student[2] $student[1]<br>\n";
    }
    print "<br><input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
    print "</form></body></html>\n";
    die;
}


my @student = $sth->fetchrow;
my $studnum = $student[4];

# Print Start of Page / Table setup.
print "<center><h1>". $lex{'Subject Enrollment'}. "</h1>\n";
print "<font size=\"+1\"><b>$student[2] $student[3] $student[1] (". $lex{Grade}. " $student[5])</b></font>\n";

print "<table><tr><td valign=\"top\">
<!--  Left Column  -->
<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\"><tr><th>";
print $lex{'Subjects Already Enrolled'}. "</th></tr>\n";


# Print Out Existing Subject enrollments for this student
$sth = $dbh->prepare("select distinct subjcode from eval 
    where studnum = ?");
$sth->execute($studnum);
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
my $subjrows = $sth->rows;

if ($subjrows < 1){ # No subjects
    print "<tr><td><b>". $lex{'No Subjects'}. "</b></td></tr>\n";}
else {
    for (1..$subjrows){
	$subjsec = $sth->fetchrow;
	# Get subject record and print subject
	$sth1 = $dbh->prepare("select * from subject 
         where subjsec = ? order by description");
	$sth1->execute($subjsec);
	if ($DBI::errstr){print $DBI::errstr; die;}
	@subject = $sth1->fetchrow;
	print "<tr><td>$subject[2] ($subject[9])</td></tr>\n";
    }
}

print "</table></td><td valign=\"top\"><!--  Right Column  -->
<form action=\"enrolstud1.pl\" method=\"post\"> 
<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">
<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

print "<tr><th>". $lex{Subject}. "</th><th>". $lex{Select}. "</th></tr>\n";


# Next get the subjects for this grade and display.

$sth1 = $dbh->prepare("select * from subject 
   where grade = ? order by description");
$sth1->execute($student[5]);
if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr; }
$subjrows = $sth1->rows;
for (1..$subjrows) {
    @subject = $sth1->fetchrow;
    my $subject = "$subject[2] ($subject[9])";
    my $subjsec = $subject[9];

    print "<tr><td>$subject</td>
    <td><input type=\"checkbox\" name=\"$studnum:$subjsec\" 
    value=1 $checked></td></tr>\n";
}

## End of HTML ##
print "<tr><th colspan=\"2\" align=\"center\">". $lex{'Additional Subjects'}. "</th></tr>
<tr><th colspan=\"2\" align=\"center\">". $lex{'Enter Subject-Section Code'}. "</th></tr>
<tr><td colspan=\"2\" align=\"center\"><input type=\"text\" name=\"subject1\" size=\"8\"></td></tr>
<tr><td colspan=\"2\" align=\"center\"><input type=\"text\" name=\"subject2\" size=\"8\"></td></tr>
<tr><td colspan=\"2\" align=\"center\"><input type=\"text\" name=\"subject3\" size=\"8\"></td></tr>
<tr><td colspan=\"2\" align=\"center\"><input type=\"text\" name=\"subject4\" size=\"8\"></td></tr>
<tr><td colspan=\"2\" align=\"center\"><input type=\"text\" name=\"subject5\" size=\"8\"></td></tr>
<tr><td colspan=\"2\" align=\"center\"><input type=\"text\" name=\"subject6\" size=\"8\"></td></tr>
</table>\n";

print "<center><input type=\"submit\" value=\"". $lex{'Enroll Student'}. "\"></center></form>\n";
 print "</td></tr></table></center></body></html>\n";
