#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Subject' => 'Subject',
	   'Term' => 'Term',
	   'Records' => 'Records',
	   'Report Card' => 'Report Card',
	   'Your enrollments are now stored' => 'Your enrollments are now stored',
	   'Please contact' => 'Please contact',
	   'Your enrollments are now stored' => 'Your enrollments are now stored',
	   'Please record the following error' => 'Please record the following error',
	   'Student Subject Enrollment' => 'Student Subject Enrollment',
	   'skip' => 'skip',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'No such subject-section' => 'No such subject-section',


	   );


use DBI;
use CGI;

require "../../etc/admin.conf" or die "Cannot open admin.conf!";

 
my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

my $studnum = $arr{studnum}; #used throughout

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get the Student Information
$sth = $dbh->prepare("select lastname, firstname, initial from student 
  where studnum = ?");
$sth->execute($studnum);
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my ($lastname, $firstname, $middlename) = $sth->fetchrow;


print "$doctype\n<html><head><title>". $lex{'Student Subject Enrollment'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

print "<center><h1>". $lex{'Student Subject Enrollment'}. "</h1>
<h3>$firstname $middlename $lastname</h3>
<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">
<tr><th>". $lex{Subject}. "</th><th>". $lex{Term}. "<br>";
print $lex{Records}. "</th></tr>\n";


# Do the loop for the 6 extra subject fields. Fail if not exist.
for (1..6){
    $subjfield = "subject$_";  # make subject1, subject2, etc.
    if ($arr{$subjfield}){ # We have a subjsec entry
	$sth = $dbh->prepare("select * from subject 
         where subjsec = '$arr{$subjfield}'");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	$subjrows = $sth->rows;
	@subject = $sth->fetchrow;
	if ($subjrows < 1){  # We don't have this subject; skip!
	    print "<h1>". $lex{'No such subject-section'}. ": $arr{$subjfield}</h1>\n";
	    next;
	}
	push @entry,"$subject[9]:$subject[2]:$subject[32]:$subject[33]";
    }
}


# Now put these into the database.
foreach $subject (@entry) {
    ($subjsec,$description,$startrp,$endrp) = split /:/,$subject;
    print "<tr><td>$description ($subjsec)</td><td align=\"center\">";

    for ($i = $startrp;$i <=$endrp; $i++){

	# Check for existence of record
	$sth = $dbh->prepare("select id from eval
         where subjcode = '$subjsec' and term = '$i' 
         and studnum = '$studnum'");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $id = $sth->fetchrow;
	if ($id) { 
	    print "(<font color=\"red\">". $lex{skip}. " $i</font>)\n";
	    next; # skip to next record...
	}

	# put in the record if we get this far...
	$sth = $dbh->prepare("insert into eval values (
	  $sql{default},'$subjsec','$studnum',NULL,'$i',
          NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, NULL, NULL)");
	$sth->execute;
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	print " $i ";

    }  # Loop for Terms

    print "</td></tr>\n";

    # Write the EvalJrl entry.
    wrEvalJrl($subjsec,$studnum);

}    


foreach $key (keys %arr) {  # $key contains studnum:subjsec 
                            # $arr{$key} contains 1
    if ($arr{$key} == 1) {
	($dud,$subjsec) = split(/:/,$key);
       
	#Read the subject into @subject
	$sth1 = $dbh->prepare("select * from subject 
         where subjsec = '$subjsec'");
	$sth1->execute;
	if ($DBI::errstr){ print $DBI::errstr; die; }
	@subject = $sth1->fetchrow;

	$startterm = $subject[32];
	$endterm = $subject[33];

	print "<tr><td>$subject[2] ($subject[9])</td>\n<td align=\"center\">";

	for ($i = $startterm;$i <=$endterm; $i++){

	    # Check for existence of record
	    $sth = $dbh->prepare("select id from eval
             where subjcode = '$subjsec' and term = '$i' and studnum = '$studnum'");
	    $sth->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    my $id = $sth->fetchrow;
	    if ($id) { 
		print "(<font color=\"red\">". $lex{skip}. " $i</font>)\n";
		next; # skip to next record...
	    }

	    $sth = $dbh->prepare("insert into eval values (
 	     $sql{default},'$subjsec','$studnum','$subject[4]','$i',
             NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
             NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
             NULL, NULL, NULL, NULL, NULL, NULL)");
	    $sth->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    print " $i ";
       
	}  # Loop for Terms

	print "</td></tr>\n";

    } # End of If
}

print "</table>\n";

# End HTML Section.
if (not $DBI::errstr ) {
   print "<h3>". $lex{'Your enrollments are now stored'}. ".</h3></p>\n";
} else {
    print "<h3>". $lex{'There was an error storing your data'}. ". ";
    print $lex{'Please contact'}. " $adminname at <a href=\"mailto:$adminemail\">$adminemail</a> ";
    print $lex{'Please record the following error'}. ": $DBI::errstr</p>\n";
}

print "<p>[ <a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";
print "</p></center></body></html>\n";
