#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Please enter a Subject-Section code!' =>
	     'Please enter a Subject-Section code!',
	   'Single Subject Enrollment' => 'Single Subject Enrollment',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Subject not found' => 'Subject not found',
	   'Continue' => 'Continue',
	   'Students' => 'Students',
	   'Select' => 'Select',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

print "$doctype\n<html><head><title>". $lex{'Single Subject Enrollment'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

print "<center><h1>". $lex{'Single Subject Enrollment'}. "</h1>\n";

if (not $arr{subjsec}){
    print "<h3>". $lex{'Please enter a Subject-Section code!'}. "</h3>\n";
    print "</body></html>\n";
    die;
}

my $subjsec = $arr{subjsec};
my $checked = $arr{checked};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# First find the subject record of subject to add.
$sth = $dbh->prepare("select description, subjsec, grade from subject 
  where subjsec = ?");
$sth->execute($subjsec);
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my $subjrows = $sth->rows;
if ($subjrows < 1){
    print "<h3>". $lex{'Subject not found'}. "!</h3>\n";
    print "</body></html>\n";
    die;
}
my ($description,$subjsec,$grade) = $sth->fetchrow;

# Loop through students identifying groups and assg subject,teacher.

my $sth = $dbh->prepare("select lastname,firstname,initial,studnum 
  from student order by lastname, firstname");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my $studrows = $sth->rows;

print "<h3>$description ($subjsec) ". $lex{Students}. ": $studrows</h3>\n";

print "<form action=\"enroladd1.pl\" method=\"post\">\n";
print "<input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th>". $lex{Students}. "</th><th>". $lex{Select}. "</th></tr>\n";

while( my ($lastname, $firstname, $middlename, $studnum) = $sth->fetchrow) {
    print "<tr><td><b>$lastname</b>, $firstname $middlename ($studnum)</td>\n";
    print "<td><input type=\"checkbox\" name=\"$studnum:$subjsec\" ";
    print "value=\"1\" $checked></td></tr>\n";
}
print "</table>\n";

print "<input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
print "</form></center></body></html>\n";

