#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Subject Enrollment Summary' => 'Subject Enrollment Summary',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Subjects Enrolled' => 'Subjects Enrolled',
	   'Students' => 'Students',
	   'Subjects NOT Enrolled' => 'Subjects NOT Enrolled',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Create Sorted List of Subject-Section Code in Subject table
my $sth = $dbh->prepare("select distinct subjsec, grade, description from subject 
  order by grade, description,subjsec");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
while ( my ($subjsec, $gr, $desc) = $sth->fetchrow ) {
    push @subjarray,$subjsec;
}

# Now run through eval table finding folks
my @eval;
$sth = $dbh->prepare("select distinct subjcode from eval order by subjcode desc");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

my $sth1 = $dbh->prepare("select description, grade from subject where subjsec = ?");

while ( my $subjsec = $sth->fetchrow ) {
    $sth1->execute( $subjsec );
    my ($description, $grade) = $sth1->fetchrow;
    $eval{$subjsec} = "1";
    push @eval,"$grade:$description:$subjsec";
}
@eval = sort @eval;


# Print HTML Page Header

print "$doctype\n<html><head><title>". $lex{'Subject Enrollment Summary'}. "</title>
 <link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
 $chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

print "<center><h1>". $lex{'Subject Enrollment Summary'}. "</h1>\n";

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">
<tr><td valign=\"top\">
<!--  Left Column -->
<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th>". $lex{'Subjects Enrolled'}. "</th><th>". $lex{Students}. "</th></tr>\n";


foreach my $subject ( @eval ){  # those already enrolled

    my ($grade,$description,$subjsec) = split /:/,$subject;

    # print the subject 
    print "<tr><td align=\"left\"><b>$grade</b>) $description ($subjsec)</td>\n";
    
    $sth=$dbh->prepare("select distinct subjcode,studnum from eval 
      where subjcode = '$subjsec'");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die; }
    $rows = $sth->rows;
    
    print "<td align=\"center\">$rows</td></tr>\n";
}

print "</table></td><td valign=\"top\">
<!--  Right Column  -->\n";

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th colspan=\"2\">". $lex{'Subjects NOT Enrolled'}. "</th></tr>\n";
 
foreach my $subjsec ( @subjarray ) {
    if ( not $eval{$subjsec} ) {
	$sth1 = $dbh->prepare("select description,grade from subject where subjsec = ?");
	$sth1->execute( $subjsec );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ($description,$grade) = $sth1->fetchrow;
	print "<tr><td align=\"left\"><b>$grade</b>) $description ($subjsec)</td></tr>\n";
    }
}

print "</table>\n";
print"</td></tr></table></body></html>\n";

