#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Teacher Subject Report' => 'Teacher Subject Report',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Name' => 'Name',
	   'Subj-Sec' => 'Subj-Sec',
	   'Alias' => 'Alias',
	   'Terms' => 'Terms',
	   'No Teacher Found' => 'No Teacher Found',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
    $iddst) = localtime(time);
$year = $year + 1900;
$mon++; $wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sortorder = "teacher, grade, description";

my $sth = $dbh->prepare("select description, subjsec, teacher, alias, 
 startrptperiod, endrptperiod from subject order by $sortorder");
$sth->execute;
if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'Teacher Subject Report'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:2em 4em;\">\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

print "<h1>". $lex{'Teacher Subject Report'}. "</h1><h3>$currdate</h3>\n";

my $currtch = "-1";
my $first = 1;

while ( my ( $description, $subjsec, $teacher, $alias, $startterm, $endterm) 
	= $sth->fetchrow ) {

    if (not $teacher){
	$teacher = "<font color=red size=+1>". $lex{'No Teacher Found'}. "</font>";
    }

    $oldtch = $currtch;
    $currtch = $teacher;

    if ($currtch ne $oldtch) {
	if (not $first){ print "</table>\n"; } else { $first = 0; }
	print "<div style=\"margin:2em 1em 0.5em 1em;border-bottom:";
	print "1px solid gray;padding:0.3em;width:50%;\">";
	print "<b><i>$currtch</i></b></div>\n";
	print "<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";
	print '<tr><th>'. $lex{Name}. '</th><th>'. $lex{'Subj-Sec'};
	print '</th><th>'. $lex{Alias};
	print "</th><th>". $lex{Terms}. "</th></tr>\n";

    }

    print "<tr><td><b>$description</b></td><td>$subjsec</td>\n";
    print "<td>$alias</td><td align=\"center\">$startterm - $endterm</td></tr>\n";

}

print "</table></body></html>\n";
