#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Subject Mark Sheets' => 'Subject Mark Sheets',
	   'All' => 'All',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Report' => 'Report',
	   'Grade' => 'Grade',
	   'Teacher' => 'Teacher',
	   'Subject' => 'Subject',
	   'All Grades' => 'All Grades',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
    $iddst) = localtime(time);
$year = $year + 1900;
$mon++; $wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;
# Passed Values in $arr{select}:  All, Teacher, Grade, Subject


open(TERM, "../../etc/term") || die "Can't find the term number!";
my $term = <TERM>;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sortorder;
if ($arr{select} eq $lex{Teacher} ){
    $sortorder = "teacher, grade, description";
} elsif ( $arr{select} eq $lex{Grade} ){
    $sortorder = "grade, description, teacher";
} elsif ($arr{select} eq $lex{Subject} ){
    $sortorder = "description, grade, teacher";
} else {  
    $sortorder = "teacher, grade, description";
}

# Print Page Head
print "$doctype\n<html><head><title>". $lex{'Subject Mark Sheets'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |
<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

print "<center><h1>". $lex{'Subject Mark Sheets'}. "</h1><h3>$currdate</h3>\n";

if ( $arr{select} eq $lex{All} ){ # Display choices by Grade

    $sth = $dbh->prepare("select distinct grade from subject order by grade");
    $sth->execute;
    if ( $DBI::errstr){print $DBI::errstr; die $DBI::errstr; }
    my $rows = $sth->rows;

    print"<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";
    print "<tr><th>". $lex{Grade}. "</th><th>". $lex{Report}. "</th></tr>\n";
    print "<tr><td>". $lex{'All Grades'}. "</td><td>";
    print "<a href=\"rptsummark1.pl?grade=". $lex{All}. "\">". $lex{Report}. "</a></td></tr>\n";

    for ($i=1; $i <= $rows; ++$i) {
	$grade = $sth->fetchrow;
	print "<tr><td align=\"center\">$grade</td><td>\n";
	print "<a href=\"rptsummark1.pl?grade=$grade\">". $lex{Report}. "</a>";
	print "</td></tr>\n";
    }
    print "</table></body></html>\n";

} else { # Do it one of the other ways....

    $sth = $dbh->prepare("select subjsec, description, grade, teacher from subject 
      order by $sortorder");
    $sth->execute;
    if ($DBI::errstr){print $DBI::errstr; die; }
    $rows = $sth->rows;

    print"<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";
    print "<tr><th>". $lex{Subject}. "</th><th>". $lex{Grade}. "</th><th>";
    print $lex{Teacher}. "</th><th>". $lex{Report}. "</th></tr>\n";

    while ( my ( $subjsec, $description, $grade, $teacher ) = $sth->fetchrow ) {
	print "<tr><td>$description ($subjsec)</td><td align=\"center\">$grade</td>";
	print "<td>$teacher</td><td>\n";
	print "<a href=\"rptsummark1.pl?subjsec=$subjsec\">". $lex{Report}. "</a></td></tr>\n";
    }

}
print "</td></tr></table></center></body></html>\n";
