#! /usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Student Summary Marks' => 'Student Summary Marks',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'No records found for' => 'No records found for',
	   'Grade' => 'Grade',
	   'Term' => 'Term',
	   'Student Marks' => 'Student Marks',
	   'View/Download Student Summary Mark List' => 'View/Download Student Summary Mark List',
	   'View Log File' => 'View Log File',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../../lib/liblatex.pl";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

# Get Markfield (field storing a mark value) and $additionalcomments
eval require "../../etc/repcard.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
$mon++; $wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
%arr = $q->Vars;



print "$doctype\n<html><head><title>". $lex{'Student Summary Marks'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";


my $maxlines;
if ($arr{maxstudents}) {
   $maxlines=$arr{maxstudents};
} else {
   $maxlines = 32;
}
my $grade = $arr{grade}; # grade is passed.

open TERM,"<","../../etc/term" or die "Cannot open term!";
my $term = <TERM>;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select student.lastname, student.firstname, 
  eval.studnum, eval.subjcode, eval.$markfield from eval left outer join student
  on student.studnum = eval.studnum 
  where term = '$term' and  grade = '$grade' 
  order by student.lastname, student.firstname, eval.studnum, eval.subjcode");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;
if ($rows < 1) { 
    print "<h1>". $lex{'No records found for'}. q{ }. $lex{Grade};
    print ": $grade ". $lex{Term}. ": $term</h1>\n";
    print "</body></html>\n";
    die;
}


# Now get TEX ready...
my $shortname = "summarkstud$$";
my $fileName = "$shortname.tex";

open(TEX,">$fileName") || die "Can't open tex file";

my $papersize;
if ( $defaultpapersize ) {
    $papersize = $defaultpapersize;
} else {
    $papersize = 'letterpaper';
}


print TEX "\\documentclass[11pt,$papersize]{article}
\\usepackage{array,colortbl,multicol,inputenc}
\\inputencoding{latin1}
\\renewcommand{\\familydefault}{\\sfdefault}
%\\pagestyle{empty}
\\setlength{\\textwidth}{7.9in}
\\setlength{\\textheight}{9.5in}
\\setlength{\\hoffset}{-1.5in}
\\setlength{\\voffset}{-1.4in}
\\addtolength{\\evensidemargin}{0in}
\\addtolength{\\oddsidemargin}{0in}
\\setlength{\\tabcolsep}{3.5pt}
\\setlength{\\extrarowheight}{4pt}\n";

print TEX "\\begin{document}{\\sf\\huge ". $lex{Grade};
print TEX " $grade ". $lex{'Student Marks'}. "}\n\\hfill ". $lex{Term};
print TEX " $term -- $currdate\n\n\\hrulefill\\begin{multicols}{2}\n\\raggedcolumns\n\n";

my $oldstud = -1;
my $startflag = 1;

while ( my @arr = $sth->fetchrow ) {
    @arr = latex_filter(@arr);
    my ( $lastname, $firstname, $studnum, $subjsec, $eval ) = @arr;

    $oldstud = $curstud;
    $curstud = $studnum;

    if ($oldstud ne $curstud){  # print new student info
	if (not $startflag) { 
	    print TEX "\\end{tabular}\n\\bigskip\n\n"; 
	} else {
	    $startflag = 0;
	}
	print TEX "\\begin{tabular}{|p{2.8in}|p{0.5in}|}\\hline\n";
	print TEX "\\multicolumn{2}{|c|}{\\rule[-2mm]{0mm}{9mm}";
	print TEX "\\sf\\LARGE $arr[1] $arr[0]}\\\\\\hline\\hline\n";
    }

    # Get the subject name...
    my $sth1 = $dbh->prepare("select description from subject 
     where subjsec = ?"); 
    $sth1->execute($subjsec);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

    my $description = $sth1->fetchrow;
    if ($description eq $additionalcomments) { next; } # skip additional comments subject.
    ($description) = latex_filter(($description));

    # Print the Line
    print TEX "$description ($arr[3]) & \\hfil $arr[4]\\hfil\\\\\\hline\n";

} # End of main loop

if (not $startflag ) { print TEX "\\end{tabular}\n\n"; } # no records...

print TEX "\\end{multicols}\n\\end{document}\n";
close TEX;


print "<center><h1><a href=\"$webdownloaddir/$shortname.pdf\">";
print $lex{'View/Download Student Summary Mark List'}. "</a></h1>\n";

print "[ <a href=\"$reppage\">". $lex{'Report Card'}. "</a> | \n";
print "<a href=\"$webdownloaddir/pdflog$$.txt\">". $lex{'View Log File'}. "</a> ]\n";

system("$pdflatex $fileName >pdflog$$.txt");
system("mv $shortname.pdf $downloaddir");
system("mv pdflog$$.txt $downloaddir");
system("rm -f $shortname.*");

print "</center></body></html>\n";
