#! /usr/bin/perl 
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Report' => 'Report',
	   'Main' => 'Main',
	   'Transcript' => 'Transcript',
	   'Edit Transcripts' => 'Edit Transcripts',
	   'Transcripts Report' => 'Transcripts Report',
	   'Transcripts' => 'Transcripts',
	   'Transcript of Marks' => 'Transcript of Marks',
	   'No Quality Score for' => 'No Quality Score for',
	   'Report Card' => 'Report Card',
	   'Term' => 'Term',
	   'Credits Earned' => 'Credits Earned',
	   'Credits Attempted' => 'Credits Attempted',
	   'Reqd' => 'Reqd',
	   'Earned' => 'Earned',
	   'Total' => 'Total',
	   'Approved by' => 'Approved by',
	   'Transcript is official when sealed' => 'Transcript is official when sealed',
	   'Phone' => 'Phone',
	   'Fax' => 'Fax',
	   'Requirements Complete' => 'Requirements Complete',
	   'Printed' => 'Printed',
	   'No Records Found' => 'No Records Found',
	   'No Records Selected' => 'No Records Selected',
	   'Entry Error' => 'Entry Error',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Graduation~Requirements' => 'Graduation~Requirements',
	   'Semester GPA' => 'Semester GPA',
	   'Cum GPA' => 'Cum GPA',
	   'Diploma Awarded on' => 'Graduation date:',
	   'View/Download' => 'View/Download',
	   'View Log File' => 'View Log File',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'DOB' => 'DOB',
	   'Lastname/Lastname,Firstname/Initials/StudentNumber' => 
	     'Lastname/Lastname,Firstname/Initials/StudentNumber',
	   'Select Student' => 'Select Student',
	   'Select Group' => 'Select Group',
	   'Continue' => 'Continue',
	   'Code' => 'Code',
	   'Subject' => 'Subject',
	   'Credit' => 'Credit',
	   'Area' => 'Area',
	   'Error' => 'Error',

	   );

my $self = 'rpttranscript.pl';

# Configuration Format Variables
my $blockwidth = '2.75in';
my $col1 = '0.60in';
my $col2 = '1.45in';
my $col3 = '0.35in';
my $col4 = '0.20in';

$grayscale = '0.93';
my $maxlines = 35; # begin splitting into separate tables after this...

use DBI;
use CGI;
use Number::Format qw(:subs);


# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../../etc/transcript.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@<br>\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $fmt = new Number::Format(-decimal_fill => '1', -decimal_digits => '2');



my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
    $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


my $shortname = "transcript$$";
my $filename = "$shortname.tex";
my $logfile = "pdflog$$.txt";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

if (not $arr{startflag} ) { 
    $offset = 2; 
} elsif ( $arr{startflag} == 1 ) {
    $offset = 1;
}


print "$doctype\n<html><head><title>". $lex{'Transcript'}. ' '. $lex{Report}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "<link rel=\"stylesheet\" type=\"text/css\" media=\"all\">\n";
print "$chartype\n</head><body style=\"padding:2em;\" ";
print "onload=\"document.forms[0].elements[$offset].focus()\">\n";


print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";
print " <a href=\"tscdeled.pl\">". $lex{'Edit Transcripts'}. "</a>\n";


if (not $arr{startflag} ) {
    showStartPage();
} elsif ( $arr{startflag} == 1 ) {
    delete $arr{startflag};
    processSearch();
} elsif ( $arr{startflag} == 2 ) {
    delete $arr{startflag};
    printTranscriptsHTML();
    printTranscriptsPDF();
}



#----------------
sub showStartPage {
#----------------

    # print sortorder and selection input form.
    print "<h1>". $lex{'Transcripts Report'}. "</h1>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"startflag\" value=\"1\">\n";

    print "<div style=\"border:1px solid gray;padding:1em; margin:0.5em; width:50%;\">";
    print $lex{'Lastname/Lastname,Firstname/Initials/StudentNumber'}. "<br>\n";
    print "<input type=\"submit\" value=\"". $lex{'Select Student'}. "\">\n";
    print "<input type=\"text\"  name=\"student\" size=\"12\"></div>\n";

    print "<div style=\"border:1px solid gray;padding:1em; margin:0.5em; width:50%;\">";
    print "<input type=\"submit\" value=\"". $lex{'Select Group'}. "\">\n";
    print "<select name=\"groupname\"><option>". $lex{Grade}. "</option>\n";
    print "<option>". $lex{Homeroom}. "</option>\n";
    print "</select>\n";
    print "<input type=\"text\" name=\"groupvalue\" size=\"6\"></div>\n";
    
    print "</form>\n";
    print "</body></html>\n";

    exit;

}


#----------------
sub processSearch {
#----------------

    # Passed: student, group, select

    #foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    my @students;


    if ( $arr{student} ) { # We are looking for a single student...

	my $student = $arr{student};
    
	# Setup the Search
	if ($student =~ /\d+/) {  # we have a student number
	    push @students, $student;
	} else { # we have words hopefully with a comma
	    my ($lastname,$firstname)  = split /\,/, $student;
	    $firstname =~ s/^\s*//;
	    $lastname =~ s/^\s*//;
	    if ($lastname and $firstname){ # both entered.
		$sth = $dbh->prepare("select studnum from tscriptident 
                  where lastname = ? and firstname = ?");
		$sth->execute( $lastname, $firstname );
	    } elsif ($lastname and not $firstname){ # only lastname (no comma)
		if (length($lastname) == 2){ # search by initials: fi, li.
		    my $fi = substr($lastname,0,1). '%';
		    my $li = substr($lastname,1,1). '%';

		    $sth = $dbh->prepare("select studnum from tscriptident 
                     where lastname $sql{like} ? and firstname $sql{like} ?");
		    $sth->execute( $li, $fi );
		} else {
		    $sth = $dbh->prepare("select studnum from tscriptident 
                     where lastname = ? order by firstname");
		    $sth->execute( $lastname );
		}
	    } else { # print an error....
		print '<p><b>'. $lex{'Entry Error'}. ': '. $lex{'No Student(s) Found'};
		print ".</b></p>\n";
		print "</body></html>\n";
		exit;
	    }

	} # Last Else

   	if ( $sth ) { # if text we should have a statement handle (sth)
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    $rows = $sth->rows;
	    if ($rows < 1) { 
		print '<p><b>'. $lex{'No Student(s) Found'}. ".</b></p>\n";
		print "</body></html>\n"; 
		exit;
	    } 
    
	    while ( my $studnum = $sth->fetchrow ) {
		push @students, $studnum;
	    }
	}

    } elsif ( $arr{groupvalue} ) { # We have a group selected; select from student table

	my $select;
	if ( $arr{groupname} eq $lex{Grade} ) {
	    $select = 'where grade = ?';
	} elsif ( $arr{groupname} eq $lex{Homeroom} ) {
	    $select = 'where homeroom = ?';
	} else {
	    print $lex{'No Records Selected'};
	    print "</body></html>\n";
	    exit;
	}
	
	$sth = $dbh->prepare("select studnum from studentall $select 
          order by lastname, firstname");
	$sth->execute( $arr{groupvalue} );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	while ( my $studnum = $sth->fetchrow ) {
	    push @students, $studnum;
	}
    }


    if (not @students) {
	print $lex{'No Records Found'};
	print "</body></html>\n";
	exit;

    }


    # Now print the next level form...
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"startflag\" value=\"2\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
   
    # display found students, if any...
    $sth1 = $dbh->prepare("select lastname, firstname from tscriptident where studnum = ?");

    my $checked;
    if ( $arr{groupvalue} ) { # check group by default only.
	$checked = 'checked';
    }

    foreach my $studnum (@students) {
	$sth1->execute($studnum);
	my ($lastname, $firstname) = $sth1->fetchrow;
	print "<tr>";
	print "<td>$firstname $lastname ($studnum)</td>";
	print "<td><input type=\"checkbox\" name=\"$studnum\" value=\"1\" $checked></td>";
	print "</tr>\n";
	
    }

    print "<tr><td><input type=\"submit\" value=\"". $lex{Continue}. "\"></td><td></td></tr>\n";
    print "</form></body></html>\n";
	

    exit;

}

#-----------------------
sub printTranscriptsHTML {
#-----------------------

    #foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    if ( not %arr ){
	print '<p><b>'. $lex{'No Records Found'}. ".</b></p>\n";
	print "</body></html>\n";
	halt;
    }


    my $sth = $dbh->prepare("select id, subjectcode, subjecttext, subjectarea, score_mark, score_letter, 
     score_diff, schoolyear, credit, term, term_desc from tscriptdata where studnum = ?
     order by schoolyear, term, subjecttext");
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    my $sth1 = $dbh->prepare("select lastname, firstname, birthdate 
     from tscriptident where studnum = ?");
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    # Main Loop - once for each student.
    foreach my $studnum ( keys %arr ) {

	my ($totalCredits, $totalGPQuality, $totalGPCredits); # totalCredits include Pass/Fail Subjects

	# process transcript data
	$sth->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }


	# Fetch Student's Info
	$sth1->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname, $birthdate) = $sth1->fetchrow;

   
	print "<h1>$firstname $lastname ($studnum) - $birthdate</h1>\n";
	
	my $currdesc = -1;
	my $prevdesc;


	# Outer Table
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
	print "<tr><td valign=\"top\">\n";

	# Inner Table
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print "<tr><th>". $lex{Code}. "</th><th>". $lex{Subject}. "</th><th>". $lex{Area};
	print "</th><th>". $lex{Credit}. "</th><th>". $lex{Grade}. "</th></tr>\n";

	my $first = 1;
	my $colcounter = 1;
	my ( $semesterGPCredits, $semesterGPQuality, $semesterAttempts, $semesterCredits );


	# Loop through all transcript records.
	while ( my ( $id, $subjectcode, $subjecttext, $subjectarea, $score_mark, $score_letter, 
		     $score_diff, $schoolyear, $credit, $term, $term_desc ) = $sth->fetchrow ) {


	    $prevdesc = $currdesc;
	    $currdesc = $term_desc;


	    if ( $currdesc ne $prevdesc ) {
		if (not $first ) {
		    my ($gpa, $cumgpa);
		    if ($semesterGPCredits) {
			$gpa = $fmt->format_number( $semesterGPQuality / $semesterGPCredits, 4 );
		    } else {
			$gpa = 0;
		    }

		    if ( $totalGPCredits ) {
			$cumgpa = $fmt->format_number( $totalGPQuality / $totalGPCredits, 4 );
		    } else {
			$cumgpa = 0;
		    }
		    my $gpa = $fmt->format_number( $gpa , 4);
		    my $cumgpa = $fmt->format_number( $cumgpa, 4);
		    
		    print "<tr style=\"background-color:#EEE;\">";
		    print "<td colspan=\"5\">". $lex{'Semester GPA'}. ": $gpa\n";
		    print $lex{'Cum GPA'}. ": $cumgpa</td></tr>\n";

		    $semesterAttempts = $fmt->format_number( $semesterAttempts, 2); # attempted
		    $semesterCredits = $fmt->format_number( $semesterCredits, 2);  # earned

		    print "<tr style=\"background-color:#CCF;\">";
		    print "<td colspan=\"5\">". $lex{'Credits Attempted'}. " $semesterAttempts\n";
		    print $lex{'Credits Earned'}. " $semesterCredits</td></tr>\n";
		    print "</table>\n";

		    if ( $colcounter % 2 ) {
			print "\n\n</td><td valign=\"top\">\n"; # new cell...
		    } else {
			print "\n\n</td></tr>\n<tr><td>\n"; # new row
		    }
		    $colcounter++;	    

		    $semesterGPQuality = 0;
		    $semesterGPCredits = 0;
		    $semesterCredits = 0;
		    $semesterAttempts = 0;


		    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
		    print "<tr><th>". $lex{Code}. "</th><th>". $lex{Subject}. "</th><th>". $lex{Area}. "</th><th>";
		    print $lex{Credit}. "</th><th>". $lex{Grade}. "</th></tr>\n";


		} else { 
		    $first = 0; 
		}

		print "<div style=\"font-weight:bold; font-size:140%; letter-spacing:0.1em; text-align:center;\">";
		print "$schoolyear - ". $lex{Term}. " $term - $currdesc</div>\n";

	    }


	    # letterToQual hash in transcript.conf; add up quality scores and credit counts.
	    # Check for missing Quality value in transcript.conf
	    if ( ( not defined $letterToQual{ $score_letter } ) and ($score_letter ne $passletter ) ) { 
		print $lex{'No Quality Score for'}. " $score_letter<br>\n"; 
	    }

	    my $quality = $letterToQual{ $score_letter } + $score_diff;


	    $semesterGPQuality += $quality * $credit;
	    $totalGPQuality += $quality * $credit;

	    $semesterAttempts += $credit;

	    if ( $score_letter ne $failletter ) {
		$semesterCredits += $credit;
		$totalCredits += $credit;

		# If not a fail and also not a pass/fail course
		if ( $score_letter ne $passletter ) {
		    $totalGPCredits += $credit;
		    $semesterGPCredits += $credit;
		}
	    }

	    $credit = $fmt->format_number( $credit, 2);

	    print "<tr><td>$subjectcode</td><td>$subjecttext</td><td>$subjectarea</td>";
	    print "<td>$credit</td><td>$score_letter ($quality)</td></tr>\n";
	    
	}  

	# Print the last GPA value...
	if (not $first ) {

	    my ($gpa, $cumgpa);
	    if ($semesterGPCredits) {
		$gpa = $fmt->format_number( $semesterGPQuality / $semesterGPCredits, 4 );
	    } else {
		$gpa = 0;
	    }
	    if ( $totalGPCredits ) {
		$cumgpa = $fmt->format_number( $totalGPQuality / $totalGPCredits, 4 );
	    } else {
		$cumgpa = 0;
	    }
	    $gpa = $fmt->format_number( $gpa, 2 );
	    $cumgpa = $fmt->format_number( $cumgpa, 2 );


	    print "<tr style=\"background-color:#EEE;\">";
	    print "<td colspan=\"5\">". $lex{'Semester GPA'}. ": $gpa\n";
	    print $lex{'Cum GPA'}. ": $cumgpa</td></tr>\n";

	    $semesterAttempts = $fmt->format_number( $semesterAttempts, 2); # attempted
	    $semesterCredits = $fmt->format_number( $semesterCredits, 2);  # earned
	    
	    print "<tr style=\"background-color:#CCF;\">";
	    print "<td colspan=\"5\">". $lex{'Credits Attempted'}. " $semesterAttempts\n";
	    print $lex{'Credits Earned'}. " $semesterCredits</td></tr>\n";

	    $semesterGPQuality = 0;
	    $semesterGPCredits = 0;
	    $semesterCredits = 0;
	    $semesterAttempts = 0;

	}


	print "</table>\n"; # finish off last inner table.

	# Finish off outer table.
	print "<!-- Finish Off outer table  -->\n";
	if ( $colcounter % 2 ) {
	    print "\n</td><td></td></tr>\n";
	} else {
	    print "\n</td></tr>\n";
	}
	print "</table>\n";



    } # End of Main Student Loop

    print "</table><p></p>\n";



}

#--------------
sub prTexHeader {
#--------------

    if ( $defaultpapersize ) {
	$papersize = $defaultpapersize;
    } else {
	$papersize = 'letterpaper';
    }

    print TEX "\\documentclass[10pt,$papersize]{article}\n";
    print TEX "\\usepackage{ array, colortbl, multicol, helvet, pifont, fancyhdr, inputenc}\n";
    print TEX "\\inputencoding{latin1}\n";

    print TEX "\\setlength{\\textwidth}{8in}\n \\setlength{\\textheight}{9.8in}\n";
    print TEX "\\setlength{\\hoffset}{-0.7in}\n\\setlength{\\voffset}{-1in}\n";
    print TEX "\\setlength{\\evensidemargin}{0in}\n\\setlength{\\oddsidemargin}{0in}\n";
    #print TEX "\\setlength{\\extrarowheight}{2pt}\n
    print TEX "\\setlength{\\parindent}{0pt}\n";

    print TEX "\\setlength{\\topskip}{0pt}\n";
    print TEX "\\setlength{\\headsep}{6pt}\n";
    print TEX "\\renewcommand{\\familydefault}{\\sfdefault}\n";
    print TEX "\\pagestyle{fancy}\n \\rfoot{". $lex{Printed}. ": $currdate }\n";
    print TEX "\\cfoot{ }\n";

    print TEX "\\begin{document}\n";

}



#----------------------
sub printTranscriptsPDF {
#----------------------

    #foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    my $pagecount = 1;

    if ( not %arr ){
	print '<p><b>'. $lex{'No Records Found'}. ".</b></p>\n";
	print "</body></html>\n";
	halt;
    }


    # Setup Tex File 
    open(TEX,">$filename") || die "Cannot open tex file";
    prTexHeader(); # print TeX file header defaults.

    # Setup selects for transcript data and student name
    my $sth = $dbh->prepare("select id, subjectcode, subjecttext, score_mark, score_letter, 
     score_diff, schoolyear, credit, term, term_desc from tscriptdata where studnum = ?
     order by schoolyear, term, subjecttext");
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    # Get Student Name
    my $sth1 = $dbh->prepare("select lastname, firstname, middlename, birthdate, graddate
      from tscriptident where studnum = ?");
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }


    # Main Loop - once for each student.
    foreach my $studnum ( keys %arr ) {

	# totalCredits include Pass/Fail Subjects
	my ($totalCredits, $totalGPQuality, $totalGPCredits); 

	# process transcript data
	$sth->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

	# Fetch Student's Info
	$sth1->execute($studnum);
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname, $middlename, $birthdate, $graddate ) = $sth1->fetchrow;
	$globalGradDate = $graddate;

	if ( $pagecount != 1 ) { # start a new page.
	    print TEX "\\newpage\n";
	}

	print TEX "\\setcounter{page}{1}\n";
	#print TEX "\\{$schoolname -- $schoolyear \\hfill ";
	print TEX "\\rhead{$firstname $middlename $lastname -- Page \\thepage}\n";


	# Print School Info
	print TEX "{\\Large $schoolname} \\hfill {\\Large ";
	print TEX  $lex{'Transcript of Marks'}. "} \\hfill ". $lex{Phone}. " $schoolphone \n\n";
	
	print TEX  "$schooladdr1 $schooladdr2 $schoolcity, $schoolprov \\hfill ";
	print TEX $lex{Fax}. " $schoolfax \n\n";
	print TEX "\n\\bigskip\n\n";

   
	# Print Student Info
	print TEX "{\\Large\\bf $firstname $lastname} ";
	print TEX "\\quad{\\it\\bf ". $lex{DOB}. ":} $birthdate \n\n";

	print TEX "\\begin{tabular}[t]{|p{ $blockwidth }|p{ $blockwidth }|}\\hline\n";

	my $currdesc = -1;
	my $prevdesc;


	my $first = 1;
	my $colcounter = 1;
	my $colorcounter = 1;

	my ($linecounter, $blockcounter); # needed to count how far down until splitting the table.

	my ( $semesterGPCredits, $semesterGPQuality, $semesterAttempts, $semesterCredits );

	# Loop through all transcript records.
	while ( my ( $id, $subjectcode, $subjecttext, $score_mark, $score_letter, 
		     $score_diff, $schoolyear, $credit, $term, $term_desc ) = $sth->fetchrow ) {

	    # remove section text if value set in transcript.conf
	    if ( $t_TruncateSection ) {
		my ($tmp, @rest) = split /-/, $subjectcode;
		$subjectcode = $tmp;
	    }

	    $blockcounter++;

	    $subjecttext =~ s/&/\\&/g;
	    $subjecttext =~ s/#/\\#/g;

	    $prevdesc = $currdesc;
	    $currdesc = $term_desc;

	    # if starting a new block, finish current totals, end table, start a new table.
	    if ( $currdesc ne $prevdesc ) { 
		if ( not $first ) {

		    my ($gpa, $cumgpa);
		    if ($semesterGPCredits) {
			$gpa = $fmt->format_number( ($semesterGPQuality / $semesterGPCredits), 4 );
		    } else {
			$gpa = 0;
		    }
		    if ( $totalGPCredits ) {
			$cumgpa = $fmt->format_number( ($totalGPQuality / $totalGPCredits), 4 );
		    } else {
			$cumgpa = 0;
		    }

		    $gpa = $fmt->format_number( $gpa, 2 );
		    $cumgpa = $fmt->format_number( $cumgpa, 2 );


		    print TEX " \\multicolumn{4}{\@{}l}{\\rule{0pt}{12pt}\\it\\small ";
		    print TEX $lex{'Semester GPA'}. ": {\\bf $gpa} \\quad ";
		    print TEX $lex{'Cum GPA'}. ": {\\bf $cumgpa}}\\\\\n";

		    $semesterAttempts = $fmt->format_number( $semesterAttempts, 2 ); # attempted
		    $semesterCredits = $fmt->format_number( $semesterCredits, 2 );  # earned

		    print TEX " \\multicolumn{4}{\@{}l}{\\it\\small ". $lex{'Credits Attempted'};
		    print TEX ": {\\bf $semesterAttempts} \\quad ";
		    print TEX $lex{'Credits Earned'}. ": {\\bf $semesterCredits} }\\\\\n";

		    $semesterGPQuality = 0;
		    $semesterGPCredits = 0;
		    $semesterCredits = 0;
		    $semesterAttempts = 0;

		    print TEX "\\end{tabular}\n"; # end this (inner) table.
	    
		    if ( $colcounter % 2 ) {
			$blockCountA = $blockcounter;
			$blockcounter = 0;
			print TEX " & \n";
		    } else { # we are at the end of a block line
			print TEX " \\\\ \\hline\n";
			
			# Now add up the lines
			$blockCountB = $blockcounter;
			$blockcounter = 0;

			if ( $blockCountA > $blockcounB ) {
			    $linecounter += $blockCountA;
			} else {
			    $linecounter += $blockCountB;
			}
			$linecounter += 4; # add 4 for a new block
			#print "LC:Block $linecounter<br>\n";


			# Put in Split here for the 
			if ( $linecounter > $maxlines ) {
			    print TEX "\\end{tabular}";
			    if ( not $splitflag ) {
				# print Right Hand Column: Grad Requirements, etc.
				printRightColumn( $studnum );
				$splitflag = 1;
				$linecounter = 0;
			    } else {
				print TEX "\n";
			    }
			    
			    print TEX "\\begin{tabular}[t]{|p{ $blockwidth }|p{ $blockwidth }|}\\hline\n";
			}
			# End of Splitter to fix formatting.

		    }
		    $colcounter++;
		    $colorcounter = 1;

		} else { 
		    $first = 0; 
		}

		# set tabular column layout for next block
		print TEX "\\begin{tabular}[t]{\@{\\hspace{1pt}}p{ $col1 }\@{\\hspace{2pt}}p{ $col2 }";
		print TEX "\@{\\hspace{5pt}}p{ $col3 }\@{\\hspace{1pt}}p{ $col4 }\@{\\hspace{1pt}}}\n";

		print TEX "\\multicolumn{4}{l}{\\rule{0pt}{12pt}\\bf $schoolyear - $currdesc}\\\\\n";
		print TEX "\\multicolumn{4}{\@{}l}{\\it\\small\ " . $lex{Code};
		print TEX " \\hspace{0.5in} ". $lex{Subject};
		print TEX " \\hspace{0.7in} ". $lex{Credit}. " ".  $lex{Grade}. "}\\\\ \n";

	    }


	    # letterToQual hash in transcript.conf; add up quality scores and credit counts.
	    # Check for missing Quality value in transcript.conf
	    if (not defined $letterToQual{ $score_letter } and $score_letter ne $passletter ) { 
		print $lex{'No Quality Score for'}. " $score_letter<br>\n"; 
	    }

	    # score difficulty; from record.
	    my $quality = $letterToQual{ $score_letter } + $score_diff; 
	    
	    $semesterGPQuality += $quality * $credit;
	    $totalGPQuality += $quality * $credit;

	    $semesterAttempts += $credit;

	    if ( $score_letter ne $failletter ) {
		$semesterCredits += $credit;
		$totalCredits += $credit;

		# If not a fail and also not a pass/fail course
		if ( $score_letter ne $passletter ) {
		    $totalGPCredits += $credit;
		    $semesterGPCredits += $credit;
		}
	    }

	    $credit = $fmt->format_number( $credit, 2);

	    if ( $colorcounter % 2 ) {
		print TEX "\\rowcolor[gray]{ $grayscale }\n";
	    }
	    $colorcounter ++;
	    print TEX "\\small $subjectcode& \\raggedright\\small $subjecttext & ";
	    print TEX "\\small $credit & \\small $score_letter \\\\ \n";
	    
	}  


	# Print the last GPA value...
	if ( not $first ) {

	    my ($gpa, $cumgpa);
	    if ($semesterGPCredits) {
		$gpa = $fmt->format_number( ( $semesterGPQuality / $semesterGPCredits ), 4 );
	    } else {
		$gpa = 0;
	    }
	    if ( $totalGPCredits ) {
		$cumgpa = $fmt->format_number( ( $totalGPQuality / $totalGPCredits ), 4 );
	    } else {
		$cumgpa = 0;
	    }
	    $gpa = $fmt->format_number( $gpa, 2 );
	    $cumgpa = $fmt->format_number( $cumgpa, 2 );


	    print TEX " \\multicolumn{4}{\@{}l}{\\rule{0pt}{12pt}\\it\\small ";
	    print TEX $lex{'Semester GPA'}. ": {\\bf $gpa} \\quad ";
	    print TEX $lex{'Cum GPA'}. ": {\\bf $cumgpa}}\\\\\n";

	    $semesterAttempts = $fmt->format_number( $semesterAttempts, 2); # attempted
	    $semesterCredits = $fmt->format_number( $semesterCredits, 2);  # earned

	    print TEX " \\multicolumn{4}{\@{}l}{\\it\\small ". $lex{'Credits Attempted'};
	    print TEX ": {\\bf $semesterAttempts} \\quad ";
	    print TEX $lex{'Credits Earned'}. ": {\\bf $semesterCredits} }\\\\\n";

	    print TEX "\\end{tabular}\n";

	    $semesterGPQuality = 0;
	    $semesterGPCredits = 0;
	    $semesterCredits = 0;
	    $semesterAttempts = 0;

	}

	if ( $colcounter % 2 ) {
	    print TEX " & \n";
	} 
	
	print TEX "\\\\ \\hline\\end{tabular}\n";


	# print Right Hand Column: Grad Requirements, etc.
	if ( not $splitflag ) { # we haven't printed the right column yet...
	    printRightColumn( $studnum );
	}

	$pagecount++;

    } # End of Main Student Loop


    print TEX "\\end{document}\n";
    close TEX;

    system("$pdflatex $filename >$logfile");
    system("mv $shortname.pdf $downloaddir");
    system("mv $logfile $downloaddir");
    system("rm -f $shortname.*");

    print "<h1><a href=\"$webdownloaddir/$shortname.pdf\">\n";
    print $lex{'View/Download'}. ' '. $lex{'Transcripts'};
    print "</a></h1>\n[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$webdownloaddir/$logfile\">". $lex{'View Log File'};
    print "</a> ]</center>";
    print "</body></html>\n";

    exit;


}


#-------------------
sub printRightColumn { # print the grad requirements, etc in right most col of pdf version
#-------------------

    my $studnum = shift;

    # Now print the right hand column
    print TEX "\\raggedbottom\\parbox[t]{2in}{\\vspace{0.3in}{\\bf\\small\\quad ";
    print TEX $lex{'Graduation~Requirements'}. "\n\n";
    print TEX "\\begin{tabular}{r\@{ \\hspace{4pt} }r\@{ \\hspace{4pt} }r\@{ \\hspace{2pt} }l}\n";
    print TEX "\\it\\bf\\small ". $lex{'Subject'}. q{ }. $lex{'Area'}. "& \\it\\bf\\small ";
    print TEX $lex{Reqd}. "& \\it\\bf\\small ". $lex{Earned}. "& \\\\ \\hline \n"; 

    my $requiredTotal;
    my $earnedTotal;

    my $sth4 = $dbh->prepare("select id, score_letter, credit from tscriptdata 
      where studnum = ? and subjectarea = ?");

    foreach my $key (sort keys %gradRequirements ) {
	if ( $gradRequirements{$key} ) { # Any 0 credit elective is supressed...

	    # Find courses for this subject area.
	    $sth4->execute($studnum, $key);
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		
	    my $creditTotal = 0; # total credits for this area.
	    while (my ( $id, $scoreletter, $credit ) = $sth4->fetchrow ) {
		if ( $scoreletter ne $failletter ) {
		    $creditTotal += $credit;
		}
	    }

	    $earnedTotal += $creditTotal;
	    $requiredTotal += $gradRequirements{$key};

	    print TEX "\\it\\small $key & \\it\\small ". $fmt->format_number( $gradRequirements{$key}, 2 );
	    print TEX "&\\it\\small ". $fmt->format_number( $creditTotal, 2);

	    if ( $creditTotal >= $gradRequirements{$key} ) {
		print TEX "& \\ding{52} ";
	    } else {
		print TEX "& ";
	    }

	    print TEX "\\\\ \n\n";

	}
    }

    print TEX "\\hline\n"; # put in line separator between these 2 sections.


    # Now do the zero credit versions... normally only 'Other'.
    foreach my $key (sort keys %gradRequirements ) {
	if (not $gradRequirements{$key} ) { # Any 0 credit elective

	    # Find courses for this subject area.
	    $sth4->execute($studnum, $key);
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
		
	    my $creditTotal = 0; # total credits for this area.
	    while (my ( $id, $scoreletter, $credit ) = $sth4->fetchrow ) {
		if ( $scoreletter ne $failletter ) {
		    $creditTotal += $credit;
		}
	    }

	    $earnedTotal += $creditTotal;
	    $requiredTotal += $gradRequirements{$key};

	    print TEX "\\it\\small $key & \\it\\small ". $fmt->format_number( $gradRequirements{$key}, 2 );
	    print TEX "&\\it\\small ". $fmt->format_number( $creditTotal, 2). " \\\\ \n\n";

	    # print TEX "\\it\\small $key & \\it\\small ";
	    # print TEX $fmt->format_number( $gradRequirements{$key}, 2 );
	    # print TEX "&\\it\\small  \\\\ \n\n";
	}
    }


    print TEX "\\hline\n";
    
    print TEX "\\it\\scriptsize ". $lex{Total}. "& \\it\\scriptsize ";
    print TEX $fmt->format_number( $requiredTotal, 2 );
    print TEX "&\\it\\scriptsize ";
    print TEX $fmt->format_number( $earnedTotal, 2). " \\\\ \n\n";

    print TEX "\\end{tabular}} \n\n";


    print TEX "\\begin{center}\\it\\footnotesize \\ding{52} = ";
    print TEX $lex{'Requirements Complete'}. "\n\n";
    print TEX "{\\tiny $section1}\n";
    print TEX "\\end{center}\n";

    if ( $globalGradDate ) {
	print TEX "\\vspace{0.5in}\n";
	# Removed and replaced with below: print TEX "\\quad\\underline{\\hspace{2in}}\n\n";
	print TEX  "\\quad\\small ". $lex{'Diploma Awarded on'}. " $globalGradDate\n\n";
    }

    print TEX "\\vspace{0.3in}\n";
    print TEX "\\quad\\underline{\\hspace{2in}}\n\n\\quad\\small ". $lex{'Approved by'}. "\n\n";

    print TEX "\\vspace{0.5in}\\begin{center}";
    print TEX $lex{'Transcript is official when sealed'}. "\\end{center}\n\n";

    print TEX "}\n\n\n"; # end of the right side... 3 CR at end are important.


} # End of printRightColumn
