#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


# Subject Alias Update Script
#   Add an Alias to any empty one, using an available number.

my %lex = ('Subject Alias Updates' => 'Subject Alias Updates',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Subject Aliases Updated' => 'Subject Aliases Updated',
	   'Alias' => 'Alias',
	   'Subject' => 'Subject',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
%arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# print the HTML head section.
print "$doctype\n<html><head><title>". $lex{'Subject Alias Updates'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em 3em;\">\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

# Count the subjects; should be less than 100 for 2 digit alias or die;
my $sth = $dbh->prepare("select count(*) from subject");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my $subcount = $sth->fetchrow;

if ( $subcount > 99 ) {
    print "<h2>Update this script to handle > 99 subject aliases";
    print "</h2></body></html>\n";
    die;
}

$sth = $dbh->prepare("select alias from subject where alias != ''");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
$aliasrows = $sth->rows;
my %used;
for (1..$aliasrows){
    my $alias = $sth->fetchrow;
    $used{$alias} = 1;
}

# Now create an array of available alias numbers.
for my $num (1..99){
    if ($num < 10){ $num = "0$num";}
    if(not $used{$num})
       { push @avail, $num;
    }
}

# Now find the holes and fill them.
$sth = $dbh->prepare("select id, description from subject 
 where alias is NULL or alias = ''");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
$aliasrows = $sth->rows;

print "<h3>$aliasrows ". $lex{'Subject Aliases Updated'}. "</h3>\n";

if ($aliasrows) {
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th colspan=\"2\">". $lex{Subject}. ' | '. $lex{Alias}. "</th></tr>\n";
}

for (1..$aliasrows){
    my ($id, $description) = $sth->fetchrow;
    $newalias = shift @avail;
    if (length($newalias) == 1) { # Add a 0
	$newalias = '0'. $newalias;
    }

    my $sth1 = $dbh->prepare("update subject set alias = '$newalias' 
     where id = '$id'");
    $sth1->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

    print "<tr><td>$description</td><td>$newalias</td></tr>\n";
}
if ($aliasrows) {
    print "</table>\n";
}

# Footer Section
print "<p>[ <a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]
</p></center></body></html>\n";

