#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Subject Alias Records' => 'Subject Alias Records',
	   'Subject' => 'Subject',
	   'Teacher' => 'Teacher',
	   'Alias' => 'Alias',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select subjsec,description,alias,teacher 
  from subject order by description");
$sth->execute;
if ($DBI::errstr) {print $DBI::errstr;die $DBI::errstr; }
my $rows = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'Subject Alias Records'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print " <a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

print "<center><h1>". $lex{'Subject Alias Records'}. "</h1>\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

print '<tr><th>'. $lex{Subject}. '</th><th>'. $lex{Teacher};
print '</th><th>'. $lex{Alias}. "</th></tr>\n";

while ( my ($subjsec,$description,$alias,$teacher) = $sth->fetchrow) {

    print "<tr><td><b>$description</b> ($subjsec)</td>";
    print "<td>$teacher</td><td>$alias</td></tr>\n";

}

print "</table></body></html>\n";
