#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Subject Entry - Add a New Subject-Section' => 
	     'Subject Entry - Add a New Subject-Section',
	   'Clone' => 'Clone',
	   'Subject-Section' => 'Subject-Section',
	   'Codes' => 'Codes',
	   'Other Codes' => 'Other Codes',
	   'Save Subject' => 'Save Subject',
	   'Course Code' => 'Course Code',
	   'Section' => 'Section',
	   'Description' => 'Description',
	   'Short Description' => 'Short Description',
	   'Max' => 'Max',
	   'char' => 'char',
	   'Grade' => 'Grade',
	   'Start Term' => 'Start Term',
	   'End Term' => 'End Term',
	   'Teacher' => 'Teacher',
	   'Sequence' => 'Sequence',
	   'Controls printing order on report card' => 
	     'Controls printing order on report card',
	   'Web Visible' => 'Web Visible',
	   'Y' => 'Y',
	   'N' => 'N',
	   'Instructional Mode' => 'Instructional Mode',
	   'Class' => 'Class',
	   'Distance' => 'Distance',
	   'Exam Mix' => 'Exam Mix',
	   'School' => 'School',
	   'Blended' => 'Blended',
	   'Faculty' => 'Faculty',
	   'Location' => 'Location',
	   'Mark Scheme' => 'Mark Scheme',
	   'Objective' => 'Objective',
	   'Save Subject' => 'Save Subject',

	   'Credit' => 'Credit',
	   'Difficulty' => 'Difficulty',
	   'Subject Area' => 'Subject Area',
	   'Calc Average' => 'Calc Average',
	   'If your subject only has marks and comments, no objective entry' => 
	     'If your subject only has marks and comments, no objective entry',
	   'is required. If you have non-mark based objectives, please enter' =>
	     'is required. If you have non-mark based objectives, please enter',
	   'the description that will appear on the report card. These will' =>
	     'the description that will appear on the report card. These will',
	   'also appear for evaluation entry. Limit: 255 characters' =>
	     'also appear for evaluation entry. Limit: 255 characters',
	   'Error' => 'Error',
	   'You are missing a required field or have a hyphen in a course code' =>
	     'You are missing a required field or have a hyphen in a course code',
	   'Please go back and try again' => 'Please go back and try again',
	   'This subject - section already exists!' => 
	     'This subject - section already exists!',
	   'The subject is now stored' => 'The subject is now stored',
	   'There was an error storing your data' => 
	     'There was an error storing your data',
	   'Please contact' => 'Please contact',
	   'Add Another Subject' => 'Add Another Subject',
	   'No students in this grade.' => 'No students in this grade.',

	   );

$studentCheck = 0; # check for students in that grade.


use DBI;
use CGI;

my $self = 'subjadd.pl';

my $defaultsequence = 100; 
# Starting value for sequence number.

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

eval require "../../etc/transcript.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

print "$doctype\n<html><head><title>". $lex{'Subject Entry - Add a New Subject-Section'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em 2em;\">\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> |\n";

print " <a href=\"../sasklrn/qrydeptcourses.pl\" target=\"_blank\">SK ". $lex{Codes}. "</a> |
<a href=\"http://richtech.ca/cgi-bin/testbank/courseview.pl\" 
target=\"_blank\">". $lex{'Other Codes'}. "</a> ] \n";

#foreach my $key (sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    writeRecord();
}


# If 'cloning' selected while looping, pull in the record.
my @subj;
if ( $arr{subjsec} ) {
    $sth = $dbh->prepare("select * from subject 
     where subjsec = ?"); 
    $sth->execute( $arr{subjsec} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    @subj = $sth->fetchrow;
}


# Load teachers into an array
$sth = $dbh->prepare("select lastname, firstname, userid from staff 
 order by lastname, firstname"); 
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
while ( my ( $lastname, $firstname, $userid) = $sth->fetchrow ) {
    push @teacherarray, "$lastname, $firstname ($userid)";
}

# Set sequence number; if cloning, keep existing val
if ( $subj[7] ) { $defaultsequence = $subj[7];}



print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">
<input type=\"submit\" value=\"". $lex{Clone}. q{ }. $lex{'Subject-Section'}. "\">
<input type=\"text\" name=\"subjsec\" size=\"9\"></form></td></tr></table>
<center><h1>". $lex{'Subject Entry - Add a New Subject-Section'}. "</h1></center>\n";


print "<form action=\"$self\" method=\"post\"> 
<input type=\"hidden\" name=\"writeflag\" value=\"1\">
<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">
<tr><td></td><td>
<input type=\"submit\" value=\"". $lex{'Save Subject'};
print "\"> (<font color=red>* = Required</font>)</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Course Code'}. "<font color=red>*</font></td>
<td><input type=\"text\" name=\"coursecode\" size=\"10\" value=\"$subj[1]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Section}. "<font color=red>*</font></td>
<td><input type=\"text\" name=\"section\" size=\"6\" value=\"$subj[8]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Description}. "<font color=red>*</font></td>
<td><input type=\"text\" name=\"description\" size=\"50\" maxlength=\"255\" 
  value=\"$subj[2]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Short Description'}. "<font color=red>*</font></td>
<td><input type=\"text\" name=\"smdesc\" size=\"8\" maxlength=\"8\" value=\"$subj[37]\"> ";
print $lex{Max}. ": 8 ". $lex{char}. "</td></tr>\n";


print "<tr><td align=\"right\">". $lex{Grade}. "<font color=red>*</font></td>
<td><input type=\"text\" Name=\"grade\" size=\"4\" maxlength=\"8\" value=\"$subj[3]\">
</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Start Term'}. "<font color=red>*</font></td>
<td><input type=\"text\" name=\"startrptperiod\" size=\"6\" value=\"$subj[32]\">
</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'End Term'}. "<font color=red>*</font></td>
<td><input type=\"text\" name=\"endrptperiod\" size=\"6\" value=\"$subj[33]\">
</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Teacher'}. "<font color=red>*</font></td>
<td><select name=\"teacher\"><option>$subj[4]</option>\n";


foreach my $teacher ( @teacherarray ) {
    print "<option>$teacher</option>\n";
}

print "</select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Sequence}. "</td>\n";
print "<td><input type=\"text\" name=\"sequence\" size=\"8\" value=\"$defaultsequence\">\n";
print $lex{'Controls printing order on report card'}. ".</td></tr>\n";

print "<tr><tr><td align=\"right\">". $lex{'Web Visible'}. "</td>\n";
print "<td><select name=\"visible\"><option>$subj[31]</option>\n";
print "<option>". $lex{Y}. "</option><option>". $lex{N}. "</option></select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Instructional Mode'}. "</td>\n";
print "<td><select name=\"instmode\"><option>$subj[38]</option>\n";
print "<option>". $lex{'Class'}. "</option><option>". $lex{Distance}. "</option></select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Exam Mix'}. "</td><td><select name=\"exammix\">\n";
print "<option>$subj[39]</option><option>". $lex{'School'}. "</option><option>". $lex{'Blended'};
print  "</option></select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Faculty}. "</td><td><input type=\"text\" name=\"faculty\" 
 size=\"12\" maxlength=\"255\" value=\"$subj[35]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Location}. "</td><td><input type=\"text\" name=\"location\" 
size=\"12\" maxlength=\"255\" value=\"$subj[36]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Mark Scheme'}. "</td><td><textarea name=\"markscheme\" 
rows=\"6\" cols=\"40\">$subj[34]</textarea></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Credit'}. "</td><td>";
if ( @creditValues ) { # from transcript.conf
    print "<select name=\"credit\">\n";
    print "<option>$subj[46]</option>\n";
    foreach my $val ( @creditValues ) {
	print "<option>$val</option>\n";
    }
    print "</select>\n";
} else {
    print "<input type=\"text\" name=\"credit\" size=\"4\" ";
    print "maxlength=\"8\" value=\"$subj[46]\">";
}
print "</td></tr>\n";


print "<tr><td align=\"right\">". $lex{'Difficulty'};
print "</td><td><input type=\"text\" name=\"difficulty\" 
size=\"4\" maxlength=\"8\" value=\"$subj[47]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Subject Area'}. "</td>\n";

if ( %gradRequirements ) {
    print "<td><select name=\"area\"><option>$subj[48]</option>\n";
    foreach my $key ( sort keys %gradRequirements ) {
	print "<option>$key</option>";
    }
    print "</select></td></tr>\n";
} else {
    print "<td><input type=\"text\" name=\"area\" size=\"20\" maxlength=\"255\" ";
    print "value=\"$subj[48]\"></td></tr>\n";
}

print "<tr><td align=\"right\">". $lex{'Calc Average'}. "</td><td><select name=\"calcavg\">\n";
if ( $subj[49] ) { # We have an existing value...
    print "<option>$subj[49]</option>\n";
}
print "<option>". $lex{N}. "</option>\n";
print "<option>". $lex{Y}. "</option>\n";
print "</select></td></tr>\n";


print "<tr><td></td><td><div style=\"border:1px solid gray;margin:1em 0;padding:1em;\">\n";
print $lex{'If your subject only has marks and comments, no objective entry'}. "<br>\n";
print $lex{'is required. If you have non-mark based objectives, please enter'}. "<br>\n";
print $lex{'the description that will appear on the report card. These will'}. "<br>\n";
print $lex{'also appear for evaluation entry. Limit: 255 characters'}. ".<div></td></tr>\n";

for (my $i=1;$i<=20;$i++){
    my $j = $i + 9;
    print "<tr><td align=\"right\">". $lex{Objective}. " $i</td><td><input type=\"text\" ";
    print "name=\"q$i\" size=\"50\" value=\"$subj[$j]\"></td></tr>\n";
}

print "<tr><td></td><td>\n<input type=\"submit\" value=\"". $lex{'Save Subject'};
print "\"></td></tr>\n</table></center></form></center></body></html>\n";



#--------------
sub writeRecord {
#--------------

    # Join Subject and Section to make Subjsec
    $arr{coursecode} =~ s/-//g; # strip any hyphens...
    my $subjsec = $arr{coursecode}. "-". $arr{section};


    # Make sure it has the right fields filled in and no hyphens
    if (not $arr{coursecode} or not $arr{section} or 
	not $arr{description} or not $arr{startrptperiod} or 
	not $arr{endrptperiod} or not $arr{grade} or 
	not $arr{teacher} or  $arr{coursecode} =~ m/-/) {
	print '<h1>';
	print $lex{'You are missing a required field or have a hyphen in a course code'};
	print "<br>\n";
	print $lex{'Please go back and try again'}. ".</h1></body></html>\n";
	exit;
    }


    # Check for existing subject-section ( subjsec )
    my $sth = $dbh->prepare("select count(*) from subject where subjsec = ?");
    $sth->execute( $subjsec );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ( $count > 0 ){
	print "<h1>". $lex{'This subject - section already exists!'}. "\n";
	print $lex{'Please go back and try again'}. ".</h1></body></html>\n";
	exit;
    }

    if ( $studentCheck ) {
	# Check that this grade exists ( among students )
	my $sth = $dbh->prepare("select count(*) from student where grade = ?");
	$sth->execute( $arr{grade} );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my $gradecount = $sth->fetchrow;
	if ( $gradecount < 1 ){ # no kids in this grade.
	    print "<h1>". $lex{'No students in this grade.'}. ": $arr{grade}<br>\n";
	    print $lex{'Please go back and try again'}. ".</h1></body></html>\n";
	    exit;
	}
    }


    # Quote everything (or set NULL)
    foreach my $key (keys %arr) {
	#print "K:$key V:$arr{$key}<br>\n";
	if ( $arr{$key} ) {
	    $arr{$key} = $dbh->quote( $arr{$key} );
	} else {
	    $arr{$key} = $sql{default};
	}
    }

    $subjsec = $dbh->quote( $subjsec );


    #Note: modules and type field left null

    $sth = $dbh->prepare("insert into subject values (
     $sql{default}, $arr{coursecode}, $arr{description},
     $arr{grade}, $arr{teacher}, $sql{default},
     $sql{default}, $arr{sequence} , $arr{section}, $subjsec,
     $arr{q1}, $arr{q2}, $arr{q3}, $arr{q4}, $arr{q5},
     $arr{q6}, $arr{q7}, $arr{q8}, $arr{q9}, $arr{q10},
     $arr{q11}, $arr{q12}, $arr{q13}, $arr{q14}, $arr{q15},
     $arr{q16}, $arr{q17}, $arr{q18}, $arr{q19}, $arr{q20},NULL,
     $arr{visible}, $arr{startrptperiod}, $arr{endrptperiod},
     $arr{markscheme}, $arr{faculty}, $arr{location}, $arr{smdesc},
     $arr{instmode}, $arr{exammix},
     $sql{default}, $sql{default}, $sql{default}, 
     $sql{default},$sql{default},$sql{default},
     $arr{credit}, $arr{difficulty}, $arr{area}, $arr{calcavg} )");
    # six nulls near end are for new scheduling functions; not changed here...

    $sth->execute;

    if (not $DBI::errstr ) {
	print '<h3>'. $lex{'The subject is now stored'}. ".</h3>\n";
    } else { 
	print '<h3>'. $lex{'There was an error storing your data'}. ". \n";
	print $lex{'Please contact'}. " $adminname ";
	print "(<a href=\"mailto:$adminemail\">$adminemail</a>)<br>\n";
	print " $DBI::errstr</h3></p>\n";
    }

    print "<p>[ <a href=\"$self\">". $lex{'Add Another Subject'}. "</a> |\n";
    print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]</p></center></body></html>\n";

    exit;

}
