#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Subject Deletion' => 'Subject Deletion',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'student records depend on this subject' => 'student records depend on this subject',
	   'Please remove these first using' => 'Please remove these first using',
	   'Edit/Delete Subject Enrollments' => 'Edit/Delete Subject Enrollments',
	   'Subject' => 'Subject',
	   'Subject-Section' => 'Subject-Section',
	   'Records Depending' => 'Records Depending',
	   'Are you sure you want to delete this record' => 
	     'Are you sure you want to delete this record',
	   'Delete the Record' => 'Delete the Record',
	   'Subjects' => 'Subjects',
	   'Edit/Delete' => 'Edit/Delete',
	   'Record Deletion Failed' => 'Record Deletion Failed',
	   'Please contact' => 'Please contact',
	   'deleted' => 'deleted',
	   'Error' => 'Error',

	   );

my $self = 'subjdel.pl';

use CGI;
use DBI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset => $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Subject Deletion'}. "</title>
 <link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
 $chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

if ($arr{flag}) {
    deleteRecord();
}

my $sth = $dbh->prepare("select subjsec, description from subject where id = ?"); 
$sth->execute( $arr{id} );
my ( $subjsec, $description ) = $sth->fetchrow;

$sth = $dbh->prepare("select count(*) from eval where subjcode = ?"); 
$sth->execute( $subjsec );
$subjcount = $sth->fetchrow;


if ( $subjcount > 0 ){ # Some records depend on this...
    print "<h1>$subjcount ";
    print $lex{'student records depend on this subject'}. ".<br>\n";
    print $lex{'Please remove these first using'};
    print " &quot;". $lex{'Edit/Delete Subject Enrollments'}. "&quot;</h1>\n";
    print "<h1>[ <a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";
    print "</h1></center></body></html>\n";
    die;
}

print "<center><h1>". $lex{'Subject Deletion'}. "</h1>\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

print "<tr><th align=\"right\">". $lex{Subject};
print "</td><td align=left>$description</td></tr>\n";

print "<tr><th align=\"right\">". $lex{'Subject-Section'};
print "</td><td align=left>$subjsec</td></tr>\n";

print "<tr><th align=\"right\">". $lex{'Records Depending'};
print "</td><td align=left>$subjcount</td></tr>\n";

print "</table>\n<p><em>";
print $lex{'Are you sure you want to delete this record'}. "?</em></p>
<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"flag\" value=\"1\">
<input type=\"hidden\" name=\"itemid\" value=\"$arr{id}\">
<input type=\"hidden\" name=\"name\" value=\"$description\">
<input type=\"submit\" value=\"". $lex{'Delete the Record'}. "!\"></center>
</form></center></body></html>\n";


#---------------
sub deleteRecord {
#---------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    my $sth = $dbh->prepare("delete from subject where id = ?");
    $sth->execute( $arr{itemid} );

    if ($DBI::errstr) {
	print "<h1>". $lex{'Record Deletion Failed'}. ". ". $lex{'Please contact'}. " $adminname ";
	print "( $adminemail )\n";
    } else {
	print "<h1>&quot;$arr{name}&quot; ". $lex{deleted}. ".</h1>\n";
    }
    print "<p>[ <a href=\"$reppage\">". $lex{'Report Card'}. "</a> | \n";
    print "<a href=\"subjdeled.pl\">". $lex{'Edit/Delete'}. q{ }. $lex{Subjects}. "</a> ]</p>\n"; 

    print "</center></body></html>\n";

    exit;

}
