#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Edit/Delete Subjects' => 'Edit/Delete Subjects',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Subject' => 'Subject',
	   'Teacher' => 'Teacher',
	   'Term' => 'Term',
	   'Grade' => 'Grade',
	   'Sort by' => 'Sort by',
	   'No Teacher' => 'No Teacher',
	   'Subj-Sec' => 'Subj-Sec',
	   'Terms' => 'Terms',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Clone' => 'Clone',
	   'SmDesc' => 'SmDesc',
	   'Enrol' => 'Enrol',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;
use Number::Format qw(round);

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = CGI->new;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my $sortorder;
if ($arr{sortorder} eq $lex{Subject} ){
    $sortorder = 'description, grade, teacher';
} elsif ($arr{sortorder} eq $lex{Teacher} ){
    $sortorder = 'teacher, description, grade';
} elsif ($arr{sortorder} eq $lex{Grade} ){
    $sortorder = 'grade, description, teacher';
} elsif ($arr{sortorder} eq $lex{Term}){
    $sortorder = 'startrptperiod, description, teacher';
} else {
    $sortorder = 'description,grade,teacher';
    $arr{sortorder} = $lex{Subject};
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select id, subjsec, description, smdesc, grade, 
 teacher, startrptperiod, endrptperiod from subject order by $sortorder");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
$rows = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'Edit/Delete Subjects'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">
<input type=\"submit\" value=\"". $lex{'Sort by'}. "\">\n";
 
print "<select name=\"sortorder\">\n";
if ( $arr{sortorder} ) {
    print "<option>$arr{sortorder}</option>\n";
}
print "<option>". $lex{Subject}. "</option><option>". $lex{Teacher};
print "</option><option>". $lex{Grade}. "</option><option>". $lex{Term};
print "</option></select></form></td></tr></table>\n";

print "<center><h1>". $lex{'Edit/Delete Subjects'}. "</h1>\n";

print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">";
print "<tr><th>". $lex{Subject}. '</th><th>'. $lex{'Subj-Sec'};
print '</th><th>'. $lex{SmDesc}. '</th><th>'. $lex{Grade};
print '</th><th>'. $lex{Teacher}. '</th><th>'. $lex{Terms};
print '</th><th>'. $lex{Enrol}. '</th><th>'. $lex{Edit}. "</th><th>\n";
print $lex{Delete}. '</th><th>'. $lex{Clone}. "</th></tr>\n";

$sth1 = $dbh->prepare("select count(*) from eval where subjcode = ?");

while ( my ($id,$subjsec, $description,$smdesc, $grade, $teacher, 
	    $startterm, $endterm) = $sth->fetchrow){
    
    $sth1->execute( $subjsec );
    my $count = $sth1->fetchrow;
    my $terms = ($endterm - $startterm) + 1;
    if ($terms < 1) { $terms = 1; }
    my $enrollments = round( $count / $terms, 2);

    if ( not $teacher ){ 
	$teacher = "<font color=\"red\">". $lex{'No Teacher'}. "</font>"; 
    }

    print "<tr><td>$description</td><td>$subjsec</td><td>$smdesc</td>\n";
    print "<td>$grade</td><td>$teacher</td><td>$startterm - $endterm</td>";
    print "<td>$enrollments</td>\n";
    print "<td><a href=\"subjed.pl?id=$id\">". $lex{Edit}. "</a></td>\n";
    print "<td><a href=\"subjdel.pl?id=$id\">". $lex{Delete}. "</a></td>\n";
    print "<td><a href=\"subjadd.pl?subjsec=$subjsec\">". $lex{Clone}. "</a></td></tr>\n";
}

print "</table></center></body></html>\n";
