#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex=('Subject Edit' => 'Subject Edit',
	 'Main' => 'Main',
	 'Report Card' => 'Report Card',
	 'Codes' => 'Codes',
	 'Other Codes' => 'Other Codes',
	 'Save Subject' => 'Save Subject',
	 'Course Code' => 'Course Code',
	 'Section' => 'Section',
	 'Description' => 'Description',
	 'Short Description' => 'Short Description',
	 'Max' => 'Max',
	 'char' => 'char',
	 'Grade' => 'Grade',
	 'Start Term' => 'Start Term',
	 'End Term' => 'End Term',
	 'Teacher' => 'Teacher',
	 'Sequence' => 'Sequence',
	 'Controls printing order on report card' => 
	   'Controls printing order on report card',
	 'Web Visible' => 'Web Visible',
	 'Y' => 'Y',
	 'N' => 'N',
	 'Instructional Mode' => 'Instructional Mode',
	 'Class' => 'Class',
	 'Distance' => 'Distance',
	 'Exam Mix' => 'Exam Mix',
	 'School' => 'School',
	 'Blended' => 'Blended',
	 'Faculty' => 'Faculty',
	 'Location' => 'Location',
	 'Mark Scheme' => 'Mark Scheme',
	 'Objective' => 'Objective',
	 'Save Subject' => 'Save Subject',
	 'Credit' => 'Credit',
	 'Difficulty' => 'Difficulty',
	 'Subject Area' => 'Subject Area',
	 'Calc Average' => 'Calc Average',
	 'If your subject only has marks and comments, no objective entry' => 
	   'If your subject only has marks and comments, no objective entry',
	 'is required. If you have non-mark based objectives, please enter' =>
	   'is required. If you have non-mark based objectives, please enter',
	 'the description that will appear on the report card. These will' =>
	  'the description that will appear on the report card. These will',
	 'also appear for evaluation entry. Limit: 255 characters' =>
	   'also appear for evaluation entry. Limit: 255 characters',
	 'Changing Start/End Term will require adding/removing student mark records' =>
	 'Changing Start/End Term will require adding/removing student mark records',
	 'There is one mark record for every term for each student' =>
	   'There is one mark record for every term for each student',
	 'There was an error storing your data' => 'There was an error storing your data',
	 'Please contact' => 'Please contact',
	 'Please record the following error' => 'Please record the following error',
	 'Your subject update is now stored' => 'Your subject update is now stored',
	 'Edit Another Subject' => 'Edit Another Subject',
	 'Required' => 'Required',
	 'Start Term cannot be larger than End Term' => 'Start Term cannot be larger than End Term',
	 'Terms cannot be larger than' => 'Terms cannot be larger than',
	 'Error' => 'Error',
	 

	 );

my $self = 'subjed.pl';
my $maxterms = 12;  # maximum value allowed in the start and end reporting period (terms)

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../../etc/transcript.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Subject Edit'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> | \n";

print "<a href=\"../sasklrn/qrydeptcourses.pl\" target=\"_blank\">SK ". $lex{Codes}. "</a> |
<a href=\"http://richtech.ca/cgi-bin/testbank/courseview.pl\" 
target=\"_blank\">". $lex{'Other Codes'}. "</a> ]\n";

print "<h1 style=\"margin-left:2em;\">". $lex{'Subject Edit'}. "</h1>\n";


if ( $arr{flag} ) {
    writeRecord();
}


# Load teachers into an array
my $sth = $dbh->prepare("select lastname, firstname, userid from staff 
 where userid != '' and userid is not null order by lastname, firstname"); 
$sth->execute;
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
while ( my ($ln, $fn, $uid) = $sth->fetchrow ) {
    push @teacherarray, "$ln, $fn ($uid)";
}

# Now select and load the subject
$sth = $dbh->prepare("select * from subject where id = ?"); 
$sth->execute( $arr{id} );
my @subj = $sth->fetchrow;

# Now count the eval records for this subject (to see if any exist).
# Find the number of eval records depending on this...
my $noeditflag;
$sth = $dbh->prepare("select count(*) from eval where subjcode = ?");
$sth->execute( $subj[9] ); # subjsec field
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my $count = $sth->fetchrow;
if ( $count ){ $noeditflag = 1; }


# Now print the form.
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$arr{id}\">\n";
print "<input type=\"hidden\" name=\"flag\" value=\"1\">\n";
print "<input type=\"hidden\" name=\"noeditflag\" value=\"$noeditflag\">\n";

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\"\n>
<tr><td></td><td>\n";
print "<input type=\"submit\" value=\"". $lex{'Save Subject'};
print "\"> (<font color=red>* = ". $lex{Required}. "</font>)</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Course Code'}. "<font color=red>*</font></td><td>\n";
if ( $noeditflag ) {
    print $subj[1];
} else {
    print "<input type=\"text\" name=\"subjcode\" size=\"10\" value=\"$subj[1]\">";
}
print "</td></tr>\n";


print "<tr><td align=\"right\">". $lex{Section}. "<font color=red>*</font></td>\n<td>";
if ( $noeditflag ) {
    print $subj[8];
} else {
    print "<input type=\"text\" name=\"section\" size=\"6\" value=\"$subj[8]\">";
}
print "</td></tr>\n";


print "<tr><td align=\"right\">". $lex{Description}. "<font color=red>*</font></td>
<td><input type=\"text\" name=\"description\" size=\"50\" maxlength=\"255\" 
  value=\"$subj[2]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Short Description'}. "<font color=red>*</font></td>
<td><input type=\"text\" name=\"smdesc\" size=\"8\" maxlength=\"8\" value=\"$subj[37]\"> ";
print $lex{Max}. ": 8 ". $lex{char}. "</td></tr>\n";


print "<tr><td align=\"right\">". $lex{Grade}. "<font color=red>*</font></td>
<td><input type=\"text\" Name=\"grade\" size=\"4\" maxlength=\"8\" value=\"$subj[3]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Start Term'}. "<font color=red>*</font></td>
<td><input type=\"text\" name=\"startrptperiod\" size=\"6\" value=\"$subj[32]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'End Term'}. "<font color=red>*</font></td>
<td><input type=\"text\" name=\"endrptperiod\" size=\"6\" value=\"$subj[33]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Teacher'}. "<font color=red>*</font></td>
<td><select name=\"teacher\"><option>$subj[4]</option>\n";

foreach $teacher (@teacherarray){
    print "<option>$teacher</option>\n";
}
print "</select></td></tr>\n";


print "<tr><td align=\"right\">". $lex{Sequence}. "</td>\n";
print "<td><input type=\"text\" name=\"sequence\" size=\"8\" value=\"$subj[7]\">\n";
print $lex{'Controls printing order on report card'}. ".</td></tr>\n";

print "<tr><tr><td align=\"right\">". $lex{'Web Visible'}. "</td>\n";
print "<td><select name=\"visible\"><option>$subj[31]</option>\n";
print "<option>". $lex{Y}. "</option><option>". $lex{N}. "</option></select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Instructional Mode'}. "</td>\n";
print "<td><select name=\"instmode\"><option>$subj[38]</option>\n";
print "<option>". $lex{'Class'}. "</option><option>". $lex{Distance}. "</option></select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Exam Mix'}. "</td><td><select name=\"exammix\">\n";
print "<option>$subj[39]</option><option>". $lex{'School'}. "</option><option>". $lex{'Blended'};
print  "</option></select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Faculty}. "</td><td><input type=\"text\" name=\"faculty\" 
 size=\"12\" maxlength=\"255\" value=\"$subj[35]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Location}. "</td><td><input type=\"text\" name=\"location\" 
size=\"12\" maxlength=\"255\" value=\"$subj[36]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Mark Scheme'}. "</td><td><textarea name=\"markscheme\" 
rows=\"6\" cols=\"40\">$subj[34]</textarea></td></tr>\n";


print "<tr><td align=\"right\">". $lex{'Credit'}. "</td><td>";
if ( @creditValues ) { # from transcript.conf
    print "<select name=\"credit\">\n";
    if ($subj[46] ) { print "<option>$subj[46]</option>\n"; }
    foreach my $val ( @creditValues ) {
	print "<option>$val</option>\n";
    }
    print "</select>\n";
} else {
    print "<input type=\"text\" name=\"credit\" size=\"4\" ";
    print "maxlength=\"8\" value=\"$subj[46]\">";
}
print "</td></tr>\n";


print "<tr><td align=\"right\">". $lex{'Difficulty'}. "</td><td><input type=\"text\" name=\"difficulty\" 
size=\"4\" maxlength=\"8\" value=\"$subj[47]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Subject Area'}. "</td>\n";
if ( %gradRequirements ) {
    print "<td><select name=\"area\"><option>$subj[48]</option>\n";
    foreach my $key ( sort keys %gradRequirements ) {
	print "<option>$key</option>";
    }
    print "</select></td></tr>\n";
} else {
    print "<td><input type=\"text\" name=\"area\" size=\"20\" maxlength=\"255\" value=\"$subj[48]\"></td></tr>\n";
}

print "<tr><td align=\"right\">". $lex{'Calc Average'}. "</td><td><select name=\"calcavg\">\n";
if ( $subj[49] ) { # We have an existing value...
    print "<option>$subj[49]</option>\n";
}
print "<option>". $lex{N}. "</option>\n";
print "<option>". $lex{Y}. "</option>\n";
print "</select></td></tr>\n";


print "<tr><td></td><td><div style=\"border:1px solid gray;margin:1em 0;padding:1em;\">\n";
print $lex{'If your subject only has marks and comments, no objective entry'}. "<br>\n";
print $lex{'is required. If you have non-mark based objectives, please enter'}. "<br>\n";
print $lex{'the description that will appear on the report card. These will'}. "<br>\n";
print $lex{'also appear for evaluation entry. Limit: 255 characters'}. ".<div></td></tr>\n";

for (my $i=1;$i<=20;$i++){
    my $j = $i + 9;
    print "<tr><td align=\"right\">". $lex{Objective}. " $i</td><td><input type=\"text\" ";
    print "name=\"q$i\" size=\"50\" value=\"$subj[$j]\"></td></tr>\n";
}

print "<tr><td></td><td><input type=\"submit\" value=\"". $lex{'Save Subject'};
print "\"></td></tr>\n</table></center></form></center></body></html>\n";


#--------------
sub writeRecord {
#--------------

    delete $arr{flag};
    my $noeditflag = $arr{noeditflag};
    delete $arr{noeditflag};
    my $id = $dbh->quote( $arr{id} );
    delete $arr{id}; # record id to edit.

    #foreach $key (sort keys(%arr)) { print "K:$key V:$arr{$key}<br>\n"}

    # load existing record values for subjcode, section, subjsec, periods
    my $sth = $dbh->prepare("select subjcode, section, subjsec,
     startrptperiod, endrptperiod from subject where id = ?");
    $sth->execute( $id );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($subjcode, $section, $subjsec,$startterm, $endterm) = $sth->fetchrow;

    # Find the number of eval records depending on this...
    $sth = $dbh->prepare("select count(*) from eval where subjcode = ?");
    $sth->execute( $subjsec );
    if ($DBI::errstr){ print $DBI::errstr; die;}
    my $subjcount = $sth->fetchrow;

    if ( ($startterm != $arr{startrptperiod} and $subjcount)
	 or ($endterm != $arr{endrptperiod} and $subjcount) ) {
	print "<h1>";
	print $lex{'Changing Start/End Term will require adding/removing student mark records'}. "!\n"; 
	print $lex{'There is one mark record for every term for each student'}. "!</h1>\n";
    }

    # Check for start/end term errors
    if ( $arr{startrptperiod} > $arr{endrptperiod} ) {
	print "<p><b>". $lex{'Start Term cannot be larger than End Term'}. "</b></p>\n";
	exit;
    }
    if ( $arr{startrptperiod} > $maxterms or $arr{endrptperiod} > $maxterms ) {
	print "<p><b>". $lex{'Terms cannot be larger than'}. " $maxterms</b></p>\n";
	exit;
    }


    # Join Subject and Section to make SubjSec; Add to %arr; not passed if restricted editing.
    if ( $arr{subjcode} and $arr{section} ) { # they have to exist
	$arr{subjsec} = $arr{subjcode}."-".$arr{section};
    }
    

    # We'll leave full name along with bracketed UID for now.
    #($teachname,$teachid) = split /\(/,$arr{teacher};
    #chop $teachid;  # chop trailing bracket.
    #$teachid = $arr{teacher};


    foreach my $key (sort keys %arr) {
	if (not $arr{$key}) { 
	    $arr{$key} = $sql{default};
	} else {
	    $arr{$key} = $dbh->quote( $arr{$key} );
	}
	$sth = $dbh->prepare("update subject set $key = $arr{$key} where id = $id");
	$sth->execute;
	#print "K:$key V:$arr{$key}<br>\n";
	if ($DBI::errstr ) { print $DBI::errstr; }
    }

    if (not $DBI::errstr ) {
	print "<h3>". $lex{'Your subject update is now stored'}. ".</h3></p>\n";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. ".\n";
	print $lex{'Please contact'};
	print " $adminname (<a href=\"mailto:$adminemail\">$adminemail</a> )<br>\n";
	print $lex{'Please record the following error'}. "<br>$DBI::errstr<br>\n";
    }

    print "<p>[ <a href=\"$reppage\">". $lex{'Report Card'}. "</a> | \n";
    print "<a href=\"subjdeled.pl\">". $lex{'Edit Another Subject'}. "</a> ]\n";
    print "</p></body></html>\n";

    exit;

}
