#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View Subject Records' => 'View Subject Records',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Sort by' => 'Sort by',
	   'Grade' => 'Grade',
	   'Subject' => 'Subject',
	   'Teacher' => 'Teacher',
	   'Subjsec' => 'Subjsec',
	   'Description' => 'Description',
	   'Seq' => 'Seq',
	   'Terms' => 'Terms',
	   'SmDesc' => 'SmDesc',
	   'Mode' => 'Mode',
	   'MarkBy' => 'MarkBy',
	   'Subjects' => 'Subjects',
	   'Credit' => 'Credit',
	   'Difficulty' => 'Diff',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my %sortorder =  ( $lex{Grade} => 'grade, sequence, description',
		   $lex{Teacher} => 'teacher, description',
		   $lex{Subject} => 'description, grade, teacher'
		   );

if ($arr{sort}) {
    $sortorder= $sortorder{$arr{sort}};
} else {
    $sortorder = $sortorder{Grade};
}

my $sth = $dbh->prepare("select * from subject order by $sortorder");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }


print "$doctype\n<html><head><title>". $lex{'View Subject Records'}. "</title>
 <link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
 $chartype\n</head><body>\n";

print "<a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ] ";
  
print "<form action=\"subjview.pl\" method=\"post\" style=\"display:inline;\">";
print "</select><input type=\"submit\" value=\"". $lex{'Sort by'}. "\">\n";
print "<select name=\"sort\">";
foreach $key (keys %sortorder) {
    print "<option>$key</option>\n";
}
print "</select></form>\n";


print "<h1 style=\"display:inline;margin:1em;\">". $lex{Subjects}. "</h1>
<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";

print "<tr><th>". $lex{Subjsec}. "</th><th>". $lex{Description}. "</th>\n<th>";
print $lex{Grade}. "</th><th>". $lex{Teacher}. "</th><th>". $lex{Seq}. "</th><th>";
print $lex{Terms}. "</th><th>". $lex{SmDesc}. "</th><th>". $lex{Mode}. "<br>". $lex{MarkBy};
print "</th><th>". $lex{'Credit'}. "<br>". $lex{'Difficulty'}. "</th></tr>\n";

while ( my @arr = $sth->fetchrow ) {
    print "<tr><td valign=\"top\">$arr[9]</td><td valign=\"top\">";
    print "<a href=\"subjed.pl?id=$arr[0]\">$arr[2]</a></td>";
    print "<td>$arr[3]</td><td>$arr[4]</td>\n";
    print "<td>$arr[7]</td><td>$arr[32] - $arr[33]</td><td>$arr[37]</td>\n";
    print "<td>$arr[38]<br>$arr[39]</td><td>$arr[46]<br>$arr[47]</td></tr>\n";

    my $first = 1;
    for ($z=10;$z<=29;$z++) {
	if ($arr[$z]) {
	    if ($first) { 
		print "<tr style=\"background-color:#EEE;\"><td colspan=\"9\">";
		$first = 0;
	    }
	    print "$arr[$z] | \n";
	}
    }
    print "</td></tr>\n";
}

print "</table></body></html>\n";
