#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Edit Term(s)' => 'Edit Term(s)',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Multi-Track Mode' => 'Multi-Track Mode',
	   'Cannot open the term file' => 'Cannot open the term file',
	   'Term(s) Updated' => 'Term(s) Updated',
	   'Term settings for schools that have different grade levels' =>
	     'Term settings for schools that have different grade levels',
	   'with different term numbers and dates' =>
	     'with different term numbers and dates',
	   'Term' => 'Term',
	   'Term values must contain digits only' => 
	     'Term values must contain digits only',
	   'Error' => 'Error',

	   );


use CGI;

my $self = 'termed.pl';

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

# Multi-Track mode: different grades have a different term (K-6,7-12)
if ($multiTrack){ # read all multitrack values

    foreach my $type (sort values %g_termtype){ 
	# %g_termtype def'd in admin.conf
	$termtype{$type} = 0;  # nominally 'e' and 'h'
    }
}


# Print start of page
print "$doctype\n<html><head><title>". $lex{'Edit Term(s)'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body style=\"margin:2em 4em;border:1px solid gray;\">\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";
print "<h1>". $lex{'Edit Term(s)'}. "</h1>\n";

# Write updates
if ($arr{flag}){
    updateTerms();
    print "</body></html>\n";
    die;
}

# Open term file and get values, push into @terms
open(TERM, "../../etc/term") || die $lex{'Cannot open the term file'};
while (my $trm = <TERM>){ # read all lines if more than one...
    push @terms, $trm;
}


my $term = $terms[0];
# Build %termfile hash for other values, if present.
for (1..$#terms){
    if ($terms[$_]){ # if we have a value
	my ($key,$val) = split /:/,$terms[$_];
	$termfile{$key} = $val;
    }
}


print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"flag\" value=\"1\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

print "<tr><td align=\"right\">". $lex{Term}. "</td>\n";
print "<td><input type=\"text\" name=\"term\" size=\"6\" ";
print "value=\"$term\"></td></tr>\n";


if ($multiTrack){
    print "<tr><td colspan=\"2\"><b>". $lex{'Multi-Track Mode'};
    print ":</b>\n";
    print $lex{'Term settings for schools that have different grade levels'};
    print "<br>\n";
    print $lex{'with different term numbers and dates'}. ".</td></tr>\n";

    foreach my $type (keys %termtype){
	print "<tr><td align=\"right\">$type</td>\n";
	print "<td><input type=\"text\" name=\"$type\" size=\"6\" ";
	print "value=\"$termfile{$type}\">";
	print "</td></tr>\n";
    }
}

# Print Ending Submit.
print "<tr><td colspan=\"2\" align=\"center\">";
print "<input type=\"submit\" value=\"Update Term(s)\"></td></tr>
</table></form></body></html>\n";


#--------------
sub updateTerms {
#--------------

    delete $arr{flag};
    my $term = $arr{term};
    delete $arr{term};
    # Term is value on first line; 
    # following lines, if any are for multitrack schools and have form of
    # track:value;

    open(TERM, ">../../etc/term") || die "Can't open the term file!";
    print TERM "$term\n"; # write main term value.

    foreach my $key (keys %arr ){
	#print "K:$key V:$arr{$key}<br>\n";
	# Warn if not a digit.
	if ($arr{$key} =~ m/^\D+$/){
	    print "$key - ";
	    print $lex{'Term values must contain digits only'};
	    print ".<br>\n";
	}

	print TERM "$key:$arr{$key}\n";

    }

    close TERM;
    print "<b>". $lex{'Term(s) Updated'}. ".</b>\n";

}

