#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'PK Report Card' => 'PK Report Card',
	   'Subject Enrollment' => 'Subject Enrollment',
	   'Student Group' => 'Student Group',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Alt' => 'Alt',
	   'Continue' => 'Continue',
	   'Group Value(s)' => 'Group Value(s)',
	   'Checked' => 'Checked',
	   'Error' => 'Error',
	   'Students' => 'Students',
	   'Subjects' => 'Subjects',
	   'Subject Select' => 'Subject Select',
	   'by Group' => 'by Group',
	   'All' => 'All',
	   'Separate group values with commas ( 3, 4, 5 )' => 
	     'Separate group values with commas ( 3, 4, 5 )',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'No Subjects Found' => 'No Subjects Found',
	   'Record Exists' => 'Record Exists',
	   'Term' => 'Term',
	   'Student' => 'Student',
	   'Subject' => 'Subject',	   
	   'Skipping' => 'Skipping',
	   'Your records are now stored' => 'Your records are now stored',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Record the following error' => 'Record the following error',
	   'Objective' => 'Objective',
	   'Not Found' => 'Not Found',

	   );

my $self = 'pkenroladd.pl';
my $checked = q{checked="checked"};

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Subject Enrollment'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'PK Report Card'}. "</a> ]\n";
print "<center><h1>". $lex{'Subject Enrollment'}. "</h1></center>\n";

if ( not $arr{page} ) {
    showStartPage();
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectSubjectStudent_1();
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    selectSubjectStudent_2();
} elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    writeRecords();
}


#----------------
sub showStartPage {
#----------------

    print "<center><div style=\"padding:1em;margin:0.5em 5em;border:1px solid gray;\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<tr><td align=\"right\">\n";
    print $lex{'Student Group'}. "</td><td><select name=\"studgrpname\"><option></option>\n";
    print "<option>". $lex{Grade}. "</option><option>". $lex{Homeroom}. "</option>\n";
    print "<option>". $lex{Alt}. "</option></select></td></tr>\n";

    print "<tr><td align=\"right\">". $lex{'Group Value(s)'};
    print "</td><td><input type=\"text\" name=\"studgrpvalue\" size=\"10\">\n ";
    print $lex{'Separate group values with commas ( 3, 4, 5 )'}. "</td></tr>\n";

    print "<tr><td align=\"right\">". $lex{'Subject Select'};
    print "</td><td><select name=\"subjselect\">\n";
    print "<option>". $lex{'by Group'}. "</option><option>". $lex{All}. "</option>\n";
    print "</select></td></tr>\n";

    print "<tr><td>". $lex{Students}. q{ }. $lex{Checked}. "? ";
    print "<input type=\"checkbox\" name=\"studchecked\" value=\"1\"></td><td>\n";

    print $lex{Subjects}. q{ }. $lex{Checked}. "? ";
    print "<input type=\"checkbox\" name=\"subjchecked\" value=\"1\"></td></tr>\n";

    print "<tr><td></td><td><input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";
    print "</form></table></div></body></html>\n";

    exit;

}


#-------------------------
sub selectSubjectStudent_1 { # select students and subjects
#-------------------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my @groups = split /,/, $arr{studgrpvalue};
    my $groupname;
    if ( $arr{studgrpname} eq $lex{Grade} ) {
	$groupname = grade;
    } elsif ( $arr{studgrpname} eq $lex{Homeroom} ) {
	$groupname = homeroom;
    } elsif ( $arr{studgrpname} eq $lex{Alt} ) {
	$groupname = alt1;
    }

    # Set the checking
    my ( $studchecked, $subjchecked );
    if ( $arr{studchecked} ) { $studchecked = $checked; }
    if ( $arr{subjchecked} ) { $subjchecked = $checked; }

    my @students;
    foreach my $grp ( @groups ) {

	# Put put students  into a student array
	my $sth = $dbh->prepare("select lastname, firstname, initial, studnum 
         from student where $groupname = ? order by lastname, firstname");
	$sth->execute( $grp );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	while ( my ( $lastname, $firstname, $initial, $studnum ) = $sth->fetchrow ) {
	    push @students, "$lastname, $firstname $initial:$studnum";
	}
    }

    if ( not @students ) {
	print "<h1>". $lex{'No Student(s) Found'}. "</h1>\n";
	print "</body></html>\n";
	exit;
    }


    # Now get the subjects based on studgrpname and studgrpvalue (in rc_subject)
    my @subjects;
    if ( $arr{subjselect} eq $lex{All} ) {

	my $sth = $dbh->prepare("select subjsec from rc_subject
          order by description, subjsec");
	$sth->execute;
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	while ( my $subjsec = $sth->fetchrow ) {
	    push @subjects, $subjsec;
	}

    } else { # we are selecting by groupname and groupvalue

	my $sth = $dbh->prepare("select subjsec from rc_subject
         where studgrpname = ? and studgrpvalue = ? order by description, subjsec");
	$sth->execute( $arr{studgrpname}, $arr{studgrpvalue} );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	while ( my $subjsec = $sth->fetchrow ) {
	    push @subjects, $subjsec;
	}

    }

    if ( not @subjects ) {
	print "<h1>". $lex{'No Subjects Found'}. "</h1>\n";
	print "</body></html>\n";
	exit;
    }

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";

    # We now have @subjects (subjsec) and @students (name:studnum) populated.
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\" style=\"float:left;\">\n";    
    print "<tr><th>". $lex{Students}. "</th></tr>\n";
    foreach my $stud ( @students ) {
	my ($name, $studnum) = split /:/, $stud;
	print "<tr><td><input type=\"checkbox\" name=\"$stud\" value=\"S\" $studchecked>";
	print "$name</td></tr>\n";
    }
    print "</table>\n";


    my $sth = $dbh->prepare("select description from rc_subject where subjsec = ?");
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\" style=\"float:left;\">\n";    
    print "<tr><th>". $lex{Subjects}. "</th></tr>\n";

    foreach my $subjsec ( @subjects ) {
	$sth->execute( $subjsec );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my $desc = $sth->fetchrow;
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	print "<tr><td><input type=\"checkbox\" name=\"$subjsec\" value=\"C\" $subjchecked>";
	print "$desc ($subjsec)</td></tr>\n";
    }
    print "</table>\n";

    print "<br clear=\"left\"><input type=\"submit\" value=\"". $lex{Continue}. "\"><br>\n";
    print "</form></body></html>\n";

    exit;

}



#-------------------------
sub selectSubjectStudent_2 { # select individual students and subjects
#-------------------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }


    my ( @students, @subjects );
    foreach my $key ( sort keys %arr ) { # separate into students and subjects
	if ( $arr{$key} eq 'S' ) {
	    push @students, $key;
	} else {
	    push @subjects, $key;
	}
    }

    my $sth = $dbh->prepare("select description from rc_subject where subjsec = ?");
    my $sth1 = $dbh->prepare("select lastname, firstname from student where studnum = ?");

    # Start the Form.
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\">\n";

    foreach my $subjsec ( @subjects ) {

	$sth->execute( $subjsec );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my $desc = $sth->fetchrow;
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\" ";
	print "style=\"float:left;margin:0.3em;\">\n";    
	print "<tr><th>$desc</th></tr>\n";

	foreach my $stud ( @students ) {

	    my ($name, $studnum) = split /:/, $stud;
	    print "<tr><td>";
	    print "<input type=\"checkbox\" name=\"$subjsec:$studnum\" value=\"1\" $checked>\n";
	    print "<b>$name</b></td></tr>\n";
	}

	print "</table>\n";

    }

    print "<br clear=\"left\"><input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
    print "</form></body></html>\n";

    exit;


} # end of selectSubjectStudent_2



#---------------
sub writeRecords {
#---------------
    
    #foreach my $key ( sort keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print '<tr><th>'. $lex{Student}. '</th><th>'. $lex{Subject};
    print "</th><th>". $lex{Objective}. "</th></tr>\n";

    my $sth1 = $dbh->prepare("select lastname, firstname from student where studnum = ?");

    foreach my $key ( sort keys %arr ) {  # $key contains subjsec:studnum 

	my ( $subjsec, $studnum ) = split(/:/,$key);
       
	# Read the subject
	my $sth = $dbh->prepare("select description, startterm, endterm 
         from rc_subject where subjsec = ?");
	$sth->execute( $subjsec );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my ($description, $startterm, $endterm) = $sth->fetchrow;

	# Read the objectives for this subject
	my @objectives;
	$sth = $dbh->prepare("select id from rc_objective where subjsec = ?");
	$sth->execute( $subjsec );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	while ( my $id = $sth->fetchrow ) {
	    push @objectives, $id;
	}


	# Outline: Each subject record in rc_subject has objectives
	# (in rc_objectives) linked by the subjsec field. In turn both
	# the evaluations are linked to the objectives, not directly
	# to the subject table. The choices for the objectives are
	# also linked in this way (via objid). Thus, when we enrol a
	# student in a subject, we have to create records in
	# rc_obj_eval for each term for each objective. Thus a 3 term
	# subject with 5 objectives would require 3 x 5 = 15 records
	# to be added, 3 for each objective; 5 for each term.

	# Check for the existence of the same record(s),
	# one for each term for each student in each subject.
	my ($term, %terms);

	# Get Student Name
	$sth1->execute( $studnum );
	if ( $DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname) = $sth1->fetchrow;
	if ( not $lastname ) { $lastname = '<font color=red>'. $lex{'Not Found'}. '</font>'; }

	# Setup for existence of eval records already. (by objid, term, and studnum)
	my $sth1 = $dbh->prepare("select  count(*) from rc_obj_eval 
         where studnum = ? and objid = ? and term = ?");

	my $sth2 = $dbh->prepare("insert into rc_obj_eval 
         ( studnum, objid, term ) values ( ?, ?, ?)");

	my $sth3 = $dbh->prepare("select description from rc_objective where id = ?");

	# Loop through and check where term is missing...
	for my $term ( $startterm..$endterm ) {
	    foreach my $objid ( @objectives ){
		$sth1->execute( $studnum, $objid, $term );
	        if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		my $count = $sth1->fetchrow;
		if ( $count > 0 ) { # record already exists
		    print $lex{'Record Exists'}. q{ }. $lex{Term}. ":$term ";
		    print $lex{Subject}. ":$description ($subjsec $objid)\n"; 
		    print $lex{Student}. ":$lastname, $firstname ($studnum).\n";
		    print "<b>". $lex{Skipping}. "</b><br>\n";
		} else { # Add a new record.
		    $sth2->execute( $studnum, $objid, $term );
		    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
		    # print line for this record.
		    if ( $term == $startterm ) {
			# Get Objective Name
			$sth3->execute( $objid );
			if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
			my $objdesc = $sth3->fetchrow;
			print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td>";
			print "<td>$description ($subjsec)</td><td>$objdesc</td></tr>\n";
		    }
		}

	    } # objective loop
	} # term loop

	
    } # Next Student / Subject combo.

    if ( not $DBI::errstr ) {
	print "</table>\n";
	print "<h3>". $lex{'Your records are now stored'}. ".</h3></p>\n";
    } else {
	print "</table><p>". $lex{'There was an error storing your data'}. ".\n";
	print $lex{Contact};
	print " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Record the following error'}. ": $DBI::errstr</p>\n";
    }

    print "<p>[ <a href=\"$reppage\">". $lex{'PK Report Card'}. "</a> ]\n";
    print "</p></center></body></html>\n";

    exit;

} # End of writeRecords
