#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'PK Report Card' => 'PK Report Card',
	   'Subject' => 'Subject',
	   'Continue' => 'Continue',
	   'Enrollment View' => 'Enrollment View',
	   'Add Choices' => 'Add Choices',
	   'Choice' => 'Choice',
	   'Contact' => 'Contact',
	   'Different Subject' => 'Different Subject',
	   'Error' => 'Error',
	   'Existing Choices' => 'Existing Choices',
	   'Add Objectives' => 'Add Objectives'
	   'Save Choices' => 'Save Choices',
	   'Same Subject' => 'Same Subject',
	   'Records Saved' => 'Records Saved',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'New Choices' => 'New Choices'

	   );

use DBI;
use CGI;

my $self = 'pkenrolview.pl';

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. " $self: $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


# Page Header
print "$doctype\n<html><head><title>". $lex{'Enrollment View'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em 2em;\">\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'PK Report Card'}. "</a> |\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


if ( not $arr{page} or $arr{page} == 1 ) {
    showStartPage();
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    addChoices();
} elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    writeChoices();
}


#----------------
sub showStartPage {  # select the subject and # of objectives to add.
#----------------

    print "<h1>". $lex{'Enrollment View'}. "</h1>\n";

    #print "<form action=\"$self\" method=\"post\">\n";
    #print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    #print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";
    #print "<tr><th>". $lex{Subject}. "</th></tr>\n";

    # Display all subjects for selection
    my $sth = $dbh->prepare("select id, description, subjsec from rc_subject 
      order by description");
    $sth->execute;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

    # Find Objectives and Choices
    my $sth1 = $dbh->prepare("select id, name from rc_objective where subjsec = ? order by name");
    my $sth2 = $dbh->prepare("select id, choice from rc_obj_choice where objid = ? order by choice");

    while ( my ( $id, $description, $subjsec ) = $sth->fetchrow ) {
	print "<div><h3 style=\"font-size:140%;font-weight:bold;\">$description ($subjsec)</h3>\n";

	print "<table cellpadding=\"3\" border=\"0\" cellspacing=\"0\">\n";

	# Now find the objectives;
	$sth1->execute( $subjsec );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	while ( my ( $id, $name ) = $sth1->fetchrow ) {
    
	    print "<tr><td style=\"text-align:right;font-weight:bold;\">$name</td>\n<td>";

	    print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
	    print "<input type=\"hidden\" name=\"objid\" value=\"$id\">\n";
	    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
	    print "<input type=\"submit\" value=\"". $lex{'Add Choices'}. "\"></form></td><td>\n";

	    # Now find choices for each objective.
	    $sth2->execute( $id );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    while ( my ($id, $choice ) = $sth2->fetchrow ) {
		print "$choice | \n";
	    }
	    print "</td></tr>\n";
	    
	}
	print "</table></div>\n";

    }

    #print "<input type=\"submit\" value=\"". $lex{Continue}. "\">\n";
    print "</form></center>\n";
    print "</body></html>\n";

    exit;

}


#----------------
sub addChoices {
#----------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # Passed: objid - objid of an objective, to add to.

    # Display the Subject and the Objective, List existing objectives for this subject,
    my $sth = $dbh->prepare("select description, subjsec from rc_objective where id = ?");
    $sth->execute( $arr{objid} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my ($objectiveDescription, $subjsec) = $sth->fetchrow;

    my $sth = $dbh->prepare("select description from rc_subject where subjsec = ?");
    $sth->execute( $subjsec );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $subjectDescription = $sth->fetchrow;
    
    print "<h1>$subjectDescription ($subjsec) - $objectiveDescription</h1>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";
    print "<input type=\"hidden\" name=\"objid\" value=\"$arr{objid}\">\n";

    # Now print existing choices from this subject.
    print "<h3>". $lex{'Existing Choices'}. "</h3>\n";

    my $sth1 = $dbh->prepare("select id, choice from rc_obj_choice where objid = ?");

    my $sth = $dbh->prepare("select id from rc_objective where subjsec = ?");
    $sth->execute( $subjsec );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    while ( my $id = $sth->fetchrow ) {
	$sth1->execute( $id );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	while ( my ( $choiceid, $choice ) = $sth1->fetchrow ) {
	    print "<div><input type=\"checkbox\" name=\"$choiceid\" value=\"1\"> $choice</div>\n";
	}
    }


    # Now print empty fields for new choices (up to 6?)
    print "<h3>". $lex{'New Choices'}. "</h3>\n";
    for my $i (1..6) {
	my $choice = 'ch'. $i;
	print "<div style=\"padding:0.3em;\">". $lex{Choice};
	print " $i <input type=\"text\" name=\"$choice\" size=\"40\"></div>\n";
    }

    print "<input type=\"submit\" value=\"". $lex{'Save Choices'}. "\">\n";
    print "</form></center></body></html>\n";

    exit;
}



#----------------
sub writeChoices {
#----------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $objid = $arr{objid};
    delete $arr{objid};

    for my $i (1..6) {
	my $idx = 'ch'. $i;
	if ( $arr{$idx} ) {
	    $sth = $dbh->prepare("insert into rc_obj_choice ( objid, choice ) values ( ?, ? )");
	    $sth->execute( $objid, $arr{$idx} );
	    if ( $DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	}
	delete $arr{$idx};
    }

    # Insert existing choices.
    my $sth = $dbh->prepare("select choice from rc_obj_choice where id = ?");    
    foreach my $key ( sort keys %arr ) { 
	$sth->execute( $key );
	if ( $DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $choice = $sth->fetchrow;

	# now insert the choice.
	$sth1 = $dbh->prepare("insert into rc_obj_choice ( objid, choice ) values ( ?, ? )");
	$sth1->execute( $objid, $choice );
	if ( $DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    }


    if ( not $DBI::errstr ) {
	print "<h3>$rec{name} - ". $lex{'Records Saved'}. ".</h3>\n";
    } else { 
	print '<h3>'. $lex{'There was an error storing your data'}. ". \n";
	print $lex{'Contact'}. " $adminname ";
	print "(<a href=\"mailto:$adminemail\">$adminemail</a>)<br>\n";
	print " $DBI::errstr</h3>\n";
    }


    print "<p>[ <a href=\"$self\">". $lex{'Add Choices'}.' - ';
    print $lex{'Different Subject'}. "</a> |\n";

    #print "[ <a href=\"$self?subjsec=$subjsec&page=2\">". $lex{'Add Objectives'}.' - ';
    #print $lex{'Same Subject'}. "</a> |\n";

    print "<a href=\"$reppage\">". $lex{'PK Report Card'}. "</a> ]</p>\n";
    print "</center></body></html>\n";

    exit;

}




