#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'PK Objective Entry' => 'PK Objective Entry',
	   'PK Report Card' => 'PK Report Card',
	   'Subject' => 'Subject',
	   'Select Subject' => 'Select Subject',
	   'Continue' => 'Continue',
	   'Number of Objectives to Enter' => 'Number of Objectives to Enter',
	   'Sequence Number' => 'Sequence Number',
	   'Description' => 'Description',
	   'Group Name' => 'Group Name',
	   'or New Group' => 'or New Group',
	   'Existing Objectives' => 'Existing Objectives',
	   'No Objectives Found' => 'No Objectives Found',
	   'Add New Objectives' => 'Add New Objectives',
	   'Objective' => 'Objective',
	   'Save Objectives' => 'Save Objectives',
	   'The Record is Stored' => 'The Record is Stored',
	   'Contact' => 'Contact',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'More Objectives' => 'More Objectives',
	   'Same Subject' => 'Same Subject',
	   'Different Subject' => 'Different Subject',
	   'No Subject entered' => 'No Subject entered',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

my $self = 'pkobjadd.pl';
my $defaultObjCount = 6;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


# Page Header
print "$doctype\n<html><head><title>". $lex{'PK Objective Entry'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em 2em;\">\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'PK Report Card'}. "</a> |\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

if ( not $arr{page} or $arr{page} == 1 ) {
    showStartPage();
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    addObjectives();
} elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    writeObjectives();
}



#----------------
sub showStartPage {  # select the subject and # of objectives to add.
#----------------

    print "<center><h1>". $lex{'Select Subject'}. "</h1>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";

    print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";
    print "<tr><th>". $lex{Subject}. "</th></tr>\n";

    print "<tr><td align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";

    print "<tr><td align=\"center\">". $lex{'Number of Objectives to Enter'};
    print " <input type=\"text\" name = \"objcount\" size=\"3\" value=\"$defaultObjCount\">";
    print "</td></tr>\n";

    # Display all subjects for selection
    my $sth = $dbh->prepare("select id, description, subjsec from rc_subject 
      order by description");
    $sth->execute;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    while ( my ( $id, $description, $subjsec ) = $sth->fetchrow ) {
	print "<tr><td>";
	print "<input type=\"radio\" name=\"subjsec\" value=\"$subjsec\">\n";
	print "$description ($subjsec)</td></tr>\n";
    }

    print "<tr><td align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";
    print "</table></form></center></body></html>\n";

    exit;

}


#----------------
sub addObjectives {
#----------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    # Passed: subjsec, objcount

    if ( not $arr{subjsec} ) {
	print '<h3>'. $lex{'No Subject entered'}. "</h3>\n";
	print "</body></html>\n";
	die;
    }

    if ( not $arr{objcount} ) { $arr{objcount} = $defaultObjCount; } # Number of Objectives


    my $sth = $dbh->prepare("select description from rc_subject where subjsec = ?");
    $sth->execute( $arr{subjsec} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $description = $sth->fetchrow;

    print "<center><h1>". $lex{'Existing Objectives'}. "</h1>\n";
    print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"1\">\n";
    print "<tr><th colspan=\"2\"><b>$description</b></th></tr>\n";

    my $flag;
    # find existing objectives and display
    my $sth = $dbh->prepare("select description, groupname, groupseq from rc_objective 
      where subjsec = ? order by groupname, groupseq");
    $sth->execute( $arr{subjsec} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    while ( my ( $description, $groupname, $groupseq ) = $sth->fetchrow ) {
	print "<tr><td>$description</td><td>$groupname $groupseq</td></tr>\n";
	$flag = 1;
    }
    print "</table>\n";
    if ( not $flag ) { print "<p>". $lex{'No Objectives Found'}. "</p>\n"; }


    # Get Distinct Group Names
    $sth = $dbh->prepare("select distinct groupname from rc_objective 
      where subjsec = ? order by groupname");
    $sth->execute( $arr{subjsec} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    while ( my $gname = $sth->fetchrow ) {
	push @groupnames, $gname;
    }

    print "<h1>". $lex{'Add New Objectives'}. "</h1>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";
    print "<input type=\"hidden\" name=\"subjsec\" value=\"$arr{subjsec}\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Save Objectives'}. "\">\n";
		       
    # create entries for set number of objectives, prev screen.
    for my $i ( 1..$arr{objcount} ) {

	print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"1\">\n";
	print "<caption style=\"font-weight:bold;font-size:150%;\">";
	print $lex{Objective}. " $i</caption>\n";

	print "<tr><td align=\"right\">". $lex{Description}. "</td><td>";
	print " <input type=\"text\" name=\"$i:description\" size=\"20\"></td></tr>\n";

	print "<tr><td align=\"right\">". $lex{'Group Name'}. "</td><td>";
	print " <select name=\"$i:groupname\"><option></option>\n";
	foreach my $gn ( @groupnames ) { print "<option>$gn</option>\n" }
	print "</select> ". $lex{'or New Group'}. q{ };

	print "<input type=\"text\" name=\"$i:newgroup\" size=\"12\">\n";
	print "</td></tr>\n";

	print "<tr><td align=\"right\">". $lex{'Sequence Number'}. "</td><td>";
	print " <input type=\"text\" name=\"$i:sequence\" size=\"4\"></td></tr>\n";
	print "</table><p></p>\n";

    }

    print "<input type=\"submit\" value=\"". $lex{'Save Objectives'}. "\">\n";
    print "</form></center></body></html>\n";

    exit;
}



#------------------
sub writeObjectives {
#------------------

    my $subjsec = $arr{subjsec};
    delete $arr{subjsec};

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    
    foreach my $key ( sort keys %arr ) {
	my ($i, $fld ) = split /:/, $key;
	if ( $fld ne 'description' or not $arr{$key} ) { next; } # use only name fields to parse.

	my %rec;
	$rec{description} = $arr{$key};

	#$rec{description} = $arr{$i. ':description'};

	if ( $arr{$i. ':newgroup'} ) { # new group overrides any group name passed.
	    $rec{groupname} = $arr{$i. ':newgroup'};
	} else {
	    $rec{groupname} = $arr{$i. ':groupname'};
	}
	$rec{groupseq} = $arr{$i. ':sequence'};
	$rec{subjsec} = $subjsec;

	# New Code - July / 08
	my @keys = keys %rec;
	my $keys = join(',', @keys);
	
	foreach my $k ( keys %rec ) {
	    if ( not $rec{$k} ) { 
		$rec{$k} = $sql{default};
	    } else {
		$rec{$k} = $dbh->quote( $rec{$k} );
	    }
	}
	my $values = join(',', ( values %rec ));

	$sth = $dbh->prepare("insert into rc_objective ( $keys ) values ( $values )");
	$sth->execute;

	if ( not $DBI::errstr ) {
	    print "<h3>$rec{description} - ". $lex{'The Record is Stored'}. ".</h3>\n";
	} else { 
	    print '<h3>'. $lex{'There was an error storing your data'}. ". \n";
	    print $lex{'Contact'}. " $adminname ";
	    print "(<a href=\"mailto:$adminemail\">$adminemail</a>)<br>\n";
	    print " $DBI::errstr</h3>\n";
	}

    }


    my $sth = $dbh->prepare("select description from rc_subject where subjsec = ?");
    $sth->execute( $subjsec );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $description = $sth->fetchrow;

    print "<center><h1>$description<br>". $lex{'Existing Objectives'}. "</h1>\n";
    print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"1\">\n";

    my $flag;
    # find existing objectives and display
    my $sth = $dbh->prepare("select description, groupname, groupseq from rc_objective 
      where subjsec = ? order by groupname, groupseq");
    $sth->execute( $subjsec );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    while ( my ( $description, $groupname, $groupseq ) = $sth->fetchrow ) {
	print "<tr><td>$description</td><td>$groupname $groupseq</td></tr>\n";
	$flag = 1;
    }
    print "</table>\n";


    print "<p>[ <a href=\"$self\">". $lex{'More Objectives'}.' - ';
    print $lex{'Different Subject'}. "</a> |\n";

    print "[ <a href=\"$self?subjsec=$subjsec&page=2\">". $lex{'More Objectives'}.' - ';
    print $lex{'Same Subject'}. "</a> |\n";

    print "<a href=\"$reppage\">". $lex{'PK Report Card'}. "</a> ]</p>\n";
    print "</center></body></html>\n";

    exit;

}




