#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Edit/Delete PK Subjects' => 'Edit/Delete PK Subjects',
	   'Main' => 'Main',
	   'Report Card' => 'Report Card',
	   'Subject' => 'Subject',
	   'Teacher(s)' => 'Teacher(s)',
	   'Term' => 'Term',
	   'Grade' => 'Grade',
	   'Sort by' => 'Sort by',
	   'No Teacher' => 'No Teacher',
	   'Subj-Sec' => 'Subj-Sec',
	   'Terms' => 'Terms',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Clone' => 'Clone',
	   'SmDesc' => 'SmDesc',
	   'Enrol' => 'Enrol',
	   'Error' => 'Error',
	   'Group' => 'Group',
	   'student enrolments depend on this subject' => 
	     'student enrolments depend on this subject',
	   'Subject Deletion' => 'Subject Deletion',
	   'Subject-Section' => 'Subject-Section',
	   'Enrolment Records Depending' => 'Enrolment Records Depending',
	   'Are you sure you want to delete this record' =>
	     'Are you sure you want to delete this record',
	   'Delete the Record' => 'Delete the Record',
	   'Record deleted' => 'Record deleted',
	   'Record Deletion Failed' => 'Record Deletion Failed',
	   'Contact' => 'Contact',

	   );

my $self = 'pksubjdeled.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

my $q = CGI->new;
print $q->header( -charset => $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Edit/Delete PK Subjects'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Report Card'}. "</a> ]\n";

if ( $arr{id} ) {
    confirmDelete();
} elsif ( $arr{itemid} ) {
    deleteRecord();
}


my $sortorder;
if ($arr{sortorder} eq $lex{Subject} ){
    $sortorder = 'description, studgrpvalue';
} elsif ($arr{sortorder} eq $lex{Grade} ){
    $sortorder = 'studgrpvalue, description ';
} elsif ($arr{sortorder} eq $lex{Term}){
    $sortorder = 'startterm, description';
} else {
    $sortorder = 'description, studgrpvalue';
    $arr{sortorder} = $lex{Subject};
}


my $sth = $dbh->prepare("select id, subjsec, description, smdesc, studgrpname, 
  studgrpvalue, startterm, endterm from rc_subject order by $sortorder");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
$rows = $sth->rows;


print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">
<input type=\"submit\" value=\"". $lex{'Sort by'}. "\">\n";

print "<select name=\"sortorder\">\n";
if ( $arr{sortorder} ) {
    print "<option>$arr{sortorder}</option>\n";
}
print "<option>". $lex{Subject};
print "</option><option>". $lex{Grade}. "</option><option>". $lex{Term};
print "</option></select></form></td></tr></table>\n";

print "<center><h1>". $lex{'Edit/Delete PK Subjects'}. "</h1>\n";

print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">";
print "<tr><th>". $lex{Subject}. '</th><th>'. $lex{'Subj-Sec'};
print '</th><th>'. $lex{SmDesc}. '</th><th>'. $lex{Group}. '</th><th>';
print $lex{'Teacher(s)'}. '</th><th>'. $lex{Terms};
print '</th><th>'. $lex{Enrol}. '</th><th>'. $lex{Edit}. "</th><th>\n";
print $lex{Delete}. '</th><th>'. $lex{Clone}. "</th></tr>\n";

my $sth1 = $dbh->prepare("select count( distinct e.studnum ) from rc_obj_eval as e, 
  rc_objective as o  where o.id = e.objid and o.subjsec = ?"); 


while ( my ( $id, $subjsec, $description,$smdesc, $studgrpname, $studgrpvalue, 
	    $startterm, $endterm ) = $sth->fetchrow){
    
    $sth1->execute( $subjsec );
    my $enrollments = $sth1->fetchrow;

    # Now get the teacher(s)
    my @teachers;
    my $sth2 = $dbh->prepare("select lastname, firstname from staff where userid = ?");

    my $sth1 = $dbh->prepare("SELECT  t.userid from rc_teacher as t
      WHERE t.subjsec = ?");
    $sth1->execute( $subjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    while ( my $userid = $sth1->fetchrow ) {
	$sth2->execute( $userid );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my ( $lastname, $firstname ) = $sth2->fetchrow;
	push @teachers, "$firstname $lastname ($userid)";
    }

    #if ( not $teacher ){ 
    #$teacher = "<font color=\"red\">". $lex{'No Teacher'}. "</font>"; 
    #}

    print "<tr><td>$description</td><td>$subjsec</td><td>$smdesc</td>\n";
    print "<td>$studgrpname $studgrpvalue</td><td>";
    foreach my $teacher (@teachers) { print $teacher. q{ }; }
    print "</td><td>$startterm - $endterm</td>";
    print "<td>$enrollments</td>\n";

    print "<td><form action=\"pksubjed.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
    print "<input type=\"submit\" value=\"". $lex{Edit}. "\"></form></td>\n";

    print "<td><form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"id\" value=\"$id\">\n";
    print "<input type=\"submit\" value=\"". $lex{Delete}. "\"></form></td>\n";

    print "<td><form action=\"pksubjadd.pl\" method=\"post\" style=\"display:inline;\">\n";
    print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
    print "<input type=\"submit\" value=\"". $lex{Clone}. "\"></form></td>\n";
    print "</tr>\n";

}

print "</table></center></body></html>\n";



#----------------
sub confirmDelete {
#----------------


    my $sth = $dbh->prepare("select description, subjsec from rc_subject where id = ?"); 
    $sth->execute( $arr{id} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $description, $subjsec ) = $sth->fetchrow;


    # Now check for dependent records.
    $sth = $dbh->prepare("select count(distinct studnum) from rc_obj_eval as oe,
     rc_objective as ob where oe.objid = ob.id and ob.subjsec = ?"); 
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    $sth->execute( $subjsec );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $studcount = $sth->fetchrow;

    if ( $studcount > 0 ){ # Some records depend on this...
	print "<h1>$studcount ";
	print $lex{'student enrolments depend on this subject'}. ".</h1>\n";
	#print "</center></body></html>\n";
	#die;
    }

    print "<center><h1>". $lex{'Subject Deletion'}. "</h1>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";

    print "<tr><th align=\"right\">". $lex{Subject};
    print "</td><td align=left>$description</td></tr>\n";
    print "<tr><th align=\"right\">". $lex{'Subject-Section'};
    print "</td><td align=left>$subjsec</td></tr>\n";
    print "<tr><th align=\"right\">". $lex{'Enrolment Records Depending'};
    print "</td><td align=left>$studcount</td></tr>\n";
    print "</table>\n<p><em>";
    print $lex{'Are you sure you want to delete this record'}. "?</em></p>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"itemid\" value=\"$arr{id}\">\n";
    print "<input type=\"submit\" value=\"". $lex{'Delete the Record'}. "!\">\n";
    print "</form></center></body></html>\n";

    exit;

}



#---------------
sub deleteRecord {
#---------------

    # foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    # Get subjsec
    my $sth = $dbh->prepare("select subjsec from rc_subject where id = ?");
    $sth->execute( $arr{itemid} );
    my $subjsec = $sth->fetchrow;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    # Now get rc_objectives (and linked records) to delete
    $sth = $dbh->prepare("select id from rc_objective where subjsec = ?");
    $sth->execute( $subjsec );
    while ( my $objid = $sth->fetchrow ) {

	# First delete eval recs (?)
	my $sth1 = $dbh->prepare("delete from rc_obj_eval where objid = ?");
	$sth1->execute( $objid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	# Delete choices
	$sth1 = $dbh->prepare("delete from rc_obj_choice where objid = ?");
	$sth1->execute( $objid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	# Delete the objective itself now.
	$sth1 = $dbh->prepare("delete from rc_objective where id = ?");
	$sth1->execute( $objid );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    }

    # Delete the subject record
    $sth = $dbh->prepare("delete from rc_subject where id = ?");
    $sth->execute( $arr{itemid} );


    if ($DBI::errstr) {
	print "<h1>". $lex{'Record Deletion Failed'}. ". ". $lex{Contact}. " $adminname ";
	print "( $adminemail )\n";
    } else {
	print "<h1>". $lex{'Record deleted'}. ".</h1>\n";
    }
    print "<p>[ <a href=\"$reppage\">". $lex{'Report Card'}. "</a> |\n";
    print "<a href=\"pksubjdeled.pl\">". $lex{'Edit/Delete PK Subjects'}. "</a> ]</p>\n"; 

    print "</center></body></html>\n";

    exit;

}
