#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Alt Report Card' => 'Alt Report Card',
	   'Alt Subject Edit' => 'Alt Subject Edit',
	   'Required' => 'Required',
	   'Subject-Section' => 'Subject-Section',
	   'Save Subject' => 'Save Subject',
	   'Description' => 'Description',
	   'Short Description' => 'Short Description',
	   'Max' => 'Max',
	   'char' => 'char',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Alt' => 'Alt',
	   'Start Term' => 'Start Term',
	   'End Term' => 'End Term',
	   'Group Name' => 'Group Name',
	   'Group Value' => 'Group Value',
	   'Teacher' => 'Teacher',
	   'Sequence' => 'Sequence',
	   'Controls printing order on report card' => 
	     'Controls printing order on report card',
	   'Y' => 'Y',
	   'N' => 'N',
	   'Mark Scheme' => 'Mark Scheme',
	   'Save Subject' => 'Save Subject',
	   'Credit' => 'Credit',
	   'Difficulty' => 'Difficulty',
	   'Subject Area' => 'Subject Area',
	   'Calc Average' => 'Calc Average',
	   'Error' => 'Error',
	   'You are missing a required field or have a hyphen in a course code' =>
	     'You are missing a required field or have a hyphen in a course code',
	   'Please go back and try again' => 'Please go back and try again',
	   'There was an error storing your data' => 
	     'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Record Updated' => 'Record Updated',

	   );

use DBI;
use CGI;

my $maxteachers = 3; # max number of teachers to show for entry.
my $self = 'pksubjed.pl';

my $defaultsequence = 100; 
# Starting value for sequence number.

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

eval require "../../etc/transcript.conf";
if ( $@ ) {
    print $lex{Error}. " $self: $@<br>\n";
    die $lex{Error}. "$self: $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


print "$doctype\n<html><head><title>". $lex{'Alt Subject Edit'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body style=\"padding:1em 2em;\">\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$reppage\">". $lex{'Alt Report Card'}. "</a> |\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    updateRecord();
}


my @subj;
if ( $arr{id} ) {
    $sth = $dbh->prepare("select * from rc_subject where id = ?"); 
    $sth->execute( $arr{id} );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    $subj = $sth->fetchrow_hashref;
}


# Load teachers into an array
my @teachers;
my $sth = $dbh->prepare("select distinct userid, lastname, firstname from staff 
 order by lastname, firstname"); 
$sth->execute;
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
while ( my ( $userid, $lastname, $firstname ) = $sth->fetchrow ) {
    push @teachers, "$lastname, $firstname ($userid)";
}

print "<center><h1>". $lex{'Alt Subject Edit'}. "</h1></center>\n";


print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";
print "<input type=\"hidden\" name=\"id\" value=\"$subj->{id}\">\n";

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
print "<tr><td></td><td><input type=\"submit\" value=\"". $lex{'Save Subject'};
print "\"> (<font color=\"red\">* = ". $lex{Required}. "</font>)</td></tr>\n";


print "<tr><td align=\"right\">". $lex{'Subject-Section'}. "<font color=\"red\">*</font></td>
<td><input type=\"text\" name=\"subjsec\" size=\"10\" value=\"$subj->{subjsec}\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Description}. "<font color=\"red\">*</font></td>
<td><input type=\"text\" name=\"description\" size=\"50\" maxlength=\"255\" 
  value=\"$subj->{description}\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Short Description'}. "<font color=\"red\">*</font></td>
<td><input type=\"text\" name=\"smdesc\" size=\"8\" maxlength=\"8\" value=\"$subj->{smdesc}\"> ";
print $lex{Max}. ": 8 ". $lex{char}. "</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Start Term'}. "<font color=\"red\">*</font></td>
<td><input type=\"text\" name=\"startterm\" size=\"6\" value=\"$subj->{startterm}\">
</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'End Term'}. "<font color=\"red\">*</font></td>
<td><input type=\"text\" name=\"endterm\" size=\"6\" value=\"$subj->{endterm}\">
</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Group Name'}. "<font color=\"red\">*</font></td>
<td><select name=\"studgrpname\"><option>$subj->{studgrpname}</option>>\n";
print "<option>". $lex{Grade}. "</option><option>". $lex{Homeroom}. "</option>\n<option>";
print $lex{Alt}. "</option></select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Group Value'};
print "<font color=\"red\">*</font></td>\n<td><input type=\"text\" Name=\"studgrpvalue\" ";
print "size=\"4\" maxlength=\"8\" value=\"$subj->{studgrpvalue}\"></td></tr>\n";


# Setup for getting teachers for this subject
my $sth1 = $dbh->prepare("select userid from rc_teacher where subjsec = ?"); 
$sth1->execute( $subj->{subjsec} );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

# Get Teacher Name
my $sth2 = $dbh->prepare("select lastname, firstname from staff where userid = ?"); 
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

for my $i ( 1..$maxteachers ) {
    my $userid = $sth1->fetchrow;
    if ( $userid ) {
	$sth2->execute( $userid );
	my ( $lastname, $firstname ) = $sth2->fetchrow;
	$userid = "$lastname, $firstname ($userid)";
    }
    print "<tr><td align=\"right\">". $lex{Teacher}. " $i</td>\n";
    print "<td><select name=\"teacher$i\"><option>$userid</option>\n";
    foreach my $teacher ( @teachers ) {	print "<option>$teacher</option>\n"; }
    print "<option></option></select></td></tr>\n";
}

print "<tr><td align=\"right\">". $lex{Sequence}. "</td>\n";
print "<td><input type=\"text\" name=\"sequence\" size=\"8\" value=\"$subj->{sequence}\">\n";
print $lex{'Controls printing order on report card'}. ".</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Mark Scheme'};
print "</td><td><textarea name=\"markscheme\" 
rows=\"6\" cols=\"40\">$subj->{markscheme}</textarea></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Credit}. "</td><td>";
if ( @creditValues ) { # from transcript.conf
    print "<select name=\"credit\">\n";
    print "<option>$subj->{credit}</option>\n";
    foreach my $val ( @creditValues ) {	print "<option>$val</option>\n"; }
    print "</select>\n";

} else {

    print "<input type=\"text\" name=\"credit\" size=\"4\" ";
    print "maxlength=\"8\" value=\"$subj->{credit}\">";
}
print "</td></tr>\n";


print "<tr><td align=\"right\">". $lex{'Difficulty'};
print "</td><td><input type=\"text\" name=\"difficulty\" 
size=\"4\" maxlength=\"8\" value=\"$subj->{difficulty}\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Subject Area'}. "</td>\n";

if ( %gradRequirements ) {
    print "<td><select name=\"area\"><option>$subj->{area}</option>\n";
    foreach my $key ( sort keys %gradRequirements ) {
	print "<option>$key</option>";
    }
    print "</select></td></tr>\n";
} else {
    print "<td><input type=\"text\" name=\"area\" size=\"20\" maxlength=\"255\" ";
    print "value=\"$subj->{area}\"></td></tr>\n";
}

print "<tr><td align=\"right\">". $lex{'Calc Average'};
print "</td><td><select name=\"calcavg\">\n";
if ( $subj->{calcavg} ) { # We have an existing value...
    print "<option>$subj->{calcavg}</option>\n";
}
print "<option>". $lex{N}. "</option>\n";
print "<option>". $lex{Y}. "</option>\n";
print "</select></td></tr>\n";

print "<tr><td></td><td>\n<input type=\"submit\" value=\"". $lex{'Save Subject'};
print "\"></td></tr>\n</table></center></form></center></body></html>\n";



#---------------
sub updateRecord {
#---------------

    # Make sure it has the right fields filled in and no hyphens
    my $required = qw(subjsec description smdesc startterm endterm teacher
		      studgrpname studgrpvalue );
    my $missingflag;
    foreach my $req ( @required ) {
	if ( not $arr{$req} ) { $missingflag = 1; }
    }

    if ( $missingflag ) {
	print '<h1>';
	print $lex{'You are missing a required field or have a hyphen in a course code'};
	print "<br>\n". $lex{'Please go back and try again'}. ".</h1></body></html>\n";
	exit;
    }


    # Update teachers in rc_teacher table; remove existing and put back in...
    # load existing subjsec (in case it was changed).
    my $sth = $dbh->prepare("select subjsec from rc_subject where id = ?"); 
    $sth->execute( $arr{id} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $currsubjsec = $sth->fetchrow;

    # Remove teachers based on current stored subjsec value (in case changed).
    $sth = $dbh->prepare("delete from rc_teacher where subjsec = ?");
    $sth->execute( $currsubjsec );

    $sth = $dbh->prepare("insert into rc_teacher ( subjsec, userid ) values (?,?)");
    for my $i ( 1..$maxteachers ) {
	my $tkey  = 'teacher'. $i;
	if ( $arr{$tkey} ) { # if we have a teacher entry
	    my ($dud, $userid) = split /\(/, $arr{$tkey};
	    chop $userid; # remove trailing parenthesis
	    $sth->execute( $arr{subjsec}, $userid );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	}
	delete $arr{$tkey};
    }    

    # Setup Record id for updates
    my $id = $arr{id};
    delete $arr{id};

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    foreach my $key ( keys %arr ) {

	my $sth = $dbh->prepare("update rc_subject set $key = ? where id = ?");
	$sth->execute( $arr{$key}, $id );

    }


    # Update objectives if the subjsec has changed.
    if ( $currsubjsec ne $arr{subjsec} ) {
	my $sth = $dbh->prepare("update rc_objective set subjsec = ? where subjsec = ?");
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	$sth->execute( $arr{subjsec}, $currsubjsec );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    }


    if (not $DBI::errstr ) {
	print '<h3>'. $lex{'Record Updated'}. ".</h3>\n";
    } else { 
	print '<h3>'. $lex{'There was an error storing your data'}. ". \n";
	print $lex{'Contact'}. " $adminname ";
	print "(<a href=\"mailto:$adminemail\">$adminemail</a>)<br>\n";
	print " $DBI::errstr</h3>\n";
    }

    print "[ <a href=\"$reppage\">". $lex{'Alt Report Card'};
    print "</a> ]</p></center></body></html>\n";

    exit;

}
