#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('School Enrollment' => 'School Enrollment',
	   'Date format Error' => 'Date format Error',
	   'Main' => 'Main',
	   'Enrollment' => 'Enrollment',
	   'Current Date' => 'Current Date',
	   'Aging Date' => 'Aging Date',
	   'Current Enrollment' => 'Current Enrollment',
	   'Student' => 'Student',
	   'Grade' => 'Grade',
	   'Date' => 'Date',
	   'Type' => 'Type',
	   'Description' => 'Description',
	   'Enrolled' => 'Enrolled',
	   'Not Found' => 'Not Found',
	   'No Enrollment Changes this month' => 'No Enrollment Changes this month',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
    $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


print "$doctype\n<html><head><title>". $lex{'School Enrollment'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

my ($mo, $yr, $da);
if ( not $arr{date} ) { # We'll go back 1 month.
    if ( $mon > 1 ){
	$mo = $mon;
	$yr = $year;
    } else { # else we're at 1 - January...
	$mo = 12;
	$yr = $year - 1;
    }
    $da = $mday;
} else {
    ($yr, $mo, $da) = split /-/, $arr{date};
}

my $agingdate = "$yr-$mo-$da";

if ($yr == 0 or $mo == 0 or $da == 0) {
    print '<center><h1>';
    print $lex{'Date format Error'}. " (yymmdd)";
    print "</h1>\n<form><input type=\"button\" onclick=\"javascript:history.back()\" ";
    print "value=\"Back!\">\n";
    print "</form></body></html>\n"; 
    die; 
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# First count how many currently enrolled (in student table)
my $sth = $dbh->prepare("select count(*) from student");
$sth->execute;
my $curenrol = $sth->fetchrow;

# Now count backwards through entry records until we reach date of interest
my $sth1 = $dbh->prepare("select * from transfer 
  where to_days(date) >= to_days('$agingdate') order by date desc");
$sth1->execute;
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth1->rows;


print "<center><h1>$schoolname ". $lex{Enrollment}. "</h1>\n<p><b>";
print $lex{'Current Date'}. ":</b> $currdate<br><b>";
print $lex{'Aging Date'}. ":</b> $agingdate</p>\n";

print '<b>'. $lex{'Current Enrollment'}. ": $curenrol</b>\n";

if ( $rows < 1 ) {
    print "<h3>". $lex{'No Enrollment Changes this month'}. "</h3>\n";
    print "</body></html>\n";
    die;
}

print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";
print '<tr><th>'. $lex{Student}. '</th><th>'. $lex{Grade}. '</th><th>'. $lex{Date};
print "</th>\n<th>". $lex{Type}. '</th><th>'. $lex{Description};
print '</th><th>'. $lex{Enrolled}. "</th></tr>\n";
 
my $sth2 = $dbh->prepare("select lastname, firstname, grade from studentall 
  where studnum = ?");

for ( my $i=1; $i <= $rows; ++$i) {

    my @arr = $sth1->fetchrow;

    # Find student name

    $sth2->execute( $arr[1] );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname, $grade ) = $sth2->fetchrow;
    if ( not $lastname ) {
	$name = $lex{'Not Found'};
    } else {
	$name = "$firstname $lastname";
    }

    # Now print record
    print "<tr><td>$name ($arr[1])</td><td align=\"center\">$grade</td>\n";
    print "<td>$arr[2]</td><td>$arr[3]</td><td>$arr[4]</td>\n";
    print "<td align=\"center\">$curenrol</td></tr>\n";

    # Change Enrollment Number
    if ( $arr[3] eq 'enrol' or $arr[3] eq 're-enrol' ) {
	$curenrol--;
    } elsif ($arr[3] eq 'withdraw') {
	$curenrol++;
    } else {
	# We have a programming error!
	print "<tr><td colspan=\"5\">". $lex{Error}. ": $arr[3] ". $lex{Student};
	print " $arr[1] on $arr[2]</td></tr>\n</table>";
	die; 
    }


}

print "</table></center></body></html>\n";
