#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

use DBI;
use CGI;

my %lex = ('Summary Ethnic Report' => 'Summary Ethnic Report',
	   'Main' => 'Main',
	   'Students' => 'Students',
	   'Grade' => 'Grade',
	   'Ethnicity' => 'Ethnicity',
	   'Gender' => 'Gender',
	   'Count' => 'Count',
	   'Total' => 'Total',
	   'Error' => 'Error',

	   );

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


print "$doctype\n<html><head><title>". $lex{'Summary Ethnic Report'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
<style type=\"text/css\">body { margin: 0 2em;}</style>
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]<center>
<h1 class=\"large\">". $lex{'Summary Ethnic Report'}. "</h1><p>$currdate</p>\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# First get total student count for school
my $sth = $dbh->prepare("select count(*) from student");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my $total = $sth->fetchrow;

# Now get a grade count and push into array
$sth = $dbh->prepare("select distinct grade from student 
  where grade != '' order by grade");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while ( my $gr = $sth->fetchrow ) {
    push @grades, $gr;
}
print '<b>'. $lex{'Students'}. ": $total</b>\n";

print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\"><tr>\n";
print "<th>". $lex{Grade}. "</th><th>". $lex{Ethnicity}. "</th><th>";
print $lex{Gender}. "</th><th>". $lex{Count}. "</th></tr>";

foreach my $grade ( @grades ) {
    my $sth = $dbh->prepare("select distinct ethnic, sex, count(*) from student 
      where grade = ?  group by ethnic, sex");
    $sth->execute($grade);
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    my $total;
    while ( my ($ethnic, $sex, $count ) = $sth->fetchrow ) {
	   print "<tr><td>$grade</td><td>$ethnic</td><td>$sex</td><td>$count</td></tr>\n";
	   $total += $count;
    }
    print "<tr style=\"background-color:#DDD;\"><td colspan=\"3\" align=\"right\">";
    print $lex{Total}. "</td><td>$total</td></tr>\n";
    
}

print "</table>\n";
print"</center></body></html>";
