#! /usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('House League Report' => 'House League Report',
	   'Main' => 'Main',
	   'View/Download' => 'View/Download',
	   'View Log File' => 'View Log File',
	   'Students' => 'Students',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

my $maxlines = 32; # maximum number of lines before we start a new page....

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


print "$doctype\n<html><head><title>". $lex{'House League Report'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $shortname = "houseleague$$";
my $filename = "$shortname.tex";

open(TEX,">$filename") || die "Can't open tex file";

my $papersize;
if ( $defaultpapersize ) {
    $papersize = $defaultpapersize;
} else {
    $papersize = 'letterpaper';
}

print TEX "\\documentclass[12pt,$papersize]{article}
\\usepackage{array,inputenc}
\\inputencoding{latin1}
\\renewcommand{\\familydefault}{\\sfdefault}
\\pagestyle{empty}
\\setlength{\\textwidth}{7.50in}
\\setlength{\\textheight}{10in}
\\setlength{\\hoffset}{-0.5in}
\\setlength{\\voffset}{-1.4in}
\\setlength{\\parindent}{0in}
\\setlength{\\evensidemargin}{0in}
\\setlength{\\oddsidemargin}{0in}
\\setlength{\\extrarowheight}{4pt}
\n";

print TEX "\\begin{document}\n";

$sth = $dbh->prepare("select * from student 
  order by house, homeroom,lastname,firstname");
$sth->execute;
$rows = $sth->rows;

my $curhouse = "none";
my $curroom = -1;
my $studcount;
my $linecount;

for (my $i=1; $i<=$rows; $i++) {
   
    $oldhouse = $curhouse;
    $oldroom = $curroom;

    @arr = $sth->fetchrow;

    $curhouse = $arr[9];
    $curroom = $arr[6];

    if ( $oldhouse eq $curhouse ) { # We have another record for same house
	$linecount++;
	$studcount++;

	if ($linecount > $maxlines ) {
	    print TEX "\\hline\n\\end{tabular}\\\\ \n \\newpage \n";
	    $linecount = 0;
	    print TEX  "{\\large ". $lex{'House League Report'}. "}\\\\\n";
	    print TEX "\\begin{tabular}{|p{62mm}|p{16mm}|p{10mm}|p{10mm}|";
	    print TEX "p{10mm}|p{10mm}|p{10mm}|p{10mm}|p{10mm}|}";
	    print TEX "{\\small $currdate} & & & & & & & & \\\\ & & & & & & & & \\\\\n";
	    print TEX "{\\Large\\sf $curhouse} & & & & & & & & \\\\ \\hline\n";
	}

	print TEX  "\\textbf{$arr[1]}, $arr[2] ($arr[6])& & & & & & & & \\\\ \\hline\n";

    } else {  # We are starting a new house (on new page)

	if ($i != 1) {
	    print TEX "\n\\end{tabular}\\\\ \n\\medskip\n\n\\textbf{\\large ";
	    print TEX $lex{Students}. ": $studcount}\n\\newpage\n";
	}
	$studcount = 1;
	$linecount = 0;

	print TEX "\n{\\large ". $lex{'House League Report'}. "}\\\\\n";
	print TEX "\\begin{tabular}{|p{62mm}|p{16mm}|p{10mm}|p{10mm}|p{10mm}|";
	print TEX "p{10mm}|p{10mm}|p{10mm}|p{10mm}|}";
	print TEX "{\\small $currdate} & & & & & & & & \\\\  & & & & & & & & \\\\ \n";
	print TEX "{\\Large\\sf $curhouse} & & & & & & & & \\\\ \\hline\n";
	print TEX "\\textbf{$arr[1]}, $arr[2] ($arr[6])& &  &  &  &  &  & & \\\\ \\hline\n";
    }    
    
}  # End of For loop for printing student names


# Print ending of report
print TEX "\n\\end{tabular}\n\\medskip\n\n";
print TEX " \\textbf{\\large ". $lex{Students}. ": $studcount}\\\\ \n \\end{document}\n";
close TEX;

system("$pdflatex $filename >pdflog$$.txt");
system("mv $shortname.pdf $downloaddir");
system("mv pdflog$$.txt $downloaddir");
system("rm -f $shortname.*");

print "<center><h1><a href=\"$webdownloaddir/$shortname.pdf\">\n";
print $lex{'View/Download'}. ' '. $lex{'House League Report'}. "</a></h1>\n";
print "<p>[ <a href=\"$webdownloaddir/pdflog$$.txt\">". $lex{'View Log File'};
print  "</a>\n | <a href=\"$homepage\">". $lex{Main}. "</a> ]</p>\n";
print "</center></body></html>\n";
