#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my $self = 'rptphone.pl';

my %lex = ('Student Phone List' => 'Student Phone List',
	   'Main' => 'Main',
	   'Name' => 'Name',
	   'HRoom' => 'HRoom',
	   'Grade' => 'Grade',
	   'Parent 1' => 'Parent 1',
	   'Parent 2' => 'Parent 2',
	   'Emergency' => 'Emergency',
	   'Homeroom' => 'Homeroom',
	   'Sort by' => 'Sort by',
	   'Lastname' => 'Lastname',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
    $iddst) = localtime(time);
$year = $year + 1900;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


my $sortorder = "lastname, firstname";
my $mode = 'lastname';
if ($arr{sortorder} eq $lex{Homeroom}) {
    $sortorder = "homeroom, lastname, firstname";
    $mode = 'homeroom';
} elsif ($arr{sortorder} eq $lex{Grade}) {
    $sortorder = "grade, lastname, firstname";
    $mode = 'grade';
}

my $select;
if ($arr{group}) {
    if ($mode eq 'grade') {
	$select = "where grade = '$arr{group}'";
    } elsif ($mode eq 'homeroom') {
	$select = "where homeroom = '$arr{group}'";
    }
}


my $sth = $dbh->prepare("select * from student $select order by $sortorder");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }


print "$doctype\n<html><head><title>". $lex{'Student Phone List'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

# Selection Form.
print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"submit\" value=\"". $lex{'Sort by'}. "\">\n";
print "<select name=\"sortorder\">";
if ($arr{sortorder}) { print "<option>$arr{sortorder}</option>\n"; }
print "<option>". $lex{Lastname}. "</option>\n";
print "<option>". $lex{Grade}. "</option>\n";
print "<option>". $lex{Homeroom}. "</option>\n";
print "</select>&nbsp;". $lex{Homeroom}. '/'. $lex{Grade};
print " <input type=\"text\" name=\"group\" size=\"6\" value=\"$arr{group}\">";
print "</form>\n";


print "<center><h1>". $lex{'Student Phone List'}. "</h1><h4>$currdate</h4>\n";


my $curroom = -1;
my $currgrade = -1;
my $first = 1;

#print "Mode: $mode<br>\n";

while ( my @arr = $sth->fetchrow ) {
    
    $oldroom = $curroom;
    $curroom = $arr[6];
    $oldgrade = $currgrade;
    $currgrade = $arr[5];


    if ( ($curroom ne $oldroom and $mode eq 'homeroom') or 
	 ($currgrade ne $oldgrade and $mode eq 'grade') or
	 ($first and $mode eq 'lastname') ){

	if (not $first) { print "</table>\n"; } else { $first = 0; } 

	print "<p style=\"font-size:150%;font-weight:bold;\">";
	if ($mode eq 'grade') {
	    print $lex{Grade}. " $currgrade</p>\n";
	} elsif ($mode eq 'homeroom') {
	    print $lex{Homeroom}. " $curroom</p>\n";
	}

	print "<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">";
	print '<tr><th>'. $lex{Name}. ' / '. $lex{HRoom}. ' - '. $lex{Grade};
	print '</th><th>'. $lex{'Parent 1'}. '</th><th>'. $lex{'Parent 2'};
	print '</th><th>'. $lex{Emergency}. "</th></tr>\n";

    }

    print "<tr><td><b><a href=\"studed.pl?recnum=$arr[0]\">$arr[1]</a></b>, $arr[2] $arr[3] ($arr[4])<br>\n";
    print "<b>Hr:</b>$arr[6]<br><b>Gr:</b>$arr[5]</td>\n";

    print "<td><b>Rel:</b> $arr[27]<br>$arr[29]<br>H: $arr[30]<br>W: $arr[31]<br>C:$arr[32]</td>\n";
    print "<td><b>Rel:</b> $arr[38]<br>$arr[40]<br>H: $arr[41]<br>W: $arr[42]<br>C:$arr[43]</td>\n";
    print "<td><b>Rel:</b> $arr[49]<br>$arr[50]<br>H: $arr[51]<br>W: $arr[52]<br>C:$arr[53]</td></tr>\n";
  
}

print "</table></center></body></html>\n";
