#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Birthdate' => 'Birthdate',
	   'Student Religion' => 'Student Religion',
	   'Name' => 'Name',
	   'HRoom' => 'HRoom',
	   'Religion' => 'Religion',
	   'Baptism' => 'Baptism',
	   'Commun' => 'Commun',
	   'Recon' => 'Recon',
	   'Confirm' => 'Confirm',
	   'Error' => 'Error',
	   'Main' => 'Main',
	   'Select by' => 'Select by',
	   'Homeroom' => 'Homeroom',
	   'Grade' => 'Grade',

	   );

my $self = 'rptreligion.pl';


use DBI;
use CGI;
use Cwd;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Set Date
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
    $iddst) = localtime(time);
$year = $year + 1900;
$mon++; $wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

# Get current dir so know what CSS to display;
if ( getcwd() =~ /tcgi/ ){ # we are in tcgi
    $css = $tchcss;
    $homepage = $tchpage;
}

print "$doctype\n<html><head><title>". $lex{'Student Religion'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"submit\" value=\"". $lex{'Select by'}. "\">\n";
print "<select name=\"group\">";
if ( $arr{group} ) { print "<option>$arr{group}</option>\n"; }
if ( $arr{group} ne $lex{Homeroom} ) { print "<option>". $lex{Homeroom}. "</option>\n";}
if ( $arr{group} ne $lex{Grade} ) { print "<option>". $lex{Grade}. "</option>\n";}
print "</select>\n";
print "<input type=\"text\" name=\"groupid\" size=\"6\" value=\"$arr{groupid}\"></form>\n";


my $select;
if ( $arr{groupid}) {
    my $groupid = $dbh->quote( $arr{groupid} );
    if ( $arr{group} eq $lex{Homeroom} ) {
	$select = "where homeroom = $groupid ";
    } else {
	$select = "where grade = $groupid ";
    }
}

# No inputs for this, yet.
my $sortorder = "lastname, firstname";
if ( $arr{sortorder} eq $lex{Birthdate} ) {
    $sortorder = "birthdate";
} 

my $fieldlist = "lastname, firstname, initial, homeroom, ".
"studrel, baptism, commun, recon, confirm";

$sth = $dbh->prepare("select $fieldlist from student $select 
 order by $sortorder");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}


print "<center><h1>". $lex{'Student Religion'}. "</h1><h3>$currdate</h3>\n";
print "<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";

print "<tr><th>". $lex{Name}. "</th><th>". $lex{HRoom}. "</th><th>". $lex{Religion};
print "</th><th>". $lex{Baptism}. "</th><th>". $lex{Commun}. "</th><th>". $lex{Recon};
print "</th><th>". $lex{Confirm}. "</th></tr>\n";

while ( my ($lastname, $firstname, $initial, $homeroom, $studrel, $baptism, 
 $commun, $recon, $confirm) = $sth->fetchrow ) {
    
    print "<tr><td><b>$lastname</b>, $firstname $initial</td>";
    print "<td>$homeroom</td><td>$studrel</td>\n";
    print "<td>$baptism</td><td>$commun</td><td>$recon</td><td>$confirm</td></tr>\n";

}

print "</table></center></body></html>\n";
