#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Note: These are the grades we currently report on. Change to suit....
my @grades = qw(2 ); # The grades to report on....

my %lex = ('Student Religion' => 'Student Religion',
	   'Parish' => 'Parish',
	   'Name' => 'Name',
	   'Grade' => 'Grade',
	   'Parent 1' => 'Parent 1',
	   'Parent 2' => 'Parent 2',
	   'Phone' => 'Phone',
	   'Student Sacramental Preparation' => 'Student Sacramental Preparation',
	   'Main' => 'Main',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;


eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset => $charset );
my %arr = $q->Vars;


my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Find the grades that we are selecting for... normally 2 and 7.
my $first = 1;
my $select = 'where ';
foreach my $gr (@grades) {
    if (not $first) { $select .= ' or '; } else { $first = 0; }
    $select .= "grade = $gr ";
}

my $sortorder = "parish desc, lastname, firstname";

$sth = $dbh->prepare("select 
  parish,lastname,firstname, initial, grade, name1, name2, hphone1 
  from student $select order by $sortorder");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

print "$doctype\n<html><head><title>". $lex{'Student Religion'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";
print '<center><h1>'. $lex{'Student Sacramental Preparation'}. "</h1>\n<h3>$currdate</h3>\n";
print "<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";
print '<tr><th>'. $lex{Parish}. '</th><th>'. $lex{Name}. '</th><th>'. $lex{Grade};
print "</th>\n<th>". $lex{'Parent 1'}. '</th><th>'. $lex{'Parent 2'}. '</th><th>';
print $lex{Phone}. "</th></tr>\n";


while ( my ( $parish,$lastname,$firstname,$initial,$grade,$parent1,$parent2,$phone ) = 	
	$sth->fetchrow ) {
    print "<tr><td>$parish</td><td><b>$lastname,</b> $firstname $initial</td>\n";
    print "<td> $grade</td><td> $parent1</td><td> $parent2</td><td> $phone</td></tr>\n";
}

print "</table></center></body></html>\n";
