#! /usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('Main' => 'Main',
	   'View/Download' => 'View/Download',
	   'Short Student Roster' => 'Short Student Roster',
	   'View Log File' => 'View Log File',
	   'Student Roster' => 'Student Roster',
	   'Name' => 'Name',
	   'Address' => 'Address',
	   'Ph' => 'Ph',
	   'Parent 1' => 'Parent 1',
	   'Parent 2' => 'Parent 2',
	   'Emergency' => 'Emergency',
	   'Page' => 'Page',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %student = $q->Vars;

my $maxlines = 16;
if ($student{maxstudents}) {
    $maxlines = $student{maxstudents};
    delete $student{maxstudents};
}

foreach $key (keys %student) {
    #print "K:$key V:$student{$key}<br>\n";
    if ($student{$key}) {
	push @studlist, $key;
    }
}
@sortedstud = sort {$b cmp $a} @studlist;


# Basic Constants
my $logfile = "pdflog$$.txt";
my $shortname = "shorost$$";
my $filename = "$shortname.tex";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head><title>". $lex{'Short Student Roster'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

unless ( open(TEX,">$filename") ) {
    print "Can't open tex file";
    die "Can't open tex file";
}

my $papersize;
if ( $defaultpapersize ) {
    $papersize = $defaultpapersize;
} else {
    $papersize = 'letterpaper';
}


print TEX "\\documentclass[11pt,$papersize]{article}
\\usepackage{newcent,colortbl,inputenc}
\\inputencoding{latin1}
\\renewcommand{\\familydefault}{\\sfdefault}
\\pagestyle{empty}
\\setlength{\\textwidth}{8in}
\\setlength{\\textheight}{10.6in}
\\setlength{\\hoffset}{-1.4in}
\\setlength{\\voffset}{-1.4in}
\\setlength{\\parindent}{0pt}
\\setlength{\\tabcolsep}{3.5pt}\n";

print TEX "\\begin{document}\n";

$studentcount = 30 ;  # Special Number to trigger nonprinting first page stuff
$page = 0;

foreach my $student ( @sortedstud ) {    #loop and print each student
    my ($dud,$key) = split /:/,$student;

    $sth = $dbh->prepare("select * from student where studid = '$key' ");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die;}
    @arr = $sth->fetchrow;

    foreach $element (@arr) {
	$element =~ s/#/\\#/g;
	$element =~ s/&/\\&/g; 
    }
   
    $studentcount++;
  
    if ($studentcount >= $maxlines) { # We'll print a new page header here
	# New Page Header
	
	if ($studentcount != 31) {
	    print TEX "\\end{tabular}\\\\ \\newpage\n";
	}
	$studentcount = 0;
	$page++;
	
	print TEX "\\center{{\\bf $schoolname ". $lex{'Student Roster'}. "} - $currdate}\\hfil ";
	print TEX $lex{Page}. " $page\\\\ \n";
	print TEX "\\medskip\n\n\\begin{tabular}{|p{4.5cm}|p{4.5cm}|p{3.5cm}|p{3.5cm}|p{3.5cm}|}";

	print TEX "\\hline\n\\rowcolor[gray]{0.90}{\\bf ". $lex{Name}. "} & {\\bf ";
	print TEX $lex{Address}. '/'. $lex{Ph};
	print TEX "} & {\\bf ". $lex{'Parent 1'}. "}";
	print TEX "& {\\bf ". $lex{'Parent 2'}. "} &{\\bf ". $lex{Emergency}. "} \\\\ \\hline\n";
	
    }
    

    print TEX "{\\bf $arr[1]}, $arr[2] $arr[3] & $arr[34] & $arr[29] & $arr[40] & $arr[50] \\\\";
    # Name & Address1 & Name1 & Name2 & EmName

    print TEX "($arr[4]) Rm: $arr[6]  & Ph: $arr[30] & $arr[31] $arr[32] &";
    # (studnum) homeroom & hphone1 & wphone1 cellphone1

    print TEX "$arr[42] $arr[43] & $arr[51] $arr[52] $arr[53]\\\\\n\n\\hline\n";
    # workplace2 wphone2 & emhphone emwphone emcell

}  # End of While loop

print TEX "\\end{tabular}\n\n\\end{document}";
close TEX;

system("$pdflatex $filename >$logfile");
system("mv $shortname.pdf $downloaddir");
system("mv $logfile $downloaddir");
system("rm $shortname.*");

# print rest of html page
print "<center><h1><a href=\"$webdownloaddir/$shortname.pdf\">";
print $lex{'View/Download'}. ' '. $lex{'Short Student Roster'}. "</a></h1>
[ <a href=\"$homepage\">". $lex{Main}. "</a> |
<a href=\"$webdownloaddir/$logfile\">". $lex{'View Log File'}. "</a> ]\n";

print "</center></body></html>\n";
