#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = (
	   'Enrollment by Age' => 'Enrollment by Age',
	   'Main' => 'Main',
	   'Printing Date' => 'Printing Date',
	   'Date format Error' => 'Date format Error',
	   'Go Back' => 'Go Back',
	   'Age Group' => 'Age Group',
	   'Boys' => 'Boys',
	   'Girls' => 'Girls',
	   'Total' => 'Total',
	   'At Date' => 'At Date',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
 $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
%arr = $q->Vars;

print "$doctype\n<html><head><title>". $lex{'Enrollment by Age'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

my ($date,$yr,$mo,$da);
if ( not $arr{date} ) {
    $yr = $year;
    $mo = $mon + 1;
    $da = $mday;
} else {
    $date = $arr{date};
    ( $yr, $mo, $da ) = split /-/, $date;
}

if ($yr == 0 or $mo == 0 or $da == 0) {
    print '<center><h1>'. $lex{'Date format Error'}. ". (yymmdd)\n";
    print "</h1><form><input type=\"button\" onclick=\"javascript:history.back()\" value=\"";
    print $lex{'Go Back'}. "!\">";
    print "</form></body></html>\n"; 
    die; 
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

$sth = $dbh->prepare("select sex, birthdate from student order by birthdate");
$sth->execute;


print '<center><h1>'. $lex{'Enrollment by Age'}. "</h1>
 <p><b>". $lex{'Printing Date'}. ":</b> $currdate</p>
 <caption><b>". $lex{'At Date'}. ": $yr-$mo-$da</b></caption>\n";

my %ages;
while ( my ($sex,$birthdate) = $sth->fetchrow ) {
    my $age;
    if (not $birthdate or $birthdate eq '0000-00-00'){ next; }
    ($curryear, $currmonth,$currday) = split /-/,$birthdate;
    $age = $yr - $curryear;  #first subtract years  
    if ($currmonth > $mo) { $age-- }
    if ($currmonth == $mo and $currday > $da) { $age-- } 
    
    $student = "$age$sex:$age:$sex";
    push @rec, $student;  #push data into array
}

print "</table><table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n";
print '<tr><th>'. $lex{'Age Group'}. '</th><th>'. $lex{Boys}. '</th><th>';
print $lex{Girls}. '</th><th>'. $lex{Total}. "</th></tr>\n";

$curage = 0;
$cursex = "";
$boycount = 0;
$girlcount = 0;

@sortedrec = sort @rec;
for $arrayref (@sortedrec) {
    ($blank,$age,$sex) = split /:/, $arrayref;
    if ($age != $curage and $curage != 0) { # we have a new agegroup
	$total = $boycount + $girlcount;
	print "<tr><td>$curage</td><td>$boycount</td>";
	print "<td>$girlcount</td><td>$total</td><tr>\n"; 
	$boycount = 0;
	$girlcount = 0;
    }
   
    $curage = $age;
    if ($sex eq "M") {
	$boycount ++;
    } else {
	$girlcount ++;
    }  
}

$total = $boycount + $girlcount;

print "<tr><td>$curage</td><td>$boycount</td>";
print "<td>$girlcount</td><td>$total</td><tr>\n";
print "</table></center></body></html>\n";
