#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Enrollment Summary' => 'Enrollment Summary',
	   'Main' => 'Main',
	   'Room' => 'Room',
	   'Teacher' => 'Teacher',
	   'Grade' => 'Grade',
	   'Male' => 'Male',
	   'Female' => 'Female',
	   'Young' => 'Young',
	   'HRm' => 'HRm',
	   'Total' => 'Total',
	   'Gr' => 'Gr',
	   'Totals' => 'Totals',
	   'Error' => 'Error',

	   );



use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
 $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select * from student 
  order by grade, homeroom, lastname,firstname");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'Enrollment Summary'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";
print "<center><h1>$schoolname ". $lex{'Enrollment Summary'}. "</h1>
 <h4>$currdate</h4>\n";

print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print '<tr><th>'. $lex{Room}. ' - ', $lex{Teacher}. '</th><th>';

print $lex{Grade}. '</th><th>'. $lex{Male}. '</th><th>'. $lex{Female}. '</th><th>';
print $lex{Young}. '</th><th>'. $lex{HRm}. ' ', $lex{Total}. '</th><th>'. $lex{Gr}. ' '. $lex{Total}. "</th></tr>\n";

my $youngest = 0;
my $youngtot = 0;

my $boytotal = 0;
my $girltotal = 0;
my $boycount = 0;
my $girlcount = 0;
my $boygrade = 0;
my $girlgrade = 0;

my $curroom = -1; $currgrade = -1;

for ($i=1; $i <= $rows; ++$i) {
    my @arr = $sth->fetchrow;
   
    $oldroom = $curroom;
    $oldgrade = $currgrade;
    $curroom = $arr[6];
    $currgrade = $arr[5];

    if (($oldroom ne $curroom and $i != 1) or
	($oldroom eq $curroom and $oldgrade ne $currgrade and $i != 1)) { 
        # we have a new room (or same room but different grade)
	$hrtotal = $boycount + $girlcount;

	my ($sal, $firstname, $lastname);
	if ($oldroom){  # If oldroom present, find it's teacher.
	    $sth1 = $dbh->prepare("select sal, firstname, lastname from staff 
              where homeroom = '$oldroom'");
	    $sth1->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    ($sal, $firstname, $lastname) = $sth1->fetchrow;
	}

	# Print out teacher name, totals for this room and then reset the variables.
	print "<tr><td>$oldroom - $sal $firstname $lastname</td><td>$oldgrade</td><td>$boycount</td>\n";
	print "<td>$girlcount</td><td><i>$youngest</i></td> <td>$hrtotal</td><td></td></tr>\n";

	$girlcount = 0;
	$boycount = 0;
	$youngest = 0;
    }
    
    if ($oldgrade ne $currgrade and $i != 1) { # we have a new grade also
	$grtotal = $boygrade + $girlgrade;
	print "<tr class=\"gray\"><td></td><td>$oldgrade</td>
         <td><b>$boygrade</b></td><td><b>$girlgrade</b></td><td></td><td></td>
         <td><b>$grtotal</b></td></tr>\n";

	$girlgrade = 0;
	$boygrade = 0;
    }

    if ("\U$arr[7]" eq "F") {
	$girlcount++;
	$girltotal++;
	$girlgrade++;
    } else {
	$boycount++;
	$boytotal++;
	$boygrade++;
    }
    if ("\U$arr[15]" eq "Y") {
	$youngest++;
	$youngtot++;
    }

} # End of Main Loop

$total = $boycount + $girlcount;

if ($curroom){
    $sth1 = $dbh->prepare("select sal, firstname, lastname from staff
       where homeroom = '$curroom'");
    $sth1->execute;
    if ($DBI::errstr){print $DBI::errstr; die;}
    my ($sal, $firstname, $lastname) = $sth1->fetchrow;

    print "<tr><td>$curroom  $sal $firstname $lastname</td>
    <td>$currgrade</td><td>$boycount</td>
    <td>$girlcount</td><td><i>$youngest</i></td><td>$total</td></tr>\n";
}

$grtotal = $boygrade + $girlgrade;

print "<tr class=\"gray\"><td></td><td>$currgrade</td><td><b>$boygrade</b></td>
 <td><b>$girlgrade</b></td><td></td><td></td><td><b>$grtotal</b></td>
 </tr>\n";

print "<tr class=\"blue\"><td colspan=2><b>". $lex{Totals};
print "</b></td><td><b>$boytotal</b></td><td><b>$girltotal</b></td>\n";
print "<td><b><i>$youngtot</i></b></td><td></td><td><b>$rows</b></td></tr>\n";
print "</table></center></body></html>\n";
