#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View Ethnic Categories' => 'View Ethnic Categories',
	   'Ethnicity Report' => 'Ethnicity Report',
	   'Main' => 'Main',
	   'Ethnic Category' => 'Ethnic Category',
	   'Percent' => 'Percent',
	   'Count' => 'Count',
	   'No Data' => 'No Data',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;
use Number::Format qw(round);

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

print "$doctype\n<html><head><title>". $lex{'View Ethnic Categories'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n"; 

print "<center><h1>$schoolname ". $lex{'Ethnicity Report'}. "</h1><p><b>$currdate</b></p>\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# First get total student count for school
$sth = $dbh->prepare("select count(ethnic) from student");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my $total = $sth->fetchrow;

print "<b>Students: $total</b>\n";

# First Count Ethnic Categories and stuff into ethnic hash.
my %ethnic;
# Note: don't use distinct since it removes NULL's.
my $sth1 = $dbh->prepare("select ethnic, count(*) from student 
  group by ethnic order by ethnic");
$sth1->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while ( my  ($ethnic, $count) = $sth1->fetchrow) {
    if (not $ethnic) { $ethnic = $lex{'No Data'}; }
    $ethnic{$ethnic} = $count; 
}


# Print Ethnic Category Table
print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";
print '<tr><th>'. $lex{'Ethnic Category'}. '</th><th>'. $lex{Count};
print '</th><th>'. $lex{Percent}. "</th></tr>\n";

foreach my $key (keys %ethnic) {
    my $percent = ($ethnic{$key}/$total) * 100;
    print "<tr><td>$key</td><td>$ethnic{$key}</td><td align=\"right\">";
    print round( $percent, 2 );
    print "%</td></tr>\n";
}

print "</table></center></body></html>\n";
