#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View Religion Categories' => 'View Religion Categories',
	   'Main' => 'Main',
	   'Religion by Grade Report' => 'Religion by Grade Report',
	   'Catholic' => 'Catholic',
	   'Non Catholic' => 'Non Catholic',
	   'Total' => 'Total',
	   'Religion' => 'Religion',
	   'Count' => 'Count',
	   'Percent Catholic' => 'Percent Catholic',
	   'Error' => 'Error',

	   );

# Catholic value above is what is searched for in religion fields for counting purposes.
# Note: @g_religion holds the religion values in admin.conf.

use DBI;
use CGI;
use Number::Format qw(round);

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $cathcount = 0;
my $noncathcount = 0;

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

print "$doctype\n<html><head><title>". $lex{'View Religion Categories'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

print "<center><h1 class=\"large\">". $lex{'Religion by Grade Report'}. "</h1>
[ <a href=\"#total\">Totals</a> ]\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select distinct grade from student 
  where grade != '' order by grade");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
while ( my $gr = $sth->fetchrow){
    push @grades,$gr;
}


$sth = $dbh->prepare("select count(studrel) from student");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
my $total = $sth->fetchrow;

  my $sth1 = $dbh->prepare("select student.studrel, count(studrel) from student 
    where grade = ? group by studrel");

foreach $grade ( @grades ) {

    $sth1->execute( $grade );
    $rows1 = $sth1->rows;

    my %rel;
    for (1..$rows1) {
	@arr = $sth1->fetchrow;
	$rel{$arr[0]} = $arr[1]; 
    }

    print "<h1>Grade $grade</h1><table border=\"1\" cellspacing=\"0\" cellpadding=\"4\">\n";
    print '<tr><th>'. $lex{Religion}. '</th><th>'. $lex{Count}. "</th></tr>\n";

    my $count;
    foreach my $key (keys %rel) {
	print "<tr><td>$key</td><td>$rel{$key}</td></tr>\n";
	$count += $rel{$key};

	if ( $key =~ m/$lex{Catholic}/) {
	    $cathcount += $rel{$key}; 
	} else { 
	    $noncathcount += $rel{$key};
	} 
    }

    print '<tr><td><b>'. $lex{Total}. "</b></td><td>$count</td></tr>\n";
    print "</table><p></p>\n";

}

$percent = $cathcount/$total * 100;

print "<h1>Totals</h1><a name=\"total\"></a>
<table border=\"1\" cellspacing=\"0\" cellpadding=\"4\">\n";

print '<tr><th>'. $lex{Religion}. '</th><th>'. $lex{Count}. "</th></tr>\n";

print "<tr><td align=\"right\">". $lex{Catholic}. "</td><td>$cathcount</td></tr>
<tr><td align=\"right\">". $lex{'Non Catholic'}. "</td><td>$noncathcount</td></tr>
<tr><td align=\"right\">Total</td><td>$total</td></tr>
<tr><td align=\"right\">". $lex{'Percent Catholic'}. "</td><td>";

print round( $percent, 2 );
print "%</td></tr></table></center></body></html>\n";
