#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Youngest in Family' => 'Youngest in Family',
	   'Main' => 'Main',
	   'Name' => 'Name',
	   'Parent 1' => 'Parent 1',
	   'Parent 2' => 'Parent 2',
	   'Lastname, Firstname' => 'Lastname, Firstname',
	   'Homeroom, Lastname, Firstname' => 'Homeroom, Lastname, Firstname',
	   'Grade, Lastname, Firstname' => 'Grade, Lastname, Firstname',
	   'Sort by' => 'Sort by',
	   'Select' => 'Select',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Error' => 'Error',

	   );

my $self = 'rptyoungest.pl';

use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
    $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


my $sortorder = "homeroom, lastname, firstname";
if ( $arr{sortorder} ) {
    $sortorder = $arr{sortorder};
    delete $arr{sortorder};
}

my $select;
if ( $arr{group} or $arr{homeroom} ) {
    if ( $arr{select} eq $lex{Grade} ) { # Find this grade;
	my $grp = $dbh->quote( $arr{group} );
	$select = "and grade = $grp";
    } elsif ( $arr{select} eq $lex{Homeroom} ) {
	my $grp = $dbh->quote( $arr{group} );
	$select = "and homeroom = $grp";
    } else { # must be old homeroom...
	my $homeroom = $dbh->quote($arr{homeroom});
	$select = "and homeroom = $homeroom";
    }
}


# Select Data
my $sth = $dbh->prepare("select lastname, firstname, initial, homeroom, grade, youngest, 
  relation1, name1, hphone1, wphone1, relation2, name2, hphone2, wphone2 from student 
  where youngest = 'y' $select order by $sortorder");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Youngest in Family'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "<div style=\"display:inline;\">";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";
print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"submit\" value=\"". $lex{'Sort by'}. "\">\n";
print "<select name=\"sortorder\"><option>". $lex{'Lastname, Firstname'}. "</option>\n";
print "<option>". $lex{'Homeroom, Lastname, Firstname'}. "</option>\n";
print "<option>". $lex{'Grade, Lastname, Firstname'}. "</option>\n";
print "</select>\n";

print "<input type=\"submit\" value=\"". $lex{Select}. "\">\n";
print "<select name=\"select\"><option>". $lex{Grade}. "</option>\n";
print "<option>". $lex{Homeroom}. "</option>\n";
print "</select>\n";
print "<input type=\"text\" name=\"group\" size=\"6\">\n";

print "</form></div>\n";


print '<center><h1>'. $lex{'Youngest in Family'}. "</h1><h4>$schoolname - $currdate</h4>\n";

my $curroom = -1;
my $first = 1;

while (my ($lastname, $firstname, $middlename, $homeroom, $grade, $youngest, 
  $relation1, $parent1, $hphone1, $wphone1, $relation2, $parent2, $hphone2, $wphone2) = $sth->fetchrow) {

    $oldroom = $curroom;
    $curroom = $hroom;
  
    if ($curroom ne $oldroom) {
	if (not $first) { print "</table><p></p>\n"; } else { $first = 0; }
	print "<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";
	print '<tr><th>'. $lex{Name}. '</th><th>'. $lex{'Parent 1'}. '</th><th>'. $lex{'Parent 2'}. "</th></tr>\n";
    } 

    print "<tr><td><b>$lastname</b>, $firstname $middlename<br><b>Gr:</b> $grade<br><b>Hr:</b> $homeroom</td>\n";
    print "<td><b>Rel:</b> $relation1<br>$parent1<br>H:$hphone1<br>W:$wphone1</td>\n";
    print "<td><b>Rel:</b> $relation2<br>$parent2<br>H:$hphone2<br>W:$wphone2</td></tr>\n";
  
}

print "</table></center></body></html>\n";
