#!/usr/bin/perl
#  Copyright 2001-2005 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#  Open Admin for Schools is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

use DBI;
use CGI;

require "../../etc/admin.conf" or die "checkpn.pl: Cannot open admin.conf!";

$q = new CGI;

# Http Header to return
print $q->header; 

%arr = $q->Vars;

$dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

print "$doctype\n<html><head>
<title>Check Provincial Student Number Parity</title>
<link rel=\"stylesheet\" type=\"text/css\" href=\"$css\">
$chartype\n</head><body><a name=\"top\"></a>[ <a href=\"$homepage\">Main</a> | 
<a href=\"$exppage\">Export</a> ]
<center><h1>Check Provincial Student Number Parity</h1>
<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">
<tr><th>Error</th><th>Student</th></tr>\n";


$sth = $dbh->prepare("select * from student order by lastname, firstname");
$sth->execute;
if ($DBI::errstr){print "$DBI::errstr \n"; die "DBI::errstr";}

$errflag = 0;

while (@student = $sth->fetchrow){
    if ($student[57]) { # They have a prov number  
	$temppn = $student[57];
	$tempcd = chomp($temppn);  
	$checkdigit = checkpn($temppn);
	$pnerr = "";
	if ($checkdigit != $tempcd ) {
         print "<tr><td><b><font color=\"red\">Parity Error</font></b></td>";
	 print "<td><a href=\"$cgiurl/studed.pl?recnum=$student[0]\">";
	 print "<i>$student[1]</i>, $student[2] $student[3]</a>";
	 print "($student[4])/$student[8]) - Prov #: $temppn</td>";
         print "</tr>\n";
	 $errflag = 1;
	}  
    } else {
	print "<tr><td><b>No Provincial Number</b></td>";
	print "<td><a href=\"$cgiurl/studed.pl?recnum=$student[0]\">";
        print "<i>$student[1]</i>, $student[2] $student[3]</a>\n";
	print "($student[4]/$student[8])</td></tr>\n";
	$errflag = 1;
    }
} # end of reading loop

print "</table>\n";
if ($errflag){
    print "<p><b>Please recheck/enter the provincial student numbers for those 
      students listed above!</b></p>\n\n";
} else {
    print "<p>All provincial student numbers have passed a 
     parity check!</p>\n";
}
print "<p>[ <a href=\"#top\">Top</a> ]</p></body></html>\n";


sub checkpn {
    my @pn = split(//,$_[0]);
    for ($i=1; $i<=8; $i += 2) {
	$pn[$i] *= 2;
	if ($pn[$i] > 9) {
	    my @tmp = split(//,$pn[$i]);
	    $pn[$i] = $tmp[0] + $tmp[1];
        }
    }
    
    my $tempnum = 0;
    foreach my $pnum (@pn) {
	$tempnum += $pnum;
    }
    @pn = split(//,$tempnum);   
    $retval= pop(@pn);
    $retval = 9 - $retval;
    return $retval;
}

