#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#  Input: Logname in 'log' var and records in 'rec' var.
#   Assume that that two log files are error.log and update.log

# Change to suit
my $minrecords = 5;
my $maxrecords = 100;
my ($filename, $sname);

use DBI;
use CGI;
use Fcntl qw(:DEFAULT :flock);

my @month = ("January","February","March","April","May","June",
	  "July","August","September","October","November","December");
my @dow = ("Sunday","Monday","Tuesday","Wednesday","Thursday",
	"Friday","Saturday");
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

$q = new CGI;
print $q->header;
%arr = $q->Vars;

if ($arr{log} eq 'Error'){
    $sname = 'error';
    $filename = "error.log";
} elsif ($arr{log} eq 'Update'){
    $sname = 'update';
    $filename = "update.log";
} else {
    print "Logfile name not found!";
    die;
}

my $records = $arr{rec};
if ($records < $minrecords){ $records = $minrecords;}
if ($records > $maxrecords){ $records = $maxrecords;}
my $tempfile = "tempfile$$";

# Read config variables
require "../../etc/admin.conf" || die "Cannot read admin.conf!";

print "$doctype\n<html><head><title>Logfile Truncation</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>
[ <a href=\"$homepage\">Main</a> | <a href=\"$exppage\">Export</a> ]\n";

# Do the file manipulations
sysopen (LOG, $filename, O_RDWR | O_CREAT) or 
  die "Cannot sysopen $filename: $!";
flock(LOG,LOCK_EX);
open (TMP,">$tempfile") or die "Cannot open $tempfile: $!\n";
@lines = <LOG>;
$start = $#lines - $records + 1;
if ($start < 0){ $start = 0;}
for ($start..$#lines){ print TMP $lines[$_];}
close TMP or die "Cannot close $tempfile: $!\n";
close LOG or die "Cannot close $filename: $!\n";
rename($filename, "$sname.bak") or 
  die "Cannot rename $filename to $sname.bak: $!\n";
rename($tempfile, $filename) or
  die "Cannot rename $tempfile to $filename: $!\n";

print "<h1>\u$sname Log shortened to $records entries</h1></body></html>\n";
