#!/usr/bin/perl
#  Copyright 2001-2005 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#  Open Admin for Schools is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#  Input: Logname in 'log' var and record viewing order in 'order'
#   Assume that that two log files are error.log and update.log
#   Assume that 'order' is either 'Forward' or 'Reverse' 
#     (really just Reverse and anything else...)

my ($filename, $order, );

use CGI;

my @month = ("January","February","March","April","May","June",
	     "July","August","September","October","November","December");
my @dow = ("Sunday","Monday","Tuesday","Wednesday","Thursday",
	   "Friday","Saturday");
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
$currdate = "$dow[$wday], $month[$mon] $mday, $year";

$q = new CGI;

# Just so I don't forget what is really sent...
print $q->header;

%arr = $q->Vars;

$order = $arr{order};
if ($arr{log} eq 'Error'){
    $filename = "error.log";
} elsif ($arr{log} eq 'Update'){
    $filename = "update.log";
} else {
    print "Logfile name not found!\n";
    die "Logfile name not found\n";
}

# Read config variables
require "../../etc/admin.conf" || die "Cannot read admin.conf!";

print "$doctype\n<html><head><title>View Logfile</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>
[ <a href=\"$homepage\">Main</a> | <a href=\"$exppage\">Export</a> ]
$currdate \n";

open (LOG,"<$filename") or die "Cannot open $filename: $!\n";
@lines = <LOG>;
if ($order eq 'Reverse'){@lines = reverse @lines;};

print "<h1>\U$filename</h1>\n";
print "<b>Order:</b> $order<br>\n";
foreach my $line (@lines){
  print "$line<br>\n";
}

print "</body></html>\n";
