#! /usr/bin/perl
#  Copyright 2001-2006 Leslie Richardson

#  This file is part of Open Admin for Schools.

# This script will update SL with student class marks.
  

use DBI;
use CGI;
use XML::Writer;
use XML::Writer::String;
use Data::UUID;
use IO;
use HTTP::Request::Common qw(POST); 
use HTTP::Headers; 
use LWP::UserAgent; 
use XML::LibXML;
use Number::Format qw(round);

my $self = 'studmark2.pl';

# Read config variables
require "../../etc/admin.conf" || die "Cannot read admin.conf: $!";
#require "sklrn.conf" || die "Cannot read sklrn.conf: $!";
eval(require "slxmllib.pl");
if ($@) {
    print "Problem reading slxmllib.pl! $@<br>\n";
    die "Problem reading slxmllib.pl. $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;
print $q->header;


print "$doctype\n<html><head><title>SDS Mark Submission</title> 
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">Main</a> | 
<a href=\"$exppage\">Export</a> ]<h1>SDS Mark Submission</h1>\n";


my ($debug);
if ($arr{debug}){
    $debug = $arr{debug};
    delete $arr{debug};

    if (not $arr{flag}) { # Show the options for debug data errors.
	showDebug();
	die;
    } else { # Set the data error options
	$maxfilesize = $arr{xmlsize}; # override values in config
	delete $arr{xmlsize};
	delete $arr{flag};
	$recddata = $arr{recddata};
	delete $arr{recddata};
	$sentdata = $arr{sentdata};
	delete $arr{sentdata};
    }

}


#foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }


my @tim = localtime(time);
my $year = $tim[5] + 1900;
$tim[4]++;
for (0..4){if (length($tim[$_]) == 1){ $tim[$_] = '0'.$tim[$_];}}
my $currdate = "$year-$tim[4]-$tim[3]";
my $currtime = "$tim[2]:$tim[1]:$tim[0]";

my $dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);


# now get the number of records (ie. size of %arr);
my $donecount = 1;
my $reccount = keys %arr;
my $xfercount = 1; # Counter for message headers (to make unique).


while ($donecount <= $reccount){

    # Create a new user agent
    my $ua = LWP::UserAgent->new();
    $ua->agent("OpenAdmin");

    # Create Writer Instance
    my $output = XML::Writer::String->new();
    my $datamode = 0;
    if ($debug){$datamode = 1;}

    $wr = new XML::Writer(OUTPUT => $output, DATA_MODE => $datamode, 
			  DATA_INDENT => '2');
    # Data Mode 1 turns on pretty output, Data Mode 0 is more condensed.


    # Open Update and Error Log files for appending.
    open(ERR,">>error.log") or die "Cannot open error.log: $!\n";
    open(UPD,">>update.log") or die "Cannot open update.log: $!\n";

    
    # Set XML Header and write Root Element
    $wr->xmlDecl("UTF-8");
    $wr->startTag('SL_Message','xmlns' =>$xmlns, 
		  'xmlns:xsi' =>$xmlnsxsi, 
		  'xsi:schemaLocation' => $xsischemaLocation);

    $wr->startTag('SL_Event');

    mkSL_Header($currdate,$currtime, $schoolnumber,$xfercount);

    $xfercount++;
    if ($xfercount > 99){ $xfercount = 1;}

    $wr->startTag('SL_ObjectData');

    $wr->startTag('SL_EventObject',
		  'ObjectName' => 'StudentClassMark', 
		  'Action' => 'Add');

    my $filesize = 0;
    #my %studsubj;

    # Main Loop - once for each student/subject.
STUDENT:
    foreach my $key (sort keys %arr){
	my ($subjsec, $studnum) = split /:/,$key;

	# Get Student Bdate and ProvNum, and Name
	$sth = $dbh->prepare("select lastname, firstname, provnum,birthdate 
          from studentall where studnum = ?");
	$sth->execute( $studnum );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname, $provnum,$bdate) = $sth->fetchrow;
	my $name = "<b>$lastname</b>, $firstname ($studnum)";

	# Get Subject Data
	$sth = $dbh->prepare("select * from subject 
         where subjsec = '$subjsec'");
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my @subject = $sth->fetchrow;
	my $subject = "$subject[2] ($subject[9])";
	my $classid = $subject[9]; # Subject/Section id.
	my $courseid = $subject[1]; # Subject code.


	# Get Dates for this subject.
	my $startdate = $g_termstart{$subject[32]};
	my $enddate = $g_termend{$subject[33]};
	if (not $startdate or not $enddate){
	    print "Subject $subject[2] ($subject[9]) does not have start/end";
	    print " dates correctly defined. ";
	    print "(or term start/end dates defined)\n";
	    print " Terminating.\n"; 
	    die "Subject $subject[2] ($subject[9]) dates not correct";
	}

	# Get Mark Information
	# Need subject/section (subjsec), studnum, and end term ($subject[33])
	$sth = $dbh->prepare("select a1 from eval where 
          subjcode = '$subjsec' and
          term = '$subject[33]' and
          studnum = '$studnum'");
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $mark = $sth->fetchrow;

	if (not $mark) {
	    $donecount++; # since we _have_ done this one...
	    my $sth1 = $dbh->prepare("select lastname, firstname from studentall
              where studnum = ?");
	    $sth1->execute($studnum);
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my ($lastname, $firstname) = $sth1->fetchrow;

	    print "<b>No Mark found</b>";
	    print " for: <b>$firstname $lastname ($studnum)</b> in subject ";
	    print "<b>$subject</b><br>\n";
	    next STUDENT;
	}

	# Get rid of spaces and any percent symbols.
	$mark =~ s/\%//;
	$mark =~ s/^\s+//;
	$mark =~ s/\s+$//;

    
	my $refid = "$subjsec-$studnum"; # Subjsec-StudentNumber - refid #
	$studsubj{$refid} = "$name:$subject:$mark";

	my $correction = ''; # A 'Yes' or 'No' to note any corrections.

	mkStudentClassMark($refid, $provnum, $bdate, $classid, $startdate,
			    $enddate,$mark,$correction);

	$donecount++; # increment counter for all utagged records

	$filesize = length($output->value); # Get the new larger size.
	if ($filesize >= $maxfilesize){ last;} # break out of loop. 
	#print "$donecount:", $filesize,"<br>\n";

    } # End of this student-subjsec


    $wr->endTag('SL_EventObject');
    $wr->endTag('SL_ObjectData');
    $wr->endTag('SL_Event');
    $wr->endTag('SL_Message');
    $wr->end();

    # show output sent to Sask Learning if set via debug mode
    if ($sentdata){
	my $temp = $output->value;
	$temp =~ s/</&lt;/g;
	$temp =~ s/>/&gt;/g;
	print "<div style=\"color: blue;\">\n";
	print "<h1>DEBUG - Request sent to Sask Learning</h1>\n";
	print "<pre>",$temp,"</pre></div><p></p>\n";
    }

    $filesize = length($output->value)/1000; # Get Final Filesize.
    print "<p>The filesize is ", round( $filesize, 1), "KB 
     (Limit: 32KB)</p> \n";


    # Create the https post request 
    my $req = POST $url, [ XML=> $output->value ];

    $req->content_type('application/xml;charset="utf-8"');
    $req->authorization_basic($sds_userid, $sds_password); 

    # Issue the request and receive a response
    $res = $ua->request($req);

    # Check the status of the transfer (NOT result of xml transactions)
    if ($res->is_success) {

	# For Debugging ....
	if ($recddata){
	    print "<h1>DEBUG - Sask Learning XML Response</h1>\n";
	    print "<div style=\"color:green;\">\n";
	    my $temp = $res->content;
	    $temp =~ s/</&lt;/g;
	    $temp =~ s/>/&gt;/g;
	    print "<pre>",$temp,"</pre></div>\n";
	 }


	# Parse returned XML.
	# This does most of the screen printing (and table layout).
	parseResponse(); # response results if errors, update student provnum

    } else {
	my $err = $res->status_line;
	print "<h1>Transfer Error: $err</h1>";
	print "<pre>",$res->content,"</pre>\n";
	die;
    }

} # End of the Counted loop for all student-subjsec marks

print "</body></html>\n";



#------------
sub showDebug {  # Show debug options...
#------------
    print <<"EOS";
<h1>Marks Submission -- Debug Options</h1>

<p>In order to find problems with submitted data, the sizes of the XML
files (and the number of contained records) should be limited so that
it is easier to pick out the offending data. If size is less than 3000
characters, this will limit data to a couple of student records (which
are relatively easy to locate data errors within).</p>

<form action="$self" method="post">
<input type="hidden" name="flag" value="1">
<input type="hidden" name="debug" value="1">
EOS

# have to pass these values through to the real script.
foreach my $key (keys %arr) { 
    #print "K:$key V:$arr{$key}<br>\n";
    print "<input type=\"hidden\" name=\"$key\" value=\"1\">\n";
}

    print <<"EOS1";
<table cellpadding="3" cellspacing="0" border="0">

<tr><td></td><td><input type="submit" value="Continue"></td></tr>

<tr><td align="right">XML File Size Limit:</td>
<td><input type="text" name="xmlsize" size="8" value="3000">
</td></tr>

<tr><td align="right">View Submitted Data</td>
<td><input type="checkbox" name="sentdata" value="1" checked></td></tr>

<tr><td align="right">View Received Data</td>
<td><input type="checkbox" name="recddata" value="1" checked></td></tr>

<tr><td></td><td><input type="submit" value="Continue"></td></tr>
</table>
</body></html>
EOS1
    

}


#----------------
sub parseResponse {
#----------------
# parse response from SL, display errors (if any), update provnum in 
#  student table,  print to error logs.

    # Parse the response.
    my $parser = XML::LibXML->new();

    eval {$doc = $parser->parse_string($res->content)};
    if ($@){
	print "Sask Learning Error:\n<pre>$@<br>";
	print $res->content,"</pre><br>\n";
	print "</body></html>\n"; die;
    }	

    #print "XMLns:",$xmlns,"<br>\n";

    $doc->setEncoding('UTF-8');

    my $root = $doc->getDocumentElement;
    $root->setNamespace($xmlns,'sl',1);

    my $status = $root->findvalue('//sl:SL_Status/sl:SL_StatusCode');
    my $statusMsg = $root->findvalue('//sl:SL_Status/sl:SL_StatusMsg');

    # Print table heading for table of results.
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>Name</th><th>Subject</th><th>Mark</th><th>Message</th></tr>\n";

    my $currsubj = -1;
    my $oldsubj;

    if ($status eq 'Errors' or 
	$status eq 'Successful' or 
	$status eq 'Warnings') { 

	my @errors = $root->findnodes('//sl:SL_Error');
	foreach my $error (@errors){  # loop through all student marks
	    
	    my $refid = $error->getAttribute('RefId');
	    my $errcode = $error->findvalue('sl:SL_ErrorCode');
	    my $errmsg = $error->findvalue('sl:SL_ErrorMsg');
	    #print "Ref:$refid V: $studsubj{$refid}<br>\n";
	    
	    my ($nm,$sub,$mark) = split /:/, $studsubj{$refid};
	    $oldsubj = $currsubj;
	    $currsubj = $sub;
	    if ($oldsubj ne $currsubj) {
		print "<tr><td colspan=\"4\" ";
		print "style=\"background-color:#DDD;font-size:130%;\">\n";
		print "<b>$currsubj</b></td></tr>\n";
	    }

	    print "<tr><td>$nm</td><td>$sub</td><td align=\"center\">$mark</td>";
	    if ($errcode) { # if not zero, we have an error....
		print "<td style=\"color:red;\">$errmsg ($errcode)</td></tr>\n";
	    } else {
		print "<td>$errmsg</td></tr>\n";
	    }

	} # End of printing of response loop


    } elsif ($status eq 'Invalid'){ # Print out errors
	print "<div style=\"font-size: 200%; font-weight: bold;\">";
	my @errors = $root->findnodes('//sl:SL_Error');
	foreach my $error (@errors){
	    my $refid = $error->getAttribute('RefId');
	    my $errcode = $error->findvalue('sl:SL_ErrorCode');
	    my $errmsg = $error->findvalue('sl:SL_ErrorMsg');
	    print "Error: $errmsg ($errcode) ";
	}
	print "</div>\n";

    } else {
	print "<p><b>Weird result</b> - Status: $status<br></p>\n";
	die;
    }
    print "</table>\n";
    print "<p></p>\n";
    return undef;

} # End of parseResponse
