#! /usr/bin/perl 
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


use DBI;
use CGI;

my %lex = ('Student Timetables' => 'Student Timetables',
	   'Main' => 'Main',
	   'Schedule' => 'Schedule',
	   'Cannot open tex file' => 'Cannot open tex file',
	   'View/Download' => 'View/Download',
	   'View Log File' => 'View Log File',
	   'Select' => 'Select',
	   'Lastname, Firstname' => 'Lastname, Firstname',
	   'Homeroom, Lastname, Firstname' => 'Homeroom, Lastname, Firstname',
	   'Grade, Lastname, Firstname' => 'Grade, Lastname, Firstname',
	   'Band, Lastname, Firstname' => 'Band, Lastname, Firstname',
	   'Sort by' => 'Sort by',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Continue' => 'Continue',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Error' => 'Error',
	   'Blank=All' => 'Blank=All',
	   'Band' => 'Band',
	   'Term' => 'Term',
	   'Period' => 'Period',
	   'Day' => 'Day',
	   'Separate multiple terms with spaces' => 'Separate multiple terms with spaces',
	   'Term(s)' => 'Term(s)',

	);

my $grayshade = '0.80';
my $maxchars = 10; # maximum characters for subject description (if not small desc field)

my $logowidth = '20mm';
my $logofile = 'schoollogo.jpg';

my $self = "rptschedule.pl";


eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $maxlines = 28;
my $shortname = "schedrpt$$";
my $filename = "$shortname.tex";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $sortorder = "homeroom, lastname, firstname";
if ( $arr{sortorder} eq $lex{'Lastname, Firstname'} ) {
    $sortorder = "lastname, firstname";
} elsif ( $arr{sortorder} eq $lex{'Grade, Lastname, Firstname'} ) {
    $sortorder = "grade, lastname, firstname";
} elsif ( $arr{sortorder} eq $lex{'Band, Lastname, Firstname'} ) {
    $sortorder = "band, lastname, firstname";
} elsif ( $arr{sortorder} eq $lex{'Homeroom, Lastname, Firstname'} ) {
    $sortorder = "homeroom, lastname, firstname";
}
if ( $arr{sortorder} ) { delete $arr{sortorder}; }

my @terms = split /\s/, $arr{term};
delete $arr{term};

my $select;
if ( $arr{group} ) {
    if ( $arr{select} eq $lex{Grade} ) { # Find this grade;
	my $grp = $dbh->quote( $arr{group} );
	$select = "where grade = $grp";
    } elsif ( $arr{select} eq $lex{Homeroom} ) {
	my $grp = $dbh->quote( $arr{group} );
	$select = "where homeroom = $grp";
    } elsif ( $arr{select} eq $lex{Band} ) {
	my $grp = $dbh->quote( $arr{group} );
	$select = "where band = $grp";
    }

}


# print page header
print "$doctype\n<html><head><title>",$lex{'Student Timetables'},"\n";
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";

print "$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> | \n";
print "<a href=\"$schpage\">". $lex{Schedule},"</a> ]\n";


if ( not $arr{page} ) {
    showStartPage();
}

# foreach my $key (sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
# print "Sortorder: $sortorder  Select: $select<br>\n";


# Now create an array, @students,  to store student numbers of students to print
my $sth = $dbh->prepare("select studnum from student $select
 order by $sortorder");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while ( my $studnum = $sth->fetchrow ) {
    push @students, $studnum;
}

if ( @students ) { # We have students to print; setup LaTeX file.
    open(TEX,">$filename") || die $lex{'Cannot open tex file'};

    my $papersize;
    if ( $defaultpapersize ) {
	$papersize = $defaultpapersize;
    } else {
	$papersize = 'letterpaper';
    }

    print TEX "\\documentclass[12pt,$papersize, landscape]{article}
\\usepackage{array,colortbl,multicol,inputenc,graphicx,helvet}
\\inputencoding{latin1}
\\pagestyle{empty}
%\\setlength{\\textwidth}{7in}
%\\setlength{\\textheight}{10in}
\\setlength{\\evensidemargin}{0in}
\\setlength{\\oddsidemargin}{0in}
\\setlength{\\hoffset}{-0.4in}
\\setlength{\\voffset}{-1in}
\\setlength{\\extrarowheight}{2pt}
\\setlength{\\parindent}{0pt}\n";

    print TEX "\\begin{document}\n";

} else {
    print "<h3>". $lex{'No Student(s) Found'}. "</h3>\n";
    print "</body></html>\n";
    die $lex{'No Student(s) Found'}. "\n";
}

# Now Do Student Timetables
my %subtimes = (); # used for global subject storage;

foreach my $studnum ( @students ) {

    prTimetable( $studnum, $term ); # do 1 term and 1 student.l

} # End of Student Loop

print TEX "\\end{document}";
close TEX;

system("$pdflatex $filename >pdflog$$.txt");
system("mv $shortname.pdf $downloaddir");
system("mv pdflog$$.txt $downloaddir");
system("rm $shortname.*");

print "<center><h1><a href=\"/download/$shortname.pdf\">\n";
print $lex{'View/Download'}. ' '. $lex{'Student Timetables'}, "</a></h1>\n";
print "[ <a href=\"$schpage\">". $lex{Schedule}. "</a> |\n";
print "<a href=\"$webdownloaddir/pdflog$$.txt\">". $lex{'View Log File'}. "\n";
print "</a> ]\n</center></body></html>\n";


#--------------
sub prTimetable {
#--------------

    my $studnum = shift;

    # Get more student info
    my $sth = $dbh->prepare("select lastname, firstname, grade, homeroom, band,
     provnum from studentall where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ( $lastname, $firstname, $grade, $homeroom, $band, $provnum ) = $sth->fetchrow;


    # Now print the Timetable in TeX, heading first.
    print TEX "\\includegraphics[width=$logowidth]{../../etc/$logofile}\\quad\n";

    print TEX "\\parbox[b]{150mm}{ {\\Large $schoolname}\n\n\n\n";
    print TEX "{\\LARGE\\bf $firstname $lastname} ($provnum)\n\n";
    print TEX "{\\bf ". $lex{Grade}. "} $grade\\\\\n";
    if ( $homeroom ) {
	print TEX "{\\bf ". $lex{Homeroom}. "} $homeroom\\\\\n";
    }
    if ( $band ) {
	print TEX "{\\bf ". $lex{Band}. "} $band\\\\\n";
    }
    print TEX " }\n\n"; # end of parbox.
    print TEX "\\vspace{8mm}\n";

    foreach my $term ( @terms ) {

	# Get their enrollment this term; could be repeated for multiple terms.
	$sth = $dbh->prepare("select distinct subjcode from eval 
          where studnum = ? and term = ?");
	$sth->execute( $studnum, $term );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

	my @timetable = ();
	my $maxdays = 0;

	my $sth1 = $dbh->prepare("select day, period from schedat 
          where term = $term and subjsec = ? order by day, period");

	while ( my $subjsec  = $sth->fetchrow ) {

	    if ( not $subtimes{$subjsec} ) { # don't have subject's timetable values
		# load each timetable record for this subject.
		$sth1->execute( $subjsec ) ;
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		$subtimes{ $subjsec } = [ ]; # create
		while ( my ( $day, $period ) = $sth1->fetchrow ) {
		    push @{ $subtimes{$subjsec} }, "$day:$period";
		}
	    }

	    # Populate 2D day:period array; use global values for day and period.
	    my @dayperiod = @{ $subtimes{$subjsec} };

	    foreach my $rec ( @dayperiod ) {
		my ( $day, $period ) = split /:/, $rec;
		if ( $day > $maxdays ) { $maxdays = $day; }
		$timetable[$period][$day] = $subjsec; # since we iterate over periods first.
	    }
	}

	if ( not $maxdays ) { next; }

#$maxdays = 1; # override for Eagleview...

	print TEX "\\begin{tabular}{|c|";
	for ( 1 .. $maxdays ) { print TEX "l|" }
	print TEX "}\\hline\n\n";

	# Print Top Row here.
	print TEX $lex{Term}. " $term / ". $lex{Day};
	for my $day ( 1 .. $maxdays ) { print TEX " & $day "; }
	print TEX "\\\\ \\hline\n";

	my $sth2 = $dbh->prepare("select description, smdesc, location, teacher 
          from subject where subjsec = ?");

	for my $period ( 1 .. $#timetable ) {
	    print TEX $lex{Period}. " $period";
	    for my $day ( 1 .. $maxdays ) { 
		my $subjsec = $timetable[$period][$day];
		$sth2->execute( $subjsec );
		if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
		my ( $description, $smdesc, $location, $teacher ) = $sth2->fetchrow;
		if ( not $smdesc ) {
		    $smdesc = substr( $description, $maxchars ); # defined at top.
		}

		print TEX " & $smdesc ($subjsec)";
	    }
	    print TEX "\\\\ \\hline\n";
	}
	print TEX "\\end{tabular}\n";

    } # end of Term Loop
    
    print TEX "\n\\newpage\n"; # new line for next student.


} # end of prTimetable




#-----------------
sub showStartPage {
#-----------------

    # No longer used; left just in case... Find the terms
    #my $sth = $dbh->prepare("select min(startrptperiod) from subject");
    #$sth->execute;
    #if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    #my  $startterm = $sth->fetchrow;

    #$sth = $dbh->prepare("select max(endrptperiod) from subject");
    #$sth->execute;
    #if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    #my  $endterm = $sth->fetchrow;

    #my @terms;
    #for my $trm ( $startterm .. $endterm ) {
    #	push @terms, $trm;
    #}
   
    # print sortorder and selection input form.
    print "<center><h1>". $lex{'Student Timetables'}. "</h1>\n";
    print "<div><form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
    print "<tr><td align=\"right\">". $lex{'Sort by'}. "\n";
    print "</td><td><select name=\"sortorder\"><option>". $lex{'Lastname, Firstname'};
    print "</option>\n";
    print "<option>". $lex{'Homeroom, Lastname, Firstname'}. "</option>\n";
    print "<option>". $lex{'Grade, Lastname, Firstname'}. "</option>\n";
    print "<option>". $lex{'Band, Lastname, Firstname'}. "</option>\n";
    print "</select></td></tr>\n";

    print "<tr><td align=\"right\">". $lex{Select}. "\n";
    print "</td><td><select name=\"select\"><option>". $lex{Grade}. "</option>\n";
    print "<option>". $lex{Homeroom}. "</option>\n";
    print "<option>". $lex{Band}. "</option>\n";
    print "</select>\n";
    print "<input type=\"text\" name=\"group\" size=\"14\"> ". $lex{'Blank=All'}. "</td></tr>\n";
    
    # Now do the term
    print "<tr><td align=\"right\">". $lex{'Term(s)'}. "</td><td>";
    print "<input type=\"text\"  name=\"term\" size=\"12\">\n";
    print $lex{'Separate multiple terms with spaces'}. "</td></tr>\n";

    print "<tr><td align=\"center\" colspan=\"2\">";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";

    print "</table></form></div>\n";
    print "</center></body></html>\n";

    exit;

}
