#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Schedule Entry' => 'Schedule Entry',
	   'Schedule' => 'Schedule',
	   'Grade' => 'Grade',
	   'Term' => 'Term',
	   'Terms' => 'Terms',
	   'Day' => 'Day',
	   'Save' => 'Save',
	   'Period' => 'Period',
	   'Subject-Section' => 'Subject-Section',
	   'Add Backings' => 'Add Backings',
	   'Records added for' => 'Records added for',
	   'Contact' => 'Contact',
	   'Separate with Spaces' => 'Separate with Spaces',
	   'Additional Subjects' => 'Additional Subjects',
	   'Add Schedule Entries for these terms' => 'Add Schedule Entries for these terms',
	   'Continue' => 'Continue',
	   'Teacher' => 'Teacher',
	   'OR' => 'OR',
	   'Per' => 'Per',

	   );


use DBI;
use CGI;

my $self = "schedadd.pl";
my $maxbackings = 6; # maximum number of backed classes per cycle.

#($sec, $min, $hour, $mday, $mon, $year, 
# $wday, $yday, $iddst) = localtime(time);
my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# print page header.
print "$doctype\n<html><head><title>". $lex{'Schedule Entry'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body style=\"margin: 0 2em;\">\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$schpage\">". $lex{Schedule}. "</a> ]\n";
print "<h1>". $lex{'Schedule Entry'}. "</h1>\n";


# show Starting Page
if ( $arr{writeflag} ){
    updateRecords(); # Write Records
} elsif ( not $arr{grade} and not $arr{teacher} ) {
    showStartPage();
}

# parse passed values for termX elements. Extract X.

foreach my $key ( keys %arr ) {
    if ( $key =~ m/term(\d*)/ ) {
	push @tmp,$1;
    }
}
@sortedterms = sort { $a <=> $b } @tmp;

my $termselect;
{
    my $startterm = $sortedterms[0];
    my $endterm = $sortedterms[-1];
    $termselect = "and startrptperiod <= $startterm and endrptperiod >= $endterm";

    # print "TS: $termselect  START: $startterm END: $endterm<br>\n";
}



my $select;
if ( $arr{grade} ) {
    # split grades to select subjects from
    if ( $arr{subjectselect} ){
	@selgrades = split /\s/,$arr{subjectselect};
    } else {
	$selgrades[0] = $arr{grade};
    }
    foreach my $gr ( @selgrades ) {
	$select .= "or grade = '$gr' ";
    }
    $select =~ s/^or/where/; # change leading 'or' to 'where'.
} else { # teacher
    my ( $dud, $userid ) = split /\(/, $arr{teacher};
    chop $userid;
    $select = "where teacher $sql{like} ". q{'%(}. $userid. q{)%'};
}
#print "Select: $select<br>\n";


# Load Subject-Sections into array.
$sth = $dbh->prepare("select description, smdesc, subjsec from subject
  $select $termselect order by description");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my @subjects;
while ( my ( $description,$smdesc, $subjsec ) = $sth->fetchrow ){
    # use truncated longer description if no small description. 
    if ( not $smdesc ) { $smdesc = substr($description,0,8);} 
    push @subjects,"$smdesc ($subjsec)";
}
# print "Subjects ", @subjects, "<br>\n";


# Print Teacher or Grade
print "<div style=\"font-size:150%; margin:1em;\">";
if ( $arr{grade} ) {
    print "<b>". $lex{Grade}. "</b> $arr{grade}\n";
} else { # print grade
    print "<b>". $lex{Teacher}. "</b> $arr{teacher}\n"; 
}

# Print Terms
print "&nbsp;<b>". $lex{Terms}. "</b>\n ";
foreach my $trm ( @sortedterms ){
  print $lex{Term}. " $trm&nbsp;&nbsp;";
  $trm = $trm.' ';
}
print "</div>\n";

# Print Main Layout Table
print "<form action=\"$self\" method=\"post\">";
print "<input type=\"submit\" value=\"". $lex{Save}. "\">\n";

print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";
print "<input type=\"hidden\" name=\"grade\" value=\"$arr{grade}\">\n";
print "<input type=\"hidden\" name=\"terms\" value=\"";
print @sortedterms,"\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

# Set Days and Periods
my $days = $daysPerCycle; # One for each Day.
my $maxppd = 0;
if ( $arr{grade} ) {
    $maxppd = $g_ppd{ $arr{grade} };
} else {
    foreach my $key ( keys %g_ppd ) {
	if ( $g_ppd{ $key } > $maxppd ) { $maxppd = $g_ppd{ $key }; }
    }
}


# Print Header
print "<tr><th></th>";
for (1..$daysPerCycle){	print "<th>". $lex{Day}. " $_</th>\n"; }
print "</tr>\n";

for my $ppd ( 1..$maxppd ) {
    print "<tr>";
    for ( 0..$days ) {
	if ($_ == 0) { 
	    print "<td><b>". $lex{Per}. " $ppd</b></td>\n";
	} else {
	    print "<td>";
	    my $id = "$ppd:$_";
	    prSelections( $id );
	    print "</td>\n";
	}
    }
    print "</tr>\n";
}

my $span = $days + 1;
print "</table><input type=\"submit\" value=\"". $lex{Save}. "\">\n";

print "<p><b>". $lex{'Add Backings'}. "</b></p>\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th>". $lex{'Subject-Section'}. "</th><th>". $lex{Day};
print "</th><th>". $lex{Period}. "</th></tr>\n";

for ( 1..$maxbackings ){
    print "<tr><td>";
    my $id = "b$_";
    prSelections($id);
    print "</td><td><input type=\"text\" name=\"bd$_\" size=\"6\"></td>\n";
    print "</td><td><input type=\"text\" name=\"bp$_\" size=\"6\"></td>\n";
    print "</tr>\n";
}

print "</table><input type=\"submit\" value=\"". $lex{Save}. "\">\n";
print "</form></body></html>\n";



#------------------
sub showStartPage {
#------------------

    # Load terms from eval
    my $sth = $dbh->prepare("select distinct term from eval 
     where term != '' order by term");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my @terms;
    while ( my $trm = $sth->fetchrow ) {
	if ( $trm ){ push @terms, $trm; }
    }

    # Get Teachers
    my @teachers;
    my $sth = $dbh->prepare("select distinct userid, lastname, firstname from staff 
      order by lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    while ( my ( $userid, $lastname, $firstname ) = $sth->fetchrow ) {
	push @teachers, "<b>$lastname</b>, $firstname ($userid)";
    }


    print "<form action=\"$self\" method=\"post\">\n";

    print "<div style=\"border:1px solid gray;padding:0.5em;margin:0.3em;\">\n";
    print $lex{'Schedule Entry'}. q{ &ndash; }. $lex{Grade};
    print " <input type=\"text\" name=\"grade\" size=\"6\"><br style=\"margin:0.5em 0;\">\n";

    print $lex{'Additional Subjects'}. q{ &ndash; }. $lex{Grade};
    print " <input type=\"text\" name=\"subjectselect\" size=\"6\"> ";
    print $lex{'Separate with Spaces'}. "</div>\n";

    print "<div style=\"border:1px solid gray;padding:0.5em;margin:0.3em;\">\n";
    print "<b>". $lex{OR}. "</b> ". $lex{Teacher};
    print " <select name=\"teacher\"><option></option>\n";
    foreach my $teacher ( @teachers ) {
	print "<option>$teacher</option>";
    }
    print "</select></div>\n";

    print "<div style=\"border:1px solid gray;padding:0.5em;margin:0.3em;\">\n";
    print $lex{'Add Schedule Entries for these terms'}. ":<br>\n";
    foreach my $trm (@terms){
	print $lex{Term}. " $trm<input type=\"checkbox\" name=\"term$trm\" ";
	print " value=\"1\" >&nbsp;&nbsp;";
    }
    print "</p>\n";

    #print "<p><b>";
    #print $le {Term}. "</b> ". $le {'A period of time with report cards at the end'};
    #print ".</p>\n";

    print "<p style=\"margin-right:5em;\">\n";
    #print "The terms are the periods of time these entries in a
    #timetable are valid. In a K-6 school with 3 terms for the year,
    #the answer is all 3 terms. In a high school with 2 semesters and 2
    #terms in each semester, the first semester timetable entries would
    #be for terms 1 and 2 while the second semester would be terms 3 and
    #4.</p>\n";

    print "<p><input type=\"submit\" value=\"". $lex{Continue}. "\"></p>";
    print "</form></body></html>\n";

    exit;
}


#---------------
sub prSelections {  # print selection list for subject array
#---------------

    my $id = shift;

    print "<select name=\"$id\"><option></option>\n";
    foreach my $subj ( @subjects ) {
	print "<option>$subj</option>";
    }
    print "</select>\n";

}

#----------------
sub updateRecords { # Write the records to schedat table.
#----------------

    delete $arr{writeflag};
    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my @terms = split /\s/,$arr{terms}; # same for all

    my $sth = $dbh->prepare("select grade from subject where subjsec = ?");

    foreach my $key ( keys  %arr ) {
	my ($period,$day) = split /:/,$key;
	if ( $day and $arr{$key} and $arr{terms} ) { # filled entry
	    #print "K: $key V: $arr{$key} Day: $day Period: $period<br>\n";
    
	    my ($subj,$subjsec) = split /\(/,$arr{$key};
	    chop $subjsec; # remove trailing bracket.

	    # Set Grade
	    my $grade;
	    if ( not $arr{grade} ) {
		$grade = $sth->execute($subjsec);
	    } else {
		$grade = $arr{grade};
	    }

	    foreach my $trm ( @terms ) {
		$sth1 = $dbh->prepare("insert into schedat values (
	        $sql{default},?,?,?,?,?)");
		$sth1->execute( $day, $period, $subjsec, $grade, $trm );
		if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    }

	} elsif ( $arr{$key} and $key =~ m/b(\d)/){ # one of the backups...
	    my $di = "bd$1"; my $pi = "bp$1";
	    #print "Backup K: $key V:$arr{$key} T:$1 Day: $arr{$di} Period: $arr{$pi}<br>\n";
	    my ($subj,$subjsec) = split /\(/,$arr{$key};
	    chop $subjsec; # remove trailing bracket.
	    if ( $arr{$di} and $arr{$pi} ) { # must have day and period, too.
		foreach my $trm ( @terms ){
		    my $sth1 = $dbh->prepare("insert into schedat values (
                      $sql{default},?,?,?,?,?)");
		    $sth1->execute( $arr{$di}, $arr{$pi}, $subjsec, $arr{grade}, $trm );
		    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
		}
	    } # if day and period

	} # if backup

    } # end of for loop


    if ( not $DBI::errstr ) {
	print '<p>'. $lex{'Records added for'}. q{ }. $lex{Grade}. " $arr{grade} ";
	print $lex{Terms}. ": $arr{terms}</p>\n";
    } else {
	print "<h3><b>". $lex{Error}. "</b> $DBI::errstr<br>\n";
	print $lex{Contact}. " $adminname <a href=\"mailto:$adminemail\">$adminemail</a></h3>\n";
    }
    
    print "<p>[ <a href=\"$schpage\">". $lex{Schedule}. "</a> ] \n";
    print "</p></center></body></html>\n";

    exit;
}
