#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Error' => 'Error',
	   'Main' => 'Main',
	   'Schedule' => 'Schedule',
	   'Delete Schedule Entries' => 'Delete Schedule Entries',
	   'View Schedule' => 'View Schedule',
	   'Records' => 'Records',
	   'Day' => 'Day',
	   'Period' => 'Period',
	   'Subject' => 'Subject',
	   'Teacher' => 'Teacher',
	   'Grade' => 'Grade',
	   'Term' => 'Term',
	   'Delete' => 'Delete',
	   'Delete Selected Records' => 'Delete Selected Records',
	   'Records Deleted' => 'Records Deleted',
	   

	   );

my $self = 'schedel.pl';

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# print page header.
print "$doctype\n<html><head><title>". $lex{'Delete Schedule Entries'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print " <a href=\"$schpage\">". $lex{Schedule}. "</a> |\n";
print "<a href=\"schedview.pl\">". $lex{'View Schedule'}. "</a> ]\n";

if ( $arr{flag} ){ # delete records...
    deleteRecords();
}


my $sortorder = "term, day, period, subjsec";

$sth = $dbh->prepare("select * from schedat 
where term = ? and grade = ?
order by $sortorder");

$sth->execute( $arr{trm}, $arr{gr} );
if ($DBI::errstr){print $DBI::errstr; die;}
$rows = $sth->rows;


print "<center><h1>". $lex{'Delete Schedule Entries'}. "</h1>\n";
print "<p><b>". $lex{Records}. ": $rows</b></p>\n";

print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"flag\" value=\"1\">
<table border=\"1\" cellpadding=\"4\" cellspacing=\"0\">\n";

print "<tr><th>". $lex{Day}. "</th><th>". $lex{Period}. "</th><th>". $lex{Subject}. "</th><th>";
print $lex{Teacher}. "</th><th>". $lex{Grade}. "</th><th>". $lex{Term}. "</th><th>". $lex{Delete}. "</th></tr>\n";
print "<tr><td colspan=\"7\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{'Delete Selected Records'}. "\"></td></tr>\n";

my $sth1 = $dbh->prepare("select description,teacher from subject
  where subjsec = ?");

while ( my ( $id, $day, $period, $subjsec, $grade,$term ) = $sth->fetchrow ) {

    $sth1->execute( $subjsec );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($description,$teacher) = $sth1->fetchrow;
    print "<tr><td align=\"center\">$day</td><td align=\"center\">$period</td>\n";
    print "<td>$description ($subjsec)</td><td>$teacher</td><td>$grade</td><td>$term</td>\n";
    print "<td><input type=\"checkbox\" name=\"$id\" value=\"1\"></td></tr>\n";

}

print "<tr><td colspan=\"7\" align=\"center\">\n";
print "<input type=\"submit\" value=\"". $lex{'Delete Selected Records'}. "\"></td></tr>\n";

print "</table></form></center></body></html>\n";


#----------------
sub deleteRecords {
#----------------

    delete $arr{flag};
    my $sth = $dbh->prepare("delete from schedat where id = ?");
    print "<br>\n";

    foreach my $key (keys %arr){
	$sth->execute($key);
	print " $key<br>\n";
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    }

    print "<br>". $lex{'Records Deleted'}. "</body></html>\n";
    
    exit;

} # End of deleteRecords
