#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my $self = 'schedview.pl';
my %lex = ('View Schedules' => 'View Schedules',
	   'Main' => 'Main',
	   'Schedule' => 'Schedule',
	   'No records found' => 'No records found',
	   'Grade' => 'Grade',
	   'Term' => 'Term',
	   'Delete Entries' => 'Delete Entries',
	   'No Value' => 'No Value',
	   'Period' => 'Period',
	   'Day' => 'Day',
	   'Term' => 'Term',
	   'View' => 'View',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;
use Cwd;

# Set prepath for config file: (/tcgi or cgi/schedule)
my $prepath = '../..';
if (getcwd() =~ /tcgi/){ # we are in tcgi
    $prepath = '..';
}

eval require "$prepath/etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

# Get current dir so know what CSS to display;
if (getcwd() =~ /tcgi/){ # we are in tcgi
    $css = $tchcss;
    $homepage = $tchpage;
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my ($select, $term);
if ($arr{term} =~ m/\d/) { # must be a digit
    $term = $arr{term};
    my $trm = $dbh->quote($arr{term});
    $select = "where term = $trm";
}


# print page header.
print "$doctype\n<html><head><title>". $lex{'View Schedules'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> \n";
unless (getcwd() =~ /tcgi/){ # unless we are in tcgi
    print "| <a href=\"$schpage\">". $lex{Schedule}. "</a> \n";
}

print "] <form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print $lex{Term}. " <input type=\"text\" size=\"6\" name=\"term\">\n";
print "<input type=\"submit\" value=\"". $lex{View}. "\"></form>\n";


my $sth = $dbh->prepare("select distinct grade, term from schedat $select order by grade, term");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;
if ($rows < 1){
    print "<p><b>". $lex{'No records found'}. ".</b></p>\n";
    print "</body></html>\n";
    exit 0;
}

for (1..$rows){
    my ($grade, $term) = $sth->fetchrow;
    printTimetable($grade,$term);
}
print "</body></html>\n";


#-----------------
sub printTimetable { # print timetable for 1 grade for 1 term.
#-----------------

    my ($grade, $term) = @_;  # passed grade and term.
    print "<p style=\"font-size: 150%;\">". $lex{Grade}. ": $grade ". $lex{Term}. ": $term\n";
    print "[ <a href=\"schedel.pl?gr=$grade&trm=$term\">". $lex{'Delete Entries'}. "</a> ]</p>\n";

    my $sth = $dbh->prepare("select day, period, subjsec from schedat 
      where term = ? and grade = ? order by period, day");
    $sth->execute($term, $grade);

    # Create 2D subject array (of [period][day] indexes)
    my @subject;
    while (my ($day, $period, $subjsec) = $sth->fetchrow){
	$subject[$period][$day] .= "$subjsec ";
    }

    my $tblrows = $#subject;
    my $tblcols;
    for $i (1..$tblrows){
	if ($#{$subject[$i]} > $tblcols){ $tblcols = $#{$subject[$i]};}
    }
    $sth = $dbh->prepare("select description from subject where subjsec = ?");

    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    # heading
    print "<tr><th></th>";
    for (1..$tblcols){ print "<th>". $lex{Day}. " $_</th>"; }
    print "</tr>\n";
    
    # Main body of table.
    for $i (1..$tblrows){
	print "<tr><td>". $lex{Period}. " $i</td>";
	for (1..$tblcols){
	    if ($subject[$i][$_]){ # if we have a subjsec value;
		my $firstflag = 1;
		@subjval = split /\s/,$subject[$i][$_];
		print "<td>";
		foreach my $sv (@subjval){
		    if (not $firstflag){ print "<br>";} else { $firstflag = 0;}
		    $sth->execute($sv);
		    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}	    
		    my $desc = $sth->fetchrow;
		    print "$desc ($sv)";
		}
		print "</td>";
	    } else {
		print "<td style=\"font-color: red;\">". $lex{'No Value'}. "</td>";
	    }
	}
	print "</tr>\n";
    }
    print "</table>\n";

} # End of printTimetable
