#!/usr/bin/perl

#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = (
	   'Update Record' => 'Update Record',
	   'Your schedule updates are now stored in the database' => 
	     'Your schedule updates are now stored in the database',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Please contact your network adminstrator' => 
	     'Please contact your network adminstrator',
	   'Please record the following error' => 'Please record the following error',
	   'Edit Subject Periods per Cycle' => 'Edit Subject Periods per Cycle',
	   'PPC = Periods per Cycle' => 'PPC = Periods per Cycle',
	   'Act = Active' => 'Act = Active',
	   'Schedule' => 'Schedule',
	   'Main' => 'Main',
	   'Description' => 'Description',
	   'Teacher' => 'Teacher',
	   'Active' => 'Act',
	   'PPC1' => 'PPC1',
	   'PPC2' => 'PPC2',
	   'PPC3' => 'PPC3',
	   'PPC4' => 'PPC4',
	   'updated with' => 'updated with',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Head.
print "$doctype\n<html><head><title>". $lex{'Edit Subject Periods per Cycle'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> | 
<a href=\"$schpage\">". $lex{'Schedule'}. "</a> ]
<center><h1>". $lex{'Edit Subject Periods per Cycle'}. "</h1>\n";


my $sth = $dbh->prepare("select id, description, teacher, subjsec, schedppc1, schedppc2, 
 schedppc3, schedppc4, active from subject order by grade, description"); 
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }


if ($arr{updateflag}) {
    delete $arr{updateflag};
    updateRecords();
    die;
}

# Print Form Header
print "<form action=\"subjsched.pl\" method=\"post\">
<input type=\"hidden\" name=\"updateflag\" value=\"1\">\n";


print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
print '<caption><b>'. $lex{'PPC = Periods per Cycle'}. "&nbsp;&nbsp;|&nbsp;&nbsp;". $lex{'Act = Active'}. "</caption>\n";
print '<tr><th>'. $lex{Description}. '</th><th>'. $lex{Teacher}. '</th><th>'. $lex{Active}. '</th><th>'. $lex{PPC1};
print '</th><th>'. $lex{PPC2}. '</th><th>'. $lex{PPC3}. '</th><th>'. $lex{PPC4}. "</th></tr>\n";

while (my ($id, $description, $teacher, $subjsec, $schedppc1, $schedppc2, 
	   $schedppc3, $schedppc4, $active) = $sth->fetchrow) {

    print "<tr><td>$description ($subjsec)</td><td>$teacher</td>\n";
    print "<td><input type=\"text\" name=\"$id:active\" value=\"$active\" size=\"1\"></td>\n";
    print "<td><input type=\"text\" name=\"$id:schedppc1\" value=\"$schedppc1\" size=\"4\"></td>\n";
    print "<td><input type=\"text\" name=\"$id:schedppc2\" value=\"$schedppc2\" size=\"4\"></td>\n";
    print "<td><input type=\"text\" name=\"$id:schedppc3\" value=\"$schedppc3\" size=\"4\"></td>\n";
    print "<td><input type=\"text\" name=\"$id:schedppc4\" value=\"$schedppc4\" size=\"4\"></td></tr>\n";
    
}



print "</table><p><input type=\"submit\" value=\"". $lex{'Update Record'}.
 "\"></form></center></body></html>\n";



#---------------
sub updateRecords {
#---------------

    foreach $key (keys(%arr)) { 
	#print "K:$key V:$arr{$key}<br>\n";
	my ($id, $fieldid) = split /:/, $key;

	$sth = $dbh->prepare("select $fieldid from subject
          where id = '$id'");
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $prevalue = $sth->fetchrow;
	if ($prevalue eq $arr{$key}) { next; } #skip this one...

	$sth = $dbh->prepare("update subject set $fieldid = '$arr{$key}'
          where id = '$id'");
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	print "$fieldid ". $lex{'updated with'}. " $arr{$key}<br>\n";

    }

    print '<h3>';
    if (not $DBI::errstr ) {
	print $lex{'Your schedule updates are now stored in the database'}. ".</h3></p>";
    } else {
	print $lex{'There was an error storing your data'}. "<br>\n";
	print $lex{'Please contact your network adminstrator'};
	print " <a href=\"mailto:$adminemail\">$adminemail</a><br>\n ";
	print $lex{'Please record the following error'}. "<br>\n";
	print $DBI::errstr;
    }
    print "</h3>\n";

    print "<p>[ <a href=\"$schpage\">". $lex{Schedule}. "</a> ]</p>";
    print "</center></body></html>\n";


}
