#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# resetbus.pl - reset bus route.

my %lex = ('Main' => 'Main',
	   'Schedule' => 'Sched/Trans',
	   'Update Transportation Type' => 'Update Transportation Type',
	   'Student' => 'Student',
	   'Transportation Type' => 'Transportation Type',
	   'Back to Top' => 'Back to Top',
	   'Error' => 'Error',
	   'Update Bus Route' => 'Update Bus Route',

	);

my $self = 'transed.pl'; 
my $resetfield = 'trans_type';


use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $mode = $arr{mode};
delete $arr{mode};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


my %resetvals;
my $sth = $dbh->prepare("select distinct $resetfield from student 
 where $resetfield != ''");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while (my $val = $sth->fetchrow) {
    $resetvals{$val} = 1;
}

# now get values from meta...
$sth = $dbh->prepare("select defaultvalue from meta where tableid = 'student'
 and fieldid = '$resetfield'");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my $defaults = $sth->fetchrow;
my @vals = split / /, $defaults;
foreach my $val (@vals) {
    if ($val eq '~') { next; }
    $resetvals{$val} = 1;
}



# page heading
print "$doctype\n<html><head><title>". $lex{'Update Transportation Type'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body><a name=\"top\"></a>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | ";
print "<a href=\"$schpage\">". $lex{Schedule}. "</a> ]\n";

print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"submit\" value=\"Select Mode\">\n";
print "Raw <input type=\"radio\" name=\"mode\" value=\"raw\" CHECKED>\n";
print "List <input type=\"radio\" name=\"mode\" value=\"list\">\n";
print "</form>\n";



if ($arr{writeflag}){
    updateRecords();
    die;
}

my $sth = $dbh->prepare("select studid, lastname, firstname, studnum, 
  $resetfield from student order by lastname,firstname");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }


print "<center><h1>$schoolname ". $lex{'Transportation Type'};
print "</h1>\n";
print "<form action =\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";
print "<input type=\"submit\" value=\"". $lex{'Update Transportation Type'}. "\">\n";


# Just print table heading
print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Student}. "</th><th>". $lex{'Transportation Type'};
print "</th></tr>\n";


while (my ($studid, $lastname, $firstname, $studnum, $busroute) = 
       $sth->fetchrow){
    print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td><td>";

    if ($mode eq 'list') {
	print "<select name=\"$studid\"><option>$busroute</option>\n";
	foreach my $val (sort keys %resetvals) { print "<option>$val</option>"; }
	print "</select>\n";
    } else {
	print "<input name=\"$studid\" value=\"$busroute\" size=\"10\">";
    }

    print "</td></tr>\n";

} # End of loop 

print "<tr><td colspan=\"2\" align=\"center\">\n";
print "<input type=\"submit\" value=\"",$lex{'Update Transportation Type'},"\"></td>\n";
print "</tr></table></form>
 [ <a href=\"#top\">",$lex{'Back to Top'},"</a> ]</body></html>\n";



#----------------
sub updateRecords {
#----------------

    delete $arr{writeflag};

    my $sth = $dbh->prepare("select lastname, firstname, $resetfield
      from student where studid = ?");

    my $sth1 = $dbh->prepare("update student set $resetfield = ?
      where studid = ?");

    print "<h1>",$lex{'Update Bus Route'},"</h1>\n";
    print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
    print "<tr><th>Student</th><th>",$lex{'Transportation Type'},"</th></tr>\n";

    foreach my $key (keys %arr){
	# Get Student Records currently...
	$sth->execute($key);
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
	my ($lastname, $firstname, $busroute) = $sth->fetchrow;

	if ($busroute ne $arr{$key}){ # then update
	    $sth1->execute($arr{$key},$key);
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
	    print "<tr><td>$lastname, $firstname</td><td>$arr{$key}</td>";
	    print "</tr>\n";
	}
    }
    print "</table></body></html>\n";

}
