#! /usr/bin/perl

#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# TODO: ugly array stuff at bottom. other cleanup in the loop needed.

my %lex = ('Error' => 'Error',
	   'Schedule' => 'Schedule',
	   'Main' => 'Main',
	   'Bus Route Report' => 'Bus Route Report',
	   'Bussing Report' => 'Bussing Report',
	   'Students' => 'Students',
	   'Route' => 'Route',
	   'Name' => 'Name',
	   'Grade' => 'Grade',
	   'HRoom' => 'HRoom',
	   'Address' => 'Address',
	   'Ph' => 'Ph',
	   'Parent 1' => 'Parent 1',
	   'Parent 2' => 'Parent 2',
	   'View/Download' => 'View/Download',
	   'View Log File' => 'View Log File',
	   'Rm' => 'Rm',

	   );

use DBI;
use CGI;

# Basic Constants
my $logfile = "pdflog$$.txt";
my $shortname = "trans$$";
my $fileName = "$shortname.tex";
my $maxlines = 19;

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;
print $q->header( -charset, $charset );

if ($arr{maxstudents}) {
    $maxlines = $arr{maxstudents};
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
 $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

print "$doctype\n<html><head><title>". $lex{'Bus Route Report'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$schpage\">". $lex{Schedule}. "</a> ]\n";

my $sortorder = 'busroute, lastname, firstname';
my $route;
if($arr{route}){ $route = "where busroute = '$arr{route}'"; }

open(TEX,">$fileName") || die "Can't open tex file";

print TEX "\\documentclass[10pt,letterpaper]{article}
\\pagestyle{empty}
\\setlength{\\textwidth}{8in}
\\setlength{\\textheight}{10.6in}
\\setlength{\\hoffset}{-1.65in}
\\setlength{\\voffset}{-1.4in}
\\setlength{\\parindent}{0pt}
\\setlength{\\tabcolsep}{3.5pt}\n";


print TEX "\\begin{document}\n";

$sth = $dbh->prepare("select * from student $route 
  order by busroute, lastname, firstname");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die; }
$rows = $sth->rows;

$curroute = -1;
$studcount = 0;
for ( my $i=1; $i<=$rows; $i++ ) {
    my @arr = $sth->fetchrow;  # Read in a student record.

    foreach $element (@arr){ # Filter out any funny stuff to LaTeX
	$element =~ s/#/\\#/g;
	$element =~ s/&/\\&/g; 
    }

    $oldroute = lc($curroute);
    $curroute = lc($arr[56]);

    #remove any accidental spaces from the front or end of the route
    $curroute =~ s/^\s+//;
    $curroute =~ s/\s+$//; 
    #$curroute =~ s/#/\\#/; # Watch for pound symbol in route name.

   
   if ($linecount > $maxlines || $i eq 1 || $oldroute ne $curroute) 
   {  # We'll print a new page header here
       if ( $i ne "1" ) {
	   if($oldroute ne $curroute){
	       print TEX "Students: $studcount & & & &  \\\\ \\hline";
	       $studcount = 0;
	   }
	   print TEX "\\end{tabular}\\\\";
       }
       $linecount = 0;
       
       print TEX "\\newpage\n\\center{{\\bf $schoolname ". $lex{'Bussing Report'}. "} - $currdate \\\\ \n";
       print TEX "{\\bf ". $lex{Route}. ": $curroute}} \\\\ \n";
       print TEX "\\medskip\n\\begin{tabular}{|p{4.5cm}|p{4.0cm}|p{3.5cm}|p{3.5cm}|p{3.5cm}|}\n";
       print TEX "\\hline\n {\\bf ". $lex{Name}. "} & {\\bf ". $lex{Grade}. q{/}. $lex{HRoom};
       print TEX "} & {\\bf ". $lex{Address}. q{/}. $lex{Ph}. "} & {\\bf ". $lex{'Parent 1'};
       print TEX "} & {\\bf ". $lex{'Parent 2'}. "} \\\\ \n\\hline";

   } # End of New Page Header

    # Normal record printing.
    print TEX "{\\bf $arr[1]}, $arr[2] $arr[3] & Grade: $arr[5] & $arr[34] & $arr[29] & $arr[40] \\\\ \n";
    print TEX "($arr[4])  ". $lex{Rm}. ": $arr[6] & ". $lex{Ph}. ": $arr[30] & &  \\\\ \\hline \n"; 

    $linecount++;
    $studcount++;	
}  # End of For loop

print TEX $lex{Students}. ": $studcount & & & &  \\\\ \\hline\n\\end{tabular}\\\\ \n \\end{document}";
close TEX;

system("$pdflatex $fileName > $logfile");
system("mv $shortname.pdf $downloaddir");
system("mv $logfile $downloaddir");
system("rm -f $shortname.*");

print "<center><h1><a href=\"$webdownloaddir/$shortname.pdf\">\n";
print $lex{'View/Download'}. q{ }. $lex{'Bussing Report'}. "</a></h1>\n";
print "[ <a href=\"$webdownloaddir/$logfile\">". $lex{'View Log File'}. "</a> |\n";
print "<a href=\"$homepage\">". $lex{Main}. "</a> ]</center></body></html>\n";
