#!/usr/bin/perl
#  Copyright 2001-2006 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# transview - view transportation fields

my %lex = ('Main' => 'Main',
	   'Schedule' => 'Sched/Trans',
	   'View Transportation Fields' => 'View Transportation Fields',
	   'Student' => 'Student',
	   'Back to Top' => 'Back to Top',
	   'All' => 'All',
	   'Error' => 'Error',


	   );

my $self = 'transview.pl'; 

my $transtype = 'trans_type';

my $transfields = 'trans_type, trans_bus_stop_location, trans_name,
 trans_am_route, trans_pickup_time, trans_pm_route, trans_dropoff_time, 
 group_after_school_prog';

my @transfields = qw(trans_type trans_bus_stop_location trans_name 
 trans_am_route trans_pickup_time trans_pm_route trans_dropoff_time 
 group_after_school_prog);

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $select;
if ($arr{transtype} and $arr{transtype} ne $lex{All} ) { # no selection for All.
    $select = "where $transtype = ?";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# get distinct transtype values
my $sth = $dbh->prepare("select distinct $transtype from student 
 where $transtype != '' group by $transtype order by $transtype");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while (my $trans = $sth->fetchrow) {
    push @transtype, $trans;
}


# get descriptions for each field
my %fielddesc;
my $sth = $dbh->prepare("select fieldname from meta where 
  tableid = 'student' and fieldid = ?");
foreach my $fld (@transfields) {
    $sth->execute($fld);
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $desc = $sth->fetchrow;
    $fielddesc{$fld} = $desc;
}


# page heading
print "$doctype\n<html><head><title>". $lex{'View Transportation Fields'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body><a name=\"top\"></a>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> | ";
print "<a href=\"$schpage\">". $lex{Schedule}. "</a> ]\n";

# Selection Form.
print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"submit\" value=\"Select by\">\n";
print "<select name=\"transtype\">";
if ($arr{transtype}) { print "<option>$arr{transtype}</option>\n"; }
print "<option>". $lex{All}. "</option>\n";
foreach my $tr (@transtype) {
    print "<option>$tr</option>";
}
print "</select></form>\n";


my $sth = $dbh->prepare("select studid, lastname, firstname, studnum, 
  $transfields from student $select order by $transtype, lastname, firstname");
if ($select) { 
    $sth->execute($arr{transtype}); 
} else { 
    $sth->execute;
}
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }


print "<center><h1>". $lex{'View Transportation Fields'}. " &ndash; $schoolname</h1>\n";

# Just print table heading
print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Student}. "</th>\n";
foreach my $fld (@transfields) {
    print "<th>$fielddesc{$fld}</th>";
}
print "</tr>\n";


while (my ($studid, $lastname, $firstname, $studnum, @trans) = 
       $sth->fetchrow){
    print "<tr><td><b>$lastname</b>, $firstname ($studnum)</td>";
    foreach my $fld (@trans) {
	print "<td>$fld</td>";
    }
    print "</tr>\n";

} # End of loop 


print "</table>";
print " [ <a href=\"#top\">",$lex{'Back to Top'},"</a> ]\n";
print "</body></html>\n";
