#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# OUTLINE: Find the current term (from file or admin.conf
# settings). Find the distinct classes for this term and match to teachers
# in the subject file.

my %lex = ('Main' => 'Main',
	   'Schedule' => 'Schedule',
	   'Error' => 'Error',
	   'Day' => 'Day',
	   'Period' => 'Period',
	   'Location' => 'Location',
	   'No Subject' => 'No Subject',
	   'Current Date' => 'Current Date',
	   'No Term Found' => 'No Term Found',
	   'Term' => 'Term',
	   'Teacher Timetable' => 'Teacher Timetable',

	   );

my $maxterms = 12; # maximum # of terms to search for.

use DBI;
use CGI;
use Date::Business;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

# Set Date thingy's.
my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $day = $tim[3];
if (length($month) == 1){ $month = "0".$month;}
if (length($day) == 1){ $day = "0".$day;}
my $currdate = "$year-$month-$day";
my $currsdate = "$year$month$day";
my $currdate1 = "@month[$month] $day, $year";

my $date = $currsdate; # Short Date, no hyphens
my $dateobj = new Date::Business(DATE=>$date);

$q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


# Find the term
# open(TERM, "term") || die "Can't find the term number!";
# $term = <TERM>;

# Figure out the current term, if not passed term
$term = 0;
for (1..$maxterms){ 
    my $startdate = $g_termstart{$_}; $startdate =~ s/-//g;
    my $startobj = new Date::Business(DATE => $startdate);
    my $enddate = $g_termend{$_}; $enddate =~ s/-//g;
    my $endobj = new Date::Business(DATE => $enddate);
    $startoffset = $dateobj->diffb($startobj,'prev','next');
    $endoffset = $dateobj->diffb($endobj,'prev','next');
    # print "StartOffset: $startoffset  Endoffset: $endoffset<br>\n";

    if ($startoffset >= 0 and $endoffset <= 0){
	$term = $_; last;
    }
}

#Print HTML Page Header
print "$doctype\n<html><head><title>". $lex{'Teacher Timetable'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$schpage\">". $lex{Schedule}. "</a> ] ". $lex{Term}. " $term<center>\n";

if ( not $term ){ # No term found!
    print "<h1>". $lex{'No Term Found'}. "</h1>\n<p>";
    print $lex{'Current Date'}. " $date</p>\n";
    print "</body></html>\n";
    die;
}

$dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

# Now search for the teachers classes in this term and matching period
#  in schedule table.

$sth = $dbh->prepare("select distinct eval.subjcode, schedat.day, 
     schedat.period, subject.description, subject.teacher, 
     subject.location from eval 
     left outer join schedat  on eval.subjcode = schedat.subjsec
     left outer join subject on eval.subjcode = subject.subjsec
     where eval.term = '$term' 
     order by subject.teacher,schedat.day, schedat.period"); 
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

$currtch = "none";
while ( my ( $subjsec,$day,$period,$desc,$tch,$location ) = $sth->fetchrow ){

    $oldtch = $currtch;  $currtch = $tch;
    if ($currtch ne $oldtch){

	$displaytch = $currtch;
	$displaytch =~ s/\(.*\)//;

	print "</table><h1>$displaytch</h1><table cellpadding=\"3\" ";
	print "cellspacing=\"0\" border=\"1\"><tr><th>Subject</th>\n";

	print "<th>". $lex{Day}. "</th><th>". $lex{Period}. "</th><th>";
	print $lex{Location}. "</th></tr>\n";
    }

    if ( not $desc ){ $desc = "<font color=\"red\">". $lex{'No Subject'}. "</font>";}

    print "<tr><td><b>$desc</b> ($subjsec)</td><td>$day</td><td>$period</td>";
    print "<td>$location</td></tr>\n";;
}

print "</table></body></html>\n";
