#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

%lex = ( 'Edit' => 'Edit',
	 'Student Table' => 'Student Table',
	 'Main' => 'Main',
	 'Your student update is now stored' => 'Your student update is now stored',
	 'Bold' => 'Bold',
	 'Required Field' => 'Required Field',
	 'Cannot open' => 'Cannot open',
	 'Edit Another Student' => 'Edit Another Student',
	 'Main' => 'Main',
	 'There was an error storing your data' => 'There was an error storing your data',
	 'Contact' => 'Contact',
	 'Update Student Data' => 'Update Student Data',
	 'Withdrawn' => 'Withdrawn',
	 'Preregistration' => 'Preregistration',
	 'Record the following error' => 'Record the following error',
	 'Error' => 'Error',

	 
	 );

use CGI;
use DBI;

my $self = 'studed.pl';

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../lib/libmeta.pl";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;



# Don't make into 'my' vars...
$dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

if ( not $arr{tb} ) { # no passed table to edit...
    $arr{tb} = 'student';
}

if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    updateRecord();
}

# Select table to Edit.
my $table; # table to edit...
if ( $arr{tb} eq 'wd' ){ # if passed a tb=wd param, then edit alt table.
    $sth = $dbh->prepare("select * from studentwd where studid = ?");
    $wd = '<font color="red">'. $lex{Withdrawn}. '</font>';
    $table = 'studentwd';

} elsif ( $arr{tb} eq 'prereg' ){ # if tb=pre then edit prereg table.
    $sth = $dbh->prepare("select * from prereg where studid = ?"); 
    $wd = '<font color="red">'. $lex{Preregistration}. '</font>';
    $table = 'prereg';
} else {
    $sth = $dbh->prepare("select * from student where studid = ?"); 
    $table = 'student';
}

$sth->execute( $arr{recnum} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
@rec = $sth->fetchrow;
$studnum = $rec[4];

print "$doctype\n<html><head><title>". $lex{Edit}. ' '. $lex{'Student Table'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";
print "<h1>". $lex{Edit}. " $wd ", $lex{'Student Table'},"</h1>\n";


print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"recnum\" value=\"$arr{recnum}\">
<input type=\"hidden\" name=\"tb\" value=\"$table\">
<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";

print "<div>[ <b>". $lex{Bold}. "</b> = ". $lex{'Required Field'}. " ]\n";
print "<input type=\"submit\" value=\"". $lex{'Update Student Data'}. "\"></div>\n";

# Read in Template
unless ( open (FH,"<../template/student.tpl") ) {
    print $lex{'Cannot open'}. " template - $!\n";
    die $lex{'Cannot open'}. " template - $!\n";
}
my $text;
{ local $/; $text = <FH>; close FH;}

# Parse for simple field replacement / highlighting  <*name*> elements
while ( $text =~ m/\<\*(.*)\*\>/g){
    push @replace, $1;
}

#print "<br>Replacements:<br>\n",@replace,"<br>\n";

# Create Hash to hold replacement text.
foreach my $val (@replace){
    $replacement{$val} = &metaReplace('student',$val);
}

#print "<br>Replacement Text<br>\n",%replacement,"<br>\n";

# Now put replacement text back in.
$text =~ s{\<\*(.*?)\*\>}
          { exists($replacement{$1}) 
		  ? $replacement{$1} 
	          : $1
          }gsex;

# now parse for form entry replacement elements  <@name@> 
# Extract fields from template
while ( $text =~ m/\<\@(.*)\@\>/g){
    push @fields, $1;
}

# Preprocess Template for Values 
$text =~ s/\<\@studnum\@\>/$studnum/;

# get replacement values for fields
foreach my $val (@fields){
    $values{$val} = metaput($table,$val,$studnum,'edit');
}

# now put field values back into $text variable...
$text =~ s{ \<\@(.*?)\@\> }
{ exists($values{$1}) 
      ? $values{$1} 
  : "$values{$1}-$1"
  }gsex;

print $text,"\n";

print "<input type=\"submit\" value=\"". $lex{'Update Student Data'}. "\">\n";
print "</form></body></html>\n";


#---------------
sub updateRecord {
#---------------

    my $table = $arr{tb};
    delete $arr{tb}; # delete table value
    my $recnum = $arr{recnum};
    delete $arr{recnum};

    #foreach my $key (keys %arr){ print "K: $key  VAL: $arr{$key}<br>\n";}

    foreach my $key ( keys %arr ) {
	my $sth = $dbh->prepare("update $table set $key = ? where studid = ?");
	$sth->execute( $arr{$key}, $recnum );
	if ( $DBI::errstr ) { print $DBI::errstr; }
    }


    if ( not $DBI::errstr ) {
	print '<b>';
	print $lex{'Your student update is now stored'}. ".</b>\n";
    } else {
	print "<b>". $lex{'There was an error storing your data'};
	print $lex{Contact}. " $adminname ";
	print "<a href=\"mailto:$adminemail\">$adminemail</a>.";
	print $lex{'Record the following error'}. ": $DBI::errstr</b>\n";
    }

    print "<p>[ <a href=\"studeled.pl\">". $lex{'Edit Another Student'};
    print "</a> | <a href=\"$homepage\">". $lex{Main};
    print "</a> ]</p></body></html>\n";

    exit;

} # End of updateRecord
