#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = (
	   'Edit Student Tables' => 'Edit Student Tables',
	   'Current Students' => 'Current Students',
	   'Withdrawn Students' =>  'Withdrawn Students',
	   'Preregistered Students' =>  'Preregistered Students',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select studid, lastname, firstname, studnum 
 from student order by lastname, firstname");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
$rows = $sth->rows;

print "$doctype\n<html><head><title>",$lex{'Edit Student Tables'},
"</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">Main</a> |\n";
print "<a href=\"#curr\">",$lex{'Current Students'},"</a> |\n";
print "<a href=\"#withdrawn\">",$lex{'Withdrawn Students'},"</a> |\n";
print "<a href=\"#prereg\">",$lex{'Preregistered Students'},"</a> ]\n";

print "<center><h1>",$lex{'Edit Student Tables'},"</h1>\n";

if ( $rows < 1 ) {
    print "<p><b>". $lex{'No Student(s) Found'}. "</b></p>\n";
    print "</body></html>\n";
    die;
}


print "<a name=\"curr\"></a>\n";
print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<tr><th colspan=\"3\">",$lex{'Current Students'},"</th></tr>\n";

my $count = 1;
print "<tr>";

while (my ($id,$lastname, $firstname, $studnum) = $sth->fetchrow){
    print "<td><a href=\"studed.pl?recnum=$id\"><strong>$lastname</strong>, ";
    print "$firstname</a>($studnum)</td>\n";
    if (not ($count % 3)){ print "</tr>\n<tr>";}
    $count++;
}
if ($count % 3 == 2){ print "<td></td><td></td></tr>\n"; }
if ($count % 3 == 0){ print "<td></td></tr>\n"; }

print "</table><p></p>\n";

# --------- Withdrawn Students -------

$sth = $dbh->prepare("select studid, lastname, firstname, studnum 
 from studentwd order by lastname, firstname");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

print "<a name=\"withdrawn\">\n";
print "</a><table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<tr><th colspan=\"3\">",$lex{'Withdrawn Students'},"</th></tr>\n";

my $count = 1;
print "<tr>";

while (my ($id,$lastname, $firstname, $studnum) = $sth->fetchrow){
    print "<td><a href=\"studed.pl?tb=wd&recnum=$id\">";
    print "<strong>$lastname</strong>, ";
    print "$firstname</a>($studnum)</td>\n";
    if (not ($count % 3)){ print "</tr>\n<tr>";}
    $count++;
}
#if ($count % 3 == 1){} # nothing to be done...
if ($count % 3 == 2){ print "<td></td><td></td></tr>\n"; }
if ($count % 3 == 0){ print "<td></td></tr>\n"; }

print "</table><p></p>\n";
# ------- End of Withdrawn Students --------

# -------- Preregistered Students ----------
$sth = $dbh->prepare("select studid, lastname, firstname, studnum 
 from prereg order by lastname, firstname");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

print "<a name=\"prereg\"></a>\n";
print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<tr><th colspan=\"3\">",$lex{'Preregistered Students'},"</th></tr>\n";

my $count = 1;
print "<tr>";

while (my ($id,$lastname, $firstname, $studnum) = $sth->fetchrow){
    print "<td><a href=\"studed.pl?tb=prereg&recnum=$id\">";
    print "<strong>$lastname</strong>, ";
    print "$firstname</a>($studnum)</td>\n";
    if (not ($count % 3)){ print "</tr>\n<tr>";}
    $count++;
}
if ($count % 3 == 2){ print "<td></td><td></td></tr>\n"; }
if ($count % 3 == 0){ print "<td></td></tr>\n"; }

print "</table>\n";

# --------- End of Preregistered Students -----------

print "</center></body></html>\n";

