#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Entry Error' => 'Entry Error',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Student Search Results' => 'Student Search Results',
	   'Main' => 'Main',
	   'Name' => 'Name',
	   'last' => 'last',
	   'first or last or initials' => 'first or last or initials',
	   'Student Number' => 'Student Number',
	   'or' => 'or',
	   'Search' => 'Search',
	   'Cannot open' => 'Cannot open',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# passed value...
my $student = $arr{student};
$student =~ s/'/''/g;

prHtmlHead(); # Print the HTML Heading.

# Setup the Search
if ($student =~ /\d+/) {  # we have a student number
    $studentnumber = $student;
    $sth = $dbh->prepare("select * from student where studnum = '$student'");
} else { # we have words hopefully with a comma
    ($lastname,$firstname)  = split /\,/, $student;
    $firstname =~ s/^\s*//;
    $lastname =~ s/^\s*//;
    if ($lastname and $firstname){ # both entered.
	$sth = $dbh->prepare("select * from student 
         where lastname = '$lastname' and 
         firstname = '$firstname'");
    } elsif ($lastname and not $firstname){ # only lastname (no comma)
	if (length($lastname) == 2){ # search by initials: fi, li.
	    $fi = substr($lastname,0,1); $li = substr($lastname,1,1);
	    $sth = $dbh->prepare("select * from student 
              where lastname $sql{like} '$li%' and firstname $sql{like} '$fi%'");
	} else {
	    $sth = $dbh->prepare("select * from student 
             where lastname = '$lastname' order by firstname");
	}
    } else { # print an error....
	print '<p><b>'. $lex{'Entry Error'}. ': '. $lex{'No Student(s) Found'}.".</b></p>\n";
	print "</body></html>\n";
	die; 
    }

} # Last Else

$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
$rows = $sth->rows;
if ($rows < 1) { 
    print '<p><b>'. $lex{'No Student(s) Found'}. ".</b></p>\n";
    print "</body></html>\n"; 
    die; 
} 

print '<center><h1>'. $lex{'Student Search Results'}. "</h1>
 <table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";

my $sth2 = $dbh->prepare("select lastname, firstname, pic from student where studnum = ?");


# Loop through and display all records.
while (my @arr = $sth->fetchrow){

    # Setup for picture display
    $sth2->execute($arr[4]);

    my ($lastname, $firstname,$pic) = $sth2->fetchrow;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    if ($pic eq 'Y') {
       print "<tr><td colspan=\"5\" style=\"background-color:#DDD; text-align:left;\">";
       print "<img src=\"/pic-sm/$arr[4].jpg\" align=\"middle\">";
       print " <span style=\"font-size:200%;font-weight:bold;\">$firstname $lastname</td></tr>\n";
    }

    prStudentRecord(@arr);
} # End of Loop

print "</table><p>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]</p>\n";
mkSearchError();
print "</center></body></html>\n";


#-------------
sub metaVal {  # replace tag with current record value.
#-------------
    my ($table,$field,$arrayptr) = @_;
    # Passed table and fieldid, return value from current @arr array.
    # Find the record in the meta table
    my $sth = $dbh->prepare("select arrayidx from meta
     where tableid = '$table' and fieldid = '$field'");
    $sth->execute;
    if ($DBI::errstr){print $DBI::errstr; die $DBI::errstr;}
    my $arrayidx = $sth->fetchrow;
    #print "FLD: $field  IDX: $arrayidx  PTR: $arrayptr<br>\n";

    return ${$arrayptr}[$arrayidx];
}


#-------------
sub prHtmlHead {
#-------------
    print "$doctype\n<html><head><title>". $lex{'Student Search Results'}. "</title>";
    print "<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
    print "$chartype\n</head><body><div style=\"float:left;\">\n";
    print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]</div>\n";
    mkSearchError();
    print "<br clear=\"left\">\n";
}


#----------------
sub mkSearchError {
#----------------
    print "<div style=\"position:absolute;right:1em;\">\n";
    print "<form action=\"studsearch.pl\" method=\"post\">";
    print "<b>". $lex{Name}. "</b>(". $lex{last}. ','. $lex{'first or last or initials'};
    print ") ". $lex{or}. " <b>". $lex{'Student Number'}. "</b><br>\n";
    print "<input type=\"text\" name=\"student\" size=\"30\">\n";
    print "<input type=\"submit\" value=\"". $lex{Search}. "\"></form></div>\n";
}


#-------------------
sub prStudentRecord {
#-------------------
    # print the student record (as a row in a table)
    # Passed in values: @arr (data), $picdirurl, $cgiurl
    # Also read in template value.
    my @arr = @_;  # passed student record array

    unless ( require "../lib/libmeta.pl"){
	print $lex{'Cannot open'}. " libmeta.pl\n";
	die $lex{'Cannot open'}. " libmeta.pl\n";
    }

    # Read in Template
    unless (open (FH,"<../template/studsearch.tpl")) {
	print $lex{'Cannot open'}. " template file: $!\n";
	die $lex{'Cannot open'}. " template file: $!\n";
    }
    my $text;
    { local $/; $text = <FH>; close FH;}


    # Parse for simple field value replacement / highlighting  <#name#> elements
    while ( $text =~ m/\<\#(.*?)\#\>/g){
	push @replace, $1;
    }

    # Create Hash to hold replacement value (from student record).
    foreach my $val (@replace){
	$replacement{$val} = &metaVal('student',$val,\@arr);
    }

    #print "<br>Replacement Text<br>\n",%replacement,"<br>\n";

    # Now put replacement text back in.
    $text =~ s{\<\#(.*?)\#\>}
              { exists($replacement{$1}) 
		  ? $replacement{$1} 
	          : $1
	      }gsex;
    print $text,"\n";

} # End of NewPrStudentRecord
