#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('View Students' => 'View Students',
	   'Hospital List' => 'Hospital List',
	   'Health Num' => 'Health Num',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Main' => 'Main',
	   'Mini Student Roster' => 'Mini Student Roster',
	   'Name' => 'Name',
	   'Email' => 'Email',
	   'Studnum' => 'Studnum',
	   'Provnum' => 'Provnum',
	   'Sex' => 'Sex',
	   'HRm' => 'HRm',
	   'HPhone' => 'HPhone',
	   'Parent(s)' => 'Parent(s)',
	   'Sort by' => 'Sort by',
	   'Error' => 'Error',

	   );

my $self = 'studviewmini.pl';

use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
$yday, $iddst) = localtime(time);
my $year = $year + 1900;
$mon++;
$currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

my $select;
if ($arr{select} eq $lex{'Grade'}) {
    $select = "where grade = '$arr{value}'";
} elsif ($arr{select} eq $lex{'Homeroom'}) {
    $select = "where homeroom = '$arr{value}'";
}

my $sortorder = "lastname, firstname";
if ($arr{sortorder} eq $lex{'Grade'}) {
    $sortorder = "grade, lastname, firstname";
} elsif ($arr{sortorder} eq $lex{'Homeroom'}) {
    $sortorder = "homeroom, lastname, firstname";
} else { $arr{sortorder} = $lex{Name}; }

# print top of Page
print "$doctype\n<html><head><title>". $lex{'View Students'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>\n";


# Print start of table
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">
<tr><td>[ <a href=\"$homepage\">". $lex{Main}. "</a> |
</td>\n";
# Selection Form.
print "<td><form action=\"$self\" method=\"post\">
<input type=\"submit\" value=\"". $lex{'Sort by'}. "\"> 
<select name=\"sortorder\">
<option>$arr{sortorder}</option><option>". $lex{Name};
print "</option><option>". $lex{Homeroom}. "</option><option>". $lex{Grade};
print "</option></select>\n";

print "<input type=\"submit\" name=\"hospitallist\" value=\"". $lex{'Hospital List'};
print "\"></form></td></tr></table>\n";


# Do jump to Hospital List, if selected.
if ($arr{hospitallist}) {
    doHospitalList();
    die;
}


# Do the select for mini roster.
$sth = $dbh->prepare("select lastname, firstname, initial, studnum,provnum,
  grade, sex, homeroom, hphone1,name1, name2, email 
  from student $select order by $sortorder");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

# Print Mini Roster
print "<center><h1>". $lex{'Mini Student Roster'}. "</h1><h3>$currdate</h3>\n";
print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">".
 '<tr><th>'. $lex{Name}. '</th><th>'. $lex{Email}. '</th><th>'. $lex{Studnum}.
 '</th><th>'.$lex{Provnum}. '</th><th>'. $lex{Grade}. '</th><th>'. $lex{Sex}.
 '</th><th>'. $lex{'HRm'}. '</th><th>'. $lex{'HPhone'}. '</th><th>'.
 $lex{'Parent(s)'}. "</th></tr>\n";

while (my ($lastname, $firstname, $initial, $studnum, $provnum, $grade, 
 $sex, $homeroom, $hphone1, $parent1, $parent2, $email) = $sth->fetchrow) {
    print "<tr><td><b>$lastname, $firstname $initial</b></td>";
    print "<td><a href=\"mailto:$email\">$email</a></td>";
    print "<td>$studnum</td>\n";
    print "<td>$provnum</td><td>$grade</td>\n";
    print "<td>$sex</td><td>$homeroom</td>\n";
    print "<td>$hphone1</td><td>$parent1 | $parent2</td>\n";

    print "</tr>\n";
}

print "</table></center></body></html>\n";



#---------------
sub doHospitalList {
#---------------

    # Do the select
    my $sth = $dbh->prepare("select lastname, firstname, initial, healthid, grade,
      hphone1,name1, name2 from student $select order by $sortorder");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
   
    # print page head
    print "<center><h1>". $lex{'Hospital List'}. "</h1><h3>$currdate</h3>\n";
    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";

    # start table.
    print '<tr><th>'. $lex{Name}. '</th><th>' .$lex{'Health Num'}. "</th>\n";
    print '<th>'. $lex{Grade}. '</th><th>'. $lex{'HPhone'}. '</th><th>';
    print $lex{'Parent(s)'}. "</th></tr>\n";

    while (my ($lastname, $firstname, $initial, $healthnum, $grade, $hphone1, $parent1, $parent2) 
	   = $sth->fetchrow) {
	print "<tr><td><b>$lastname, $firstname $initial</b></td>";
	print "<td>$healthnum</td><td>$grade</td>\n";
	print "<td>$hphone1</td><td>$parent1 | $parent2</td>\n";
	print "</tr>\n";
    }

    print "</table></center></body></html>\n";


} # End of doHospitalList



