#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Error' => 'Error',
	   'Edit Translation' => 'Edit Translation',
	   'Eoy' => 'Eoy',
	   'Search' => 'Search',
	   'Original Text' => 'Original Text',
	   'Translated Text' => 'Translated Text',
	   'Both' => 'Both',
	   'Continue' => 'Continue',
	   'Start of Phrase' => 'Start of Phrase',
	   'Everywhere in Phrase' => 'Everywhere in Phrase',
	   'Translation' => 'Translation',
	   'Blank=All' => 'Blank=All',
	   'Removed Phrases' => 'Removed Phrases',
	   'Delete' => 'Delete',
	   'Phrase' => 'Phrase',
	   'Translation' => 'Translation',
	   'Deleted' => 'Deleted',
	   'Count' => 'Count',

	   );

my $self = 'xlatTransEdit.pl';
my $maxfieldlength = 70; # max size for text input fields; doesn't limit input.

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset); 
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Edit Translation'};
print "</title><link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">\n";
print "$chartype\n</head><body>\n";

print "[ <a href=\"$homepage\">". $lex{Main}. "</a> |\n";
print "<a href=\"$eoypage\">". $lex{Eoy}. "</a> ]\n";
print "<center><h1>". $lex{'Edit Translation'}. "</h1></center>\n";

if ( not $arr{page} ) {
    showStartPage();
} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    showChoices();
} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    updateRecords();
} elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    deleteExtra();
}

 

#----------------
sub showChoices {
#----------------

    # foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }
    # Passed: sposition, sphrase and sgroup

    # Create select based on group, as well look
    my ( $select, $phrase, $table );
    if ( $arr{sphrase} ) {
	if ( $arr{sposition} eq $lex{'Start of Phrase'} ) {
	    $phrase = $dbh->quote( $arr{sphrase}. q{%} );
	} else {
	    $phrase = $dbh->quote( q{%}. $arr{sphrase}. q{%} ); # do both ends with %
	}
    } 

    my %phrases = ();
    my %trans = ();

    # Search translation table first for phrases; Then able to compare
    # with phrase table to see if there are extra (or missing) values
    # in the translation table. Extra values should be
    # removed. Missing value could be flagged.

    if ( $arr{sgroup} eq 'both' or $arr{sgroup} eq 'translation' ) {
	my $select = "where phrase != '' and phrase is not null";
	if ( $phrase ) { $select .= " and translation like $phrase"; }
	$table = 'xlat_lang';

	my $sth = $dbh->prepare("select phrase from $table $select"); 
	# no 'distinct'; no dups.
	$sth->execute;
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	while ( my $phrase = $sth->fetchrow ) {
	    $phrases{$phrase} = 1;
	    $trans{$phrase} = 1;
	}
    }


    # Search xlat_phrase table (phrase table)
    if ( $arr{sgroup} eq 'phrase' or $arr{sgroup} eq 'both' ) {

	my $select = "where phrase != '' and phrase is not null";
	if ( $phrase ) { $select .= " and phrase like $phrase"; }

	my $sth = $dbh->prepare("select phrase from xlat_phrase $select");
	$sth->execute;
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	while ( my $phrase = $sth->fetchrow ) {

	    # remove translation marker; any values left in %trans
	    # have been removed from xlat_phrase; 
	    if ( $trans{$phrase} ) { 
		delete $trans{$phrase}; 
	    } 
	    $phrases{$phrase} = 1; 
	} 
    }


    # We should now have the %phrases hash fully populated ( from 1 or both tables )

    # print form header.
    print "<center><table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";
    print "<tr><td colspan=\"2\" align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";

    my $sth = $dbh->prepare("select id, translation, phrase from xlat_lang where phrase = ?");

    foreach my $phrase ( sort keys %phrases ) {

	$sth->execute( $phrase );
	my  ( $id, $translation, $testphrase ) = $sth->fetchrow;

	while ( $testphrase and ( $phrase ne $testphrase ) ) {
	    print "<font color=\"red\">ERROR: PH:$phrase  TEST: $testphrase</font><br>\n";
	    ( $id, $translation, $testphrase ) = $sth->fetchrow;
	}

	if ( not $id ) { # No record yet in trans table, use id of phrase table

	    my $sth1 = $dbh->prepare("select id, phrase from xlat_phrase where phrase = ?");
	    $sth1->execute( $phrase );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    my ($pid, $testphrase);
	    while ( ( $pid, $testphrase ) = $sth1->fetchrow ) {
		if ( $testphrase ne $phrase ) { next; } else { last; }
	    }
	    if ( not $pid ) { print "Phrase ID not found for: $phrase<br>\n"; die; }
	    $id = "A-$pid";
	    $translation = '';
	}

	# filter tag identifiers
	$phrase =~ s/</&lt;/g;
	$phrase =~ s/>/&gt;/g;

	print "<tr><td align=\"right\">$phrase</td><td align=\"left\">";
	print "<input type=\"text\" name=\"$id\" value=\"$translation\" size=\"$maxfieldlength\">";
	print "</td></tr>\n";

    }


    # print form footer.
    print "<tr><td colspan=\"2\" align=\"center\">";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";
    print "</form></table>\n";

    if ( %trans ) {
	my $count = 1;

	print "<p><hr></p>\n";
	print "<h1>". $lex{'Removed Phrases'}. "</h1>\n";

	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
	print "<form action=\"$self\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"page\" value=\"3\">\n";

	print "<tr><td colspan=\"4\" align=\"center\">";
	print "<input type=\"submit\" value=\"". $lex{Delete}. "\"></td></tr>\n";

	print "<tr><th>". $lex{Count}. "</th><th>".  $lex{Delete}. "</th><th>";
	print $lex{Phrase}. "</th><th>". $lex{Translation}. "</th></tr>\n"; 

	my $sth = $dbh->prepare("select id, translation from xlat_lang where phrase = ?");

	foreach my $phrase ( sort keys %trans ) {

	    $sth->execute( $phrase );
	    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	    my ( $id, $translation ) = $sth->fetchrow;
	    my $trows = $sth->rows;
	    if ( $trows > 1) { $trows = "<font color=\"red\">$trows</font>"; }
	    

	    # filter tag identifiers
	    $phrase =~ s/</&lt;/g;
	    $phrase =~ s/>/&gt;/g;
	    print "<tr><td>$trows</td>";
	    print "<td><input type=\"checkbox\" name=\"$id\" value=\"1\"></td>\n";
	    print "<td>$count. $phrase</td>";

	    $translation =~ s/</&lt;/g;
	    $translation =~ s/>/&gt;/g;
	    print "<td>$translation</td></tr>\n";
	    $count++;

	}

	print "<tr><td colspan=\"4\" align=\"center\">";
	print "<input type=\"submit\" value=\"". $lex{Delete}. "\"></td></tr>\n";
	print "</table></form>\n";

    } # end of Redundant Phrase

    print "</body></html>\n";

    exit;

}


#----------------
sub deleteExtra {
#----------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $sth = $dbh->prepare("delete from xlat_lang where id = ?");
    my $sth1 = $dbh->prepare("select phrase, translation from xlat_lang where id = ?");

    foreach my $id ( sort keys %arr ) {
	$sth1->execute( $id );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	my ( $phrase, $translation ) = $sth1->fetchrow;

	$sth->execute( $id );
	if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

	print "<p>$phrase | $translation <b>". $lex{Deleted}. "</b></p>\n";
    }

    exit;

}


#----------------
sub showStartPage {
#----------------

    print "<center><table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<tr><td align=\"right\" colspan=\"2\">". $lex{Search};
    print " <input type=\"text\" name=\"sphrase\" size=\"10\"></td><td>";
    print "<select name=\"sposition\"><option>". $lex{'Start of Phrase'}. "</option>";
    print "<option>". $lex{'Everywhere in Phrase'}. "</option></select>\n";
    print $lex{'Blank=All'}. "</td></tr>\n";

    print "<tr><td align=\"right\">". $lex{'Original Text'};
    print "</td><td><input type=\"radio\" name=\"sgroup\" value=\"phrase\">";
    print "</td></tr>\n<tr><td align=\"right\">";
    print $lex{'Translated Text'}. "</td><td>";
    print "<input type=\"radio\" name=\"sgroup\" value=\"translation\">";
    print "</td></tr>\n<tr><td align=\"right\">";
    print $lex{Both}. "</td><td><input type=\"radio\" name=\"sgroup\" value=\"both\" checked>";
    print "</td></tr>\n";

    print "<tr><td colspan=\"2\" align=\"right\">";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";
    print "</form></table></body></html>\n";

    exit;

}


#---------------
sub updateRecords {
#---------------
    
    #foreach my $key ( sort keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    print "<center><table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print '<tr><th>'. $lex{Translation}. "</th></tr>\n";

    my $sth = $dbh->prepare("select phrase, translation from xlat_lang where id = ?");
    my $sth1 = $dbh->prepare("update xlat_lang set translation = ? where id = ?");

    foreach my $key ( sort keys %arr ) {  # $key contains record id (or A-number if new)

	if ( $key =~ m/^\d+/ ) { # if a digit

	    # Read stored translation
	    $sth->execute( $key );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    my ( $phrase, $oldtrans ) = $sth->fetchrow;

	    if ( $oldtrans eq $arr{$key} ) { next; } # skip this one since not changed.

	    # update record
	    $sth1->execute( $arr{$key}, $key );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    print "<tr><td>". $arr{$key}. "</td></tr>\n";

	} elsif ( $arr{$key} ) { # if we have a value to insert...

	    my ( $dud, $phraseid ) = split /-/, $key;
	    my $sth = $dbh->prepare("select phrase from xlat_phrase where id = ?");
	    $sth->execute( $phraseid );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    my $phrase = $sth->fetchrow;
	    print "Phrase: $phrase  Value: $arr{$key}<br>\n";

	    my $sth2 = $dbh->prepare("insert into xlat_lang ( phrase, translation ) 
              values( ?, ?)");
	    $sth2->execute( $phrase, $arr{$key} );
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    print "<tr><td>". $arr{$key}. "</td></tr>\n";

        }

    }

    print "</table>\n";
    print "<p>[ <a href=\"$eoypage\">". $lex{Eoy}. "</a> ]\n";
    print "</p></center></body></html>\n";

    exit;

} # End of writeRecords
