#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.
#  Add choice chips (wise choices)

my $defaultForms = 2; # number of entry forms per student.

my %lex = ('Add Choice Chips' => 'Add Choice Chips',
	   'Main' => 'Main',
	   'Save Chips' => 'Save Chips',
	   'Previous Week' => 'Previous Week',
	   'Next Week' => 'Next Week',
	   'Name' => 'Name',
	   'Category' => 'Category',
	   'Missing Date' => 'Missing Date',
	   'Add More Chips' => 'Add More Chips',
	   'Chips Added' => 'Chips Added',
	   'Fill Value' => 'Fill Value',
	   'Error' => 'Error',
	   'Homeroom' => 'Homeroom',

	   );


my $self = 'chipadd.pl';

use DBI;
use CGI;
use Time::JulianDay;
use Date::Business;


# Read config variables
eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../etc/choices.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
my $cookieuser = $q->cookie($divcookie);
print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

# Open Database
my $dsn = "DBI:$dbtype:$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $points;
if ( $arr{defaultPoints} ) {
    $points = $arr{defaultPoints};
    delete $arr{defaultPoints};
}

my $select;
my $homeroomtitle;
if ($arr{homeroom}) {
    my $homeroom = $dbh->quote( $arr{homeroom} );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    $select = 'where homeroom = '. $homeroom;
    $homeroomtitle = "<b>". $lex{Homeroom}. ":</b> $arr{homeroom}";
}


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Add Choice Chips'};
print "</title>\n<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$tchpage\">". $lex{Main};
print "</a> ]\n";
print '<center><h1>'. $lex{'Add Choice Chips'}. "</h1>\n";


if (not $schoolstart){ $schoolstart = $g_termstart{1};}
my ($styear,$stmonth,$stday) = split /-/,$schoolstart;
my ($endyear,$endmonth,$endday) = split /-/,$schoolend;
$startjd = julian_day($styear,$stmonth,$stday);
$endjd = julian_day($endyear,$endmonth,$endday);

my ($jd, $mondayjd, $currdate, $currsdate);
my ($day, $month, $year);

if ($arr{flag}) {
    delete $arr{flag};
    writeRecord();
    die;

} elsif ($arr{date}) { # if passed a date.

    # Generate a list from those dates. Assume year-mon-day
    ($year,$month,$day) = split /-/,$arr{date};

    $jd = julian_day($year,$month,$day);
    $dow = day_of_week($jd) + 1; # since now 1 = Sunday
    $mondayjd = $jd - ($dow-1);

    # Check for date before start of year; reset to year start.
    #if ($mondayjd < $startjd ){ $mondayjd = $startjd;}

    if (length($month) == 1){ $month = "0".$month;}
    if (length($day) == 1){ $day = "0".$day;}
    $currsdate = "$year$month$day"; 
    $currdate = "$year-$month-$day";


} else {

    my @tim = localtime(time);
    $year = $tim[5] + 1900;
    $month = $tim[4] + 1;
    $day = $tim[3];

    $jd = julian_day($year,$month,$day);
    $mondayjd = $jd - ($tim[6]-1); #This will now give Monday of that week.
    if (length($month) == 1){ $month = "0".$month;}
    if (length($day) == 1){ $day = "0".$day;}
    $currdate = "$year-$month-$day";
    $currsdate = "$year$month$day";

} 

# Now print the option to fill with default Points value
print "<div style=\"position:absolute; top:3em; left:1em;\">\n";
print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"date\" value=\"$currdate\">
<input type=\"hidden\" name=\"homeroom\" value=\"$arr{homeroom}\">
<input type=\"text\" name=\"defaultPoints\" size=\"4\" value=\"$defaultPoints\">
<input type=\"submit\" value=\"". $lex{'Fill Value'}. "\"></form></div>\n";


$dateobj = new Date::Business(DATE=>$currsdate);

# Setup Array and Hash to hold Dates and DOW Dates (Multi-Day Method)
my $weekcount = 1; # Number of weeks to do for entry. (normally 1 or 2)
mkDateData($mondayjd,$weekcount);
# creates @days and @datedata


$prevjd = $mondayjd - 7;

if ($prevjd < $startjd){ $prevjd = $startjd;}

($prevyear, $prevmonth, $prevday) = inverse_julian_day($prevjd);
$prevdate = "$prevyear-$prevmonth-$prevday";

print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">
<tr><td>
  <form action=\"$self\" method=\"post\">
  <input type=\"hidden\" name=\"date\" value=\"$prevdate\">
  <input type=\"hidden\" name=\"homeroom\" value=\"$arr{homeroom}\">
  <input type=\"submit\" value=\"<= ". $lex{'Previous Week'}. "\"></form>
  </td>\n";

$nextjd = $mondayjd + 7; 
if ($nextjd > $endjd){ $nextjd = $endjd;}
($nextyear, $nextmonth, $nextday) = inverse_julian_day($nextjd);
$nextdate = "$nextyear-$nextmonth-$nextday";

print "<td><form action=\"$self\" method=\"post\">
  <input type=\"hidden\" name=\"date\" value=\"$nextdate\">
  <input type=\"hidden\" name=\"homeroom\" value=\"$arr{homeroom}\">
  <input type=\"submit\" value=\"". $lex{'Next Week'}. " =>\"></form>
  </td></tr></table>\n\n";



# Start the form.
print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"flag\" value=\"1\">
<input type=\"hidden\" name=\"homeroom\" value=\"$arr{homeroom}\">\n";

print "<div style=\"padding:0.3em;\"><input type=\"submit\" value=\"";
print $lex{'Save Chips'}. "\"></div>\n";

# Get all/selected students
my @students;
my $sth = $dbh->prepare("select lastname, firstname, studnum from student
  $select order by lastname, firstname");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}    


# Get Date Info
print "<div style=\"border:1px solid black;padding:0.5em; width:50%;\">";

print "<b>Date</b> <select name=\"date\">\n";
for ($i=1;$i<=5;$i++) {
    ($wkyear, $wkmonth, $wkday) = inverse_julian_day($mondayjd);
    $dow = day_of_week($mondayjd) + 1;
    print "<option";
    if ($wkmonth == $month and $wkday == $day) {
	print " selected";
    }
    print ">$dow[$dow], $wkyear-$wkmonth-$wkday</option>\n";
    $mondayjd++;
}

print "</select></div>\n";
#print '<tr><th>'. $lex{Name}. '</th><th>'. $lex{Category}. '</th><th></tr>\n";

# Setup Table
print "<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\">\n";
print "<caption>$homeroomtitle</caption>\n";


my $count = 0;

# Loop through all students displaying name, etc.
while (my ($lastname, $firstname, $studnum) = $sth->fetchrow){
    #if ($stylemode){ $stylemode = ''; } else { $stylemode = 'style="background-color:#CCC;"'; }


    if ($count % 5 == 0) {
	print q{<tr><th></th>};
	foreach my $cat (@category) { # loaded from choices.conf    
	    print "<th>$cat</th>";
	}
	print "</tr>\n";
    }

    print "<tr $stylemode><td><b><i>$lastname</i>, $firstname</b></td>\n";

    foreach my $cat (@category) { # loaded from choices.conf    
	# print category cell
	print "<td><input type=\"text\" name=\"$cat:$studnum\" size=\"3\" ";
	print "value=\"$points\"></td>";
    }
    print "</tr>\n";
    
    $count++;

} # End of student loop.


print "</table>\n";

print "<p><input type=\"submit\" value=\"". $lex{'Save Chips'}. "\"></p></form>\n";


print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
foreach my $key ( sort keys %category ) {
    print "<tr><th>$key</th><th>$category{$key}</th></tr>\n";
}
print "</table></body></html>\n";



#--------------
sub writeRecord {
#--------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }
    #die;

    # Die if missing date fields; 
    if ( not $arr{date} ) {
	print '<h1>'. $lex{'Missing Date'}. "!</h1>\n";
	die;
    }
    print "</center>\n";

    my $homeroom;
    if ($arr{homeroom}) {
	$homeroom = $arr{homeroom};
	delete $arr{homeroom};
    }

    my ($day, $date) = split /,/, $arr{date};
    my $date = $dbh->quote($date);
    delete $arr{date};

    my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
    my $count = 1;
    my $dupcount = 1;
RECORD:
    foreach my $key (keys %arr) {

	# split key apart to get category and studnum;
	my ($cat,$studnum) = split /:/, $key;
	if ($arr{$key} =~ /\D/) { next RECORD; }
	if ( $arr{$key} < 1) {
	    #print "Points:$points:<br>\n";
	    next RECORD;
	}
	my $points = $dbh->quote($arr{$key});

	# Check for duplicates for this date, student, and category.
	my $sth = $dbh->prepare("select count(*) from choices where cdate = $date and 
         studnum = $studnum and category = '$cat'");
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }    
	my $ct = $sth->fetchrow;
	if ( $ct > 0 ) {
	    $sth1->execute($studnum);
	    my ($lastname, $firstname) = $sth1->fetchrow;
	    print "$dupcount: Duplicate for student: <b>$firstname $lastname</b> ($studnum)";
	    print "Date: <b>$date</b> Cat: <b>$cat</b> Skipping!<br>\n";
	    $dupcount++;
	    next RECORD;
	}

	$cat = $dbh->quote($cat);
	$sth = $dbh->prepare("insert into choices values (
          $sql{default}, $studnum, $date, $cat, NULL, $points, NULL)");
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$sth1->execute($studnum);
	my ($lastname, $firstname) = $sth1->fetchrow;
	print "$count: <b>$firstname $lastname</b> ($studnum) Date:<b>$date</b> Cat:<b>$cat</b><br>\n";
	$count++;
	
    }

    print '<p><b>'. $lex{'Chips Added'}. "</b></p>\n";
    print "<p>[ <a href=\"$tchpage\">". $lex{Main}. "</a> |\n";
    print "<a href=\"$self?homeroom=$homeroom\">". $lex{'Add More Chips'}. "</a> ]</p>\n";

    print "</body></html>\n";

}


#-------------
sub mkDateData {
#-------------
    my ($jd, $weeks) = (@_);
    # Build an array of ISO dates and a hash using them
    # as keys to hash values of 'Mon Jan 6' format.
    # If one week, then just 5 values, if two wk then 10, etc.
    for (1..$weeks){
	for (1..5){
	    my ($yr,$mon,$day) = inverse_julian_day($jd);
	    my $dow = day_of_week($jd) + 1;
	    push @days, "$yr-$mon-$day";
	    $datedata{"$yr-$mon-$day"} = "$dow[$dow], $month[$mon] $day";
	    $jd++;
	}
	$jd = $jd + 2; # skip over weekend.
    }
}
