#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Script to show chips to allow editing or deleting.

my %lex = ('View/Edit Chips' => 'View/Edit Chips',
	   'Main' => 'Main',
	   'Date' => 'Date',
	   'Code' => 'Code',
	   'Category' => 'Category',
	   'Pt' => 'Pt',
	   'Comment' => 'Comment',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'Homeroom' => 'Homeroom',
	   'Top' => 'Top',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../etc/choices.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my ($select, $hrm);
if ($arr{homeroom}) {
    $hr = $dbh->quote($arr{homeroom});
    $select = " and student.homeroom = $hr";
    $nameselect = "where student.homeroom = $hr";
}

# Create a list of names for linkages...
my $sth = $dbh->prepare("select firstname, lastname, studnum from student
  $nameselect order by lastname, firstname");
$sth->execute;
while ( my ($lastname, $firstname, $studnum) = $sth->fetchrow ) {
    push @students, "$firstname $lastname:$studnum";
}


my $fieldlist = "choices.id, choices.studnum, choices.cdate, choices.category, choices.ccode,
 choices.points, choices.comment, student.lastname, student.firstname";

$sth = $dbh->prepare("select $fieldlist from choices, student
  where choices.studnum = student.studnum $select
  order by student.lastname, student.firstname, choices.cdate");

$sth->execute;
if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr;}
my $rows = $sth->rows;

# Show Page Header.
print "$doctype\n<html><head><title>". $lex{'View/Edit Chips'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
</head><body><a name=\"top\"></a>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]
<center><h1>". $lex{'View/Edit Chips'}. "</h1>\n";

# Print homeroom if one selected.
if ( $arr{homeroom} ) {
    print '<b>'. $lex{'Homeroom'}. ": $arr{homeroom}</b><br>\n";
}

# print students
print "[ ";
for my $rec ( @students ) {
    my ($name, $studnum) = split /:/, $rec;
    print "<a href=\"\#$studnum\">$name</a> | \n";
}
print " ]<br>\n";


my $currstud = -1;
my $oldstud;

for ( my $i=1; $i <= $rows; ++$i) {
    my ($id, $studnum, $cdate, $category, $ccode, $points, $comment, $lastname, $firstname)
	= $sth->fetchrow;
   
    $oldstud = $currstud;
    $currstud = $studnum;

    if ($oldstud ne $currstud ) {  # We have a new student
	if ($i != 1) {  # close previous list
	    print "</table>";
	}

	print "<a name=\"$studnum\"></a><h3>$firstname $lastname ($studnum)&nbsp;";
	print "[ <a href=\"#top\">". $lex{Top}. "</a> ]</h3>";
	
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print '<tr><th>'. $lex{Date}. '</th><th>'. $lex{Category}. '</th><th>'. $lex{Code};
	print '</th><th>'. $lex{Pt}. '</th><th>'. $lex{Comment};
	print '</th><th>'. $lex{Edit}. '</th><th>'. $lex{Delete}. "</th></tr>\n";      
    }

    print "<tr><td><b>$cdate</b></td><td>$category</td><td>$ccode</td>\n";
    print "<td>$points</td><td>$comment</td>\n";

    print "<td><a href=\"chiped.pl?id=$id\">". $lex{Edit}. "</a></td>\n";
    print "<td><a href=\"chipdel.pl?id=$id\">". $lex{Delete}. "</a></td></tr>\n";

} # End of loop counter

print "</ul></body></html>\n";
