#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

my %lex = ('Edit Chips' => 'Edit Chips',
	   'Main' => 'Main',
	   'Update Chips' => 'Update Chips',
	   'Date' => 'Date',
	   'Comment' => 'Comment',
	   'Code' => 'Code',
	   'Points' => 'Points',
	   'Category' => 'Category',
	   'View/Edit Chips' => 'View/Edit Chips',
	   'Chips Updated' => 'Chips Updated',
	   'Error' => 'Error',

	   );


my $self = 'chiped.pl';

use DBI;
use CGI;

# Read config variables
eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

eval require "../etc/choices.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $id = $arr{id};
delete $arr{id};

# Open Database
my $dsn = "DBI:$dbtype:$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Edit Chips'};
print "</title>\n<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";
print '<center><h1>'. $lex{'Edit Chips'}. "</h1>\n";

if ( $arr{flag} ) {
    delete $arr{flag};
    updateRecord();
}


# Get record and then student name
my $sth = $dbh->prepare("select * from choices where id = ?");
$sth->execute($id);
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my ($id1, $studnum, $cdate, $category, $ccode, $points, $comment) = $sth->fetchrow;

$sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
$sth->execute($studnum);
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
my ($lastname, $firstname) = $sth->fetchrow;


# Start the form.
print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"flag\" value=\"1\">
<input type=\"hidden\" name=\"id\" value=\"$id\">
<p><input type=\"submit\" value=\"". $lex{'Update Chips'}. "\"></p>\n";


print "<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\">\n";
print "<tr><th align=\"center\" colspan=\"2\"><b>$firstname $lastname</b></th></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Date'};
print "</b></td>\n<td><input type=\"text\" name=\"cdate\" size=\"12\" value=\"$cdate\"></td></tr>\n";

# print category cell
print "<tr><td align=\"right\"><b>". $lex{'Category'}. "</td>";
print "<td><select name=\"category\"><option>$category</option>\n";
foreach my $cat (@category) { # loaded from choices.conf
    print "<option>$cat</option>";
}
print "</select></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Code'};
print "</b></td>\n<td><input type=\"text\" name=\"ccode\" size=\"8\" value=\"$ccode\"></td></tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Points'};
print "</b></td>\n<td><input type=\"text\" name=\"points\" size=\"4\" value=\"$points\"></td></tr>\n";

print "<tr><td colspan=\"2\"><b>". $lex{Comment}. "</b><br>\n";
print "<textarea name=\"comment\" cols=\"50\" rows=\"4\">$comment</textarea></td></tr>\n";
print "</table>\n";

print "<p><input type=\"submit\" value=\"". $lex{'Update Chips'}. "\"></p>
</form></body></html>\n";



#--------------
sub updateRecord {
#--------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    # Filter
    my $cdate = $dbh->quote($arr{cdate});
    my $category = $dbh->quote($arr{category});
    my $ccode = $dbh->quote($arr{ccode});
    my $points = $dbh->quote($arr{points});
    my $comment = $dbh->quote($arr{comment});

    my $sth = $dbh->prepare("update choices set
     points = $points, cdate = $cdate,
     category = $category, ccode = $ccode, 
     comment = $comment
    where id = '$id'");
    
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    print '<p><b>'. $lex{'Chips Updated'}. "</b></p>\n";
    print "<p>[ <a href=\"$tchpage\">". $lex{Main}. "</a> |\n";
    print "<a href=\"chipdeled.pl\">". $lex{'View/Edit Chips'}. "</a> ]</p>\n";

    print "</body></html>\n";

    exit;
}
