#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# compress.pl - compress / delete assessment items into a single item
# (or zero items in the case of delete)

my %lex = ('Compress' => 'Compress',
	   'Delete' => 'Delete',
	   'GB&nbsp;Main' => 'GB&nbsp;Main',
	   'Main' => 'Main',
	   'Error' => 'Error',
	   'Delete / Compress More Items' => 'Delete / Compress More Items',
	   'Delete / Compress Assessment Items' => 'Delete / Compress Assessment Items',
	   'Please select a subject to remove / compress items from:' =>
	     'Please select a subject to remove / compress items from:',
	   'Select all items?' => 'Select all items?',
	   'Sort by' => 'Sort by',
	   'No records found to delete.' => 'No records found to delete.',
	   'Please select items to remove. Scores will also be deleted.' =>
	     'Please select items to remove. Scores will also be deleted.',
	   'Delete Items and Scores' => 'Delete Items and Scores',
	   'Please select items to compress.' => 'Please select items to compress.',
	   'Please enter values for new target item.' => 
	     'Please enter values for new target item.',
	   'Name' => 'Name',
	   'Description' => 'Description',
	   'Date' => 'Date',
	   'Weight' => 'Weight',
	   'No colons(:) please.' => 'No colons(:) please.',
	   'Group' => 'Group',
	   'or New Group' => 'or New Group',
	   'A colon (:) is used to separate group and subgroup. Do not use a colon' =>
  	     'A colon (:) is used to separate group and subgroup. Do not use a colon',
	   'in the group name unless you <i>mean</i> to create a group with subgroups' =>
	     'in the group name unless you <i>mean</i> to create a group with subgroups',
	   'Compress Items' => 'Compress Items',
	   'Name required to add a new item. Dying.' => 'Name required to add a new item. Dying.',
	   'Delete / Compress More Items' => 'Delete / Compress More Items',
	   'No Maximum Score for Test' => 'No Maximum Score for Test',
	   'Item with this name exists. Please try again.' => 
	     'Item with this name exists. Please try again.'
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'compress.pl';

%sortorder = ('Date' => 'tdate',
	      'Name' => 'name',
	      'Group' => 'grp,tdate'
	      );

use DBI;
use CGI::Session;
use CGI;
use Number::Format qw{ round };

# Set the current date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day"; 

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}

my $q = new CGI;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

my $userid = $session->param('userid');
my $logged_in = $session->param(logged_in);
if (not $logged_in){
    print $q->header( -charset, $charset );
    print $lex{'Please Log In'}. "<br>\n";
    die;
}
my $subjsec = $session->param('subjsec');
my $userid = $session->param('userid');

print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


# Now setup page header
print "$doctype\n<html><head><title>". $lex{'Delete / Compress Assessment Items'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">$chartype
</head><body>\n";

print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> |\n";
print "<a href=\"gbmain.pl\">". $lex{'GB&nbsp;Main'}. "</a> ]\n";
print "<center><h1>". $lex{'Delete / Compress Assessment Items'}. "</h1></center>\n";

# foreach my $key (keys %arr) { print "K: $key V: $arr{$key}<br>\n"; }


# Check for an action value
if ( $arr{action} eq $lex{Compress} ) { # do compression...
    doCompress( $arr{subjsec}, $arr{sortorder}, $arr{selectall} );
    die;

} elsif ($arr{action} eq $lex{Delete}) { # do deletion...
    doDelete($arr{subjsec},$arr{sortorder},$arr{selectall});

} elsif ($arr{deleterecords}) {
    delete $arr{deleterecords}; # remove the flag value, leave id's.
    deleteRecords(\%arr);

} elsif ($arr{compressrecords}) {
    delete $arr{compressrecords}; # remove the flag value, leave id's.
    compressRecords(\%arr);
}

print '<b>'. $lex{'Please select a subject to remove / compress items from:'}. "</b>\n";
print "<form action=\"$self\" method=\"post\">\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";


# Get Teacher's subjects
$sth = $dbh->prepare("select smdesc, description,subjsec from subject 
  where teacher like '%$userid%' order by description");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while ( my ( $name,$description,$subjsec ) = $sth->fetchrow) {
    print "<tr><td><input type=\"radio\" name=\"subjsec\" value=\"$subjsec\"></td>\n";
    print "<td>$name - $description ($subjsec)</td></tr>\n";
}
print "</table>\n";

print '<p><b>'. $lex{'Select all items?'};
print "</b><input type=\"checkbox\" name=\"selectall\" value=\"1\"></p>\n";

print '<p><b>'. $lex{'Sort by'}. ":</b>\n";
print "<select name=\"sortorder\">\n";
foreach my $so (sort keys %sortorder) {
    print "<option>$so</option>";
}
print "</select>\n";

print "<p><input type=\"submit\" name=\"action\"  value=\"". $lex{Delete}. "\">\n";
print "<input type=\"submit\" name=\"action\"  value=\"". $lex{Compress}. "\"></p>\n";

print "</form></body></html>\n";


#======== Functions ================

#-----------
sub doDelete {  # Delete selected items of this subject...
#-----------

    my ($subjsec,$sortkey,$selectall) = @_;
    my $checked;
    if ($selectall) { $checked = 'CHECKED'; }

    # Find the items in the correct order.
    my $sortorder = "order by $sortorder{$sortkey}";

    my $sth = $dbh->prepare("select id, name, description, tdate, grp from gbtest
     where subjsec = ? $sortorder");
    $sth->execute( $subjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
    my $count = $sth->rows;
    if ($count < 1){
	print '<b>'. $lex{'No records found to delete.'}. "</b>\n";
	print "</body></html>\n";
	die;
    }

    print q{<b>}. $lex{'Please select items to remove. Scores will also be deleted.'}. "</b>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"deleterecords\" value=\"1\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

    while (my ($id, $name, $description,$tdate,$grp) = $sth->fetchrow) {
	print "<tr><td><input type=\"checkbox\" name=\"$id\" value=\"1\" $checked></td>\n";
	print "<td>$name - $description</td><td>$tdate</td><td>$grp</td></tr>\n";
    }
    print "</table>\n";
    print "<input type=\"submit\" value=\"". $lex{'Delete Items and Scores'}. "\">\n";
    print "</form>";
    print "</body></html>\n";

    exit;

} # End of doDelete


#----------------
sub deleteRecords {  # Do the actual record deletion.
#----------------
    # Passed a list of test item id's, delete the item and all scores for the item.
    my $hash_ref = shift;
    my %items = %{$hash_ref};

    my $count;
    foreach my $id (keys %items) {
	#print "K:$id V:$items{$id}<br>\n";
	my $result = $dbh->do("delete from gbtest where id = '$id'");
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
	my $result = $dbh->do("delete from gbscore where testid = '$id'");
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
	$count++;
    }

    print "$count Item(s) deleted.<br>\n";
    print "[ <a href=\"$self\">". $lex{'Delete / Compress More Items'}. "</a> ]\n";
    print "</body></html>\n";

    exit;

} # End of deleteRecords


#-------------
sub doCompress { 
#-------------
    my ($subjsec,$sortkey,$selectall) = @_;
    my $checked;
    if ($selectall) { $checked = 'CHECKED'; }

    my $sth = $dbh->prepare("select distinct grp from gbtest
     where subjsec = ? and grp != ''");
    $sth->execute( $subject );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
    while (my $grp = $sth->fetchrow) {
	push @group, $grp;
    }


    # Find the items in the correct order.
    my $sortorder = "order by $sortorder{$sortkey}";

    $sth = $dbh->prepare("select id, name, description, tdate, grp from gbtest
     where subjsec = ? $sortorder");
    $sth->execute( $subjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
    my $count = $sth->rows;
    if ($count < 1){
	print q{<b>}. $lex{'No records found to delete.'}. "</b>\n";
	print "</body></html>\n";
	die;
    }

    print q{<p><b>}. $lex{'Please select items to compress.'}. "</b></p>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"compressrecords\" value=\"1\">\n";
    print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\" style=\"background-color:#DFD;\">\n";

    while (my ($id, $name, $description,$tdate,$grp) = $sth->fetchrow) {
	print "<tr><td><input type=\"checkbox\" name=\"$id\" value=\"1\" $checked></td>\n";
	print "<td>$name - $description</td><td>$tdate</td><td>$grp</td></tr>\n";
    }
    print "</table>\n";

    print q{<p><b>}. $lex{'Please enter values for new target item.'}. "</b></p>\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\" style=\"background-color:#DFD;\">\n";
    print "<tr><td align=\"right\">". $lex{Name}. "</td><td><input type=\"text\" name=\"name\" size=\"10\" ";
    print "maxlength=\"32\"> ". $lex{'No colons(:) please.'}. "</td></tr>\n";

    print q{<tr><td align="right">}. $lex{Description}. q{</td>},"\n";
    print q{<td><input type="text" name="description" size="50" maxlength="255"></td></tr>},"\n";

    print q{<tr><td align="right">}. $lex{Date}. q{</td>};
    print "<td><input type=\"text\" name=\"tdate\" size=\"12\" value=\"$currdate\"></td></tr>\n";

    #print {<tr><td align="right">}. $lex{Weight}. {</td>};
    #print q{<td><input type="text" name="weight" size="4" value="$defaultweight"></td></tr>};

    print q{<tr><td align="right">}. $lex{Group}. q{</td><td><select name="grp">};


    foreach my $gp (@group){
	print "<option>$gp</option>\n";
    }

    print "</select> ". $lex{'or New Group'} ." <input type=\"text\" name=\"newgrp\" size=\"16\" ";
    print "maxlength=\"64\"></td></tr>\n";

    print "<tr><td colspan=\"2\" align=\"center\">";
    print $lex{'A colon (:) is used to separate group and subgroup. Do not use a colon'}. "<br>\n";
    print $lex{'in the group name unless you <i>mean</i> to create a group with subgroups'}. "\n";
    print "</td></tr>\n";

    print "</table>\n";


    print "<input type=\"submit\" value=\"". $lex{'Compress Items'}. "\">\n";
    print "</form>";

    print "</body></html>\n";

    exit;

}


#----------------
sub compressRecords {  # Do the actual record compressions 
#----------------

    # Passed a list of test item id's, delete the item and all scores for the item.
    my $hash_ref = shift;
    my %items = %{$hash_ref};

    # Extract 5 values to use for the new item.
    my $description = $items{description};
    delete $items{description};
    my $subjsec = $items{subjsec};
    delete $items{subjsec};
    my $name = $items{name};
    delete $items{name};
    if (not $name) {
	print '<b>'. $lex{'Name required to add a new item. Dying.'}. "</b>\n";
	print "</body></html>\n";
	die;
    }

    my $tdate = $items{tdate};
    delete $items{tdate};
    my $grp = $items{grp};
    delete $items{grp};
    my $newgrp = $items{newgrp};
    delete $items{newgrp};

    my $group; # for insertion.
    if ($newgrp) { # IF we have a new group, that overrides.
	$group = $newgrp;
    } else { 
	$group = $grp; 
    }

    my ($totalweight, $totalmaxscore);
    # Get all tests and load their max scores and weights
    foreach my $id (keys %items) {
	my $sth = $dbh->prepare("select weight,score from gbtest where id = ?");
	$sth->execute( $id );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
	my ($wt,$score) = $sth->fetchrow;
	#print "ID: $id SCORE: $score  W: $wt V: $items{$id}<br>\n";

	$weight{$id} = $wt;
	$totalweight += $wt;

	$maxscore{$id} = $score;
	$totalmaxscore += $score;
    }

    #print "TS: $totalmaxscore  TW: $totalweight <br>\n";

    # create the new assessment item and get it's new id. It will use the TW and TS above.
    # Check for presence of that 'name' for the item...
    #$arr{$key} =~ s/'/''/g;

    # Check for an existing item with this name in this subject.
    my $sth = $dbh->prepare("select count(*) from gbtest where subjsec = ? and name = ?");
    $sth->execute( $subjsec, $name );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ($count) {
	print '<p><b>'. $lex{'Item with this name exists. Please try again.'}. "</b></p>\n";
	print "</body></html>\n";
	die;
    }

    # Strip colons from name since used as field separator in gbmain.
    $name =~ s/://g;

    # Load the markscheme field
    $sth = $dbh->prepare("select markscheme from subject where subjsec = ?");
    $sth->execute( $subjsec );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $markscheme = $sth->fetchrow;

    # add to the %group hash above; removing duplicates effectively.
    my @fields = split (/[\n|\r]/, $markscheme);
    foreach my $fld (@fields) { 
	if ($fld) {
	    my ($grp, $percent) = split /=/, $fld;
	    $group{$grp} = $percent;
	}
    }

    

    # Add the group into markscheme if it doesn't exist there.
    if (not $group{$group}) { 
	$markscheme .= "\n$group=0";
	$sth = $dbh->prepare("update subject set markscheme = ? where subjsec = ?");
	$sth->execute( $markscheme, $subjsec );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    }


    my $sth = $dbh->prepare("insert into gbtest values (
     NULL, '$subjsec','$name',? ,'$tdate','$totalmaxscore', NULL, '$totalweight', ?)");
    $sth->execute( $description, $group );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }    

    # Now get the ID for that new record...
    my $sth = $dbh->prepare("select id from gbtest 
     where name = ? and subjsec = ?");
    $sth->execute( $name, $subjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }    
    my $newid = $sth->fetchrow;
    #print "The New Item ID is: $newid<br>\n";


    # next get the kids (from eval) and loop through putting in records
    $sth = $dbh->prepare("select distinct studnum from eval where
      subjcode = ? and studnum != ''");
    $sth->execute( $subjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    
    $sth1 = $dbh->prepare("select score from gbscore 
      where studnum = ? and testid = ? ");

    # loop through each student and create their new score records.    
    while (my $studnum = $sth->fetchrow) {

	my ($localtotalweight, $localtotalscore);

	# First read in their score (if any) for each item to be compressed.
	foreach my $testid (keys %items) {

	    # Get a score...
	    $sth1->execute($studnum,$testid);
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my $score = $sth1->fetchrow;

	    if ($score eq $specchar or $score eq '' or 
 		  not defined $score) {  #skip this score
		next; 
	    }

	    if ( not $maxscore{$testid} ) { #check for any problems with this...
		print $lex{'No Maximum Score for Test'}.  ": $testid<br>\n";
		next;
	    }

	    if ($score =~ /\d/) { # if score is a digit... do it.
		$localtotalweight += $weight{$testid};
		$localtotalscore += ($weight{$testid} * $score / $maxscore{$testid});
		
	    } else { 
		# some sort of text score...count as zero... update total weight.
		$localtotalweight += $weight{$testid};
	    }
	    #print "SC: $score  WT:$weight{$testid} MAX: $maxscore{$testid}<br>\n";
	} # End of tests loop

	#print "SN: $studnum W:$localtotalweight SC:$localtotalscore<br>\n";
	if ($localtotalweight){
	    $score = $localtotalscore * $totalmaxscore / $localtotalweight;
	} else {
	    $score = 0;
	}
	$score = round( $score, 1);
	#NOTE: 1 decimal rounding should give sufficient accuracy. Change if required.
	
	#print "<br>Score: $score  Max: $totalmaxscore<br>\n";

	# Write the record with the updated score.
	my $sth2 = $dbh->prepare("insert into gbscore values (
         $sql{default},'$studnum','$newid',?,?)");
	$sth2->execute( $score, $comment );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    }
	
    # delete the existing records for each 'old' item...
    foreach my $id (keys %items) {
	#print "K:$id V:$items{$id}<br>\n";
	my $result = $dbh->do("delete from gbtest where id = '$id'");
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $result = $dbh->do("delete from gbscore where testid = '$id'");
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    }

    print "[ <a href=\"$self\">". $lex{'Delete / Compress More Items'}. "</a> ]\n";
    print "</body></html>\n";

    exit;

} # End of compressRecords
