#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# multiedit.pl - add/edit multiple item scores.

my %lex = ('Multiple Item Score Entry' => 'Multiple Item Score Entry',
	   'GB&nbsp;Main' => 'GB&nbsp;Main',
	   'Main' => 'Main',
	   'Your Scores were added/updated!' => 'Your Scores were added/updated!',
	   'Max Score' => 'Max Score',
	   'Save / Update Scores' => 'Save / Update Scores',
	   'Assessment Item' => 'Assessment Item',
	   'Item Date' => 'Item Date',
	   'Continue' => 'Continue',
	   'Error for test:' => 'Error for test:',
	   'Multiple Test Score Entry' => 'Multiple Test Score Entry',
	   'Test' => 'Test',
	   'Select' => 'Select',
	   'Items with no test scores are automatically checked.' => 
	     'Items with no test scores are automatically checked.',
	   'Error' => 'Error',
	   'Please Log In' => 'Please Log In',


	   );


use DBI;
use CGI;
use CGI::Session;

# Set the current date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day"; 

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}

my $q = new CGI;

my ($view,$subview) = split /:/,$arr{vw};

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session Information...
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

my $logged_in = $session->param(logged_in);
if (not $logged_in){
    print $q->header( -charset, $charset );
    print $lex{'Please Log In'}. "<br>\n";
    die;
}

my $subjsec = $session->param('subjsec');

print $q->header( -charset, $charset ); 
my %arr = $q->Vars;


# Now setup page header
print "$doctype\n<html><head><title>". $lex{'Multiple Item Score Entry'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> |\n";
print "<a href=\"gbmain.pl\">". $lex{'GB&nbsp;Main'}. "</a> ]\n";
print "<h1>". $lex{'Multiple Item Score Entry'}. "</h1>\n";


# Update records for changed scores.
if ($arr{flag} == 3){
    updateRecs();
    print "<div style=\"padding:0.5em; border: 2px dotted red;";
    print "background-color: white; font-size: 150%; font-weight: bold;\">";
    print $lex{'Your Scores were added/updated!'}. "</div><p><hr></p>\n";
}

# Select subjects if not already done in last loop.
if ( not $arr{flag} ){ # no flag, then print entry screen.
    prEntryPage($subjsec);
    die;
}

# Lookup Test records; Only subjsec=subjsec, id = 1, flag=2
foreach $key (keys %arr){
    if ($arr{$key} == 1){ # loop through the tests: $key is id of test.
	$sth = $dbh->prepare("select tdate,name,score from gbtest where id = ?");
	$sth->execute( $key );
	if ($DBI::errstr){ print $DBI::errstr; die; }
	my ($tdate,$name,$score) = $sth->fetchrow;
	$name =~ s/://g; # strip colons
	$test{"$tdate:$key"} = "$name:$score"; # use this to sort hash
    }
}

# Creates array controlling student sort order.
my @studnum = mkStudNum($arr{subjsec});

print "<form action=\"multiedit.pl\" method=\"post\"> 
<input type=\"hidden\" name=\"flag\" value=\"3\">
<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">
<div style=\"padding:0.4em 0 0 4em;\">
<input type=\"submit\" value=\"". $lex{'Save / Update Scores'}. 
"\"></div><table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">
<tr><th>". $lex{'Assessment Item'}. "</th>\n";


# Print item Name, Date, Max Score
foreach my $key (sort keys %test){
    my ($name,$score) = split /:/,$test{$key};
    print "<td style=\"text-align:center;background:#CCC\">";
    print "<b>$name</b></td>\n";
}

print "</tr>\n<tr><th>". $lex{'Max Score'}. "</th>";
foreach my $key (sort keys %test){
    my ($name,$score) = split /:/,$test{$key};
    print "<td align=\"center\">$score</td>";
}

print "</tr>\n<tr><th>". $lex{'Item Date'}. "</th>";
foreach my $key (sort keys %test){
    my ($date,$id) = split /:/,$key;
    print "<td>$date</td>";
}
print "</tr>\n";


# Print the students and their marks;
foreach my $studnum (@studnum) {
    # Do the name column
    $sth = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
    $sth->execute( $studnum );
    if ($DBI::errstr) { print "$DBI::errstr"; die;}
    my ($lastname, $firstname) = $sth->fetchrow;
    print "<tr><td>$lastname, $firstname</td>\n";

    # Do all of the test columns for the student.
    foreach my $key (sort keys %test){
	my ($tdate,$id) = split /:/,$key;

	# Now get the score for this student for this testid.
	$sth = $dbh->prepare("select id, score from gbscore where studnum = ? and testid = ?");
	$sth->execute( $studnum, $id );
	if ($DBI::errstr) { print "GetScore Error: $DBI::errstr"; die;}
	my $trow = $sth->rows; 
	# Trow is passed to the next script for deciding how to update record
	#  0 means no record and thus add new one; 1 means update record.
	my ($sid,$score) = $sth->fetchrow; 

	print "<td><input type=\"text\" name=\"$id:$studnum:$trow\" ";
	print "size=\"6\" value=\"$score\"></td>\n";
    }
    print "</tr>\n\n";

} # End of Student Loop

print "</table><div style=\"padding-left:4em;\">
<input type=\"submit\" value=\"". $lex{'Save / Update Scores'};
print "\"></div></form></body></html>\n";



#------------
sub mkStudNum {
#------------

    my $subjsec = shift;
    my (@eval, @studnum, %remove);

    # Create the studnum array that controls the order that students are
    # displayed in. Load the eval records first into an array, sorted by
    # lastname and firstname. (@eval) Load the sort order records in order
    # into an array and also into a hash (%remove)
    # Any remaining array elements in eval are added to the end of
    # the studnum array once done. If there _are_ no sortorder recs, then
    # the final array becomes the eval records only. This has the desired
    # behavior.

    # Find the enrollments for this class and read them into @eval array
    $sth = $dbh->prepare("select distinct eval.studnum from eval
     left outer join studentall on studentall.studnum = eval.studnum 
     where eval.subjcode = ? order by studentall.lastname, studentall.firstname");

    $sth->execute( $subjsec );
    if ($DBI::errstr) { print "$DBI::errstr"; die $DBI::errstr;}
    while (my $studnum = $sth->fetchrow){
	push @eval,$studnum;
    }
    
    # Load 'SortOrder' test if it exists...
    $sth = $dbh->prepare("select id from gbtest where subjsec = ? and name = 'sortorder'");
    $sth->execute( $subjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
    my $sortid = $sth->fetchrow;

    if ($sortid){ # We have a sortorder
	$sth = $dbh->prepare("select studnum from gbscore where testid = ? order by score");
	$sth->execute( $sortid );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
	while (my $sn = $sth->fetchrow){
	    push @studnum, $sn;
	    $remove{$sn} = 1;
	}
	
	# Now add on @eval elements who are not in @studnum
	foreach my $en (@eval){
	    if (not $remove{$en}){ push @studnum, $en;}
	}
	return @studnum;

    } else { # no sortorder
	return @eval;
    }
}

#--------------
sub prEntryPage { # Entry Values for Test Selection
#--------------
    my $subjsec = shift; # Get passed subjsec

    $sth = $dbh->prepare("select description from subject where subjsec = ?");
    $sth->execute( $subjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    $subject = $sth->fetchrow;

    if ($view ne 'All' and defined $view){ # a select group is being viewed.
	$grpselect = "and grp = '$view'";
    }

    # Get Tests for this subject
    $sth = $dbh->prepare("select id, name, description from gbtest
      where subjsec = ? and name != 'sortorder' $grpselect
      order by tdate");
    $sth->execute( $subjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    

    print "<h1>". $lex{'Multiple Test Score Entry'}. " - $subject</h1>
<p>". $lex{'Items with no test scores are automatically checked.'}. "</p>
<form action=\"multiedit.pl\" method=\"post\">
<input type=\"hidden\" name=\"flag\" value=\"2\">
<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">
<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">
<tr><th>". $lex{Test}. "</th><th>". $lex{Select}. "</th></tr>\n";


    print "<tr><td colspan=\"2\" align=\"center\"><input type=\"submit\" ";
    print "value=\"". $lex{Continue}. "\"></td></tr>\n";

    while (my ($id,$name,$desc) = $sth->fetchrow){
	my $checked; # initially zilch
	# From the testid, find out if they have any score records.
	# If not, then they get checked.
	$sth1 = $dbh->prepare("select count(*) from gbscore where testid = ?");
	$sth1->execute( $id );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $count = $sth1->fetchrow;
	if (not $count){ $checked = 'checked';}

	print "<tr><td>$desc ($name)</td>\n";
	print "<td align=\"center\"><input type=\"checkbox\" ";
	print "name=\"$id\" value=\"1\" $checked>"; 
	print "</td></tr>\n";
    }

    print "<tr><td colspan=\"2\" align=\"center\"><input type=\"submit\" ";
    print "value=\"". $lex{'Continue'}. "\">";
    print "</td></tr></table></form></body></html>\n";

}


#-------------
sub updateRecs { # Update scores records
#-------------

    delete $arr{flag}; # not needed here...force back to entry page

    #foreach $key (keys(%arr)) { # Read all passed values...
    #print "K: $key VAL: $arr{$key}<br>\n";
    #}

RECORD:
    foreach $key (keys(%arr)) { # Read all passed values...
	if ($key eq 'subjsec' or $key eq 'vw'){ next; } # skip those values

        my ($testid,$studnum,$flag) = split /:/,$key;
	#print "T:$testid S:$studnum F:$flag V:$arr{$key}<br>\n";
	if (not defined $flag) {
	    print "Error in Entry Value for: $arr{$key} for test: $arr{id}<br>\n";
	    print "Contact Programmer!<br>\n";
	    die;
	}

	# Look for an existing student score record...
	my $sth = $dbh->prepare("select count(*) from gbscore where studnum = ? and testid = ?");
	$sth->execute( $studnum, $testid );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my $count = $sth->fetchrow;

	if ($count != $flag){ 
	    print "Count does not match flag value for student number ";
	    print "$studnum for test $testid. Contact Les Richardson.\n";
	    die;
	} elsif (not $studnum or not $testid){
	    print "Missing value for entry: Student Num: $studnum ";
	    print "Testid: $testid  Flag: $flag . Write down this message";
	    print " and contact Les Richardson<br>\n";
	    die;
	}

	if ($count == 1 ){  # we have an existing record to update
	    $sth = $dbh->prepare("update gbscore set score = ? where studnum = ? and testid = ?");
	    $sth->execute( $arr{$key}, $studnum, $testid);
	} elsif ($count == 0) {
	    if (not defined $arr{$key}) { next RECORD;}
	    $sth = $dbh->prepare("insert into gbscore values (
             $sql{default},?,?,?,$sql{default})");
	    $sth->execute( $studnum, $testid, $arr{$key} );
	} else { # we have an $count error condition:
            print $lex{'Error for test:'}. " $testid for student#: $studnum.";
            print " Count is: $count<br>\n";
            die;
        }

	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    }

} # End of updateRecs
