#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson
#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my $self = "search.pl";

my %lex = ('Gradebook Search' => 'Gradebook Search',
	   'Continue' => 'Continue',
	   'Main' => 'Main',
	   'GB&nbsp;Main' => 'GB&nbsp;Main',
	   'Search For' => 'Search For',
	   'Blank=All' => 'Blank=All',
	   'Scores' => 'Scores',
	   'Averages' => 'Averages',
	   'Search In' => 'Search In',
	   'Classes' => 'Classes',
	   'All' => 'All',
	   'Terms' => 'Terms',
	   'Sort By' => 'Sort By',
	   'Class' => 'Class',
	   'Student' => 'Student',
	   'Please Log In' => 'Please Log In',
	   'No Search' => 'No Search',
	   'Error' => 'Error',
	   'Course' => 'Course',
	   'Item' => 'Item',
	   'Score' => 'Score',
	   'Value' => 'Value',
	   'Average' => 'Average',
	   'No Records Found' => 'No Records Found',
	   'Search Again' => 'Search Again',
	   'and' => 'and',


	   );

# Characters NOT to search for in score field entries.
my $searchclass = '^0-9,.';

use DBI;
use CGI;
use CGI::Session;
use Number::Format qw{ round };

eval require "../../etc/admin.conf";
if ( $@ ) {
    print "<br>". $lex{Error}. ": $@<br>\n";
    print "</body></html>\n";    
    die $lex{Error}. ": $@\n";
}

eval require "../../etc/gbook.conf";
if ( $@ ) {
    print "<br>". $lex{Error}. ": $@<br>\n";
    print "</body></html>\n";    
    die $lex{Error}. ": $@\n";
}

my $q = CGI->new;

my $dsn = "DBI:$dbtype:dbname=$dbase";
$dbh = DBI->connect($dsn,$user,$password);

# Get Session Information...
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

my $logged_in = $session->param(logged_in); # checked below page header..
my $userid = $session->param('userid');
my $subjsec = $session->param('subjsec');

print $q->header( -charset, $charset ); 
my %arr = $q->Vars;

my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
 $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
# Now using global values for month and dow.
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


# print page header
print "$doctype\n<html><head><title>$lex{'Gradebook Search'}</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head><body>\n";

print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> |\n";
print "<a href=\"gbmain.pl\">". $lex{'GB&nbsp;Main'}. "</a> \n";
if ( %arr ) {
    print "| <a href=\"$self\">". $lex{'Search Again'}. "</a> \n";
}
print " ]\n";


if ( not $logged_in ) {
    print "<h1>". $lex{'Please Log In'}. "</h1>\n";
    print "</body></html>\n";
    die;
}


# Select subjects to print.
if ( not $arr{searchType} ) { 
    showStartPage();
}

# get input values and leave subjsec's in @arr.  
my ($averageGtSearch, $averageLtSearch, $scoreGtSearch, $scoreLtSearch, $searchType,
$sortby, $textSearch);

if ( defined $arr{averageGtSearch} ) {
    $averageGtSearch =  $arr{averageGtSearch};
    delete $arr{averageGtSearch};
}
if ( defined $arr{averageLtSearch} ) {
    $averageLtSearch = $arr{averageLtSearch};
    delete $arr{averageLtSearch};
}
if ( defined $arr{scoreGtSearch} ) {
    $scoreGtSearch = $arr{scoreGtSearch};
    delete $arr{scoreGtSearch};
}
if ( defined $arr{scoreLtSearch} ) {
    $scoreLtSearch = $arr{scoreLtSearch};
    delete $arr{scoreLtSearch};
}
if ( defined $arr{searchType} ) {
    $searchType = $arr{searchType};
    delete $arr{searchType};
}

if ( defined $arr{sortby} ) {
    $sortby = $arr{sortby};
    delete $arr{sortby};
}
if ( defined $arr{textSearch} ) {
    $textSearch = $arr{textSearch};
    delete $arr{textSearch};
}

# Define termsearch for term selection.
my $termsearch;
if ( $arr{terms} ne $lex{All} ) { # we have a term selection.
    my $startdate = $g_termstart{ $arr{terms} };
    my $enddate = $g_termend{ $arr{terms} };
    delete $arr{terms};
    $termsearch = "and to_days(tdate) >= to_days('$startdate') ". 
	"and to_days(tdate) <= to_days('$enddate')";
}

#foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

if ( $searchType eq 'text' ) {
    searchText( $textSearch, $sortby, \%arr, $termsearch );

} elsif ( $searchType eq 'scores' ) {
    searchScores( $scoreLtSearch, $scoreGtSearch, $sortby, \%arr, $termsearch );

} elsif ( $searchType eq 'averages' ) {
    searchAverages( $averageLtSearch, $averageGtSearch, $sortby, \%arr );

} else {
    print "<h1>". $lex{'No Search'}. "</h1>\n";
    print "</body></html>\n";
}


#---------------
sub searchText {
#---------------

    # Passed %arr ref; also need selects and sortorder;
    my ( $textSearch, $sortorder, $subj_ref, $tsearch ) = @_;

    my $sth = $dbh->prepare("select description from subject where subjsec = ?");
    my $sth1 = $dbh->prepare("select id, description,tdate from gbtest 
      where subjsec = ? $tsearch order by tdate");
    my $sth2 = $dbh->prepare("select id, score, studnum from gbscore where testid = ? ");
    my $sth3 = $dbh->prepare("select lastname, firstname from studentall where studnum = ? ");

    print "<p></p><table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Course}. "</th><th>". $lex{Student}. "</th><th>". $lex{Item};
    print "</th><th>". $lex{Score}. "</th></tr>\n";
    my $first = 1; # flag to see if any results...

    foreach my $subjsec (keys %{$subj_ref} ) {

	# Get course name...
	$sth->execute( $subjsec );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}     
	my $description = $sth->fetchrow;

	# Now loop through assessments...
	$sth1->execute( $subjsec );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}     
	while ( my ($testid, $testdesc, $tdate ) = $sth1->fetchrow ) {
	    
	    # Now loop through scores
	    $sth2->execute( $testid );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}     
	    while ( my ( $id, $score, $studnum ) = $sth2->fetchrow ) {

		if ( ( $textSearch and $score eq $textSearch ) or 
		     ( not $textSearch and  $score =~ /[$searchclass]/ )) {

		    # Get Student Name
		    $sth3->execute( $studnum );
		    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}     
		    my ($lastname, $firstname ) = $sth3->fetchrow;
		    $first = 0;
		    print "<tr><td>$description</td><td>$firstname $lastname ($studnum)</td>\n";
		    print "<td>$testdesc ($tdate)</td><td>$score</td></tr>\n";
		}
	    }
	}

    }

    if ( $first ) { 
	print "<tr><td colspan=\"4\" align=\"center\">";
	print $lex{'No Records Found'}. "</td></tr>\n"; 
    }

    print "</table>\n";
    exit;

}


#-----------------
sub searchAverages {
#-----------------

    eval require "libgbreport.pl";
    if ( $@ ) {
	print "<br>". $lex{Error}. ": $@<br>\n";
	print "</body></html>\n";    
	die $lex{Error}. ": $@\n";
    }

    # Passed %arr ref; also need selects and sortorder;
    my ( $maxAvg, $minAvg, $sortorder, $subj_ref ) = @_;
    if ( not $minAvg ) { $minAvg = 0; }
    if ( not $maxAvg ) { $maxAvg = 200; } # 200% should be safe...

    my $sth = $dbh->prepare("select description from subject where subjsec = ?");
    my $sth1 = $dbh->prepare("select distinct e.studnum from eval as e, studentall as s 
      where e.subjcode = ? and e.studnum = s.studnum order by s.lastname, s.firstname");

    my $sth3 = $dbh->prepare("select lastname, firstname from studentall where studnum = ? ");

    print "<p></p><table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Course}. "</th><th>". $lex{Student}. "</th><th>". $lex{Average};
    print "</th></tr>\n";
    my $first = 1; # flag to see if any results...

    foreach my $subjsec (keys %{$subj_ref} ) {

	# Get course name...
	$sth->execute( $subjsec );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}     
	my $description = $sth->fetchrow;

	# Get Students
	$sth1->execute( $subjsec );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}     
	while ( my $studnum = $sth1->fetchrow ) {

	    my $avg = calcStudentAverage( $studnum, $subjsec, 2 );

	    if ( ( $avg >= $minAvg ) and ( $avg <= $maxAvg ) ) {

		# Get Student Name
		$sth3->execute( $studnum );
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}     
		my ($lastname, $firstname ) = $sth3->fetchrow;

		$first = 0;

		print "<tr><td>$description</td><td>$firstname $lastname ($studnum)</td>\n";
		print "<td align=\"left\"><b>". round( $avg, 2 );
		print "</b></td></tr>\n";
	    }
	}
    }

    if ( $first ) { 
	print "<tr><td colspan=\"4\" align=\"center\">";
	print $lex{'No Records Found'}. "</td></tr>\n"; 
    }
    print "</table>\n";
    exit;

}


#---------------
sub searchScores {
#---------------

    # Passed %arr ref; also need selects and sortorder;
    my ( $maxScore, $minScore, $sortorder, $subj_ref, $tsearch ) = @_;
    if ( not $minScore ) { $minScore = 0; }
    if ( not $maxScore ) { $maxScore = 200; } # 200% should be safe...

    my $sth = $dbh->prepare("select description from subject where subjsec = ?");
    my $sth1 = $dbh->prepare("select id, description, score, tdate from gbtest 
     where subjsec = ? $tsearch order by tdate");
    my $sth2 = $dbh->prepare("select id, score, studnum from gbscore where testid = ? ");
    my $sth3 = $dbh->prepare("select lastname, firstname from studentall where studnum = ? ");


    print "<p></p><table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th>". $lex{Course}. "</th><th>". $lex{Student}. "</th><th>". $lex{Item};
    print "</th><th>". $lex{Score}. "</th></tr>\n";
    my $first = 1; # flag to see if any results...

    foreach my $subjsec (keys %{$subj_ref} ) {

	# Get course name...
	$sth->execute( $subjsec );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}     
	my $description = $sth->fetchrow;

	# Now loop through assessments...
	$sth1->execute( $subjsec );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}     
	while ( my ($testid, $testdesc, $maxscore, $tdate ) = $sth1->fetchrow ) {
	    if ( not $maxscore ) { next; } #skip missing score tests (shouldn't be any).

	    # Now loop through scores
	    $sth2->execute( $testid );
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}     
	    while ( my ( $id, $score, $studnum ) = $sth2->fetchrow ) {
		if ( $score =~ /[$searchclass]/ ) { next; } # skip if text...

		my $avg = $score / $maxscore * 100;

		if ( ( $avg >= $minScore ) and ( $avg <= $maxScore ) ) {

		    # Get Student Name
		    $sth3->execute( $studnum );
		    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}     
		    my ($lastname, $firstname ) = $sth3->fetchrow;
		    $first = 0;
		    print "<tr><td>$description</td><td>$firstname $lastname ($studnum)</td>\n";
		    print "<td>$testdesc ($tdate)</td><td align=\"left\"><b>". round( $avg, 2);
		    print "</b> ( $score / $maxscore )</td></tr>\n";
		}
	    }
	}

    }

    if ( $first ) { 
	print "<tr><td colspan=\"4\" align=\"center\">";
	print $lex{'No Records Found'}. "</td></tr>\n"; 
    }
    print "</table>\n";

    exit;


}


#----------------
sub showStartPage { # Get search values...
#----------------

    # Note: assume that userid and subjsec is already loaded from Session.

    my %terms;
    # Now find the subjects and store the subjsec, desc for them 
    $sth = $dbh->prepare("select subjsec, description, startrptperiod, endrptperiod from subject
     where teacher like '%$userid%' order by description");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
    while (my ( $subjsec,$desc, $sterm, $eterm ) = $sth->fetchrow){
	for my $t ( $sterm..$eterm ) { $terms{$t} = 1; } # set term values.
	$desc =~ s/://g;
	push @subjsec, "$subjsec:$desc";
    }

    print "<center><h1>". $lex{'Gradebook Search'}. "</h1>\n";
    print "<form action=\"$self\" method=\"post\">\n";

    print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"0\">\n";

    print "<tr style=\"background-color:#BBB;\"><td colspan=\"3\" align=\"center\">\n";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";

    # SEARCH FOR section
    print "<tr><td align=\"right\"><b>". $lex{'Search For'}. "</b></td>\n";
    print "<td><input type=\"radio\" name=\"searchType\" value=\"text\" checked> ";
    $lex{Score}. q{ }. $lex{Value}. "\n";
    print "<input type=\"input\" name=\"textSearch\" size=\"10\"> ". $lex{'Blank=All'};
    print "</td></tr>\n";

    print "<tr><td></td>\n";
    print "<td><input type=\"radio\" name=\"searchType\" value=\"scores\"> ". $lex{Scores};
    print "&nbsp;&nbsp;>=\n";
    print "<input type=\"input\" name=\"scoreGtSearch\" size=\"4\"> % \n";
    print $lex{and}. " <= <input type=\"input\" name=\"scoreLtSearch\" size=\"4\"> %\n";
    print "</td></tr>\n";

    print "<tr><td></td>\n";
    print "<td><input type=\"radio\" name=\"searchType\" value=\"averages\"> ";
    print $lex{Averages}. "\n";
    print " >= <input type=\"input\" name=\"averageGtSearch\" size=\"4\"> %\n";
    print $lex{and}. " <= <input type=\"input\" name=\"averageLtSearch\" size=\"4\"> % \n";
    print "</td></tr>\n";

    # now the SEARCH IN section
    print "<tr><td align=\"right\"><b>". $lex{'Search In'}. "</b></td>\n";
    print "<td colspan=\"2\"><b>". $lex{Classes}. "</b></td></tr>\n";

    foreach my $subj ( @subjsec ) {
	my ($subjsec, $desc) = split /:/,$subj;

	print "<tr><td align=\"right\"><input type=\"checkbox\" name=\"$subjsec\" ";
	print "value=\"1\" checked=\"1\"></td>\n";
	print "<td align=\"left\">$desc ($subjsec)</td>\n";
	print "</tr>\n";
    }
    

    # Now Terms
    print "<tr><td align=\"right\"><b>". $lex{Terms}. "</b></td><td><select name=\"terms\">";
    print "<option>". $lex{All}. "</option>\n";
    foreach my $trm (sort keys %terms ) { print "<option>$trm</option>"; }
    print "</select></td></tr>\n";

    # Now the SORT BY section.
    #print "<tr><td align=\"right\"><b>". $lex{'Sort By'}. "</b></td><td colspan=\"2\">";
    #print "<input type=\"radio\" name=\"sortby\" value=\"class\" checked> ";
    #print $lex{Class}. "\n";
    #print "<input type=\"radio\" name=\"sortby\" value=\"student\"> ";
    #print $lex{Student}. "</td></tr>\n";


    print "<tr style=\"background-color:#BBB;\"><td colspan=\"3\" align=\"center\">\n";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\">";
    print "</td></tr>\n</table></form></center></body></html>\n";

    exit;

} # End of showStartPage
