#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'GB&nbsp;Main' => 'GB&nbsp;Main',
	   'Clone/Duplicate Assessment Items' => 'Clone/Duplicate Assessment Items',
	   'Source Subject-Section' => 'Source Subject-Section',
	   'Destination Subject-Section' => 'Destination Subject-Section',
	   'Select these Subject-Sections' => 'Select these Subject-Sections',
	   'Name' => 'Name',
	   'Description' => 'Description',
	   'Group' => 'Group',
	   'Sel' => 'Sel',
	   'No Tests found' => 'No Tests found',
	   'Count' => 'Count',
	   'Add Selected Items to' => 'Add Selected Items to',
	   'Added Assessment Items...' => 'Added Assessment Items...',
	   'Maintenance Menu' => 'Maintenance Menu',
	   'No userid found. Dying.' => 'No userid found. Dying.',
	   'Error' => 'Error',
	   'Please Log In' => 'Please Log In',

	   );

my $self = 'testclone.pl';

use DBI;
use CGI;
use CGI::Session;
#use strict;

# Set the current date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day"; 

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Clone/Duplicate Assessment Items'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>\n";

print "<div style=\"padding: 0 1em;\">[ <a href=\"$tchpage\">". $lex{Main};
print "</a>\n | <a href=\"gbmain.pl\">". $lex{'GB&nbsp;Main'};
print "</a> ] </div><center><h1>". $lex{'Clone/Duplicate Assessment Items'}. "</h1>\n";


# Get session.
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;
my $userid = $session->param('userid');

my $logged_in = $session->param(logged_in);
if (not $logged_in){
    print $q->header( -charset, $charset );
    print $lex{'Please Log In'}. "<br>\n";
    die;
}

my $subjsec = $session->param('subjsec');


if ($arr{showflag}) {
    delete $arr{showflag};
    showTests();
    die;
}


if ($arr{addflag}) {
    delete $arr{addflag};
    addTests();
    die;
}

if (not $userid) {
    print $lex{'No userid found. Dying.'};
    print "</body></html>\n";
    die "No userid found.\n";
}

# Get Teacher's subjects
$sth = $dbh->prepare("select distinct subjsec, description from subject 
  where teacher like '%$userid%' order by description");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
while (my ($subjsec, $desc) = $sth->fetchrow) {
    $desc =~ s/\(//g;
    push @subject, "$desc ($subjsec)";
}


# Start the form
print "<form action=\"$self\" method=\"post\">\n";
print qq{<input type="hidden" name="showflag" value="1">\n};
print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";


# Write Source 
print "<tr><td align=\"right\"><b>". $lex{'Source Subject-Section'};
print "</b></td><td><select name=\"source\">\n";
foreach my $subj (@subject) {
    print "<option>$subj</option>";
}
print "\n</select> Checked <input type=\"checkbox\" name=\"check\" value=\"checked\"></td></tr>\n";


# Write Destination 
print "<tr><td align=\"right\"><b>". $lex{'Destination Subject-Section'};
print "</b></td>\n<td><select name=\"destination\">\n";
#if ($arr{subjsec}) { print "<option> ($arr{subjsec})</option>\n"; }

foreach my $subj (@subject) {
    print "<option>$subj</option>";
}
print "\n</select></td></tr>\n";

print "<tr><td></td><td align=\"center\">\n<input type=\"submit\" value=\"";
print $lex{'Select these Subject-Sections'};
print "\"></td></tr>\n";


print "</table></form>\n";
print "</center></body></html>\n";



#------------
sub showTests {
#------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }
    #die;

    my $check = $arr{check};

    my ($srcsubj, $srcsubjsec) = split /\(/, $arr{source};
    $srcsubjsec =~ s/\)//g;
    #print "Src: $srcsubjsec Name: $srcsubj<br>\n";

    my ($destsubj, $destsubjsec) = split /\(/, $arr{destination};
    $destsubjsec =~ s/\)//g;
    #print "Dest: $destsubjsec Name: $destsubj<br>\n";

    # Print start of form.
    print "<form action=\"$self\" method=\"post\">\n";
    print qq{<input type="hidden" name="addflag" value="1">\n};
    print qq{<input type="hidden" name="subjsec" value="$destsubjsec">\n};

    print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"1\">\n";
    print "<caption><b>$srcsubj</b></caption>\n";
    print '<tr><th>'. $lex{Name}. '</th><th>'. $lex{Description}. '</th><th>'. $lex{Group}. '</th><th>'. $lex{Sel};
    print "</th>\n<th>". $lex{Count}. "</th></tr>\n";
    print "<tr><td colspan=\"5\" align=\"center\" style=\"background-color:#EEE;\">";
    print "<input type=\"submit\" value=\"". $lex{'Add Selected Items to'}. " $destsubj\"></td></tr>\n";

    # Get the source items, display in form.
    my $sth = $dbh->prepare("select id, name, description, grp from gbtest
      where subjsec = ? order by tdate, grp");
    $sth->execute( $srcsubjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    my $srccount;
    while (my ($id, $name, $desc, $grp) = $sth->fetchrow) {
	print "<tr><td>$name</td><td>$desc</td>\n";
	print "<td><input type=\"text\" name=\"group$id\" size=\"8\" value=\"$grp\"></td>\n";
	print "<td><input type=\"checkbox\" name=\"$id\" value=\"1\" $check></td>\n";
	print "<td><input type=\"text\" name=\"count$id\" size=\"3\" value=\"1\"></td></tr>\n";
	$srccount++;
    }
    if (not $srccount){
	print '<tr><td colspan=\"5\">'. $lex{'No Tests found'}. "!</td></tr>\n";
	print "</table></body></html>\n";
	die;
    }

    print "<tr><td colspan=\"5\" align=\"center\" style=\"background-color:#EEE;\">";
    print "<input type=\"submit\" value=\"". $lex{'Add Selected Items to'}. " $destsubj\"></td></tr>\n";
    print "</table>\n";

    print "</form>\n";
    print "</body></html>\n";

} # End of showTests


#------------
sub addTests {
#------------

    # This is the destination subject...
    my $subjsec = $arr{subjsec};
    delete $arr{subjsec};

    # load the names of the destination subject items to check for collisions.
    my $sth = $dbh->prepare("select name from gbtest where subjsec = ?");
    $sth->execute( $subjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my %testname;
    while (my $name = $sth->fetchrow) {
	$testname{$name} = 1;
    }

    $sth = $dbh->prepare("select name, description, tdate, score, weight, grp 
      from gbtest where id = ?");
  
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
    print "<caption><b>". $lex{'Added Assessment Items...'}. "</b></caption>\n";
    print '<tr><th>'. $lex{'Name'}. '</th><th>'. $lex{'Description'}. "</th></tr>\n";


    # Load the markscheme field
    $sth1 = $dbh->prepare("select markscheme from subject where subjsec = ?");
    $sth1->execute( $subjsec );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $markscheme = $sth1->fetchrow;

    # Setup groupweight to hold any new groups; write update after done loop below.
    my %groupweight;
    # add to the %group hash above; removing duplicates effectively.
    my @fields = split (/[\n|\r]/, $markscheme);
    foreach my $fld (@fields) { 
	if ($fld) {
	    my ($grp, $percent) = split /=/, $fld;
	    $groupweight{$grp} = $percent;
	}
    }

    foreach my $id (keys %arr) { 
	if ($id =~ m/^\d/) { # only digits at the start...
	    my $copies = $arr{"count$id"};
	    my $group = $arr{"group$id"};
	    #print "Id:$id Copies:$copies Group: $group<br>\n";
	    $sth->execute($id);
	    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	    my ($name, $desc, $tdate, $score, $weight, $grp) = $sth->fetchrow;

	    if ($grp ne $group) { # changed by user;
		$group =~ s/\'+//g; # filter...
		$grp = $group;
	    }

	    $groupweight{$grp} = 0;

	    my $originalname = $name;
	    my $originaldesc = $desc;
	    if ($testname{$name}) { # name already exists for this...
		$name .= '0'; # add trailing zero.
	    }

	    for my $loopcount (1..$copies) {

		# Now do the insertion
		my $sth1 = $dbh->prepare("insert into gbtest values(
                 $sql{default}, ?,?,?,?,?, $sql{default},?,?)");
		$sth1->execute($subjsec, $name, $desc, $tdate, $score, $weight,$grp);
		if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
		print "<tr><td>$name</td><td>$desc</td></tr>\n";

		$name = $originalname.$loopcount;
		$desc = $originaldesc.$loopcount;
	    }

	} # end of If
    } # end of foreach 

    # Rewrite the markscheme for this subject.
    my $markscheme;
    foreach my $grp (sort keys %groupweight) {
	$markscheme .= "$grp=$groupweight{$grp}\n";
    }
    $sth = $dbh->prepare("update subject set markscheme = ? where subjsec = ?");
    $sth->execute( $markscheme, $subjsec );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

    print "</table>\n";

    print "<p>[ <a href=\"$self\">". $lex{'Clone/Duplicate Assessment Items'}. "</a> |\n";
    print "<a href=\"mtcemenu.pl\">". $lex{'Maintenance Menu'}.  "</a> ]</p>\n";
    print "</body></html>\n";

}
