#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#  tested.pl - edit a test/assessment item record.

my %lex = ('Edit Assessment Item' => 'Edit Assessment Item',
	   'Main' => 'Main',
	   'GB&nbsp;Main' => 'GB&nbsp;Main',
	   'Your item MUST have a group and a score!' => 
	     'Your item MUST have a group and a score!',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Please contact' => 'Please contact',
	   'or New Group' => 'or New Group',
	   'Update Assessment Item' => 'Update Assessment Item',
	   'The test/assessment is now stored' => 'The test/assessment is now stored',
	   'Your new group was added' => 'Your new group was added',
	   'Subject-Section' => 'Subject-Section',
	   'Name' => 'Name',
	   'Description' => 'Description',
	   'Date' => 'Date',
	   'Max Raw Score' => 'Max Raw Score',
	   'Weight' => 'Weight',
	   'Group' => 'Group',
	   'The default weight is' => 'The default weight is',
	   'Error' => 'Error',
	   'Please Log in!' => 'Please Log in!',

	   );

use DBI;
use CGI;
use CGI::Session;

my $self = 'tested.pl';

# Set the current date
my @tim = localtime(time);
my $year = @tim[5] + 1900;
my $month = @tim[4] + 1;
my $day = @tim[3];
my $currdate = "$year-$month-$day"; 

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}

eval require "../../etc/gbook.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}

my $q = new CGI;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session Information...
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

my $logged_in = $session->param(logged_in);

# loaded below...
#my $subjsec = $session->param('subjsec');

print $q->header( -charset, $charset );
my %arr = $q->Vars;
my $testid = $arr{id};

print "$doctype\n<html><head><title>". $lex{'Edit Assessment Item'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>\n";
print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> |\n";
print "<a href=\"gbmain.pl\">". $lex{'GB&nbsp;Main'}. "</a> ]\n";

if (not $logged_in){
    print $lex{'Please Log in!'}. "<br>\n";
}


# Get the test info....
my $sth = $dbh->prepare("select subjsec, name, description, tdate, score, weight, grp 
  from gbtest where id = ?");
$sth->execute( $testid );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my ( $subjsec, $name, $desc, $tdate, $score, $weight, $grp) = $sth->fetchrow;


# Load the different groups, using %group hash
my %group;
$sth = $dbh->prepare("select distinct grp from gbtest 
  where grp != '' and grp is not null and subjsec = ?");
$sth->execute($subjsec);
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
while (my $grp = $sth->fetchrow){
    if ($grp){ $group{$grp} = 1;}
}

# Load the markscheme field from the subject
$sth = $dbh->prepare("select markscheme from subject where subjsec = ?");
$sth->execute($subjsec);
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my $markscheme = $sth->fetchrow;

# add to the %group hash above; removing duplicates effectively.
my @fields = split (/[\n|\r]/, $markscheme);
foreach my $fld (@fields) { 
    if ($fld) {
	my ($grp, $percent) = split /=/, $fld;
	$group{$grp} = $percent;
    }
}


$sth = $dbh->prepare("select description from subject where subjsec = ?");
$sth->execute( $subjsec );
if ($DBI::errstr){ print $DBI::errstr; die; }
$subject = $sth->fetchrow;

if ($arr{flag}){
    updateRecs();
    die;
}

print "<center><h1>". $lex{'Edit Assessment Item'}. "</h1>
<form action=\"$self\" method=\"post\"> 
<input type=\"hidden\" name=\"id\" value=\"$testid\">
<input type=\"hidden\" name=\"subject\" value=\"$subject\">
<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">
<input type=\"hidden\" name=\"flag\" value=\"1\">\n";

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">
<tr><td colspan=\"2\" align=\"center\">
<input type=\"submit\" value=\"". $lex{'Update Assessment Item'};
print "\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Subject-Section'};
print "</td>\n<td><b>$subject ($subjsec)</b></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Name};
print " </td>\n<td><input type=\"text\" name=\"name\" ";
print "size=\"12\" maxlength=\"32\" value=\"$name\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Description}; 
print "</td><td><input type=\"text\" name=\"description\" size=\"50\"
maxlength=\"255\" value=\"$desc\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Date};
print "</td>\n<td><input type=\"text\" name=\"tdate\" size=\"12\" value=\"$tdate\">
</td></tr>\n";

print "<tr><td align=\"right\">". $lex{'Max Raw Score'};
print "</td>\n<td><input type=\"text\" name=\"score\" size=\"4\" maxlength=\"8\" value=\"$score\">
</td></tr>\n";

#<!-- <tr><td align=\"right\">Scheme</td><td>
#  <input type=\"text\" Name=\"schema\" size=\"6\" maxlength=\"8\" value=\"$test[6]\">
#</td></tr> -->

print "<tr><td align=\"right\">". $lex{Weight};
print "</td><td><input type=\"text\" name=\"weight\" size=\"4\" value=\"$weight\"> <i>";
print $lex{'The default weight is'}. " $defaultItemWeight";
print "</i></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Group};
print "</td>\n<td><select name=\"grp\"><option>$grp</option>\n";

foreach my $gp (sort keys %group){
    print "<option>$gp</option>\n";
}

print '</select> '. $lex{'or New Group'};
print " <input type=\"text\" name=\"newgrp\" size=\"8\"></td></tr>\n";

print "<tr><td colspan=\"2\" align=\"center\">
<input type=\"submit\" value=\"". $lex{'Update Assessment Item'};
print "\"></td></tr></table>\n";
print "</center></form></center></body></html>\n";


#--------------
sub updateRecs { # write the updated record.
#--------------

    if ($arr{newgrp}){ # Update the grouping
	$newgroupflag = 1;
	$arr{grp} = $arr{newgrp};
    }


    if (not $arr{grp} or not $arr{score}){
	print "<center><h1>". $lex{'Your item MUST have a group and a score!'}. "\n";
	print "</h1></center></body></html>\n";
	die;
    }

    foreach my $key (keys %arr) {
	$arr{$key} = $dbh->quote( $arr{$key} );
    }

    $sth = $dbh->prepare("update gbtest set name = $arr{name},
      description = $arr{description}, tdate = $arr{tdate},
      score = $arr{score}, weight = $arr{weight}, grp = $arr{grp}
    where id = $arr{id} ");

    $sth->execute;

    if (not $DBI::errstr ) {
	print "<center><p></p><h1>";
	print $lex{'The test/assessment is now stored'};
	print "</h1></p>\n";

	if ($newgroupflag){ 
	    print '<p>'. $lex{'Your new group was added'}. "</p>\n";
	}

    } else { 
	print '<h3>'. $lex{'There was an error storing your data'};
	print $lex{'Please contact'}. " $adminname <a href=\"mailto:$adminemail\">";
	print "$adminemail</a>  $DBI::errstr </h3>\n";
    }

    print "<p>[ <a href=\"gbmain.pl\">". $lex{'GB&nbsp;Main'}. "</a> ]</p>\n";
    print "</center></body></html>\n";

    exit;

} # End of Sub.
