#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


my %lex = ('User Id' => 'User Id',
	   'Password' => 'Password',
	   'Duration' => 'Duration',
	   'Login' => 'Login',
	   'Staff Login' => 'Staff Login',
	   'min' => 'min',
	   'No Userid Found' => 'No Userid Found',
	   'Incorrect Password' => 'Incorrect Password',
	   'Logged In' => 'Logged In',
	   'Logout Complete!' => 'Logout Complete!',
	   'Error' => 'Error',

	   );

my $self = 'login.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = CGI->new;
my %arr = $q->Vars;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $login_result;
if ( $arr{flag} ) {
    $login_result = doLogin();
} elsif ( $arr{v} eq 'quit' ) {
    doLogout();
} else {
    print $q->header( -charset, $charset );
}


printHTMLHeader();

#foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

print "<center><h3>". $lex{'Staff Login'}. "</h3>\n";

if ($login_result) {
    print "<b>$login_result</b>\n";
}

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"flag\" value=\"1\">\n";

print "<table cellpadding=\"6\" cellspacing=\"0\" border=\"1\">\n";

print "<tr><td align=\"right\">". $lex{'User Id'}. "</td>
<td><input type=\"text\" name=\"userid\" size=\"10\" value=\"$arr{user}\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Password}. "</td>
<td><input type=\"password\" name=\"password\" size=\"10\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Duration}. "</td>
<td><input type=\"text\" name=\"duration\" size=\"3\" value=\"20\"> ". $lex{min}. "</td></tr>\n";

print "<tr><td align=\"center\" colspan=\"2\">
<input type=\"submit\" value=\"". $lex{Login}. "\"></td></tr>\n";

print "</table></form></center></body></html>\n";


#-----------
sub doLogout {
#-----------

    # $dbtype set in admin.conf
    my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
				undef,{Handle => $dbh}) or die CGI::Session->errstr;
    $session->delete;
    $session->flush;
    print $q->header( -charset, $charset );
    printHTMLHeader();
    print "<center><h1>". $lex{'Logout Complete!'}. "</h1>\n";

    print "\n<p><form><input type=\"hidden\" name=\"none\">\n";
    print "<input type=\"button\" value=\"Close\" ";
    print "onClick=\"parent.close()\"></form></p>";
    print "</center></body></html>\n";

    exit;


}


#----------
sub doLogin {
#----------

    delete $arr{flag};

    my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
				undef,{Handle => $dbh}) or die CGI::Session->errstr;

    # Set Session Values;

    # Check password/userid against database (-1 no user, -2 wrong password;
    my $error = checkPassword($arr{userid}, $arr{password});

    if ($error == -1){
	print $q->header( -charset, $charset ); 
	return $lex{'No Userid Found'};
    }
    if ($error == -2){ 
	print $q->header( -charset, $charset );
	return $lex{'Incorrect Password'};
    }
    $cookietime = checkCookieTime($arr{duration});

    # Set values for userid, logged_in and duration in session
    $session->param('logged_in','1');
    $session->expire('logged_in',$cookietime);
    $session->param('userid',$arr{userid});
    $session->param('duration', $cookietime ); # was $arr{duration}
    # The duration value in the session has cookie markup: +20m format.

    # Now print page header...
    print $session->header( -charset, $charset );
    
    printHTMLHeader();
    print "<center><h3>". $lex{'Staff Login'}. "</h3>\n";

    my $sth = $dbh->prepare("select firstname, lastname from staff 
     where userid = ?");
    $sth->execute($arr{userid});
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($firstname, $lastname) = $sth->fetchrow;

    
    print "$firstname $lastname<br>". $lex{'Logged In'}. "<br>\n";

    print "\n<p><form><input type=\"hidden\" name=\"none\">\n";
    print "<input type=\"button\" value=\"Close\" ";
    print "onClick=\"parent.close()\"></form></p>";
    print "</body></html>\n";

    exit; 

}

#----------------
sub checkPassword {
#----------------
    my ($userid, $password) = @_;
    
    if (not $userid){ return -1;}
    if (not $password){ return -2;}

    # Sanitize 
    unless ( $password =~ m#^([\w\d.-@_+]+)$# ) {
      return -2;
    }
    $password = $1;

    #check for presence of userid
    my $sth = $dbh->prepare("select count(userid) from staff 
     where userid = ?");
    $sth->execute($userid);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ($count < 1){ return -1;} # no userid

    #check for presence of correct password and userid
    my $sth = $dbh->prepare("select count(userid) from staff 
     where userid = ? and passwd = ?");
    $sth->execute($userid, $password);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ($count < 1){ return -2;} # not correct password

    return 0; # if all ok...

}


#------------------
sub checkCookieTime {
#------------------
    # defaults
    $defaulttime = 20; # minutes
    $minimumtime = 3; # minutes
    $maximumtime = 60;

    my ($duration) = @_;

    if ($duration) { 
	$cookietime = $duration;
    } else { 
	$cookietime = $defaulttime;
    }

    $cookietime = $minimumtime if $cookietime < $minimumtime; 
    $cookietime = $maximumtime if $cookietime > $maximumtime; 
    $cookietime = "+".$cookietime."m"; # set format
    
    return $cookietime;

}

#------------------
sub printHTMLHeader {
#------------------
    # Print Page Heading
    print "$doctype\n<html><head><title>". $lex{'Staff Login'}. "</title>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
    print "<style type=\"text/css\">body { background-color:#063; color:white;}</style>\n";
    if ( $arr{user} ) { # if user, jump to the password field.
	print "</head><body onload=\"document.forms[0].elements[2].focus()\">\n";
    } else {
	print "</head><body onload=\"document.forms[0].elements[1].focus()\">\n";
    }

}
