#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Record Deleted' => 'Record Deleted',
	   'Lunch Attendance' => 'Lunch Attendance',
	   'View Lunch Attendance' => 'View Lunch Attendance',
	   'Name' => 'Name',
	   'Date' => 'Date',
	   'Fee Type' => 'Fee Type',
	   'Meal' => 'Meal',
	   'Amount' => 'Amount',
	   'Delete' => 'Delete',
	   'Paid' => 'Paid',
	   'Post' => 'Post',
	   'Main' => 'Main',
	   'Error' => 'Error',
	   'Grade' => 'Grade',

	   );


use DBI;
use CGI;

if ( $arr{group} eq $lex{Grade} ) { 
    $group = 'grade';
} else {
    $group = 'homeroom';
}

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

$q = new CGI;
print $q->header( -charset, $charset );
%arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'View Lunch Attendance'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\"></head><body>\n";
print "<a name=\"top\"></a>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

if ( $arr{id} ) { # passed an id to delete...
    deleteRecord();
}


my $sth = $dbh->prepare("select * from attend_lunch 
  order by attdate,studnum");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}
my $rows = $sth->rows;

print "<center><h1>". $lex{'Lunch Attendance'}. "</h1>\n";
print "<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Name}. "</th><th>". $lex{Date}. "</th><th>\n";
print $lex{'Fee Type'}. "</th><th>". $lex{Meal}. "</th><th>". $lex{Amount};
print "</th><th>". $lex{Paid}. "</th><th>". $lex{Post}. "</th><th>". $lex{Delete}. "</th></tr>\n";

my $colcolor = 'gray'; # tr colors are blue or gray;
my $currdate = -1;


$sth1 = $dbh->prepare("select lastname, firstname from studentall 
  where studnum = ?");

while (my ($id,$studnum,$attdate,$feeType,$mealType,$amount,$paid,$posted) = $sth->fetchrow){

    $sth1->execute($studnum);
    my ($lastname, $firstname) = $sth1->fetchrow;

    $prevdate = $currdate;
    $currdate = $attdate;

    if ($prevdate ne $currdate){
	if ($colcolor eq 'blue'){ 
	    $colcolor = 'gray';
	} else { 
	    $colcolor = 'blue';
	}
    }

    print "<tr class=\"$colcolor\"><td>$firstname $lastname ($studnum)</td>\n";
    print "<td>$attdate</td><td>$feeType</td><td>$mealType</td><td>$amount</td>\n";
    print "<td>$paid</td><td>$posted</td><td><a href=\"lunchview.pl?id=$id\">". $lex{Delete}. "</a></tr>\n";
}

print "</table>";
print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> | <a href=\"#top\">Top</a> ]\n";
print "</center><p></p></body></html>\n";



#---------------
sub deleteRecord { # delete a single attendance record
#---------------

    #foreach my $key (keys %arr){ print "KEY: $key VAL:$arr{$key}<br>\n"; }

    my $sth = $dbh->prepare("delete from attend_lunch where id = ?");
    $sth->execute( $arr{id} );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

    print "<h1>". $lex{'Record Deleted'}. "</h1>\n";
    print "</body></html>\n";

    exit;

}
