#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Teacher Assessment Management' => 'Teacher Assessment Management',
	   'Password' => 'Password',
	   'Term' => 'Term',
	   'System Disabled. Please contact secretary' => 
	     'System Disabled. Please contact secretary',
	   'Grade' => 'Grade',
	   'Please Log In' => 'Please Log In',
	   'No User Id' => 'No User Id',
	   'No Password' => 'No Password',
	   'Continue' => 'Continue',
	   'UserId' => 'UserId',
	   'Cookie Duration' => 'Cookie Duration',
	   'Main' => 'Main',
	   'Duration' => 'Duration',
	   'No Subjects Found' => 'No Subjects Found',
	   'Error' => 'Error',
	   'Alternate Report Card System' => 'Alternate Report Card System',

	   );

use DBI;
use CGI::Session;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session Information...
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

# Get/Set  Session Values (a defined userid means it was passed)

my $userid;
if ( $arr{userid} ){ # we want to login, passed userid/password pair.

    # Check password/userid against database (-1 no user, -2 wrong password;
    my $error = checkPassword($arr{userid}, $arr{password});
    if ($error == -1){ print $q->header( -charset, $charset ); login( $lex{'No User Id'}); }
    if ($error == -2){ print $q->header( -charset, $charset ); login($lex{'No Password'}); }

    $cookietime = checkCookieTime( $arr{duration} );

    # Set values for userid and logged_in in session
    $session->param('logged_in','1');
    $session->expire('logged_in',$cookietime );
    $session->param('userid', $arr{userid} );
    $session->param( 'duration', $cookietime );

    $userid = $arr{userid};

} else { # check logged_in value in session

    if ( not $session->param('logged_in') ){
	$userid = $session->param('userid');
        print $q->header( -charset, $charset );
        login( $lex{'Please Log In'}, $userid ); 
        die;
    }
    # Ok, we have a login. Values below we have in environment.

    $userid = $session->param('userid');
    $duration = $session->param('duration');
    if ( not ($duration =~ /\+/)) { # if not in +20m format, do so.
	$duration = checkCookieTime( $duration );
    }
    $session->expire('logged_in',$duration); # duration is in +20m format;

} # End of check for logged_in value

print $session->header( -charset, $charset );

# Read in the term
$term = "Error!";
open(TERM, "../../etc/term") || die "Can't find the term number!";
$term = <TERM>;

# Print HTML Header
print "$doctype\n<html><head><title>". $lex{'Teacher Assessment Management'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";
print $lex{Duration}. ": $duration<br>\n";

print "<center><h1>". $lex{'Teacher Assessment Management'}. "\n";
if ( not $multiTrack ) {
    print q{ &ndash; }. $lex{Term}. " $term";
}
print "</h1>\n";


if ($term == 0) {
    print '<br>'. $lex{'System Disabled. Please contact secretary'}. "</body></html>";
    die;
}

if ( $userid ) {
    showSubjects( $userid );
} else {
    # Show Login.
    login( $lex{'Please Log In'} ); 
}



#---------------
sub showSubjects {  # show the teacher his/her subjects
#---------------

    my $userid = shift; # passed teacher userid.

    my $sth = $dbh->prepare("select sal, firstname, lastname from staff where userid = ?");
    $sth->execute( $userid );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my ($sal, $firstname, $lastname) = $sth->fetchrow;
    print "<h1>$sal $firstname $lastname</h1>\n";


    # Get Subject Info for this teacher
    my $sth = $dbh->prepare("select subjsec, description, grade from subject 
     where teacher $sql{like} '%$userid%' order by grade, description");
    $sth->execute;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }


    # Setup to get Alt Subject Info, if present
    my $sth1 = $dbh->prepare("select description from rc_subject 
     where subjsec = ?");

    my $sth2 = $dbh->prepare("select subjsec from rc_teacher where userid = ?");
    $sth2->execute( $userid );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $altrows = $sth2->rows;

    print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"0\" ";
    print "style=\"background-color:#DDD;margin:1em;padding:0.5em;\">\n";

    
    my $count = 0;
    while ( my ($subjsec, $description, $grade) = $sth->fetchrow ) {

	print "<tr><td><form action=\"markadd1.pl\" method=\"post\" ";
	print "style=\"padding:0;margin:0;text-align:left;\">\n";
	print "<input type=\"hidden\" name=\"subjsec\" value=\"$subjsec\">\n";
	print "<input type=\"submit\" value=\"$description ($subjsec)\"> </form></tdn<td>";
	print $lex{Grade}. " <b>$grade</b></td></tr>\n";
	$count++;

    }



    if ( $altrows > 0 ) {

	print "</table>\n<h3>". $lex{'Alternate Report Card System'}. "</h3>\n";
	print "<form action=\"markaddalt.pl\" method=\"post\">\n";
	print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"1\">\n";
	print "<tr style=\"background-color:#EEE;\"><td align=\"center\">\n";
	print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";

	while ( my $subjsec = $sth2->fetchrow ) {

	    # Get Alt RC info
	    $sth1->execute( $subjsec );
	    my ( $description, $grade ) = $sth1->fetchrow;

	    print "<tr style=\"background-color:#EEE;\">";
	    print "<td style=\"padding:0.4em;margin:0;text-align:left;\">\n";
	    print "<input type=\"checkbox\" name=\"$subjsec\" value=\"1\">\n";
	    print "$description ($subjsec)</td></tr>\n";
	    $count++;
	    
	}
	
	print "<tr style=\"background-color:#DDD;\"><td align=\"center\">\n";
	print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";
	print "</table></form>\n";

    }


    if ( $count == 0 ) { # no records
	print "<tr><td>". $lex{'No Subjects Found'}. "</td></tr>\n";
    }

    print "</body></html>\n";

    exit;

} # end of showSubjects




#----------------
sub checkPassword {
#----------------

    my ($userid, $password) = @_;
    
    if (not $userid){ return -1;}
    if (not $password){ return -2;}

    #check for presence of userid
    my $sth = $dbh->prepare("select count(userid) from staff 
     where userid = ?");
    $sth->execute($userid);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ($count < 1){ return -1;} # no userid

    #check for presence of correct password and userid
    my $sth = $dbh->prepare("select count(userid) from staff 
     where userid = ? and passwd = ? ");
    $sth->execute($userid, $password);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ($count < 1){ return -2;} # not correct password

    return 0; # if all ok...

}


#------------------
sub checkCookieTime {
#------------------

    # Requires defaults of: $defaulttime, $maximumtime, $minimumtime
    my $defaulttime = 20;
    my $minimumtime = 3;
    my $maximumtime = 60;

    my ($duration) = @_;

    if ($duration) { 
	$cookietime = $duration;
    } else { 
	$cookietime = $defaulttime;
    }  

    $cookietime = $minimumtime if $cookietime < $minimumtime; 
    $cookietime = $maximumtime if $cookietime > $maximumtime; 
    $cookietime = "+".$cookietime."m"; # set format
    
    return $cookietime;

}


#--------
sub login { # print error, login screen and die;
#--------

    # Requires $lex values for: Continue, UserId, Password, Cookie Duration, Please Log In

    my $error = shift;
    my $userid = shift;

    if (not $error) { $error = $lex{'Please Log In'}; }
    print "$doctype\n<html><head><title>$error</title>
    <link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
    $chartype\n</head>\n";
    print "<body onload=\"document.forms[0].elements[1].focus()\">\n";
    print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

    print "<center><h1>$error</h1>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<table cellpadding=\"4\" cellspacing=\"1\" border=\"0\">\n";

    print "<tr><td align=\"right\">". $lex{UserId}. "</td>\n";
    print "<td><input type=\"text\" name=\"userid\" size=\"8\"></td></tr>\n";
    #value=\"$userid\"

    print "<tr><td align=\"right\">". $lex{Password}. "</td>\n";
    print "<td><input type=\"password\" name=\"password\" size=\"8\"></td></tr>\n";

    print "<tr><td align=\"right\">". $lex{'Cookie Duration'}. "</td>\n";
    print "<td><input type=\"text\" name=\"duration\" size=\"4\" value=\"20\"></td></tr>\n";

    print "<tr><td></td><td>\n";
    print "<input type=\"submit\" value=\"". $lex{Continue}. "\"></td></tr>\n";
    print "</table></form>\n";

    print "</center></body></html>\n";

    exit;

}
