#! /usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Assessment Entry' => 'Assessment Entry',
	   'No Subject Enrollment records found!' => 'No Subject Enrollment records found!',
	   'Main' => 'Main',
	   'System Disabled. Please contact secretary' => 
	     'System Disabled. Please contact secretary',
	   'Mark' => 'Mark',
	   'Move between fields using the <b>Tab</b> and <b>Shift-Tab</b> keys' =>
	     'Move between fields using the <b>Tab</b> and <b>Shift-Tab</b> keys',
	   'It is faster!' => 'It is faster!',
	   'Term' => 'Term',
	   'Save Assessments' => 'Save Assessments',
	   'Trm' => 'Trm',
	   'Objective' => 'Objective',
	   'Comment' => 'Comment',
	   'Your assessments are now stored in the database' => 
	     'Your assessments are now stored in the database',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Please contact' => 'Please contact',
	   'Please record' => 'Please record',
	   'Enter More Assessments' => 'Enter More Assessments',
	   'Please Log In' => 'Please Log In',
	   'Error' => 'Error',
	   'Current Evaluation' => 'Current Evaluation',


	   );

# Configured values
my $default_evalkeycols = 4;
#my $r_evalkeycols = 4; # should be in repcard.conf, but this is new release...


my $self = 'markadd1.pl';

use DBI;
use CGI;
use CGI::Session;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "../../etc/repcard.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

if ( not $r_evalkeycols ) {  # in case not set yet.
    $r_evalkeycols = $default_evalkeycols;
}

my $q = new CGI;
my %arr = $q->Vars;
my $subjsec = $arr{subjsec}; # passed in...

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session Information...
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

my $userid;
if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header( -charset, $charset );
    print "$doctype\n<html><head><title>". $lex{'Assessment Entry'}. "</title>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
    print "</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n<h1>\n";

    if ( $userid and $arr{writeflag} ) { # update records if user exists and writeflag set.
	delete $arr{writeflag};
	updateRecords();
	print $lex{'Please Log In'};
	die;
    } else {
	print $lex{'Please Log In'};
	print "</h1></body></html>\n";
	die;
    }
}
# Ok, we have a login. Values below we have in environment.

$userid = $session->param('userid');
$duration = $session->param('duration');
if (not ($duration =~ m/\+/)) {
    $duration = '+'. $duration. 'm';
}
$session->expire('logged_in',$duration);
print $session->header( -charset, $charset );


print "$doctype\n<html><head><title>". $lex{'Assessment Entry'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
print "<style type=\"text/css\">input:focus, textarea:focus ";
print " { background-color:#AEA;font-weight:bold; }\n";
print "a:link, a:visited { color:#DDD; }";

print "</style>\n";

# Some Javascript here for resizing...
print "<script type=\"text/javascript\">
 <!-- 
 function resize_div() {
   var x = document.getElementById(\"evalkey\");
   var iHeight = x.offsetHeight;
   //alert(iHeight);
   var oSpacer = document.getElementById(\"spacer\");
   oSpacer.style.height = (iHeight - 10 ) + 'px';
   //if (oFormDiv.offsetTop) {
   //  oFormDiv.style.top = iHeight + 20;
   //} else { alert('No Top Function'); }
   document.forms[0].elements[2].focus();
 }
\n";

print "function showmarks(studnum,term) { \n";
print " winName=window.open(\"viewassess.pl?studnum=\" + studnum + \"&term=\" + term,\n";
print "'Student_Marks','height=500,width=600,screenX=100,screenY=100,scrollbars=yes');";
print " winName.focus();
}
 -->
 </script>\n";

print "$chartype\n</head><body style=\"padding-left:1em;\" onload=\"resize_div()\">\n";
# End of HTML Head section.


# Get Subject Info: Description, Grade
my $sth = $dbh->prepare("select description, grade from subject where subjsec = ?");
$sth->execute( $subjsec );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
my ($description, $grade) = $sth->fetchrow;

my $acMode = 0; # Additional Comments don't have any values but a comment...
if ( $description eq $additionalcomments ) { # $additionalcomments set in admin.conf
    $acMode = 1;
}

my $subjectname;
if ($description =~ m/$grade/) {
    $subjectname = $description;
} else {
    $subjectname = "$description $grade";
}


# Get Subject Objectives and Put in @qstarray
$sth = $dbh->prepare("select * from subject where subjsec = ?");
$sth->execute($subjsec);
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
my @subject = $sth->fetchrow;

my @qstarray;
# Stuff questions into the array.
for ($a = 10;$a<=29; $a++) {
   if ($subject[$a]) { push @qstarray, $subject[$a]; }
}

if ( not $subject[10] ) { # blank qstarray
  # We must put in one question.
    push @qstarray, $lex{Mark};
}


# Read in the term(s)
my ($term, @terms, %terms);
open(TERM, "../../etc/term") || die "Can't open the term file!"; # slurp file
my $data;
{ local $/; $data = <TERM>; close FH;}
my @terms = split /\n/, $data;
$term = $terms[0];

# multiTrack variable is set in the admin.conf file.
if ($multiTrack) { # Are we in multiTrack mode? If so, reset term.
    for my $t (1..$#terms) {
	my ($key, $val) = split /:/, $terms[$t];
	$terms{$key} = $val;  # Form is   e:3  (elementary: term 3)
    }
    my $grp = $g_termtype{$grade};
    if ( $terms{$grp} ) {
	$term = $terms{$grp};
    }
}

# Check if disabled...
if ($term == 0) {
    print "<br>". $lex{'System Disabled. Please contact secretary'}. "\n";
    print "</body></html>\n";
    die;
}


# Update Records
if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    updateRecords();
}


# Get the students in this subjsect, in name order.
$sth = $dbh->prepare("select distinct eval.studnum from eval, student 
  where eval.subjcode = ? 
  and eval.studnum = student.studnum and eval.term = ? 
  order by student.lastname, student.firstname ");
$sth->execute($subjsec, $term);
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my @students;
while (my $studnum = $sth->fetchrow ) {
    push @students, $studnum;
}

if ( not @students ) {
    print "<h1>". $lex{'No Subject Enrollment records found!'}. "</h1>";
    print "</body></html>\n";
    die;
}


# Print Evaluation Keys
my @evalkey = ();
if ( $r_personal_growth eq $description ) { # if the subject is personal development
    # figure out the key scheme...used to print eval schemes $r_pdeval{$scheme}{arrayidx}
    my $scheme = $r_pdevalgrp{$grade};
    @evalkey = @{ $r_pdeval{$scheme} };
} else {
    my $scheme = $g_evalsch{$grade}; # OR $g_eval{scheme}[arrayidx]
    @evalkey = @{ $g_eval{$scheme} };
}

# Print Assessment Table at top
print "<div style=\"position:fixed;top:0;left:1em;color:#063;";
print "background-color:#FFF;\" id=\"evalkey\">\n";
print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\" ";
print "style=\"margin:0.2em auto 0 auto;\"><tr>\n";

# Print the Hint.
print "</tr><tr><td colspan=\"4\" align=\"center\" ";
print "style=\"color:white;background-color:#063;\">\n";
print "[ <a href=\"$tchpage\">". $lex{'Main'}. "</a> ]&nbsp;&nbsp;";
print $lex{'Move between fields using the <b>Tab</b> and <b>Shift-Tab</b> keys'}. ".\n";
print $lex{'It is faster!'}. "</td></tr>\n";

my $itemcount;
foreach my $item ( @evalkey ){
    if ( $item =~ /[^~+]/ ){ # skip any items with leading tildes ?
	print "<td>$item</td>\n"; 
	$itemcount++;
    }
    if ( $itemcount % $r_evalkeycols == 0 ){ # 4-3 one less (3-2 works)
	print "</tr><tr>\n";
    }
}
$remainder = $r_evalkeycols - ( $itemcount % $r_evalkeycols );
if ( $remainder == $r_evalkeycols ) { $remainder = 0; }
for ( 1..$remainder ){ print "<td></td>\n";}
print "</tr>\n</table></div>\n\n";

# print Spacer div behind absolutely positioned assessment key div
print "<div style=\"height:70px;\" id=\"spacer\"></div>\n";

# Remove after testing.... June / 07 latest...
#----------------------
#print "The terms are ";
#print "Main Term: $term<br>\n";
#foreach my $key (sort keys %terms) {
#    print "K:$key V:$terms{$key}<br>\n";
#}
#print "Actual group is ", $g_termtype{$grade}, "<br>\n";
#print "New Term: ", $terms{ $g_termtype{$grade} }, "<br>\n";
# $g_termstart{val}[term] = 
#----------------------


# Print Top Section / Start of Form
print "<center><h1 style=\"margin:0.5em;\">". $lex{'Assessment Entry'}. " &ndash; ";
print $lex{Term}. " $term</h1>\n";
print "<h2 style=\"margin:0.2em;\">$subjectname</h2>\n";
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";
print "<input type=\"submit\" value=\"". $lex{'Save Assessments'}. "\">\n";

my $sth = $dbh->prepare("select * from eval where studnum = ? and subjcode = ? order by term");

my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");

foreach my $studnum ( @students ) { # Loop through all students in this class.

    # Get Student Name
    $sth1->execute($studnum);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth1->fetchrow;


    # Load all eval records for this student in this subject (ie. all terms)
    # structure is a hash pointing to an array. (full eval record)
    my %evals;
    $sth->execute($studnum, $subjsec);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    while ( my @eval = $sth->fetchrow ) { # put into %evals hash
	$evals{$eval[4]} = [ @eval ];
    }

    print"\n<table cellpadding=\"2\" cellspacing=\"0\" border=\"1\">\n";
    print "<tr><th colspan =\"2\">$firstname $lastname &nbsp;&nbsp;";
    print "<span style=\"font-size:80%\"><a href=\"javascript:showmarks($studnum,$term)\">";
    print $lex{'Current Evaluation'}. "</a></span></th></tr>\n";
    print "<tr><td align=\"center\"><!-- Now Inner Table -->\n";

    my $id = $evals{$term}->[0];

    if ( not $acMode ) {
	print "<table cellpadding=\"2\" cellspacing=\"0\">\n";
	print "<tr style=\"background-color:#DDD;\"><td align=\"center\"><i>";
	print $lex{Objective}. "</i></td>\n";

	# Print Terms row...
	foreach my $trm ( sort keys %evals ) {
	    if ( $trm <= $term ) {
		print "<td align=\"center\"><i>". $lex{Trm}. " $trm</i></td>\n";
	    } else {
		last; # just out if hit current term
	    }
	}
	print "</tr>\n";

	my $count = 1; 
	my $qst = 7;
	foreach my $question ( @qstarray ){ 
	    print "<tr><td align=\"left\">$count. $question</td>";

	    # print previous term values
	    foreach my $trm ( sort keys %evals ) {
		if ( $trm < $term ) {
		    print "<td align=\"center\"><i>". $evals{$trm}->[$qst]. "</i></td>\n";
		} else {
		    last; # just out if hit current term
		}
	    }

	    # print current term.
	    print "<td align=\"left\">";
	    print "<input type=\"text\" name=\"$id:$studnum:$count\" ";
	    print " size=\"4\" value=\"". $evals{$term}->[$qst]. "\"></td></tr>\n";

	    $count++;
	    $qst++;
	}
	print "<!-- Finish Inner Table --></td></tr></table>\n";
    }


    print "<div style=\"text-align:left;padding:0.5em;\">\n";
    # Print Previous Comments...
    foreach my $trm ( sort keys %evals ) {
	if ( $trm < $term and $evals{$trm}->[6] ) {
	    print "<i>". $lex{Term}. " $trm:</i> ". $evals{$trm}->[6]. "<br>\n";
	}
    }


    print "<i>". $lex{Term}. " $term ". $lex{Comment}. ":</i><br>\n";
    print "<textarea name=\"$id:$studnum:comment\" cols=\"90\" rows=\"4\">";
    print $evals{$term}->[6];
    print "</textarea></div>\n";

    print "</td></tr></table><p></p>\n";

}

print "<input type=\"submit\" value=\"". $lex{'Save Assessments'}. "\">\n";
print "</form></div></body></html>\n";



#----------------
sub updateRecords {
#----------------

    #foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    foreach my $key ( keys %arr ) {
 
	my ( $evalrec, $studnum, $qst) = split /:/, $key;

	# check field type and quote.
	if ($qst eq "comment"){
	    $fieldid = "comment";
	    $arr{$key} = $dbh->quote( $arr{$key} );
	    
	} else { 
	    $fieldid = "a$qst";
	    $arr{$key} = "\U$arr{$key}";
	    $arr{$key} = $dbh->quote($arr{$key});
	}
	$evalrec = $dbh->quote( $evalrec );

	$sth = $dbh->prepare("update eval set
         $fieldid = $arr{$key} where id = $evalrec");
	# Note: Mysql fails if single quotes used with bind vars. So using older method.
	$sth->execute;
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    }


    if (not $DBI::errstr ) {
	print "<h3>". $lex{'Your assessments are now stored in the database'}. ".</h3>\n";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. ". \n";
	print $lex{'Please contact'};
	print " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Please record'}. ": $DBI::errstr</h3></p>";
    }

    print "<span style=\"background-color:#063;padding:0.5em;\"> <a href=\"$tchpage\">";
    print $lex{Main}. "</a>&nbsp;&nbsp;\n";
    print "<a href=\"markadd0.pl\">". $lex{'Enter More Assessments'}. "</a> </span>\n";
    print "</center></body></html>\n";

    exit 0;

} # End of Update Record.
