#! /usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my $studenttable = 'student'; # put in studentall if you want to see withdrawn also

my %lex = ('Assessment Entry' => 'Assessment Entry',
	   'No Subject Enrollment records found!' => 'No Subject Enrollment records found!',
	   'Main' => 'Main',
	   'System Disabled. Please contact secretary' => 
	     'System Disabled. Please contact secretary',
	   'Move between fields using the <b>Tab</b> and <b>Shift-Tab</b> keys' =>
	     'Move between fields using the <b>Tab</b> and <b>Shift-Tab</b> keys',
	   'It is faster!' => 'It is faster!',
	   'Term' => 'Term',
	   'Save Assessments' => 'Save Assessments',
	   'Your assessments are now stored' => 'Your assessments are now stored',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',
	   'Enter More Assessments' => 'Enter More Assessments',
	   'Please Log In' => 'Please Log In',
	   'Error' => 'Error',
	   'Fill Blanks' => 'Fill Blanks',
	   'from Previous Term' => 'from Previous Term',

	   );

my $self = 'markaddalt.pl';

use DBI;
use CGI;
use CGI::Session;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "../../etc/repcard.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = new CGI;
my %arr = $q->Vars;

my $evalfill; # fill blanks from previous term eval recs
if ( $arr{evalfill} ) {
    delete $arr{evalfill};
    $evalfill = 1;
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session Information...
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

my $userid;
if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header( -charset, $charset );

    print "$doctype\n<html><head><title>". $lex{'Assessment Entry'}. "</title>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
    print "</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n<h1>\n";

    if ( $userid and $arr{writeflag} ) { # update records if user exists and writeflag set.
	delete $arr{writeflag};
	updateRecords();
	print $lex{'Please Log In'};
	die;
    } else {
	print $lex{'Please Log In'};
	print "</h1></body></html>\n";
	die;
    }
}
# Ok, we have a login. Values below we have in environment.

$userid = $session->param('userid');
$duration = $session->param('duration');
if (not ($duration =~ m/\+/)) {
    $duration = '+'. $duration. 'm';
}
$session->expire('logged_in',$duration);
print $session->header( -charset, $charset );

print "$doctype\n<html><head><title>". $lex{'Assessment Entry'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";

#print "<style type=\"text/css\">input:focus, textarea:focus ";
#print " { background-color:#DED;font-weight:bold; }\n";
#print "a:link, a:visited { color:#AAA; }";
#print "</style>\n";

print "$chartype\n</head><body style=\"padding-left:1em;\">\n";
# End of HTML Head section.


# Read in the term(s)
my ($term, @terms, %terms);
open(TERM, "../../etc/term") || die "Can't open the term file!"; # slurp file
my $data;
{ local $/; $data = <TERM>; close FH;}
my @terms = split /\n/, $data;
$term = $terms[0];

# multiTrack variable is set in the admin.conf file.
$multiTrack = 0;
if ($multiTrack) { # Are we in multiTrack mode? If so, reset term.
    for my $t (1..$#terms) {
	my ($key, $val) = split /:/, $terms[$t];
	$terms{$key} = $val;  # Form is   e:3  (elementary: term 3)
    }
    my $grp = $g_termtype{$grade};
    if ( $terms{$grp} ) {
	$term = $terms{$grp};
    }
}


# Check if disabled...
if ($term == 0) {
    print "<br>". $lex{'System Disabled. Please contact secretary'}. "\n";
    print "</body></html>\n";
    die;
}


# Update Records
if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    updateRecords();
}


foreach my $subjsec ( keys %arr ) { 
    #print "K:$subjsec V:$arr{$subjsec}<br>\n"; 

    # Get Subject enrollments and student names
    $sth = $dbh->prepare("select distinct e.studnum, s.lastname, s.firstname 
      from  rc_obj_eval as e, $studenttable as s, rc_objective as o 
      where o.id = e.objid and e.studnum = s.studnum and o.subjsec = ?");
    $sth->execute($subjsec);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

    while ( my ( $studnum, $lastname, $firstname ) = $sth->fetchrow ) {
	push @students, "$lastname$firstname:$studnum:$subjsec";
    }

}

#foreach my $stud ( sort @students ) { print "$stud<br>\n"; }

if ( not @students ) {
    print "<h1>". $lex{'No Subject Enrollment records found!'}. "</h1>";
    print "</body></html>\n";
    die;
}


# Print the Hint.
print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]&nbsp;&nbsp;";
print $lex{'Move between fields using the <b>Tab</b> and <b>Shift-Tab</b> keys'}. ".\n";
print $lex{'It is faster!'}. "\n\n";

# Print the Fill Button
print "<br><form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"hidden\" name=\"evalfill\" value=\"1\">\n";
foreach my $subjsec ( keys %arr ) {
    print "<input type=\"hidden\" name=\"$subjsec\" value=\"1\">\n";
}
print "<input type=\"submit\" value=\"". $lex{'Fill Blanks'}. q{ };
print  $lex{'from Previous Term'}. "\"></form>\n\n";



# Print Top Section / Start of Form
print "<center><h1 style=\"margin:0.5em;\">". $lex{'Assessment Entry'}. " &ndash; ";
print $lex{Term}. " $term</h1>\n";
print "<h2 style=\"margin:0.2em;\">$subjectname</h2>\n";
print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";
print "<input type=\"submit\" value=\"". $lex{'Save Assessments'}. "\">\n";

my $sth1 = $dbh->prepare("select lastname, firstname from $studenttable where studnum = ?");
my $sth2 = $dbh->prepare("select description from rc_subject where subjsec = ?");

my $currstud = -1;
my $prevstud;
my $first = 1;

foreach my $rec ( sort @students ) { # Loop through all students/subject

    my ( $dud, $studnum, $subjsec ) = split /:/, $rec;

    $prevstud = $currstud;
    $currstud = $studnum;

    # Get Student Name
    $sth1->execute( $studnum );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my ($lastname, $firstname) = $sth1->fetchrow;

    # Get Subject Name
    $sth2->execute( $subjsec );
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
    my $description = $sth2->fetchrow;


    # If new subject and/or student, start a new table.
    if ( $currstud != $prevstud ) {
	if ( not $first ) { print "</table><p></p>\n"; } else { $first = 0; }

	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print "<tr><th colspan=\"2\">$firstname $lastname</th></tr>\n";
    }

    print "<tr><td colspan=\"2\" style=\"background-color:#DDD;font-weight:bold;\">\n";
    print "$firstname $lastname &ndash; $description</td></tr>\n";

    # Prep to get current eval for this objective, this student, this term.
    my $sth3 = $dbh->prepare("select id, eval from rc_obj_eval 
     where objid = ? and studnum = ? and term = ?");

    # Prep to get current choices for this objective;
    my $sth4 = $dbh->prepare("select choice from rc_obj_choice where objid = ?
     order by id");


    # Load objectives for this subject and their id's. (which are objid's)
    my $sth = $dbh->prepare("select id, description from rc_objective 
     where subjsec = ? order by groupname, groupseq");
    $sth->execute( $subjsec );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}

    while ( my ( $objid, $objdesc ) = $sth->fetchrow ) {

	# Get id and current evaluation ( if any )
	$sth3->execute( $objid, $studnum, $term );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	my ( $id, $eval ) = $sth3->fetchrow;

	if ( not $eval and $evalfill and $term > 1 ) { # fill with previous term
	    $sth3->execute( $objid, $studnum, $term - 1 );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	    my ( $previd, $preveval ) = $sth3->fetchrow;
	    $eval = $preveval;
	}

	# print start of section
	print "<tr><td>$objdesc<br><select name=\"$id\"><option>$eval</option>\n";

	# Now Get Choices
	$sth4->execute( $objid );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
	while (	my $choice = $sth4->fetchrow ) {
	    print "<option>$choice</option>\n";
	}
	print "</select></td></tr>\n";

    } # Done this objective


} # Done all students/subjects.

print "</table>\n";


print "<input type=\"submit\" value=\"". $lex{'Save Assessments'}. "\">\n";
print "</form></div></body></html>\n";



#----------------
sub updateRecords {
#----------------

    #foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my $sth = $dbh->prepare("select eval from rc_obj_eval where id = ?");

    foreach my $id ( keys %arr ) {
 
	$sth->execute( $id );
	if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $eval = $sth->fetchrow;
	#if ( not defined $eval ) { print " Eval Undefined \n"; }
	#if ( not $arr{$id} ) { print " Rec Undefined<br>\n"; }

	if ( $eval eq $arr{$id} ) { next; } # skip unchanged values

	$arr{$id} = $dbh->quote( $arr{$id} );
	
	$sth1 = $dbh->prepare("update rc_obj_eval set eval = $arr{$id} where id = ?");
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$sth1->execute( $id );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    }

    if (not $DBI::errstr ) {
	print "<h3>". $lex{'Your assessments are now stored'}. ".</h3>\n";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. ". \n";
	print $lex{Contact};
	print " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{Error}. ": $DBI::errstr</h3></p>";
    }

    print "<span style=\"background-color:#063;padding:0.5em;\"> <a href=\"$tchpage\">";
    print $lex{Main}. "</a>&nbsp;&nbsp;\n";
    print "<a href=\"markadd0.pl\">". $lex{'Enter More Assessments'}. "</a> </span>\n";
    print "</center></body></html>\n";

    exit 0;

} # End of Update Record.
