#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'View Student Marks' => 'View Student Marks',
	   'Student' => 'Student',
	   'Select' => 'Select',
	   'View Marks' => 'View Marks',
	   'No Value Entered' => 'No Value Entered',
	   'Grade' => 'Grade',
	   'No Selection' => 'No Selection',
	   'Select by' => 'Select by',
	   'Homeroom' => 'Homeroom',
	   'Error' => 'Error',
	   'Chk' => 'Chk',
	   'Term' => 'Term',
	   'Multiple records for the same term in the same subject! Please Fix!' => 
	     'Multiple records for the same term in the same subject! Please Fix!',
	   'Error for' => 'Error for',
	   'No Subject Enrollments' => 'No Subject Enrollments',
	   'Objectives' => 'Objectives',
	   'Subject' => 'Subject',

	   );

my $self = 'markview.pl';

use DBI;
use CGI;

# Passed Values: group: Homeroom, Grade, Student
# value: A value for one of the groups above.

# Read config variables
eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
    $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


# Print Page Head
print "$doctype\n<html><head><title>". $lex{'View Student Marks'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";


if ( $arr{page} == 1 ) {
    delete $arr{page};
    showResults();
}

# Print Form.
print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"submit\" value=\"". $lex{'Select by'}. "\">\n";
print "<select name=\"group\">";
if ( $arr{group} ) { print "<option>$arr{group}</option>\n"; }
if ( $arr{group} ne $lex{Grade} ) { print "<option>". $lex{Grade}. "</option>\n"; }
if ( $arr{group} ne $lex{Homeroom} ) { print "<option>". $lex{Homeroom}. "</option>\n"; }
if ( $arr{group} ne $lex{Student} ) { print "<option>". $lex{Student}. "</option>\n"; }
print "</select> <input type=\"text\" name=\"value\" size=\"10\">\n";
print $lex{Chk}. " <input type=\"checkbox\" name=\"check\" value=\"checked\"\n";
print "</form>\n";

print "<center><h1>". $lex{'View Student Marks'};
print " &ndash; $arr{group} $arr{value}</h1><h3>$currdate</h3>\n";

if ( not $arr{value} ) {
    print "<h1>". $lex{'No Value Entered'}. ".</h1>\n";
    print "</body></html>\n";
    die;
}


my $sth;
if ($arr{group} eq $lex{Homeroom} and $arr{value}){
    $sth = $dbh->prepare("select lastname, firstname, studnum  from student
     where homeroom = ? order by lastname, firstname");
} elsif ($arr{group} eq $lex{Grade} and $arr{value}){
    $sth = $dbh->prepare("select lastname, firstname, studnum  from student
     where grade = ? order by lastname, firstname");
} elsif ($arr{group} eq $lex{Student} and $arr{value}){
    $sth = $dbh->prepare("select lastname, firstname, studnum  from student
     where studnum = ? order by lastname, firstname");
} else {
    print $lex{'No Selection'};
    print "</body></html>\n";
    die;
}

$sth->execute( $arr{value} );
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }

# Setup statement handle to find which table student is in.
my $sth1 = $dbh->prepare("select studnum from student where studnum = ?");

print"<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Student}. "</th><th>". $lex{Select}. "</th></tr>\n";

print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"page\" value=\"1\">
<tr><td colspan=\"2\" align=\"center\"><input type=\"submit\" 
value=\"". $lex{'View Marks'}. "\"></td></tr>\n";

while ( my ($lastname, $firstname, $studnum) = $sth->fetchrow ) {

    # Now let's find which table student from: student or studentwd
    $sth1->execute($studnum);
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    my $active = $sth1->rows;  # returns 1 if in student, 0 if not.
    my $studentname = "<b>$lastname,</b> $firstname ($studnum)";
    $checked = $arr{check};
    if (not $active){ 
	$studentname = "<font color=\"red\">$studentname</font>";
	$checked = '';
    }
    
    print "<tr><td>$studentname</td><td align=\"center\"><input type=\"checkbox\" ";
    print "name=\"$lastname:$firstname:$studnum\" value=\"1\" $checked>\n";
    print "</td></tr>\n";
}
  
print "<tr><td colspan=\"2\" align=\"center\">";
print "<input type=\"submit\" value=\"". $lex{'View Marks'}. "\"></td></tr>\n";
print "</form></table></center></body></html>\n";



#--------------
sub showResults {
#--------------

    #foreach my $key (keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    # Get All Subject Information and put into hash with key as subjsec
    #  and value is pointer to the array.
    my %subject;
    my $sth = $dbh->prepare("select * from subject");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    while ( my @subject = $sth->fetchrow ){
	my $subjref = [ @subject ];
	$subject{$subject[9]} = $subjref;
    }

    # Get the number of terms from the eval table
    my $sth = $dbh->prepare("select max(term) from eval");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die;}
    my $maxterm = $sth->fetchrow;


    foreach my $stud (sort keys %arr){ # loop through passed student values

	my ($lastname, $firstname, $studnum) = split /:/,$stud;
	print "<h2>$firstname $lastname ($studnum)</h2>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

	#print "<tr><th>". $lex{Subject}. q{/}. $lex{Objectives}. "</th>\n";
	#for (1..$maxterm){ print "<th>". $lex{Term}. " $_</th>";}
	#print "</tr>\n";
    
	# Create Structured Hash for eval results: 
	# a)Find his/her subjects in order
	my $sth = $dbh->prepare("select distinct eval.subjcode from eval, subject
         where eval.subjcode = subject.subjsec and 
         eval.studnum = ? 
         order by subject.description,eval.subjcode");
	$sth->execute($studnum);
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

	my $sth1 = $dbh->prepare("select * from eval where subjcode = ? and
         eval.studnum = '$studnum' order by term");

	my $subjflag = 0; # flag in case of no subj enrollments.
	while (my $code = $sth->fetchrow ){ # Loop through each subject.
	    $subjflag = 1;
	    # Get Objectives Count for this subject; also # of loops
	    my $objcount; # objective count
	    for (10...29){
		if ($subject{$code}->[$_]){$objcount++;} else {last;}
	    }

	    $eval{$code} = []; # Create anonymous hash to hold pointer.
	    $sth1->execute($code); # Find the records for this subject.

	    my $currterm = -1;

	    while (my @evalrec = $sth1->fetchrow){ # Loop through eval recs.
		# Code to Check for Term Errors
		$prevterm = $currterm;
		$currterm = $evalrec[4];
		if ($prevterm == $currterm){ # We have an error!
		    print $lex{'Error for'}. " <b>$lastname, $firstname ($studnum)</b> ";
		    print $lex{Subject}. " <b>";
		    print " $subject{$code}->[2] </b> ". $lex{Term}. " <b>$currterm</b>.";
		    print $lex{'Multiple records for the same term in the same subject! Please Fix!'}. "\n";
		}
	    
		$eval[$evalrec[4]] = [ @evalrec ]; # store record 
	    } # End of Eval Creation Loop

	    if ($#eval > -1){ # If we have any eval records for this subject...
		if ($objcount == 0){ # No objectives... just marks (1 line)
		    print "<tr><td><b>${$subject{$code}}[2]</b></td>";
		    for (1..$#eval){
			print "<td align=\"center\"><b>$eval[$_]->[7]</b></td>";
		    }
		    print "</tr>\n";
		} else { # We have objectives listed
		    print "<tr><td><b>${$subject{$code}}[2]</b></td>"; # blank line w subj
		    for (1..$#eval){
			print "<td></td>";
		    }
		    print "</tr>\n";
		    for ($i = 1; $i <= $objcount; $i++){ # of lines/objectives
			my $subjindex = $i + 9;
			my $evalindex = $i + 6;
			print "<tr><td>${$subject{$code}}[$subjindex]</td>";
			for (1..$#eval){
			    print "<td align=\"center\"><b>$eval[$_]->[$evalindex]</b></td>";
			}
			print "</tr>\n";
		    }
		} # End of 'Objectives listed' - ie. not just marks.
		# Now Print Comments
		my $colcount = $#eval + 1;
		print "<tr><td colspan=\"$colcount\">";
		for (1..$#eval){
		    if ($eval[$_]->[6]){print "<i>Trm: $_</i> $eval[$_]->[6]<br>";}
		}
		print "</td></tr>\n";
		@eval = (); # empty the array for the next loop.

	    }  # End of 'Do we have eval records?'

	} # Next Subject

	if (not $subjflag){ # No subject enrollments for this student.
	    my $colcount = $maxterm + 1;
	    print "<tr><td colspan=\"$colcount\"><b>". $lex{'No Subject Enrollments'};
	    print "</b></td></tr>\n";
	}
	print "</table>\n";

    } # End of Student Loop

    print "</body></html>\n";

    exit;

}
