#! /usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

# Outline: This prints a full report of evaluations for a group of
#  students. These student numbers are passed in the %arr hash.

my %lex = ('Student Marks' => 'Student Marks',
	   'Main' => 'Main',
	   'No Subject Enrollments' => 'No Subject Enrollments',
	   'Error' => 'Error',
	   
	   );

use DBI;
use CGI;

eval require "../../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

# Passed Values: studnum, subjsec, term
my $studnum = $arr{studnum};
my $term = $arr{term};


# Print the Page Header
print "$doctype\n<html><head><title>". $lex{'Student Marks'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>\n";
#print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get student name...
my $sth = $dbh->prepare("select lastname, firstname from student where studnum = ?");
$sth->execute($studnum);
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my ($lastname, $firstname) = $sth->fetchrow;

print "<h2>$firstname $lastname &ndash; <span style=\"font-size:80%;\">Term: $term</span></h2>\n";
print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";


# Find student subjects and eval.id in order by subject description.
my $sth = $dbh->prepare("select distinct subject.description, eval.subjcode, 
 eval.id from eval, subject
 where eval.subjcode = subject.subjsec and eval.studnum = ? and eval.term = ?
 order by subject.description, eval.subjcode");
$sth->execute($studnum, $term);
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }


my $sth1 = $dbh->prepare("select * from eval where id = ?");
my $subjflag = 0; # flag in case of no subj enrollments.

while ( my ( $desc, $subjsec, $id ) = $sth->fetchrow ){ # Loop through each subject.

    $subjflag = 1; # we have at least one subject

    # Get eval record.
    $sth1->execute( $id );
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my @eval = $sth1->fetchrow;

    print "<tr><td><b>$desc</b> ";

    if ( $eval[8] ) { # We have more than 1 entry... load descriptors from subject.

	# Load Subject
	my $sth2 = $dbh->prepare("select * from subject where subjsec = ?");
	$sth2->execute( $subjsec );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my @subject = $sth2->fetchrow;

	print '[ ';
	foreach my $i (10..29) {
	    if ( $subject[$i] ) {
		print "$subject[$i] &ndash; $eval[ $i - 3 ] | \n";
	    } else {
		last; # done
	    }
	}
	if ( $eval[6] ) { print "<br><i>$eval[6]</i>\n"; }
    } else {
	if ($eval[7]) { print "&ndash; $eval[7] "; }
	if ($eval[6]) { print "&ndash; $eval[6] "; }
    }

    print "</td></tr>\n";


} # Next Subject


if (not $subjflag){ # No subject enrollments for this student.
    my $colcount = $maxterm + 1;
    print "<tr><td colspan=\"$colcount\"><b>". $lex{'No Subject Enrollments'}. "</b></td></tr>\n";
}

print "</table></body></html>\n";
