#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Birthday List' => 'Birthday List',
	   'Main' => 'Main',
	   'Month' => 'Month',
	   'Day' => 'Day',
	   'Name' => 'Name',
	   'Birthdate' => 'Birthdate',
	   'Error' => 'Error',
	   'Group by' => 'Group by',
	   'Homeroom' => 'Homeroom',
	   'School' => 'School',
	   'Grade' => 'Grade',
	   'Continue' => 'Continue',
	   'Select' => 'Select',
	   'Blank=All' => 'Blank=All',
	   'No Records Found' => 'No Records Found',
	   'Grade' => 'Grade',

	   );

my $self = 'rptbirthday.pl';

use DBI;
use CGI;
use Cwd;


my $q = new CGI;
my %arr = $q->Vars;
print $q->header( -charset, $charset );

# Read config variables
eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year += 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


# Get current dir so know what CSS to display;
if ( getcwd() =~ /tcgi/ ){ # we are in tcgi
    $css = $tchcss;
    $homepage = $tchpage;
}

# print table head
print "$doctype\n<html><head><title>". $lex{'Birthday List'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body><a name=\"top\"></a>\n";
print "[ <a href=\"$homepage\">". $lex{Main}. "</a> ]
<center><h1>". $lex{'Birthday List'}. "</h1><h3>$currdate</h3>\n";

if ( not $arr{page} ) {
    showStartPage();
} 


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $select;
if ( $arr{select} ) { # we have a selection
    if ( $arr{mode} eq 'homeroom' ) {
	my $grp = $dbh->quote( $arr{select} );
	$select = "where homeroom = $grp";
    } elsif ( $arr{mode} eq 'grade' ) {
	my $grp = $dbh->quote( $arr{select} );
	$select = "where grade = $grp";
    }
}

my $sortorder;
my $grp;
if ( $arr{mode} eq 'homeroom' ) {
    $sortorder = "homeroom, lastname, firstname";
    $grp = 'homeroom';
} elsif ( $arr{mode} eq 'grade' ) {
    $sortorder = "grade, lastname, firstname";
    $grp = 'grade';
} else {
    $sortorder = "lastname, firstname";
    $grp = 'grade';
}



$sth = $dbh->prepare("select lastname, firstname, initial, $grp, birthdate, grade 
 from student $select order by $sortorder");
$sth->execute;
if ( $DBI::errstr ) {print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;
if ( $rows < 1 ) {
    print "<h3>". $lex{'No Records Found'}. "</h3>\n";
    print "</body><html>\n";
    exit;
}

#print "Rows: $rows<br>\n";

my %records = ();

while ( my ( $lastname, $firstname, $initial, $group, $birthdate, $grade ) = 
	$sth->fetchrow ) {

    if ( not $group ) { $group = 0; }
    if ( $arr{mode} eq 'school' ) { $group = '0'; }

    my ($yr,$mon,$day) = split /-/, $birthdate;

    if ( defined @{$records{$group}}) {
	push @{$records{$group}}, "$mon$day:$lastname, $firstname $initial:$birthdate:$grade";
    } else {
	$records{$group} = [ "$mon$day:$lastname, $firstname $initial:$birthdate:$grade" ];
    }

} # End of loop


# Print Records Now.
foreach my $ref ( sort  {$a <=> $b} keys %records ) { 
    prTable( $ref, @{ $records{$ref} } );
}

print "[ <a href=\"#top\">Top</a> ]</body></html>\n";


#----------
sub prTable { # print table and then a space.
#----------

    my ($group, @records) = @_;

    if ( $arr{mode} eq 'grade' ) {
	print "<p><b>". $lex{Grade}. " $group</b>\n";
    } elsif ( $arr{mode} eq 'homeroom' ) {
	print "<p><b>". $lex{Homeroom}. " $group</b>\n";
    }

    print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
    print '<tr><th>'. $lex{Month}. '</th><th>'. $lex{Day}. '</th><th>'. $lex{Name};
    print '</th><th>'. $lex{Birthdate}. '</th><th>'. $lex{Grade}. "</th></tr>\n";

    @sortedrec = sort @rec;
    for my $rec (sort @records) {
	my ($blank,$name,$bday, $grade) = split /:/, $rec;
	my ($yr,$mon,$day) = split /-/, $bday;
	print "<tr><td align=\"right\">$month[$mon]</td>\n";
	print "<td>$day</td><td>$name</td><td>$bday</td><td>$grade</td></tr>\n";
    }

    print "</table>\n<p>&nbsp;</p>\n";

}


#----------------
sub showStartPage {
#----------------

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<p><b>". $lex{'Group by'}. "</b><br>\n";
    print $lex{Homeroom}. " <input type=\"radio\" name=\"mode\" value=\"homeroom\">\n";
    print $lex{Grade}. " <input type=\"radio\" name=\"mode\" value=\"grade\">\n";
    print $lex{School}. " <input type=\"radio\" name=\"mode\" value=\"school\"></p>\n";

    print "<div><b>". $lex{Select}. "</b> \n";
    print "<input type=\"text\" name=\"select\" width=\"6\" > ". $lex{'Blank=All'}. "</div>\n";

    print "<p><input type=\"submit\" value=\"". $lex{Continue}. "\"></p></form>\n";

    print "</body></html>\n";

    exit;
}
