#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

# Now called "Report Discipline" (rptdisc.pl) - was rptstud.pl
#  April 4: Modified to not show records with a Y in private field.

my %lex = ('Student Infractions by Date' => 'Student Infractions by Date',
	   'Main' => 'Main',
	   'Password not found or User not teacher' => 'Password not found or User not teacher',
	   'Student Infractions' => 'Student Infractions',
	   'Click on Student Name to view their records only' => 
	     'Click on Student Name to view their records only',
	   'No records found' => 'No records found',
	   'If Repeated' => 'If Repeated',
	   'Parent' => 'Parent',
	   'Please Log In' => 'Please Log In',
	   'Not Found' => 'Not Found',
	   'Error' => 'Error',
	   'Withdrawn' => 'Withdrawn',

	   );

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:$dbtype;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

# Get Session Values (a defined userid means it was passed)
if ( not $session->param('logged_in') ){
    #$userid = $session->param('userid');
    print $q->header( -charset, $charset );
    print "$doctype\n<html><head><title>". $lex{'Student Infractions by Date'}. "</title>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
    print "$chartype\n</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

    print "<h1>". $lex{'Please Log In'}. "</h1>\n"; 
    print "</body></html>\n";
    die;
}
# Ok, we have a login. Values below we have in environment.

$userid = $session->param('userid');
$duration = $session->param('duration');
if (not ($duration =~ m/\+/ )) {
    $duration = '+'. $duration. 'm';
}
$session->expire('logged_in', $duration );

print $session->header( -charset, $charset );


# Print HTML Header
print "$doctype\n<html><head><title>". $lex{'Student Infractions by Date'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

# Check for classroom teacher or administrator...
$sth = $dbh->prepare("select count(*) from staff
  where userid = ? and  ( position = ? or position = ? or position = ? )");

# We need a better solution than this...
# check for classroom teacher (first position in g_position array in
# admin.conf) or administrator (present in @g_posadmin in admin.conf)

$sth->execute( $userid, $g_position[0], $g_posadmin[0], $g_posadmin[1] );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
$count = $sth->fetchrow;
if ($count < 1){
    print "<h1>". $lex{'Password not found or User not teacher'}. ".</h1>\n";
    print"<form><input type=\"button\" ";
    print"onclick=\"javascript:history.back()\" value=\"Back!\">";
    print"</form></center></body></html>\n"; 
    die;
}

# If passed a student value, find only that student...
if ( $arr{student} ) {
    my $stud = $dbh->quote( $arr{student} );
    $sth = $dbh->prepare("select * from discipline where userid = $stud
     order by date desc");

# Show only homeroom
} elsif ( $arr{homeroom} ) {

    my $hroom = $dbh->quote( $arr{homeroom} );
    $sth = $dbh->prepare("select * from discipline
     left outer join studentall on discipline.userid = student.studnum
     where student.homeroom = $hroom and
     (discipline.private <> 'Y' or discipline.private IS NULL)
     order by discipline.userid, discipline.date desc");

} else { 
    $sth = $dbh->prepare("select d.* from discipline as d, studentall as s
    where d.userid = s.studnum
    order by s.lastname, s.firstname, d.date desc");
}

$sth->execute;

if ($DBI::errstr) {print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;

print "<center><h1>". $lex{'Student Infractions'}. "</h1></center>\n";
print "<p>". $lex{'Click on Student Name to view their records only'}. "</p>\n";


if ($rows < 1){
    print "<p><b>". $lex{'No records found'}. ".</b></p>\n";
}

my $currstud;
my $first = 1;

while ( my @arr = $sth->fetchrow ) {
    if ( $arr[9] eq 'Y' ) { next; } # skip private records
   
    $oldstud = $currstud;
    $currstud = $arr[2];     

    my $withdrawn;
    if ( $oldstud ne $currstud ) {  # We have a new student

	# Lookup Student Name
	my $sth1 = $dbh->prepare("select lastname, firstname from student where studnum = ?");
	$sth1->execute( $currstud );
	my $strows = $sth1->rows;
	if ($strows < 1){
	    $sth1 = $dbh->prepare("select lastname, firstname from studentwd where studnum = ?");
	    $sth1->execute( $currstud );
	    $withdrawn = "<span style=\"color;red;\">". $lex{Withdrawn}. "</span>";
	} 

	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname ) = $sth1->fetchrow; 
	if ( not $lastname ) {
	    $lastname = $lex{'Not Found'};
	    $withdrawn = "<span style=\"color;red;\">". $lex{Withdrawn}. "</span>";
	}

	if ($first) { $first = 0; } else { print "</ul><p></p>\n"; }

	print "<h1><a href=\"rptdisc.pl?student=$currstud\">";
	print"$firstname $lastname</a> ($currstud) $withdrawn</h1><ul>\n";

    }


    if (! $arr{summary} ) {
	print "<li><i>$arr[1]</i> [ <b>$arr[3]</b> ] ($arr[8]) $arr[4] $arr[5] \n";
	print "<i>". $lex{'If Repeated'}. ":</i> $arr[6] <i>". $lex{Parent}. ":</i>$arr[7]</li>\n";
    }
     
} # End of loop counter

print "</ul></body></html>\n";
