#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my  %lex = ('birthdate' => 'birthdate',
	    'Student Phone List' => 'Student Phone List',
	    'Main' => 'Main',
	    'Emergency' => 'Emergency',
	    'Parent 1' => 'Parent 1',
	    'Parent 2' => 'Parent 2',
	    'Student' => 'Student',
	    'Emergency' => 'Emergency',
	    'Hr' => 'Hr',
	    'Gr' => 'Gr',
	    'Work' => 'Work',
	    'Home' => 'Home',
	    'Cell' => 'Cell',
	    'Error' => 'Error',

	    );

use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Date Setting here...
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
$month++; $wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


my $select;
if ( $arr{homeroom} ) {
    $arr{homeroom} = $dbh->quote( $arr{homeroom} );
    $select = "where homeroom = $arr{homeroom} ";
}

my $sortorder = "lastname";
if ( $arr{sortorder} eq $lex{birthdate} ) {
    $sortorder = "birthdate";
} 

my $fieldlist = "lastname, firstname, initial, homeroom, grade, relation1, name1,".
    "hphone1, wphone1, cell1, relation2, name2, hphone2, wphone2, cell2,".
    "emrelation, emname, emhphone, emwphone, emcell";

$sth = $dbh->prepare("select $fieldlist from student $select order by $sortorder");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr;}
$rows = $sth->rows;

print "$doctype\n<html><head><title>". $lex{'Student Phone List'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

print "<center><h1>". $lex{'Student Phone List'}. "</h1><div>$currdate</div>\n";
print "<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Student}. "</th><th>". $lex{'Parent 1'};
print "</th><th>". $lex{'Parent 2'}. "</th><th>". $lex{Emergency}. "</th></tr>\n";

for (my $i=1; $i <= $rows; ++$i) {

    my ($lastname, $firstname, $initial, $homeroom, $grade,
	$relation1, $name1, $hphone1, $wphone1, $cell1, $relation2,
	$name2, $hphone2, $wphone2, $cell2, $emrelation, $emname,
	$emhphone, $emwphone, $emcell ) = $sth->fetchrow;

    print "<tr><td valign=\"top\"><b>$lastname</b>, $firstname $initial<br>\n";
    print "<b>". $lex{Hr}. "</b> $homeroom <b>". $lex{Gr}. "</b> $grade</td>\n";

    # Parent 1
    print "<td valign=\"top\">";
    if ( $relation1 or $name1 ) {
	print "<b>$relation1</b><br>$name1\n";
    }

    if ( $hphone1 ) {
	print "<br>". $lex{Home}. " $hphone1";
    }
    if ( $wphone1 ) {
	print "<br>". $lex{Work}. " $wphone1";
    }
    if ( $cell1 ) {
        print "<br>". $lex{Cell}. " $cell1";
    }
    print "</td>\n";

    # Parent 2
    print "<td valign=\"top\">";
    if ($relation2 or $name2) {
	print "<b>$relation2</b><br>$name2\n";
    }
    if ( $hphone2 ) {
	print "<br>". $lex{Home}. " $hphone2";
    }
    if ( $wphone2 ) {
	print "<br>". $lex{Work}. " $wphone2";
    }
    if ( $cell2 ) {
	print "<br>". $lex{Cell}. " $cell2";
    }
    print "</td>\n";

    # Emergency
    print "<td valign=\"top\">";
    if ( $emrelation or $emname ) {
	print "<b>$emrelation</b><br>$emname\n";
    }
    if ( $emhphone ) {
	print "<br>". $lex{Home}. " $emhphone";
    }
    if ( $emwphone ) {
	print "<br>". $lex{Work}. " $emwphone";
    }
    if ( $emcell ) {
	print "<br>". $lex{Cell}. " $emcell";
    }
    print "</td></tr>\n";
  
}

print "</table></center></body></html>\n";
