#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my $self = 'rptshorrost.pl';

my %lex = ('Short Student Roster' => 'Short Student Roster',
	   'Main' => 'Main',
	   'Name' => 'Name',
	   'Address' => 'Address',
	   'Phone' => 'Phone',
	   'Parent 1' => 'Parent 1',
	   'Parent 2' => 'Parent 2',
	   'Emergency' => 'Emergency',
	   'Sn' => 'Sn',
	   'Dob' => 'Dob',
	   'Rm' => 'Rm',
	   'Gr' => 'Gr',
	   'Sort by' => 'Sort by',
	   'Lastname' => 'Lastname',
	   'Grade' => 'Grade',
	   'Homeroom' => 'Homeroom',
	   'Error' => 'Error',
	   'Please select' => 'Please select',

	   );


use DBI;
use CGI;
use Cwd;


# Read config variables
eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my ($sec, $min, $hour, $mday, $mon, $year, $wday, 
    $yday, $isdst) = localtime(time);
$year = $year + 1900;
$month++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $select;
if ($arr{homeroom}) {
    my $homeroom = $dbh->quote( $arr{homeroom} );
    $select = "where homeroom = $homeroom ";
}

my $sortorder = "lastname, firstname";
if ( $arr{sortorder} eq $lex{Homeroom} ) {
    $sortorder = "homeroom, lastname, firstname";
} elsif ( $arr{sortorder} eq $lex{Grade} ) {
    $sortorder = "grade, lastname, firstname";
}

my $sth = $dbh->prepare("select * from student $select order by $sortorder");
$sth->execute;
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

$rows = $sth->rows;

# Get current dir so know what CSS to display;
if (getcwd() =~ /tcgi/){ # we are in tcgi
    $css = $tchcss;
    $homepage = $tchpage;
}

print "$doctype\n<html><head><title>". $lex{'Short Student Roster'}. "</title>
<link rel=\"stylesheet\" href=\"$css\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$homepage\">". $lex{Main}. "</a> ]\n";

# Selection Form.
print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
print "<input type=\"submit\" value=\"". $lex{'Sort by'}. "\">\n";
print "<select name=\"sortorder\">";
if ($arr{sortorder}) { print "<option>$arr{sortorder}</option>\n"; }
print "<option>". $lex{Lastname}. "</option>\n";
print "<option>". $lex{Grade}. "</option>\n";
print "<option>". $lex{Homeroom}. "</option>\n";
print "</select>&nbsp;". $lex{Homeroom};
print " <input type=\"text\" name=\"homeroom\" size=\"6\" value=\"$arr{homeroom}\">";
print "</form>\n";


if ( not defined $arr{homeroom} ) {
    print "<h1>". $lex{'Please select'}. "</h1>\n";
    print "</body></html>\n";
    die;
}


print "<center><h1>". $lex{'Short Student Roster'}. "</h1><h3>$currdate</h3>\n";
print "<table border=\"1\" cellpadding =\"3\" cellspacing=\"0\">\n";

print '<tr><th>'. $lex{Name}. '</th><th>'. $lex{Address}. '/'. $lex{Phone}. '</th><th>';
print $lex{'Parent 1'}. '</th><th>'. $lex{'Parent 2'}. '</th><th>';
print $lex{Emergency}. "</th></tr>\n";

for ($i=1; $i <= $rows; ++$i) {
    my @arr = $sth->fetchrow;

    print "<tr><td><b>$arr[1]</b>, $arr[2] $arr[3]<br>\n";
    print '<b>'. $lex{Sn}. ":</b>$arr[4]&nbsp;<b>". $lex{Dob}. ":</b>$arr[8]<br>\n";
    print "<b>". $lex{Rm}. ":</b> $arr[6]&nbsp;&nbsp;<b>". $lex{Gr}. ":</b> $arr[5]</td>\n";

    print "<td>$arr[34]<br>$arr[36]<br><b>Ph:</b> $arr[30]</td>\n";
    # Address1, Pcode1, hphone1
    print "<td>$arr[29]<br>$arr[31]<br>$arr[32]</td>\n";
    # Name 1, wphone1, cell1
    print "<td>$arr[40]<br>$arr[42]<br>$arr[43]</td>\n";
    # Name 2, wphone2, cell2
    print "<td>$arr[50]<br>H: $arr[51]<br>W:$arr[52] C:$arr[53]</td></tr>\n";
    # Emname, emhphone, emwphone, emcell

}

print "</table></center></body></html>\n";
