#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Delete Attendance' => 'Delete Attendance',
	   'Date' => 'Date',
	   'Reason' => 'Reason',
	   'Period' => 'Period',
	   'Student' => 'Student',
	   'Are you sure you want to delete this record' => 
	     'Are you sure you want to delete this record',
	   'Main' => 'Main',
	   'Delete the Record' => 'Delete the Record',
	   'Subject' => 'Subject',
	   'Section' => 'Section',
	   'Edit More Attendance Records' => 'Edit More Attendance Records',
	   'Please record the following error' => 'Please record the following error',
	   'Please contact' => 'Please contact',
	   'Your record is now deleted' => 'Your record is now deleted',
	   'There was an error deleting your data' => 'There was an error deleting your data',
	   'Period' => 'Period',
	   'Please Log In' => 'Please Log In',
	   'Error' => 'Error',
	   
	   );

my $self = 'tattdel.pl';


use CGI;
use CGI::Session;
use DBI;

my $q = new CGI;
my %arr = $q->Vars;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Setup Session
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

# Get Session Values (a defined userid means it was passed)
if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header( -charset, $charset );
    print "$doctype\n<html><head><title>". $lex{'Delete Attendance'}. "</title>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
    print "$chartype\n</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

    print "<h1>". $lex{'Please Log In'}. "</h1>\n";
    print "</body></html>\n";
    die;
}
# Ok, we have a login. Values below we have in environment.

my $userid = $session->param('userid');
my $duration = $session->param('duration');
$session->expire('logged_in',$duration); # duration is already in +20m format;

print $session->header( -charset, $charset );


print "$doctype\n<html><head><title>". $lex{'Delete Attendance'}. "</title>\n";
print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
print "$chartype\n</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

if ( $arr{deleteflag} ) {
    delete $arr{deleteflag};
    deleteRecord();
    die;
}


$sth = $dbh->prepare("select * from attend where attid = ?"); 
$sth->execute($arr{id});
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my @arr = $sth->fetchrow;

$sth1 = $dbh->prepare("select firstname, lastname from studentall where studnum = ?"); 
$sth1->execute( $arr[1] );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ($firstname, $lastname) = $sth1->fetchrow;

my $description;
if ( $arr[5] ) { # find a description
    $sth2 = $dbh->prepare("select description from subject where subjsec = ?"); 
    $sth2->execute( $arr[5] );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    $description = $sth2->fetchrow;
}


print "<center><h1>". $lex{'Delete Attendance'}. "</h1>\n";

print "<table><tr><td align=\"right\">". $lex{Student}. ":</td>\n";
print "<td align=\"left\"> <b>$firstname $lastname</b> ($arr[1])</td></tr>\n";

print "<tr><td align=\"right\">". $lex{Date}. ":</td><td> $arr[2]</td></tr>\n";

print "<tr><td align=\"right\">". $lex{Reason}. ":</td><td> $arr[3]</td></tr>\n";

print "<tr><td align=\"right\">". $lex{Period}. ":</td><td> $arr[4]</td></tr>\n";

if ( $arr[5] ) { # if we have a subject, show it...
    print "<tr><td align=\"right\">". $lex{Subject}. q{-}. $lex{Section};
    print ":</td><td>$description ($arr[5])</td></tr>\n";
}

print "</table>\n";

print "<p><em>". $lex{'Are you sure you want to delete this record'}. "</em></p>\n";

print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"id\" value=\"$arr{id}\">
<input type=\"hidden\" name=\"deleteflag\" value=\"1\">
<input type=\"submit\" value=\"". $lex{'Delete the Record'}. "\"></center>
</form></body></html>\n";



#---------------
sub deleteRecord {
#---------------

    foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }
    
    # Get student number, date, and period
    $sth = $dbh->prepare("select studentid, absdate, period from attend 
      where attid = ?");
    $sth->execute( $arr{id} );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ($studnum, $date, $period) = $sth->fetchrow;

    # Get Name
    $sth = $dbh->prepare("select firstname, lastname from studentall
      where studnum = ?");
    $sth->execute( $studnum );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my ($firstname, $lastname) = $sth->fetchrow;

    #print "Name: $firstname $lastname<br>\n";


    $sth = $dbh->prepare("delete from attend where attid = ?");
    $sth->execute( $arr{id} );

    if ( not $DBI::errstr ) {
	print "<h3>". $lex{'Your record is now deleted'}. "</h3>\n";
    } else {
	print "<h3>". $lex{'There was an error deleting your data'}. ". \n";
	print $lex{'Please contact'};
	print " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Please record the following error'}. " $DBI::errstr</h3>\n";
    }

    print "<h3>$firstname $lastname ($date) ". $les{Period}. ": $period</h3>\n";

    print "[ <a href=\"tattdeled.pl\">". $lex{'Edit More Attendance Records'}. "</a> |\n";
    print " <a href=\"$tchpage\">". $lex{Main}. "</a> ]</p></body></html>\n";


}
