#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Edit Attendance' => 'Edit Attendance',
	   'Main' => 'Main',
	   'Student Number' => 'Student Number',
	   'Date' => 'Date',
	   'Absent' => 'Absent',
	   'Reason' => 'Reason',
	   'Period' => 'Period',
	   'Subject' => 'Subject',
	   'Section' => 'Section',
	   'Late' => 'Late',
	   'min' => 'min',
	   'Update Record' => 'Update Record',
	   'Your update is now stored' => 'Your update is now stored',
	   'Please record the following error' => 'Please record the following error',
	   'Edit Homeroom Attendance Records' => 'Edit Homeroom Attendance Records',
	   'Edit Subject Attendance Records' => 'Edit Subject Attendance Records',
	   'Please Log In' => 'Please Log In',
	   'Error' => 'Error',
	   'Contact' => 'Contact',
	   'There was an error storing your data' => 'There was an error storing your data',

	   );

$self = 'tatted.pl';

use DBI;
use CGI;
use CGI::Session;

my $q = new CGI;
my %arr = $q->Vars;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Setup Session
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

# Get Session Values (a defined userid means it was passed)
if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header( -charset, $charset );
    print "$doctype\n<html><head><title>". $lex{'Edit Attendance'}. "</title>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
    print "$chartype\n</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

    print "<h1>". $lex{'Please Log In'}. "</h1>\n";
    print "</body></html>\n";
    die;
}
# Ok, we have a login. Values below we have in environment.

my $userid = $session->param('userid');
my $duration = $session->param('duration');
if (not ($duration =~ m/\+/)) {
    $duration = '+'. $duration. 'm';
}
$session->expire('logged_in',$duration);
print $session->header( -charset, $charset );


print "$doctype\n<html><head><title>". $lex{'Edit Attendance'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";


if ( $arr{writeflag} ) {
    delete $arr{writeflag};
    updateRecord();
}


$sth = $dbh->prepare("select * from attend where attid = ?"); 
$sth->execute( $arr{id} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
@arr = $sth->fetchrow;

my $sth1 = $dbh->prepare("select lastname, firstname from studentall where studnum = ?");
$sth1->execute( $arr[1] );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my ($lastname, $firstname) = $sth1->fetchrow;


print "<center><h1>". $lex{'Edit Attendance'}. "</h1>\n";

print "<form action=\"$self\" method=\"post\">
<input type=\"hidden\" name=\"id\" value=\"$arr[0]\"> 
<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";


print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">
<caption><b>$firstname $lastname</b></caption>\n";
print "<tr><td colspan=\"2\" align=\"center\">
<input type=\"submit\" value=\"". $lex{'Update Record'}. "\"></td></tr>\n";


print "<tr><td align=\"right\">". $lex{'Student Number'}. "</td>\n";
print "<td><input type=\"text\" name=\"studentid\" size=\"8\" value=\"$arr[1]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Date}. q{ }. $lex{Absent}. "</td>\n";
print "<td><input type=\"text\" name=\"absdate\" size=\"12\" value=\"$arr[2]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Reason}. "</td>\n";
print "<td><select name=\"reason\"><option>$arr[3]</option>\n";

foreach my $reason (@attend){
  print "<option>$reason</option>\n";
}

print "</select></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Period}. "</td>\n";
print "<td><input type=\"text\" name=\"period\" size=\"4\" value=\"$arr[4]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Subject}. q{-}. $lex{Section}. "</td>\n";
print "<td><input type=\"text\" Name=\"subjsec\" size=\"8\" value=\"$arr[5]\"></td></tr>\n";

print "<tr><td align=\"right\">". $lex{Late} .' ('. $lex{min}. ")</td>\n";
print "<td><input type=\"text\" name=\"late\" size=\"6\" value=\"$arr[6]\"></td></tr>\n";

print "<tr><td colspan=\"2\" align=\"center\">
<input type=\"submit\" value=\"". $lex{'Update Record'}. "\"></td></tr>\n";

print "</table></form></center></body></html>\n";



#---------------
sub updateRecord {
#---------------

    #foreach my $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

    if ( $arr{subjsec} ne 'NULL' ) {
	$arr{subjsec} = $dbh->quote($arr{subjsec});
    }
    if ( $arr{late} != 0 ) {
	$arr{late} = $dbh->quote($arr{late});
    }


    $sth = $dbh->prepare("update attend set studentid=?,
     absdate=?, reason=?, period=?, subjsec=$arr{subjsec}, late=$arr{late} 
    where attid = ?");
    $sth->execute( $arr{studentid}, $arr{absdate}, $arr{reason}, $arr{period},$arr{id});
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

    if (not $DBI::errstr ) {
	print "<h3>". $lex{'Your update is now stored'}. ".</h3></p>";
    } else {
	print "<h3>". $lex{'There was an error storing your data'}. ". \n";
	print $lex{'Contact'};
	print " $adminname <a href=\"mailto:$adminemail\">$adminemail</a>\n";
	print $lex{'Please record the following error'}. " $DBI::errstr</h3>\n";
    }

    print "<p>[ <a href=\"tattdeled.pl\">". $lex{'Edit Homeroom Attendance Records'}. "</a> |\n";
    print "<a href=\"tattsubjed.pl\">". $lex{'Edit Subject Attendance Records'}. "</a> ]\n";
    print "</p></body></html>\n";

    exit;

} # End of updateRecord
