#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson
#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2 of 
#  the License, only.

# Turn off subject smarts on line 484. These are for subject based
# entry and will use the timetable values if present.

my %lex = ('Global term start/end not defined in master configuration file' =>
	     'Global term start/end not defined in master configuration file',
	   'No Term Found' => 'No Term Found',
	   'Current Date' => 'Current Date',
	   'Verify that term dates are correctly set in the global configuration file' =>
	     'Verify that term dates are correctly set in the global configuration file',
	   'Periods per Day not set in configuration file' => 
	     'Periods per Day not set in configuration file',
	   'Student Attendance' => 'Student Attendance',
	   'Main' => 'Main',
	   'Enter Checks and Reasons for Students Missing ONLY' =>
	     'Enter Checks and Reasons for Students Missing ONLY',
	   'Date' => 'Date',
	   'Next Week' => 'Next Week',
	   'Previous Week' => 'Previous Week',
	   'Teacher Att Entries' => 'Teacher Att Entries',
	   'UserId' => 'UserId',
	   'Continue' => 'Continue',
	   'Cookie Duration' => 'Cookie Duration',
	   'Password' => 'Password',
	   'Please Log In' => 'Please Log In',
	   'Clear Prev Attendance' => 'Clear Prev Attendance',
	   'Submit Attendance' => 'Submit Attendance',
	   'Student Not Found' => 'Student Not Found',
	   'Student Alias' => 'Student Alias',
	   'Entry' => 'Entry',
	   'Period' => 'Period',
	   'Enter 4 digits (3 digit alias + 1 digit period)' => 
	     'Enter 4 digits (3 digit alias + 1 digit period)',
	   'using numeric keypad and tab key only' => 'using numeric keypad and tab key only',
	   'Subject' => 'Subject',
	   'Enter 6 digits (3 digit alias + 2 digit subject + period)' =>
	     'Enter 6 digits (3 digit alias + 2 digit subject + period)',
	   'Student' => 'Student',
	   'AM' => 'AM',
	   'PM' => 'PM',
	   'Reason' => 'Reason',
	   'Sel' => 'Sel',
	   'Previous Attendance Entries' => 'Previous Attendance Entries',
	   'Edit Attendance' => 'Edit Attendance',
	   'Date/Per' => 'Date/Per',
	   'Name' => 'Name',
	   'Student Attendance' => 'Student Attendance',
	   'Term' => 'Term',
	   'Teacher' => 'Teacher',
	   'Room' => 'Room',
	   'Day In Cycle' => 'Day In Cycle',
	   'Period(s)' => 'Period(s)',
	   'No Scheduled Periods exist today' => 'No Scheduled Periods exist today',
	   'Mode' => 'Mode',
	   'All Subjects Shown' => 'All Subjects Shown',
	   'Only Scheduled Subjects Shown' => 'Only Scheduled Subjects Shown',
	   'Method' => 'Method',
	   'Name' => 'Name',
	   'Error' => 'Error',
	   'No Password' => 'No Password',
	   'No User Id' => 'No User Id',

	   );

my $self = 'tattentry0.pl';
my $weekcount = 1; # Number of weeks to do for entry. (normally 1 or 2)


use DBI;
use CGI;
use CGI::Session;
use Time::JulianDay;
use Date::Business;

# These 4 variables are now moved into admin.conf (2.40+)
# my $maxterms = 12; # maximum # of terms to search for.
if ( not $g_maxterms ) { $g_maxterms = 12 };

# my $attendview = 16; # Number of previous attendance records to see;
if (not defined $g_attendview ) { $g_attendview = 16; }

# my $teachview = 12; # Number of teacher attendance records to see.
if (not defined $g_teachview ) { $g_teachview = 12; }

# my $allowedit = 1;  # Comment out to disable teacher editing of att records.
if ( not defined $g_allowedit ) { $g_allowedit = 1; }

my $q = new CGI;
my %arr = $q->Vars;

my $method;   # attendance entry 'method'
($dud,$method) = split /\(/, $arr{method};
chop $method; # remove trailing parens

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@<br>\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


# Get Session
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

# Get/Set  Session Values (a defined userid means it was passed)
if ( $arr{userid} ){ # we want to login, passed userid/password pair.

    # Check password/userid against database (-1 no user, -2 wrong password);
    my $error = checkPassword($arr{userid}, $arr{password});
    if ($error == -1){ print $q->header( -charset, $charset ); login($lex{'No User Id'}); }
    if ($error == -2){ print $q->header( -charset, $charset ); login($lex{'No Password'}); }

    $cookietime = checkCookieTime( $arr{duration} );

    # Set values for userid and logged_in in session
    $session->param( 'logged_in','1');
    $session->expire( 'logged_in', $cookietime );
    $session->param( 'userid',$arr{userid} );
    $session->param( 'duration',$cookietime );

    $userid = $arr{userid};


} else { # check logged_in value in session

    if ( not $session->param('logged_in') ){
	$userid = $session->param('userid');
        print $q->header( -charset, $charset );
        login( $lex{'Please Log In'}, $userid ); 
        die;
    }
    # Ok, we have a login. Values below we have in environment.

    $userid = $session->param('userid');
    $duration = $session->param('duration');

    if ( not ($duration =~ /\+/)) { # if not in +20m format, do so.
	$duration = checkCookieTime( $duration );
    }

    $session->expire('logged_in', $duration );


} # End of check for logged_in value

print $session->header( -charset, $charset );


# Print HTML Page Header....
print "$doctype\n<html><head><title>". $lex{'Student Attendance'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>\n";

# foreach my $key (keys %arr ) { print "K: $key V: $arr{$key}<br>\n"; }

print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";
print "<b>". $lex{Method}. "</b> $method\n";

# Date Functions - current date, date data structures.
# First days of year, teacher days, mess this up.
# so set first day of first term to schoolstart. 
$schoolstart = $g_termstart{1}; 
my ($styear,$stmonth,$stday) = split /-/,$schoolstart;
my ($endyear,$endmonth,$endday) = split /-/,$schoolend;
my $startjd = julian_day($styear,$stmonth,$stday);
my $endjd = julian_day($endyear,$endmonth,$endday);


my ($currdate,$currsdate);
if ( $arr{date} ) {

    # Generate a list from those dates. Assume year-mon-day
    ($year,$month,$day) = split /-/,$arr{date};

    $jd = julian_day($year,$month,$day);
    $dow = day_of_week($jd);
    $mondayjd = $jd - ($dow-1);

    # Check for date before start of year; reset to year start.
    #if ($mondayjd < $startjd ){ $mondayjd = $startjd;}

    if (length($month) == 1){ $month = "0".$month;}
    if (length($day) == 1){ $day = "0".$day;}
    $currsdate = "$year$month$day"; 
    $currdate = "$year-$month-$day";

} else {

    @tim = localtime(time);
    $year = $tim[5] + 1900;
    $month = $tim[4] + 1;
    $day = $tim[3];

    $jd = julian_day($year,$month,$day);
    $mondayjd = $jd - ($tim[6]-1); #This will now give Monday of that week.
    if (length($month) == 1){ $month = "0".$month;}
    if (length($day) == 1){ $day = "0".$day;}
    $currdate = "$year-$month-$day";
    $currsdate = "$year$month$day";

} 

if ( not %g_termstart ) {
    print $lex{'Global term start/end not defined in master configuration file'};
    print " (admin.conf)!\n";
    print "</body><html>\n";
    die $lex{'Global term start/end not defined in master configuration file'};
}


# Figure out the current term
my ( $term,$termoffset );
my $dateobj = new Date::Business(DATE=>$currsdate);

#foreach my $t ( keys %g_termstart ) {  print "K:$t V:$g_termstart{$t}<br>\n"; }

for my $trm ( sort keys %g_termstart ) {

    if ( $trm =~ m/\D/ ) { next;}  # skip if not a digit... (when multiTrack)

    # Get term offset from today.
    my $startdate = $g_termstart{$trm}; 
    $startdate =~ s/-//g;
    my $startobj = new Date::Business(DATE => $startdate);
    $termoffset = $dateobj->diffb($startobj,'prev','next');
    #print "<br>Trm: $trm Date: $startdate Offset: $termoffset<br>\n";

    if ( $termoffset < 0 ){

	# Offset will be 0 or > 0 when we just pass into next term.
	# Negative values will be days ahead... the "first" negative
	# will be the next term (and thus we haven't got there
	# yet. Subtract 1 from current term and we are in the term of
	# interest. It will be term 0 before the first term...

	$term = $trm - 1; last;
    } else {
	$term = $trm;
    }
}


if ( not $term ) { # No term found!
    print "<html><body><h1>". $lex{'No Term Found'}. ".</h1>\n<p>";
    print $lex{'Verify that term dates are correctly set in the global configuration file'}. ".\n";
    print $lex{'Current Date'}. ": $currdate</p>\n";
    print "</body></html>\n";
    die;
}

# Set Maximum periods per day; (Used by Subject entry and MultiDay)
my $maxppd = 0;  # Maximum periods per day
if (not %g_ppd){ 
    print $q->header( -charset, $charset );
    print $lex{'Periods per Day not set in configuration file'}. "!<br>\n";
    die;
}

foreach my $key (keys %g_ppd){  # Get the Largest PPD.
    if ($g_ppd{$key} > $maxppd){ $maxppd = $g_ppd{$key};}
} 

# Setup Array and Hash to hold Dates and DOW Dates (Multi-Day Method)
mkDateData($mondayjd,$weekcount);


# Push Rooms into array
my $sth = $dbh->prepare("select distinct homeroom from staff
  where userid = ? and homeroom != '' and homeroom is not null"); 
$sth->execute($userid);
if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
while ( my $homeroom = $sth->fetchrow ) {
    push @hroom, $homeroom;
}


# Rest of Top of Page...
#print $currdate;
print "<h1 style=\"display:inline;padding:0.5em 0 0.5em 3em;\">\n";
print $lex{'Student Attendance'}. q{ };
print $lex{Entry}. " &ndash; <i>". $lex{Term}. " $term</i></h1>\n";

print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\" width=\"100%\"><tr>\n";
print "<td width=\"30%\" valign=\"top\">\n<!--   ********** Column #1 *********  -->\n";

my $sth3 = $dbh->prepare("select * from tattend 
  where techid = ? order by date desc");
$sth3->execute($userid);
if ($DBI::errstr){ print $DBI::errstr; die;}
$trows = $sth3->rows;

# Limit View to the $g_teachview value (set in admin.conf)
if ( $trows > $g_teachview ){ $trows = $g_teachview; }

print "<h2>". $lex{'Teacher Att Entries'}. "</h2>\n";
print "<table cellpadding=\"2\" cellspacing=\"0\" border=\"0\">\n";
print "<tr><th>". $lex{UserId}. "</th><th>". $lex{Date}. "</th></tr>\n";

for (1..$trows){
    @tattend = $sth3->fetchrow;
    print "<tr><td>$tattend[1]</td><td>$tattend[2]</td></tr>\n";
}

print "</table>\n";

if ( $method ne 'subject' ){ # Not High School Entries

    print "<h2>". $lex{'Previous Attendance Entries'}. "</h2>\n";

    foreach my $hroom ( @hroom ) {
	if ( $g_allowedit ){
	    print "<form action=\"tattdeled.pl\" method=\"post\">\n";
	    print "<input type=\"submit\" value=\"". $lex{'Edit Attendance'}. "\"></form>\n";
	}

	$sth3 = $dbh->prepare("select * from attend, student 
         where attend.studentid = student.studnum and student.homeroom = ? 
         order by attend.absdate desc, student.lastname, 
         student.firstname, attend.period");

	$sth3->execute($hroom);
	if ($DBI::errstr) { print $DBI::errstr; die;}
	$rows = $sth3->rows;

	# Only print the value of $g_attendview attendance records
	if ($rows > $g_attendview) {
	    $rows = $g_attendview;
	}

	print "<table><tr><th>". $lex{Name}. "</th><th>". $lex{'Date/Per'}. "</th></tr>\n";

	for ($i=1; $i <= $rows; ++$i) {
	    @arr = $sth3->fetchrow;
	    if ( $g_allowedit ) {
		print "<tr><td><a href=\"tatted.pl?id=$arr[0]\">\n";
		print "<b>$arr[8]</b>, $arr[9]</a></td>\n";
	    } else { # not allowed to edit
		print "<tr><td><b>$arr[8]</b>, $arr[9]</td>\n";
	    }
	    print "<td>$arr[2]/$arr[4]</td></tr>\n";
	}
	print "</table>\n";
    }

} # End of Not Subject Method


print "</td><td width=\"70%\" valign=\"top\">
<!--   ********** Column #2 *********  -->
<center>\n";

print "<table border=\"1\" cellpadding=\"6\" cellspacing=\"0\"><tr><td>\n";
print "<div style=\"text-align:center;font-size:140;\">\n";
print $lex{'Enter Checks and Reasons for Students Missing ONLY'}. "</div>\n";
print "</td></tr></table>\n\n";

# ==============
$prevjd = $mondayjd - 7;

if ($prevjd < $startjd){ $prevjd = $startjd;}

($prevyear, $prevmonth, $prevday) = inverse_julian_day($prevjd);
$prevdate = "$prevyear-$prevmonth-$prevday";

# print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" ";
# print "style=\"padding:0;margin:0;\"><tr><td>

print"<form action=\"$self\" method=\"post\" style=\"display:inline;\">
  <input type=\"hidden\" name=\"date\" value=\"$prevdate\">
  <input type=\"hidden\" name=\"method\" value=\"($method)\">
  <input type=\"submit\" value=\"<= ". $lex{'Previous Week'}. "\"></form>\n";

$nextjd = $mondayjd + 7; 
if ($nextjd > $endjd){ $nextjd = $endjd;}
($nextyear, $nextmonth, $nextday) = inverse_julian_day($nextjd);
$nextdate = "$nextyear-$nextmonth-$nextday";

print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">
  <input type=\"hidden\" name=\"method\" value=\"($method)\">
  <input type=\"hidden\" name=\"date\" value=\"$nextdate\">
  <input type=\"submit\" value=\"". $lex{'Next Week'}. " =>\"></form>\n<br>\n";

$sth = $dbh->prepare("select dayincycle from dates where date = ?");

# Main Attendance Entry begins here.
if ($method ne 'multiday'){ 
    # multiday calls a different script to allow for reason entry
    # before going to confirmation in tattentry1 script.


    if ( $method ne 'subject' ) {
	print "<form action=\"tattentry1.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"name\" value=\"$userid\">\n";
	print "<input type=\"hidden\" name=\"method\" value=\"$method\">\n";

	print "<b>". $lex{Date}. "</b>: <select name=\"date\">\n";
	for ($i=1;$i<=5;$i++) {
	    ($wkyear, $wkmonth, $wkday) = inverse_julian_day($mondayjd);
	    $dow = day_of_week($mondayjd) + 1;
	    print "<option";
	    if ($wkmonth == $month and $wkday == $day) {
		print " selected";
	    }
	    print ">$dow[$dow], $wkyear-$wkmonth-$wkday</option>\n";
	    $mondayjd++;
	}
	print "</select><p></p>\n\n\n";

    } else { # subject method

	for ( my $i=1; $i<=5; $i++ ) {
	    ($wkyear, $wkmonth, $wkday) = inverse_julian_day($mondayjd);
	    $dow = day_of_week($mondayjd) + 1;
	    my $tmpdate = "$wkyear-$wkmonth-$wkday";

	    # NEW Check for date actually being a day in cycle.
	    $sth->execute( $tmpdate );
	    my $dayType = $sth->fetchrow;
	    if ( $dayType eq 'N' ) { # skip this day...
		$mondayjd++;
		next;
	    }

	    print "<form action=\"$self\" method=\"post\" style=\"display:inline;\">\n";
	    print "<input type=\"hidden\" name=\"date\" value=\"$tmpdate\">\n";
	    print "<input type=\"hidden\" name=\"method\" value=\"($method)\">\n";
	    print "<input type=\"submit\" value=\"$dow[$dow] $month[$wkmonth] $wkday\"></form>\n";

	    $mondayjd++;
	}

	print "<form action=\"tattentry1.pl\" method=\"post\">\n";
	print "<input type=\"hidden\" name=\"name\" value=\"$userid\">\n";
	print "<input type=\"hidden\" name=\"method\" value=\"$method\">\n";
	print "<input type=\"hidden\" name=\"date\" value=\",$currdate\">\n";

	print "<div style=\"padding:0.5em;border:1px solid gray;\"><b>";
	print $lex{Date}. "</b>: $currdate \n";

    }

}


# Entry Methods Start Here.

# =============
if ($method eq 'subject'){

    require "../lib/libschedule.pl" or die "Cannot open libschedule.pl!\n";

    # need $additionalcomments subject name to skip...
    require "../etc/repcard.conf" or die "Cannot open repcard.conf!\n";

    # Get subjects taught this term by this teacher; create %subjects
    my %subjects;

    my $sth= $dbh->prepare("select subjsec, smdesc, description from subject
     where subject.teacher $sql{like} '%($userid)' and 
     $term >= subject.startrptperiod and $term <= subject.endrptperiod");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

    my $sth1 = $dbh->prepare("select count(*) from eval where subjcode = ?");

    while ( my ( $subjsec, $smdesc, $description ) = $sth->fetchrow ) {
	if ( $description eq $additionalcomments ) { next; } # skip additional comment subjects
	$sth1->execute( $subjsec );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my $count = $sth1->fetchrow;
	if ($count < 1) { next; } # skip if no enrolled students.

	if (not  $smdesc ) { # use description if not small description.
	    $description =~ s/\s+//g; # strip spaces.
	    $smdesc = substr($description,0, 7); 
	} 
	$subjects{$subjsec} = $smdesc;
    }

    #foreach my $subjsec ( keys %subjects ) { print "$subjsec - $subjects{$subjsec}<br>\n"; }
    # We now have all subjects (with students), taught in current term.

    # Get the current DayInCycle
    my $dayInCycle = findDayInCycle( $currdate, $dbh );

    # Check for any scheduling entries for this teacher...
    my $scheduleEntriesExist;
    my $sth= $dbh->prepare("select count(*) from schedat
     left outer join subject on schedat.subjsec = subject.subjsec
     where subject.teacher $sql{like} '%($userid)' and 
     $term >= subject.startrptperiod and $term <= subject.endrptperiod
      order by period");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $scheduleEntriesExist = $sth->fetchrow;


    my %periods; # holds period and matching subjsec.
    # If they do... then check for some today...
    if ( $scheduleEntriesExist > 0 ) { 

	$scheduleEntriesExist = 1;

	# Get periods taught today.
	my $sth= $dbh->prepare("select schedat.subjsec, schedat.period from subject, schedat 
         where subject.teacher $sql{like} '%($userid)' and 
         $term >= subject.startrptperiod and $term <= subject.endrptperiod and
         schedat.subjsec = subject.subjsec and schedat.day = ? and schedat.term = $term
         order by period");
	$sth->execute( $dayInCycle );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }

	while ( my ($subjsec, $period) = $sth->fetchrow) {
	    #print "S:$subjsec P:$period<br>\n";
	    if ( exists $subjects{$subjsec} ) { # we have a subject with kids...
		$periods{"$period:$subjsec"} = $subjects{$subjsec}; # which is description...
	    }
	}
    }
	
    # This was a bad idea, since if partial timetable, can't put in attendance
    #if ( $scheduleEntriesExist and not %periods ) { # no classes timetabled for this teacher today
    #print "<h2>". $lex{'No Scheduled Periods exist today'}. "</h3>\n";
    #exit; }


    if ( not %periods ) { 
	$subjectMode = "<b>". $lex{'All Subjects Shown'}. "</b>";
    } else {
	$subjectMode = "<b>". $lex{'Only Scheduled Subjects Shown'}. "</b>";
    }

    if ($dayInCycle) {
	print "<b>". $lex{'Day In Cycle'}. "</b>: $dayInCycle<br>";
    }
    print "<b>". $lex{Mode}. "</b>: $subjectMode<br></div>\n";


    my $periodsDefined;
    if (not %periods) { # no timetable values found, fall back to load them all
	my $counter = 1;
	foreach my $subjsec (keys %subjects)  {
	    my $key = "$counter:$subjsec";
	    #print "Subject: $subjsec P:$counter<br>\n";
	    $periods{$key} = $subjects{$subjsec};
	    $counter++;
	}
    } else { # show classes from periods hash
	$periodsDefined = 1;
    }


    #foreach my $key (sort keys %periods) { print "P:$key Sub: $periods{$key}<br>\n"; }

    # print hyperlink row
    my $first = 1;
    print "[ ";
    foreach my $key (sort keys %periods) {
	my ($period, $subjsec) = split /:/, $key;
	if (not $first ) { print " |\n"; } else { $first = 0; }
	print "<a href=\"#$key\">$period-$periods{$key}</a> ";
    }
    print "]\n";
    
    my $sth2 = $dbh->prepare("select description from subject where subjsec = ?");

    foreach my $key (sort keys %periods) {
	my ($period, $subjsec) = split /:/, $key;

	# Get the description for the subject
	$sth2->execute($subjsec);
	if ($DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
	my $description = $sth2->fetchrow;

	# Get the Kids first... studnums.
	$sth = $dbh->prepare("select distinct eval.studnum from eval,student 
          where  subjcode = ? and eval.studnum = student.studnum
          order by student.lastname,student.firstname");
	$sth->execute($subjsec);
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	my $rows = $sth->rows;
	if ($rows < 1){ next;}  # No students registered.

	print "<a name=\"$key\"></a>\n";
	print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";
	print "<tr><th colspan=\"3\"><font size=+1>$description</font> ($subjsec)</th></tr>\n";
	print "<tr><th>". $lex{Student}. "</th><th colspan=\"2\">". $lex{'Period(s)'};
	print " &ndash; ". $lex{Reason}. "</th></tr>\n";
	print "<tr><td colspan=\"4\" align=\"center\">\n";
	print "<input type=\"reset\" value=\"". $lex{'Clear Prev Attendance'}. "\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";


	my $sth1 = $dbh->prepare("select lastname,firstname from student where studnum = ?");


	# Loop Through Students
	for (1..$rows) {
	    my $studnum = $sth->fetchrow;

	    $sth1->execute($studnum);
	    if ($DBI::errstr) { print $DBI::errstr; die; }
	    my ($lastname,$firstname) = $sth1->fetchrow;
	    if ( not $lastname ){  # student name not found.
		$lastname = "<span style=\"color:red;\">". $lex{'Student Not Found'}. "</span>";
	    }

	    print "<tr><td><b><a href=\"tattsubjed0.pl?studnum=$studnum&subjsec=$subjsec\" title=\"$studnum\">\n";
	    print "$lastname</b>, $firstname</a></td><td>\n";

	    if ( $periodsDefined ) {
		print"P$period<input type=\"checkbox\" name=\"$studnum:$subjsec:$period\" value=\"1\">\n";
	    } else {
		for (1..$maxppd){ 
		    print"P$_<input type=\"checkbox\" name=\"$studnum:$subjsec:$_\" value=\"1\">\n";
		}
	    }
	    
	    if ( $periodsDefined ) {
		print "</td><td><select name=\"$studnum:$subjsec:$period:Reason\">";
		print "<option></option>\n";
	    } else {
		print "</td><td><select name=\"$studnum:$subjsec:Reason\">";
		print "<option></option>\n";
	    }
    	    foreach $reason (@attend){
		print "<option>$reason</option>\n";
	    }
	    print "</select></td></tr>\n";

	}

	print "<tr><td colspan=\"4\" align=\"center\">\n";
	print "<input type=\"reset\" value=\"". $lex{'Clear Prev Attendance'}. "\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";
	print "</table><p></p>\n";


    } # Outer Loop here for each subject.

} # End of SUBJECT Method


elsif ($method eq 'sa4') {  # Student Alias, 4 digits

    print "<h2>". $lex{'Student Alias'}. " + ". $lex{Period}. q{ }. $lex{Entry}. "</h2>\n";
    print $lex{'Enter 4 digits (3 digit alias + 1 digit period)'}. "<br>\n";
    print $lex{'using numeric keypad and tab key only'}. ".<br>\n";

    print "<table border=\"1\: cellspacing=\"0\" cellpadding=\"3\">\n<tr>";
    for ($i=1;$i<=20;$i++) { # Setup 20 Input Entries
	print "<td><input type=\"text\" name=\"studa$i\" size=\"6\"></td>\n";
	if (not ($i % 5)){ print "</tr><tr>\n";}
    }
    print "</tr></table><input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\">\n";

} # End of SA4 Method


elsif ($method eq 'sa6') {  # Student Alias, Subject, Period - 6 digits

    print "<h2>". $lex{'Student Alias'}. " + ". $lex{Subject}. " + ";
    print $lex{Period}. q{ }. $lex{Entry}. "</h2>\n";
    print $lex{'Enter 6 digits (3 digit alias + 2 digit subject + period)'}. "<br>\n";
    print $lex{'using numeric keypad and tab key only'}. ".<br>\n";
    print "<table border=\"1\: cellspacing=\"0\" cellpadding=\"3\">\n<tr>";

    for ($i=1;$i<=20;$i++) { # Setup 20 Input Entries
	print "<td><input type=\"text\" name=\"studa$i\" size=\"8\"></td>\n";
	if (not ($i % 5)){ print "</tr><tr>\n";}
    }
    print "</tr></table><input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\">\n";

} # End of SA6 Method


# MULTIDAY Method
elsif ($method eq 'multiday') {  # Multi-Day Method

    print "<form action=\"tattentry0md.pl\" method=\"post\">
    <input type=\"hidden\" name=\"name\" value=\"$userid\">
    <input type=\"hidden\" name=\"method\" value=\"$method\">
    <input type=\"hidden\" name=\"passwd\" value=\"$arr{passwd}\">\n";

    # Find the kids' names and studnum
    my $sth = $dbh->prepare("select lastname, firstname, studnum from student 
      where homeroom = ? order by lastname, firstname");

    foreach my $hroom (@hroom) {
	
	$sth->execute($hroom);
	if ($DBI::errstr){ print $DBI::errstr; die "$DBI::errstr\n";}    

	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";

	# Print table headings.
	print "<tr><th>". $lex{Name}. "</th>";
	foreach my $day (@days){ print "<th>$datedata{$day}</th>";}
	print "</tr>\n";

	# Loop through kids displaying the values.
	while (my ($lastname, $firstname, $studnum) = $sth->fetchrow){
	    # print Name.
	    print "<tr><td>$lastname, $firstname</td>\n";
	    # print the days for this mode:
	    foreach my $day (@days){
		print "<td style=\"font-size: 70%;\">";
		for (1..$maxppd){
		    print "P$_<input type=\"checkbox\" ";
		    print "name=\"$studnum:$day:$_\" value=\"1\">\n";
		    if ($_ % 2 == 0){ print "<br>";}
		}
		print "</td>";
	    }
	    print "</tr>\n";
	}

	print "</table><input type=\"submit\" value=\"". $lex{Continue}. "\">\n";

    } # End of This Homeroom (in case of multiple)

} # End of Multi-Day Method


else { # If not Subject, SA4 or SA6 methods, then use SNAP.

    # Get Teacher Name
    my $sth = $dbh->prepare("select sal, lastname, firstname from staff 
      where userid = ?");
    $sth->execute($userid);
    if ($DBI::errstr) { print $DBI::errstr; die; }
    my ($tsal, $tlastname, $tfirstname) = $sth->fetchrow;
    my $teacher;
    if ($tsal) { 
	$teacher = "$tsal $tfirstname $tlastname"; 
    } else {
	$teacher = "$tfirstname $tlastname";
    }

    $sth = $dbh->prepare("select lastname, firstname, studnum from student 
      where homeroom = ? order by lastname, firstname");

    foreach my $hroom (@hroom) {
	$hroom =~ s/\s+//g;
	$sth->execute($hroom);
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	$rows = $sth->rows;

	# Now get the maxppd by using the homeroom
	my $maxppd = 0;
	my $sth1 = $dbh->prepare("select distinct grade from student where homeroom = ?");
	$sth1->execute( $hroom );
	if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
	while ( my $grade = $sth1->fetchrow ) {
	    if ( $g_ppd{$grade} > $maxppd ) { 
		$maxppd = $g_ppd{$grade}; 
	    }
	}


	print "<div style=\"padding:0.5em;\">". $lex{Teacher}. "\n";
	print " <b>$teacher</b>&nbsp;&nbsp;". $lex{Room}. " \n";
	print "<b>$hroom</b></div>\n\n";

	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";  

	print "<tr><td colspan=\"4\" align=\"center\">\n";
	print "<input type=\"reset\" value=\"". $lex{'Clear Prev Attendance'}. "\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";

	print "<tr><th>". $lex{Student}. "</th><th>";
	if ( $maxppd == 1 ) {
	    print $lex{Sel};
	} else {
	    print $lex{AM}. "</th><th>". $lex{PM};
	} 
	print "</th><th>". $lex{Reason}. "</th></tr>\n";

	while (my ($lastname, $firstname, $studnum) = $sth->fetchrow){

	    print "<tr><td><b>$lastname</b>, $firstname</td>\n";
	    print "<td><input type=\"checkbox\" name=\"$studnum:A\" value=\"1\"></td>\n";
	    if ( $maxppd != 1 ) {
		print "<td><input type=\"checkbox\" name=\"$studnum:P\" value=\"1\"></td>\n";
	    }
	    print "<td><select name=\"$studnum:Reason\"><option></option>\n";
    
	    foreach $reason (@attend){
		print "<option>$reason</option>\n";
	    }
	    print "<option></option></select></td></tr>\n";

	}

	print "<tr><td colspan=\"4\" align=\"center\">\n";
	print "<input type=\"reset\" value=\"". $lex{'Clear Prev Attendance'}. "\">\n";
	print "<input type=\"submit\" value=\"". $lex{'Submit Attendance'}. "\"></td></tr>\n";

	print "</table><p></p>\n";

    }  # Outer Loop here for each grade.

} # End of ELSE Entry Method

print "</form></center></td></tr></table></body></html>\n";



#-------------
sub mkDateData {
#-------------

    my ($jd, $weeks) = (@_);
    # Build an array of ISO dates and a hash using them
    # as keys to hash values of 'Mon Jan 6' format.
    # If one week, then just 5 values, if two wk then 10, etc.
    for (1..$weeks){
	for (1..5){
	    my ($yr,$mon,$day) = inverse_julian_day($jd);
	    my $dow = day_of_week($jd) + 1;
	    push @days, "$yr-$mon-$day";
	    $datedata{"$yr-$mon-$day"} = "$dow[$dow], $month[$mon] $day";
	    $jd++;
	}
	$jd = $jd + 2; # skip over weekend.
    }
}


#----------------
sub checkPassword {
#----------------

    my ($userid, $password) = @_;
    
    if (not $userid){ return -1;}
    if (not $password){ return -2;}

    #check for presence of userid
    my $sth = $dbh->prepare("select count(userid) from staff 
     where userid = ?");
    $sth->execute($userid);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ($count < 1){ return -1;} # no userid

    #check for presence of correct password and userid
    my $sth = $dbh->prepare("select count(userid) from staff 
     where userid = ? and passwd = ? ");
    $sth->execute($userid, $password);
    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth->fetchrow;
    if ($count < 1){ return -2;} # not correct password

    return 0; # if all ok...

}


#------------------
sub checkCookieTime {
#------------------

    # Requires defaults of: $defaulttime, $maximumtime, $minimumtime
     $defaulttime = 5;
     $maximumtime = 60;
     $minimumtime = 3;

    my $duration = shift;

    if ($duration) { 
	$cookietime = $duration;
    } else { 
	$cookietime = $defaulttime;
    }  

    $cookietime = $minimumtime if $cookietime < $minimumtime; 
    $cookietime = $maximumtime if $cookietime > $maximumtime; 
    $cookietime = "+". $cookietime."m"; # set format
    
    return $cookietime;

}


#--------
sub login { # print error, login screen and die;
#--------

    # Requires $lex: Continue, UserId, Password, Cookie Duration, Please Log In

    my $error = shift;
    my $userid = shift; # may not be present...

    if (not $error) { $error = $lex{'Please Log In'}; }
    print "$doctype\n<html><head><title>$error</title>
    <link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
    $chartype\n</head>\n";
    print "<body onload=\"document.forms[0].elements[1].focus()\">\n";
    print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

    print "<center><h1>$error</h1>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"method\" value=\"$arr{method}\">\n";
    print "<table cellpadding=\"4\" cellspacing=\"1\" border=\"0\">\n";

    print "<tr><td align=\"right\">". $lex{UserId}. "</td>\n";

    my $uservalue;
    if ( $userid ) {
	$uservalue = "value=\"$userid\"";
    }

    print "<td><input type=\"text\" name=\"userid\" size=\"8\" $uservalue></td></tr>\n";

    print "<tr><td align=\"right\">". $lex{Password}. "</td>\n";
    print "<td><input type=\"password\" name=\"password\" size=\"8\"></td></tr>\n";

    print "<tr><td align=\"right\">". $lex{'Cookie Duration'}. "</td>\n";
    print "<td><input type=\"text\" name=\"duration\" size=\"4\" value=\"20\"></td></tr>\n";

    print "<tr><td></td><td>\n";
    print "<input type=\"submit\" value=\"". $lex{'Continue'}. "\"></td></tr>\n";
    print "</table></form>\n";

    print "</center></body></html>\n";

    exit;

}
