#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Attendance Confirmation' => 'Attendance Confirmation',
	   'Main' => 'Main',
	   'Student' => 'Student',
	   'Subject' => 'Subject',
	   'Reason' => 'Reason',
	   'Period' => 'Period',
	   'No Student Found' => 'No Student Found',
	   'Save Attendance Records' => 'Save Attendance Records',
	   'No Subject' => 'No Subject',
	   'Missing Attendance Reasons' => 'Missing Attendance Reasons',
	   'Date' => 'Date',
	   'Duplicate Attendance Records' => 'Duplicate Attendance Records',
	   'Error' => 'Error',
	   
	   );

use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}

my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;

my $date;
if ( $arr{date} ){
    ( my $dud, $date ) = split /,/ ,$arr{date};
    $date =~ s/^\s*//;  # strip leading space
    delete $arr{date};
}

# Print Start of HTML Page
print "$doctype\n<html><head><title>". $lex{'Attendance Confirmation'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

print "<center><h1>". $lex{'Attendance Confirmation'}. "</h1>\n";
print "<p><b>$date</b></p>\n";

print "<form action=\"tattentry2.pl\" method=\"post\">
<input type=\"hidden\" name=\"method\" value=\"$arr{method}\">
<input type=\"hidden\" name=\"date\" value=\"$date\">\n";


# foreach $key (keys %arr) { print "K:$key V:$arr{$key}<br>\n"; }

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $noReasonFlag;
my $duplicateRecordFlag;

print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"5\">\n";
print "<tr><th>". $lex{Student}. "</th><th>". $lex{Subject}. "</th>\n";
print "<th>". $lex{Reason}. "</th><th>". $lex{Period}. "</th><th>". $lex{Date}. "</th></tr>\n";

my $sth1 = $dbh->prepare("select count(*) from attend where studentid = ? and absdate = ? and period = ?");

# === SUBJECT Method ===========
if ($arr{method} eq 'subject') {

SUBKEY:
    foreach $key (sort keys %arr) {
	if ($arr{$key} == 1) {
	    my ($studnum,$subjsec,$period) = split /:/,$key;
	    my $index = "$studnum:$subjsec:$period:Reason";
	    if (not $arr{$index}) { # try the more general approach without a period
		$index = "$studnum:$subjsec:Reason";
	    }
	    $reason = $arr{$index};
	    if (not $reason) {
		$noReasonFlag = 1;
		push @noReason, "$key:$date";  # studnum:subjsec:period:date
	    }

	    # Check for an existing attendance record.
	    $sth1->execute( $studnum, $date, $period );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; } 
	    my $count = $sth1->fetchrow;

	    #print "Count: $count  SN:$studnum D:$date  P:$period<br>\n";
	    
	    if ( $count > 0 ) { # we have an existing record...  
		$duplicateRecordFlag = 1; 
		push @duplicateRecords, "$studnum:$period:$date:$subjsec";
	    }

	    if ( $count > 0 or not $reason ) { # skip to next record
		next SUBKEY;
	    }

	    # Now find the student name, not studentall since won't show for attendance anyway
	    $sth = $dbh->prepare("select lastname,firstname from student where studnum = ?");
	    $sth->execute( $studnum );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    $rows = $sth->rows;

	    my $studname;
	    if ($rows < 1) {
		# No student found....
		$studname = "<span style=\"color:red;\">". $lex{'No Student Found'}. "</span>";
	    } else { # we have a student
		my ($lastname, $firstname) = $sth->fetchrow;
		$studname = "<b>$lastname</b>, $firstname ($studnum)";
	    }

	    # Now find the subject description
	    $sth = $dbh->prepare("select description from subject where subjsec = ? ");
	    $sth->execute( $subjsec );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    my $description = $sth->fetchrow;

	    print "<tr><td>$studname</td><td>$description<td>$reason</td><td>$period</td><td>$date</td></tr>\n";
	    print "<input type=\"hidden\" name=\"$studnum:$period:$subjsec:$reason:\" value=\"1\">\n";
	    
	} # End of If Value = 1;

    } # End of ForEach Loop (each value in %arr hash)

} # end of SUBJECT method

# Sequence for the colon separated fields above:
# Studnum:Period:Subjsec:Reason:Late:Date 


# === SNAP Method ===========
if ( $arr{method} eq 'snap' ) {

SNAPKEY:
    foreach my $key (keys %arr) {
	if ($arr{$key} == 1) {
	    my ($studnum, $period) = split /:/,$key;
	    if ($period eq "P" or $period eq "p"){ $period = 2;}
	    if ($period eq "A" or $period eq "a"){ $period = 1;}
	    my $index = $studnum.":Reason";
	    my $reason = $arr{$index};

	    if (not $reason) {
		$noReasonFlag = 1;
		push @noReason, "$studnum:\:$period:$date";  # studnum:subjsec:period:$date

	    }

	    # Check for an existing attendance record.
	    $sth1->execute( $studnum, $date, $period ); 
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; } 
	    my $count = $sth1->fetchrow; 
	    if ( $count > 0 ) { # we have an existing record...  
		$duplicateRecordFlag = 1; 
		push @duplicateRecords, "$studnum:$period:$date:$subjsec"; 
	    }

	    if ( $count > 0 or not $reason ) {
		next SNAPKEY;
	    }


	    $sth = $dbh->prepare("select * from studentall where studnum = ?");
	    $sth->execute( $studnum );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    $rows = $sth->rows;
	    if ($rows != 1) {
		# No student found....
		$studname = "<font color=red>No Student Found</font>";
	    } else { # we have a student
		@student = $sth->fetchrow;
		$studname ="$student[1], $student[2] $student[3] ($student[4])";
	    }
	    print "<tr><td>$studname</td><td></td><td>$reason</td><td>$period</td><td>$date</td></tr>\n";
	    print "<input type=\"hidden\" name=\"$student[4]:$period:\:$reason:\" value=\"1\">\n";
	    
	} # End of If Value = 1;
    } # End of ForEach Loop (each value in %arr hash)
} # end of SNAP method

# Sequence for the colon separated fields above:
# Studnum:Period:Subjsec:Reason:Late:Date


# === Multi-Day Method ===========
if ($arr{method} eq 'multiday') {

MULTIKEY:
    foreach $key (sort keys %arr) {
	my ($studnum,$date,$period) = split /:/,$key;
	if ( $date ){ # A real record... not name, method, date, etc.
	    my $reason = $arr{$key};

	    # Check for reason.
	    if (not $reason) {
		$noReasonFlag = 1;
		push @noReason, "$studnum:\:$period:$date";  # studnum:subjsec:period:date
	    }

	    # Check for an existing attendance record.
	    $sth1->execute( $studnum, $date, $period ); 
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; } 
	    my $count = $sth1->fetchrow;
	    if ( $count > 0 ) { # we have an existing record...  
		$duplicateRecordFlag = 1; 
		push @duplicateRecords, "$studnum:$period:$date:$subjsec"; 
	    }

	    if ( $count > 0 or not $reason ) { # skip to next record.
		next MULTIKEY;
	    }

	    
	    $sth = $dbh->prepare("select * from studentall where studnum = ?");
	    $sth->execute( $studnum );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    $rows = $sth->rows;
	    if ($rows != 1) {
		# No student found....
		$studname = "<span style=\"color:red;\">". $lex{'No Student Found'}. "</span>";
	    } else { # we have a student
		@student = $sth->fetchrow;
		$studname ="$student[1], $student[2] $student[3] ($student[4])";
	    }

	    print "<tr><td>$studname</td><td></td><td>$reason</td>";
	    print "<td>$period</td><td>$date</td></tr>\n";
	    print "<input type=\"hidden\" name=\"$student[4]:$period:\:$reason:\:$date\" ";
	    print "value=\"1\">\n";
	    
	} # End of loop for real hash vars (not name, date, passwd, date)
    } # End of ForEach Loop (each value in %arr hash)
} # end of Multi-Day method




# Sequence for the colon separated fields above:
# Studnum:Period:Subjsec:Reason:Late:Date

# Methods below do NOT supply a reason.

# === SA4 Method ===========

if ($arr{method} eq 'sa4') {

    my $sth = $dbh->prepare("select * from student where alias = ?");

    for ($i = 0;$i<=20;$i++) {
	my $student = "studa$i";

	if ( $arr{$student} ) {
	    my $alias = substr $arr{$student},0,3;
	    my $period = substr $arr{$student},3,1;

	    # Get Student Information
	    $sth->execute( $alias );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    my $rows = $sth->rows;
	    if ($rows < 1) {
		# No student alias for this....
		$studname = "<span style=\"color:red;\">". $lex{'No Student Found'}. "</span>";
	    } else { # we have a student
		@student = $sth->fetchrow;
		$studname ="$student[1], $student[2] $student[3] ($student[4])";
		print "<input type=\"hidden\" name=\"$student[4]:$period\" value=\"1\">\n";
	    }

	    # Check for an existing attendance record.
	    $sth1->execute( $student[4], $date, $period ); 
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; } 
	    my $count = $sth1->fetchrow;
	    if ( $count > 0 ) { # we have an existing record...  
		$duplicateRecordFlag = 1; 
		push @duplicateRecords, "$student[4]:$period:$date:$subjsec"; 
	    }
   
   
	    print "<tr><td>$studname</td><td></td><td></td><td>$period</td><td>$date</td></tr>\n";


	} # If we have an entered student.
    } # For Loop (20)
} # SA4 Method End


# ======= SA6 Method ======
if ($arr{method} eq 'sa6') {


    for ($i = 0;$i<=20;$i++) {
	my $student = "studa$i";
	if ( $arr{$student} ) {
	    my $alias = substr $arr{$student},0,3;
	    my $subject = substr $arr{$student},3,2;
	    my $period = substr $arr{$student},5,1;

	    # Get Student Information
	    $sth = $dbh->prepare("select * from student where alias = ?");
	    $sth->execute( $alias );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    $rows = $sth->rows;
	    if ($rows != 1) {
		# No student alias for this....
		$studname = "<span style=\"color:red;\">". $lex{'No Student Found'}. "</span>";
	    } else { # we have a student
		@student = $sth->fetchrow;
		$studname ="$student[1], $student[2] $student[3] ($student[4])";
	    }

	    # Check for an existing attendance record.
	    $sth1->execute( $student[4], $date, $period ); 
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; } 
	    my $count = $sth1->fetchrow;
	    if ( $count > 0 ) { # we have an existing record...  
		$duplicateRecordFlag = 1; 
		push @duplicateRecords, "$student[4]:$period:$date:$subjsec"; 
	    }


	    # Now Check the Subject
	    $sth = $dbh->prepare("select * from subject 
             where alias = '$subject'");
	    $sth->execute;
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    my $subrows = $sth->rows;
    	    if ($subrows < 1) {
		# No subject alias for this....
		$subname = "<span style=\"color:red;\">". $lex{'No Subject'}. "</span>";
	    } else { # we have a student
		@subject = $sth->fetchrow;
		$subname ="$subject[2]";
	    }

	    print "<tr><td>$studname</td><td>$subname</td><td></td><td>$period</td><td>$date</td></tr>\n";
            print "<input type=\"hidden\" name=\"$student[4]:$period:$subject[9]:\:\" value=\"1\">\n"; 
	} # If we have an entered student.  
    }  # For Loop (20)

} # End of SA6 Method



# If missing reason, fail here....
if ( $noReasonFlag ) {

    print "<tr><td colspan=\"5\" align=\"center\" style=\"color:red;\"><b>";
    print $lex{'Missing Attendance Reasons'}. "</b></td></tr>\n";

    my $sth = $dbh->prepare("select lastname,firstname from student where studnum = ?");
    my $sth1 = $dbh->prepare("select description from subject where subjsec = ?");

    foreach my $rec ( @noReason ) {
	my ($studnum, $subjsec, $period, $date) = split /:/, $rec;

	# Now find the student name
	$sth->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname) = $sth->fetchrow;

	# Now find the subject name (if subjsec exists)
	my $description;
	if ( $subjsec ) {
	    $sth1->execute( $subjsec );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    $description = $sth1->fetchrow;
	}

	print "<tr><td>$firstname $lastname ($studnum)</td>\n";
	if ($subjsec) {  
	    print "<td>$description ($subjsec)</td>\n"; 
	} else { 
	    print "<td></td>"; 
	}

	print "<td></td><td>$period</td><td>$date</td></tr>\n";
	
    }



} # End of noReasonFlag


if ( $duplicateRecordFlag ) {

    print "<tr><td colspan=\"5\" align=\"center\" style=\"color:red;\"><b>";
    print $lex{'Duplicate Attendance Records'}. "</b></td></tr>\n";

    my $sth = $dbh->prepare("select lastname,firstname from student where studnum = ?");
    my $sth1 = $dbh->prepare("select description from subject where subjsec = ?");

    foreach my $rec ( @duplicateRecords ) {
	my ($studnum, $period, $date, $subjsec) = split /:/, $rec;

	# Now find the student name
	$sth->execute( $studnum );
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	my ($lastname, $firstname) = $sth->fetchrow;

	# Now find the subject name (if subjsec exists)
	my $description;
	if ( $subjsec ) {
	    $sth1->execute( $subjsec );
	    if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	    $description = $sth1->fetchrow;
	}

	print "<tr><td>$firstname $lastname ($studnum)</td>\n";
	if ($subjsec) {  
	    print "<td>$description ($subjsec)</td>\n"; 
	} else { 
	    print "<td></td>"; 
	}

	print "<td></td><td>$period</td><td>$date</td></tr>\n";
	
    }

} # End of duplicateRecords



# If we have one or both above.... close forms and finish page
if ( $duplicateRecordFlag or $noReasonFlag ) {
    print "</table></form></center></body></html>\n";

} else {    

    print "</table><input type=\"submit\" value=\"". $lex{'Save Attendance Records'}. "\">\n";
    print "</form></center></body></html>\n";

}
