#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my $self = 'tattsubjed.pl'; # Edit attendance by subject records.

my %lex = ('Attendance Records' => 'Attendance Records',
	   'Main' => 'Main',
	   'Home Room' => 'Home Room',
	   'Please Log In' => 'Please Log In',
	   'Student' => 'Student',
	   'Date' => 'Date',
	   'Period' => 'Period',
	   'Reason' => 'Reason',
	   'Edit' => 'Edit',
	   'Delete' => 'Delete',
	   'No Subject Records Found' => 'No Subject Records Found',
	   'Duration' => 'Duration',
	   'Error' => 'Error',

	   );


use DBI;
use CGI qw/escape unescape/;
use CGI::Session;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


# needed to load $additionalcomments subject description (in order to skip).
eval require "../etc/repcard.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $q = CGI->new;
my %arr = $q->Vars; # Get passed values


my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
$mon++;
$wday++;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


# Setup Session
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

# Get Session Values (a defined userid means it was passed)
my $userid;
if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header( -charset, $charset );
    printHtmlHeader();
    print "<h1>". $lex{'Please Log In'}. "</h1>\n";
    print "</body></html>\n";
    die;
}
# Ok, we have a login. Values below we have in environment.

$userid = $session->param('userid');
my $duration = $session->param('duration');

if ( not ($duration =~ m/\+/) ) { # if no plus symbol...
    $duration = '+'. $duration. 'm';
} 

$session->expire('logged_in',$duration); # duration is in +20m format;
print $session->header( -charset, $charset );


# Get the user's subjects
my @subjects;
$sth = $dbh->prepare("select subjsec from subject where teacher $sql{like} ?
 and description != '$additionalcomments' order by description");
my $teacher = '%'. $userid. '%';
$sth->execute( $teacher );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
while (my $sub = $sth->fetchrow) {
    push @subjects, $sub;
}

#print "The subjects are: ", @subjects, "<br>\n";

# Print top of page
printHtmlHeader();
print $lex{Duration}. ": $duration<br>\n";
print "<center><h1>". $lex{Edit}. '/'. $lex{Delete}. q{ }. $lex{'Attendance Records'};
print "</h1>\n<h3>";
if ($hr) { print "<h3><b>". $lex{'Home Room'}. ": $hr &ndash; "; }
print "$currdate</h3>\n";

my $sth1 = $dbh->prepare("select description from subject where subjsec = ?");
my $sth2 = $dbh->prepare("select count(*) from attend where subjsec = ?");
my $first = 1;

foreach my $subjsec ( @subjects ) {

    # Get attendance record count for this subject
    $sth2->execute( $subjsec );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $count = $sth2->fetchrow;
    if ($count < 1) { next; } # try next subject...

    $first = 0; # if get past here, we have some subject records.

    # Get subject description
    $sth1->execute( $subjsec );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
    my $desc = $sth1->fetchrow;

    print "<h1>$desc - $subjsec</h1>\n";

    # print subject heading
    print "<table cellpadding=\"3\" border=\"1\" cellspacing=\"0\">\n";
    print '<tr><th>'. $lex{Student}. '</th><th>'. $lex{Date}. '</th><th>';
    print $lex{Period}. ' &ndash; '. $lex{Reason}. '</th><th>'. $lex{Edit};
    print '</th><th>'. $lex{Delete}. "</th></tr>\n";


    # Now select the student attendance records for this room
    $fieldlist = "attend.attid, attend.studentid, attend.absdate,
     attend.reason, attend.period, student.lastname, student.firstname";

    $sth = $dbh->prepare("select $fieldlist from attend, student 
      where attend.studentid = student.studnum 
      and attend.subjsec = ?
      order by attend.absdate desc, student.lastname, student.firstname");
    $sth->execute( $subjsec );
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    while (my ($attid, $studentid, $absdate, $reason, $period, $lastname,
	       $firstname) = $sth->fetchrow ) {

	print "<tr><td><b>$lastname</b> $firstname</td><td>$absdate</td><td>$period - $reason</td>\n";
	print "<td><a href=\"tatted.pl?id=$attid\">". $lex{Edit}. "</a></td>\n";
	print "<td><a href=\"tattdel.pl?id=$attid\">". $lex{Delete}. "</a></td></tr>\n";

    }

    print "</table>\n";

}

if ($first) { # no subject records found.
    print "<h1>". $lex{'No Subject Records Found'}. "</h1>\n";
}


print "</center></body></html>\n";



#------------------
sub printHtmlHeader {
#------------------

    print "$doctype\n<html><head><title>". $lex{Edit}. '/'. $lex{Delete};
    print q{ }. $lex{'Attendance Records'}. "</title>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
    print "$chartype\n</head><body>\n";

    print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

}
