#!/usr/bin/perl
# Copyright 2001-2009 Leslie Richardson

# Licensed under the GNU GPL.

# Part of Open Administration for Schools

# We must be passed both the student number and the 
#  subject-section number

my %lex = ('No Student!' => 'No Student!',
	   'No Subject!' => 'No Subject!',
	   'Edit Attendance' => 'Edit Attendance',
	   'Main' => 'Main',
	   'Subject' => 'Subject',
	   'Student' => 'Student',
	   'Date' => 'Date',
	   'Reason' => 'Reason',
	   'Period' => 'Period',
	   'Edit' => 'Edit',
	   'Error' => 'Error',

	   );


use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
print $q->header( -charset, $charset );
my %arr = $q->Vars;


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Name
$sth = $dbh->prepare("select lastname, firstname from student
  where studnum = ? "); 
$sth->execute( $arr{studnum} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my ($lastname,$firstname) = $sth->fetchrow;
if (not $lastname){ $lastname = "<span style=\"color:red;\">". $lex{'No Student!'}. "</span>"; }

# Get Subject
$sth = $dbh->prepare("select description from subject 
  where subjsec = ? "); 
$sth->execute( $arr{subjsec} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
$description = $sth->fetchrow;
if (not $description){ $lastname = "<<span style=\"color:red;\">". $lex{'No Subject!'}. "</font>";}

# Now get the records for this student in this subject.
my $sth = $dbh->prepare("select attid, absdate, reason, period from attend 
  where studentid = ? and subjsec = ? order by absdate desc"); 
$sth->execute( $arr{studnum}, $arr{subjsec} );
if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
my $rows = $sth->rows;

# Print Page Header
print "$doctype\n<html><head><title>". $lex{'Edit Attendance'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
$chartype\n</head><body>\n";

print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";
print "<center><h1>". $lex{'Edit Attendance'}. "</h1>
<p>". $lex{Subject}. ": <b>$description</b>  ". $lex{Student}. ": <b>$firstname $lastname</b></p>\n";

if ($rows < 1){ print "No Absences!</body></html>"; die;}

print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"1\">\n";
print "<tr><th>". $lex{Date}. "</th><th>". $lex{Reason}. "</th><th>". $lex{Period}. "</th><th></th></tr>\n";

for (1..$rows){
    my ($attid, $absdate, $reason, $period) = $sth->fetchrow;
    print "<tr><td>$absdate</td><td>$reason</td><td>$period</td>\n";
    print "<td><a href=\"tattsubjed1.pl?recnum=$attid\">". $lex{Edit}. "</a></td></tr>\n";
}

print "</table></body></html>\n";
