#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Main' => 'Main',
	   'Top' => 'Top',
	   'View Students' => 'View Students',
	   'Attendance' => 'Attendance',
	   'Start' => 'Start',
	   'End' => 'End',
	   'Records' => 'Records',
	   'Click on name to see Student Attendance Records' => 
	     'Click on name to see Student Attendance Records',
	   'Name' => 'Name',
	   'Date' => 'Date',
	   'Reason' => 'Reason',
	   'Period' => 'Period',
	   'Subject' => 'Subject',
	   'Grade' => 'Grade',
	   'Error' => 'Error',
	   'Start of Year' => 'Start of Year',
	   'Current Date' => 'Current Date',
	   'by' => 'by',
	   'No Records Found' => 'No Records Found',
	   'Error' => 'Error',

	   );

use DBI;
use CGI;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $q = new CGI;
my %arr = $q->Vars;
print $q->header( -charset, $charset );

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);


if ( $arr{group} eq $lex{Grade} ){ 
    $group = 'grade';
} else {
    $group = 'homeroom';
}


# Now Setup the Dates.
if ( $arr{startdate} ) {
    my ($year,$mo,$day) = split /-/, $arr{startdate};
    $startdate = "$month[$mo] $day, $year";

} else {
    $startdate = $lex{'Start of Year'};
}

if ( $arr{enddate} ) {
    my ($eyear, $emo, $eday) = split /-/, $arr{enddate};
    $enddate = "$month[$emo] $eday, $eyear";

} else {
    $enddate = $lex{'Current Date'};
}

my $select;
if ( $arr{startdate}  and  $arr{enddate} ) {
    $select = " and to_days(a.absdate) >= to_days('$arr{startdate}') 
     and to_days(a.absdate) <= to_days('$arr{enddate}') ";
# Otherwise, there is one or both are not defined.
} elsif ( $arr{enddate} ) {
    $select = " and to_days(a.absdate) <= to_days('$arr{enddate}')";
} elsif ($arr{startdate}) {
    $select = " and to_days(a.absdate) >= to_days('$arr{startdate}')";
}

$sth = $dbh->prepare("select a.attid, a.studentid, a.absdate, a.reason, a.period, 
  a.subjsec, s.lastname, s.firstname from attend as a, student as s 
  where a.studentid = s.studnum and  s.$group = ? $select 
  order by a.absdate desc, s.lastname, s.firstname, a.period");

$sth->execute( $arr{homeroom} );
if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr;}

$rows = $sth->rows;


print "$doctype\n<html><head><title>". $lex{'View Students'}. "</title>
 <link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
 </head><body><a name=\"top\"></a>\n";
print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

print "<center><h1>". $lex{Attendance}. q{ }. $lex{by}. " $arr{group} $arr{homeroom}</h1>\n";


print "<div style=\"border:1px solid gray; margin:1em 5em;padding:0.5em;\"><b>". $lex{Start};
print "</b> $startdate <b>". $lex{End}. "</b> $enddate\n";
print "<b>". $lex{Records}. ":</b> $rows<br>\n";
print $lex{'Click on name to see Student Attendance Records'}. "</div>\n";

if ( $rows < 1 ) {
    print "<h1>". $lex{'No Records Found'}. "</h1>\n";
    print "</body></html>\n";
    die;
}


print "<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\">\n";
print "<tr><th>". $lex{Name}. "</th><th>". $lex{Date}. "</th><th>";
print $lex{Reason}. "</th><th>". $lex{Period}. "</th><th>". $lex{Subject}. "</th></tr>\n";

my $colcolor = 'blue'; # tr colors are blue or gray;
my $currdate = -1;

for ($i=1; $i <= $rows; ++$i) {
    my ($attid, $studnum, $absdate, $reason, $period, $subjsec, 
	$lastname, $firstname) = $sth->fetchrow;
    $prevdate = $currdate;
    $currdate = $absdate;
    if ($prevdate ne $currdate){
	if ($colcolor eq 'blue'){ 
	    $colcolor = 'gray';
	} else { 
	    $colcolor = 'blue';
	}
    }

    print "<tr class=\"$colcolor\"><td><a href=\"studattview.pl?student=$studnum\">\n";
    print "<b>$lastname</b>, $firstname</a></td><td>$absdate</td>";
    print "<td>$reason</td><td>$period</td><td>$subjsec</td></tr>\n";

}

print "</table>";
print "[ <a href=\"$tchpage\">". $lex{Main}. "</a> | <a href=\"#top\">". $lex{Top}. "</a> ]\n";
print "</center></body></html>\n";
