#!/usr/bin/perl
#  Copyright 2001-2009 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Student Discipline' => 'Student Discipline',
	   'Discipline Entry' => 'Discipline Entry',
	   'Main' => 'Main',
	   'Infraction' => 'Infraction',
	   'Repeated Behavior<br>Consequence' => 'Repeated Behavior<br>Consequence',
	   'Description' => 'Description',
	   'Action Taken' => 'Action Taken',
	   'Please Log In' => 'Please Log In',
	   'Lastname/Lastname,Firstname/Initials/StudentNumber' => 
	     'Lastname/Lastname,Firstname/Initials/StudentNumber',
	   'Select Student' => 'Select Student',
	   'Search' => 'Search',
	   'No Student(s) Found' => 'No Student(s) Found',
	   'Save Record' => 'Save Record',
	   'Parental Contact' => 'Parental Contact',
	   'None' => 'None',
	   'Phoned' => 'Phoned',
	   'Letter' => 'Letter',
	   'caregiver' => 'caregiver',
	   'Your discipline record is now stored.' => 'Your discipline record is now stored.',
	   'Mistake' => 'Mistake',
	   'Description' => 'Description',
	   'Action' => 'Action',
	   'If Repeated' => 'If Repeated',
	   'Add another record' => 'Add another record',
	   'Back!' => 'Back!',
	   'Error' => 'Error',
	   'Please record the following error' => 'Please record the following error',
	   'Continue' => 'Continue',
	   'Entry Error' => 'Entry Error',
	   'Interview' => 'Interview',
	   'There was an error storing your data' => 'There was an error storing your data',
	   'Contact' => 'Contact',

	   );

my $self = 'tdiscadd.pl';

use DBI;
use CGI;
use CGI::Session;

my @tim = localtime(time);
my $year = $tim[5] + 1900;
my $month = $tim[4] + 1;
my $currdate = "$year-$month-$tim[3]";

my $q = new CGI;
my %arr = $q->Vars;

eval require "../etc/admin.conf";
if ( $@ ) {
    print $lex{Error}. ": $@<br>\n";
    die $lex{Error}. ": $@\n";
}


my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

# Get Session
my $session = new CGI::Session("driver:mysql;serializer:FreezeThaw",
 undef,{Handle => $dbh}) or die CGI::Session->errstr;

my $userid;
# Get Session Values (a defined userid means it was passed)
if ( not $session->param('logged_in') ){
    $userid = $session->param('userid');
    print $q->header( -charset, $charset );

    print "$doctype\n<html><head><title>". $lex{'Student Discipline'}. "</title>\n";
    print "<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">\n";
    print "</head><body>[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]\n";

    
    print "<h1>". $lex{'Please Log In'}. "</h1>\n";
    print "</body></html>\n";
    die;
}
# Ok, we have a login. Values below we have in environment.

$userid = $session->param('userid');
my $duration = $session->param('duration');
if (not ($duration =~ m/\+/)) { # if no format, add one.
    $duration = '+'. $duration. 'm';
}

$session->expire('logged_in',$duration);
print $session->header( -charset, $charset );


print "$doctype\n<html><head><title>". $lex{'Student Discipline'}. "</title>
<link rel=\"stylesheet\" href=\"$tchcss\" type=\"text/css\">
</head><body>\n";

print "<div style=\"display:inline;\">[ <a href=\"$tchpage\">". $lex{Main}. "</a> ]</div>\n";


if ( $arr{processflag} ) {
    processSearch( $arr{student} );
} elsif ( $arr{writeflag} ) {
    writeRecord();
} elsif (not $arr{student} ) {
    showSearch();
}



# Stuff Infractions into an array.
my @infarray;
my $sth = $dbh->prepare("select name from infraction where name != '' order by name");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
while (my $name = $sth->fetchrow) {
    push @infarray, $name;
}

my $studnum = $arr{student};
my $sth = $dbh->prepare("select lastname, firstname from student where studnum = ?");
$sth->execute( $studnum );
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
my ($lastname, $firstname) = $sth->fetchrow;
$studname = "$firstname $lastname ($studnum)";


print "<center><h1>". $lex{'Discipline Entry'}. "</h1>\n";

print "<h1>$studname</h1>\n";

print "<form action=\"$self\" method=\"post\">\n";
print "<input type=\"hidden\" name=\"studnum\" value=\"$studnum\">\n";
print "<input type=\"hidden\" name=\"writeflag\" value=\"1\">\n";


print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"0\">
<tr><td align=\"right\"><b>Date</b></td>
<td><input type=\"text\" name=\"date\" size=\"12\" value=\"$currdate\"></td>
</tr>\n";


print "<tr><td align=\"right\"><b>". $lex{'Infraction'}. "</b></td>\n";
print "<td><select name=\"mistake\">\n";

foreach my $inf (@infarray) {
    print "<option>$inf</option>\n";
}

print "</select></td></tr><tr>
 <td align=\"right\"><b>". $lex{Description}. "</b></td>
  <td><textarea name=\"description\" cols=\"60\" rows=\"6\"></textarea></td>
</tr><tr>
  <td align=\"right\"><b>". $lex{'Action Taken'}. "</b></td>
  <td><textarea name=\"action\" cols=\"60\" rows=\"4\"></textarea></td>
</tr><tr>
  <td align=\"right\"><b>". $lex{'Repeated Behavior<br>Consequence'}. "</b></td>
  <td><textarea name=\"repeat\" rows=\"4\" cols=\"60\"></textarea></td>
</tr>\n";

print "<tr><td align=\"right\"><b>". $lex{'Parental Contact'}. "</b></td>\n<td>";
 
print "<input type=\"radio\" name=\"parent\" value=\"". $lex{None};
print "\" checked> " . $lex{None}. "\n";
print "<input type=\"radio\" name=\"parent\" value=\"". $lex{Phoned}. "\">". $lex{Phoned}. "\n";
print "<input type=\"radio\" name=\"parent\" value=\"". $lex{Letter}. "\">".$lex{Letter}. "\n";
print "<input type=\"radio\" name=\"parent\" value=\"". $lex{Interview}. "\">";
print $lex{Interview}. " (". $lex{caregiver}. ")\n";

print "</td></tr>\n";
print "</table><input type=\"submit\" value=\"". $lex{'Save Record'}. "\">
</form></center></body></html>\n";



#-------------
sub showSearch {
#-------------

    print "<h1>". $lex{'Select Student'}. "</h1>\n";
    print "<form action=\"$self\" method=\"post\">";
    print "<input type=\"hidden\" name=\"processflag\" value=\"1\">\n<b>";
    print $lex{'Lastname/Lastname,Firstname/Initials/StudentNumber'};
    print "</b><br><input type=\"text\" name=\"student\" size=\"25\">\n";
    print "<input type=\"submit\" value=\"". $lex{Search}. "\"></form>\n";
    
    print "</body></html>\n";
    exit;

}


#----------------
sub processSearch {
#----------------

    my $student = shift;
    my @students;
    
    # Setup the Search
    if ($student =~ /\d+/) {  # we have a student number
	push @students, $student;
    } else { # we have words hopefully with a comma
	my ($lastname,$firstname)  = split /\,/, $student;
	$firstname =~ s/^\s*//;
	$lastname =~ s/^\s*//;
	if ($lastname and $firstname){ # both entered.
	    $sth = $dbh->prepare("select studnum from student 
              where lastname = ? and firstname = ?");
	    $sth->execute( $lastname, $firstname );
	} elsif ($lastname and not $firstname){ # only lastname (no comma)
	    if (length($lastname) == 2){ # search by initials: fi, li.
		my $fi = substr($lastname,0,1). '%';
		my $li = substr($lastname,1,1). '%';

		$sth = $dbh->prepare("select studnum from student 
                 where lastname $sql{like} ? and firstname $sql{like} ?");
		$sth->execute( $li, $fi );
	    } else {
		$sth = $dbh->prepare("select studnum from student 
                  where lastname = ? order by firstname");
		$sth->execute( $lastname );
	    }
	} else { # print an error....
	    print '<p><b>'. $lex{'Entry Error'}. ': ';
	    print $lex{'No Student(s) Found'}.".</b></p>\n";
	    print "</body></html>\n";
	    exit;
	}

    } # Last Else

   
    if ( $sth ) { # if text we should have a statement handle (sth)
	if ($DBI::errstr){ print $DBI::errstr; die $DBI::errstr; }
	$rows = $sth->rows;
	if ($rows < 1) { 
	    print '<p><b>'. $lex{'No Student(s) Found'}. ".</b></p>\n";
	    print "</body></html>\n"; 
	    exit;
	} 
    
	while ( my $studnum = $sth->fetchrow ) {
	    push @students, $studnum;
	}
    }


    print "<form action=\"$self\" method=\"post\">\n";
    print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"0\">\n";
   

    # display found students, if any...
    $sth1 = $dbh->prepare("select lastname, firstname from student where studnum = ?");

    foreach my $studnum (@students) {
    	$sth1->execute($studnum);
	my ($lastname, $firstname) = $sth1->fetchrow;
	print "<tr>";
	print "<td>$firstname $lastname ($studnum)</td>";
	print "<td><input type=\"radio\" name=\"student\" value=\"$studnum\"></td>";
	print "</tr>\n";
    
    }

    print "<tr><td><input type=\"submit\" valuu=\"". $lex{Continue}. "\"></td><td></td></tr>\n";
    print "</form></body></html>\n";

    exit;


} # End of processSearch;


#--------------
sub writeRecord {
#--------------

    delete $arr{writeflag};

    foreach my $key ( keys %arr ) {
	if ( $arr{$key} ) {
	    $arr{$key} = $dbh->quote( $arr{$key} );
	} else {
	    $arr{$key} = $sql{default};
	}
	#print "K:$key V:$arr{$key}<br>\n"; 
    }

    if ( not $arr{parent} ) { $arr{parent} = $sql{default}; }

    $sth = $dbh->prepare("insert into discipline values (
      $sql{default}, $arr{date}, $arr{studnum}, $arr{mistake},
      $arr{description}, $arr{action}, $arr{repeat},
      $arr{parent}, '$userid', $sql{default} )");

    $sth->execute;

    if (not $DBI::errstr ) {

	print "<h3>". $lex{'Your discipline record is now stored.'}. "</h3>\n";
	print "<table cellpadding=\"3\" cellspacing=\"0\" border=\"1\">\n";
	print "<tr><td align=\"right\">". $lex{Mistake}. "</td><td>$arr{mistake}</td></tr>\n";
	print "<td align=\"right\">". $lex{Description}. "</td><td>$arr{description}</td></tr>\n";
	print "<tr><td align=\"right\">". $lex{Action}. "</td><td>$arr{action}</td></tr>\n";
	print "<tr><td align=\"right\">". $lex{'If Repeated'}. "</td><td>$arr{repeat}</td></tr>\n";
	print "<tr><td align=\"right\">". $lex{'Parental Contact'};
	print "</td><td>$arr{parent}</td></tr>\n";
	print "</table>\n";

	print "<p> [ <a href=\"$tchpage\">". $lex{Main}. "</a> | <a href=\"$self\">";
	print $lex{'Add another record'}. "</a> ]</p>\n";
	print "<form><input type=\"button\" onclick=\"javascript:history.go(-2)\" value=\"";
	print $lex{'Back!'}. "\"> </form>\n";

    } else {

	print "<h3>". $lex{'There was an error storing your data'}. " \n";
	print $lex{Contact};
	print " $adminname <a href=\"mailto:$adminemail\">$adminemail</a><br>\n"; 
	print $lex{'Please record the following error'}. ": $DBI::errstr </h3>\n";

    }

    print "</body></html>\n";

    exit;


} # end of writeRecord.
