#!/usr/bin/perl
#  Copyright 2001, 2002 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

#  Open Admin for Schools is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.

#  You should have received a copy of the GNU General Public License
#  along with Open Admin; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use DBI;
use CGI;

@month = ("January","February","March","April","May","June","July","August","September","October","November","December");
@dow = ("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday");
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
$currdate = "$dow[$wday], $month[$mon] $mday, $year";

$q = new CGI;

# Http Header to return
print "Content-type: text/html\n\n";

%arr = $q->Vars;

# Read config variables
do "admin.conf" || die "Cannot read admin.conf!";

do "$globdir/global.conf" || die "Cannot read the global.conf file!";


# HTML Heading Material
print "<!DOCTYPE HTML PUBLIC \"-/W3C/DTD HTML 4.01/EN\" 
\"http://www.w3.org/TR/html4/loose.dtd\"><html><head><title>View Students</title>
<link rel=\"stylesheet\" href=\"/admin.css\" type=\"text/css\">
</head><body>\n";
print "<center><h1>Withdrawn Students Roster</h1><h3>$currdate</h3>\n";


foreach $database (keys %dbase) { #defined in global config file.

  $dsn = "DBI:mysql:$database";
  $dbh = DBI->connect($dsn,$guser,$gpassword);

  $select = "";
  if ($arr{grade} ne "") {
      $select = "where grade = '$arr{grade}'";
  }

  $sortorder = "lastname, firstname";
  if ($arr{sortorder} eq "birthdate") {
      $sortorder = "birthdate";
  } 


  $sth = $dbh->prepare("select * from studentwd $select order by $sortorder");
  $sth->execute;
  if ($DBI::errstr){
      print $DBI::errstr;
      die;
  }
  $rows = $sth->rows;


  print "<h2>$dbase{$database}</h2><table border=\"2\">
   <tr><th>Name</th><th>Number</th><th>Grade</th><th>Sex</th>  
   <th>Birthdate</th><th>Prov #</th></tr>\n";

  for ($i=1; $i <= $rows; ++$i) {
    @arr = $sth->fetchrow;

    print "<tr><td><b>$arr[1], $arr[2] $arr[3]</b></td>\n";
    print "<td>$arr[4]</td><td>$arr[5]</td><td>$arr[7]</td><td>$arr[8]</td><td>$arr[57]</td>\n";
    print "</tr>\n\n";
  }
  
  print "</table>\n";

}  # End of Database reading Loop.



print "</center></body></html>";


