#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

use DBI;
use CGI;

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

# These MUST be passed in order to find student.
$studnum = $arr{studnum};
$database = $arr{school};

# Read config variables
require "../ppp.conf" || die "Cannot read ppp.conf!";
require $globdir/global.conf" || die "Cannot read the global.conf file!";

$schoolname = $dbase{$database}; # from global.conf dbase hash.

# Print Page Header
print <<"EOH";
<!DOCTYPE HTML PUBLIC "-/W3C/DTD HTML 4.01/EN" 
"http://www.w3.org/TR/html4/loose.dtd">
<html><head><title>Student Summary Report</title>
<link rel="stylesheet" href="/division.css" type="text/css">
<style type="text/css">
    body { padding: 0 3em;}
h2 { font-style: normal; font-size: medium;
  padding: 3px;
  border: 1px solid black;}
</style>
</head><body>
EOH

$dsn = "DBI:mysql:$database";
$dbh = DBI->connect($dsn,$guser,$gpassword);

$sth = $dbh->prepare("select * from student where studnum = '$studnum'");
$sth->execute;
if ($DBI::errstr) {
  print $DBI::errstr;
  die;
}  
@student = $sth->fetchrow;

my @month = ('January','February','March','April','May','June','July',
 'August','September','October','November','December');
my @dow = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


# Now do the local PPP database; we have school data in @student.

$dsn = "DBI:mysql:$dbase";
$dbh = DBI->connect($dsn,$user,$password);

$sth = $dbh->prepare("select * from special where studnum = ?");
$sth->execute( $studnum );
if ($DBI::errstr) { print "Error: $DBI::errstr"; die $DBI::errstr; }

@special = $sth->fetchrow; 
$studname = "$special[2] $special[1]";
$shortschool = $database;

# Find their subjects.
$sth = $dbh->prepare("select * from evalmst where studnum = '$studnum'");
$sth->execute;
if ($DBI::errstr) {
  print "Error: $DBI::errstr";
  die;
}
$rows = $sth->rows;

# Print the heading section 
print <<"EOS2";
<table width="100%"><tr><td colspan="2">
[ <a href="/cgi-bin/ppp/spview0.pl">Back to Special Needs Students</a> ]</td>
</tr><tr>
<td><h1>Student Personal Program Plan</h1></td>
<td align="right">$currdate</td></tr></table>

<p><b>$studname</b></p>
EOS2


print <<"ID";
<h2>Identification</h2>

<table cellspacing="0" cellpadding="0" border="0">

<tr><td>Name</td><td> $studname </td></tr>
<tr><td>Gender</td><td> $student[7]</td></tr>
<tr><td>Birthdate</td><td> $student[8]</td></tr>
<tr><td>Grade</td><td> $student[5]</td></tr>

<tr><td>Designation Date</td><td> $special[6]</td></tr>
<tr><td>DDPF Level</td><td> $special[7]</td></tr>
<tr><td>Designation</td><td> $special[8]</td></tr>

<tr><td>Medical(other)</td><td> $student[18]</td></tr>
<tr><td>School</td><td> $schoolname  -- $g_phone{$shortschool}</td></tr>

<tr><td>Parent/Guardian</td><td> $student[29]</td></tr>
<tr><td>Address</td><td> $student[34] $student[35] $student[36]</td></tr>
<tr><td>Home Phone</td><td> $student[30]</td></tr>
<tr><td>Emergency Contact</td><td> $student[49] $student[50] $student[51]</td></tr>
</table>
ID

# Let's Do Assessments!
$sth1 = $dbh->prepare("select * from assess where studnum = '$studnum' order by resdate desc" );
$sth1->execute;
if ($DBI::errstr) { print $DBI::errstr; die;}
$assessrows = $sth1->rows; 

# Now print out Assessment headings
print <<"AH";
<h2>Assessments</h2>
<table cellspacing="0" cellpadding="4" border="1">
<tr><th>Dates</th><th>Category</th><th>Comments</th></tr>
AH

for (1..$assessrows){
  @assess = $sth1->fetchrow;
  print  "<tr><td>$assess[3]</td>
 <td>$assess[2]</td><td>$assess[5]</td></tr>\n";
}
print "</table>\n\n";


# Now lets do the team.
$sth1 = $dbh->prepare("select * from team where studnum = '$studnum'");
$sth1->execute;
if ($DBI::errstr) { print $DBI::errstr; die;}
$teamrows = $sth1->rows; 

print <<"TH";
<h2>Student Team</h2>
<table cellspacing="0" cellpadding="4" border="1">
<tr><th>Name</th><th>Position</th></tr>
TH

for (1..$teamrows){
  @team = $sth1->fetchrow;
  ($teammember,$dud) = split /\(/,$team[2];
  #push @teamarray,$teammember;  # needed for signature page
  print "<tr><td>$teammember</td><td>$team[3]</td></tr>\n";
}
print "</table>\n";

# Now let's do the objectives
$sth = $dbh->prepare("select * from evalmst where studnum = '$studnum'");
$sth->execute;
if ($DBI::errstr) { print $DBI::errstr; die;}
$rows = $sth->rows; 

print  "<h2>Student Objectives</h2>\n";

# Subjects Loop; once for each subject.
for ($i=1; $i <= $rows; ++$i) {
    @evalmst = $sth->fetchrow;
    $subnum = $evalmst[2];

    #lookup subject name
    $sth1 = $dbh->prepare("select * from catsubject where catid = '$subnum'");
    $sth1->execute;
    if ($DBI::errstr) { print $DBI::errstr; die;}
    @catsubject = $sth1->fetchrow; 
    $subname = $catsubject[2];
      
print <<"SH";
<table cellspacing="0" cellpadding="4" border="1">
<tr><th>$subname</th></tr>
<tr><td><b>Responsibility:</b> $evalmst[36]</td></tr>
<tr><td><b>Strategies, Resources, Activities:</b> $evalmst[35]</td></tr>
<tr><td>
SH

# Now print the objectives
 print "<b>Objectives</b><ul>\n";
 for ($j=3; $j<=34;$j++){
   if ($evalmst[$j]){
     print "<li>$evalmst[$j]</li>";
   }
 }
 print "</ul></td></tr></table><p></p>\n";

 } # End of Subject "For" Loop

print "</body></html>";

