#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


use DBI;
use CGI;

my @month = ('January','February','March','April','May','June','July','August',
	     'September','October','November','December');
my @dow = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');

my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";


my $q = new CGI;
print $q->header;
my %arr = $q->Vars;


# Read config variables
do "admin.conf" || die "Cannot read admin.conf!";
do "$globdir/global.conf" || die "Cannot read global.conf!";

# Sort School Databases
@dbase = sort keys %dbase;

# Initialize
@grades = ();
%grades = ();
%gradetotals = ();
$grandtotal = 0;

# Print top section of report
print "<!DOCTYPE HTML PUBLIC \"-/W3C/DTD HTML 4.01/EN\" 
\"http://www.w3.org/TR/html4/loose.dtd\">
<html><head><title>Enrollment Summary</title>
<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">
</head><body>\n";

print "[ <a href=\"$homepage\">Main</a> ]
<center><h2>$divisionname<br>Enrollment Summary</h2>
<h4>$currdate</h4>\n";

print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";

# First create array of all grades from all schools.
foreach $database (@dbase) { #defined in global config file.
    $dsn = "DBI:mysql:$database";
    $dbh = DBI->connect($dsn,$guser,$gpassword);

    $sth = $dbh->prepare("select distinct grade from student order by grade");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die; }
    my $rows = $sth->rows;
    for (1..$rows){
	my $temp = $sth->fetchrow;
	$grades{$temp} = 1;
    }
} # End of database loop

# Put into grades array
@grades = sort keys %grades;

print "<tr><th>School \\ Gr</th>\n";
foreach $grade (@grades){
    print "<th>$grade</th>";
}
print "<th>Totals</th></tr>\n";


foreach $database (@dbase) { #defined in global config file.
    $dsn = "DBI:mysql:$database";
    $dbh = DBI->connect($dsn,$guser,$gpassword);

    $sth = $dbh->prepare("select distinct grade, count(grade) from student group by grade");
    $sth->execute;
    if ($DBI::errstr){ print $DBI::errstr; die; }
    my $rows = $sth->rows;
    $schooltotal = 0;
    for (1..$rows){
	my @temp = $sth->fetchrow;
	$schoolgrades{$temp[0]} = $temp[1];
	$schooltotal += $temp[1];
	$gradetotal{$temp[0]} += $temp[1];
    }
    $grandtotal += $schooltotal;

    # Now print them out in the right order.
    print "<tr><td align=\"left\">$dbase{$database}</td>\n";
    foreach $grade (@grades){
	print "<td>$schoolgrades{$grade}</td>";
    }
    print "<td>$schooltotal</td></tr>\n";
  
    undef %schoolgrades;

} # End of database loop

# Now print summaries at the bottom.
print "<tr><td style=\"background-color:#BBB;\"></td>\n";

foreach $grade (@grades){
    print "<td style=\"background-color:#BBB;\">$gradetotal{$grade}</td>";
}

print "<td style=\"background-color:#BBB;\">$grandtotal</td></tr>\n";
print "</table></body></html>\n";
