#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

use DBI;
use CGI;

my @month = ('January','February','March','April','May','June','July','August',
	     'September','October','November','December');
my @dow = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header;
my %arr = $q->Vars;


# Read config variables
do "admin.conf" || die "Cannot read admin.conf!";
do "$globdir/global.conf" || die "Cannot read global.conf!";

# Sort School Databases
@dbase = sort keys %dbase;

# Initialize
@ethnic = ();
%ethnic = ();
%ethnictotals = ();
$grandtotal = 0;


print "<!DOCTYPE HTML PUBLIC \"-/W3C/DTD HTML 4.01/EN\" 
\"http://www.w3.org/TR/html4/loose.dtd\">
<html><head><title>Summary Ethnic Report</title>
<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">
</head><body>
[ <a href=\"$homepage\">Main</a> ]
<center>
<h1 class=\"large\">Ethnic Enrollment</h1>
<h2>$currdate</h2>\n";
print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";


# First create array of all ethnic types from all schools.
foreach $database (@dbase) { #defined in global config file.
  $dsn = "DBI:mysql:$database";
  $dbh = DBI->connect($dsn,$guser,$gpassword);

  $sth = $dbh->prepare("select distinct ethnic from student order by ethnic");
  $sth->execute;
  if ($DBI::errstr){ print $DBI::errstr; die; }
  my $rows = $sth->rows;
  for (1..$rows){
      my $temp = $sth->fetchrow;
      $ethnic{$temp} = 1;
  }
} # End of database loop

# Put into ethnic array
@ethnic = sort keys %ethnic;

# Print table headers.
print "<tr><th>School \\ Ethnic</th>\n";
foreach $ethtype (@ethnic){
    print "<th>$ethtype</th>";
}
print "<th>Totals</th></tr>\n";


foreach $database (@dbase) { #defined in global config file.

  $dsn = "DBI:mysql:$database";
  $dbh = DBI->connect($dsn,$guser,$gpassword);

  $sth = $dbh->prepare("select distinct ethnic, count(ethnic) from student group by ethnic");
  $sth->execute;
  if ($DBI::errstr){ print $DBI::errstr; die; }
  my $rows = $sth->rows;
  $schooltotal = 0;
  for (1..$rows){
      my @temp = $sth->fetchrow;
      $schoolethnic{$temp[0]} = $temp[1];
      $schooltotal += $temp[1];
      $ethnictotal{$temp[0]} += $temp[1];
  }
  $grandtotal += $schooltotal;

  # Now print them out in the right order.
  print "<tr><td>$dbase{$database}</td>\n";
  foreach $ethtype (@ethnic){
      print "<td>$schoolethnic{$ethtype}</td>";
  }
  print "<td>$schooltotal</td></tr>\n";
  
  undef %schoolethnic;

} # End of database loop

# Now print summaries at the bottom.
print "<tr><td style=\"background-color:#BBB;\"></td>\n";
foreach $ethtype (@ethnic){
   print "<td style=\"background-color:#BBB;\">$ethnictotal{$ethtype}</td>";
}
print "<td style=\"background-color:#BBB;\">$grandtotal</td></tr>\n";

print "</table></body></html>\n";






