#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my %lex = ('Reserve Resident Students' => 'Reserve Resident Students',
	   'Main' => 'Main',
	   'Native Bands in Student Table' => 'Native Bands in Student Tables',
	   'Band Name' => 'Band Name',
	   'Band Number' => 'Band Number',
	   'Grade' => 'Grade',
	   'Student' => 'Student',
	   'Reserve' => 'Reserve',
	   'Parents' => 'Parent(s)',
	   'Phone(s)' => 'Phone(s)',
	   'H' => 'H',
	   'W' => 'W',
	   'No Students Found' => 'No Students Found',

	   );

# W = Work phone, H = Home Phone

use DBI;
use CGI;

my @dow = ('Sunday','Monday','Tuesday','Wednesday','Thursday',
	'Friday','Saturday');
my @month = ('','January','February','March','April','May','June','July',
	  'August','September','October','November','December');
my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, 
 $iddst) = localtime(time);
$year = $year + 1900;
my $currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
print $q->header;
my %arr = $q->Vars;


# Read config variables
require "admin.conf" || die "Cannot read admin.conf!";
require "$globdir/global.conf" || die "Cannot read global.conf!";


# Page Header
print "$doctype\n<html><head><title>". $lex{'Reserve Resident Students'}. "</title>
<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">
$chartype\n</head><body><a name=\"top\"></a>[ <a href=\"$homepage\">Main</a> ]
<center><h1>". $lex{'Reserve Resident Students'}. "</h1><h3>$currdate</h3>\n";


# Sort School Databases
my @dbase = sort keys %dbase;


print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
print "<caption style=\"font-size: 120%\">";
print $lex{'Native Bands in Student Table'}. "</caption>\n";
print '<tr><th>'. $lex{'Band Name'}. '</th><th>'. $lex{'Band Number'}. "</th></tr>\n";


my %reserve;
my @reserve;

# First create array of all bands from all schools.
foreach $database ( @dbase ) { #defined in global config file.

    my $dsn = "DBI:mysql:$database";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);

    my $sth = $dbh->prepare("select distinct band, bandnum from student 
      where band != '' order by band");
    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
    while ( my ( $bandname, $bandnumber ) = $sth->fetchrow ) {
	$reserve{"$bandname:$bandnumber"} = 1;
    }

} # End of database loop

# put in @reserve array
@reserve = sort keys %reserve;

foreach my $band ( @reserve ) {
    my ( $bname, $bnum ) = split /:/, $band;
    print "<tr><td>$bname</td><td>$bnum</td></tr>\n";
}
print "</table>\n";


my $select = "where reserveres != '' and reserveres is not null";
my $sortby = 'grade, lastname, firstname';


foreach my $database (@dbase) { #defined in global config file.

    my $dsn = "DBI:mysql:$database";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);

    # School Name
    print "<h2>$dbase{$database}</h2>\n";

    $sth = $dbh->prepare("select lastname, firstname, initial, studnum,
     grade, birthdate, treaty, band, bandnum, name1, name2, hphone1, 
     wphone1 from student $select
     order by $sortby");

    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }

    my $currgrade = -1;
    my $firstflag = 1;

    while ( my ( $lastname, $firstname, $initial, $studnum, $grade, $birthdate, $treaty,
		 $band, $bandnum, $name1, $name2, $hphone1, $wphone1 ) = $sth->fetchrow ) {

	$oldgrade = $currgrade;
	$currgrade = $grade;

	if ($oldgrade ne $currgrade) { # we have a new grade
	    if ( not $firstflag ){ print "</table><p></p>\n"; } else { $firstflag = 0; }
	    print "<table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
	    
	    print "<caption><b>". $lex{Grade}. ": $currgrade</b></caption>\n";
	    print '<tr><th>'. $lex{Student}. '</th><th>'. $lex{Reserve};
	    print '</th><th>'. $lex{Parents}. "</th><th>". $lex{'Phone(s)'}. "</th></tr>\n";
	}

	print "<tr><td><b>$lastname</b>, $firstname $initial<br>";
	print "$birthdate ($studnum)</td>\n";

	print "<td>$treaty<br>$band $bandnum</td>\n";
	print "<td>$name1<br>$name2</td><td>". $lex{H}. ":$hphone1<br>". $lex{W}. ":$wphone1</td></tr>\n";

	
    } # End of Main Loop

    if ( $firstflag ) { # no students
	print "<tr><td colspan=\"5\">". $lex{'No Students Found'}. ".</td></tr>\n";
    }
    print "</table>\n";

} # End of Database Loop...


print "<p>[ <a href=\"#top\">Top</a> ]</p></body></html>\n";
