#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.


use DBI;
use CGI;

@month = ("January","February","March","April","May","June","July","August","September","October","November","December");
@dow = ("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday");
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $iddst) = localtime(time);
$year = $year + 1900;
$currdate = "$dow[$wday], $month[$mon] $mday, $year";

my $q = new CGI;
my %arr = $q->Vars;
print $q->header;

# Read config variables
do "admin.conf" || die "Cannot read admin.conf!";
do "$globdir/global.conf" || die "Cannot read global.conf!";

@dbase = sort keys %dbase;

print "<!DOCTYPE HTML PUBLIC \"-/W3C/DTD HTML 4.01/EN\" 
\"http://www.w3.org/TR/html4/loose.dtd\">
<html><head><title>Enrollment Details</title>
<link rel=\"stylesheet\" href=\"/division.css\" type=\"text/css\">
</head><body>[ <a href=\"$homepage\">Main</a> ]
<center><h1>Enrollment Details</h1><h4>$currdate</h4>\n";

foreach $database (@dbase) { #defined in global config file.
    $dsn = "DBI:mysql:$database";
    $dbh = DBI->connect($dsn,$guser,$gpassword);
    $sth = $dbh->prepare("select * from student order by grade, homeroom");
    $sth->execute;
    $rows = $sth->rows;

    print "<h2>$dbase{$database}</h2><table border=\"1\" cellpadding=\"3\" cellspacing=\"0\">\n";
    print "<tr><th>Room - Teacher</th><th>Grade</th><th>Male</th><th>Female</th>\n";
    print "<th>Young</th><th>HR Total</th><th>GR Total</th></tr>\n";

    $youngest = 0;
    $youngtot = 0;
    
    $boytotal = 0;
    $girltotal = 0;
    $boycount=0;
    $girlcount = 0;
    $boygrade = 0;
    $girlgrade = 0;

    @arr = $sth->fetchrow;
    if ("\U$arr[7]" eq "F") {
	$girlcount++;
	$girltotal++;
	$girlgrade++;
    } else {
	$boycount++;
	$boytotal++;
	$boygrade++;
    }
    if ("\U$arr[15]" eq "Y") {
	$youngest++;
	$youngtot++;
    }

    $curroom = "$arr[6]";
    $currgrade = "$arr[5]";

    for ($i=2; $i <= $rows; ++$i) {
	@arr = $sth->fetchrow;
  
	if ($arr[6] ne $curroom) { # we have a new room
	    $hrtotal = $boycount + $girlcount;

	    $sth1 = $dbh->prepare("select * from teacher where homeroom = '$curroom'");
	    $sth1->execute;
	    @teacher = $sth1->fetchrow;
  
	    print "<tr><td align=\"left\">$curroom - $teacher[1] $teacher[3] $teacher[2]</td>\n";
	    print "<td>$currgrade</td><td>$boycount</td><td>$girlcount</td><td><i>$youngest</i></td>\n";
	    print "<td>$hrtotal</td><td></td></tr>\n";

	    $curroom = $arr[6]; 
	    $girlcount = 0;
	    $boycount = 0;
	    $youngest = 0;
	}

	if ($arr[5] ne $currgrade) { # we have a new grade also
	    $grtotal = $boygrade + $girlgrade;
	    print "<tr><td></td><td>$currgrade</td><td><b>$boygrade</b></td>
      <td><b>$girlgrade</b></td><td></td><td></td>
      <td><b>$grtotal</b></td></tr>\n";
	    $currgrade = $arr[5];
	    $girlgrade = 0;
	    $boygrade = 0;
	}

	if ("\U$arr[7]" eq "F") {
	    $girlcount++;
	    $girltotal++;
	    $girlgrade++;
	} else {
	    $boycount++;
	    $boytotal++;
	    $boygrade++;
	}
	if ("\U$arr[15]" eq "Y") {
	    $youngest++;
	    $youngtot++;
	}

    } # End of loop counter

    $total = $boycount + $girlcount;
    
    $sth1 = $dbh->prepare("select * from teacher where homeroom = '$curroom'");
    $sth1->execute;
    @teacher = $sth1->fetchrow;

    print "<tr><td>$curroom - $teacher[1] $teacher[3] $teacher[2]</td><td>$currgrade</td><td>$boycount</td>
      <td>$girlcount</td><td><i>$youngest</i></td><td>$total</td></tr>\n";

    $grtotal = $boygrade + $girlgrade;
    
    print "<tr><td></td><td>$currgrade</td><td><b>$boygrade</b></td>
      <td><b>$girlgrade</b></td><td></td><td></td><td><b>$grtotal</b></td></tr>\n";

    print "<tr><td colspan=2><b>Totals</b></td><td><b>$boytotal</b></td>
  <td><b>$girltotal</b></td><td><b><i>$youngtot</i></b></td>
  <td></td><td><b>$rows</b></td></tr>";
  print "</table><p></p>\n";

} # end of database loop

print"</center></body></html>\n";

