#!/usr/bin/perl
#  Copyright 2001-2007 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

use DBI;
use CGI;

my $q = new CGI;
print $q->header; 
my %arr = $q->Vars;

my $student = $arr{student};

# Read config variables
do "admin.conf" || die "Cannot read admin.conf!";
do "$globdir/global.conf" || die "Cannot read the global.conf file!";

# Print Page Header
print <<"EOH";
<!DOCTYPE HTML PUBLIC "-/W3C/DTD HTML 4.01 Transitional/EN" 
"http://www.w3.org/TR/html4/loose.dtd">
<html><head><title>Student Search</title>
<link rel="stylesheet" href="/division.css" type="text/css">
</head><body>
[ <a href="$homepage">Main</a> ]
<center><h1>Student Search Results</h1>
EOH
$foundflag = 0;

foreach $database (keys %dbase) { # defined in global config file.

    $dsn = "DBI:mysql:$database";
    $dbh = DBI->connect($dsn,$guser,$gpassword);

    if ($student =~ /\d+/) {  # we have a student number
	$studentnumber = $student;
	$sth = $dbh->prepare("select * from student where studnum = '$student'");
    } else { # we have words with a comma
	($lastname,$firstname)  = split /\,/, $student;
	$firstname =~ s/^\s*//;
	$lastname =~ s/^\s*//;
	
	if ($lastname and $firstname){ # both entered.
	    $sth = $dbh->prepare("select * from student where lastname = '$lastname' and firstname = '$firstname'");
	} elsif ($lastname and not $firstname){ # only lastname
	    $sth = $dbh->prepare("select * from student where lastname = '$lastname'");
	}
    }

    $sth->execute;
    if ($DBI::errstr) { print $DBI::errstr; die $DBI::errstr; }
  
    $rows = $sth->rows;

    if ($rows < 1) { 
	next; # skip to next database  
    }

    if (not $foundflag) {
	$foundflag = 1;
    }

    # We have at least one record for this school.
    print "<h2>$dbase{$database}</h2>\n";
    print "<table border=\"1\" cellspacing=\"0\" cellpadding=\"2\">\n";
    print "<tr><th>Name</th><th>Desc</th><th>Parent1</th><th>Parent2</th><th>Emer/Rel</th></tr>\n";
  
    for ($i=1;$i<=$rows;$i++){  
	@arr = $sth->fetchrow;
	$studentnumber = $arr[4];
	$studentname = "$arr[2] $arr[1]";

	print <<"EOP";
    <tr>
     <td valign="top">
      <table><tr><td colspan="2"><b> $arr[2] $arr[3] $arr[1]</b></td></tr>
      <tr><td align="right"><em>Studnum:</em></td><td> $arr[4]</td></tr>
      <tr><td align="right"><em>Grade:</em></td><td> $arr[5]</td></tr>
      <tr><td align="right"><em>Form:</em></td><td> $arr[6]</td></tr>
      <tr><td align="right"><em>Sex:</em></td><td> $arr[7]</td></tr>
      <tr><td align="right"><em>Bdate:</em></td><td> $arr[8]</td></tr>
      <tr><td align="right"><em>ProvNum:</em></td><td> $arr[57]</td></tr>
      <tr><td align="right"><em>House:</em></td><td> $arr[9]</td></tr>
      <tr><td align="right"><em>Bus:</em></td><td> $arr[56] </td></tr>
      <tr>
        <td align="right"><em>Emerg:</em></td>
        <td>$arr[49] $arr[50] $arr[51]</td>
      </tr>
    
    <tr><td align="right"> </td>
        <td> $arr[52]  $arr[53] </td>
    </tr>
      
    <tr><td align="right"><em>Doctor:</em></td>
       <td> $arr[54]  $arr[55] </td>
    </tr>
      </table>
   </td>

  <td valign="top">
      <table>
      <tr><td align="right"><em>HealthID:</em></td><td> $arr[10]</td></tr>
      <tr><td align="right"><em>Entry:</em></td><td> $arr[11]</td></tr>
      <tr><td align="right"><em>Ethnic:</em></td><td> $arr[12]</td></tr>
      <tr><td align="right"><em>SPar:</em></td><td> $arr[13]</td></tr> 
      <tr><td align="right"><em>Internet:</em></td><td> $arr[14]</td></tr> 
      <tr><td align="right"><em>Youngest:</em></td><td> $arr[15]</td></tr>
      <tr><td align="right"><em>Owing:</em></td><td> $arr[16]</td></tr>
      <tr><td align="right"><em>Band:</em></td><td> $arr[58]</td></tr>
      <tr><td align="right"><em>Band #:</em></td><td> $arr[59]</td></tr>
      <tr><td align="right"><em>Medical:</em></td><td>$arr[18]</td></tr>
      </table>
  </td>
  
  
  <td valign="top">
   <table>
    <tr><td align="right"><em>Par:</em></td><td>$arr[27]</td></tr>
    <tr><td align="right"><em>Con:</em></td><td>$arr[28]</td></tr>
    <tr><td align="right"><em>Name:</em></td><td>$arr[29]</td></tr>
    <tr><td align="right"><em>HPh:</em></td><td> $arr[30]</td></tr>
    <tr><td align="right"><em>WPh:</em></td><td> $arr[31]</td></tr>
    <tr><td align="right"><em>Cel:</em></td><td> $arr[32]</td></tr>
    <tr><td align="right"><em>Fax:</em></td><td> $arr[33]</td></tr>
    <tr><td align="right"><em>Adr:</em></td><td> $arr[34]</td></tr>
    <tr><td align="right"><em>City:</em></td><td> $arr[35]</td></tr>
    <tr><td align="right"><em>Pcode:</em></td><td> $arr[36]</td></tr>
    <tr><td align="right"><em>Work:</em></td><td> $arr[37]</td></tr>
   </table>
  </td>


  <td valign="top">
    <table>
    <tr><td align="right"><em>Par:</em></td><td>$arr[38]</td></tr>
    <tr><td align="right"><em>Con:</em></td><td> $arr[39]</td></tr>
    <tr><td align="right"><em>Name:</em></td><td> $arr[40]</td></tr>
    <tr><td align="right"><em>HPh:</em></td><td> $arr[41]</td></tr>
    <tr><td align="right"><em>WPh:</em></td><td> $arr[42]</td></tr>
    <tr><td align="right"><em>Cel:</em></td><td> $arr[43]</td></tr>
    <tr><td align="right"><em>Fax:</em></td><td> $arr[44]</td></tr>
    <tr><td align="right"><em>Adr:</em></td><td> $arr[45]</td></tr>
    <tr><td align="right"><em>City:</em></td><td> $arr[46]</td></tr>
    <tr><td align="right"><em>Pcode:</em></td><td> $arr[47]</td></tr>
    <tr><td align="right"><em>Work:</em></td><td> $arr[48]</td></tr>
    </table>
  </td>

  <td valign"top">
    <table>
    <tr><td align="right">Rel:</td><td> $arr[19]</td></tr>
    <tr><td align="right">Mom:</td><td> $arr[20]</td></tr>
    <tr><td align="right">Dad:</td><td> $arr[21]</td></tr>
    <tr><td align="right">Parish:</td><td> $arr[22]</td></tr>
    <tr><td align="right">Bap:</td><td> $arr[60]</td></tr>
    <tr><td align="right">Comm:</td><td> $arr[23]</td></tr>
    <tr><td align="right">Recon:</td><td> $arr[24]</td></tr>
    <tr><td align="right">Conf:</td><td> $arr[25]</td></tr>
    <tr><td align="right">Maiden:</td><td> $arr[26]</td></tr>
    </table>
  </td>
 </tr>
EOP
  # End of the single student record. 
  } # End of For Loop
 
  # End of This School
  print "</table>\n\n";  

}  # End of Main Database Search Loop


if (not $foundflag) {  # No student found for all databases
   print "<center><h2>Student not found. Please try again.</h2>
   <form><input type=\"button\" onclick=\"javascript:history.back()\" 
   value=\"Back!\"></form>";
}

print <<"EOP1";  
</table>

<p>[ <a href="$homepage">Main</a> ]</p>

<p>Student Search 
<form action="/cgi-bin/studsearch.pl" method="post">
<b>Name</b>(last,first) or <b>Student Number</b> 
  <input type="text" name="student" size="30">
  <input type="submit" value="Enter">
 </form></p>

</center></body></html>
EOP1
