#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

#  Open Admin for Schools is free software; you can redistribute it 
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2 of 
#  the License, or (at your option) any later version.

my $downloaddir = '/schools/esis/admin/download';
my $webdownloaddir = '/download';

my $shell = '/bin/bash';
my $homedirroot = '/home';

my %lex = ('Error' => 'Error',
	   'User Management' => 'User Management',
	   'Main' => 'Main',
	   'Continue' => 'Continue',
	   'Checked' => 'Checked',
	   'Select Students' => 'Select Students',
	   'Grade' => 'Grade',
	   'Mode' => 'Mode',
	   'Add' => 'Add',
	   'Delete' => 'Delete',
	   'Schools' => 'Schools',
	   'Program Error' => 'Program Error',
	   'Download Management File' => 'Download Management File',

	   );

my $self = 'usermanage.pl';


use DBI;
use CGI;

eval require "admin.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

eval require "$globdir/global.conf";
if ( $@ ) {
    print $lex{Error}. " $@<br>\n";
    die $lex{Error}. " $@\n";
}

my $q = CGI->new;
my %arr = $q->Vars;
print $q->header;


print "$doctype\n<html><head><title>". $lex{'User Management'};
print "</title><link rel=\"stylesheet\" href=\"$iepcss\" type=\"text/css\">
</head><body>\n";
print "[ <a href=\"$iephome\">". $lex{Main}. "</a> ]\n";


# Decide on what function to call.
if ( not $arr{page} ) {
    showStartPage();

} elsif ( $arr{page} == 1 ) {
    delete $arr{page};
    selectStudents( $arr{dbase}, $arr{checked}, $arr{mode} );

} elsif ( $arr{page} == 2 ) {
    delete $arr{page};
    createManagementFile();

} elsif ( $arr{page} == 3 ) {
    delete $arr{page};
    # nothing here 
}



#----------------
sub showStartPage {
#----------------

    print "<center>\n";
    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"1\">\n";

    print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"0\">\n";
    print "<tr><td colspan=\"2\" align=\"center\">\n";
    print "<input type=\"submit\"  value=\"".  $lex{Continue}. "\"></td></tr>\n";

    print "<tr><td align=\"right\">". $lex{Checked}. "</td>\n<td>";
    print "<input type=\"checkbox\"  name=\"checked\" value=\"1\"></td></tr>\n";

    print "<tr><td align=\"right\">". $lex{Mode}. "</td>\n<td>";
    print "<select  name=\"mode\">\n";
    print "<option>". $lex{Add}. "</option><option>". $lex{Delete}. "</option>\n";
    print "</select></td></tr>\n";

    print "<tr style=\"background-color:#AAA;\"><th>". $lex{Schools}. "</th><td></td></tr>\n";

    # Show the database for selection.
    foreach my $database ( sort keys %dbase) { # defined in global config file.
	print "<tr><td align=\"right\">$dbase{$database}</td>\n<td>";
	print "<input type=\"radio\" value=\"$database\" name=\"dbase\"></td></tr>\n";
    }

    print "<tr><td colspan=\"2\" align=\"center\">\n";
    print "<input type=\"submit\"  value=\"".  $lex{Continue}. "\"></td></tr>\n";
    print "</table></form></center></body></html>\n";

    exit;

} # end of showStartPage



#----------------
sub selectStudents {
#----------------

    #foreach my $key ( sort keys %arr ) { print "K:$key V:$arr{$key}<br>\n"; }

    my ($dbase, $checked, $mode) = @_;
    if ( $checked ) { $checked = 'checked'; }

    my $dsn = "DBI:$dbtype:$dbase";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);

    my $sth = $dbh->prepare("select lastname, firstname, grade, studnum 
      from student order by grade, lastname, firstname");
    $sth->execute;
    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }


    # Print Form Start
    print "<center><h1>". $lex{'Select Students'}. "</h1>\n";

    print "<form action=\"$self\" method=\"post\">\n";
    print "<input type=\"hidden\" name=\"mode\" value=\"$arr{mode}\">\n";
    print "<input type=\"hidden\" name=\"dbase\" value=\"$arr{dbase}\">\n";
    print "<input type=\"hidden\" name=\"page\" value=\"2\">\n";

    my $first = 1;
    my $currgrade = -1;
    my $oldgrade;


    # Loop Through all Student with name and grade
    while ( my ( $lastname, $firstname, $grade, $studnum ) = $sth->fetchrow ) {
	
	$oldgrade = $currgrade;
	$currgrade = $grade;
	if ( $currgrade ne $oldgrade ) { # new grade.
	    if ( not $first ) { print "</table>\n"; } else { $first = 0; }
	    print "<h2>". $lex{Grade}. " $currgrade</h2>\n";
	    print "<table cellspacing=\"0\" cellpadding=\"3\" border=\"1\">\n";
	    print "<tr><td align=\"center\">\n";
	    print "<input type=\"submit\"  value=\"".  $lex{Continue}. "\"></td></tr>\n";
	}
	
	print "<tr><td>";
	print "<input type=\"checkbox\" name=\"$studnum\" value=\"1\" $checked> \n";
	print "<b>$lastname</b>, $firstname</td></tr>\n";

    }

    print "<tr><td align=\"center\">\n";
    print "<input type=\"submit\"  value=\"".  $lex{Continue}. "\"></td></tr>\n";
    print "</table></form></body></html>\n";

    exit;

} # end of selectSubject



#-----------------------
sub createManagementFile {
#-----------------------

    # Get dbase and mode
    my $dbase = $arr{dbase};
    delete $arr{dbase};
    my $mode = $arr{mode};
    delete $arr{mode};
    my $header;
    if ( $mode eq $lex{Add} ) {
	$header = 'create';
    } elsif ( $mode eq $lex{Delete} ) {
	$header = 'delete';
    } else {
	print "<h1>". $lex{'Program Error'}. "</h1>\n";
	print "</body></html>\n";
	die;
    }

    # Open file
    my $filename = 'manage'. $$. '.txt';
    open( FH, ">$filename") or die "Cannot open file: $! \n";
    #print "Filename: $filename<br>\n";

    # Set database and select for student.
    my $dsn = "DBI:$dbtype:$dbase";
    my $dbh = DBI->connect($dsn,$guser,$gpassword);

    my $sth = $dbh->prepare("select lastname, firstname, password from student
      where studnum = ?");

    @fields = qw( username password uid gid name homedir shell min max warn inactive expire );

    # now loop through all students
    foreach my $studnum ( sort keys %arr ) {

	my $record;
	if ( $mode eq $lex{Delete} ) {
	    $record = $header. ':s'. $studnum. "\n";
	} else {
	    %fld = ();
	    $fld{shell} = $shell;

	    # Get student name and password
	    $sth->execute( $studnum );
	    my ( $lastname, $firstname, $password ) = $sth->fetchrow;
	    if ( $DBI::errstr ){ print $DBI::errstr; die $DBI::errstr; }
	    $password =~ s/\n$//g;


	    $fld{name} = $firstname. ' '. $lastname;
	    $fld{username} = 's'. $studnum;
	    $fld{password} = $password;
	    $fld{homedir} = $homedirroot. '/'. $fld{username};

	    # Assemble the line/record for this student
	    $record = $header;
	    foreach my $index ( @fields ) {
		#print "$index | $fld{$index} \n";
		$record .= ':'. $fld{$index};
	    }
	    $record .= "\n"; # add newline

	} # end of else

	print FH $record;
	
    }

    close FH;

    # Now move file and provide link.
    system("mv $filename $downloaddir");

    print "<h1><a href=\"$webdownloaddir/$filename\">";
    print $lex{'Download Management File'}. "</a></h1>\n";
    print "</body></html>\n";
    exit;

}
