#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson

#  This file is part of Open Admin for Schools.

# Fix the school field of the special table to remove descriptive text
# of the school name and only store the single worded school
# database. This will be used to lookup the actual school name if
# required.

use DBI;

# load configuration files
eval require "ppp.conf";
if ( $@ ) {
    print "Error: $@\n";
    die "Error: $@\n";
}

my $dsn = "DBI:$dbtype:dbname=$dbase";
my $dbh = DBI->connect($dsn,$user,$password);

my $sth = $dbh->prepare("select id, school from special");
$sth->execute;
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

my $sth1 = $dbh->prepare("update special set school = ? where id = ?");
if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }

while ( my ( $id, $school ) = $sth->fetchrow ) {
    my ($dud, $database ) =  split /\(/, $school;
    chop $database;

    print "ID: $id DB: $database \n";

    $sth1->execute( $database, $id );
    if ( $DBI::errstr ) { print $DBI::errstr; die $DBI::errstr; }
}
