#!/usr/bin/perl
#  Copyright 2001-2008 Leslie Richardson


# This file can be used to populate the student table from a
# spreadsheet csv file. It is now easier to use the import student
# script directly from OA once you get it running. However this can do
# more 'data munging' if you want to mess with parts of fields, etc.


#  This file is part of Open Admin for Schools.

use DBI;
use CGI;
use Text::CSV_XS;

# Basic Constants... YOU MUST CHANGE THESE FOR YOUR SCHOOL!
$user = "root";
$password = "rootpassword";
$dbase = "mydatabase";
$studnum = "100";  # Starting Student Number.

print "You can use the new import script for students on the export page.\n";
print "You can upload CSV files using this utility OR you can use this...\n";
print "You must change constants above and on line 36-74 and comment this out...\n";
die;

 
$csv = Text::CSV_XS->new();

%monlkup = ("JAN",1,"FEB",2,"MAR",3,"APR",4,"MAY",5,"JUN",6,"JUL",7,"AUG",
	    8,"SEP",9,"OCT",10,"NOV",11,"DEC",12);


#============MySql section ========================

$dsn = "DBI:mysql:$dbase";
$dbh = DBI->connect($dsn,$user,$password);

$ARGV = shift @ARGV;
open (INFILE,"<$ARGV") || die "Cannot open input file";
while (<INFILE>){
    if ($csv->parse($_)) {
	# CHANGE THIS FORMAT TO AGREE WITH INPUT FILE FORMAT!!
	# Match values from the bottom insert section
	($blank, $fullname, $arr{studnum},
	 $home,
	 $addr1,
	 $addr2,
	 $addr3,
	 $addr4,
	 $arr{grade},
	 $arr{birthdate},
	 $arr{name2},
	 $arr{name1},
	 $arr{sex},
	 $arr{healthid},
	 $arr{wphone2},
	 $arr{wphone1},
	 $arr{homeroom},
	 $arr{workplace2},
	 $arr{workplace1},     
	 $arr{emname},
	 $arr{emhphone},
	 $arr{doctor},
	 $arr{docphone},
	 $arr{entry},
	 $arr{studrel},
	 $prevschool,
	 $arr{dadrel},
	 $arr{momrel},
	 $arr{ethnic},
	 $arr{single},
	 $arr{comm},
	 $arr{recon},
	 $arr{conf},
	 $arr{house},
	 $arr{owing},
	 $arr{hphone2},
	 $arr{address2},
	 $arr{city2},
	 $arr{hphone1},
	 $arr{address1},
	 $arr{city1}) = $csv->fields;
    }

# Unused fields
#$arr{internet},$arr{youngest},
#$arr{treaty},$arr{medical},$arr{parish},
#$arr{maiden},$arr{relation1},$arr{contact1},
#$arr{cell1},$arr{fax1},$arr{pcode1},$arr{relation2},
#$arr{contact2},$arr{cell2},$arr{fax2},$arr{pcode2},
#$arr{emrelation},$arr{emwphone},$arr{emcell},

#par1_email, par2_email, name_prefix, name_suffix,
#name_knownas, group_alt1, group_alt2, group_alt3,
#billet, childcare_name, childcare_address, childcare_phone1,
#childcare_phone2, internet_type, par1_firstname, par1_lastname,
#par2_firstname, par2_lastname,


#This section below, until the SQL insert section can be used to "fix
#up" any data in the input to a more pleasing format for inclusion in
#the database.


# Fix Case...put in Initial Capitals on all words.
#  $arr{city1} =~ s/(\w+)/\u\L$1/g;
#  $arr{city2} =~ s/(\w+)/\u\L$1/g;
#  $arr{address1} =~ s/(\w+)/\u\L$1/g;
#  $arr{address2} =~ s/(\w+)/\u\L$1/g;
#  $arr{name2} =~ s/(\w+)/\u\L$1/g;
#  $arr{name1} =~ s/(\w+)/\u\L$1/g;
#  $arr{workplace1} =~ s/(\w+)/\u\L$1/g;
#  $arr{workplace2} =~ s/(\w+)/\u\L$1/g;
#  $arr{doctor} =~ s/(\w+)/\u\L$1/g;
#  $arr{emname} =~ s/(\w+)/\u\L$1/g;

#  if (length($arr{address1}) == 7) {
#      $arr{address1} =~ s/(\w+)/\U$1/g;
#      $arr{pcode1} = $arr{address1};
#      $arr{address1} = $arr{address2};
#  }

    foreach $val (values %arr){
	$val =~ s/'/''/g;
    }


# This is what actually inserts the record....DON'T CHANGE THIS! 
# (since it is the table structure for the student table.)

    $sth = $dbh->prepare("insert into student values (
  NULL,
'$arr{lastname}',
'$arr{firstname}',
'$arr{initial}',
'$studnum',
'$arr{grade}',
'$arr{homeroom}',
'$arr{sex}',
'$arr{birthdate}',
'$arr{house}',
'$arr{healthid}',
'$arr{entry}',
'$arr{ethnic}',
'$arr{single}',
'$arr{internet}',
'$arr{youngest}',
'$arr{owing}',
'$arr{treaty}',
'$arr{medical}',
'$arr{studrel}',
'$arr{momrel}',
'$arr{dadrel}',
'$arr{parish}',
'$arr{comm}',
'$arr{recon}',
'$arr{conf}',
'$arr{maiden}',
'$arr{relation1}',
'$arr{contact1}',
'$arr{name1}',
'$arr{hphone1}',
'$arr{wphone1}',
'$arr{cell1}',
'$arr{fax1}',
'$arr{address1}',
'$arr{city1}',
'$arr{pcode1}',
'$arr{workplace1}',
'$arr{relation2}',
'$arr{contact2}',
'$arr{name2}',
'$arr{hphone2}',
'$arr{wphone2}',
'$arr{cell2}',
'$arr{fax2}',
'$arr{address2}',
'$arr{city2}',
'$arr{pcode2}',
'$arr{workplace2}',
'$arr{emrelation}',
'$arr{emname}',
'$arr{emhphone}',
'$arr{emwphone}',
'$arr{emcell}',
'$arr{doctor}',
'$arr{docphone}',
'$arr{busroute}','$arr{provnum}','$arr{band}','$arr{bandnum}','$arr{baptism}',
'$arr{contact}', '$arr{family}', '$arr{alias}', '$arr{pic}','$arr{password}',
'$arr{field1}', '$arr{field2}', '$arr{field3}', '$arr{prov1}','$arr{prov2}',
'$arr{reserveres}', '$arr{program}', '$arr{utag}', '$arr{email}',
'$arr{trans_type}', '$arr{trans_name}', '$arr{trans_am_route}', '$arr{trans_pickup_time}', 
'$arr{trans_pm_route}', '$arr{trans_dropoff_time}', '$arr{trans_bus_stop_location}',
'$arr{group_after_school_prog}', '$arr{lunchstatus}',

'$arr{par1_email}', '$arr{par2_email}', '$arr{name_prefix}', '$arr{name_suffix}',
'$arr{name_knownas}', '$arr{group_alt1}', '$arr{group_alt2}', '$arr{group_alt3}',
'$arr{billet}', '$arr{childcare_name}', '$arr{childcare_address}', '$arr{childcare_phone1}',
'$arr{childcare_phone2}', '$arr{internet_type}', '$arr{par1_firstname}', '$arr{par1_lastname}',
'$arr{par2_firstname}', '$arr{par2_lastname}', '$arr{graddate}'
)");

   $sth->execute;
   if ($DBI::errstr) { print $DBI::errstr; die; }
   $studnum++;
}

print "Done!\n\n";

print "The next student number is: $studnum \n\n";
print "Please edit your /etc/studentnumber file and put in this\n";
print "number which is the next available student number.\n";
